import { App } from '../generated';
import { CoinListClient } from '../coinList';
import { RouteAndQuote, TokenTypeFullname, TradeRoute, TradeStep, TradingPool, TradingPoolProvider } from './types';
import { CoinInfo } from '../generated/coin_list/coin_list';
import { AptosClient } from 'aptos';
import { coin_list } from '../../cli';
export declare class TradeAggregator {
    registryClient: CoinListClient;
    app: App;
    readonly poolProviders: TradingPoolProvider[];
    printError: boolean;
    allPools: TradingPool[];
    xToAnyPools: Map<TokenTypeFullname, TradingPool[]>;
    private constructor();
    static create(aptosClient: AptosClient, netConfig?: import("../config").NetworkConfiguration): Promise<TradeAggregator>;
    loadAllPoolLists(): Promise<void>;
    buildPoolsLookup(): void;
    getTradableCoinInfo(): coin_list.Coin_list.CoinInfo[];
    getXtoYDirectSteps(x: CoinInfo, y: CoinInfo, requireRoutable?: boolean): TradeStep[];
    getOneStepRoutes(x: CoinInfo, y: CoinInfo): TradeRoute[];
    getTwoStepRoutes(x: CoinInfo, y: CoinInfo): TradeRoute[];
    getThreeStepRoutes(x: CoinInfo, y: CoinInfo): TradeRoute[];
    getAllRoutes(x: CoinInfo, y: CoinInfo, maxSteps?: 1 | 2 | 3, allowRoundTrip?: boolean): TradeRoute[];
    getQuotes(inputUiAmt: number, x: CoinInfo, y: CoinInfo, maxSteps?: 1 | 2 | 3, reloadState?: boolean, allowRoundTrip?: boolean): Promise<RouteAndQuote[]>;
    getBestQuote(inputUiAmt: number, x: CoinInfo, y: CoinInfo, maxSteps?: 1 | 2 | 3, reloadState?: boolean, allowRoundTrip?: boolean): Promise<RouteAndQuote | null>;
}
//# sourceMappingURL=aggregator.d.ts.map