import { StructTag } from '@manahippo/move-to-ts';
import { HexString, Types } from 'aptos';
import { CoinInfo } from '../../generated/coin_list/coin_list';
import { DexType, PriceType, QuoteType, TradingPool, UITokenAmount } from '../types';
import { AnimeSwapPoolV1 } from '../../generated/SwapDeployer';
import { App } from '../../generated';
export declare class AnimeTradingPool extends TradingPool {
    ownerAddr: HexString;
    _xCoinInfo: CoinInfo;
    _yCoinInfo: CoinInfo;
    tag: StructTag;
    pool: AnimeSwapPoolV1.LiquidityPool | null;
    constructor(ownerAddr: HexString, tag: StructTag, xCoinInfo: CoinInfo, yCoinInfo: CoinInfo);
    get dexType(): DexType;
    get poolType(): import("@manahippo/move-to-ts").U64;
    get isRoutable(): boolean;
    get xCoinInfo(): CoinInfo;
    get yCoinInfo(): CoinInfo;
    isStateLoaded(): boolean;
    reloadState(app: App): Promise<void>;
    getPrice(): PriceType;
    getQuote(inputUiAmt: UITokenAmount, isXtoY: boolean): QuoteType;
    makePayload(inputUiAmt: UITokenAmount, minOutAmt: UITokenAmount): Types.EntryFunctionPayload;
}
//# sourceMappingURL=AnimeTradingPool.d.ts.map