import { DexType, PoolType, PriceType, QuoteType, TradingPool, UITokenAmount } from '../types';
import { HexString, Types } from 'aptos';
import { App } from '../../generated';
import { CoinInfo } from '../../generated/coin_list/coin_list';
import { Pool as AuxPool } from '../../generated/aux/amm';
export declare class AuxTradingPool extends TradingPool {
    ownerAddress: HexString;
    xInfo: CoinInfo;
    yInfo: CoinInfo;
    pool: AuxPool | null;
    constructor(ownerAddress: HexString, xInfo: CoinInfo, yInfo: CoinInfo);
    get dexType(): DexType;
    getPrice(): PriceType;
    getQuote(inputUiAmt: UITokenAmount, isXtoY: boolean): QuoteType;
    get isRoutable(): boolean;
    isStateLoaded(): boolean;
    makePayload(inputUiAmt: UITokenAmount, minOutAmt: UITokenAmount): Types.EntryFunctionPayload;
    get poolType(): PoolType;
    reloadState(app: App): Promise<void>;
    get xCoinInfo(): CoinInfo;
    get yCoinInfo(): CoinInfo;
}
//# sourceMappingURL=AuxTradingPool.d.ts.map