import { StructTag } from '@manahippo/move-to-ts';
import { HexString, Types } from 'aptos';
import { DexType, PriceType, QuoteType, TradingPool, TradingPoolProvider, UITokenAmount } from '../types';
import { App } from '../../generated';
import bigInt from 'big-integer';
import { CoinInfo } from '../../generated/coin_list/coin_list';
export declare class BasiqTradingPool extends TradingPool {
    ownerAddress: HexString;
    _xCoinInfo: CoinInfo;
    _yCoinInfo: CoinInfo;
    poolResourceTag: StructTag;
    basiqPool: object | null;
    constructor(ownerAddress: HexString, _xCoinInfo: CoinInfo, _yCoinInfo: CoinInfo, poolResourceTag: StructTag);
    get dexType(): DexType;
    get poolType(): import("@manahippo/move-to-ts").U64;
    get isRoutable(): boolean;
    get xCoinInfo(): CoinInfo;
    get yCoinInfo(): CoinInfo;
    isStateLoaded(): boolean;
    reloadState(app: App): Promise<void>;
    getPrice(): PriceType;
    getQuote(inputUiAmt: UITokenAmount, isXtoY: boolean): QuoteType;
    makePayload(inputUiAmt: UITokenAmount, minOutAmt: UITokenAmount): Types.EntryFunctionPayload;
}
export declare class BasiqPoolProvider extends TradingPoolProvider {
    loadPoolList(): Promise<TradingPool[]>;
}
export declare function imbalance_ratio(x_value: bigInt.BigInteger, y_value: bigInt.BigInteger): bigInt.BigInteger;
export declare function calc_swap_output(input_amount: bigInt.BigInteger, input_reserve: bigInt.BigInteger, output_reserve: bigInt.BigInteger, input_price: bigInt.BigInteger, output_price: bigInt.BigInteger, fee_bips: bigInt.BigInteger, rebate_bips: bigInt.BigInteger): bigInt.BigInteger;
//# sourceMappingURL=index.d.ts.map