import { HexString, Types } from 'aptos';
import { App } from '../../generated';
import { AptosParserRepo, U64 } from '@manahippo/move-to-ts';
import { OrderBook } from '../../generated/econia/market';
import { MarketInfo } from '../../generated/econia/registry';
import { DexType, PriceType, QuoteType, TradingPool, TradingPoolProvider, UITokenAmount } from '../types';
import { CoinInfo } from '../../generated/coin_list/coin_list';
export * from './econia_client';
export declare enum EconiaPoolType {
    V3 = 3
}
export declare class EconiaTradingPoolV1 extends TradingPool {
    xInfo: CoinInfo;
    yInfo: CoinInfo;
    orderBook: OrderBook | null;
    mi: MarketInfo;
    owner: HexString;
    repo: AptosParserRepo;
    marketId: U64;
    constructor(xInfo: CoinInfo, yInfo: CoinInfo, orderBook: OrderBook | null, mi: MarketInfo, owner: HexString, repo: AptosParserRepo, marketId: U64);
    get dexType(): DexType;
    get poolType(): U64;
    get isRoutable(): boolean;
    get xCoinInfo(): CoinInfo;
    get yCoinInfo(): CoinInfo;
    get xTag(): import("@manahippo/move-to-ts").TypeTag;
    get yTag(): import("@manahippo/move-to-ts").TypeTag;
    isStateLoaded(): boolean;
    reloadState(app: App): Promise<void>;
    getUiPrice(rawPrice: U64): number;
    getPrice(): PriceType;
    getQuote(inputUiAmt: UITokenAmount, isXtoY: boolean): QuoteType;
    makePayload(inputUiAmt: UITokenAmount, minOutAmt: UITokenAmount): Types.EntryFunctionPayload;
}
export declare class EconiaPoolProvider extends TradingPoolProvider {
    loadPoolList(): Promise<TradingPool[]>;
}
//# sourceMappingURL=types.d.ts.map