import { DexType, PriceType, QuoteType, TradingPool, UITokenAmount } from '../types';
import { HexString, Types } from 'aptos';
import { CoinInfo } from '../../generated/coin_list/coin_list';
import { StructTag, TypeTag } from '@manahippo/move-to-ts';
import { App } from '../../generated';
import { LiquidityPool as PontemPool } from '../../generated/liquidswap/liquidity_pool';
export declare class PontemTradingPool extends TradingPool {
    ownerAddress: HexString;
    _xCoinInfo: CoinInfo;
    _yCoinInfo: CoinInfo;
    curvesTag: StructTag;
    poolResourceTag: StructTag;
    pontemPool: PontemPool | null;
    constructor(ownerAddress: HexString, _xCoinInfo: CoinInfo, _yCoinInfo: CoinInfo, curvesTag: StructTag, poolResourceTag: StructTag);
    get dexType(): DexType;
    get poolType(): import("@manahippo/move-to-ts").U64;
    get isRoutable(): boolean;
    get xCoinInfo(): CoinInfo;
    get yCoinInfo(): CoinInfo;
    isStateLoaded(): boolean;
    reloadState(app: App): Promise<void>;
    getPrice(): PriceType;
    getQuote(inputUiAmt: UITokenAmount, isXtoY: boolean): QuoteType;
    getTagE(): TypeTag;
    makePayload(inputUiAmt: UITokenAmount, minOutAmt: UITokenAmount): Types.EntryFunctionPayload;
    getCurves(): StructTag;
}
//# sourceMappingURL=PontemTradingPool.d.ts.map