import { PoolType, PriceType, QuoteType, TradingPool, UITokenAmount } from '../types';
import { HexString, Types } from 'aptos';
import { CoinInfo } from '../../generated/coin_list/coin_list';
import { CoinInfo as StdCoinInfo } from '../../generated/stdlib/coin';
export declare abstract class StakeTradingPool extends TradingPool {
    ownerAddress: HexString;
    xInfo: CoinInfo;
    yInfo: CoinInfo;
    protected yAmountInfo: StdCoinInfo | undefined;
    constructor(ownerAddress: HexString, xInfo: CoinInfo, yInfo: CoinInfo);
    getPrice(): PriceType;
    abstract getXAmount(): number;
    getYAmount(): number;
    getQuote(inputUiAmt: UITokenAmount, isXtoY: boolean): QuoteType;
    get isRoutable(): boolean;
    makePayload(inputUiAmt: UITokenAmount, minOutAmt: UITokenAmount): Types.EntryFunctionPayload;
    get poolType(): PoolType;
    get xCoinInfo(): CoinInfo;
    get yCoinInfo(): CoinInfo;
}
//# sourceMappingURL=stake_trading_pool.d.ts.map