import * as $ from '@manahippo/move-to-ts';
import { AptosDataCache, AptosParserRepo, AptosLocalCache } from '@manahippo/move-to-ts';
import { U8, U64, U128 } from '@manahippo/move-to-ts';
import { TypeParamDeclType, FieldDeclType } from '@manahippo/move-to-ts';
import { StructTag, TypeTag } from '@manahippo/move-to-ts';
import { HexString, AptosClient } from 'aptos';
import * as Stdlib from '../stdlib';
export declare const packageName = "AnimeSwapV1";
export declare const moduleAddress: HexString;
export declare const moduleName = "AnimeSwapPoolV1";
export declare class AdminData {
    typeTag: TypeTag;
    static moduleAddress: HexString;
    static moduleName: string;
    __app: $.AppType | null;
    static structName: string;
    static typeParameters: TypeParamDeclType[];
    static fields: FieldDeclType[];
    signer_cap: Stdlib.Account.SignerCapability;
    dao_fee_to: HexString;
    admin_address: HexString;
    dao_fee: U8;
    swap_fee: U64;
    dao_fee_on: boolean;
    is_pause: boolean;
    constructor(proto: any, typeTag: TypeTag);
    static AdminDataParser(data: any, typeTag: TypeTag, repo: AptosParserRepo): AdminData;
    static load(repo: AptosParserRepo, client: AptosClient, address: HexString, typeParams: TypeTag[]): Promise<AdminData>;
    static loadByApp(app: $.AppType, address: HexString, typeParams: TypeTag[]): Promise<AdminData>;
    static getTag(): StructTag;
    loadFullState(app: $.AppType): Promise<void>;
}
export declare class LiquidityPool {
    typeTag: TypeTag;
    static moduleAddress: HexString;
    static moduleName: string;
    __app: $.AppType | null;
    static structName: string;
    static typeParameters: TypeParamDeclType[];
    static fields: FieldDeclType[];
    coin_x_reserve: Stdlib.Coin.Coin;
    coin_y_reserve: Stdlib.Coin.Coin;
    last_block_timestamp: U64;
    last_price_x_cumulative: U128;
    last_price_y_cumulative: U128;
    k_last: U128;
    lp_mint_cap: Stdlib.Coin.MintCapability;
    lp_freeze_cap: Stdlib.Coin.FreezeCapability;
    lp_burn_cap: Stdlib.Coin.BurnCapability;
    locked: boolean;
    constructor(proto: any, typeTag: TypeTag);
    static LiquidityPoolParser(data: any, typeTag: TypeTag, repo: AptosParserRepo): LiquidityPool;
    static load(repo: AptosParserRepo, client: AptosClient, address: HexString, typeParams: TypeTag[]): Promise<LiquidityPool>;
    static loadByApp(app: $.AppType, address: HexString, typeParams: TypeTag[]): Promise<LiquidityPool>;
    static makeTag($p: TypeTag[]): StructTag;
    loadFullState(app: $.AppType): Promise<void>;
}
export declare function swap_coins_for_coins_(_coins_in: Stdlib.Coin.Coin, $c: AptosDataCache, $p: TypeTag[]): Stdlib.Coin.Coin;
export declare function loadParsers(repo: AptosParserRepo): void;
export declare class App {
    client: AptosClient;
    repo: AptosParserRepo;
    cache: AptosLocalCache;
    constructor(client: AptosClient, repo: AptosParserRepo, cache: AptosLocalCache);
    get moduleAddress(): HexString;
    get moduleName(): string;
    get AdminData(): typeof AdminData;
    loadAdminData(owner: HexString, loadFull?: boolean, fillCache?: boolean): Promise<AdminData>;
    get LiquidityPool(): typeof LiquidityPool;
    loadLiquidityPool(owner: HexString, $p: TypeTag[], loadFull?: boolean, fillCache?: boolean): Promise<LiquidityPool>;
}
//# sourceMappingURL=AnimeSwapPoolV1.d.ts.map