import { AptosDataCache, AptosParserRepo, AptosLocalCache } from '@manahippo/move-to-ts';
import { U64, U128 } from '@manahippo/move-to-ts';
import { HexString, AptosClient } from 'aptos';
export declare const packageName = "AnimeSwapV1";
export declare const moduleAddress: HexString;
export declare const moduleName = "AnimeSwapPoolV1Library";
export declare const ERR_COIN_TYPE_SAME_ERROR: U64;
export declare const ERR_INSUFFICIENT_AMOUNT: U64;
export declare const ERR_INSUFFICIENT_INPUT_AMOUNT: U64;
export declare const ERR_INSUFFICIENT_LIQUIDITY: U64;
export declare const ERR_INSUFFICIENT_OUTPUT_AMOUNT: U64;
export declare const MAX_U128: U128;
export declare function get_amount_out_(amount_in: U64, reserve_in: U64, reserve_out: U64, swap_fee: U64, $c: AptosDataCache): U64;
export declare function quote_(amount_x: U64, reserve_x: U64, reserve_y: U64, $c: AptosDataCache): U64;
export declare function loadParsers(repo: AptosParserRepo): void;
export declare class App {
    client: AptosClient;
    repo: AptosParserRepo;
    cache: AptosLocalCache;
    constructor(client: AptosClient, repo: AptosParserRepo, cache: AptosLocalCache);
    get moduleAddress(): HexString;
    get moduleName(): string;
}
//# sourceMappingURL=AnimeSwapPoolV1Library.d.ts.map