import * as $ from '@manahippo/move-to-ts';
import { AptosDataCache, AptosParserRepo, AptosLocalCache } from '@manahippo/move-to-ts';
import { U64, U128 } from '@manahippo/move-to-ts';
import { TypeParamDeclType, FieldDeclType } from '@manahippo/move-to-ts';
import { StructTag, TypeTag } from '@manahippo/move-to-ts';
import { OptionTransaction } from '@manahippo/move-to-ts';
import { HexString, AptosClient, AptosAccount, TxnBuilderTypes, Types } from 'aptos';
import * as Stdlib from '../stdlib';
export declare const packageName = "aux";
export declare const moduleAddress: HexString;
export declare const moduleName = "amm";
export declare const EINSUFFICIENT_INPUT_AMOUNT: U64;
export declare const EINSUFFICIENT_LIQUIDITY: U64;
export declare const EINSUFFICIENT_OUTPUT_AMOUNT: U64;
export declare const EPOOL_NOT_FOUND: U64;
export declare class AddLiquidityEvent {
    typeTag: TypeTag;
    static moduleAddress: HexString;
    static moduleName: string;
    __app: $.AppType | null;
    static structName: string;
    static typeParameters: TypeParamDeclType[];
    static fields: FieldDeclType[];
    timestamp: U64;
    x_coin_type: Stdlib.String.String;
    y_coin_type: Stdlib.String.String;
    x_added_au: U64;
    y_added_au: U64;
    lp_minted_au: U64;
    constructor(proto: any, typeTag: TypeTag);
    static AddLiquidityEventParser(data: any, typeTag: TypeTag, repo: AptosParserRepo): AddLiquidityEvent;
    static getTag(): StructTag;
    loadFullState(app: $.AppType): Promise<void>;
}
export declare class LP {
    typeTag: TypeTag;
    static moduleAddress: HexString;
    static moduleName: string;
    __app: $.AppType | null;
    static structName: string;
    static typeParameters: TypeParamDeclType[];
    static fields: FieldDeclType[];
    constructor(proto: any, typeTag: TypeTag);
    static LPParser(data: any, typeTag: TypeTag, repo: AptosParserRepo): LP;
    static makeTag($p: TypeTag[]): StructTag;
    loadFullState(app: $.AppType): Promise<void>;
}
export declare class Pool {
    typeTag: TypeTag;
    static moduleAddress: HexString;
    static moduleName: string;
    __app: $.AppType | null;
    static structName: string;
    static typeParameters: TypeParamDeclType[];
    static fields: FieldDeclType[];
    frozen: boolean;
    timestamp: U64;
    fee_bps: U64;
    swap_events: Stdlib.Event.EventHandle;
    add_liquidity_events: Stdlib.Event.EventHandle;
    remove_liquidity_events: Stdlib.Event.EventHandle;
    x_reserve: Stdlib.Coin.Coin;
    y_reserve: Stdlib.Coin.Coin;
    lp_mint: Stdlib.Coin.MintCapability;
    lp_burn: Stdlib.Coin.BurnCapability;
    constructor(proto: any, typeTag: TypeTag);
    static PoolParser(data: any, typeTag: TypeTag, repo: AptosParserRepo): Pool;
    static load(repo: AptosParserRepo, client: AptosClient, address: HexString, typeParams: TypeTag[]): Promise<Pool>;
    static loadByApp(app: $.AppType, address: HexString, typeParams: TypeTag[]): Promise<Pool>;
    static makeTag($p: TypeTag[]): StructTag;
    loadFullState(app: $.AppType): Promise<void>;
}
export declare class RemoveLiquidityEvent {
    typeTag: TypeTag;
    static moduleAddress: HexString;
    static moduleName: string;
    __app: $.AppType | null;
    static structName: string;
    static typeParameters: TypeParamDeclType[];
    static fields: FieldDeclType[];
    timestamp: U64;
    x_coin_type: Stdlib.String.String;
    y_coin_type: Stdlib.String.String;
    x_removed_au: U64;
    y_removed_au: U64;
    lp_burned_au: U64;
    constructor(proto: any, typeTag: TypeTag);
    static RemoveLiquidityEventParser(data: any, typeTag: TypeTag, repo: AptosParserRepo): RemoveLiquidityEvent;
    static getTag(): StructTag;
    loadFullState(app: $.AppType): Promise<void>;
}
export declare class SwapEvent {
    typeTag: TypeTag;
    static moduleAddress: HexString;
    static moduleName: string;
    __app: $.AppType | null;
    static structName: string;
    static typeParameters: TypeParamDeclType[];
    static fields: FieldDeclType[];
    sender_addr: HexString;
    timestamp: U64;
    in_coin_type: Stdlib.String.String;
    out_coin_type: Stdlib.String.String;
    in_reserve: U64;
    out_reserve: U64;
    in_au: U64;
    out_au: U64;
    fee_bps: U64;
    constructor(proto: any, typeTag: TypeTag);
    static SwapEventParser(data: any, typeTag: TypeTag, repo: AptosParserRepo): SwapEvent;
    static getTag(): StructTag;
    loadFullState(app: $.AppType): Promise<void>;
}
export declare function add_exact_liquidity_(_sender: HexString, _x_au: U64, _y_au: U64, $c: AptosDataCache, $p: TypeTag[]): void;
export declare function buildPayload_add_exact_liquidity(_x_au: U64, _y_au: U64, $p: TypeTag[], isJSON?: boolean): TxnBuilderTypes.TransactionPayloadEntryFunction | Types.TransactionPayload_EntryFunctionPayload;
export declare function au_in_(au_out: U64, $c: AptosDataCache, $p: TypeTag[]): U64;
export declare function au_out_(au_in: U64, $c: AptosDataCache, $p: TypeTag[]): U64;
export declare function create_pool_(_sender: HexString, _fee_bps: U64, $c: AptosDataCache, $p: TypeTag[]): void;
export declare function buildPayload_create_pool(_fee_bps: U64, $p: TypeTag[], isJSON?: boolean): TxnBuilderTypes.TransactionPayloadEntryFunction | Types.TransactionPayload_EntryFunctionPayload;
export declare function get_amount_in_(amount_out: U64, reserve_in: U64, reserve_out: U64, fee_bps: U64, $c: AptosDataCache): U64;
export declare function get_amount_out_(amount_in: U64, reserve_in: U64, reserve_out: U64, fee_bps: U64, $c: AptosDataCache): U64;
export declare function swap_exact_coin_for_coin_mut_(_sender_addr: HexString, _user_in: Stdlib.Coin.Coin, _user_out: Stdlib.Coin.Coin, _au_in: U64, _min_au_out: U64, _use_limit_price: boolean, _max_out_per_in_au_numerator: U128, _max_out_per_in_au_denominator: U128, $c: AptosDataCache, $p: TypeTag[]): [U64, U64];
export declare function loadParsers(repo: AptosParserRepo): void;
export declare class App {
    client: AptosClient;
    repo: AptosParserRepo;
    cache: AptosLocalCache;
    constructor(client: AptosClient, repo: AptosParserRepo, cache: AptosLocalCache);
    get moduleAddress(): HexString;
    get moduleName(): string;
    get AddLiquidityEvent(): typeof AddLiquidityEvent;
    get LP(): typeof LP;
    get Pool(): typeof Pool;
    loadPool(owner: HexString, $p: TypeTag[], loadFull?: boolean, fillCache?: boolean): Promise<Pool>;
    get RemoveLiquidityEvent(): typeof RemoveLiquidityEvent;
    get SwapEvent(): typeof SwapEvent;
    payload_add_exact_liquidity(_x_au: U64, _y_au: U64, $p: TypeTag[], isJSON?: boolean): TxnBuilderTypes.TransactionPayloadEntryFunction | Types.TransactionPayload_EntryFunctionPayload;
    add_exact_liquidity(_account: AptosAccount, _x_au: U64, _y_au: U64, $p: TypeTag[], option?: OptionTransaction, _isJSON?: boolean): Promise<Types.UserTransaction>;
    payload_create_pool(_fee_bps: U64, $p: TypeTag[], isJSON?: boolean): TxnBuilderTypes.TransactionPayloadEntryFunction | Types.TransactionPayload_EntryFunctionPayload;
    create_pool(_account: AptosAccount, _fee_bps: U64, $p: TypeTag[], option?: OptionTransaction, _isJSON?: boolean): Promise<Types.UserTransaction>;
}
//# sourceMappingURL=amm.d.ts.map