import * as $ from '@manahippo/move-to-ts';
import { AptosDataCache, AptosParserRepo, AptosLocalCache } from '@manahippo/move-to-ts';
import { U8, U64, U128 } from '@manahippo/move-to-ts';
import { TypeParamDeclType, FieldDeclType } from '@manahippo/move-to-ts';
import { StructTag, TypeTag } from '@manahippo/move-to-ts';
import { HexString, AptosClient } from 'aptos';
export declare const packageName = "aux";
export declare const moduleAddress: HexString;
export declare const moduleName = "uint256";
export declare const E_OVERFLOW: U64;
export declare const MAX_SHIFT: U8;
export declare const UNDERLYING_HALF_POINT: U128;
export declare const UNDERLYING_HALF_SIZE: U8;
export declare const UNDERLYING_LOWER_ONES: U128;
export declare const UNDERLYING_ONES: U128;
export declare const UNDERLYING_SIZE: U8;
export declare const UNDERLYING_UPPER_ONES: U128;
export declare class Uint256 {
    typeTag: TypeTag;
    static moduleAddress: HexString;
    static moduleName: string;
    __app: $.AppType | null;
    static structName: string;
    static typeParameters: TypeParamDeclType[];
    static fields: FieldDeclType[];
    hi: U128;
    lo: U128;
    constructor(proto: any, typeTag: TypeTag);
    static Uint256Parser(data: any, typeTag: TypeTag, repo: AptosParserRepo): Uint256;
    static getTag(): StructTag;
    loadFullState(app: $.AppType): Promise<void>;
}
export declare function downcast_(x: Uint256, $c: AptosDataCache): U128;
export declare function new___(hi: U128, lo: U128, $c: AptosDataCache): Uint256;
export declare function underlying_add_with_carry_(x: U128, y: U128, $c: AptosDataCache): [U128, U128];
export declare function underlying_mul_to_uint256_(x: U128, y: U128, $c: AptosDataCache): Uint256;
export declare function underlying_mul_with_carry_(x: U128, y: U128, $c: AptosDataCache): [U128, U128];
export declare function underlying_overflow_(x: Uint256, $c: AptosDataCache): boolean;
export declare function loadParsers(repo: AptosParserRepo): void;
export declare class App {
    client: AptosClient;
    repo: AptosParserRepo;
    cache: AptosLocalCache;
    constructor(client: AptosClient, repo: AptosParserRepo, cache: AptosLocalCache);
    get moduleAddress(): HexString;
    get moduleName(): string;
    get Uint256(): typeof Uint256;
}
//# sourceMappingURL=uint256.d.ts.map