import * as $ from '@manahippo/move-to-ts';
import { AptosDataCache, AptosParserRepo, AptosLocalCache } from '@manahippo/move-to-ts';
import { U64 } from '@manahippo/move-to-ts';
import { TypeParamDeclType, FieldDeclType } from '@manahippo/move-to-ts';
import { StructTag, TypeTag } from '@manahippo/move-to-ts';
import { OptionTransaction } from '@manahippo/move-to-ts';
import { HexString, AptosClient, AptosAccount, TxnBuilderTypes, Types } from 'aptos';
import * as Stdlib from '../stdlib';
export declare const packageName = "basiq";
export declare const moduleAddress: HexString;
export declare const moduleName = "dex";
export declare class V1LP {
    typeTag: TypeTag;
    static moduleAddress: HexString;
    static moduleName: string;
    __app: $.AppType | null;
    static structName: string;
    static typeParameters: TypeParamDeclType[];
    static fields: FieldDeclType[];
    constructor(proto: any, typeTag: TypeTag);
    static V1LPParser(data: any, typeTag: TypeTag, repo: AptosParserRepo): V1LP;
    static makeTag($p: TypeTag[]): StructTag;
    loadFullState(app: $.AppType): Promise<void>;
}
export declare function add_liquidity_entry_(_sender: HexString, _amount_x: U64, _amount_y: U64, $c: AptosDataCache, $p: TypeTag[]): void;
export declare function buildPayload_add_liquidity_entry(_amount_x: U64, _amount_y: U64, $p: TypeTag[], isJSON?: boolean): TxnBuilderTypes.TransactionPayloadEntryFunction | Types.TransactionPayload_EntryFunctionPayload;
export declare function admin_create_pool_(_admin: HexString, _x_price: U64, _y_price: U64, _lp_name: Stdlib.String.String, _lp_symbol: Stdlib.String.String, _is_not_pegged: boolean, $c: AptosDataCache, $p: TypeTag[]): void;
export declare function buildPayload_admin_create_pool(_x_price: U64, _y_price: U64, _lp_name: Stdlib.String.String, _lp_symbol: Stdlib.String.String, _is_not_pegged: boolean, $p: TypeTag[], isJSON?: boolean): TxnBuilderTypes.TransactionPayloadEntryFunction | Types.TransactionPayload_EntryFunctionPayload;
export declare function swap_(coin_from: Stdlib.Coin.Coin, $c: AptosDataCache, $p: TypeTag[]): Stdlib.Coin.Coin;
export declare function loadParsers(repo: AptosParserRepo): void;
export declare class App {
    client: AptosClient;
    repo: AptosParserRepo;
    cache: AptosLocalCache;
    constructor(client: AptosClient, repo: AptosParserRepo, cache: AptosLocalCache);
    get moduleAddress(): HexString;
    get moduleName(): string;
    get V1LP(): typeof V1LP;
    payload_add_liquidity_entry(_amount_x: U64, _amount_y: U64, $p: TypeTag[], isJSON?: boolean): TxnBuilderTypes.TransactionPayloadEntryFunction | Types.TransactionPayload_EntryFunctionPayload;
    add_liquidity_entry(_account: AptosAccount, _amount_x: U64, _amount_y: U64, $p: TypeTag[], option?: OptionTransaction, _isJSON?: boolean): Promise<Types.UserTransaction>;
    payload_admin_create_pool(_x_price: U64, _y_price: U64, _lp_name: Stdlib.String.String, _lp_symbol: Stdlib.String.String, _is_not_pegged: boolean, $p: TypeTag[], isJSON?: boolean): TxnBuilderTypes.TransactionPayloadEntryFunction | Types.TransactionPayload_EntryFunctionPayload;
    admin_create_pool(_account: AptosAccount, _x_price: U64, _y_price: U64, _lp_name: Stdlib.String.String, _lp_symbol: Stdlib.String.String, _is_not_pegged: boolean, $p: TypeTag[], option?: OptionTransaction, _isJSON?: boolean): Promise<Types.UserTransaction>;
}
//# sourceMappingURL=dex.d.ts.map