import * as $ from '@manahippo/move-to-ts';
import { AptosDataCache, AptosParserRepo, AptosLocalCache } from '@manahippo/move-to-ts';
import { U8, U64 } from '@manahippo/move-to-ts';
import { TypeParamDeclType, FieldDeclType } from '@manahippo/move-to-ts';
import { StructTag, TypeTag } from '@manahippo/move-to-ts';
import { OptionTransaction } from '@manahippo/move-to-ts';
import { HexString, AptosClient, AptosAccount, TxnBuilderTypes, Types } from 'aptos';
import * as Stdlib from '../stdlib';
import * as Iterable_table from './iterable_table';
export declare const packageName = "CoinList";
export declare const moduleAddress: HexString;
export declare const moduleName = "coin_list";
export declare const E_APPROVER_ONLY: U64;
export declare const E_COIN_NOT_IN_REGISTRY: U64;
export declare const E_COIN_OWNER_ONLY: U64;
export declare const E_CONTRACT_OWNER_ONLY: U64;
export declare const E_LIST_DOES_NOT_EXIST: U64;
export declare const E_TYPE_ALREADY_EXISTS: U64;
export declare const E_UID_ALREADY_EXISTS: U64;
export declare const E_UNSUPPORTED_METHOD: U64;
export declare class CoinInfo {
    typeTag: TypeTag;
    static moduleAddress: HexString;
    static moduleName: string;
    __app: $.AppType | null;
    static structName: string;
    static typeParameters: TypeParamDeclType[];
    static fields: FieldDeclType[];
    name: Stdlib.String.String;
    symbol: Stdlib.String.String;
    official_symbol: Stdlib.String.String;
    coingecko_id: Stdlib.String.String;
    decimals: U8;
    logo_url: Stdlib.String.String;
    project_url: Stdlib.String.String;
    token_type: Stdlib.Type_info.TypeInfo;
    extensions: Stdlib.Simple_map.SimpleMap;
    constructor(proto: any, typeTag: TypeTag);
    static CoinInfoParser(data: any, typeTag: TypeTag, repo: AptosParserRepo): CoinInfo;
    static getTag(): StructTag;
    loadFullState(app: $.AppType): Promise<void>;
}
export declare class CoinList {
    typeTag: TypeTag;
    static moduleAddress: HexString;
    static moduleName: string;
    __app: $.AppType | null;
    static structName: string;
    static typeParameters: TypeParamDeclType[];
    static fields: FieldDeclType[];
    coin_types: Iterable_table.IterableTable;
    approvers: HexString[];
    constructor(proto: any, typeTag: TypeTag);
    static CoinListParser(data: any, typeTag: TypeTag, repo: AptosParserRepo): CoinList;
    static load(repo: AptosParserRepo, client: AptosClient, address: HexString, typeParams: TypeTag[]): Promise<CoinList>;
    static loadByApp(app: $.AppType, address: HexString, typeParams: TypeTag[]): Promise<CoinList>;
    static getTag(): StructTag;
    loadFullState(app: $.AppType): Promise<void>;
}
export declare class CoinRegistry {
    typeTag: TypeTag;
    static moduleAddress: HexString;
    static moduleName: string;
    __app: $.AppType | null;
    static structName: string;
    static typeParameters: TypeParamDeclType[];
    static fields: FieldDeclType[];
    type_to_coin_info: Iterable_table.IterableTable;
    uids: Stdlib.Table.Table;
    approvers: HexString[];
    constructor(proto: any, typeTag: TypeTag);
    static CoinRegistryParser(data: any, typeTag: TypeTag, repo: AptosParserRepo): CoinRegistry;
    static load(repo: AptosParserRepo, client: AptosClient, address: HexString, typeParams: TypeTag[]): Promise<CoinRegistry>;
    static loadByApp(app: $.AppType, address: HexString, typeParams: TypeTag[]): Promise<CoinRegistry>;
    static getTag(): StructTag;
    loadFullState(app: $.AppType): Promise<void>;
}
export declare class FullList {
    typeTag: TypeTag;
    static moduleAddress: HexString;
    static moduleName: string;
    __app: $.AppType | null;
    static structName: string;
    static typeParameters: TypeParamDeclType[];
    static fields: FieldDeclType[];
    coin_info_list: CoinInfo[];
    constructor(proto: any, typeTag: TypeTag);
    static FullListParser(data: any, typeTag: TypeTag, repo: AptosParserRepo): FullList;
    static load(repo: AptosParserRepo, client: AptosClient, address: HexString, typeParams: TypeTag[]): Promise<FullList>;
    static loadByApp(app: $.AppType, address: HexString, typeParams: TypeTag[]): Promise<FullList>;
    static getTag(): StructTag;
    loadFullState(app: $.AppType): Promise<void>;
}
export declare class Nothing {
    typeTag: TypeTag;
    static moduleAddress: HexString;
    static moduleName: string;
    __app: $.AppType | null;
    static structName: string;
    static typeParameters: TypeParamDeclType[];
    static fields: FieldDeclType[];
    constructor(proto: any, typeTag: TypeTag);
    static NothingParser(data: any, typeTag: TypeTag, repo: AptosParserRepo): Nothing;
    static getTag(): StructTag;
    loadFullState(app: $.AppType): Promise<void>;
}
export declare function add_approver_to_list_(list_owner: HexString, approver: HexString, $c: AptosDataCache): void;
export declare function buildPayload_add_approver_to_list(approver: HexString, isJSON?: boolean): TxnBuilderTypes.TransactionPayloadEntryFunction | Types.TransactionPayload_EntryFunctionPayload;
export declare function add_approver_to_registry_(admin: HexString, approver: HexString, $c: AptosDataCache): void;
export declare function buildPayload_add_approver_to_registry(approver: HexString, isJSON?: boolean): TxnBuilderTypes.TransactionPayloadEntryFunction | Types.TransactionPayload_EntryFunctionPayload;
export declare function add_extension_(coin_owner: HexString, key: Stdlib.String.String, value: Stdlib.String.String, $c: AptosDataCache, $p: TypeTag[]): void;
export declare function buildPayload_add_extension(key: Stdlib.String.String, value: Stdlib.String.String, $p: TypeTag[], isJSON?: boolean): TxnBuilderTypes.TransactionPayloadEntryFunction | Types.TransactionPayload_EntryFunctionPayload;
export declare function add_to_list_(approver: HexString, list: HexString, $c: AptosDataCache, $p: TypeTag[]): void;
export declare function buildPayload_add_to_list(list: HexString, $p: TypeTag[], isJSON?: boolean): TxnBuilderTypes.TransactionPayloadEntryFunction | Types.TransactionPayload_EntryFunctionPayload;
export declare function add_to_registry_(registry: CoinRegistry, name: Stdlib.String.String, symbol: Stdlib.String.String, coingecko_id: Stdlib.String.String, logo_url: Stdlib.String.String, project_url: Stdlib.String.String, is_update: boolean, $c: AptosDataCache, $p: TypeTag[]): void;
export declare function add_to_registry_by_approver_(approver: HexString, name: Stdlib.String.String, symbol: Stdlib.String.String, coingecko_id: Stdlib.String.String, logo_url: Stdlib.String.String, project_url: Stdlib.String.String, is_update: boolean, $c: AptosDataCache, $p: TypeTag[]): void;
export declare function buildPayload_add_to_registry_by_approver(name: Stdlib.String.String, symbol: Stdlib.String.String, coingecko_id: Stdlib.String.String, logo_url: Stdlib.String.String, project_url: Stdlib.String.String, is_update: boolean, $p: TypeTag[], isJSON?: boolean): TxnBuilderTypes.TransactionPayloadEntryFunction | Types.TransactionPayload_EntryFunctionPayload;
export declare function add_to_registry_by_proof_(_ownership_proof: any, name: Stdlib.String.String, symbol: Stdlib.String.String, coingecko_id: Stdlib.String.String, logo_url: Stdlib.String.String, project_url: Stdlib.String.String, is_update: boolean, $c: AptosDataCache, $p: TypeTag[]): void;
export declare function add_to_registry_by_signer_(coin_owner: HexString, name: Stdlib.String.String, symbol: Stdlib.String.String, coingecko_id: Stdlib.String.String, logo_url: Stdlib.String.String, project_url: Stdlib.String.String, is_update: boolean, $c: AptosDataCache, $p: TypeTag[]): void;
export declare function buildPayload_add_to_registry_by_signer(name: Stdlib.String.String, symbol: Stdlib.String.String, coingecko_id: Stdlib.String.String, logo_url: Stdlib.String.String, project_url: Stdlib.String.String, is_update: boolean, $p: TypeTag[], isJSON?: boolean): TxnBuilderTypes.TransactionPayloadEntryFunction | Types.TransactionPayload_EntryFunctionPayload;
export declare function create_list_(list_owner: HexString, $c: AptosDataCache): void;
export declare function buildPayload_create_list(isJSON?: boolean): TxnBuilderTypes.TransactionPayloadEntryFunction | Types.TransactionPayload_EntryFunctionPayload;
export declare function drop_extension_(coin_owner: HexString, key: Stdlib.String.String, value: Stdlib.String.String, $c: AptosDataCache, $p: TypeTag[]): void;
export declare function buildPayload_drop_extension(key: Stdlib.String.String, value: Stdlib.String.String, $p: TypeTag[], isJSON?: boolean): TxnBuilderTypes.TransactionPayloadEntryFunction | Types.TransactionPayload_EntryFunctionPayload;
export declare function fetch_all_registered_coin_info_(fetcher: HexString, $c: AptosDataCache): void;
export declare function buildPayload_fetch_all_registered_coin_info(isJSON?: boolean): TxnBuilderTypes.TransactionPayloadEntryFunction | Types.TransactionPayload_EntryFunctionPayload;
export declare function query_fetch_all_registered_coin_info(client: AptosClient, fetcher: $.SimulationKeys, repo: AptosParserRepo, $p: TypeTag[], option?: OptionTransaction, _isJSON?: boolean): Promise<FullList>;
export declare function fetch_full_list_(fetcher: HexString, list_owner_addr: HexString, $c: AptosDataCache): void;
export declare function buildPayload_fetch_full_list(list_owner_addr: HexString, isJSON?: boolean): TxnBuilderTypes.TransactionPayloadEntryFunction | Types.TransactionPayload_EntryFunctionPayload;
export declare function query_fetch_full_list(client: AptosClient, fetcher: $.SimulationKeys, repo: AptosParserRepo, list_owner_addr: HexString, $p: TypeTag[], option?: OptionTransaction, _isJSON?: boolean): Promise<FullList>;
export declare function get_all_registered_coin_info_($c: AptosDataCache): FullList;
export declare function get_coin_info_($c: AptosDataCache, $p: TypeTag[]): CoinInfo;
export declare function get_full_list_(list_owner_addr: HexString, $c: AptosDataCache): FullList;
export declare function init_module_(admin: HexString, $c: AptosDataCache): void;
export declare function buildPayload_init_module(isJSON?: boolean): TxnBuilderTypes.TransactionPayloadEntryFunction | Types.TransactionPayload_EntryFunctionPayload;
export declare function initialize_(admin: HexString, $c: AptosDataCache): void;
export declare function buildPayload_initialize(isJSON?: boolean): TxnBuilderTypes.TransactionPayloadEntryFunction | Types.TransactionPayload_EntryFunctionPayload;
export declare function is_coin_in_list_(list_owner_addr: HexString, $c: AptosDataCache, $p: TypeTag[]): boolean;
export declare function is_coin_registered_($c: AptosDataCache, $p: TypeTag[]): boolean;
export declare function is_registry_initialized_($c: AptosDataCache): boolean;
export declare function remove_approver_from_list_(list_owner: HexString, approver: HexString, $c: AptosDataCache): void;
export declare function buildPayload_remove_approver_from_list(approver: HexString, isJSON?: boolean): TxnBuilderTypes.TransactionPayloadEntryFunction | Types.TransactionPayload_EntryFunctionPayload;
export declare function remove_approver_from_registry_(admin: HexString, approver: HexString, $c: AptosDataCache): void;
export declare function buildPayload_remove_approver_from_registry(approver: HexString, isJSON?: boolean): TxnBuilderTypes.TransactionPayloadEntryFunction | Types.TransactionPayload_EntryFunctionPayload;
export declare function remove_from_list_(list_owner: HexString, $c: AptosDataCache, $p: TypeTag[]): void;
export declare function buildPayload_remove_from_list($p: TypeTag[], isJSON?: boolean): TxnBuilderTypes.TransactionPayloadEntryFunction | Types.TransactionPayload_EntryFunctionPayload;
export declare function remove_from_registry_by_approver_(_approver: HexString, $c: AptosDataCache, $p: TypeTag[]): void;
export declare function buildPayload_remove_from_registry_by_approver($p: TypeTag[], isJSON?: boolean): TxnBuilderTypes.TransactionPayloadEntryFunction | Types.TransactionPayload_EntryFunctionPayload;
export declare function remove_from_registry_by_proof_(_ownership_proof: any, $c: AptosDataCache, $p: TypeTag[]): void;
export declare function remove_from_registry_by_signer_(_coin_owner: HexString, $c: AptosDataCache, $p: TypeTag[]): void;
export declare function buildPayload_remove_from_registry_by_signer($p: TypeTag[], isJSON?: boolean): TxnBuilderTypes.TransactionPayloadEntryFunction | Types.TransactionPayload_EntryFunctionPayload;
export declare function loadParsers(repo: AptosParserRepo): void;
export declare class App {
    client: AptosClient;
    repo: AptosParserRepo;
    cache: AptosLocalCache;
    constructor(client: AptosClient, repo: AptosParserRepo, cache: AptosLocalCache);
    get moduleAddress(): HexString;
    get moduleName(): string;
    get CoinInfo(): typeof CoinInfo;
    get CoinList(): typeof CoinList;
    loadCoinList(owner: HexString, loadFull?: boolean, fillCache?: boolean): Promise<CoinList>;
    get CoinRegistry(): typeof CoinRegistry;
    loadCoinRegistry(owner: HexString, loadFull?: boolean, fillCache?: boolean): Promise<CoinRegistry>;
    get FullList(): typeof FullList;
    loadFullList(owner: HexString, loadFull?: boolean, fillCache?: boolean): Promise<FullList>;
    get Nothing(): typeof Nothing;
    payload_add_approver_to_list(approver: HexString, isJSON?: boolean): TxnBuilderTypes.TransactionPayloadEntryFunction | Types.TransactionPayload_EntryFunctionPayload;
    add_approver_to_list(_account: AptosAccount, approver: HexString, option?: OptionTransaction, _isJSON?: boolean): Promise<Types.UserTransaction>;
    payload_add_approver_to_registry(approver: HexString, isJSON?: boolean): TxnBuilderTypes.TransactionPayloadEntryFunction | Types.TransactionPayload_EntryFunctionPayload;
    add_approver_to_registry(_account: AptosAccount, approver: HexString, option?: OptionTransaction, _isJSON?: boolean): Promise<Types.UserTransaction>;
    payload_add_extension(key: Stdlib.String.String, value: Stdlib.String.String, $p: TypeTag[], isJSON?: boolean): TxnBuilderTypes.TransactionPayloadEntryFunction | Types.TransactionPayload_EntryFunctionPayload;
    add_extension(_account: AptosAccount, key: Stdlib.String.String, value: Stdlib.String.String, $p: TypeTag[], option?: OptionTransaction, _isJSON?: boolean): Promise<Types.UserTransaction>;
    payload_add_to_list(list: HexString, $p: TypeTag[], isJSON?: boolean): TxnBuilderTypes.TransactionPayloadEntryFunction | Types.TransactionPayload_EntryFunctionPayload;
    add_to_list(_account: AptosAccount, list: HexString, $p: TypeTag[], option?: OptionTransaction, _isJSON?: boolean): Promise<Types.UserTransaction>;
    payload_add_to_registry_by_approver(name: Stdlib.String.String, symbol: Stdlib.String.String, coingecko_id: Stdlib.String.String, logo_url: Stdlib.String.String, project_url: Stdlib.String.String, is_update: boolean, $p: TypeTag[], isJSON?: boolean): TxnBuilderTypes.TransactionPayloadEntryFunction | Types.TransactionPayload_EntryFunctionPayload;
    add_to_registry_by_approver(_account: AptosAccount, name: Stdlib.String.String, symbol: Stdlib.String.String, coingecko_id: Stdlib.String.String, logo_url: Stdlib.String.String, project_url: Stdlib.String.String, is_update: boolean, $p: TypeTag[], option?: OptionTransaction, _isJSON?: boolean): Promise<Types.UserTransaction>;
    payload_add_to_registry_by_signer(name: Stdlib.String.String, symbol: Stdlib.String.String, coingecko_id: Stdlib.String.String, logo_url: Stdlib.String.String, project_url: Stdlib.String.String, is_update: boolean, $p: TypeTag[], isJSON?: boolean): TxnBuilderTypes.TransactionPayloadEntryFunction | Types.TransactionPayload_EntryFunctionPayload;
    add_to_registry_by_signer(_account: AptosAccount, name: Stdlib.String.String, symbol: Stdlib.String.String, coingecko_id: Stdlib.String.String, logo_url: Stdlib.String.String, project_url: Stdlib.String.String, is_update: boolean, $p: TypeTag[], option?: OptionTransaction, _isJSON?: boolean): Promise<Types.UserTransaction>;
    payload_create_list(isJSON?: boolean): TxnBuilderTypes.TransactionPayloadEntryFunction | Types.TransactionPayload_EntryFunctionPayload;
    create_list(_account: AptosAccount, option?: OptionTransaction, _isJSON?: boolean): Promise<Types.UserTransaction>;
    payload_drop_extension(key: Stdlib.String.String, value: Stdlib.String.String, $p: TypeTag[], isJSON?: boolean): TxnBuilderTypes.TransactionPayloadEntryFunction | Types.TransactionPayload_EntryFunctionPayload;
    drop_extension(_account: AptosAccount, key: Stdlib.String.String, value: Stdlib.String.String, $p: TypeTag[], option?: OptionTransaction, _isJSON?: boolean): Promise<Types.UserTransaction>;
    payload_fetch_all_registered_coin_info(isJSON?: boolean): TxnBuilderTypes.TransactionPayloadEntryFunction | Types.TransactionPayload_EntryFunctionPayload;
    fetch_all_registered_coin_info(_account: AptosAccount, option?: OptionTransaction, _isJSON?: boolean): Promise<Types.UserTransaction>;
    query_fetch_all_registered_coin_info($p: TypeTag[], option?: OptionTransaction, _isJSON?: boolean, fetcher?: $.SimulationKeys): Promise<FullList>;
    payload_fetch_full_list(list_owner_addr: HexString, isJSON?: boolean): TxnBuilderTypes.TransactionPayloadEntryFunction | Types.TransactionPayload_EntryFunctionPayload;
    fetch_full_list(_account: AptosAccount, list_owner_addr: HexString, option?: OptionTransaction, _isJSON?: boolean): Promise<Types.UserTransaction>;
    query_fetch_full_list(list_owner_addr: HexString, $p: TypeTag[], option?: OptionTransaction, _isJSON?: boolean, fetcher?: $.SimulationKeys): Promise<FullList>;
    payload_init_module(isJSON?: boolean): TxnBuilderTypes.TransactionPayloadEntryFunction | Types.TransactionPayload_EntryFunctionPayload;
    init_module(_account: AptosAccount, option?: OptionTransaction, _isJSON?: boolean): Promise<Types.UserTransaction>;
    payload_initialize(isJSON?: boolean): TxnBuilderTypes.TransactionPayloadEntryFunction | Types.TransactionPayload_EntryFunctionPayload;
    initialize(_account: AptosAccount, option?: OptionTransaction, _isJSON?: boolean): Promise<Types.UserTransaction>;
    payload_remove_approver_from_list(approver: HexString, isJSON?: boolean): TxnBuilderTypes.TransactionPayloadEntryFunction | Types.TransactionPayload_EntryFunctionPayload;
    remove_approver_from_list(_account: AptosAccount, approver: HexString, option?: OptionTransaction, _isJSON?: boolean): Promise<Types.UserTransaction>;
    payload_remove_approver_from_registry(approver: HexString, isJSON?: boolean): TxnBuilderTypes.TransactionPayloadEntryFunction | Types.TransactionPayload_EntryFunctionPayload;
    remove_approver_from_registry(_account: AptosAccount, approver: HexString, option?: OptionTransaction, _isJSON?: boolean): Promise<Types.UserTransaction>;
    payload_remove_from_list($p: TypeTag[], isJSON?: boolean): TxnBuilderTypes.TransactionPayloadEntryFunction | Types.TransactionPayload_EntryFunctionPayload;
    remove_from_list(_account: AptosAccount, $p: TypeTag[], option?: OptionTransaction, _isJSON?: boolean): Promise<Types.UserTransaction>;
    payload_remove_from_registry_by_approver($p: TypeTag[], isJSON?: boolean): TxnBuilderTypes.TransactionPayloadEntryFunction | Types.TransactionPayload_EntryFunctionPayload;
    remove_from_registry_by_approver(_account: AptosAccount, $p: TypeTag[], option?: OptionTransaction, _isJSON?: boolean): Promise<Types.UserTransaction>;
    payload_remove_from_registry_by_signer($p: TypeTag[], isJSON?: boolean): TxnBuilderTypes.TransactionPayloadEntryFunction | Types.TransactionPayload_EntryFunctionPayload;
    remove_from_registry_by_signer(_account: AptosAccount, $p: TypeTag[], option?: OptionTransaction, _isJSON?: boolean): Promise<Types.UserTransaction>;
}
//# sourceMappingURL=coin_list.d.ts.map