import * as $ from '@manahippo/move-to-ts';
import { AptosDataCache, AptosParserRepo, AptosLocalCache } from '@manahippo/move-to-ts';
import { U8, U64 } from '@manahippo/move-to-ts';
import { TypeParamDeclType, FieldDeclType } from '@manahippo/move-to-ts';
import { StructTag, TypeTag } from '@manahippo/move-to-ts';
import { OptionTransaction } from '@manahippo/move-to-ts';
import { HexString, AptosClient, AptosAccount, TxnBuilderTypes, Types } from 'aptos';
import * as Stdlib from '../stdlib';
export declare const packageName = "CoinList";
export declare const moduleAddress: HexString;
export declare const moduleName = "devnet_coins";
export declare class CoinCaps {
    typeTag: TypeTag;
    static moduleAddress: HexString;
    static moduleName: string;
    __app: $.AppType | null;
    static structName: string;
    static typeParameters: TypeParamDeclType[];
    static fields: FieldDeclType[];
    mint: Stdlib.Coin.MintCapability;
    freeze: Stdlib.Coin.FreezeCapability;
    burn: Stdlib.Coin.BurnCapability;
    constructor(proto: any, typeTag: TypeTag);
    static CoinCapsParser(data: any, typeTag: TypeTag, repo: AptosParserRepo): CoinCaps;
    static load(repo: AptosParserRepo, client: AptosClient, address: HexString, typeParams: TypeTag[]): Promise<CoinCaps>;
    static loadByApp(app: $.AppType, address: HexString, typeParams: TypeTag[]): Promise<CoinCaps>;
    static makeTag($p: TypeTag[]): StructTag;
    loadFullState(app: $.AppType): Promise<void>;
}
export declare class DevnetBNB {
    typeTag: TypeTag;
    static moduleAddress: HexString;
    static moduleName: string;
    __app: $.AppType | null;
    static structName: string;
    static typeParameters: TypeParamDeclType[];
    static fields: FieldDeclType[];
    constructor(proto: any, typeTag: TypeTag);
    static DevnetBNBParser(data: any, typeTag: TypeTag, repo: AptosParserRepo): DevnetBNB;
    static getTag(): StructTag;
    loadFullState(app: $.AppType): Promise<void>;
}
export declare class DevnetBTC {
    typeTag: TypeTag;
    static moduleAddress: HexString;
    static moduleName: string;
    __app: $.AppType | null;
    static structName: string;
    static typeParameters: TypeParamDeclType[];
    static fields: FieldDeclType[];
    constructor(proto: any, typeTag: TypeTag);
    static DevnetBTCParser(data: any, typeTag: TypeTag, repo: AptosParserRepo): DevnetBTC;
    static getTag(): StructTag;
    loadFullState(app: $.AppType): Promise<void>;
}
export declare class DevnetDAI {
    typeTag: TypeTag;
    static moduleAddress: HexString;
    static moduleName: string;
    __app: $.AppType | null;
    static structName: string;
    static typeParameters: TypeParamDeclType[];
    static fields: FieldDeclType[];
    constructor(proto: any, typeTag: TypeTag);
    static DevnetDAIParser(data: any, typeTag: TypeTag, repo: AptosParserRepo): DevnetDAI;
    static getTag(): StructTag;
    loadFullState(app: $.AppType): Promise<void>;
}
export declare class DevnetETH {
    typeTag: TypeTag;
    static moduleAddress: HexString;
    static moduleName: string;
    __app: $.AppType | null;
    static structName: string;
    static typeParameters: TypeParamDeclType[];
    static fields: FieldDeclType[];
    constructor(proto: any, typeTag: TypeTag);
    static DevnetETHParser(data: any, typeTag: TypeTag, repo: AptosParserRepo): DevnetETH;
    static getTag(): StructTag;
    loadFullState(app: $.AppType): Promise<void>;
}
export declare class DevnetSOL {
    typeTag: TypeTag;
    static moduleAddress: HexString;
    static moduleName: string;
    __app: $.AppType | null;
    static structName: string;
    static typeParameters: TypeParamDeclType[];
    static fields: FieldDeclType[];
    constructor(proto: any, typeTag: TypeTag);
    static DevnetSOLParser(data: any, typeTag: TypeTag, repo: AptosParserRepo): DevnetSOL;
    static getTag(): StructTag;
    loadFullState(app: $.AppType): Promise<void>;
}
export declare class DevnetUSDC {
    typeTag: TypeTag;
    static moduleAddress: HexString;
    static moduleName: string;
    __app: $.AppType | null;
    static structName: string;
    static typeParameters: TypeParamDeclType[];
    static fields: FieldDeclType[];
    constructor(proto: any, typeTag: TypeTag);
    static DevnetUSDCParser(data: any, typeTag: TypeTag, repo: AptosParserRepo): DevnetUSDC;
    static getTag(): StructTag;
    loadFullState(app: $.AppType): Promise<void>;
}
export declare class DevnetUSDT {
    typeTag: TypeTag;
    static moduleAddress: HexString;
    static moduleName: string;
    __app: $.AppType | null;
    static structName: string;
    static typeParameters: TypeParamDeclType[];
    static fields: FieldDeclType[];
    constructor(proto: any, typeTag: TypeTag);
    static DevnetUSDTParser(data: any, typeTag: TypeTag, repo: AptosParserRepo): DevnetUSDT;
    static getTag(): StructTag;
    loadFullState(app: $.AppType): Promise<void>;
}
export declare function burn_(tokens: Stdlib.Coin.Coin, $c: AptosDataCache, $p: TypeTag[]): void;
export declare function deploy_(admin: HexString, $c: AptosDataCache): void;
export declare function buildPayload_deploy(isJSON?: boolean): TxnBuilderTypes.TransactionPayloadEntryFunction | Types.TransactionPayload_EntryFunctionPayload;
export declare function deposit_(user: HexString, coin: Stdlib.Coin.Coin, $c: AptosDataCache, $p: TypeTag[]): void;
export declare function init_coin_(admin: HexString, name: U8[], symbol: U8[], decimals: U8, $c: AptosDataCache, $p: TypeTag[]): void;
export declare function buildPayload_init_coin(name: U8[], symbol: U8[], decimals: U8, $p: TypeTag[], isJSON?: boolean): TxnBuilderTypes.TransactionPayloadEntryFunction | Types.TransactionPayload_EntryFunctionPayload;
export declare function init_coin_and_register_(admin: HexString, name: Stdlib.String.String, symbol: Stdlib.String.String, decimals: U8, $c: AptosDataCache, $p: TypeTag[]): void;
export declare function initialize_(admin: HexString, decimals: U8, $c: AptosDataCache, $p: TypeTag[]): void;
export declare function mint_(amount: U64, $c: AptosDataCache, $p: TypeTag[]): Stdlib.Coin.Coin;
export declare function mint_to_wallet_(user: HexString, amount: U64, $c: AptosDataCache, $p: TypeTag[]): void;
export declare function buildPayload_mint_to_wallet(amount: U64, $p: TypeTag[], isJSON?: boolean): TxnBuilderTypes.TransactionPayloadEntryFunction | Types.TransactionPayload_EntryFunctionPayload;
export declare function loadParsers(repo: AptosParserRepo): void;
export declare class App {
    client: AptosClient;
    repo: AptosParserRepo;
    cache: AptosLocalCache;
    constructor(client: AptosClient, repo: AptosParserRepo, cache: AptosLocalCache);
    get moduleAddress(): HexString;
    get moduleName(): string;
    get CoinCaps(): typeof CoinCaps;
    loadCoinCaps(owner: HexString, $p: TypeTag[], loadFull?: boolean, fillCache?: boolean): Promise<CoinCaps>;
    get DevnetBNB(): typeof DevnetBNB;
    get DevnetBTC(): typeof DevnetBTC;
    get DevnetDAI(): typeof DevnetDAI;
    get DevnetETH(): typeof DevnetETH;
    get DevnetSOL(): typeof DevnetSOL;
    get DevnetUSDC(): typeof DevnetUSDC;
    get DevnetUSDT(): typeof DevnetUSDT;
    payload_deploy(isJSON?: boolean): TxnBuilderTypes.TransactionPayloadEntryFunction | Types.TransactionPayload_EntryFunctionPayload;
    deploy(_account: AptosAccount, option?: OptionTransaction, _isJSON?: boolean): Promise<Types.UserTransaction>;
    payload_init_coin(name: U8[], symbol: U8[], decimals: U8, $p: TypeTag[], isJSON?: boolean): TxnBuilderTypes.TransactionPayloadEntryFunction | Types.TransactionPayload_EntryFunctionPayload;
    init_coin(_account: AptosAccount, name: U8[], symbol: U8[], decimals: U8, $p: TypeTag[], option?: OptionTransaction, _isJSON?: boolean): Promise<Types.UserTransaction>;
    payload_mint_to_wallet(amount: U64, $p: TypeTag[], isJSON?: boolean): TxnBuilderTypes.TransactionPayloadEntryFunction | Types.TransactionPayload_EntryFunctionPayload;
    mint_to_wallet(_account: AptosAccount, amount: U64, $p: TypeTag[], option?: OptionTransaction, _isJSON?: boolean): Promise<Types.UserTransaction>;
}
//# sourceMappingURL=devnet_coins.d.ts.map