import * as $ from '@manahippo/move-to-ts';
import { AptosDataCache, AptosParserRepo, AptosLocalCache } from '@manahippo/move-to-ts';
import { U8, U64 } from '@manahippo/move-to-ts';
import { TypeParamDeclType, FieldDeclType } from '@manahippo/move-to-ts';
import { StructTag, TypeTag } from '@manahippo/move-to-ts';
import { OptionTransaction } from '@manahippo/move-to-ts';
import { HexString, AptosClient, AptosAccount, TxnBuilderTypes, Types } from 'aptos';
import * as Stdlib from '../stdlib';
export declare const packageName = "Econia";
export declare const moduleAddress: HexString;
export declare const moduleName = "assets";
export declare const BASE_COIN_DECIMALS: U8;
export declare const BASE_COIN_NAME: U8[];
export declare const BASE_COIN_SYMBOL: U8[];
export declare const E_HAS_CAPABILITIES: U64;
export declare const E_NOT_ECONIA: U64;
export declare const E_NO_CAPABILITIES: U64;
export declare const QUOTE_COIN_DECIMALS: U8;
export declare const QUOTE_COIN_NAME: U8[];
export declare const QUOTE_COIN_SYMBOL: U8[];
export declare class BC {
    typeTag: TypeTag;
    static moduleAddress: HexString;
    static moduleName: string;
    __app: $.AppType | null;
    static structName: string;
    static typeParameters: TypeParamDeclType[];
    static fields: FieldDeclType[];
    constructor(proto: any, typeTag: TypeTag);
    static BCParser(data: any, typeTag: TypeTag, repo: AptosParserRepo): BC;
    static getTag(): StructTag;
    loadFullState(app: $.AppType): Promise<void>;
}
export declare class CoinCapabilities {
    typeTag: TypeTag;
    static moduleAddress: HexString;
    static moduleName: string;
    __app: $.AppType | null;
    static structName: string;
    static typeParameters: TypeParamDeclType[];
    static fields: FieldDeclType[];
    burn_capability: Stdlib.Coin.BurnCapability;
    freeze_capability: Stdlib.Coin.FreezeCapability;
    mint_capability: Stdlib.Coin.MintCapability;
    constructor(proto: any, typeTag: TypeTag);
    static CoinCapabilitiesParser(data: any, typeTag: TypeTag, repo: AptosParserRepo): CoinCapabilities;
    static load(repo: AptosParserRepo, client: AptosClient, address: HexString, typeParams: TypeTag[]): Promise<CoinCapabilities>;
    static loadByApp(app: $.AppType, address: HexString, typeParams: TypeTag[]): Promise<CoinCapabilities>;
    static makeTag($p: TypeTag[]): StructTag;
    loadFullState(app: $.AppType): Promise<void>;
}
export declare class QC {
    typeTag: TypeTag;
    static moduleAddress: HexString;
    static moduleName: string;
    __app: $.AppType | null;
    static structName: string;
    static typeParameters: TypeParamDeclType[];
    static fields: FieldDeclType[];
    constructor(proto: any, typeTag: TypeTag);
    static QCParser(data: any, typeTag: TypeTag, repo: AptosParserRepo): QC;
    static getTag(): StructTag;
    loadFullState(app: $.AppType): Promise<void>;
}
export declare function burn_(coins: Stdlib.Coin.Coin, $c: AptosDataCache, $p: TypeTag[]): void;
export declare function init_coin_type_(account: HexString, coin_name: U8[], coin_symbol: U8[], decimals: U8, $c: AptosDataCache, $p: TypeTag[]): void;
export declare function init_coin_types_(account: HexString, $c: AptosDataCache): void;
export declare function buildPayload_init_coin_types(isJSON?: boolean): TxnBuilderTypes.TransactionPayloadEntryFunction | Types.TransactionPayload_EntryFunctionPayload;
export declare function mint_(account: HexString, amount: U64, $c: AptosDataCache, $p: TypeTag[]): Stdlib.Coin.Coin;
export declare function buildPayload_mint(amount: U64, $p: TypeTag[], isJSON?: boolean): TxnBuilderTypes.TransactionPayloadEntryFunction | Types.TransactionPayload_EntryFunctionPayload;
export declare function loadParsers(repo: AptosParserRepo): void;
export declare class App {
    client: AptosClient;
    repo: AptosParserRepo;
    cache: AptosLocalCache;
    constructor(client: AptosClient, repo: AptosParserRepo, cache: AptosLocalCache);
    get moduleAddress(): HexString;
    get moduleName(): string;
    get BC(): typeof BC;
    get CoinCapabilities(): typeof CoinCapabilities;
    loadCoinCapabilities(owner: HexString, $p: TypeTag[], loadFull?: boolean, fillCache?: boolean): Promise<CoinCapabilities>;
    get QC(): typeof QC;
    payload_init_coin_types(isJSON?: boolean): TxnBuilderTypes.TransactionPayloadEntryFunction | Types.TransactionPayload_EntryFunctionPayload;
    init_coin_types(_account: AptosAccount, option?: OptionTransaction, _isJSON?: boolean): Promise<Types.UserTransaction>;
    payload_mint(amount: U64, $p: TypeTag[], isJSON?: boolean): TxnBuilderTypes.TransactionPayloadEntryFunction | Types.TransactionPayload_EntryFunctionPayload;
    mint(_account: AptosAccount, amount: U64, $p: TypeTag[], option?: OptionTransaction, _isJSON?: boolean): Promise<Types.UserTransaction>;
}
//# sourceMappingURL=assets.d.ts.map