import * as $ from '@manahippo/move-to-ts';
import { AptosDataCache, AptosParserRepo, AptosLocalCache } from '@manahippo/move-to-ts';
import { U8, U64 } from '@manahippo/move-to-ts';
import { TypeParamDeclType, FieldDeclType } from '@manahippo/move-to-ts';
import { StructTag, TypeTag } from '@manahippo/move-to-ts';
import { OptionTransaction } from '@manahippo/move-to-ts';
import { HexString, AptosClient, AptosAccount, TxnBuilderTypes, Types } from 'aptos';
import * as Stdlib from '../stdlib';
export declare const packageName = "HippoAggregator";
export declare const moduleAddress: HexString;
export declare const moduleName = "aggregator";
export declare const DEX_ANIMESWAP: U8;
export declare const DEX_APTOSWAP: U8;
export declare const DEX_AUX: U8;
export declare const DEX_BASIQ: U8;
export declare const DEX_DITTO: U8;
export declare const DEX_ECONIA: U8;
export declare const DEX_HIPPO: U8;
export declare const DEX_PONTEM: U8;
export declare const DEX_TORTUGA: U8;
export declare const E_COIN_STORE_NOT_EXITES: U64;
export declare const E_INVALID_PAIR_OF_DITTO: U64;
export declare const E_INVALID_PAIR_OF_TORTUGA: U64;
export declare const E_NOT_ADMIN: U64;
export declare const E_OUTPUT_LESS_THAN_MINIMUM: U64;
export declare const E_TYPE_NOT_EQUAL: U64;
export declare const E_UNKNOWN_DEX: U64;
export declare const E_UNKNOWN_POOL_TYPE: U64;
export declare const E_UNSUPPORTED_NUM_STEPS: U64;
export declare const HIPPO_CONSTANT_PRODUCT: U64;
export declare const HIPPO_PIECEWISE: U64;
export declare const HI_64: U64;
export declare class AuxSigner {
    typeTag: TypeTag;
    static moduleAddress: HexString;
    static moduleName: string;
    __app: $.AppType | null;
    static structName: string;
    static typeParameters: TypeParamDeclType[];
    static fields: FieldDeclType[];
    signerCapability: Stdlib.Account.SignerCapability;
    constructor(proto: any, typeTag: TypeTag);
    static AuxSignerParser(data: any, typeTag: TypeTag, repo: AptosParserRepo): AuxSigner;
    static load(repo: AptosParserRepo, client: AptosClient, address: HexString, typeParams: TypeTag[]): Promise<AuxSigner>;
    static loadByApp(app: $.AppType, address: HexString, typeParams: TypeTag[]): Promise<AuxSigner>;
    static getTag(): StructTag;
    loadFullState(app: $.AppType): Promise<void>;
}
export declare class CoinStore {
    typeTag: TypeTag;
    static moduleAddress: HexString;
    static moduleName: string;
    __app: $.AppType | null;
    static structName: string;
    static typeParameters: TypeParamDeclType[];
    static fields: FieldDeclType[];
    balance: Stdlib.Coin.Coin;
    constructor(proto: any, typeTag: TypeTag);
    static CoinStoreParser(data: any, typeTag: TypeTag, repo: AptosParserRepo): CoinStore;
    static load(repo: AptosParserRepo, client: AptosClient, address: HexString, typeParams: TypeTag[]): Promise<CoinStore>;
    static loadByApp(app: $.AppType, address: HexString, typeParams: TypeTag[]): Promise<CoinStore>;
    static makeTag($p: TypeTag[]): StructTag;
    loadFullState(app: $.AppType): Promise<void>;
}
export declare class EventStore {
    typeTag: TypeTag;
    static moduleAddress: HexString;
    static moduleName: string;
    __app: $.AppType | null;
    static structName: string;
    static typeParameters: TypeParamDeclType[];
    static fields: FieldDeclType[];
    swap_step_events: Stdlib.Event.EventHandle;
    constructor(proto: any, typeTag: TypeTag);
    static EventStoreParser(data: any, typeTag: TypeTag, repo: AptosParserRepo): EventStore;
    static load(repo: AptosParserRepo, client: AptosClient, address: HexString, typeParams: TypeTag[]): Promise<EventStore>;
    static loadByApp(app: $.AppType, address: HexString, typeParams: TypeTag[]): Promise<EventStore>;
    static getTag(): StructTag;
    loadFullState(app: $.AppType): Promise<void>;
}
export declare class SwapStepEvent {
    typeTag: TypeTag;
    static moduleAddress: HexString;
    static moduleName: string;
    __app: $.AppType | null;
    static structName: string;
    static typeParameters: TypeParamDeclType[];
    static fields: FieldDeclType[];
    dex_type: U8;
    pool_type: U64;
    x_type_info: Stdlib.Type_info.TypeInfo;
    y_type_info: Stdlib.Type_info.TypeInfo;
    input_amount: U64;
    output_amount: U64;
    time_stamp: U64;
    constructor(proto: any, typeTag: TypeTag);
    static SwapStepEventParser(data: any, typeTag: TypeTag, repo: AptosParserRepo): SwapStepEvent;
    static getTag(): StructTag;
    loadFullState(app: $.AppType): Promise<void>;
}
export declare function change_coin_type_(x_coin: Stdlib.Coin.Coin, $c: AptosDataCache, $p: TypeTag[]): Stdlib.Coin.Coin;
export declare function check_and_deposit_(sender: HexString, coin: Stdlib.Coin.Coin, $c: AptosDataCache, $p: TypeTag[]): void;
export declare function check_and_deposit_opt_(sender: HexString, coin_opt: Stdlib.Option.Option, $c: AptosDataCache, $p: TypeTag[]): void;
export declare function create_aux_signer_(admin: HexString, $c: AptosDataCache): void;
export declare function buildPayload_create_aux_signer(isJSON?: boolean): TxnBuilderTypes.TransactionPayloadEntryFunction | Types.TransactionPayload_EntryFunctionPayload;
export declare function emit_swap_step_event_(dex_type: U8, pool_type: U64, input_amount: U64, output_amount: U64, $c: AptosDataCache, $p: TypeTag[]): void;
export declare function get_intermediate_output_(dex_type: U8, pool_type: U64, is_x_to_y: boolean, x_in: Stdlib.Coin.Coin, $c: AptosDataCache, $p: TypeTag[]): [Stdlib.Option.Option, Stdlib.Coin.Coin];
export declare function init_coin_store_(admin: HexString, $c: AptosDataCache, $p: TypeTag[]): void;
export declare function buildPayload_init_coin_store($p: TypeTag[], isJSON?: boolean): TxnBuilderTypes.TransactionPayloadEntryFunction | Types.TransactionPayload_EntryFunctionPayload;
export declare function init_coin_store_all_(admin: HexString, $c: AptosDataCache): void;
export declare function buildPayload_init_coin_store_all(isJSON?: boolean): TxnBuilderTypes.TransactionPayloadEntryFunction | Types.TransactionPayload_EntryFunctionPayload;
export declare function init_module_(admin: HexString, $c: AptosDataCache): void;
export declare function buildPayload_init_module(isJSON?: boolean): TxnBuilderTypes.TransactionPayloadEntryFunction | Types.TransactionPayload_EntryFunctionPayload;
export declare function one_step_direct_(dex_type: U8, pool_type: U64, is_x_to_y: boolean, x_in: Stdlib.Coin.Coin, $c: AptosDataCache, $p: TypeTag[]): [Stdlib.Option.Option, Stdlib.Coin.Coin];
export declare function one_step_route_(sender: HexString, first_dex_type: U8, first_pool_type: U64, first_is_x_to_y: boolean, x_in: U64, y_min_out: U64, $c: AptosDataCache, $p: TypeTag[]): void;
export declare function buildPayload_one_step_route(first_dex_type: U8, first_pool_type: U64, first_is_x_to_y: boolean, x_in: U64, y_min_out: U64, $p: TypeTag[], isJSON?: boolean): TxnBuilderTypes.TransactionPayloadEntryFunction | Types.TransactionPayload_EntryFunctionPayload;
export declare function swap_(sender: HexString, num_steps: U8, first_dex_type: U8, first_pool_type: U64, first_is_x_to_y: boolean, second_dex_type: U8, second_pool_type: U64, second_is_x_to_y: boolean, third_dex_type: U8, third_pool_type: U64, third_is_x_to_y: boolean, x_in: U64, m_min_out: U64, $c: AptosDataCache, $p: TypeTag[]): void;
export declare function buildPayload_swap(num_steps: U8, first_dex_type: U8, first_pool_type: U64, first_is_x_to_y: boolean, second_dex_type: U8, second_pool_type: U64, second_is_x_to_y: boolean, third_dex_type: U8, third_pool_type: U64, third_is_x_to_y: boolean, x_in: U64, m_min_out: U64, $p: TypeTag[], isJSON?: boolean): TxnBuilderTypes.TransactionPayloadEntryFunction | Types.TransactionPayload_EntryFunctionPayload;
export declare function swap_direct_(num_steps: U8, first_dex_type: U8, first_pool_type: U64, first_is_x_to_y: boolean, second_dex_type: U8, second_pool_type: U64, second_is_x_to_y: boolean, third_dex_type: U8, third_pool_type: U64, third_is_x_to_y: boolean, x_in: Stdlib.Coin.Coin, $c: AptosDataCache, $p: TypeTag[]): [Stdlib.Option.Option, Stdlib.Option.Option, Stdlib.Option.Option, Stdlib.Coin.Coin];
export declare function three_step_direct_(first_dex_type: U8, first_pool_type: U64, first_is_x_to_y: boolean, second_dex_type: U8, second_pool_type: U64, second_is_x_to_y: boolean, third_dex_type: U8, third_pool_type: U64, third_is_x_to_y: boolean, x_in: Stdlib.Coin.Coin, $c: AptosDataCache, $p: TypeTag[]): [Stdlib.Option.Option, Stdlib.Option.Option, Stdlib.Option.Option, Stdlib.Coin.Coin];
export declare function three_step_route_(sender: HexString, first_dex_type: U8, first_pool_type: U64, first_is_x_to_y: boolean, second_dex_type: U8, second_pool_type: U64, second_is_x_to_y: boolean, third_dex_type: U8, third_pool_type: U64, third_is_x_to_y: boolean, x_in: U64, m_min_out: U64, $c: AptosDataCache, $p: TypeTag[]): void;
export declare function buildPayload_three_step_route(first_dex_type: U8, first_pool_type: U64, first_is_x_to_y: boolean, second_dex_type: U8, second_pool_type: U64, second_is_x_to_y: boolean, third_dex_type: U8, third_pool_type: U64, third_is_x_to_y: boolean, x_in: U64, m_min_out: U64, $p: TypeTag[], isJSON?: boolean): TxnBuilderTypes.TransactionPayloadEntryFunction | Types.TransactionPayload_EntryFunctionPayload;
export declare function two_step_direct_(first_dex_type: U8, first_pool_type: U64, first_is_x_to_y: boolean, second_dex_type: U8, second_pool_type: U64, second_is_x_to_y: boolean, x_in: Stdlib.Coin.Coin, $c: AptosDataCache, $p: TypeTag[]): [Stdlib.Option.Option, Stdlib.Option.Option, Stdlib.Coin.Coin];
export declare function two_step_route_(sender: HexString, first_dex_type: U8, first_pool_type: U64, first_is_x_to_y: boolean, second_dex_type: U8, second_pool_type: U64, second_is_x_to_y: boolean, x_in: U64, z_min_out: U64, $c: AptosDataCache, $p: TypeTag[]): void;
export declare function buildPayload_two_step_route(first_dex_type: U8, first_pool_type: U64, first_is_x_to_y: boolean, second_dex_type: U8, second_pool_type: U64, second_is_x_to_y: boolean, x_in: U64, z_min_out: U64, $p: TypeTag[], isJSON?: boolean): TxnBuilderTypes.TransactionPayloadEntryFunction | Types.TransactionPayload_EntryFunctionPayload;
export declare function loadParsers(repo: AptosParserRepo): void;
export declare class App {
    client: AptosClient;
    repo: AptosParserRepo;
    cache: AptosLocalCache;
    constructor(client: AptosClient, repo: AptosParserRepo, cache: AptosLocalCache);
    get moduleAddress(): HexString;
    get moduleName(): string;
    get AuxSigner(): typeof AuxSigner;
    loadAuxSigner(owner: HexString, loadFull?: boolean, fillCache?: boolean): Promise<AuxSigner>;
    get CoinStore(): typeof CoinStore;
    loadCoinStore(owner: HexString, $p: TypeTag[], loadFull?: boolean, fillCache?: boolean): Promise<CoinStore>;
    get EventStore(): typeof EventStore;
    loadEventStore(owner: HexString, loadFull?: boolean, fillCache?: boolean): Promise<EventStore>;
    get SwapStepEvent(): typeof SwapStepEvent;
    payload_create_aux_signer(isJSON?: boolean): TxnBuilderTypes.TransactionPayloadEntryFunction | Types.TransactionPayload_EntryFunctionPayload;
    create_aux_signer(_account: AptosAccount, option?: OptionTransaction, _isJSON?: boolean): Promise<Types.UserTransaction>;
    payload_init_coin_store($p: TypeTag[], isJSON?: boolean): TxnBuilderTypes.TransactionPayloadEntryFunction | Types.TransactionPayload_EntryFunctionPayload;
    init_coin_store(_account: AptosAccount, $p: TypeTag[], option?: OptionTransaction, _isJSON?: boolean): Promise<Types.UserTransaction>;
    payload_init_coin_store_all(isJSON?: boolean): TxnBuilderTypes.TransactionPayloadEntryFunction | Types.TransactionPayload_EntryFunctionPayload;
    init_coin_store_all(_account: AptosAccount, option?: OptionTransaction, _isJSON?: boolean): Promise<Types.UserTransaction>;
    payload_init_module(isJSON?: boolean): TxnBuilderTypes.TransactionPayloadEntryFunction | Types.TransactionPayload_EntryFunctionPayload;
    init_module(_account: AptosAccount, option?: OptionTransaction, _isJSON?: boolean): Promise<Types.UserTransaction>;
    payload_one_step_route(first_dex_type: U8, first_pool_type: U64, first_is_x_to_y: boolean, x_in: U64, y_min_out: U64, $p: TypeTag[], isJSON?: boolean): TxnBuilderTypes.TransactionPayloadEntryFunction | Types.TransactionPayload_EntryFunctionPayload;
    one_step_route(_account: AptosAccount, first_dex_type: U8, first_pool_type: U64, first_is_x_to_y: boolean, x_in: U64, y_min_out: U64, $p: TypeTag[], option?: OptionTransaction, _isJSON?: boolean): Promise<Types.UserTransaction>;
    payload_swap(num_steps: U8, first_dex_type: U8, first_pool_type: U64, first_is_x_to_y: boolean, second_dex_type: U8, second_pool_type: U64, second_is_x_to_y: boolean, third_dex_type: U8, third_pool_type: U64, third_is_x_to_y: boolean, x_in: U64, m_min_out: U64, $p: TypeTag[], isJSON?: boolean): TxnBuilderTypes.TransactionPayloadEntryFunction | Types.TransactionPayload_EntryFunctionPayload;
    swap(_account: AptosAccount, num_steps: U8, first_dex_type: U8, first_pool_type: U64, first_is_x_to_y: boolean, second_dex_type: U8, second_pool_type: U64, second_is_x_to_y: boolean, third_dex_type: U8, third_pool_type: U64, third_is_x_to_y: boolean, x_in: U64, m_min_out: U64, $p: TypeTag[], option?: OptionTransaction, _isJSON?: boolean): Promise<Types.UserTransaction>;
    payload_three_step_route(first_dex_type: U8, first_pool_type: U64, first_is_x_to_y: boolean, second_dex_type: U8, second_pool_type: U64, second_is_x_to_y: boolean, third_dex_type: U8, third_pool_type: U64, third_is_x_to_y: boolean, x_in: U64, m_min_out: U64, $p: TypeTag[], isJSON?: boolean): TxnBuilderTypes.TransactionPayloadEntryFunction | Types.TransactionPayload_EntryFunctionPayload;
    three_step_route(_account: AptosAccount, first_dex_type: U8, first_pool_type: U64, first_is_x_to_y: boolean, second_dex_type: U8, second_pool_type: U64, second_is_x_to_y: boolean, third_dex_type: U8, third_pool_type: U64, third_is_x_to_y: boolean, x_in: U64, m_min_out: U64, $p: TypeTag[], option?: OptionTransaction, _isJSON?: boolean): Promise<Types.UserTransaction>;
    payload_two_step_route(first_dex_type: U8, first_pool_type: U64, first_is_x_to_y: boolean, second_dex_type: U8, second_pool_type: U64, second_is_x_to_y: boolean, x_in: U64, z_min_out: U64, $p: TypeTag[], isJSON?: boolean): TxnBuilderTypes.TransactionPayloadEntryFunction | Types.TransactionPayload_EntryFunctionPayload;
    two_step_route(_account: AptosAccount, first_dex_type: U8, first_pool_type: U64, first_is_x_to_y: boolean, second_dex_type: U8, second_pool_type: U64, second_is_x_to_y: boolean, x_in: U64, z_min_out: U64, $p: TypeTag[], option?: OptionTransaction, _isJSON?: boolean): Promise<Types.UserTransaction>;
}
//# sourceMappingURL=aggregator.d.ts.map