import * as $ from '@manahippo/move-to-ts';
import { AptosDataCache, AptosParserRepo, AptosLocalCache } from '@manahippo/move-to-ts';
import { U64 } from '@manahippo/move-to-ts';
import { TypeParamDeclType, FieldDeclType } from '@manahippo/move-to-ts';
import { StructTag, TypeTag } from '@manahippo/move-to-ts';
import { OptionTransaction } from '@manahippo/move-to-ts';
import { HexString, AptosClient, AptosAccount, TxnBuilderTypes, Types } from 'aptos';
export declare const packageName = "HippoAggregator";
export declare const moduleAddress: HexString;
export declare const moduleName = "devnet";
export declare const BTC_AMOUNT: U64;
export declare const STABLE_COIN_AMOUNT: U64;
export declare class PontemLP {
    typeTag: TypeTag;
    static moduleAddress: HexString;
    static moduleName: string;
    __app: $.AppType | null;
    static structName: string;
    static typeParameters: TypeParamDeclType[];
    static fields: FieldDeclType[];
    constructor(proto: any, typeTag: TypeTag);
    static PontemLPParser(data: any, typeTag: TypeTag, repo: AptosParserRepo): PontemLP;
    static makeTag($p: TypeTag[]): StructTag;
    loadFullState(app: $.AppType): Promise<void>;
}
export declare class PontemLP2 {
    typeTag: TypeTag;
    static moduleAddress: HexString;
    static moduleName: string;
    __app: $.AppType | null;
    static structName: string;
    static typeParameters: TypeParamDeclType[];
    static fields: FieldDeclType[];
    constructor(proto: any, typeTag: TypeTag);
    static PontemLP2Parser(data: any, typeTag: TypeTag, repo: AptosParserRepo): PontemLP2;
    static makeTag($p: TypeTag[]): StructTag;
    loadFullState(app: $.AppType): Promise<void>;
}
export declare function deploy_aux_(admin: HexString, xAmount: U64, yAmount: U64, $c: AptosDataCache, $p: TypeTag[]): void;
export declare function deploy_pontem_(admin: HexString, xAmount: U64, yAmount: U64, $c: AptosDataCache, $p: TypeTag[]): void;
export declare function mock_deploy_aux_(admin: HexString, $c: AptosDataCache): void;
export declare function buildPayload_mock_deploy_aux(isJSON?: boolean): TxnBuilderTypes.TransactionPayloadEntryFunction | Types.TransactionPayload_EntryFunctionPayload;
export declare function mock_deploy_pontem_(admin: HexString, $c: AptosDataCache): void;
export declare function buildPayload_mock_deploy_pontem(isJSON?: boolean): TxnBuilderTypes.TransactionPayloadEntryFunction | Types.TransactionPayload_EntryFunctionPayload;
export declare function registe_coins_(hippo_swap: HexString, coin_list: HexString, deploy_coin_list: boolean, $c: AptosDataCache): void;
export declare function buildPayload_registe_coins(deploy_coin_list: boolean, isJSON?: boolean): TxnBuilderTypes.TransactionPayloadEntryFunction | Types.TransactionPayload_EntryFunctionPayload;
export declare function loadParsers(repo: AptosParserRepo): void;
export declare class App {
    client: AptosClient;
    repo: AptosParserRepo;
    cache: AptosLocalCache;
    constructor(client: AptosClient, repo: AptosParserRepo, cache: AptosLocalCache);
    get moduleAddress(): HexString;
    get moduleName(): string;
    get PontemLP(): typeof PontemLP;
    get PontemLP2(): typeof PontemLP2;
    payload_mock_deploy_aux(isJSON?: boolean): TxnBuilderTypes.TransactionPayloadEntryFunction | Types.TransactionPayload_EntryFunctionPayload;
    mock_deploy_aux(_account: AptosAccount, option?: OptionTransaction, _isJSON?: boolean): Promise<Types.UserTransaction>;
    payload_mock_deploy_pontem(isJSON?: boolean): TxnBuilderTypes.TransactionPayloadEntryFunction | Types.TransactionPayload_EntryFunctionPayload;
    mock_deploy_pontem(_account: AptosAccount, option?: OptionTransaction, _isJSON?: boolean): Promise<Types.UserTransaction>;
    payload_registe_coins(deploy_coin_list: boolean, isJSON?: boolean): TxnBuilderTypes.TransactionPayloadEntryFunction | Types.TransactionPayload_EntryFunctionPayload;
    registe_coins(_account: AptosAccount, deploy_coin_list: boolean, option?: OptionTransaction, _isJSON?: boolean): Promise<Types.UserTransaction>;
}
//# sourceMappingURL=devnet.d.ts.map