import * as $ from '@manahippo/move-to-ts';
import { AptosDataCache, AptosParserRepo, AptosLocalCache } from '@manahippo/move-to-ts';
import { U64 } from '@manahippo/move-to-ts';
import { TypeParamDeclType, FieldDeclType } from '@manahippo/move-to-ts';
import { StructTag, TypeTag } from '@manahippo/move-to-ts';
import { HexString, AptosClient } from 'aptos';
export declare const packageName = "Liquidswap";
export declare const moduleAddress: HexString;
export declare const moduleName = "curves";
export declare const ERR_INVALID_CURVE: U64;
export declare class Stable {
    typeTag: TypeTag;
    static moduleAddress: HexString;
    static moduleName: string;
    __app: $.AppType | null;
    static structName: string;
    static typeParameters: TypeParamDeclType[];
    static fields: FieldDeclType[];
    constructor(proto: any, typeTag: TypeTag);
    static StableParser(data: any, typeTag: TypeTag, repo: AptosParserRepo): Stable;
    static getTag(): StructTag;
    loadFullState(app: $.AppType): Promise<void>;
}
export declare class Uncorrelated {
    typeTag: TypeTag;
    static moduleAddress: HexString;
    static moduleName: string;
    __app: $.AppType | null;
    static structName: string;
    static typeParameters: TypeParamDeclType[];
    static fields: FieldDeclType[];
    constructor(proto: any, typeTag: TypeTag);
    static UncorrelatedParser(data: any, typeTag: TypeTag, repo: AptosParserRepo): Uncorrelated;
    static getTag(): StructTag;
    loadFullState(app: $.AppType): Promise<void>;
}
export declare function assert_valid_curve_($c: AptosDataCache, $p: TypeTag[]): void;
export declare function is_stable_($c: AptosDataCache, $p: TypeTag[]): boolean;
export declare function is_uncorrelated_($c: AptosDataCache, $p: TypeTag[]): boolean;
export declare function is_valid_curve_($c: AptosDataCache, $p: TypeTag[]): boolean;
export declare function loadParsers(repo: AptosParserRepo): void;
export declare class App {
    client: AptosClient;
    repo: AptosParserRepo;
    cache: AptosLocalCache;
    constructor(client: AptosClient, repo: AptosParserRepo, cache: AptosLocalCache);
    get moduleAddress(): HexString;
    get moduleName(): string;
    get Stable(): typeof Stable;
    get Uncorrelated(): typeof Uncorrelated;
}
//# sourceMappingURL=curves.d.ts.map