import { AptosClient } from 'aptos';
import { AptosParserRepo, AptosLocalCache } from '@manahippo/move-to-ts';
import * as Coin_helper from './coin_helper';
import * as Curves from './curves';
import * as Liquidity_pool from './liquidity_pool';
import * as Math from './math';
import * as Router from './router';
import * as Scripts from './scripts';
import * as Stable_curve from './stable_curve';
export * as Coin_helper from './coin_helper';
export * as Curves from './curves';
export * as Liquidity_pool from './liquidity_pool';
export * as Math from './math';
export * as Router from './router';
export * as Scripts from './scripts';
export * as Stable_curve from './stable_curve';
export declare function loadParsers(repo: AptosParserRepo): void;
export declare function getPackageRepo(): AptosParserRepo;
export declare type AppType = {
    client: AptosClient;
    repo: AptosParserRepo;
    cache: AptosLocalCache;
};
export declare class App {
    client: AptosClient;
    repo: AptosParserRepo;
    cache: AptosLocalCache;
    coin_helper: Coin_helper.App;
    curves: Curves.App;
    liquidity_pool: Liquidity_pool.App;
    math: Math.App;
    router: Router.App;
    scripts: Scripts.App;
    stable_curve: Stable_curve.App;
    constructor(client: AptosClient, repo: AptosParserRepo, cache: AptosLocalCache);
}
//# sourceMappingURL=index.d.ts.map