import { AptosDataCache, AptosParserRepo, AptosLocalCache } from '@manahippo/move-to-ts';
import { U64 } from '@manahippo/move-to-ts';
import { TypeTag } from '@manahippo/move-to-ts';
import { HexString, AptosClient } from 'aptos';
import * as Stdlib from '../stdlib';
export declare const packageName = "Liquidswap";
export declare const moduleAddress: HexString;
export declare const moduleName = "router";
export declare const ERR_UNREACHABLE: U64;
export declare function get_amount_out_(amount_in: U64, $c: AptosDataCache, $p: TypeTag[]): U64;
export declare function get_coin_out_with_fees_(coin_in: U64, reserve_in: U64, reserve_out: U64, scale_in: U64, scale_out: U64, $c: AptosDataCache, $p: TypeTag[]): U64;
export declare function get_decimals_scales_($c: AptosDataCache, $p: TypeTag[]): [U64, U64];
export declare function get_fees_config_($c: AptosDataCache, $p: TypeTag[]): [U64, U64];
export declare function get_reserves_size_($c: AptosDataCache, $p: TypeTag[]): [U64, U64];
export declare function swap_exact_coin_for_coin_(coin_in: Stdlib.Coin.Coin, _mint_out_amt: U64, $c: AptosDataCache, $p: TypeTag[]): Stdlib.Coin.Coin;
export declare function loadParsers(repo: AptosParserRepo): void;
export declare class App {
    client: AptosClient;
    repo: AptosParserRepo;
    cache: AptosLocalCache;
    constructor(client: AptosClient, repo: AptosParserRepo, cache: AptosLocalCache);
    get moduleAddress(): HexString;
    get moduleName(): string;
}
//# sourceMappingURL=router.d.ts.map