import { AptosDataCache, AptosParserRepo, AptosLocalCache } from '@manahippo/move-to-ts';
import { U64, U128 } from '@manahippo/move-to-ts';
import { HexString, AptosClient } from 'aptos';
import * as U256 from '../u256';
export declare const packageName = "Liquidswap";
export declare const moduleAddress: HexString;
export declare const moduleName = "stable_curve";
export declare const ONE_E_8: U128;
export declare function coin_out_(coin_in: U128, scale_in: U64, scale_out: U64, reserve_in: U128, reserve_out: U128, $c: AptosDataCache): U128;
export declare function d_(x0_u256: U256.U256.U256, y_u256: U256.U256.U256, $c: AptosDataCache): U256.U256.U256;
export declare function f_(x0_u256: U256.U256.U256, y_u256: U256.U256.U256, $c: AptosDataCache): U256.U256.U256;
export declare function get_y_(x0: U256.U256.U256, xy: U256.U256.U256, y: U256.U256.U256, $c: AptosDataCache): U256.U256.U256;
export declare function lp_value_(x_coin: U128, x_scale: U64, y_coin: U128, y_scale: U64, $c: AptosDataCache): U256.U256.U256;
export declare function loadParsers(repo: AptosParserRepo): void;
export declare class App {
    client: AptosClient;
    repo: AptosParserRepo;
    cache: AptosLocalCache;
    constructor(client: AptosClient, repo: AptosParserRepo, cache: AptosLocalCache);
    get moduleAddress(): HexString;
    get moduleName(): string;
}
//# sourceMappingURL=stable_curve.d.ts.map