import * as $ from '@manahippo/move-to-ts';
import { AptosDataCache, AptosParserRepo, AptosLocalCache } from '@manahippo/move-to-ts';
import { U8, U64, U128 } from '@manahippo/move-to-ts';
import { TypeParamDeclType, FieldDeclType } from '@manahippo/move-to-ts';
import { StructTag, TypeTag } from '@manahippo/move-to-ts';
import { HexString, AptosClient } from 'aptos';
export declare const packageName = "U256";
export declare const moduleAddress: HexString;
export declare const moduleName = "u256";
export declare const ECAST_OVERFLOW: U64;
export declare const EDIV_BY_ZERO: U64;
export declare const EOVERFLOW: U64;
export declare const EQUAL: U8;
export declare const EWORDS_OVERFLOW: U64;
export declare const GREATER_THAN: U8;
export declare const LESS_THAN: U8;
export declare const U128_MAX: U128;
export declare const U64_MAX: U128;
export declare const WORDS: U64;
export declare class DU256 {
    typeTag: TypeTag;
    static moduleAddress: HexString;
    static moduleName: string;
    __app: $.AppType | null;
    static structName: string;
    static typeParameters: TypeParamDeclType[];
    static fields: FieldDeclType[];
    v0: U64;
    v1: U64;
    v2: U64;
    v3: U64;
    v4: U64;
    v5: U64;
    v6: U64;
    v7: U64;
    constructor(proto: any, typeTag: TypeTag);
    static DU256Parser(data: any, typeTag: TypeTag, repo: AptosParserRepo): DU256;
    static getTag(): StructTag;
    loadFullState(app: $.AppType): Promise<void>;
}
export declare class U256 {
    typeTag: TypeTag;
    static moduleAddress: HexString;
    static moduleName: string;
    __app: $.AppType | null;
    static structName: string;
    static typeParameters: TypeParamDeclType[];
    static fields: FieldDeclType[];
    v0: U64;
    v1: U64;
    v2: U64;
    v3: U64;
    constructor(proto: any, typeTag: TypeTag);
    static U256Parser(data: any, typeTag: TypeTag, repo: AptosParserRepo): U256;
    static getTag(): StructTag;
    loadFullState(app: $.AppType): Promise<void>;
}
export declare function add_(a: U256, b: U256, $c: AptosDataCache): U256;
export declare function as_u128_(a: U256, $c: AptosDataCache): U128;
export declare function as_u64_(a: U256, $c: AptosDataCache): U64;
export declare function bitand_(a: U256, b: U256, $c: AptosDataCache): U256;
export declare function bitor_(a: U256, b: U256, $c: AptosDataCache): U256;
export declare function bits_(a: U256, $c: AptosDataCache): U64;
export declare function bitxor_(a: U256, b: U256, $c: AptosDataCache): U256;
export declare function compare_(a: U256, b: U256, $c: AptosDataCache): U8;
export declare function div_(a: U256, b: U256, $c: AptosDataCache): U256;
export declare function du256_to_u256_(a: DU256, $c: AptosDataCache): [U256, boolean];
export declare function from_u128_(val: U128, $c: AptosDataCache): U256;
export declare function from_u64_(val: U64, $c: AptosDataCache): U256;
export declare function get_(a: U256, i: U64, $c: AptosDataCache): U64;
export declare function get_d_(a: DU256, i: U64, $c: AptosDataCache): U64;
export declare function leading_zeros_u64_(a: U64, $c: AptosDataCache): U8;
export declare function mul_(a: U256, b: U256, $c: AptosDataCache): U256;
export declare function overflowing_add_(a: U64, b: U64, $c: AptosDataCache): [U64, boolean];
export declare function overflowing_sub_(a: U64, b: U64, $c: AptosDataCache): [U64, boolean];
export declare function put_(a: U256, i: U64, val: U64, $c: AptosDataCache): void;
export declare function put_d_(a: DU256, i: U64, val: U64, $c: AptosDataCache): void;
export declare function shl_(a: U256, shift: U8, $c: AptosDataCache): U256;
export declare function shr_(a: U256, shift: U8, $c: AptosDataCache): U256;
export declare function split_u128_(a: U128, $c: AptosDataCache): [U64, U64];
export declare function sub_(a: U256, b: U256, $c: AptosDataCache): U256;
export declare function zero_($c: AptosDataCache): U256;
export declare function loadParsers(repo: AptosParserRepo): void;
export declare class App {
    client: AptosClient;
    repo: AptosParserRepo;
    cache: AptosLocalCache;
    constructor(client: AptosClient, repo: AptosParserRepo, cache: AptosLocalCache);
    get moduleAddress(): HexString;
    get moduleName(): string;
    get DU256(): typeof DU256;
    get U256(): typeof U256;
}
//# sourceMappingURL=u256.d.ts.map