import { StructTag, AptosParserRepo, AptosLocalCache } from '@manahippo/move-to-ts';
import { AptosClient, HexString } from 'aptos';
import * as AptosStdlib from './generated/stdlib';
import { Coin_list } from './generated/coin_list';
import { App } from './generated';
import * as $ from '@manahippo/move-to-ts';
export declare function typeInfoToTypeTag(typeInfo: AptosStdlib.Type_info.TypeInfo): $.TypeTag;
export declare function typeTagToTypeInfo(tag: StructTag): AptosStdlib.Type_info.TypeInfo;
export declare function isTypeInfoSame(ti1: AptosStdlib.Type_info.TypeInfo, ti2: AptosStdlib.Type_info.TypeInfo): boolean;
export declare function printResource(resource: any): void;
export declare function printResources(resources: any[]): void;
export declare function getCoinStoresForAddress(client: AptosClient, address: HexString, repo: AptosParserRepo, version?: undefined | number | bigint): Promise<AptosStdlib.Coin.CoinStore[]>;
export declare function parseCoinInfoListFromCoinList(registry: Coin_list.CoinRegistry, coinList: Coin_list.CoinList, cache: AptosLocalCache): Coin_list.CoinInfo[];
export declare function queryFetchFullList(app: App, owner: HexString, expireTimestampSecFromNow?: number): Promise<Coin_list.FullList>;
//# sourceMappingURL=utils.d.ts.map