import { HexString, TxnBuilderTypes, Types } from 'aptos';
import { NetworkConfiguration } from '../config';
import * as AptosFramework from '../generated/stdlib';
import * as CoinList from '../generated/coin_list';
import { App } from '../generated';
export declare class HippoWalletClient {
    netConf: NetworkConfiguration;
    app: App;
    walletAddress: HexString;
    coinStores: AptosFramework.Coin.CoinStore[];
    symbolToCoinStore: Record<string, AptosFramework.Coin.CoinStore>;
    fullnameToCoinStore: Record<string, AptosFramework.Coin.CoinStore>;
    symbolToTokenInfo: Record<string, CoinList.Coin_list.CoinInfo>;
    fullnameToTokenInfo: Record<string, CoinList.Coin_list.CoinInfo>;
    devnetCoinSymbols: string[];
    private constructor();
    buildCache(): Promise<void>;
    refreshStores(version?: undefined | number | bigint): Promise<void>;
    static createInTwoCalls(netConf: NetworkConfiguration, app: App, walletAddress: HexString, version?: undefined | number | bigint): Promise<HippoWalletClient>;
    makeFaucetMintToPayload(uiAmount: number, symbol: string, isJSONPayload?: boolean): TxnBuilderTypes.TransactionPayloadEntryFunction | Types.TransactionPayload_EntryFunctionPayload;
    debugPrint(): void;
}
//# sourceMappingURL=hippoWalletClient.d.ts.map