import { HexString } from 'aptos';
import * as $ from '@manahippo/move-to-ts';
import { u64, u8, VectorTag, StructTag, SimpleStructTag, AtomicTypeTag, u128, AptosParserRepo, AptosLocalCache, u8str, parseTypeTagOrThrow, strToU8, parseMoveStructTag, getTypeTagFullname, moveValueToOpenApiObject, U64 } from '@manahippo/move-to-ts';
export { u128, u64, u8 } from '@manahippo/move-to-ts';
import bigInt from 'big-integer';

/*! *****************************************************************************
Copyright (c) Microsoft Corporation.

Permission to use, copy, modify, and/or distribute this software for any
purpose with or without fee is hereby granted.

THE SOFTWARE IS PROVIDED "AS IS" AND THE AUTHOR DISCLAIMS ALL WARRANTIES WITH
REGARD TO THIS SOFTWARE INCLUDING ALL IMPLIED WARRANTIES OF MERCHANTABILITY
AND FITNESS. IN NO EVENT SHALL THE AUTHOR BE LIABLE FOR ANY SPECIAL, DIRECT,
INDIRECT, OR CONSEQUENTIAL DAMAGES OR ANY DAMAGES WHATSOEVER RESULTING FROM
LOSS OF USE, DATA OR PROFITS, WHETHER IN AN ACTION OF CONTRACT, NEGLIGENCE OR
OTHER TORTIOUS ACTION, ARISING OUT OF OR IN CONNECTION WITH THE USE OR
PERFORMANCE OF THIS SOFTWARE.
***************************************************************************** */

function __awaiter(thisArg, _arguments, P, generator) {
    function adopt(value) { return value instanceof P ? value : new P(function (resolve) { resolve(value); }); }
    return new (P || (P = Promise))(function (resolve, reject) {
        function fulfilled(value) { try { step(generator.next(value)); } catch (e) { reject(e); } }
        function rejected(value) { try { step(generator["throw"](value)); } catch (e) { reject(e); } }
        function step(result) { result.done ? resolve(result.value) : adopt(result.value).then(fulfilled, rejected); }
        step((generator = generator.apply(thisArg, _arguments || [])).next());
    });
}

const packageName$1v = 'MoveStdlib';
const moduleAddress$1v = new HexString('0x1');
const moduleName$1v = 'bcs';
function to_bytes_(v, $c, $p /* <MoveValue>*/) {
    return $.std_bcs_to_bytes(v, $c, [$p[0]]);
}
function loadParsers$1I(repo) { }
class App$1J {
    constructor(client, repo, cache) {
        this.client = client;
        this.repo = repo;
        this.cache = cache;
    }
    get moduleAddress() {
        {
            return moduleAddress$1v;
        }
    }
    get moduleName() {
        {
            return moduleName$1v;
        }
    }
}

var Bcs = /*#__PURE__*/Object.freeze({
    __proto__: null,
    packageName: packageName$1v,
    moduleAddress: moduleAddress$1v,
    moduleName: moduleName$1v,
    to_bytes_: to_bytes_,
    loadParsers: loadParsers$1I,
    App: App$1J
});

const packageName$1u = 'MoveStdlib';
const moduleAddress$1u = new HexString('0x1');
const moduleName$1u = 'error';
const ABORTED = u64('7');
const ALREADY_EXISTS = u64('8');
const CANCELLED = u64('10');
const INTERNAL = u64('11');
const INVALID_ARGUMENT = u64('1');
const INVALID_STATE = u64('3');
const NOT_FOUND = u64('6');
const NOT_IMPLEMENTED = u64('12');
const OUT_OF_RANGE = u64('2');
const PERMISSION_DENIED = u64('5');
const RESOURCE_EXHAUSTED = u64('9');
const UNAUTHENTICATED = u64('4');
const UNAVAILABLE = u64('13');
function aborted_(r, $c) {
    return canonical_($.copy(ABORTED), $.copy(r));
}
function already_exists_(r, $c) {
    return canonical_($.copy(ALREADY_EXISTS), $.copy(r));
}
function canonical_(category, reason, $c) {
    return $.copy(category).shl(u8('16')).add($.copy(reason));
}
function internal_(r, $c) {
    return canonical_($.copy(INTERNAL), $.copy(r));
}
function invalid_argument_(r, $c) {
    return canonical_($.copy(INVALID_ARGUMENT), $.copy(r));
}
function invalid_state_(r, $c) {
    return canonical_($.copy(INVALID_STATE), $.copy(r));
}
function not_found_(r, $c) {
    return canonical_($.copy(NOT_FOUND), $.copy(r));
}
function not_implemented_(r, $c) {
    return canonical_($.copy(NOT_IMPLEMENTED), $.copy(r));
}
function out_of_range_(r, $c) {
    return canonical_($.copy(OUT_OF_RANGE), $.copy(r));
}
function permission_denied_(r, $c) {
    return canonical_($.copy(PERMISSION_DENIED), $.copy(r));
}
function resource_exhausted_(r, $c) {
    return canonical_($.copy(RESOURCE_EXHAUSTED), $.copy(r));
}
function unauthenticated_(r, $c) {
    return canonical_($.copy(UNAUTHENTICATED), $.copy(r));
}
function unavailable_(r, $c) {
    return canonical_($.copy(UNAVAILABLE), $.copy(r));
}
function loadParsers$1H(repo) { }
class App$1I {
    constructor(client, repo, cache) {
        this.client = client;
        this.repo = repo;
        this.cache = cache;
    }
    get moduleAddress() {
        {
            return moduleAddress$1u;
        }
    }
    get moduleName() {
        {
            return moduleName$1u;
        }
    }
}

var Error$1 = /*#__PURE__*/Object.freeze({
    __proto__: null,
    packageName: packageName$1u,
    moduleAddress: moduleAddress$1u,
    moduleName: moduleName$1u,
    ABORTED: ABORTED,
    ALREADY_EXISTS: ALREADY_EXISTS,
    CANCELLED: CANCELLED,
    INTERNAL: INTERNAL,
    INVALID_ARGUMENT: INVALID_ARGUMENT,
    INVALID_STATE: INVALID_STATE,
    NOT_FOUND: NOT_FOUND,
    NOT_IMPLEMENTED: NOT_IMPLEMENTED,
    OUT_OF_RANGE: OUT_OF_RANGE,
    PERMISSION_DENIED: PERMISSION_DENIED,
    RESOURCE_EXHAUSTED: RESOURCE_EXHAUSTED,
    UNAUTHENTICATED: UNAUTHENTICATED,
    UNAVAILABLE: UNAVAILABLE,
    aborted_: aborted_,
    already_exists_: already_exists_,
    canonical_: canonical_,
    internal_: internal_,
    invalid_argument_: invalid_argument_,
    invalid_state_: invalid_state_,
    not_found_: not_found_,
    not_implemented_: not_implemented_,
    out_of_range_: out_of_range_,
    permission_denied_: permission_denied_,
    resource_exhausted_: resource_exhausted_,
    unauthenticated_: unauthenticated_,
    unavailable_: unavailable_,
    loadParsers: loadParsers$1H,
    App: App$1I
});

const packageName$1t = 'MoveStdlib';
const moduleAddress$1t = new HexString('0x1');
const moduleName$1t = 'hash';
function sha2_256_(data, $c) {
    return $.std_hash_sha2_256(data, $c);
}
function sha3_256_(data, $c) {
    return $.std_hash_sha3_256(data, $c);
}
function loadParsers$1G(repo) { }
class App$1H {
    constructor(client, repo, cache) {
        this.client = client;
        this.repo = repo;
        this.cache = cache;
    }
    get moduleAddress() {
        {
            return moduleAddress$1t;
        }
    }
    get moduleName() {
        {
            return moduleName$1t;
        }
    }
}

var Hash = /*#__PURE__*/Object.freeze({
    __proto__: null,
    packageName: packageName$1t,
    moduleAddress: moduleAddress$1t,
    moduleName: moduleName$1t,
    sha2_256_: sha2_256_,
    sha3_256_: sha3_256_,
    loadParsers: loadParsers$1G,
    App: App$1H
});

const packageName$1s = 'MoveStdlib';
const moduleAddress$1s = new HexString('0x1');
const moduleName$1s = 'vector';
const EINDEX_OUT_OF_BOUNDS = u64('131072');
function append_$3(lhs, other, $c, $p /* <Element>*/) {
    reverse_(other, $c, [$p[0]]);
    while (!is_empty_$2(other, $c, [$p[0]])) {
        {
            push_back_(lhs, pop_back_(other, $c, [$p[0]]), $c, [$p[0]]);
        }
    }
    destroy_empty_$5(other, $c, [$p[0]]);
    return;
}
function borrow_$7(v, i, $c, $p /* <Element>*/) {
    return $.std_vector_borrow(v, i, $c, [$p[0]]);
}
function borrow_mut_$7(v, i, $c, $p /* <Element>*/) {
    return $.std_vector_borrow_mut(v, i, $c, [$p[0]]);
}
function contains_$8(v, e, $c, $p /* <Element>*/) {
    let i, len;
    i = u64('0');
    len = length_$6(v, $c, [$p[0]]);
    while ($.copy(i).lt($.copy(len))) {
        {
            if ($.dyn_eq($p[0], borrow_$7(v, $.copy(i), $c, [$p[0]]), e)) {
                return true;
            }
            i = $.copy(i).add(u64('1'));
        }
    }
    return false;
}
function destroy_empty_$5(v, $c, $p /* <Element>*/) {
    return $.std_vector_destroy_empty(v, $c, [$p[0]]);
}
function empty_$5($c, $p /* <Element>*/) {
    return $.std_vector_empty($c, [$p[0]]);
}
function index_of_$1(v, e, $c, $p /* <Element>*/) {
    let i, len;
    i = u64('0');
    len = length_$6(v, $c, [$p[0]]);
    while ($.copy(i).lt($.copy(len))) {
        {
            if ($.dyn_eq($p[0], borrow_$7(v, $.copy(i), $c, [$p[0]]), e)) {
                return [true, $.copy(i)];
            }
            i = $.copy(i).add(u64('1'));
        }
    }
    return [false, u64('0')];
}
function is_empty_$2(v, $c, $p /* <Element>*/) {
    return length_$6(v, $c, [$p[0]]).eq(u64('0'));
}
function length_$6(v, $c, $p /* <Element>*/) {
    return $.std_vector_length(v, $c, [$p[0]]);
}
function pop_back_(v, $c, $p /* <Element>*/) {
    return $.std_vector_pop_back(v, $c, [$p[0]]);
}
function push_back_(v, e, $c, $p /* <Element>*/) {
    return $.std_vector_push_back(v, e, $c, [$p[0]]);
}
function remove_$5(v, i, $c, $p /* <Element>*/) {
    let temp$1, temp$2, len;
    len = length_$6(v, $c, [$p[0]]);
    if ($.copy(i).ge($.copy(len))) {
        throw $.abortCode($.copy(EINDEX_OUT_OF_BOUNDS));
    }
    len = $.copy(len).sub(u64('1'));
    while ($.copy(i).lt($.copy(len))) {
        {
            temp$2 = v;
            temp$1 = $.copy(i);
            i = $.copy(i).add(u64('1'));
            swap_$4(temp$2, temp$1, $.copy(i), $c, [$p[0]]);
        }
    }
    return pop_back_(v, $c, [$p[0]]);
}
function reverse_(v, $c, $p /* <Element>*/) {
    let back_index, front_index, len;
    len = length_$6(v, $c, [$p[0]]);
    if ($.copy(len).eq(u64('0'))) {
        return;
    }
    front_index = u64('0');
    back_index = $.copy(len).sub(u64('1'));
    while ($.copy(front_index).lt($.copy(back_index))) {
        {
            swap_$4(v, $.copy(front_index), $.copy(back_index), $c, [$p[0]]);
            front_index = $.copy(front_index).add(u64('1'));
            back_index = $.copy(back_index).sub(u64('1'));
        }
    }
    return;
}
function singleton_$1(e, $c, $p /* <Element>*/) {
    let v;
    v = empty_$5($c, [$p[0]]);
    push_back_(v, e, $c, [$p[0]]);
    return v;
}
function swap_$4(v, i, j, $c, $p /* <Element>*/) {
    return $.std_vector_swap(v, i, j, $c, [$p[0]]);
}
function swap_remove_(v, i, $c, $p /* <Element>*/) {
    let last_idx;
    if (!!is_empty_$2(v, $c, [$p[0]])) {
        throw $.abortCode($.copy(EINDEX_OUT_OF_BOUNDS));
    }
    last_idx = length_$6(v, $c, [$p[0]]).sub(u64('1'));
    swap_$4(v, $.copy(i), $.copy(last_idx), $c, [$p[0]]);
    return pop_back_(v, $c, [$p[0]]);
}
function loadParsers$1F(repo) { }
class App$1G {
    constructor(client, repo, cache) {
        this.client = client;
        this.repo = repo;
        this.cache = cache;
    }
    get moduleAddress() {
        {
            return moduleAddress$1s;
        }
    }
    get moduleName() {
        {
            return moduleName$1s;
        }
    }
}

var Vector = /*#__PURE__*/Object.freeze({
    __proto__: null,
    packageName: packageName$1s,
    moduleAddress: moduleAddress$1s,
    moduleName: moduleName$1s,
    EINDEX_OUT_OF_BOUNDS: EINDEX_OUT_OF_BOUNDS,
    append_: append_$3,
    borrow_: borrow_$7,
    borrow_mut_: borrow_mut_$7,
    contains_: contains_$8,
    destroy_empty_: destroy_empty_$5,
    empty_: empty_$5,
    index_of_: index_of_$1,
    is_empty_: is_empty_$2,
    length_: length_$6,
    pop_back_: pop_back_,
    push_back_: push_back_,
    remove_: remove_$5,
    reverse_: reverse_,
    singleton_: singleton_$1,
    swap_: swap_$4,
    swap_remove_: swap_remove_,
    loadParsers: loadParsers$1F,
    App: App$1G
});

const packageName$1r = 'MoveStdlib';
const moduleAddress$1r = new HexString('0x1');
const moduleName$1r = 'option';
const EOPTION_IS_SET = u64('262144');
const EOPTION_NOT_SET = u64('262145');
class Option {
    constructor(proto, typeTag) {
        this.typeTag = typeTag;
        this.__app = null;
        this.vec = proto['vec'];
    }
    static OptionParser(data, typeTag, repo) {
        const proto = $.parseStructProto(data, typeTag, repo, Option);
        return new Option(proto, typeTag);
    }
    static makeTag($p) {
        return new StructTag(moduleAddress$1r, moduleName$1r, 'Option', $p);
    }
    loadFullState(app) {
        return __awaiter(this, void 0, void 0, function* () {
            this.__app = app;
        });
    }
}
Option.moduleAddress = moduleAddress$1r;
Option.moduleName = moduleName$1r;
Option.structName = 'Option';
Option.typeParameters = [{ name: 'Element', isPhantom: false }];
Option.fields = [{ name: 'vec', typeTag: new VectorTag(new $.TypeParamIdx(0)) }];
function borrow_$6(t, $c, $p /* <Element>*/) {
    if (!is_some_(t, $c, [$p[0]])) {
        throw $.abortCode($.copy(EOPTION_NOT_SET));
    }
    return borrow_$7(t.vec, u64('0'), $c, [$p[0]]);
}
function borrow_mut_$6(t, $c, $p /* <Element>*/) {
    if (!is_some_(t, $c, [$p[0]])) {
        throw $.abortCode($.copy(EOPTION_NOT_SET));
    }
    return borrow_mut_$7(t.vec, u64('0'), $c, [$p[0]]);
}
function borrow_with_default_(t, default_ref, $c, $p /* <Element>*/) {
    let temp$1, vec_ref;
    vec_ref = t.vec;
    if (is_empty_$2(vec_ref, $c, [$p[0]])) {
        temp$1 = default_ref;
    }
    else {
        temp$1 = borrow_$7(vec_ref, u64('0'), $c, [$p[0]]);
    }
    return temp$1;
}
function contains_$7(t, e_ref, $c, $p /* <Element>*/) {
    return contains_$8(t.vec, e_ref, $c, [$p[0]]);
}
function destroy_none_(t, $c, $p /* <Element>*/) {
    if (!is_none_(t, $c, [$p[0]])) {
        throw $.abortCode($.copy(EOPTION_IS_SET));
    }
    let { vec: vec } = t;
    return destroy_empty_$5(vec, $c, [$p[0]]);
}
function destroy_some_(t, $c, $p /* <Element>*/) {
    let elem;
    if (!is_some_(t, $c, [$p[0]])) {
        throw $.abortCode($.copy(EOPTION_NOT_SET));
    }
    let { vec: vec } = t;
    elem = pop_back_(vec, $c, [$p[0]]);
    destroy_empty_$5(vec, $c, [$p[0]]);
    return elem;
}
function destroy_with_default_(t, default__, $c, $p /* <Element>*/) {
    let temp$1;
    let { vec: vec } = t;
    if (is_empty_$2(vec, $c, [$p[0]])) {
        temp$1 = default__;
    }
    else {
        temp$1 = pop_back_(vec, $c, [$p[0]]);
    }
    return temp$1;
}
function extract_$1(t, $c, $p /* <Element>*/) {
    if (!is_some_(t, $c, [$p[0]])) {
        throw $.abortCode($.copy(EOPTION_NOT_SET));
    }
    return pop_back_(t.vec, $c, [$p[0]]);
}
function fill_(t, e, $c, $p /* <Element>*/) {
    let vec_ref;
    vec_ref = t.vec;
    if (is_empty_$2(vec_ref, $c, [$p[0]])) {
        push_back_(vec_ref, e, $c, [$p[0]]);
    }
    else {
        throw $.abortCode($.copy(EOPTION_IS_SET));
    }
    return;
}
function get_with_default_(t, default__, $c, $p /* <Element>*/) {
    let temp$1, vec_ref;
    vec_ref = t.vec;
    if (is_empty_$2(vec_ref, $c, [$p[0]])) {
        temp$1 = $.copy(default__);
    }
    else {
        temp$1 = $.copy(borrow_$7(vec_ref, u64('0'), $c, [$p[0]]));
    }
    return temp$1;
}
function is_none_(t, $c, $p /* <Element>*/) {
    return is_empty_$2(t.vec, $c, [$p[0]]);
}
function is_some_(t, $c, $p /* <Element>*/) {
    return !is_empty_$2(t.vec, $c, [$p[0]]);
}
function none_($c, $p /* <Element>*/) {
    return new Option({ vec: empty_$5($c, [$p[0]]) }, new SimpleStructTag(Option, [$p[0]]));
}
function some_(e, $c, $p /* <Element>*/) {
    return new Option({ vec: singleton_$1(e, $c, [$p[0]]) }, new SimpleStructTag(Option, [$p[0]]));
}
function swap_$3(t, e, $c, $p /* <Element>*/) {
    let old_value, vec_ref;
    if (!is_some_(t, $c, [$p[0]])) {
        throw $.abortCode($.copy(EOPTION_NOT_SET));
    }
    vec_ref = t.vec;
    old_value = pop_back_(vec_ref, $c, [$p[0]]);
    push_back_(vec_ref, e, $c, [$p[0]]);
    return old_value;
}
function swap_or_fill_(t, e, $c, $p /* <Element>*/) {
    let temp$1, old_value, vec_ref;
    vec_ref = t.vec;
    if (is_empty_$2(vec_ref, $c, [$p[0]])) {
        temp$1 = none_($c, [$p[0]]);
    }
    else {
        temp$1 = some_(pop_back_(vec_ref, $c, [$p[0]]), $c, [$p[0]]);
    }
    old_value = temp$1;
    push_back_(vec_ref, e, $c, [$p[0]]);
    return old_value;
}
function to_vec_(t, $c, $p /* <Element>*/) {
    let { vec: vec } = t;
    return vec;
}
function loadParsers$1E(repo) {
    repo.addParser('0x1::option::Option', Option.OptionParser);
}
class App$1F {
    constructor(client, repo, cache) {
        this.client = client;
        this.repo = repo;
        this.cache = cache;
    }
    get moduleAddress() {
        {
            return moduleAddress$1r;
        }
    }
    get moduleName() {
        {
            return moduleName$1r;
        }
    }
    get Option() {
        return Option;
    }
}

var Option$1 = /*#__PURE__*/Object.freeze({
    __proto__: null,
    packageName: packageName$1r,
    moduleAddress: moduleAddress$1r,
    moduleName: moduleName$1r,
    EOPTION_IS_SET: EOPTION_IS_SET,
    EOPTION_NOT_SET: EOPTION_NOT_SET,
    Option: Option,
    borrow_: borrow_$6,
    borrow_mut_: borrow_mut_$6,
    borrow_with_default_: borrow_with_default_,
    contains_: contains_$7,
    destroy_none_: destroy_none_,
    destroy_some_: destroy_some_,
    destroy_with_default_: destroy_with_default_,
    extract_: extract_$1,
    fill_: fill_,
    get_with_default_: get_with_default_,
    is_none_: is_none_,
    is_some_: is_some_,
    none_: none_,
    some_: some_,
    swap_: swap_$3,
    swap_or_fill_: swap_or_fill_,
    to_vec_: to_vec_,
    loadParsers: loadParsers$1E,
    App: App$1F
});

const packageName$1q = 'AptosStdlib';
const moduleAddress$1q = new HexString('0x1');
const moduleName$1q = 'type_info';
class TypeInfo {
    constructor(proto, typeTag) {
        this.typeTag = typeTag;
        this.__app = null;
        this.account_address = proto['account_address'];
        this.module_name = proto['module_name'];
        this.struct_name = proto['struct_name'];
    }
    static TypeInfoParser(data, typeTag, repo) {
        const proto = $.parseStructProto(data, typeTag, repo, TypeInfo);
        return new TypeInfo(proto, typeTag);
    }
    static getTag() {
        return new StructTag(moduleAddress$1q, moduleName$1q, 'TypeInfo', []);
    }
    typeFullname() {
        return `${this.account_address.toShortString()}::${$.u8str(this.module_name)}::${$.u8str(this.struct_name)}`;
    }
    toTypeTag() {
        return $.parseTypeTagOrThrow(this.typeFullname());
    }
    moduleName() {
        return this.toTypeTag().module;
    }
    structName() {
        return this.toTypeTag().name;
    }
    loadFullState(app) {
        return __awaiter(this, void 0, void 0, function* () {
            this.__app = app;
        });
    }
}
TypeInfo.moduleAddress = moduleAddress$1q;
TypeInfo.moduleName = moduleName$1q;
TypeInfo.structName = 'TypeInfo';
TypeInfo.typeParameters = [];
TypeInfo.fields = [
    { name: 'account_address', typeTag: AtomicTypeTag.Address },
    { name: 'module_name', typeTag: new VectorTag(AtomicTypeTag.U8) },
    { name: 'struct_name', typeTag: new VectorTag(AtomicTypeTag.U8) }
];
function account_address_(type_info, $c) {
    return $.copy(type_info.account_address);
}
function module_name_(type_info, $c) {
    return $.copy(type_info.module_name);
}
function struct_name_(type_info, $c) {
    return $.copy(type_info.struct_name);
}
function type_name_$2($c, $p /* <T>*/) {
    return $.aptos_std_type_info_type_name($c, [$p[0]]);
}
function type_of_($c, $p /* <T>*/) {
    return $.aptos_std_type_info_type_of($c, [$p[0]]);
}
function loadParsers$1D(repo) {
    repo.addParser('0x1::type_info::TypeInfo', TypeInfo.TypeInfoParser);
}
class App$1E {
    constructor(client, repo, cache) {
        this.client = client;
        this.repo = repo;
        this.cache = cache;
    }
    get moduleAddress() {
        {
            return moduleAddress$1q;
        }
    }
    get moduleName() {
        {
            return moduleName$1q;
        }
    }
    get TypeInfo() {
        return TypeInfo;
    }
}

var Type_info = /*#__PURE__*/Object.freeze({
    __proto__: null,
    packageName: packageName$1q,
    moduleAddress: moduleAddress$1q,
    moduleName: moduleName$1q,
    TypeInfo: TypeInfo,
    account_address_: account_address_,
    module_name_: module_name_,
    struct_name_: struct_name_,
    type_name_: type_name_$2,
    type_of_: type_of_,
    loadParsers: loadParsers$1D,
    App: App$1E
});

const packageName$1p = 'AptosStdlib';
const moduleAddress$1p = new HexString('0x1');
const moduleName$1p = 'ed25519';
const E_WRONG_PUBKEY_SIZE$1 = u64('1');
const E_WRONG_SIGNATURE_SIZE$1 = u64('2');
const PUBLIC_KEY_NUM_BYTES$1 = u64('32');
const SIGNATURE_NUM_BYTES$1 = u64('64');
const SIGNATURE_SCHEME_ID$1 = u8('0');
class Signature$2 {
    constructor(proto, typeTag) {
        this.typeTag = typeTag;
        this.__app = null;
        this.bytes = proto['bytes'];
    }
    static SignatureParser(data, typeTag, repo) {
        const proto = $.parseStructProto(data, typeTag, repo, Signature$2);
        return new Signature$2(proto, typeTag);
    }
    static getTag() {
        return new StructTag(moduleAddress$1p, moduleName$1p, 'Signature', []);
    }
    loadFullState(app) {
        return __awaiter(this, void 0, void 0, function* () {
            this.__app = app;
        });
    }
}
Signature$2.moduleAddress = moduleAddress$1p;
Signature$2.moduleName = moduleName$1p;
Signature$2.structName = 'Signature';
Signature$2.typeParameters = [];
Signature$2.fields = [{ name: 'bytes', typeTag: new VectorTag(AtomicTypeTag.U8) }];
class SignedMessage {
    constructor(proto, typeTag) {
        this.typeTag = typeTag;
        this.__app = null;
        this.type_info = proto['type_info'];
        this.inner = proto['inner'];
    }
    static SignedMessageParser(data, typeTag, repo) {
        const proto = $.parseStructProto(data, typeTag, repo, SignedMessage);
        return new SignedMessage(proto, typeTag);
    }
    static makeTag($p) {
        return new StructTag(moduleAddress$1p, moduleName$1p, 'SignedMessage', $p);
    }
    loadFullState(app) {
        return __awaiter(this, void 0, void 0, function* () {
            yield this.type_info.loadFullState(app);
            if (this.inner.typeTag instanceof StructTag) {
                yield this.inner.loadFullState(app);
            }
            this.__app = app;
        });
    }
}
SignedMessage.moduleAddress = moduleAddress$1p;
SignedMessage.moduleName = moduleName$1p;
SignedMessage.structName = 'SignedMessage';
SignedMessage.typeParameters = [{ name: 'MessageType', isPhantom: false }];
SignedMessage.fields = [
    { name: 'type_info', typeTag: new StructTag(new HexString('0x1'), 'type_info', 'TypeInfo', []) },
    { name: 'inner', typeTag: new $.TypeParamIdx(0) }
];
class UnvalidatedPublicKey$1 {
    constructor(proto, typeTag) {
        this.typeTag = typeTag;
        this.__app = null;
        this.bytes = proto['bytes'];
    }
    static UnvalidatedPublicKeyParser(data, typeTag, repo) {
        const proto = $.parseStructProto(data, typeTag, repo, UnvalidatedPublicKey$1);
        return new UnvalidatedPublicKey$1(proto, typeTag);
    }
    static getTag() {
        return new StructTag(moduleAddress$1p, moduleName$1p, 'UnvalidatedPublicKey', []);
    }
    loadFullState(app) {
        return __awaiter(this, void 0, void 0, function* () {
            this.__app = app;
        });
    }
}
UnvalidatedPublicKey$1.moduleAddress = moduleAddress$1p;
UnvalidatedPublicKey$1.moduleName = moduleName$1p;
UnvalidatedPublicKey$1.structName = 'UnvalidatedPublicKey';
UnvalidatedPublicKey$1.typeParameters = [];
UnvalidatedPublicKey$1.fields = [{ name: 'bytes', typeTag: new VectorTag(AtomicTypeTag.U8) }];
class ValidatedPublicKey$1 {
    constructor(proto, typeTag) {
        this.typeTag = typeTag;
        this.__app = null;
        this.bytes = proto['bytes'];
    }
    static ValidatedPublicKeyParser(data, typeTag, repo) {
        const proto = $.parseStructProto(data, typeTag, repo, ValidatedPublicKey$1);
        return new ValidatedPublicKey$1(proto, typeTag);
    }
    static getTag() {
        return new StructTag(moduleAddress$1p, moduleName$1p, 'ValidatedPublicKey', []);
    }
    loadFullState(app) {
        return __awaiter(this, void 0, void 0, function* () {
            this.__app = app;
        });
    }
}
ValidatedPublicKey$1.moduleAddress = moduleAddress$1p;
ValidatedPublicKey$1.moduleName = moduleName$1p;
ValidatedPublicKey$1.structName = 'ValidatedPublicKey';
ValidatedPublicKey$1.typeParameters = [];
ValidatedPublicKey$1.fields = [{ name: 'bytes', typeTag: new VectorTag(AtomicTypeTag.U8) }];
function new_signature_from_bytes_$1(bytes, $c) {
    if (!length_$6(bytes, $c, [AtomicTypeTag.U8]).eq($.copy(SIGNATURE_NUM_BYTES$1))) {
        throw $.abortCode(invalid_argument_($.copy(E_WRONG_SIGNATURE_SIZE$1)));
    }
    return new Signature$2({ bytes: $.copy(bytes) }, new SimpleStructTag(Signature$2));
}
function new_signed_message_(data, $c, $p /* <T>*/) {
    return new SignedMessage({ type_info: type_of_($c, [$p[0]]), inner: data }, new SimpleStructTag(SignedMessage, [$p[0]]));
}
function new_unvalidated_public_key_from_bytes_$1(bytes, $c) {
    if (!length_$6(bytes, $c, [AtomicTypeTag.U8]).eq($.copy(PUBLIC_KEY_NUM_BYTES$1))) {
        throw $.abortCode(invalid_argument_($.copy(E_WRONG_PUBKEY_SIZE$1)));
    }
    return new UnvalidatedPublicKey$1({ bytes: $.copy(bytes) }, new SimpleStructTag(UnvalidatedPublicKey$1));
}
function new_validated_public_key_from_bytes_$1(bytes, $c) {
    let temp$1;
    if (public_key_validate_internal_$1($.copy(bytes), $c)) {
        temp$1 = some_(new ValidatedPublicKey$1({ bytes: $.copy(bytes) }, new SimpleStructTag(ValidatedPublicKey$1)), $c, [new SimpleStructTag(ValidatedPublicKey$1)]);
    }
    else {
        temp$1 = none_($c, [new SimpleStructTag(ValidatedPublicKey$1)]);
    }
    return temp$1;
}
function public_key_bytes_to_authentication_key_$1(pk_bytes, $c) {
    push_back_(pk_bytes, $.copy(SIGNATURE_SCHEME_ID$1), $c, [AtomicTypeTag.U8]);
    return sha3_256_($.copy(pk_bytes), $c);
}
function public_key_into_unvalidated_$1(pk, $c) {
    return new UnvalidatedPublicKey$1({ bytes: $.copy(pk.bytes) }, new SimpleStructTag(UnvalidatedPublicKey$1));
}
function public_key_to_unvalidated_$1(pk, $c) {
    return new UnvalidatedPublicKey$1({ bytes: $.copy(pk.bytes) }, new SimpleStructTag(UnvalidatedPublicKey$1));
}
function public_key_validate_$1(pk, $c) {
    return new_validated_public_key_from_bytes_$1($.copy(pk.bytes), $c);
}
function public_key_validate_internal_$1(bytes, $c) {
    return $.aptos_std_ed25519_public_key_validate_internal(bytes, $c);
}
function signature_to_bytes_$2(sig, $c) {
    return $.copy(sig.bytes);
}
function signature_verify_strict_$1(signature, public_key, message, $c) {
    return signature_verify_strict_internal_$1($.copy(signature.bytes), $.copy(public_key.bytes), $.copy(message), $c);
}
function signature_verify_strict_internal_$1(signature, public_key, message, $c) {
    return $.aptos_std_ed25519_signature_verify_strict_internal(signature, public_key, message, $c);
}
function signature_verify_strict_t_$1(signature, public_key, data, $c, $p /* <T>*/) {
    let encoded;
    encoded = new SignedMessage({ type_info: type_of_($c, [$p[0]]), inner: data }, new SimpleStructTag(SignedMessage, [$p[0]]));
    return signature_verify_strict_internal_$1($.copy(signature.bytes), $.copy(public_key.bytes), to_bytes_(encoded, $c, [new SimpleStructTag(SignedMessage, [$p[0]])]), $c);
}
function unvalidated_public_key_to_authentication_key_$1(pk, $c) {
    return public_key_bytes_to_authentication_key_$1($.copy(pk.bytes), $c);
}
function unvalidated_public_key_to_bytes_$1(pk, $c) {
    return $.copy(pk.bytes);
}
function validated_public_key_to_authentication_key_$1(pk, $c) {
    return public_key_bytes_to_authentication_key_$1($.copy(pk.bytes), $c);
}
function validated_public_key_to_bytes_$1(pk, $c) {
    return $.copy(pk.bytes);
}
function loadParsers$1C(repo) {
    repo.addParser('0x1::ed25519::Signature', Signature$2.SignatureParser);
    repo.addParser('0x1::ed25519::SignedMessage', SignedMessage.SignedMessageParser);
    repo.addParser('0x1::ed25519::UnvalidatedPublicKey', UnvalidatedPublicKey$1.UnvalidatedPublicKeyParser);
    repo.addParser('0x1::ed25519::ValidatedPublicKey', ValidatedPublicKey$1.ValidatedPublicKeyParser);
}
class App$1D {
    constructor(client, repo, cache) {
        this.client = client;
        this.repo = repo;
        this.cache = cache;
    }
    get moduleAddress() {
        {
            return moduleAddress$1p;
        }
    }
    get moduleName() {
        {
            return moduleName$1p;
        }
    }
    get Signature() {
        return Signature$2;
    }
    get SignedMessage() {
        return SignedMessage;
    }
    get UnvalidatedPublicKey() {
        return UnvalidatedPublicKey$1;
    }
    get ValidatedPublicKey() {
        return ValidatedPublicKey$1;
    }
}

var Ed25519 = /*#__PURE__*/Object.freeze({
    __proto__: null,
    packageName: packageName$1p,
    moduleAddress: moduleAddress$1p,
    moduleName: moduleName$1p,
    E_WRONG_PUBKEY_SIZE: E_WRONG_PUBKEY_SIZE$1,
    E_WRONG_SIGNATURE_SIZE: E_WRONG_SIGNATURE_SIZE$1,
    PUBLIC_KEY_NUM_BYTES: PUBLIC_KEY_NUM_BYTES$1,
    SIGNATURE_NUM_BYTES: SIGNATURE_NUM_BYTES$1,
    SIGNATURE_SCHEME_ID: SIGNATURE_SCHEME_ID$1,
    Signature: Signature$2,
    SignedMessage: SignedMessage,
    UnvalidatedPublicKey: UnvalidatedPublicKey$1,
    ValidatedPublicKey: ValidatedPublicKey$1,
    new_signature_from_bytes_: new_signature_from_bytes_$1,
    new_signed_message_: new_signed_message_,
    new_unvalidated_public_key_from_bytes_: new_unvalidated_public_key_from_bytes_$1,
    new_validated_public_key_from_bytes_: new_validated_public_key_from_bytes_$1,
    public_key_bytes_to_authentication_key_: public_key_bytes_to_authentication_key_$1,
    public_key_into_unvalidated_: public_key_into_unvalidated_$1,
    public_key_to_unvalidated_: public_key_to_unvalidated_$1,
    public_key_validate_: public_key_validate_$1,
    public_key_validate_internal_: public_key_validate_internal_$1,
    signature_to_bytes_: signature_to_bytes_$2,
    signature_verify_strict_: signature_verify_strict_$1,
    signature_verify_strict_internal_: signature_verify_strict_internal_$1,
    signature_verify_strict_t_: signature_verify_strict_t_$1,
    unvalidated_public_key_to_authentication_key_: unvalidated_public_key_to_authentication_key_$1,
    unvalidated_public_key_to_bytes_: unvalidated_public_key_to_bytes_$1,
    validated_public_key_to_authentication_key_: validated_public_key_to_authentication_key_$1,
    validated_public_key_to_bytes_: validated_public_key_to_bytes_$1,
    loadParsers: loadParsers$1C,
    App: App$1D
});

const packageName$1o = 'AptosFramework';
const moduleAddress$1o = new HexString('0x1');
const moduleName$1o = 'event';
class EventHandle {
    constructor(proto, typeTag) {
        this.typeTag = typeTag;
        this.__app = null;
        this.counter = proto['counter'];
        this.guid = proto['guid'];
    }
    static EventHandleParser(data, typeTag, repo) {
        const proto = $.parseStructProto(data, typeTag, repo, EventHandle);
        return new EventHandle(proto, typeTag);
    }
    static makeTag($p) {
        return new StructTag(moduleAddress$1o, moduleName$1o, 'EventHandle', $p);
    }
    loadFullState(app) {
        return __awaiter(this, void 0, void 0, function* () {
            yield this.guid.loadFullState(app);
            this.__app = app;
        });
    }
}
EventHandle.moduleAddress = moduleAddress$1o;
EventHandle.moduleName = moduleName$1o;
EventHandle.structName = 'EventHandle';
EventHandle.typeParameters = [{ name: 'T', isPhantom: true }];
EventHandle.fields = [
    { name: 'counter', typeTag: AtomicTypeTag.U64 },
    { name: 'guid', typeTag: new StructTag(new HexString('0x1'), 'guid', 'GUID', []) }
];
function counter_(handle_ref, $c, $p /* <T>*/) {
    return $.copy(handle_ref.counter);
}
function destroy_handle_(handle, $c, $p /* <T>*/) {
    return;
}
function emit_event_(handle_ref, msg, $c, $p /* <T>*/) {
    write_to_event_store_(to_bytes_(handle_ref.guid, $c, [new StructTag(new HexString('0x1'), 'guid', 'GUID', [])]), $.copy(handle_ref.counter), msg, $c, [$p[0]]);
    handle_ref.counter = $.copy(handle_ref.counter).add(u64('1'));
    return;
}
function guid_(handle_ref, $c, $p /* <T>*/) {
    return handle_ref.guid;
}
function new_event_handle_$1(guid, $c, $p /* <T>*/) {
    return new EventHandle({ counter: u64('0'), guid: guid }, new SimpleStructTag(EventHandle, [$p[0]]));
}
function write_to_event_store_(guid, count, msg, $c, $p /* <T>*/) {
    return $.aptos_framework_event_write_to_event_store(guid, count, msg, $c, [$p[0]]);
}
function loadParsers$1B(repo) {
    repo.addParser('0x1::event::EventHandle', EventHandle.EventHandleParser);
}
class App$1C {
    constructor(client, repo, cache) {
        this.client = client;
        this.repo = repo;
        this.cache = cache;
    }
    get moduleAddress() {
        {
            return moduleAddress$1o;
        }
    }
    get moduleName() {
        {
            return moduleName$1o;
        }
    }
    get EventHandle() {
        return EventHandle;
    }
}

var Event = /*#__PURE__*/Object.freeze({
    __proto__: null,
    packageName: packageName$1o,
    moduleAddress: moduleAddress$1o,
    moduleName: moduleName$1o,
    EventHandle: EventHandle,
    counter_: counter_,
    destroy_handle_: destroy_handle_,
    emit_event_: emit_event_,
    guid_: guid_,
    new_event_handle_: new_event_handle_$1,
    write_to_event_store_: write_to_event_store_,
    loadParsers: loadParsers$1B,
    App: App$1C
});

const packageName$1n = 'MoveStdlib';
const moduleAddress$1n = new HexString('0x1');
const moduleName$1n = 'string';
const EINVALID_INDEX = u64('2');
const EINVALID_UTF8$1 = u64('1');
class String {
    constructor(proto, typeTag) {
        this.typeTag = typeTag;
        this.__app = null;
        this.bytes = proto['bytes'];
    }
    static StringParser(data, typeTag, repo) {
        const proto = $.parseStructProto(data, typeTag, repo, String);
        return new String(proto, typeTag);
    }
    static getTag() {
        return new StructTag(moduleAddress$1n, moduleName$1n, 'String', []);
    }
    str() {
        return $.u8str(this.bytes);
    }
    loadFullState(app) {
        return __awaiter(this, void 0, void 0, function* () {
            this.__app = app;
        });
    }
}
String.moduleAddress = moduleAddress$1n;
String.moduleName = moduleName$1n;
String.structName = 'String';
String.typeParameters = [];
String.fields = [{ name: 'bytes', typeTag: new VectorTag(AtomicTypeTag.U8) }];
function append_$2(s, r, $c) {
    return append_$3(s.bytes, $.copy(r.bytes), $c, [AtomicTypeTag.U8]);
}
function append_utf8_(s, bytes, $c) {
    return append_$2(s, utf8_($.copy(bytes), $c), $c);
}
function bytes_(s, $c) {
    return s.bytes;
}
function index_of_(s, r, $c) {
    return internal_index_of_(s.bytes, r.bytes, $c);
}
function insert_$1(s, at, o, $c) {
    let temp$1, temp$2, temp$3, temp$4, temp$5, temp$6, temp$7, bytes, end, front, l;
    bytes = s.bytes;
    if ($.copy(at).le(length_$6(bytes, $c, [AtomicTypeTag.U8]))) {
        temp$1 = internal_is_char_boundary_(bytes, $.copy(at), $c);
    }
    else {
        temp$1 = false;
    }
    if (!temp$1) {
        throw $.abortCode($.copy(EINVALID_INDEX));
    }
    l = length_$5(s, $c);
    [temp$2, temp$3, temp$4] = [s, u64('0'), $.copy(at)];
    front = sub_string_(temp$2, temp$3, temp$4, $c);
    [temp$5, temp$6, temp$7] = [s, $.copy(at), $.copy(l)];
    end = sub_string_(temp$5, temp$6, temp$7, $c);
    append_$2(front, $.copy(o), $c);
    append_$2(front, $.copy(end), $c);
    $.set(s, $.copy(front));
    return;
}
function internal_check_utf8_(v, $c) {
    return $.std_string_internal_check_utf8(v, $c);
}
function internal_index_of_(v, r, $c) {
    return $.std_string_internal_index_of(v, r, $c);
}
function internal_is_char_boundary_(v, i, $c) {
    return $.std_string_internal_is_char_boundary(v, i, $c);
}
function internal_sub_string_(v, i, j, $c) {
    return $.std_string_internal_sub_string(v, i, j, $c);
}
function is_empty_$1(s, $c) {
    return is_empty_$2(s.bytes, $c, [AtomicTypeTag.U8]);
}
function length_$5(s, $c) {
    return length_$6(s.bytes, $c, [AtomicTypeTag.U8]);
}
function sub_string_(s, i, j, $c) {
    let temp$1, temp$2, temp$3, bytes, l;
    bytes = s.bytes;
    l = length_$6(bytes, $c, [AtomicTypeTag.U8]);
    if ($.copy(j).le($.copy(l))) {
        temp$1 = $.copy(i).le($.copy(j));
    }
    else {
        temp$1 = false;
    }
    if (temp$1) {
        temp$2 = internal_is_char_boundary_(bytes, $.copy(i), $c);
    }
    else {
        temp$2 = false;
    }
    if (temp$2) {
        temp$3 = internal_is_char_boundary_(bytes, $.copy(j), $c);
    }
    else {
        temp$3 = false;
    }
    if (!temp$3) {
        throw $.abortCode($.copy(EINVALID_INDEX));
    }
    return new String({ bytes: internal_sub_string_(bytes, $.copy(i), $.copy(j), $c) }, new SimpleStructTag(String));
}
function try_utf8_(bytes, $c) {
    let temp$1;
    if (internal_check_utf8_(bytes, $c)) {
        temp$1 = some_(new String({ bytes: $.copy(bytes) }, new SimpleStructTag(String)), $c, [
            new SimpleStructTag(String)
        ]);
    }
    else {
        temp$1 = none_($c, [new SimpleStructTag(String)]);
    }
    return temp$1;
}
function utf8_(bytes, $c) {
    if (!internal_check_utf8_(bytes, $c)) {
        throw $.abortCode($.copy(EINVALID_UTF8$1));
    }
    return new String({ bytes: $.copy(bytes) }, new SimpleStructTag(String));
}
function loadParsers$1A(repo) {
    repo.addParser('0x1::string::String', String.StringParser);
}
class App$1B {
    constructor(client, repo, cache) {
        this.client = client;
        this.repo = repo;
        this.cache = cache;
    }
    get moduleAddress() {
        {
            return moduleAddress$1n;
        }
    }
    get moduleName() {
        {
            return moduleName$1n;
        }
    }
    get String() {
        return String;
    }
}

var String$1 = /*#__PURE__*/Object.freeze({
    __proto__: null,
    packageName: packageName$1n,
    moduleAddress: moduleAddress$1n,
    moduleName: moduleName$1n,
    EINVALID_INDEX: EINVALID_INDEX,
    EINVALID_UTF8: EINVALID_UTF8$1,
    String: String,
    append_: append_$2,
    append_utf8_: append_utf8_,
    bytes_: bytes_,
    index_of_: index_of_,
    insert_: insert_$1,
    internal_check_utf8_: internal_check_utf8_,
    internal_index_of_: internal_index_of_,
    internal_is_char_boundary_: internal_is_char_boundary_,
    internal_sub_string_: internal_sub_string_,
    is_empty_: is_empty_$1,
    length_: length_$5,
    sub_string_: sub_string_,
    try_utf8_: try_utf8_,
    utf8_: utf8_,
    loadParsers: loadParsers$1A,
    App: App$1B
});

const packageName$1m = 'AptosStdlib';
const moduleAddress$1m = new HexString('0x1');
const moduleName$1m = 'from_bcs';
const EINVALID_UTF8 = u64('1');
function from_bytes_$1(bytes, $c, $p /* <T>*/) {
    return $.aptos_std_from_bcs_from_bytes(bytes, $c, [$p[0]]);
}
function to_address_(v, $c) {
    return from_bytes_$1($.copy(v), $c, [AtomicTypeTag.Address]);
}
function to_bool_(v, $c) {
    return from_bytes_$1($.copy(v), $c, [AtomicTypeTag.Bool]);
}
function to_string_(v, $c) {
    let s;
    s = from_bytes_$1($.copy(v), $c, [new StructTag(new HexString('0x1'), 'string', 'String', [])]);
    if (!internal_check_utf8_(bytes_(s), $c)) {
        throw $.abortCode($.copy(EINVALID_UTF8));
    }
    return $.copy(s);
}
function to_u128_$2(v, $c) {
    return from_bytes_$1($.copy(v), $c, [AtomicTypeTag.U128]);
}
function to_u64_(v, $c) {
    return from_bytes_$1($.copy(v), $c, [AtomicTypeTag.U64]);
}
function to_u8_(v, $c) {
    return from_bytes_$1($.copy(v), $c, [AtomicTypeTag.U8]);
}
function loadParsers$1z(repo) { }
class App$1A {
    constructor(client, repo, cache) {
        this.client = client;
        this.repo = repo;
        this.cache = cache;
    }
    get moduleAddress() {
        {
            return moduleAddress$1m;
        }
    }
    get moduleName() {
        {
            return moduleName$1m;
        }
    }
}

var From_bcs = /*#__PURE__*/Object.freeze({
    __proto__: null,
    packageName: packageName$1m,
    moduleAddress: moduleAddress$1m,
    moduleName: moduleName$1m,
    EINVALID_UTF8: EINVALID_UTF8,
    from_bytes_: from_bytes_$1,
    to_address_: to_address_,
    to_bool_: to_bool_,
    to_string_: to_string_,
    to_u128_: to_u128_$2,
    to_u64_: to_u64_,
    to_u8_: to_u8_,
    loadParsers: loadParsers$1z,
    App: App$1A
});

const packageName$1l = 'AptosFramework';
const moduleAddress$1l = new HexString('0x1');
const moduleName$1l = 'guid';
const EGUID_GENERATOR_NOT_PUBLISHED = u64('0');
class GUID {
    constructor(proto, typeTag) {
        this.typeTag = typeTag;
        this.__app = null;
        this.id = proto['id'];
    }
    static GUIDParser(data, typeTag, repo) {
        const proto = $.parseStructProto(data, typeTag, repo, GUID);
        return new GUID(proto, typeTag);
    }
    static getTag() {
        return new StructTag(moduleAddress$1l, moduleName$1l, 'GUID', []);
    }
    loadFullState(app) {
        return __awaiter(this, void 0, void 0, function* () {
            yield this.id.loadFullState(app);
            this.__app = app;
        });
    }
}
GUID.moduleAddress = moduleAddress$1l;
GUID.moduleName = moduleName$1l;
GUID.structName = 'GUID';
GUID.typeParameters = [];
GUID.fields = [{ name: 'id', typeTag: new StructTag(new HexString('0x1'), 'guid', 'ID', []) }];
class ID {
    constructor(proto, typeTag) {
        this.typeTag = typeTag;
        this.__app = null;
        this.creation_num = proto['creation_num'];
        this.addr = proto['addr'];
    }
    static IDParser(data, typeTag, repo) {
        const proto = $.parseStructProto(data, typeTag, repo, ID);
        return new ID(proto, typeTag);
    }
    static getTag() {
        return new StructTag(moduleAddress$1l, moduleName$1l, 'ID', []);
    }
    loadFullState(app) {
        return __awaiter(this, void 0, void 0, function* () {
            this.__app = app;
        });
    }
}
ID.moduleAddress = moduleAddress$1l;
ID.moduleName = moduleName$1l;
ID.structName = 'ID';
ID.typeParameters = [];
ID.fields = [
    { name: 'creation_num', typeTag: AtomicTypeTag.U64 },
    { name: 'addr', typeTag: AtomicTypeTag.Address }
];
function create_$3(addr, creation_num_ref, $c) {
    let creation_num;
    creation_num = $.copy(creation_num_ref);
    $.set(creation_num_ref, $.copy(creation_num).add(u64('1')));
    return new GUID({ id: new ID({ creation_num: $.copy(creation_num), addr: $.copy(addr) }, new SimpleStructTag(ID)) }, new SimpleStructTag(GUID));
}
function create_id_(addr, creation_num, $c) {
    return new ID({ creation_num: $.copy(creation_num), addr: $.copy(addr) }, new SimpleStructTag(ID));
}
function creation_num_(guid, $c) {
    return $.copy(guid.id.creation_num);
}
function creator_address_(guid, $c) {
    return $.copy(guid.id.addr);
}
function eq_id_(guid, id, $c) {
    return $.deep_eq(guid.id, id);
}
function id_(guid, $c) {
    return $.copy(guid.id);
}
function id_creation_num_(id, $c) {
    return $.copy(id.creation_num);
}
function id_creator_address_(id, $c) {
    return $.copy(id.addr);
}
function loadParsers$1y(repo) {
    repo.addParser('0x1::guid::GUID', GUID.GUIDParser);
    repo.addParser('0x1::guid::ID', ID.IDParser);
}
class App$1z {
    constructor(client, repo, cache) {
        this.client = client;
        this.repo = repo;
        this.cache = cache;
    }
    get moduleAddress() {
        {
            return moduleAddress$1l;
        }
    }
    get moduleName() {
        {
            return moduleName$1l;
        }
    }
    get GUID() {
        return GUID;
    }
    get ID() {
        return ID;
    }
}

var Guid = /*#__PURE__*/Object.freeze({
    __proto__: null,
    packageName: packageName$1l,
    moduleAddress: moduleAddress$1l,
    moduleName: moduleName$1l,
    EGUID_GENERATOR_NOT_PUBLISHED: EGUID_GENERATOR_NOT_PUBLISHED,
    GUID: GUID,
    ID: ID,
    create_: create_$3,
    create_id_: create_id_,
    creation_num_: creation_num_,
    creator_address_: creator_address_,
    eq_id_: eq_id_,
    id_: id_,
    id_creation_num_: id_creation_num_,
    id_creator_address_: id_creator_address_,
    loadParsers: loadParsers$1y,
    App: App$1z
});

const packageName$1k = 'AptosStdlib';
const moduleAddress$1k = new HexString('0x1');
const moduleName$1k = 'multi_ed25519';
const BITMAP_NUM_OF_BYTES = u64('4');
const E_WRONG_PUBKEY_SIZE = u64('1');
const E_WRONG_SIGNATURE_SIZE = u64('2');
const INDIVIDUAL_PUBLIC_KEY_NUM_BYTES = u64('32');
const INDIVIDUAL_SIGNATURE_NUM_BYTES = u64('64');
const MAX_NUMBER_OF_PUBLIC_KEYS = u64('32');
const SIGNATURE_SCHEME_ID = u8('1');
const THRESHOLD_SIZE_BYTES = u64('1');
class Signature$1 {
    constructor(proto, typeTag) {
        this.typeTag = typeTag;
        this.__app = null;
        this.bytes = proto['bytes'];
    }
    static SignatureParser(data, typeTag, repo) {
        const proto = $.parseStructProto(data, typeTag, repo, Signature$1);
        return new Signature$1(proto, typeTag);
    }
    static getTag() {
        return new StructTag(moduleAddress$1k, moduleName$1k, 'Signature', []);
    }
    loadFullState(app) {
        return __awaiter(this, void 0, void 0, function* () {
            this.__app = app;
        });
    }
}
Signature$1.moduleAddress = moduleAddress$1k;
Signature$1.moduleName = moduleName$1k;
Signature$1.structName = 'Signature';
Signature$1.typeParameters = [];
Signature$1.fields = [{ name: 'bytes', typeTag: new VectorTag(AtomicTypeTag.U8) }];
class UnvalidatedPublicKey {
    constructor(proto, typeTag) {
        this.typeTag = typeTag;
        this.__app = null;
        this.bytes = proto['bytes'];
    }
    static UnvalidatedPublicKeyParser(data, typeTag, repo) {
        const proto = $.parseStructProto(data, typeTag, repo, UnvalidatedPublicKey);
        return new UnvalidatedPublicKey(proto, typeTag);
    }
    static getTag() {
        return new StructTag(moduleAddress$1k, moduleName$1k, 'UnvalidatedPublicKey', []);
    }
    loadFullState(app) {
        return __awaiter(this, void 0, void 0, function* () {
            this.__app = app;
        });
    }
}
UnvalidatedPublicKey.moduleAddress = moduleAddress$1k;
UnvalidatedPublicKey.moduleName = moduleName$1k;
UnvalidatedPublicKey.structName = 'UnvalidatedPublicKey';
UnvalidatedPublicKey.typeParameters = [];
UnvalidatedPublicKey.fields = [{ name: 'bytes', typeTag: new VectorTag(AtomicTypeTag.U8) }];
class ValidatedPublicKey {
    constructor(proto, typeTag) {
        this.typeTag = typeTag;
        this.__app = null;
        this.bytes = proto['bytes'];
    }
    static ValidatedPublicKeyParser(data, typeTag, repo) {
        const proto = $.parseStructProto(data, typeTag, repo, ValidatedPublicKey);
        return new ValidatedPublicKey(proto, typeTag);
    }
    static getTag() {
        return new StructTag(moduleAddress$1k, moduleName$1k, 'ValidatedPublicKey', []);
    }
    loadFullState(app) {
        return __awaiter(this, void 0, void 0, function* () {
            this.__app = app;
        });
    }
}
ValidatedPublicKey.moduleAddress = moduleAddress$1k;
ValidatedPublicKey.moduleName = moduleName$1k;
ValidatedPublicKey.structName = 'ValidatedPublicKey';
ValidatedPublicKey.typeParameters = [];
ValidatedPublicKey.fields = [{ name: 'bytes', typeTag: new VectorTag(AtomicTypeTag.U8) }];
function new_signature_from_bytes_(bytes, $c) {
    if (!length_$6(bytes, $c, [AtomicTypeTag.U8])
        .mod($.copy(INDIVIDUAL_SIGNATURE_NUM_BYTES))
        .eq($.copy(BITMAP_NUM_OF_BYTES))) {
        throw $.abortCode(invalid_argument_($.copy(E_WRONG_SIGNATURE_SIZE)));
    }
    return new Signature$1({ bytes: $.copy(bytes) }, new SimpleStructTag(Signature$1));
}
function new_unvalidated_public_key_from_bytes_(bytes, $c) {
    if (!length_$6(bytes, $c, [AtomicTypeTag.U8])
        .div($.copy(INDIVIDUAL_PUBLIC_KEY_NUM_BYTES))
        .le($.copy(MAX_NUMBER_OF_PUBLIC_KEYS))) {
        throw $.abortCode(invalid_argument_($.copy(E_WRONG_PUBKEY_SIZE)));
    }
    if (!length_$6(bytes, $c, [AtomicTypeTag.U8])
        .mod($.copy(INDIVIDUAL_PUBLIC_KEY_NUM_BYTES))
        .eq($.copy(THRESHOLD_SIZE_BYTES))) {
        throw $.abortCode(invalid_argument_($.copy(E_WRONG_PUBKEY_SIZE)));
    }
    return new UnvalidatedPublicKey({ bytes: $.copy(bytes) }, new SimpleStructTag(UnvalidatedPublicKey));
}
function new_validated_public_key_from_bytes_(bytes, $c) {
    let temp$1, temp$2;
    if (length_$6(bytes, $c, [AtomicTypeTag.U8])
        .mod($.copy(INDIVIDUAL_PUBLIC_KEY_NUM_BYTES))
        .eq($.copy(THRESHOLD_SIZE_BYTES))) {
        temp$1 = public_key_validate_internal_($.copy(bytes), $c);
    }
    else {
        temp$1 = false;
    }
    if (temp$1) {
        temp$2 = some_(new ValidatedPublicKey({ bytes: $.copy(bytes) }, new SimpleStructTag(ValidatedPublicKey)), $c, [new SimpleStructTag(ValidatedPublicKey)]);
    }
    else {
        temp$2 = none_($c, [new SimpleStructTag(ValidatedPublicKey)]);
    }
    return temp$2;
}
function public_key_bytes_to_authentication_key_(pk_bytes, $c) {
    push_back_(pk_bytes, $.copy(SIGNATURE_SCHEME_ID), $c, [AtomicTypeTag.U8]);
    return sha3_256_($.copy(pk_bytes), $c);
}
function public_key_into_unvalidated_(pk, $c) {
    return new UnvalidatedPublicKey({ bytes: $.copy(pk.bytes) }, new SimpleStructTag(UnvalidatedPublicKey));
}
function public_key_to_unvalidated_(pk, $c) {
    return new UnvalidatedPublicKey({ bytes: $.copy(pk.bytes) }, new SimpleStructTag(UnvalidatedPublicKey));
}
function public_key_validate_(pk, $c) {
    return new_validated_public_key_from_bytes_($.copy(pk.bytes), $c);
}
function public_key_validate_internal_(bytes, $c) {
    return $.aptos_std_multi_ed25519_public_key_validate_internal(bytes, $c);
}
function signature_to_bytes_$1(sig, $c) {
    return $.copy(sig.bytes);
}
function signature_verify_strict_(multisignature, public_key, message, $c) {
    return signature_verify_strict_internal_($.copy(multisignature.bytes), $.copy(public_key.bytes), $.copy(message), $c);
}
function signature_verify_strict_internal_(multisignature, public_key, message, $c) {
    return $.aptos_std_multi_ed25519_signature_verify_strict_internal(multisignature, public_key, message, $c);
}
function signature_verify_strict_t_(multisignature, public_key, data, $c, $p /* <T>*/) {
    let encoded;
    encoded = new_signed_message_(data, $c, [$p[0]]);
    return signature_verify_strict_internal_($.copy(multisignature.bytes), $.copy(public_key.bytes), to_bytes_(encoded, $c, [new StructTag(new HexString('0x1'), 'ed25519', 'SignedMessage', [$p[0]])]), $c);
}
function unvalidated_public_key_to_authentication_key_(pk, $c) {
    return public_key_bytes_to_authentication_key_($.copy(pk.bytes), $c);
}
function unvalidated_public_key_to_bytes_(pk, $c) {
    return $.copy(pk.bytes);
}
function validated_public_key_to_authentication_key_(pk, $c) {
    return public_key_bytes_to_authentication_key_($.copy(pk.bytes), $c);
}
function validated_public_key_to_bytes_(pk, $c) {
    return $.copy(pk.bytes);
}
function loadParsers$1x(repo) {
    repo.addParser('0x1::multi_ed25519::Signature', Signature$1.SignatureParser);
    repo.addParser('0x1::multi_ed25519::UnvalidatedPublicKey', UnvalidatedPublicKey.UnvalidatedPublicKeyParser);
    repo.addParser('0x1::multi_ed25519::ValidatedPublicKey', ValidatedPublicKey.ValidatedPublicKeyParser);
}
class App$1y {
    constructor(client, repo, cache) {
        this.client = client;
        this.repo = repo;
        this.cache = cache;
    }
    get moduleAddress() {
        {
            return moduleAddress$1k;
        }
    }
    get moduleName() {
        {
            return moduleName$1k;
        }
    }
    get Signature() {
        return Signature$1;
    }
    get UnvalidatedPublicKey() {
        return UnvalidatedPublicKey;
    }
    get ValidatedPublicKey() {
        return ValidatedPublicKey;
    }
}

var Multi_ed25519 = /*#__PURE__*/Object.freeze({
    __proto__: null,
    packageName: packageName$1k,
    moduleAddress: moduleAddress$1k,
    moduleName: moduleName$1k,
    BITMAP_NUM_OF_BYTES: BITMAP_NUM_OF_BYTES,
    E_WRONG_PUBKEY_SIZE: E_WRONG_PUBKEY_SIZE,
    E_WRONG_SIGNATURE_SIZE: E_WRONG_SIGNATURE_SIZE,
    INDIVIDUAL_PUBLIC_KEY_NUM_BYTES: INDIVIDUAL_PUBLIC_KEY_NUM_BYTES,
    INDIVIDUAL_SIGNATURE_NUM_BYTES: INDIVIDUAL_SIGNATURE_NUM_BYTES,
    MAX_NUMBER_OF_PUBLIC_KEYS: MAX_NUMBER_OF_PUBLIC_KEYS,
    SIGNATURE_SCHEME_ID: SIGNATURE_SCHEME_ID,
    THRESHOLD_SIZE_BYTES: THRESHOLD_SIZE_BYTES,
    Signature: Signature$1,
    UnvalidatedPublicKey: UnvalidatedPublicKey,
    ValidatedPublicKey: ValidatedPublicKey,
    new_signature_from_bytes_: new_signature_from_bytes_,
    new_unvalidated_public_key_from_bytes_: new_unvalidated_public_key_from_bytes_,
    new_validated_public_key_from_bytes_: new_validated_public_key_from_bytes_,
    public_key_bytes_to_authentication_key_: public_key_bytes_to_authentication_key_,
    public_key_into_unvalidated_: public_key_into_unvalidated_,
    public_key_to_unvalidated_: public_key_to_unvalidated_,
    public_key_validate_: public_key_validate_,
    public_key_validate_internal_: public_key_validate_internal_,
    signature_to_bytes_: signature_to_bytes_$1,
    signature_verify_strict_: signature_verify_strict_,
    signature_verify_strict_internal_: signature_verify_strict_internal_,
    signature_verify_strict_t_: signature_verify_strict_t_,
    unvalidated_public_key_to_authentication_key_: unvalidated_public_key_to_authentication_key_,
    unvalidated_public_key_to_bytes_: unvalidated_public_key_to_bytes_,
    validated_public_key_to_authentication_key_: validated_public_key_to_authentication_key_,
    validated_public_key_to_bytes_: validated_public_key_to_bytes_,
    loadParsers: loadParsers$1x,
    App: App$1y
});

const packageName$1j = 'MoveStdlib';
const moduleAddress$1j = new HexString('0x1');
const moduleName$1j = 'signer';
function address_of_(s, $c) {
    return $.copy(borrow_address_(s, $c));
}
function borrow_address_(s, $c) {
    return $.std_signer_borrow_address(s, $c);
}
function loadParsers$1w(repo) { }
class App$1x {
    constructor(client, repo, cache) {
        this.client = client;
        this.repo = repo;
        this.cache = cache;
    }
    get moduleAddress() {
        {
            return moduleAddress$1j;
        }
    }
    get moduleName() {
        {
            return moduleName$1j;
        }
    }
}

var Signer = /*#__PURE__*/Object.freeze({
    __proto__: null,
    packageName: packageName$1j,
    moduleAddress: moduleAddress$1j,
    moduleName: moduleName$1j,
    address_of_: address_of_,
    borrow_address_: borrow_address_,
    loadParsers: loadParsers$1w,
    App: App$1x
});

const packageName$1i = 'AptosFramework';
const moduleAddress$1i = new HexString('0x1');
const moduleName$1i = 'system_addresses';
const ENOT_APTOS_FRAMEWORK_ADDRESS = u64('3');
const ENOT_CORE_RESOURCE_ADDRESS = u64('1');
const ENOT_FRAMEWORK_RESERVED_ADDRESS = u64('4');
const EVM = u64('2');
function assert_aptos_framework_(account, $c) {
    if (!is_aptos_framework_address_(address_of_(account, $c))) {
        throw $.abortCode(permission_denied_($.copy(ENOT_APTOS_FRAMEWORK_ADDRESS)));
    }
    return;
}
function assert_core_resource_(account, $c) {
    return assert_core_resource_address_(address_of_(account, $c));
}
function assert_core_resource_address_(addr, $c) {
    if (!is_core_resource_address_($.copy(addr))) {
        throw $.abortCode(permission_denied_($.copy(ENOT_CORE_RESOURCE_ADDRESS)));
    }
    return;
}
function assert_framework_reserved_address_(account, $c) {
    if (!is_framework_reserved_address_(address_of_(account, $c))) {
        throw $.abortCode(permission_denied_($.copy(ENOT_FRAMEWORK_RESERVED_ADDRESS)));
    }
    return;
}
function assert_vm_(account, $c) {
    if (!is_vm_(account, $c)) {
        throw $.abortCode(permission_denied_($.copy(EVM)));
    }
    return;
}
function is_aptos_framework_address_(addr, $c) {
    return $.copy(addr).hex() === new HexString('0x1').hex();
}
function is_core_resource_address_(addr, $c) {
    return $.copy(addr).hex() === new HexString('0xa550c18').hex();
}
function is_framework_reserved_address_(addr, $c) {
    let temp$1, temp$2, temp$3, temp$4, temp$5, temp$6, temp$7, temp$8, temp$9;
    if (is_aptos_framework_address_($.copy(addr))) {
        temp$1 = true;
    }
    else {
        temp$1 = $.copy(addr).hex() === new HexString('0x2').hex();
    }
    if (temp$1) {
        temp$2 = true;
    }
    else {
        temp$2 = $.copy(addr).hex() === new HexString('0x3').hex();
    }
    if (temp$2) {
        temp$3 = true;
    }
    else {
        temp$3 = $.copy(addr).hex() === new HexString('0x4').hex();
    }
    if (temp$3) {
        temp$4 = true;
    }
    else {
        temp$4 = $.copy(addr).hex() === new HexString('0x5').hex();
    }
    if (temp$4) {
        temp$5 = true;
    }
    else {
        temp$5 = $.copy(addr).hex() === new HexString('0x6').hex();
    }
    if (temp$5) {
        temp$6 = true;
    }
    else {
        temp$6 = $.copy(addr).hex() === new HexString('0x7').hex();
    }
    if (temp$6) {
        temp$7 = true;
    }
    else {
        temp$7 = $.copy(addr).hex() === new HexString('0x8').hex();
    }
    if (temp$7) {
        temp$8 = true;
    }
    else {
        temp$8 = $.copy(addr).hex() === new HexString('0x9').hex();
    }
    if (temp$8) {
        temp$9 = true;
    }
    else {
        temp$9 = $.copy(addr).hex() === new HexString('0xa').hex();
    }
    return temp$9;
}
function is_reserved_address_(addr, $c) {
    let temp$1;
    if (is_aptos_framework_address_($.copy(addr))) {
        temp$1 = true;
    }
    else {
        temp$1 = is_vm_address_($.copy(addr));
    }
    return temp$1;
}
function is_vm_(account, $c) {
    return is_vm_address_(address_of_(account, $c));
}
function is_vm_address_(addr, $c) {
    return $.copy(addr).hex() === new HexString('0x0').hex();
}
function loadParsers$1v(repo) { }
class App$1w {
    constructor(client, repo, cache) {
        this.client = client;
        this.repo = repo;
        this.cache = cache;
    }
    get moduleAddress() {
        {
            return moduleAddress$1i;
        }
    }
    get moduleName() {
        {
            return moduleName$1i;
        }
    }
}

var System_addresses = /*#__PURE__*/Object.freeze({
    __proto__: null,
    packageName: packageName$1i,
    moduleAddress: moduleAddress$1i,
    moduleName: moduleName$1i,
    ENOT_APTOS_FRAMEWORK_ADDRESS: ENOT_APTOS_FRAMEWORK_ADDRESS,
    ENOT_CORE_RESOURCE_ADDRESS: ENOT_CORE_RESOURCE_ADDRESS,
    ENOT_FRAMEWORK_RESERVED_ADDRESS: ENOT_FRAMEWORK_RESERVED_ADDRESS,
    EVM: EVM,
    assert_aptos_framework_: assert_aptos_framework_,
    assert_core_resource_: assert_core_resource_,
    assert_core_resource_address_: assert_core_resource_address_,
    assert_framework_reserved_address_: assert_framework_reserved_address_,
    assert_vm_: assert_vm_,
    is_aptos_framework_address_: is_aptos_framework_address_,
    is_core_resource_address_: is_core_resource_address_,
    is_framework_reserved_address_: is_framework_reserved_address_,
    is_reserved_address_: is_reserved_address_,
    is_vm_: is_vm_,
    is_vm_address_: is_vm_address_,
    loadParsers: loadParsers$1v,
    App: App$1w
});

const packageName$1h = 'AptosStdlib';
const moduleAddress$1h = new HexString('0x1');
const moduleName$1h = 'table';
class Box {
    constructor(proto, typeTag) {
        this.typeTag = typeTag;
        this.__app = null;
        this.val = proto['val'];
    }
    static BoxParser(data, typeTag, repo) {
        const proto = $.parseStructProto(data, typeTag, repo, Box);
        return new Box(proto, typeTag);
    }
    static load(repo, client, address, typeParams) {
        return __awaiter(this, void 0, void 0, function* () {
            const result = yield repo.loadResource(client, address, Box, typeParams);
            return result;
        });
    }
    static loadByApp(app, address, typeParams) {
        return __awaiter(this, void 0, void 0, function* () {
            const result = yield app.repo.loadResource(app.client, address, Box, typeParams);
            yield result.loadFullState(app);
            return result;
        });
    }
    static makeTag($p) {
        return new StructTag(moduleAddress$1h, moduleName$1h, 'Box', $p);
    }
    loadFullState(app) {
        return __awaiter(this, void 0, void 0, function* () {
            if (this.val.typeTag instanceof StructTag) {
                yield this.val.loadFullState(app);
            }
            this.__app = app;
        });
    }
}
Box.moduleAddress = moduleAddress$1h;
Box.moduleName = moduleName$1h;
Box.structName = 'Box';
Box.typeParameters = [{ name: 'V', isPhantom: false }];
Box.fields = [{ name: 'val', typeTag: new $.TypeParamIdx(0) }];
class Table {
    constructor(proto, typeTag) {
        this.typeTag = typeTag;
        this.__app = null;
        this.handle = proto['handle'];
    }
    static TableParser(data, typeTag, repo) {
        const proto = $.parseStructProto(data, typeTag, repo, Table);
        return new Table(proto, typeTag);
    }
    static makeTag($p) {
        return new StructTag(moduleAddress$1h, moduleName$1h, 'Table', $p);
    }
    toTypedTable() {
        return TypedTable.fromTable(this);
    }
    loadFullState(app) {
        return __awaiter(this, void 0, void 0, function* () {
            throw new Error('Cannot enumertate full state of Table');
        });
    }
}
Table.moduleAddress = moduleAddress$1h;
Table.moduleName = moduleName$1h;
Table.structName = 'Table';
Table.typeParameters = [
    { name: 'K', isPhantom: true },
    { name: 'V', isPhantom: true }
];
Table.fields = [{ name: 'handle', typeTag: AtomicTypeTag.Address }];
function add_$8(table, key, val, $c, $p /* <K, V>*/) {
    return add_box_(table, $.copy(key), new Box({ val: val }, new SimpleStructTag(Box, [$p[1]])), $c, [
        $p[0],
        $p[1],
        new SimpleStructTag(Box, [$p[1]])
    ]);
}
function add_box_(table, key, val, $c, $p /* <K, V, B>*/) {
    return $.aptos_std_table_add_box(table, key, val, $c, [$p[0], $p[1], $p[2]]);
}
function borrow_$5(table, key, $c, $p /* <K, V>*/) {
    return borrow_box_(table, $.copy(key), $c, [$p[0], $p[1], new SimpleStructTag(Box, [$p[1]])]).val;
}
function borrow_box_(table, key, $c, $p /* <K, V, B>*/) {
    return $.aptos_std_table_borrow_box(table, key, $c, [$p[0], $p[1], $p[2]]);
}
function borrow_box_mut_(table, key, $c, $p /* <K, V, B>*/) {
    return $.aptos_std_table_borrow_box_mut(table, key, $c, [$p[0], $p[1], $p[2]]);
}
function borrow_mut_$5(table, key, $c, $p /* <K, V>*/) {
    return borrow_box_mut_(table, $.copy(key), $c, [$p[0], $p[1], new SimpleStructTag(Box, [$p[1]])]).val;
}
function borrow_mut_with_default_$2(table, key, default__, $c, $p /* <K, V>*/) {
    let temp$1, temp$2;
    [temp$1, temp$2] = [table, $.copy(key)];
    if (!contains_$6(temp$1, temp$2, $c, [$p[0], $p[1]])) {
        add_$8(table, $.copy(key), default__, $c, [$p[0], $p[1]]);
    }
    return borrow_mut_$5(table, $.copy(key), $c, [$p[0], $p[1]]);
}
function contains_$6(table, key, $c, $p /* <K, V>*/) {
    return contains_box_(table, $.copy(key), $c, [$p[0], $p[1], new SimpleStructTag(Box, [$p[1]])]);
}
function contains_box_(table, key, $c, $p /* <K, V, B>*/) {
    return $.aptos_std_table_contains_box(table, key, $c, [$p[0], $p[1], $p[2]]);
}
function destroy_$2(table, $c, $p /* <K, V>*/) {
    destroy_empty_box_(table, $c, [$p[0], $p[1], new SimpleStructTag(Box, [$p[1]])]);
    return drop_unchecked_box_(table, $c, [$p[0], $p[1], new SimpleStructTag(Box, [$p[1]])]);
}
function destroy_empty_box_(table, $c, $p /* <K, V, B>*/) {
    return $.aptos_std_table_destroy_empty_box(table, $c, [$p[0], $p[1], $p[2]]);
}
function drop_unchecked_box_(table, $c, $p /* <K, V, B>*/) {
    return $.aptos_std_table_drop_unchecked_box(table, $c, [$p[0], $p[1], $p[2]]);
}
function new___$5($c, $p /* <K, V>*/) {
    return new Table({ handle: new_table_handle_($c, [$p[0], $p[1]]) }, new SimpleStructTag(Table, [$p[0], $p[1]]));
}
function new_table_handle_($c, $p /* <K, V>*/) {
    return $.aptos_std_table_new_table_handle($c, [$p[0], $p[1]]);
}
function remove_$4(table, key, $c, $p /* <K, V>*/) {
    let { val: val } = remove_box_(table, $.copy(key), $c, [$p[0], $p[1], new SimpleStructTag(Box, [$p[1]])]);
    return val;
}
function remove_box_(table, key, $c, $p /* <K, V, B>*/) {
    return $.aptos_std_table_remove_box(table, key, $c, [$p[0], $p[1], $p[2]]);
}
function upsert_$1(table, key, value, $c, $p /* <K, V>*/) {
    let temp$1, temp$2, ref;
    [temp$1, temp$2] = [table, $.copy(key)];
    if (!contains_$6(temp$1, temp$2, $c, [$p[0], $p[1]])) {
        add_$8(table, $.copy(key), value, $c, [$p[0], $p[1]]);
    }
    else {
        ref = borrow_mut_$5(table, $.copy(key), $c, [$p[0], $p[1]]);
        $.set(ref, value);
    }
    return;
}
function loadParsers$1u(repo) {
    repo.addParser('0x1::table::Box', Box.BoxParser);
    repo.addParser('0x1::table::Table', Table.TableParser);
}
class App$1v {
    constructor(client, repo, cache) {
        this.client = client;
        this.repo = repo;
        this.cache = cache;
    }
    get moduleAddress() {
        {
            return moduleAddress$1h;
        }
    }
    get moduleName() {
        {
            return moduleName$1h;
        }
    }
    get Box() {
        return Box;
    }
    loadBox(owner, $p /* <V> */, loadFull = true, fillCache = true) {
        return __awaiter(this, void 0, void 0, function* () {
            const val = yield Box.load(this.repo, this.client, owner, $p);
            if (loadFull) {
                yield val.loadFullState(this);
            }
            if (fillCache) {
                this.cache.set(val.typeTag, owner, val);
            }
            return val;
        });
    }
    get Table() {
        return Table;
    }
}
class TypedTable {
    constructor(table, keyTag, valueTag) {
        this.table = table;
        this.keyTag = keyTag;
        this.valueTag = valueTag;
    }
    static fromTable(table) {
        const tag = table.typeTag;
        if (!(tag instanceof StructTag)) {
            throw new Error();
        }
        if (tag.getParamlessName() !== '0x1::table::Table') {
            throw new Error();
        }
        if (tag.typeParams.length !== 2) {
            throw new Error();
        }
        const [keyTag, valueTag] = tag.typeParams;
        return new TypedTable(table, keyTag, valueTag);
    }
    loadEntryRaw(client, key) {
        return __awaiter(this, void 0, void 0, function* () {
            return yield client.getTableItem(this.table.handle.toString(), {
                key_type: $.getTypeTagFullname(this.keyTag),
                value_type: $.getTypeTagFullname(this.valueTag),
                key: $.moveValueToOpenApiObject(key, this.keyTag)
            });
        });
    }
    loadEntry(client, repo, key) {
        return __awaiter(this, void 0, void 0, function* () {
            const rawVal = yield this.loadEntryRaw(client, key);
            return repo.parse(rawVal, this.valueTag);
        });
    }
}

var Table$1 = /*#__PURE__*/Object.freeze({
    __proto__: null,
    packageName: packageName$1h,
    moduleAddress: moduleAddress$1h,
    moduleName: moduleName$1h,
    Box: Box,
    Table: Table,
    add_: add_$8,
    add_box_: add_box_,
    borrow_: borrow_$5,
    borrow_box_: borrow_box_,
    borrow_box_mut_: borrow_box_mut_,
    borrow_mut_: borrow_mut_$5,
    borrow_mut_with_default_: borrow_mut_with_default_$2,
    contains_: contains_$6,
    contains_box_: contains_box_,
    destroy_: destroy_$2,
    destroy_empty_box_: destroy_empty_box_,
    drop_unchecked_box_: drop_unchecked_box_,
    new___: new___$5,
    new_table_handle_: new_table_handle_,
    remove_: remove_$4,
    remove_box_: remove_box_,
    upsert_: upsert_$1,
    loadParsers: loadParsers$1u,
    App: App$1v,
    TypedTable: TypedTable
});

const packageName$1g = 'AptosFramework';
const moduleAddress$1g = new HexString('0x1');
const moduleName$1g = 'account';
const DERIVE_RESOURCE_ACCOUNT_SCHEME = u8('255');
const EACCOUNT_ALREADY_EXISTS = u64('1');
const EACCOUNT_ALREADY_USED = u64('16');
const EACCOUNT_DOES_NOT_EXIST$1 = u64('2');
const ECANNOT_RESERVED_ADDRESS = u64('5');
const ED25519_SCHEME = u8('0');
const EINVALID_ACCEPT_ROTATION_CAPABILITY = u64('10');
const EINVALID_ORIGINATING_ADDRESS = u64('13');
const EINVALID_PROOF_OF_KNOWLEDGE = u64('8');
const EINVALID_SCHEME = u64('12');
const EMALFORMED_AUTHENTICATION_KEY = u64('4');
const ENO_CAPABILITY = u64('9');
const ENO_SUCH_SIGNER_CAPABILITY = u64('14');
const ENO_VALID_FRAMEWORK_RESERVED_ADDRESS = u64('11');
const EOUT_OF_GAS$1 = u64('6');
const ERESOURCE_ACCCOUNT_EXISTS = u64('15');
const ESEQUENCE_NUMBER_TOO_BIG = u64('3');
const EWRONG_CURRENT_PUBLIC_KEY = u64('7');
const MAX_U64$5 = u128('18446744073709551615');
const MULTI_ED25519_SCHEME = u8('1');
const ZERO_AUTH_KEY$1 = [
    u8('0'),
    u8('0'),
    u8('0'),
    u8('0'),
    u8('0'),
    u8('0'),
    u8('0'),
    u8('0'),
    u8('0'),
    u8('0'),
    u8('0'),
    u8('0'),
    u8('0'),
    u8('0'),
    u8('0'),
    u8('0'),
    u8('0'),
    u8('0'),
    u8('0'),
    u8('0'),
    u8('0'),
    u8('0'),
    u8('0'),
    u8('0'),
    u8('0'),
    u8('0'),
    u8('0'),
    u8('0'),
    u8('0'),
    u8('0'),
    u8('0'),
    u8('0')
];
class Account {
    constructor(proto, typeTag) {
        this.typeTag = typeTag;
        this.__app = null;
        this.authentication_key = proto['authentication_key'];
        this.sequence_number = proto['sequence_number'];
        this.guid_creation_num = proto['guid_creation_num'];
        this.coin_register_events = proto['coin_register_events'];
        this.key_rotation_events = proto['key_rotation_events'];
        this.rotation_capability_offer = proto['rotation_capability_offer'];
        this.signer_capability_offer = proto['signer_capability_offer'];
    }
    static AccountParser(data, typeTag, repo) {
        const proto = $.parseStructProto(data, typeTag, repo, Account);
        return new Account(proto, typeTag);
    }
    static load(repo, client, address, typeParams) {
        return __awaiter(this, void 0, void 0, function* () {
            const result = yield repo.loadResource(client, address, Account, typeParams);
            return result;
        });
    }
    static loadByApp(app, address, typeParams) {
        return __awaiter(this, void 0, void 0, function* () {
            const result = yield app.repo.loadResource(app.client, address, Account, typeParams);
            yield result.loadFullState(app);
            return result;
        });
    }
    static getTag() {
        return new StructTag(moduleAddress$1g, moduleName$1g, 'Account', []);
    }
    loadFullState(app) {
        return __awaiter(this, void 0, void 0, function* () {
            yield this.coin_register_events.loadFullState(app);
            yield this.key_rotation_events.loadFullState(app);
            yield this.rotation_capability_offer.loadFullState(app);
            yield this.signer_capability_offer.loadFullState(app);
            this.__app = app;
        });
    }
}
Account.moduleAddress = moduleAddress$1g;
Account.moduleName = moduleName$1g;
Account.structName = 'Account';
Account.typeParameters = [];
Account.fields = [
    { name: 'authentication_key', typeTag: new VectorTag(AtomicTypeTag.U8) },
    { name: 'sequence_number', typeTag: AtomicTypeTag.U64 },
    { name: 'guid_creation_num', typeTag: AtomicTypeTag.U64 },
    {
        name: 'coin_register_events',
        typeTag: new StructTag(new HexString('0x1'), 'event', 'EventHandle', [
            new StructTag(new HexString('0x1'), 'account', 'CoinRegisterEvent', [])
        ])
    },
    {
        name: 'key_rotation_events',
        typeTag: new StructTag(new HexString('0x1'), 'event', 'EventHandle', [
            new StructTag(new HexString('0x1'), 'account', 'KeyRotationEvent', [])
        ])
    },
    {
        name: 'rotation_capability_offer',
        typeTag: new StructTag(new HexString('0x1'), 'account', 'CapabilityOffer', [
            new StructTag(new HexString('0x1'), 'account', 'RotationCapability', [])
        ])
    },
    {
        name: 'signer_capability_offer',
        typeTag: new StructTag(new HexString('0x1'), 'account', 'CapabilityOffer', [
            new StructTag(new HexString('0x1'), 'account', 'SignerCapability', [])
        ])
    }
];
class CapabilityOffer {
    constructor(proto, typeTag) {
        this.typeTag = typeTag;
        this.__app = null;
        this.for__ = proto['for__'];
    }
    static CapabilityOfferParser(data, typeTag, repo) {
        const proto = $.parseStructProto(data, typeTag, repo, CapabilityOffer);
        return new CapabilityOffer(proto, typeTag);
    }
    static makeTag($p) {
        return new StructTag(moduleAddress$1g, moduleName$1g, 'CapabilityOffer', $p);
    }
    loadFullState(app) {
        return __awaiter(this, void 0, void 0, function* () {
            yield this.for__.loadFullState(app);
            this.__app = app;
        });
    }
}
CapabilityOffer.moduleAddress = moduleAddress$1g;
CapabilityOffer.moduleName = moduleName$1g;
CapabilityOffer.structName = 'CapabilityOffer';
CapabilityOffer.typeParameters = [{ name: 'T', isPhantom: true }];
CapabilityOffer.fields = [
    { name: 'for__', typeTag: new StructTag(new HexString('0x1'), 'option', 'Option', [AtomicTypeTag.Address]) }
];
class CoinRegisterEvent {
    constructor(proto, typeTag) {
        this.typeTag = typeTag;
        this.__app = null;
        this.type_info = proto['type_info'];
    }
    static CoinRegisterEventParser(data, typeTag, repo) {
        const proto = $.parseStructProto(data, typeTag, repo, CoinRegisterEvent);
        return new CoinRegisterEvent(proto, typeTag);
    }
    static getTag() {
        return new StructTag(moduleAddress$1g, moduleName$1g, 'CoinRegisterEvent', []);
    }
    loadFullState(app) {
        return __awaiter(this, void 0, void 0, function* () {
            yield this.type_info.loadFullState(app);
            this.__app = app;
        });
    }
}
CoinRegisterEvent.moduleAddress = moduleAddress$1g;
CoinRegisterEvent.moduleName = moduleName$1g;
CoinRegisterEvent.structName = 'CoinRegisterEvent';
CoinRegisterEvent.typeParameters = [];
CoinRegisterEvent.fields = [
    { name: 'type_info', typeTag: new StructTag(new HexString('0x1'), 'type_info', 'TypeInfo', []) }
];
class KeyRotationEvent {
    constructor(proto, typeTag) {
        this.typeTag = typeTag;
        this.__app = null;
        this.old_authentication_key = proto['old_authentication_key'];
        this.new_authentication_key = proto['new_authentication_key'];
    }
    static KeyRotationEventParser(data, typeTag, repo) {
        const proto = $.parseStructProto(data, typeTag, repo, KeyRotationEvent);
        return new KeyRotationEvent(proto, typeTag);
    }
    static getTag() {
        return new StructTag(moduleAddress$1g, moduleName$1g, 'KeyRotationEvent', []);
    }
    loadFullState(app) {
        return __awaiter(this, void 0, void 0, function* () {
            this.__app = app;
        });
    }
}
KeyRotationEvent.moduleAddress = moduleAddress$1g;
KeyRotationEvent.moduleName = moduleName$1g;
KeyRotationEvent.structName = 'KeyRotationEvent';
KeyRotationEvent.typeParameters = [];
KeyRotationEvent.fields = [
    { name: 'old_authentication_key', typeTag: new VectorTag(AtomicTypeTag.U8) },
    { name: 'new_authentication_key', typeTag: new VectorTag(AtomicTypeTag.U8) }
];
class OriginatingAddress {
    constructor(proto, typeTag) {
        this.typeTag = typeTag;
        this.__app = null;
        this.address_map = proto['address_map'];
    }
    static OriginatingAddressParser(data, typeTag, repo) {
        const proto = $.parseStructProto(data, typeTag, repo, OriginatingAddress);
        return new OriginatingAddress(proto, typeTag);
    }
    static load(repo, client, address, typeParams) {
        return __awaiter(this, void 0, void 0, function* () {
            const result = yield repo.loadResource(client, address, OriginatingAddress, typeParams);
            return result;
        });
    }
    static loadByApp(app, address, typeParams) {
        return __awaiter(this, void 0, void 0, function* () {
            const result = yield app.repo.loadResource(app.client, address, OriginatingAddress, typeParams);
            yield result.loadFullState(app);
            return result;
        });
    }
    static getTag() {
        return new StructTag(moduleAddress$1g, moduleName$1g, 'OriginatingAddress', []);
    }
    loadFullState(app) {
        return __awaiter(this, void 0, void 0, function* () {
            yield this.address_map.loadFullState(app);
            this.__app = app;
        });
    }
}
OriginatingAddress.moduleAddress = moduleAddress$1g;
OriginatingAddress.moduleName = moduleName$1g;
OriginatingAddress.structName = 'OriginatingAddress';
OriginatingAddress.typeParameters = [];
OriginatingAddress.fields = [
    {
        name: 'address_map',
        typeTag: new StructTag(new HexString('0x1'), 'table', 'Table', [AtomicTypeTag.Address, AtomicTypeTag.Address])
    }
];
class RotationCapability {
    constructor(proto, typeTag) {
        this.typeTag = typeTag;
        this.__app = null;
        this.account = proto['account'];
    }
    static RotationCapabilityParser(data, typeTag, repo) {
        const proto = $.parseStructProto(data, typeTag, repo, RotationCapability);
        return new RotationCapability(proto, typeTag);
    }
    static getTag() {
        return new StructTag(moduleAddress$1g, moduleName$1g, 'RotationCapability', []);
    }
    loadFullState(app) {
        return __awaiter(this, void 0, void 0, function* () {
            this.__app = app;
        });
    }
}
RotationCapability.moduleAddress = moduleAddress$1g;
RotationCapability.moduleName = moduleName$1g;
RotationCapability.structName = 'RotationCapability';
RotationCapability.typeParameters = [];
RotationCapability.fields = [{ name: 'account', typeTag: AtomicTypeTag.Address }];
class RotationCapabilityOfferProofChallenge {
    constructor(proto, typeTag) {
        this.typeTag = typeTag;
        this.__app = null;
        this.sequence_number = proto['sequence_number'];
        this.recipient_address = proto['recipient_address'];
    }
    static RotationCapabilityOfferProofChallengeParser(data, typeTag, repo) {
        const proto = $.parseStructProto(data, typeTag, repo, RotationCapabilityOfferProofChallenge);
        return new RotationCapabilityOfferProofChallenge(proto, typeTag);
    }
    static getTag() {
        return new StructTag(moduleAddress$1g, moduleName$1g, 'RotationCapabilityOfferProofChallenge', []);
    }
    loadFullState(app) {
        return __awaiter(this, void 0, void 0, function* () {
            this.__app = app;
        });
    }
}
RotationCapabilityOfferProofChallenge.moduleAddress = moduleAddress$1g;
RotationCapabilityOfferProofChallenge.moduleName = moduleName$1g;
RotationCapabilityOfferProofChallenge.structName = 'RotationCapabilityOfferProofChallenge';
RotationCapabilityOfferProofChallenge.typeParameters = [];
RotationCapabilityOfferProofChallenge.fields = [
    { name: 'sequence_number', typeTag: AtomicTypeTag.U64 },
    { name: 'recipient_address', typeTag: AtomicTypeTag.Address }
];
class RotationProofChallenge {
    constructor(proto, typeTag) {
        this.typeTag = typeTag;
        this.__app = null;
        this.sequence_number = proto['sequence_number'];
        this.originator = proto['originator'];
        this.current_auth_key = proto['current_auth_key'];
        this.new_public_key = proto['new_public_key'];
    }
    static RotationProofChallengeParser(data, typeTag, repo) {
        const proto = $.parseStructProto(data, typeTag, repo, RotationProofChallenge);
        return new RotationProofChallenge(proto, typeTag);
    }
    static getTag() {
        return new StructTag(moduleAddress$1g, moduleName$1g, 'RotationProofChallenge', []);
    }
    loadFullState(app) {
        return __awaiter(this, void 0, void 0, function* () {
            this.__app = app;
        });
    }
}
RotationProofChallenge.moduleAddress = moduleAddress$1g;
RotationProofChallenge.moduleName = moduleName$1g;
RotationProofChallenge.structName = 'RotationProofChallenge';
RotationProofChallenge.typeParameters = [];
RotationProofChallenge.fields = [
    { name: 'sequence_number', typeTag: AtomicTypeTag.U64 },
    { name: 'originator', typeTag: AtomicTypeTag.Address },
    { name: 'current_auth_key', typeTag: AtomicTypeTag.Address },
    { name: 'new_public_key', typeTag: new VectorTag(AtomicTypeTag.U8) }
];
class SignerCapability {
    constructor(proto, typeTag) {
        this.typeTag = typeTag;
        this.__app = null;
        this.account = proto['account'];
    }
    static SignerCapabilityParser(data, typeTag, repo) {
        const proto = $.parseStructProto(data, typeTag, repo, SignerCapability);
        return new SignerCapability(proto, typeTag);
    }
    static getTag() {
        return new StructTag(moduleAddress$1g, moduleName$1g, 'SignerCapability', []);
    }
    loadFullState(app) {
        return __awaiter(this, void 0, void 0, function* () {
            this.__app = app;
        });
    }
}
SignerCapability.moduleAddress = moduleAddress$1g;
SignerCapability.moduleName = moduleName$1g;
SignerCapability.structName = 'SignerCapability';
SignerCapability.typeParameters = [];
SignerCapability.fields = [{ name: 'account', typeTag: AtomicTypeTag.Address }];
class SignerCapabilityOfferProofChallenge {
    constructor(proto, typeTag) {
        this.typeTag = typeTag;
        this.__app = null;
        this.sequence_number = proto['sequence_number'];
        this.recipient_address = proto['recipient_address'];
    }
    static SignerCapabilityOfferProofChallengeParser(data, typeTag, repo) {
        const proto = $.parseStructProto(data, typeTag, repo, SignerCapabilityOfferProofChallenge);
        return new SignerCapabilityOfferProofChallenge(proto, typeTag);
    }
    static getTag() {
        return new StructTag(moduleAddress$1g, moduleName$1g, 'SignerCapabilityOfferProofChallenge', []);
    }
    loadFullState(app) {
        return __awaiter(this, void 0, void 0, function* () {
            this.__app = app;
        });
    }
}
SignerCapabilityOfferProofChallenge.moduleAddress = moduleAddress$1g;
SignerCapabilityOfferProofChallenge.moduleName = moduleName$1g;
SignerCapabilityOfferProofChallenge.structName = 'SignerCapabilityOfferProofChallenge';
SignerCapabilityOfferProofChallenge.typeParameters = [];
SignerCapabilityOfferProofChallenge.fields = [
    { name: 'sequence_number', typeTag: AtomicTypeTag.U64 },
    { name: 'recipient_address', typeTag: AtomicTypeTag.Address }
];
class SignerCapabilityOfferProofChallengeV2 {
    constructor(proto, typeTag) {
        this.typeTag = typeTag;
        this.__app = null;
        this.sequence_number = proto['sequence_number'];
        this.source_address = proto['source_address'];
        this.recipient_address = proto['recipient_address'];
    }
    static SignerCapabilityOfferProofChallengeV2Parser(data, typeTag, repo) {
        const proto = $.parseStructProto(data, typeTag, repo, SignerCapabilityOfferProofChallengeV2);
        return new SignerCapabilityOfferProofChallengeV2(proto, typeTag);
    }
    static getTag() {
        return new StructTag(moduleAddress$1g, moduleName$1g, 'SignerCapabilityOfferProofChallengeV2', []);
    }
    loadFullState(app) {
        return __awaiter(this, void 0, void 0, function* () {
            this.__app = app;
        });
    }
}
SignerCapabilityOfferProofChallengeV2.moduleAddress = moduleAddress$1g;
SignerCapabilityOfferProofChallengeV2.moduleName = moduleName$1g;
SignerCapabilityOfferProofChallengeV2.structName = 'SignerCapabilityOfferProofChallengeV2';
SignerCapabilityOfferProofChallengeV2.typeParameters = [];
SignerCapabilityOfferProofChallengeV2.fields = [
    { name: 'sequence_number', typeTag: AtomicTypeTag.U64 },
    { name: 'source_address', typeTag: AtomicTypeTag.Address },
    { name: 'recipient_address', typeTag: AtomicTypeTag.Address }
];
function assert_valid_signature_and_get_auth_key_(scheme, public_key_bytes, signature, challenge, $c) {
    let temp$3, temp$4, pk, pk__1, sig, sig__2;
    if ($.copy(scheme).eq($.copy(ED25519_SCHEME))) {
        pk = new_unvalidated_public_key_from_bytes_$1($.copy(public_key_bytes), $c);
        sig = new_signature_from_bytes_$1($.copy(signature), $c);
        if (!signature_verify_strict_t_$1(sig, pk, $.copy(challenge), $c, [new SimpleStructTag(RotationProofChallenge)])) {
            throw $.abortCode(invalid_argument_($.copy(EINVALID_PROOF_OF_KNOWLEDGE)));
        }
        temp$4 = unvalidated_public_key_to_authentication_key_$1(pk, $c);
    }
    else {
        if ($.copy(scheme).eq($.copy(MULTI_ED25519_SCHEME))) {
            pk__1 = new_unvalidated_public_key_from_bytes_($.copy(public_key_bytes), $c);
            sig__2 = new_signature_from_bytes_($.copy(signature), $c);
            if (!signature_verify_strict_t_(sig__2, pk__1, $.copy(challenge), $c, [
                new SimpleStructTag(RotationProofChallenge)
            ])) {
                throw $.abortCode(invalid_argument_($.copy(EINVALID_PROOF_OF_KNOWLEDGE)));
            }
            temp$3 = unvalidated_public_key_to_authentication_key_(pk__1, $c);
        }
        else {
            throw $.abortCode(invalid_argument_($.copy(EINVALID_SCHEME)));
        }
        temp$4 = temp$3;
    }
    return temp$4;
}
function create_account_$2(new_address, $c) {
    let temp$1, temp$2;
    if (!!$c.exists(new SimpleStructTag(Account), $.copy(new_address))) {
        throw $.abortCode(already_exists_($.copy(EACCOUNT_ALREADY_EXISTS)));
    }
    if ($.copy(new_address).hex() !== new HexString('0x0').hex()) {
        temp$1 = $.copy(new_address).hex() !== new HexString('0x1').hex();
    }
    else {
        temp$1 = false;
    }
    if (temp$1) {
        temp$2 = $.copy(new_address).hex() !== new HexString('0x3').hex();
    }
    else {
        temp$2 = false;
    }
    if (!temp$2) {
        throw $.abortCode(invalid_argument_($.copy(ECANNOT_RESERVED_ADDRESS)));
    }
    return create_account_unchecked_($.copy(new_address), $c);
}
function create_account_unchecked_(new_address, $c) {
    let authentication_key, coin_register_events, guid_creation_num, guid_for_coin, guid_for_rotation, key_rotation_events, new_account;
    new_account = create_signer_$1($.copy(new_address), $c);
    authentication_key = to_bytes_(new_address, $c, [AtomicTypeTag.Address]);
    if (!length_$6(authentication_key, $c, [AtomicTypeTag.U8]).eq(u64('32'))) {
        throw $.abortCode(invalid_argument_($.copy(EMALFORMED_AUTHENTICATION_KEY)));
    }
    guid_creation_num = u64('0');
    guid_for_coin = create_$3($.copy(new_address), guid_creation_num);
    coin_register_events = new_event_handle_$1(guid_for_coin, $c, [new SimpleStructTag(CoinRegisterEvent)]);
    guid_for_rotation = create_$3($.copy(new_address), guid_creation_num);
    key_rotation_events = new_event_handle_$1(guid_for_rotation, $c, [new SimpleStructTag(KeyRotationEvent)]);
    $c.move_to(new SimpleStructTag(Account), new_account, new Account({
        authentication_key: $.copy(authentication_key),
        sequence_number: u64('0'),
        guid_creation_num: $.copy(guid_creation_num),
        coin_register_events: coin_register_events,
        key_rotation_events: key_rotation_events,
        rotation_capability_offer: new CapabilityOffer({ for: none_($c, [AtomicTypeTag.Address]) }, new SimpleStructTag(CapabilityOffer, [new SimpleStructTag(RotationCapability)])),
        signer_capability_offer: new CapabilityOffer({ for: none_($c, [AtomicTypeTag.Address]) }, new SimpleStructTag(CapabilityOffer, [new SimpleStructTag(SignerCapability)]))
    }, new SimpleStructTag(Account)));
    return new_account;
}
function create_authorized_signer_(account, offerer_address, $c) {
    let account_resource, addr;
    if (!exists_at_($.copy(offerer_address), $c)) {
        throw $.abortCode(not_found_($.copy(EACCOUNT_DOES_NOT_EXIST$1)));
    }
    account_resource = $c.borrow_global(new SimpleStructTag(Account), $.copy(offerer_address));
    addr = address_of_(account, $c);
    if (!contains_$7(account_resource.signer_capability_offer.for__, addr, $c, [AtomicTypeTag.Address])) {
        throw $.abortCode(not_found_($.copy(ENO_SUCH_SIGNER_CAPABILITY)));
    }
    return create_signer_$1($.copy(offerer_address), $c);
}
function create_framework_reserved_account_(addr, $c) {
    let temp$1, temp$2, temp$3, temp$4, temp$5, temp$6, temp$7, temp$8, temp$9, signer, signer_cap;
    if ($.copy(addr).hex() === new HexString('0x1').hex()) {
        temp$1 = true;
    }
    else {
        temp$1 = $.copy(addr).hex() === new HexString('0x2').hex();
    }
    if (temp$1) {
        temp$2 = true;
    }
    else {
        temp$2 = $.copy(addr).hex() === new HexString('0x3').hex();
    }
    if (temp$2) {
        temp$3 = true;
    }
    else {
        temp$3 = $.copy(addr).hex() === new HexString('0x4').hex();
    }
    if (temp$3) {
        temp$4 = true;
    }
    else {
        temp$4 = $.copy(addr).hex() === new HexString('0x5').hex();
    }
    if (temp$4) {
        temp$5 = true;
    }
    else {
        temp$5 = $.copy(addr).hex() === new HexString('0x6').hex();
    }
    if (temp$5) {
        temp$6 = true;
    }
    else {
        temp$6 = $.copy(addr).hex() === new HexString('0x7').hex();
    }
    if (temp$6) {
        temp$7 = true;
    }
    else {
        temp$7 = $.copy(addr).hex() === new HexString('0x8').hex();
    }
    if (temp$7) {
        temp$8 = true;
    }
    else {
        temp$8 = $.copy(addr).hex() === new HexString('0x9').hex();
    }
    if (temp$8) {
        temp$9 = true;
    }
    else {
        temp$9 = $.copy(addr).hex() === new HexString('0xa').hex();
    }
    if (!temp$9) {
        throw $.abortCode(permission_denied_($.copy(ENO_VALID_FRAMEWORK_RESERVED_ADDRESS)));
    }
    signer = create_account_unchecked_($.copy(addr), $c);
    signer_cap = new SignerCapability({ account: $.copy(addr) }, new SimpleStructTag(SignerCapability));
    return [signer, signer_cap];
}
function create_guid_(account_signer, $c) {
    let account, addr;
    addr = address_of_(account_signer, $c);
    account = $c.borrow_global_mut(new SimpleStructTag(Account), $.copy(addr));
    return create_$3($.copy(addr), account.guid_creation_num);
}
function create_resource_account_$1(source, seed, $c) {
    let temp$1, temp$2, account, account__3, resource, resource_addr, signer_cap;
    temp$1 = address_of_(source, $c);
    resource_addr = create_resource_address_(temp$1, $.copy(seed), $c);
    if (exists_at_($.copy(resource_addr), $c)) {
        account = $c.borrow_global(new SimpleStructTag(Account), $.copy(resource_addr));
        if (!is_none_(account.signer_capability_offer.for__, $c, [AtomicTypeTag.Address])) {
            throw $.abortCode(already_exists_($.copy(ERESOURCE_ACCCOUNT_EXISTS)));
        }
        if (!$.copy(account.sequence_number).eq(u64('0'))) {
            throw $.abortCode(invalid_state_($.copy(EACCOUNT_ALREADY_USED)));
        }
        temp$2 = create_signer_$1($.copy(resource_addr), $c);
    }
    else {
        temp$2 = create_account_unchecked_($.copy(resource_addr), $c);
    }
    resource = temp$2;
    rotate_authentication_key_internal_(resource, $.copy(ZERO_AUTH_KEY$1), $c);
    account__3 = $c.borrow_global_mut(new SimpleStructTag(Account), $.copy(resource_addr));
    account__3.signer_capability_offer.for__ = some_($.copy(resource_addr), $c, [AtomicTypeTag.Address]);
    signer_cap = new SignerCapability({ account: $.copy(resource_addr) }, new SimpleStructTag(SignerCapability));
    return [resource, signer_cap];
}
function create_resource_address_(source, seed, $c) {
    let bytes;
    bytes = to_bytes_(source, $c, [AtomicTypeTag.Address]);
    append_$3(bytes, $.copy(seed), $c, [AtomicTypeTag.U8]);
    push_back_(bytes, $.copy(DERIVE_RESOURCE_ACCOUNT_SCHEME), $c, [AtomicTypeTag.U8]);
    return to_address_(sha3_256_($.copy(bytes), $c), $c);
}
function create_signer_$1(addr, $c) {
    return $.aptos_framework_account_create_signer(addr, $c);
}
function create_signer_with_capability_(capability, $c) {
    let addr;
    addr = capability.account;
    return create_signer_$1($.copy(addr), $c);
}
function exists_at_(addr, $c) {
    return $c.exists(new SimpleStructTag(Account), $.copy(addr));
}
function get_authentication_key_(addr, $c) {
    return $.copy($c.borrow_global(new SimpleStructTag(Account), $.copy(addr)).authentication_key);
}
function get_guid_next_creation_num_(addr, $c) {
    return $.copy($c.borrow_global(new SimpleStructTag(Account), $.copy(addr)).guid_creation_num);
}
function get_sequence_number_(addr, $c) {
    return $.copy($c.borrow_global(new SimpleStructTag(Account), $.copy(addr)).sequence_number);
}
function get_signer_capability_address_(capability, $c) {
    return $.copy(capability.account);
}
function increment_sequence_number_(addr, $c) {
    let sequence_number;
    sequence_number = $c.borrow_global_mut(new SimpleStructTag(Account), $.copy(addr)).sequence_number;
    if (!u128($.copy(sequence_number)).lt($.copy(MAX_U64$5))) {
        throw $.abortCode(out_of_range_($.copy(ESEQUENCE_NUMBER_TOO_BIG)));
    }
    $.set(sequence_number, $.copy(sequence_number).add(u64('1')));
    return;
}
function initialize_$k(aptos_framework, $c) {
    assert_aptos_framework_(aptos_framework, $c);
    $c.move_to(new SimpleStructTag(OriginatingAddress), aptos_framework, new OriginatingAddress({ address_map: new___$5($c, [AtomicTypeTag.Address, AtomicTypeTag.Address]) }, new SimpleStructTag(OriginatingAddress)));
    return;
}
function new_event_handle_(account, $c, $p /* <T>*/) {
    return new_event_handle_$1(create_guid_(account, $c), $c, [$p[0]]);
}
function offer_signer_capability_(account, signer_capability_sig_bytes, account_scheme, account_public_key_bytes, recipient_address, $c) {
    let account_resource, expected_auth_key, expected_auth_key__2, proof_challenge, pubkey, pubkey__1, signer_capability_sig, signer_capability_sig__3, source_address;
    source_address = address_of_(account, $c);
    if (!exists_at_($.copy(recipient_address), $c)) {
        throw $.abortCode(not_found_($.copy(EACCOUNT_DOES_NOT_EXIST$1)));
    }
    account_resource = $c.borrow_global_mut(new SimpleStructTag(Account), $.copy(source_address));
    proof_challenge = new SignerCapabilityOfferProofChallengeV2({
        sequence_number: $.copy(account_resource.sequence_number),
        source_address: $.copy(source_address),
        recipient_address: $.copy(recipient_address)
    }, new SimpleStructTag(SignerCapabilityOfferProofChallengeV2));
    if ($.copy(account_scheme).eq($.copy(ED25519_SCHEME))) {
        pubkey = new_unvalidated_public_key_from_bytes_$1($.copy(account_public_key_bytes), $c);
        expected_auth_key = unvalidated_public_key_to_authentication_key_$1(pubkey, $c);
        if (!$.veq($.copy(account_resource.authentication_key), $.copy(expected_auth_key))) {
            throw $.abortCode(invalid_argument_($.copy(EWRONG_CURRENT_PUBLIC_KEY)));
        }
        signer_capability_sig = new_signature_from_bytes_$1($.copy(signer_capability_sig_bytes), $c);
        if (!signature_verify_strict_t_$1(signer_capability_sig, pubkey, proof_challenge, $c, [
            new SimpleStructTag(SignerCapabilityOfferProofChallengeV2)
        ])) {
            throw $.abortCode(invalid_argument_($.copy(EINVALID_PROOF_OF_KNOWLEDGE)));
        }
    }
    else {
        if ($.copy(account_scheme).eq($.copy(MULTI_ED25519_SCHEME))) {
            pubkey__1 = new_unvalidated_public_key_from_bytes_($.copy(account_public_key_bytes), $c);
            expected_auth_key__2 = unvalidated_public_key_to_authentication_key_(pubkey__1, $c);
            if (!$.veq($.copy(account_resource.authentication_key), $.copy(expected_auth_key__2))) {
                throw $.abortCode(invalid_argument_($.copy(EWRONG_CURRENT_PUBLIC_KEY)));
            }
            signer_capability_sig__3 = new_signature_from_bytes_($.copy(signer_capability_sig_bytes), $c);
            if (!signature_verify_strict_t_(signer_capability_sig__3, pubkey__1, proof_challenge, $c, [
                new SimpleStructTag(SignerCapabilityOfferProofChallengeV2)
            ])) {
                throw $.abortCode(invalid_argument_($.copy(EINVALID_PROOF_OF_KNOWLEDGE)));
            }
        }
        else {
            throw $.abortCode(invalid_argument_($.copy(EINVALID_SCHEME)));
        }
    }
    swap_or_fill_(account_resource.signer_capability_offer.for__, $.copy(recipient_address), $c, [
        AtomicTypeTag.Address
    ]);
    return;
}
function buildPayload_offer_signer_capability(signer_capability_sig_bytes, account_scheme, account_public_key_bytes, recipient_address, isJSON = false) {
    const typeParamStrings = [];
    return $.buildPayload(new HexString('0x1'), 'account', 'offer_signer_capability', typeParamStrings, [signer_capability_sig_bytes, account_scheme, account_public_key_bytes, recipient_address], isJSON);
}
function register_coin_(account_addr, $c, $p /* <CoinType>*/) {
    let account;
    account = $c.borrow_global_mut(new SimpleStructTag(Account), $.copy(account_addr));
    emit_event_(account.coin_register_events, new CoinRegisterEvent({ type_info: type_of_($c, [$p[0]]) }, new SimpleStructTag(CoinRegisterEvent)), $c, [new SimpleStructTag(CoinRegisterEvent)]);
    return;
}
function revoke_signer_capability_(account, to_be_revoked_address, $c) {
    let account_resource, addr;
    if (!exists_at_($.copy(to_be_revoked_address), $c)) {
        throw $.abortCode(not_found_($.copy(EACCOUNT_DOES_NOT_EXIST$1)));
    }
    addr = address_of_(account, $c);
    account_resource = $c.borrow_global_mut(new SimpleStructTag(Account), $.copy(addr));
    if (!contains_$7(account_resource.signer_capability_offer.for__, to_be_revoked_address, $c, [
        AtomicTypeTag.Address
    ])) {
        throw $.abortCode(not_found_($.copy(ENO_SUCH_SIGNER_CAPABILITY)));
    }
    extract_$1(account_resource.signer_capability_offer.for__, $c, [AtomicTypeTag.Address]);
    return;
}
function buildPayload_revoke_signer_capability(to_be_revoked_address, isJSON = false) {
    const typeParamStrings = [];
    return $.buildPayload(new HexString('0x1'), 'account', 'revoke_signer_capability', typeParamStrings, [to_be_revoked_address], isJSON);
}
function rotate_authentication_key_(account, from_scheme, from_public_key_bytes, to_scheme, to_public_key_bytes, cap_rotate_key, cap_update_table, $c) {
    let temp$3, temp$4, account_resource, addr, address_map, challenge, curr_auth_key, curr_auth_key_as_address, from_auth_key, from_auth_key__2, from_pk, from_pk__1, new_auth_key, new_auth_key_as_address;
    addr = address_of_(account, $c);
    if (!exists_at_($.copy(addr), $c)) {
        throw $.abortCode(not_found_($.copy(EACCOUNT_DOES_NOT_EXIST$1)));
    }
    account_resource = $c.borrow_global_mut(new SimpleStructTag(Account), $.copy(addr));
    if ($.copy(from_scheme).eq($.copy(ED25519_SCHEME))) {
        from_pk = new_unvalidated_public_key_from_bytes_$1($.copy(from_public_key_bytes), $c);
        from_auth_key = unvalidated_public_key_to_authentication_key_$1(from_pk, $c);
        if (!$.veq($.copy(account_resource.authentication_key), $.copy(from_auth_key))) {
            throw $.abortCode(unauthenticated_($.copy(EWRONG_CURRENT_PUBLIC_KEY)));
        }
    }
    else {
        if ($.copy(from_scheme).eq($.copy(MULTI_ED25519_SCHEME))) {
            from_pk__1 = new_unvalidated_public_key_from_bytes_($.copy(from_public_key_bytes), $c);
            from_auth_key__2 = unvalidated_public_key_to_authentication_key_(from_pk__1, $c);
            if (!$.veq($.copy(account_resource.authentication_key), $.copy(from_auth_key__2))) {
                throw $.abortCode(unauthenticated_($.copy(EWRONG_CURRENT_PUBLIC_KEY)));
            }
        }
        else {
            throw $.abortCode(invalid_argument_($.copy(EINVALID_SCHEME)));
        }
    }
    curr_auth_key_as_address = to_address_($.copy(account_resource.authentication_key), $c);
    challenge = new RotationProofChallenge({
        sequence_number: $.copy(account_resource.sequence_number),
        originator: $.copy(addr),
        current_auth_key: $.copy(curr_auth_key_as_address),
        new_public_key: $.copy(to_public_key_bytes)
    }, new SimpleStructTag(RotationProofChallenge));
    curr_auth_key = assert_valid_signature_and_get_auth_key_($.copy(from_scheme), $.copy(from_public_key_bytes), $.copy(cap_rotate_key), challenge, $c);
    new_auth_key = assert_valid_signature_and_get_auth_key_($.copy(to_scheme), $.copy(to_public_key_bytes), $.copy(cap_update_table), challenge, $c);
    address_map = $c.borrow_global_mut(new SimpleStructTag(OriginatingAddress), new HexString('0x1')).address_map;
    new_auth_key_as_address = to_address_($.copy(new_auth_key), $c);
    [temp$3, temp$4] = [address_map, $.copy(curr_auth_key_as_address)];
    if (contains_$6(temp$3, temp$4, $c, [AtomicTypeTag.Address, AtomicTypeTag.Address])) {
        if (!($.copy(addr).hex() ===
            remove_$4(address_map, $.copy(curr_auth_key_as_address), $c, [
                AtomicTypeTag.Address,
                AtomicTypeTag.Address
            ]).hex())) {
            throw $.abortCode(not_found_($.copy(EINVALID_ORIGINATING_ADDRESS)));
        }
    }
    add_$8(address_map, $.copy(new_auth_key_as_address), $.copy(addr), $c, [
        AtomicTypeTag.Address,
        AtomicTypeTag.Address
    ]);
    emit_event_(account_resource.key_rotation_events, new KeyRotationEvent({ old_authentication_key: $.copy(curr_auth_key), new_authentication_key: $.copy(new_auth_key) }, new SimpleStructTag(KeyRotationEvent)), $c, [new SimpleStructTag(KeyRotationEvent)]);
    account_resource.authentication_key = $.copy(new_auth_key);
    return;
}
function buildPayload_rotate_authentication_key(from_scheme, from_public_key_bytes, to_scheme, to_public_key_bytes, cap_rotate_key, cap_update_table, isJSON = false) {
    const typeParamStrings = [];
    return $.buildPayload(new HexString('0x1'), 'account', 'rotate_authentication_key', typeParamStrings, [from_scheme, from_public_key_bytes, to_scheme, to_public_key_bytes, cap_rotate_key, cap_update_table], isJSON);
}
function rotate_authentication_key_internal_(account, new_auth_key, $c) {
    let account_resource, addr;
    addr = address_of_(account, $c);
    if (!exists_at_($.copy(addr), $c)) {
        throw $.abortCode(not_found_($.copy(EACCOUNT_DOES_NOT_EXIST$1)));
    }
    if (!length_$6(new_auth_key, $c, [AtomicTypeTag.U8]).eq(u64('32'))) {
        throw $.abortCode(invalid_argument_($.copy(EMALFORMED_AUTHENTICATION_KEY)));
    }
    account_resource = $c.borrow_global_mut(new SimpleStructTag(Account), $.copy(addr));
    account_resource.authentication_key = $.copy(new_auth_key);
    return;
}
function loadParsers$1t(repo) {
    repo.addParser('0x1::account::Account', Account.AccountParser);
    repo.addParser('0x1::account::CapabilityOffer', CapabilityOffer.CapabilityOfferParser);
    repo.addParser('0x1::account::CoinRegisterEvent', CoinRegisterEvent.CoinRegisterEventParser);
    repo.addParser('0x1::account::KeyRotationEvent', KeyRotationEvent.KeyRotationEventParser);
    repo.addParser('0x1::account::OriginatingAddress', OriginatingAddress.OriginatingAddressParser);
    repo.addParser('0x1::account::RotationCapability', RotationCapability.RotationCapabilityParser);
    repo.addParser('0x1::account::RotationCapabilityOfferProofChallenge', RotationCapabilityOfferProofChallenge.RotationCapabilityOfferProofChallengeParser);
    repo.addParser('0x1::account::RotationProofChallenge', RotationProofChallenge.RotationProofChallengeParser);
    repo.addParser('0x1::account::SignerCapability', SignerCapability.SignerCapabilityParser);
    repo.addParser('0x1::account::SignerCapabilityOfferProofChallenge', SignerCapabilityOfferProofChallenge.SignerCapabilityOfferProofChallengeParser);
    repo.addParser('0x1::account::SignerCapabilityOfferProofChallengeV2', SignerCapabilityOfferProofChallengeV2.SignerCapabilityOfferProofChallengeV2Parser);
}
class App$1u {
    constructor(client, repo, cache) {
        this.client = client;
        this.repo = repo;
        this.cache = cache;
    }
    get moduleAddress() {
        {
            return moduleAddress$1g;
        }
    }
    get moduleName() {
        {
            return moduleName$1g;
        }
    }
    get Account() {
        return Account;
    }
    loadAccount(owner, loadFull = true, fillCache = true) {
        return __awaiter(this, void 0, void 0, function* () {
            const val = yield Account.load(this.repo, this.client, owner, []);
            if (loadFull) {
                yield val.loadFullState(this);
            }
            if (fillCache) {
                this.cache.set(val.typeTag, owner, val);
            }
            return val;
        });
    }
    get CapabilityOffer() {
        return CapabilityOffer;
    }
    get CoinRegisterEvent() {
        return CoinRegisterEvent;
    }
    get KeyRotationEvent() {
        return KeyRotationEvent;
    }
    get OriginatingAddress() {
        return OriginatingAddress;
    }
    loadOriginatingAddress(owner, loadFull = true, fillCache = true) {
        return __awaiter(this, void 0, void 0, function* () {
            const val = yield OriginatingAddress.load(this.repo, this.client, owner, []);
            if (loadFull) {
                yield val.loadFullState(this);
            }
            if (fillCache) {
                this.cache.set(val.typeTag, owner, val);
            }
            return val;
        });
    }
    get RotationCapability() {
        return RotationCapability;
    }
    get RotationCapabilityOfferProofChallenge() {
        return RotationCapabilityOfferProofChallenge;
    }
    get RotationProofChallenge() {
        return RotationProofChallenge;
    }
    get SignerCapability() {
        return SignerCapability;
    }
    get SignerCapabilityOfferProofChallenge() {
        return SignerCapabilityOfferProofChallenge;
    }
    get SignerCapabilityOfferProofChallengeV2() {
        return SignerCapabilityOfferProofChallengeV2;
    }
    payload_offer_signer_capability(signer_capability_sig_bytes, account_scheme, account_public_key_bytes, recipient_address, isJSON = false) {
        return buildPayload_offer_signer_capability(signer_capability_sig_bytes, account_scheme, account_public_key_bytes, recipient_address, isJSON);
    }
    offer_signer_capability(_account, signer_capability_sig_bytes, account_scheme, account_public_key_bytes, recipient_address, option, _isJSON = false) {
        return __awaiter(this, void 0, void 0, function* () {
            const payload__ = buildPayload_offer_signer_capability(signer_capability_sig_bytes, account_scheme, account_public_key_bytes, recipient_address, _isJSON);
            return $.sendPayloadTx(this.client, _account, payload__, option);
        });
    }
    payload_revoke_signer_capability(to_be_revoked_address, isJSON = false) {
        return buildPayload_revoke_signer_capability(to_be_revoked_address, isJSON);
    }
    revoke_signer_capability(_account, to_be_revoked_address, option, _isJSON = false) {
        return __awaiter(this, void 0, void 0, function* () {
            const payload__ = buildPayload_revoke_signer_capability(to_be_revoked_address, _isJSON);
            return $.sendPayloadTx(this.client, _account, payload__, option);
        });
    }
    payload_rotate_authentication_key(from_scheme, from_public_key_bytes, to_scheme, to_public_key_bytes, cap_rotate_key, cap_update_table, isJSON = false) {
        return buildPayload_rotate_authentication_key(from_scheme, from_public_key_bytes, to_scheme, to_public_key_bytes, cap_rotate_key, cap_update_table, isJSON);
    }
    rotate_authentication_key(_account, from_scheme, from_public_key_bytes, to_scheme, to_public_key_bytes, cap_rotate_key, cap_update_table, option, _isJSON = false) {
        return __awaiter(this, void 0, void 0, function* () {
            const payload__ = buildPayload_rotate_authentication_key(from_scheme, from_public_key_bytes, to_scheme, to_public_key_bytes, cap_rotate_key, cap_update_table, _isJSON);
            return $.sendPayloadTx(this.client, _account, payload__, option);
        });
    }
}

var Account$1 = /*#__PURE__*/Object.freeze({
    __proto__: null,
    packageName: packageName$1g,
    moduleAddress: moduleAddress$1g,
    moduleName: moduleName$1g,
    DERIVE_RESOURCE_ACCOUNT_SCHEME: DERIVE_RESOURCE_ACCOUNT_SCHEME,
    EACCOUNT_ALREADY_EXISTS: EACCOUNT_ALREADY_EXISTS,
    EACCOUNT_ALREADY_USED: EACCOUNT_ALREADY_USED,
    EACCOUNT_DOES_NOT_EXIST: EACCOUNT_DOES_NOT_EXIST$1,
    ECANNOT_RESERVED_ADDRESS: ECANNOT_RESERVED_ADDRESS,
    ED25519_SCHEME: ED25519_SCHEME,
    EINVALID_ACCEPT_ROTATION_CAPABILITY: EINVALID_ACCEPT_ROTATION_CAPABILITY,
    EINVALID_ORIGINATING_ADDRESS: EINVALID_ORIGINATING_ADDRESS,
    EINVALID_PROOF_OF_KNOWLEDGE: EINVALID_PROOF_OF_KNOWLEDGE,
    EINVALID_SCHEME: EINVALID_SCHEME,
    EMALFORMED_AUTHENTICATION_KEY: EMALFORMED_AUTHENTICATION_KEY,
    ENO_CAPABILITY: ENO_CAPABILITY,
    ENO_SUCH_SIGNER_CAPABILITY: ENO_SUCH_SIGNER_CAPABILITY,
    ENO_VALID_FRAMEWORK_RESERVED_ADDRESS: ENO_VALID_FRAMEWORK_RESERVED_ADDRESS,
    EOUT_OF_GAS: EOUT_OF_GAS$1,
    ERESOURCE_ACCCOUNT_EXISTS: ERESOURCE_ACCCOUNT_EXISTS,
    ESEQUENCE_NUMBER_TOO_BIG: ESEQUENCE_NUMBER_TOO_BIG,
    EWRONG_CURRENT_PUBLIC_KEY: EWRONG_CURRENT_PUBLIC_KEY,
    MAX_U64: MAX_U64$5,
    MULTI_ED25519_SCHEME: MULTI_ED25519_SCHEME,
    ZERO_AUTH_KEY: ZERO_AUTH_KEY$1,
    Account: Account,
    CapabilityOffer: CapabilityOffer,
    CoinRegisterEvent: CoinRegisterEvent,
    KeyRotationEvent: KeyRotationEvent,
    OriginatingAddress: OriginatingAddress,
    RotationCapability: RotationCapability,
    RotationCapabilityOfferProofChallenge: RotationCapabilityOfferProofChallenge,
    RotationProofChallenge: RotationProofChallenge,
    SignerCapability: SignerCapability,
    SignerCapabilityOfferProofChallenge: SignerCapabilityOfferProofChallenge,
    SignerCapabilityOfferProofChallengeV2: SignerCapabilityOfferProofChallengeV2,
    assert_valid_signature_and_get_auth_key_: assert_valid_signature_and_get_auth_key_,
    create_account_: create_account_$2,
    create_account_unchecked_: create_account_unchecked_,
    create_authorized_signer_: create_authorized_signer_,
    create_framework_reserved_account_: create_framework_reserved_account_,
    create_guid_: create_guid_,
    create_resource_account_: create_resource_account_$1,
    create_resource_address_: create_resource_address_,
    create_signer_: create_signer_$1,
    create_signer_with_capability_: create_signer_with_capability_,
    exists_at_: exists_at_,
    get_authentication_key_: get_authentication_key_,
    get_guid_next_creation_num_: get_guid_next_creation_num_,
    get_sequence_number_: get_sequence_number_,
    get_signer_capability_address_: get_signer_capability_address_,
    increment_sequence_number_: increment_sequence_number_,
    initialize_: initialize_$k,
    new_event_handle_: new_event_handle_,
    offer_signer_capability_: offer_signer_capability_,
    buildPayload_offer_signer_capability: buildPayload_offer_signer_capability,
    register_coin_: register_coin_,
    revoke_signer_capability_: revoke_signer_capability_,
    buildPayload_revoke_signer_capability: buildPayload_revoke_signer_capability,
    rotate_authentication_key_: rotate_authentication_key_,
    buildPayload_rotate_authentication_key: buildPayload_rotate_authentication_key,
    rotate_authentication_key_internal_: rotate_authentication_key_internal_,
    loadParsers: loadParsers$1t,
    App: App$1u
});

const packageName$1f = 'MoveStdlib';
const moduleAddress$1f = new HexString('0x1');
const moduleName$1f = 'acl';
const ECONTAIN = u64('0');
const ENOT_CONTAIN = u64('1');
class ACL {
    constructor(proto, typeTag) {
        this.typeTag = typeTag;
        this.__app = null;
        this.list = proto['list'];
    }
    static ACLParser(data, typeTag, repo) {
        const proto = $.parseStructProto(data, typeTag, repo, ACL);
        return new ACL(proto, typeTag);
    }
    static getTag() {
        return new StructTag(moduleAddress$1f, moduleName$1f, 'ACL', []);
    }
    loadFullState(app) {
        return __awaiter(this, void 0, void 0, function* () {
            this.__app = app;
        });
    }
}
ACL.moduleAddress = moduleAddress$1f;
ACL.moduleName = moduleName$1f;
ACL.structName = 'ACL';
ACL.typeParameters = [];
ACL.fields = [{ name: 'list', typeTag: new VectorTag(AtomicTypeTag.Address) }];
function add_$7(acl, addr, $c) {
    let temp$1, temp$2;
    [temp$1, temp$2] = [acl.list, addr];
    if (!!contains_$8(temp$1, temp$2, $c, [AtomicTypeTag.Address])) {
        throw $.abortCode(invalid_argument_($.copy(ECONTAIN)));
    }
    push_back_(acl.list, $.copy(addr), $c, [AtomicTypeTag.Address]);
    return;
}
function assert_contains_(acl, addr, $c) {
    if (!contains_$5(acl, $.copy(addr), $c)) {
        throw $.abortCode(invalid_argument_($.copy(ENOT_CONTAIN)));
    }
    return;
}
function contains_$5(acl, addr, $c) {
    return contains_$8(acl.list, addr, $c, [AtomicTypeTag.Address]);
}
function empty_$4($c) {
    return new ACL({ list: empty_$5($c, [AtomicTypeTag.Address]) }, new SimpleStructTag(ACL));
}
function remove_$3(acl, addr, $c) {
    let temp$1, temp$2, found, index;
    [temp$1, temp$2] = [acl.list, addr];
    [found, index] = index_of_$1(temp$1, temp$2, $c, [AtomicTypeTag.Address]);
    if (!found) {
        throw $.abortCode(invalid_argument_($.copy(ENOT_CONTAIN)));
    }
    remove_$5(acl.list, $.copy(index), $c, [AtomicTypeTag.Address]);
    return;
}
function loadParsers$1s(repo) {
    repo.addParser('0x1::acl::ACL', ACL.ACLParser);
}
class App$1t {
    constructor(client, repo, cache) {
        this.client = client;
        this.repo = repo;
        this.cache = cache;
    }
    get moduleAddress() {
        {
            return moduleAddress$1f;
        }
    }
    get moduleName() {
        {
            return moduleName$1f;
        }
    }
    get ACL() {
        return ACL;
    }
}

var Acl = /*#__PURE__*/Object.freeze({
    __proto__: null,
    packageName: packageName$1f,
    moduleAddress: moduleAddress$1f,
    moduleName: moduleName$1f,
    ECONTAIN: ECONTAIN,
    ENOT_CONTAIN: ENOT_CONTAIN,
    ACL: ACL,
    add_: add_$7,
    assert_contains_: assert_contains_,
    contains_: contains_$5,
    empty_: empty_$4,
    remove_: remove_$3,
    loadParsers: loadParsers$1s,
    App: App$1t
});

const packageName$1e = 'AptosFramework';
const moduleAddress$1e = new HexString('0x1');
const moduleName$1e = 'aggregator';
const EAGGREGATOR_OVERFLOW$1 = u64('1');
const EAGGREGATOR_UNDERFLOW$1 = u64('2');
const ENOT_SUPPORTED = u64('3');
class Aggregator$1 {
    constructor(proto, typeTag) {
        this.typeTag = typeTag;
        this.__app = null;
        this.handle = proto['handle'];
        this.key = proto['key'];
        this.limit = proto['limit'];
    }
    static AggregatorParser(data, typeTag, repo) {
        const proto = $.parseStructProto(data, typeTag, repo, Aggregator$1);
        return new Aggregator$1(proto, typeTag);
    }
    static getTag() {
        return new StructTag(moduleAddress$1e, moduleName$1e, 'Aggregator', []);
    }
    loadFullState(app) {
        return __awaiter(this, void 0, void 0, function* () {
            this.__app = app;
        });
    }
}
Aggregator$1.moduleAddress = moduleAddress$1e;
Aggregator$1.moduleName = moduleName$1e;
Aggregator$1.structName = 'Aggregator';
Aggregator$1.typeParameters = [];
Aggregator$1.fields = [
    { name: 'handle', typeTag: AtomicTypeTag.Address },
    { name: 'key', typeTag: AtomicTypeTag.Address },
    { name: 'limit', typeTag: AtomicTypeTag.U128 }
];
function add_$6(aggregator, value, $c) {
    return $.aptos_framework_aggregator_add(aggregator, value, $c);
}
function destroy_$1(aggregator, $c) {
    return $.aptos_framework_aggregator_destroy(aggregator, $c);
}
function limit_$1(aggregator, $c) {
    return $.copy(aggregator.limit);
}
function read_$1(aggregator, $c) {
    return $.aptos_framework_aggregator_read(aggregator, $c);
}
function sub_$2(aggregator, value, $c) {
    return $.aptos_framework_aggregator_sub(aggregator, value, $c);
}
function loadParsers$1r(repo) {
    repo.addParser('0x1::aggregator::Aggregator', Aggregator$1.AggregatorParser);
}
class App$1s {
    constructor(client, repo, cache) {
        this.client = client;
        this.repo = repo;
        this.cache = cache;
    }
    get moduleAddress() {
        {
            return moduleAddress$1e;
        }
    }
    get moduleName() {
        {
            return moduleName$1e;
        }
    }
    get Aggregator() {
        return Aggregator$1;
    }
}

var Aggregator$2 = /*#__PURE__*/Object.freeze({
    __proto__: null,
    packageName: packageName$1e,
    moduleAddress: moduleAddress$1e,
    moduleName: moduleName$1e,
    EAGGREGATOR_OVERFLOW: EAGGREGATOR_OVERFLOW$1,
    EAGGREGATOR_UNDERFLOW: EAGGREGATOR_UNDERFLOW$1,
    ENOT_SUPPORTED: ENOT_SUPPORTED,
    Aggregator: Aggregator$1,
    add_: add_$6,
    destroy_: destroy_$1,
    limit_: limit_$1,
    read_: read_$1,
    sub_: sub_$2,
    loadParsers: loadParsers$1r,
    App: App$1s
});

const packageName$1d = 'AptosFramework';
const moduleAddress$1d = new HexString('0x1');
const moduleName$1d = 'aggregator_factory';
const EAGGREGATOR_FACTORY_NOT_FOUND = u64('1');
class AggregatorFactory {
    constructor(proto, typeTag) {
        this.typeTag = typeTag;
        this.__app = null;
        this.phantom_table = proto['phantom_table'];
    }
    static AggregatorFactoryParser(data, typeTag, repo) {
        const proto = $.parseStructProto(data, typeTag, repo, AggregatorFactory);
        return new AggregatorFactory(proto, typeTag);
    }
    static load(repo, client, address, typeParams) {
        return __awaiter(this, void 0, void 0, function* () {
            const result = yield repo.loadResource(client, address, AggregatorFactory, typeParams);
            return result;
        });
    }
    static loadByApp(app, address, typeParams) {
        return __awaiter(this, void 0, void 0, function* () {
            const result = yield app.repo.loadResource(app.client, address, AggregatorFactory, typeParams);
            yield result.loadFullState(app);
            return result;
        });
    }
    static getTag() {
        return new StructTag(moduleAddress$1d, moduleName$1d, 'AggregatorFactory', []);
    }
    loadFullState(app) {
        return __awaiter(this, void 0, void 0, function* () {
            yield this.phantom_table.loadFullState(app);
            this.__app = app;
        });
    }
}
AggregatorFactory.moduleAddress = moduleAddress$1d;
AggregatorFactory.moduleName = moduleName$1d;
AggregatorFactory.structName = 'AggregatorFactory';
AggregatorFactory.typeParameters = [];
AggregatorFactory.fields = [
    {
        name: 'phantom_table',
        typeTag: new StructTag(new HexString('0x1'), 'table', 'Table', [AtomicTypeTag.Address, AtomicTypeTag.U128])
    }
];
function create_aggregator_(account, limit, $c) {
    assert_aptos_framework_(account, $c);
    return create_aggregator_internal_($.copy(limit), $c);
}
function create_aggregator_internal_(limit, $c) {
    let aggregator_factory;
    if (!$c.exists(new SimpleStructTag(AggregatorFactory), new HexString('0x1'))) {
        throw $.abortCode(not_found_($.copy(EAGGREGATOR_FACTORY_NOT_FOUND)));
    }
    aggregator_factory = $c.borrow_global_mut(new SimpleStructTag(AggregatorFactory), new HexString('0x1'));
    return new_aggregator_(aggregator_factory, $.copy(limit), $c);
}
function initialize_aggregator_factory_(aptos_framework, $c) {
    let aggregator_factory;
    assert_aptos_framework_(aptos_framework, $c);
    aggregator_factory = new AggregatorFactory({ phantom_table: new___$5($c, [AtomicTypeTag.Address, AtomicTypeTag.U128]) }, new SimpleStructTag(AggregatorFactory));
    $c.move_to(new SimpleStructTag(AggregatorFactory), aptos_framework, aggregator_factory);
    return;
}
function new_aggregator_(aggregator_factory, limit, $c) {
    return $.aptos_framework_aggregator_factory_new_aggregator(aggregator_factory, limit, $c);
}
function loadParsers$1q(repo) {
    repo.addParser('0x1::aggregator_factory::AggregatorFactory', AggregatorFactory.AggregatorFactoryParser);
}
class App$1r {
    constructor(client, repo, cache) {
        this.client = client;
        this.repo = repo;
        this.cache = cache;
    }
    get moduleAddress() {
        {
            return moduleAddress$1d;
        }
    }
    get moduleName() {
        {
            return moduleName$1d;
        }
    }
    get AggregatorFactory() {
        return AggregatorFactory;
    }
    loadAggregatorFactory(owner, loadFull = true, fillCache = true) {
        return __awaiter(this, void 0, void 0, function* () {
            const val = yield AggregatorFactory.load(this.repo, this.client, owner, []);
            if (loadFull) {
                yield val.loadFullState(this);
            }
            if (fillCache) {
                this.cache.set(val.typeTag, owner, val);
            }
            return val;
        });
    }
}

var Aggregator_factory = /*#__PURE__*/Object.freeze({
    __proto__: null,
    packageName: packageName$1d,
    moduleAddress: moduleAddress$1d,
    moduleName: moduleName$1d,
    EAGGREGATOR_FACTORY_NOT_FOUND: EAGGREGATOR_FACTORY_NOT_FOUND,
    AggregatorFactory: AggregatorFactory,
    create_aggregator_: create_aggregator_,
    create_aggregator_internal_: create_aggregator_internal_,
    initialize_aggregator_factory_: initialize_aggregator_factory_,
    new_aggregator_: new_aggregator_,
    loadParsers: loadParsers$1q,
    App: App$1r
});

const packageName$1c = 'AptosStdlib';
const moduleAddress$1c = new HexString('0x1');
const moduleName$1c = 'any';
const ETYPE_MISMATCH$1 = u64('1');
class Any$1 {
    constructor(proto, typeTag) {
        this.typeTag = typeTag;
        this.__app = null;
        this.type_name = proto['type_name'];
        this.data = proto['data'];
    }
    static AnyParser(data, typeTag, repo) {
        const proto = $.parseStructProto(data, typeTag, repo, Any$1);
        return new Any$1(proto, typeTag);
    }
    static getTag() {
        return new StructTag(moduleAddress$1c, moduleName$1c, 'Any', []);
    }
    loadFullState(app) {
        return __awaiter(this, void 0, void 0, function* () {
            yield this.type_name.loadFullState(app);
            this.__app = app;
        });
    }
}
Any$1.moduleAddress = moduleAddress$1c;
Any$1.moduleName = moduleName$1c;
Any$1.structName = 'Any';
Any$1.typeParameters = [];
Any$1.fields = [
    { name: 'type_name', typeTag: new StructTag(new HexString('0x1'), 'string', 'String', []) },
    { name: 'data', typeTag: new VectorTag(AtomicTypeTag.U8) }
];
function pack_$1(x, $c, $p /* <T>*/) {
    return new Any$1({ type_name: type_name_$2($c, [$p[0]]), data: to_bytes_(x, $c, [$p[0]]) }, new SimpleStructTag(Any$1));
}
function type_name_$1(x, $c) {
    return x.type_name;
}
function unpack_$1(x, $c, $p /* <T>*/) {
    if (!$.deep_eq(type_name_$2($c, [$p[0]]), $.copy(x.type_name))) {
        throw $.abortCode(invalid_argument_($.copy(ETYPE_MISMATCH$1)));
    }
    return from_bytes_$1($.copy(x.data), $c, [$p[0]]);
}
function loadParsers$1p(repo) {
    repo.addParser('0x1::any::Any', Any$1.AnyParser);
}
class App$1q {
    constructor(client, repo, cache) {
        this.client = client;
        this.repo = repo;
        this.cache = cache;
    }
    get moduleAddress() {
        {
            return moduleAddress$1c;
        }
    }
    get moduleName() {
        {
            return moduleName$1c;
        }
    }
    get Any() {
        return Any$1;
    }
}

var Any$2 = /*#__PURE__*/Object.freeze({
    __proto__: null,
    packageName: packageName$1c,
    moduleAddress: moduleAddress$1c,
    moduleName: moduleName$1c,
    ETYPE_MISMATCH: ETYPE_MISMATCH$1,
    Any: Any$1,
    pack_: pack_$1,
    type_name_: type_name_$1,
    unpack_: unpack_$1,
    loadParsers: loadParsers$1p,
    App: App$1q
});

const packageName$1b = 'AptosFramework';
const moduleAddress$1b = new HexString('0x1');
const moduleName$1b = 'optional_aggregator';
const EAGGREGATOR_OVERFLOW = u64('1');
const EAGGREGATOR_UNDERFLOW = u64('2');
class Integer {
    constructor(proto, typeTag) {
        this.typeTag = typeTag;
        this.__app = null;
        this.value = proto['value'];
        this.limit = proto['limit'];
    }
    static IntegerParser(data, typeTag, repo) {
        const proto = $.parseStructProto(data, typeTag, repo, Integer);
        return new Integer(proto, typeTag);
    }
    static getTag() {
        return new StructTag(moduleAddress$1b, moduleName$1b, 'Integer', []);
    }
    loadFullState(app) {
        return __awaiter(this, void 0, void 0, function* () {
            this.__app = app;
        });
    }
}
Integer.moduleAddress = moduleAddress$1b;
Integer.moduleName = moduleName$1b;
Integer.structName = 'Integer';
Integer.typeParameters = [];
Integer.fields = [
    { name: 'value', typeTag: AtomicTypeTag.U128 },
    { name: 'limit', typeTag: AtomicTypeTag.U128 }
];
class OptionalAggregator {
    constructor(proto, typeTag) {
        this.typeTag = typeTag;
        this.__app = null;
        this.aggregator = proto['aggregator'];
        this.integer = proto['integer'];
    }
    static OptionalAggregatorParser(data, typeTag, repo) {
        const proto = $.parseStructProto(data, typeTag, repo, OptionalAggregator);
        return new OptionalAggregator(proto, typeTag);
    }
    static getTag() {
        return new StructTag(moduleAddress$1b, moduleName$1b, 'OptionalAggregator', []);
    }
    loadFullState(app) {
        return __awaiter(this, void 0, void 0, function* () {
            yield this.aggregator.loadFullState(app);
            yield this.integer.loadFullState(app);
            this.__app = app;
        });
    }
}
OptionalAggregator.moduleAddress = moduleAddress$1b;
OptionalAggregator.moduleName = moduleName$1b;
OptionalAggregator.structName = 'OptionalAggregator';
OptionalAggregator.typeParameters = [];
OptionalAggregator.fields = [
    {
        name: 'aggregator',
        typeTag: new StructTag(new HexString('0x1'), 'option', 'Option', [
            new StructTag(new HexString('0x1'), 'aggregator', 'Aggregator', [])
        ])
    },
    {
        name: 'integer',
        typeTag: new StructTag(new HexString('0x1'), 'option', 'Option', [
            new StructTag(new HexString('0x1'), 'optional_aggregator', 'Integer', [])
        ])
    }
];
function add_$5(optional_aggregator, value, $c) {
    let aggregator, integer;
    if (is_some_(optional_aggregator.aggregator, $c, [
        new StructTag(new HexString('0x1'), 'aggregator', 'Aggregator', [])
    ])) {
        aggregator = borrow_mut_$6(optional_aggregator.aggregator, $c, [
            new StructTag(new HexString('0x1'), 'aggregator', 'Aggregator', [])
        ]);
        add_$6(aggregator, $.copy(value), $c);
    }
    else {
        integer = borrow_mut_$6(optional_aggregator.integer, $c, [new SimpleStructTag(Integer)]);
        add_integer_(integer, $.copy(value));
    }
    return;
}
function add_integer_(integer, value, $c) {
    if (!$.copy(value).le($.copy(integer.limit).sub($.copy(integer.value)))) {
        throw $.abortCode(out_of_range_($.copy(EAGGREGATOR_OVERFLOW)));
    }
    integer.value = $.copy(integer.value).add($.copy(value));
    return;
}
function destroy_(optional_aggregator, $c) {
    if (is_parallelizable_(optional_aggregator, $c)) {
        destroy_optional_aggregator_(optional_aggregator, $c);
    }
    else {
        destroy_optional_integer_(optional_aggregator, $c);
    }
    return;
}
function destroy_integer_(integer, $c) {
    return;
}
function destroy_optional_aggregator_(optional_aggregator, $c) {
    let limit;
    let { aggregator: aggregator, integer: integer } = optional_aggregator;
    limit = limit_$1(borrow_$6(aggregator, $c, [new StructTag(new HexString('0x1'), 'aggregator', 'Aggregator', [])]));
    destroy_$1(destroy_some_(aggregator, $c, [new StructTag(new HexString('0x1'), 'aggregator', 'Aggregator', [])]), $c);
    destroy_none_(integer, $c, [new SimpleStructTag(Integer)]);
    return $.copy(limit);
}
function destroy_optional_integer_(optional_aggregator, $c) {
    let limit;
    let { aggregator: aggregator, integer: integer } = optional_aggregator;
    limit = limit_(borrow_$6(integer, $c, [new SimpleStructTag(Integer)]));
    destroy_integer_(destroy_some_(integer, $c, [new SimpleStructTag(Integer)]));
    destroy_none_(aggregator, $c, [new StructTag(new HexString('0x1'), 'aggregator', 'Aggregator', [])]);
    return $.copy(limit);
}
function is_parallelizable_(optional_aggregator, $c) {
    return is_some_(optional_aggregator.aggregator, $c, [
        new StructTag(new HexString('0x1'), 'aggregator', 'Aggregator', [])
    ]);
}
function limit_(integer, $c) {
    return $.copy(integer.limit);
}
function new___$4(limit, parallelizable, $c) {
    let temp$1;
    if (parallelizable) {
        temp$1 = new OptionalAggregator({
            aggregator: some_(create_aggregator_internal_($.copy(limit), $c), $c, [
                new StructTag(new HexString('0x1'), 'aggregator', 'Aggregator', [])
            ]),
            integer: none_($c, [new SimpleStructTag(Integer)])
        }, new SimpleStructTag(OptionalAggregator));
    }
    else {
        temp$1 = new OptionalAggregator({
            aggregator: none_($c, [new StructTag(new HexString('0x1'), 'aggregator', 'Aggregator', [])]),
            integer: some_(new_integer_($.copy(limit)), $c, [new SimpleStructTag(Integer)])
        }, new SimpleStructTag(OptionalAggregator));
    }
    return temp$1;
}
function new_integer_(limit, $c) {
    return new Integer({ value: u128('0'), limit: $.copy(limit) }, new SimpleStructTag(Integer));
}
function read_(optional_aggregator, $c) {
    let temp$1, aggregator, integer;
    if (is_some_(optional_aggregator.aggregator, $c, [
        new StructTag(new HexString('0x1'), 'aggregator', 'Aggregator', [])
    ])) {
        aggregator = borrow_$6(optional_aggregator.aggregator, $c, [
            new StructTag(new HexString('0x1'), 'aggregator', 'Aggregator', [])
        ]);
        temp$1 = read_$1(aggregator, $c);
    }
    else {
        integer = borrow_$6(optional_aggregator.integer, $c, [new SimpleStructTag(Integer)]);
        temp$1 = read_integer_(integer);
    }
    return temp$1;
}
function read_integer_(integer, $c) {
    return $.copy(integer.value);
}
function sub_$1(optional_aggregator, value, $c) {
    let aggregator, integer;
    if (is_some_(optional_aggregator.aggregator, $c, [
        new StructTag(new HexString('0x1'), 'aggregator', 'Aggregator', [])
    ])) {
        aggregator = borrow_mut_$6(optional_aggregator.aggregator, $c, [
            new StructTag(new HexString('0x1'), 'aggregator', 'Aggregator', [])
        ]);
        sub_$2(aggregator, $.copy(value), $c);
    }
    else {
        integer = borrow_mut_$6(optional_aggregator.integer, $c, [new SimpleStructTag(Integer)]);
        sub_integer_(integer, $.copy(value));
    }
    return;
}
function sub_integer_(integer, value, $c) {
    if (!$.copy(value).le($.copy(integer.value))) {
        throw $.abortCode(out_of_range_($.copy(EAGGREGATOR_UNDERFLOW)));
    }
    integer.value = $.copy(integer.value).sub($.copy(value));
    return;
}
function switch_(optional_aggregator, $c) {
    let value;
    value = read_(optional_aggregator, $c);
    switch_and_zero_out_(optional_aggregator, $c);
    add_$5(optional_aggregator, $.copy(value), $c);
    return;
}
function switch_and_zero_out_(optional_aggregator, $c) {
    if (is_parallelizable_(optional_aggregator, $c)) {
        switch_to_integer_and_zero_out_(optional_aggregator, $c);
    }
    else {
        switch_to_aggregator_and_zero_out_(optional_aggregator, $c);
    }
    return;
}
function switch_to_aggregator_and_zero_out_(optional_aggregator, $c) {
    let aggregator, integer, limit;
    integer = extract_$1(optional_aggregator.integer, $c, [new SimpleStructTag(Integer)]);
    limit = limit_(integer);
    aggregator = create_aggregator_internal_($.copy(limit), $c);
    fill_(optional_aggregator.aggregator, aggregator, $c, [
        new StructTag(new HexString('0x1'), 'aggregator', 'Aggregator', [])
    ]);
    return $.copy(limit);
}
function switch_to_integer_and_zero_out_(optional_aggregator, $c) {
    let aggregator, integer, limit;
    aggregator = extract_$1(optional_aggregator.aggregator, $c, [
        new StructTag(new HexString('0x1'), 'aggregator', 'Aggregator', [])
    ]);
    limit = limit_$1(aggregator);
    destroy_$1(aggregator, $c);
    integer = new_integer_($.copy(limit));
    fill_(optional_aggregator.integer, integer, $c, [new SimpleStructTag(Integer)]);
    return $.copy(limit);
}
function loadParsers$1o(repo) {
    repo.addParser('0x1::optional_aggregator::Integer', Integer.IntegerParser);
    repo.addParser('0x1::optional_aggregator::OptionalAggregator', OptionalAggregator.OptionalAggregatorParser);
}
class App$1p {
    constructor(client, repo, cache) {
        this.client = client;
        this.repo = repo;
        this.cache = cache;
    }
    get moduleAddress() {
        {
            return moduleAddress$1b;
        }
    }
    get moduleName() {
        {
            return moduleName$1b;
        }
    }
    get Integer() {
        return Integer;
    }
    get OptionalAggregator() {
        return OptionalAggregator;
    }
}

var Optional_aggregator = /*#__PURE__*/Object.freeze({
    __proto__: null,
    packageName: packageName$1b,
    moduleAddress: moduleAddress$1b,
    moduleName: moduleName$1b,
    EAGGREGATOR_OVERFLOW: EAGGREGATOR_OVERFLOW,
    EAGGREGATOR_UNDERFLOW: EAGGREGATOR_UNDERFLOW,
    Integer: Integer,
    OptionalAggregator: OptionalAggregator,
    add_: add_$5,
    add_integer_: add_integer_,
    destroy_: destroy_,
    destroy_integer_: destroy_integer_,
    destroy_optional_aggregator_: destroy_optional_aggregator_,
    destroy_optional_integer_: destroy_optional_integer_,
    is_parallelizable_: is_parallelizable_,
    limit_: limit_,
    new___: new___$4,
    new_integer_: new_integer_,
    read_: read_,
    read_integer_: read_integer_,
    sub_: sub_$1,
    sub_integer_: sub_integer_,
    switch_: switch_,
    switch_and_zero_out_: switch_and_zero_out_,
    switch_to_aggregator_and_zero_out_: switch_to_aggregator_and_zero_out_,
    switch_to_integer_and_zero_out_: switch_to_integer_and_zero_out_,
    loadParsers: loadParsers$1o,
    App: App$1p
});

const packageName$1a = 'AptosFramework';
const moduleAddress$1a = new HexString('0x1');
const moduleName$1a = 'coin';
const ECOIN_INFO_ADDRESS_MISMATCH = u64('1');
const ECOIN_INFO_ALREADY_PUBLISHED = u64('2');
const ECOIN_INFO_NOT_PUBLISHED = u64('3');
const ECOIN_NAME_TOO_LONG = u64('12');
const ECOIN_STORE_ALREADY_PUBLISHED = u64('4');
const ECOIN_STORE_NOT_PUBLISHED = u64('5');
const ECOIN_SUPPLY_UPGRADE_NOT_SUPPORTED = u64('11');
const ECOIN_SYMBOL_TOO_LONG = u64('13');
const EDESTRUCTION_OF_NONZERO_TOKEN = u64('7');
const EFROZEN = u64('10');
const EINSUFFICIENT_BALANCE = u64('6');
const EZERO_COIN_AMOUNT = u64('9');
const MAX_COIN_NAME_LENGTH = u64('32');
const MAX_COIN_SYMBOL_LENGTH = u64('10');
const MAX_U128$1 = u128('340282366920938463463374607431768211455');
class BurnCapability {
    constructor(proto, typeTag) {
        this.typeTag = typeTag;
        this.__app = null;
    }
    static BurnCapabilityParser(data, typeTag, repo) {
        const proto = $.parseStructProto(data, typeTag, repo, BurnCapability);
        return new BurnCapability(proto, typeTag);
    }
    static makeTag($p) {
        return new StructTag(moduleAddress$1a, moduleName$1a, 'BurnCapability', $p);
    }
    loadFullState(app) {
        return __awaiter(this, void 0, void 0, function* () {
            this.__app = app;
        });
    }
}
BurnCapability.moduleAddress = moduleAddress$1a;
BurnCapability.moduleName = moduleName$1a;
BurnCapability.structName = 'BurnCapability';
BurnCapability.typeParameters = [{ name: 'CoinType', isPhantom: true }];
BurnCapability.fields = [];
class Coin {
    constructor(proto, typeTag) {
        this.typeTag = typeTag;
        this.__app = null;
        this.value = proto['value'];
    }
    static CoinParser(data, typeTag, repo) {
        const proto = $.parseStructProto(data, typeTag, repo, Coin);
        return new Coin(proto, typeTag);
    }
    static makeTag($p) {
        return new StructTag(moduleAddress$1a, moduleName$1a, 'Coin', $p);
    }
    loadFullState(app) {
        return __awaiter(this, void 0, void 0, function* () {
            this.__app = app;
        });
    }
}
Coin.moduleAddress = moduleAddress$1a;
Coin.moduleName = moduleName$1a;
Coin.structName = 'Coin';
Coin.typeParameters = [{ name: 'CoinType', isPhantom: true }];
Coin.fields = [{ name: 'value', typeTag: AtomicTypeTag.U64 }];
class CoinInfo$1 {
    constructor(proto, typeTag) {
        this.typeTag = typeTag;
        this.__app = null;
        this.name = proto['name'];
        this.symbol = proto['symbol'];
        this.decimals = proto['decimals'];
        this.supply = proto['supply'];
    }
    static CoinInfoParser(data, typeTag, repo) {
        const proto = $.parseStructProto(data, typeTag, repo, CoinInfo$1);
        return new CoinInfo$1(proto, typeTag);
    }
    static load(repo, client, address, typeParams) {
        return __awaiter(this, void 0, void 0, function* () {
            const result = yield repo.loadResource(client, address, CoinInfo$1, typeParams);
            return result;
        });
    }
    static loadByApp(app, address, typeParams) {
        return __awaiter(this, void 0, void 0, function* () {
            const result = yield app.repo.loadResource(app.client, address, CoinInfo$1, typeParams);
            yield result.loadFullState(app);
            return result;
        });
    }
    static makeTag($p) {
        return new StructTag(moduleAddress$1a, moduleName$1a, 'CoinInfo', $p);
    }
    loadFullState(app) {
        return __awaiter(this, void 0, void 0, function* () {
            yield this.name.loadFullState(app);
            yield this.symbol.loadFullState(app);
            yield this.supply.loadFullState(app);
            this.__app = app;
        });
    }
}
CoinInfo$1.moduleAddress = moduleAddress$1a;
CoinInfo$1.moduleName = moduleName$1a;
CoinInfo$1.structName = 'CoinInfo';
CoinInfo$1.typeParameters = [{ name: 'CoinType', isPhantom: true }];
CoinInfo$1.fields = [
    { name: 'name', typeTag: new StructTag(new HexString('0x1'), 'string', 'String', []) },
    { name: 'symbol', typeTag: new StructTag(new HexString('0x1'), 'string', 'String', []) },
    { name: 'decimals', typeTag: AtomicTypeTag.U8 },
    {
        name: 'supply',
        typeTag: new StructTag(new HexString('0x1'), 'option', 'Option', [
            new StructTag(new HexString('0x1'), 'optional_aggregator', 'OptionalAggregator', [])
        ])
    }
];
class CoinStore$1 {
    constructor(proto, typeTag) {
        this.typeTag = typeTag;
        this.__app = null;
        this.coin = proto['coin'];
        this.frozen = proto['frozen'];
        this.deposit_events = proto['deposit_events'];
        this.withdraw_events = proto['withdraw_events'];
    }
    static CoinStoreParser(data, typeTag, repo) {
        const proto = $.parseStructProto(data, typeTag, repo, CoinStore$1);
        return new CoinStore$1(proto, typeTag);
    }
    static load(repo, client, address, typeParams) {
        return __awaiter(this, void 0, void 0, function* () {
            const result = yield repo.loadResource(client, address, CoinStore$1, typeParams);
            return result;
        });
    }
    static loadByApp(app, address, typeParams) {
        return __awaiter(this, void 0, void 0, function* () {
            const result = yield app.repo.loadResource(app.client, address, CoinStore$1, typeParams);
            yield result.loadFullState(app);
            return result;
        });
    }
    static makeTag($p) {
        return new StructTag(moduleAddress$1a, moduleName$1a, 'CoinStore', $p);
    }
    loadFullState(app) {
        return __awaiter(this, void 0, void 0, function* () {
            yield this.coin.loadFullState(app);
            yield this.deposit_events.loadFullState(app);
            yield this.withdraw_events.loadFullState(app);
            this.__app = app;
        });
    }
}
CoinStore$1.moduleAddress = moduleAddress$1a;
CoinStore$1.moduleName = moduleName$1a;
CoinStore$1.structName = 'CoinStore';
CoinStore$1.typeParameters = [{ name: 'CoinType', isPhantom: true }];
CoinStore$1.fields = [
    { name: 'coin', typeTag: new StructTag(new HexString('0x1'), 'coin', 'Coin', [new $.TypeParamIdx(0)]) },
    { name: 'frozen', typeTag: AtomicTypeTag.Bool },
    {
        name: 'deposit_events',
        typeTag: new StructTag(new HexString('0x1'), 'event', 'EventHandle', [
            new StructTag(new HexString('0x1'), 'coin', 'DepositEvent', [])
        ])
    },
    {
        name: 'withdraw_events',
        typeTag: new StructTag(new HexString('0x1'), 'event', 'EventHandle', [
            new StructTag(new HexString('0x1'), 'coin', 'WithdrawEvent', [])
        ])
    }
];
class DepositEvent {
    constructor(proto, typeTag) {
        this.typeTag = typeTag;
        this.__app = null;
        this.amount = proto['amount'];
    }
    static DepositEventParser(data, typeTag, repo) {
        const proto = $.parseStructProto(data, typeTag, repo, DepositEvent);
        return new DepositEvent(proto, typeTag);
    }
    static getTag() {
        return new StructTag(moduleAddress$1a, moduleName$1a, 'DepositEvent', []);
    }
    loadFullState(app) {
        return __awaiter(this, void 0, void 0, function* () {
            this.__app = app;
        });
    }
}
DepositEvent.moduleAddress = moduleAddress$1a;
DepositEvent.moduleName = moduleName$1a;
DepositEvent.structName = 'DepositEvent';
DepositEvent.typeParameters = [];
DepositEvent.fields = [{ name: 'amount', typeTag: AtomicTypeTag.U64 }];
class FreezeCapability {
    constructor(proto, typeTag) {
        this.typeTag = typeTag;
        this.__app = null;
    }
    static FreezeCapabilityParser(data, typeTag, repo) {
        const proto = $.parseStructProto(data, typeTag, repo, FreezeCapability);
        return new FreezeCapability(proto, typeTag);
    }
    static makeTag($p) {
        return new StructTag(moduleAddress$1a, moduleName$1a, 'FreezeCapability', $p);
    }
    loadFullState(app) {
        return __awaiter(this, void 0, void 0, function* () {
            this.__app = app;
        });
    }
}
FreezeCapability.moduleAddress = moduleAddress$1a;
FreezeCapability.moduleName = moduleName$1a;
FreezeCapability.structName = 'FreezeCapability';
FreezeCapability.typeParameters = [{ name: 'CoinType', isPhantom: true }];
FreezeCapability.fields = [];
class MintCapability {
    constructor(proto, typeTag) {
        this.typeTag = typeTag;
        this.__app = null;
    }
    static MintCapabilityParser(data, typeTag, repo) {
        const proto = $.parseStructProto(data, typeTag, repo, MintCapability);
        return new MintCapability(proto, typeTag);
    }
    static makeTag($p) {
        return new StructTag(moduleAddress$1a, moduleName$1a, 'MintCapability', $p);
    }
    loadFullState(app) {
        return __awaiter(this, void 0, void 0, function* () {
            this.__app = app;
        });
    }
}
MintCapability.moduleAddress = moduleAddress$1a;
MintCapability.moduleName = moduleName$1a;
MintCapability.structName = 'MintCapability';
MintCapability.typeParameters = [{ name: 'CoinType', isPhantom: true }];
MintCapability.fields = [];
class SupplyConfig {
    constructor(proto, typeTag) {
        this.typeTag = typeTag;
        this.__app = null;
        this.allow_upgrades = proto['allow_upgrades'];
    }
    static SupplyConfigParser(data, typeTag, repo) {
        const proto = $.parseStructProto(data, typeTag, repo, SupplyConfig);
        return new SupplyConfig(proto, typeTag);
    }
    static load(repo, client, address, typeParams) {
        return __awaiter(this, void 0, void 0, function* () {
            const result = yield repo.loadResource(client, address, SupplyConfig, typeParams);
            return result;
        });
    }
    static loadByApp(app, address, typeParams) {
        return __awaiter(this, void 0, void 0, function* () {
            const result = yield app.repo.loadResource(app.client, address, SupplyConfig, typeParams);
            yield result.loadFullState(app);
            return result;
        });
    }
    static getTag() {
        return new StructTag(moduleAddress$1a, moduleName$1a, 'SupplyConfig', []);
    }
    loadFullState(app) {
        return __awaiter(this, void 0, void 0, function* () {
            this.__app = app;
        });
    }
}
SupplyConfig.moduleAddress = moduleAddress$1a;
SupplyConfig.moduleName = moduleName$1a;
SupplyConfig.structName = 'SupplyConfig';
SupplyConfig.typeParameters = [];
SupplyConfig.fields = [{ name: 'allow_upgrades', typeTag: AtomicTypeTag.Bool }];
class WithdrawEvent {
    constructor(proto, typeTag) {
        this.typeTag = typeTag;
        this.__app = null;
        this.amount = proto['amount'];
    }
    static WithdrawEventParser(data, typeTag, repo) {
        const proto = $.parseStructProto(data, typeTag, repo, WithdrawEvent);
        return new WithdrawEvent(proto, typeTag);
    }
    static getTag() {
        return new StructTag(moduleAddress$1a, moduleName$1a, 'WithdrawEvent', []);
    }
    loadFullState(app) {
        return __awaiter(this, void 0, void 0, function* () {
            this.__app = app;
        });
    }
}
WithdrawEvent.moduleAddress = moduleAddress$1a;
WithdrawEvent.moduleName = moduleName$1a;
WithdrawEvent.structName = 'WithdrawEvent';
WithdrawEvent.typeParameters = [];
WithdrawEvent.fields = [{ name: 'amount', typeTag: AtomicTypeTag.U64 }];
function allow_supply_upgrades_(aptos_framework, allowed, $c) {
    let allow_upgrades;
    assert_aptos_framework_(aptos_framework, $c);
    allow_upgrades = $c.borrow_global_mut(new SimpleStructTag(SupplyConfig), new HexString('0x1')).allow_upgrades;
    $.set(allow_upgrades, allowed);
    return;
}
function balance_$1(owner, $c, $p /* <CoinType>*/) {
    if (!is_account_registered_($.copy(owner), $c, [$p[0]])) {
        throw $.abortCode(not_found_($.copy(ECOIN_STORE_NOT_PUBLISHED)));
    }
    return $.copy($c.borrow_global(new SimpleStructTag(CoinStore$1, [$p[0]]), $.copy(owner)).coin.value);
}
function burn_$3(coin, _cap, $c, $p /* <CoinType>*/) {
    let maybe_supply, supply;
    let { value: amount } = coin;
    if (!$.copy(amount).gt(u64('0'))) {
        throw $.abortCode(invalid_argument_($.copy(EZERO_COIN_AMOUNT)));
    }
    maybe_supply = $c.borrow_global_mut(new SimpleStructTag(CoinInfo$1, [$p[0]]), coin_address_($c, [$p[0]])).supply;
    if (is_some_(maybe_supply, $c, [
        new StructTag(new HexString('0x1'), 'optional_aggregator', 'OptionalAggregator', [])
    ])) {
        supply = borrow_mut_$6(maybe_supply, $c, [
            new StructTag(new HexString('0x1'), 'optional_aggregator', 'OptionalAggregator', [])
        ]);
        sub_$1(supply, u128($.copy(amount)), $c);
    }
    return;
}
function burn_from_(account_addr, amount, burn_cap, $c, $p /* <CoinType>*/) {
    let coin_store, coin_to_burn;
    if ($.copy(amount).eq(u64('0'))) {
        return;
    }
    coin_store = $c.borrow_global_mut(new SimpleStructTag(CoinStore$1, [$p[0]]), $.copy(account_addr));
    coin_to_burn = extract_(coin_store.coin, $.copy(amount), $c, [$p[0]]);
    burn_$3(coin_to_burn, burn_cap, $c, [$p[0]]);
    return;
}
function coin_address_($c, $p /* <CoinType>*/) {
    let type_info;
    type_info = type_of_($c, [$p[0]]);
    return account_address_(type_info);
}
function decimals_($c, $p /* <CoinType>*/) {
    return $.copy($c.borrow_global(new SimpleStructTag(CoinInfo$1, [$p[0]]), coin_address_($c, [$p[0]])).decimals);
}
function deposit_$1(account_addr, coin, $c, $p /* <CoinType>*/) {
    let coin_store;
    if (!is_account_registered_($.copy(account_addr), $c, [$p[0]])) {
        throw $.abortCode(not_found_($.copy(ECOIN_STORE_NOT_PUBLISHED)));
    }
    coin_store = $c.borrow_global_mut(new SimpleStructTag(CoinStore$1, [$p[0]]), $.copy(account_addr));
    if (!!$.copy(coin_store.frozen)) {
        throw $.abortCode(permission_denied_($.copy(EFROZEN)));
    }
    emit_event_(coin_store.deposit_events, new DepositEvent({ amount: $.copy(coin.value) }, new SimpleStructTag(DepositEvent)), $c, [new SimpleStructTag(DepositEvent)]);
    merge_(coin_store.coin, coin, $c, [$p[0]]);
    return;
}
function destroy_burn_cap_(burn_cap, $c, $p /* <CoinType>*/) {
    $.copy(burn_cap);
    return;
}
function destroy_freeze_cap_(freeze_cap, $c, $p /* <CoinType>*/) {
    $.copy(freeze_cap);
    return;
}
function destroy_mint_cap_$1(mint_cap, $c, $p /* <CoinType>*/) {
    $.copy(mint_cap);
    return;
}
function destroy_zero_(zero_coin, $c, $p /* <CoinType>*/) {
    let { value: value } = zero_coin;
    if (!$.copy(value).eq(u64('0'))) {
        throw $.abortCode(invalid_argument_($.copy(EDESTRUCTION_OF_NONZERO_TOKEN)));
    }
    return;
}
function extract_(coin, amount, $c, $p /* <CoinType>*/) {
    if (!$.copy(coin.value).ge($.copy(amount))) {
        throw $.abortCode(invalid_argument_($.copy(EINSUFFICIENT_BALANCE)));
    }
    coin.value = $.copy(coin.value).sub($.copy(amount));
    return new Coin({ value: $.copy(amount) }, new SimpleStructTag(Coin, [$p[0]]));
}
function extract_all_(coin, $c, $p /* <CoinType>*/) {
    let total_value;
    total_value = $.copy(coin.value);
    coin.value = u64('0');
    return new Coin({ value: $.copy(total_value) }, new SimpleStructTag(Coin, [$p[0]]));
}
function freeze_coin_store_(account_addr, _freeze_cap, $c, $p /* <CoinType>*/) {
    let coin_store;
    coin_store = $c.borrow_global_mut(new SimpleStructTag(CoinStore$1, [$p[0]]), $.copy(account_addr));
    coin_store.frozen = true;
    return;
}
function initialize_$j(account, name, symbol, decimals, monitor_supply, $c, $p /* <CoinType>*/) {
    return initialize_internal_(account, $.copy(name), $.copy(symbol), $.copy(decimals), monitor_supply, false, $c, [
        $p[0]
    ]);
}
function initialize_internal_(account, name, symbol, decimals, monitor_supply, parallelizable, $c, $p /* <CoinType>*/) {
    let temp$1, temp$2, temp$3, temp$4, account_addr, coin_info;
    account_addr = address_of_(account, $c);
    if (!(coin_address_($c, [$p[0]]).hex() === $.copy(account_addr).hex())) {
        throw $.abortCode(invalid_argument_($.copy(ECOIN_INFO_ADDRESS_MISMATCH)));
    }
    if (!!$c.exists(new SimpleStructTag(CoinInfo$1, [$p[0]]), $.copy(account_addr))) {
        throw $.abortCode(already_exists_($.copy(ECOIN_INFO_ALREADY_PUBLISHED)));
    }
    if (!length_$5(name, $c).le($.copy(MAX_COIN_NAME_LENGTH))) {
        throw $.abortCode(invalid_argument_($.copy(ECOIN_NAME_TOO_LONG)));
    }
    if (!length_$5(symbol, $c).le($.copy(MAX_COIN_SYMBOL_LENGTH))) {
        throw $.abortCode(invalid_argument_($.copy(ECOIN_SYMBOL_TOO_LONG)));
    }
    temp$4 = $.copy(name);
    temp$3 = $.copy(symbol);
    temp$2 = $.copy(decimals);
    if (monitor_supply) {
        temp$1 = some_(new___$4($.copy(MAX_U128$1), parallelizable, $c), $c, [
            new StructTag(new HexString('0x1'), 'optional_aggregator', 'OptionalAggregator', [])
        ]);
    }
    else {
        temp$1 = none_($c, [new StructTag(new HexString('0x1'), 'optional_aggregator', 'OptionalAggregator', [])]);
    }
    coin_info = new CoinInfo$1({ name: temp$4, symbol: temp$3, decimals: temp$2, supply: temp$1 }, new SimpleStructTag(CoinInfo$1, [$p[0]]));
    $c.move_to(new SimpleStructTag(CoinInfo$1, [$p[0]]), account, coin_info);
    return [
        new BurnCapability({}, new SimpleStructTag(BurnCapability, [$p[0]])),
        new FreezeCapability({}, new SimpleStructTag(FreezeCapability, [$p[0]])),
        new MintCapability({}, new SimpleStructTag(MintCapability, [$p[0]]))
    ];
}
function initialize_supply_config_(aptos_framework, $c) {
    assert_aptos_framework_(aptos_framework, $c);
    $c.move_to(new SimpleStructTag(SupplyConfig), aptos_framework, new SupplyConfig({ allow_upgrades: false }, new SimpleStructTag(SupplyConfig)));
    return;
}
function initialize_with_parallelizable_supply_(account, name, symbol, decimals, monitor_supply, $c, $p /* <CoinType>*/) {
    assert_aptos_framework_(account, $c);
    return initialize_internal_(account, $.copy(name), $.copy(symbol), $.copy(decimals), monitor_supply, true, $c, [
        $p[0]
    ]);
}
function is_account_registered_(account_addr, $c, $p /* <CoinType>*/) {
    return $c.exists(new SimpleStructTag(CoinStore$1, [$p[0]]), $.copy(account_addr));
}
function is_coin_initialized_($c, $p /* <CoinType>*/) {
    return $c.exists(new SimpleStructTag(CoinInfo$1, [$p[0]]), coin_address_($c, [$p[0]]));
}
function merge_(dst_coin, source_coin, $c, $p /* <CoinType>*/) {
    dst_coin.value = $.copy(dst_coin.value).add($.copy(source_coin.value));
    return;
}
function mint_$4(amount, _cap, $c, $p /* <CoinType>*/) {
    let maybe_supply, supply;
    if ($.copy(amount).eq(u64('0'))) {
        return zero_$1($c, [$p[0]]);
    }
    maybe_supply = $c.borrow_global_mut(new SimpleStructTag(CoinInfo$1, [$p[0]]), coin_address_($c, [$p[0]])).supply;
    if (is_some_(maybe_supply, $c, [
        new StructTag(new HexString('0x1'), 'optional_aggregator', 'OptionalAggregator', [])
    ])) {
        supply = borrow_mut_$6(maybe_supply, $c, [
            new StructTag(new HexString('0x1'), 'optional_aggregator', 'OptionalAggregator', [])
        ]);
        add_$5(supply, u128($.copy(amount)), $c);
    }
    return new Coin({ value: $.copy(amount) }, new SimpleStructTag(Coin, [$p[0]]));
}
function name_($c, $p /* <CoinType>*/) {
    return $.copy($c.borrow_global(new SimpleStructTag(CoinInfo$1, [$p[0]]), coin_address_($c, [$p[0]])).name);
}
function register_$2(account, $c, $p /* <CoinType>*/) {
    let account_addr, coin_store;
    account_addr = address_of_(account, $c);
    if (!!is_account_registered_($.copy(account_addr), $c, [$p[0]])) {
        throw $.abortCode(already_exists_($.copy(ECOIN_STORE_ALREADY_PUBLISHED)));
    }
    register_coin_($.copy(account_addr), $c, [$p[0]]);
    coin_store = new CoinStore$1({
        coin: new Coin({ value: u64('0') }, new SimpleStructTag(Coin, [$p[0]])),
        frozen: false,
        deposit_events: new_event_handle_(account, $c, [new SimpleStructTag(DepositEvent)]),
        withdraw_events: new_event_handle_(account, $c, [new SimpleStructTag(WithdrawEvent)])
    }, new SimpleStructTag(CoinStore$1, [$p[0]]));
    $c.move_to(new SimpleStructTag(CoinStore$1, [$p[0]]), account, coin_store);
    return;
}
function supply_($c, $p /* <CoinType>*/) {
    let temp$1, maybe_supply, supply, value;
    maybe_supply = $c.borrow_global(new SimpleStructTag(CoinInfo$1, [$p[0]]), coin_address_($c, [$p[0]])).supply;
    if (is_some_(maybe_supply, $c, [
        new StructTag(new HexString('0x1'), 'optional_aggregator', 'OptionalAggregator', [])
    ])) {
        supply = borrow_$6(maybe_supply, $c, [
            new StructTag(new HexString('0x1'), 'optional_aggregator', 'OptionalAggregator', [])
        ]);
        value = read_(supply, $c);
        temp$1 = some_($.copy(value), $c, [AtomicTypeTag.U128]);
    }
    else {
        temp$1 = none_($c, [AtomicTypeTag.U128]);
    }
    return temp$1;
}
function symbol_($c, $p /* <CoinType>*/) {
    return $.copy($c.borrow_global(new SimpleStructTag(CoinInfo$1, [$p[0]]), coin_address_($c, [$p[0]])).symbol);
}
function transfer_$1(from, to, amount, $c, $p /* <CoinType>*/) {
    let coin;
    coin = withdraw_$1(from, $.copy(amount), $c, [$p[0]]);
    deposit_$1($.copy(to), coin, $c, [$p[0]]);
    return;
}
function buildPayload_transfer$1(to, amount, $p /* <CoinType>*/, isJSON = false) {
    const typeParamStrings = $p.map((t) => $.getTypeTagFullname(t));
    return $.buildPayload(new HexString('0x1'), 'coin', 'transfer', typeParamStrings, [to, amount], isJSON);
}
function unfreeze_coin_store_(account_addr, _freeze_cap, $c, $p /* <CoinType>*/) {
    let coin_store;
    coin_store = $c.borrow_global_mut(new SimpleStructTag(CoinStore$1, [$p[0]]), $.copy(account_addr));
    coin_store.frozen = false;
    return;
}
function upgrade_supply_(account, $c, $p /* <CoinType>*/) {
    let account_addr, maybe_supply, supply;
    account_addr = address_of_(account, $c);
    if (!(coin_address_($c, [$p[0]]).hex() === $.copy(account_addr).hex())) {
        throw $.abortCode(invalid_argument_($.copy(ECOIN_INFO_ADDRESS_MISMATCH)));
    }
    if (!$.copy($c.borrow_global_mut(new SimpleStructTag(SupplyConfig), new HexString('0x1')).allow_upgrades)) {
        throw $.abortCode(permission_denied_($.copy(ECOIN_SUPPLY_UPGRADE_NOT_SUPPORTED)));
    }
    maybe_supply = $c.borrow_global_mut(new SimpleStructTag(CoinInfo$1, [$p[0]]), $.copy(account_addr)).supply;
    if (is_some_(maybe_supply, $c, [
        new StructTag(new HexString('0x1'), 'optional_aggregator', 'OptionalAggregator', [])
    ])) {
        supply = borrow_mut_$6(maybe_supply, $c, [
            new StructTag(new HexString('0x1'), 'optional_aggregator', 'OptionalAggregator', [])
        ]);
        if (!is_parallelizable_(supply, $c)) {
            switch_(supply, $c);
        }
    }
    return;
}
function buildPayload_upgrade_supply($p /* <CoinType>*/, isJSON = false) {
    const typeParamStrings = $p.map((t) => $.getTypeTagFullname(t));
    return $.buildPayload(new HexString('0x1'), 'coin', 'upgrade_supply', typeParamStrings, [], isJSON);
}
function value_(coin, $c, $p /* <CoinType>*/) {
    return $.copy(coin.value);
}
function withdraw_$1(account, amount, $c, $p /* <CoinType>*/) {
    let account_addr, coin_store;
    account_addr = address_of_(account, $c);
    if (!is_account_registered_($.copy(account_addr), $c, [$p[0]])) {
        throw $.abortCode(not_found_($.copy(ECOIN_STORE_NOT_PUBLISHED)));
    }
    coin_store = $c.borrow_global_mut(new SimpleStructTag(CoinStore$1, [$p[0]]), $.copy(account_addr));
    if (!!$.copy(coin_store.frozen)) {
        throw $.abortCode(permission_denied_($.copy(EFROZEN)));
    }
    emit_event_(coin_store.withdraw_events, new WithdrawEvent({ amount: $.copy(amount) }, new SimpleStructTag(WithdrawEvent)), $c, [new SimpleStructTag(WithdrawEvent)]);
    return extract_(coin_store.coin, $.copy(amount), $c, [$p[0]]);
}
function zero_$1($c, $p /* <CoinType>*/) {
    return new Coin({ value: u64('0') }, new SimpleStructTag(Coin, [$p[0]]));
}
function loadParsers$1n(repo) {
    repo.addParser('0x1::coin::BurnCapability', BurnCapability.BurnCapabilityParser);
    repo.addParser('0x1::coin::Coin', Coin.CoinParser);
    repo.addParser('0x1::coin::CoinInfo', CoinInfo$1.CoinInfoParser);
    repo.addParser('0x1::coin::CoinStore', CoinStore$1.CoinStoreParser);
    repo.addParser('0x1::coin::DepositEvent', DepositEvent.DepositEventParser);
    repo.addParser('0x1::coin::FreezeCapability', FreezeCapability.FreezeCapabilityParser);
    repo.addParser('0x1::coin::MintCapability', MintCapability.MintCapabilityParser);
    repo.addParser('0x1::coin::SupplyConfig', SupplyConfig.SupplyConfigParser);
    repo.addParser('0x1::coin::WithdrawEvent', WithdrawEvent.WithdrawEventParser);
}
class App$1o {
    constructor(client, repo, cache) {
        this.client = client;
        this.repo = repo;
        this.cache = cache;
    }
    get moduleAddress() {
        {
            return moduleAddress$1a;
        }
    }
    get moduleName() {
        {
            return moduleName$1a;
        }
    }
    get BurnCapability() {
        return BurnCapability;
    }
    get Coin() {
        return Coin;
    }
    get CoinInfo() {
        return CoinInfo$1;
    }
    loadCoinInfo(owner, $p /* <CoinType> */, loadFull = true, fillCache = true) {
        return __awaiter(this, void 0, void 0, function* () {
            const val = yield CoinInfo$1.load(this.repo, this.client, owner, $p);
            if (loadFull) {
                yield val.loadFullState(this);
            }
            if (fillCache) {
                this.cache.set(val.typeTag, owner, val);
            }
            return val;
        });
    }
    get CoinStore() {
        return CoinStore$1;
    }
    loadCoinStore(owner, $p /* <CoinType> */, loadFull = true, fillCache = true) {
        return __awaiter(this, void 0, void 0, function* () {
            const val = yield CoinStore$1.load(this.repo, this.client, owner, $p);
            if (loadFull) {
                yield val.loadFullState(this);
            }
            if (fillCache) {
                this.cache.set(val.typeTag, owner, val);
            }
            return val;
        });
    }
    get DepositEvent() {
        return DepositEvent;
    }
    get FreezeCapability() {
        return FreezeCapability;
    }
    get MintCapability() {
        return MintCapability;
    }
    get SupplyConfig() {
        return SupplyConfig;
    }
    loadSupplyConfig(owner, loadFull = true, fillCache = true) {
        return __awaiter(this, void 0, void 0, function* () {
            const val = yield SupplyConfig.load(this.repo, this.client, owner, []);
            if (loadFull) {
                yield val.loadFullState(this);
            }
            if (fillCache) {
                this.cache.set(val.typeTag, owner, val);
            }
            return val;
        });
    }
    get WithdrawEvent() {
        return WithdrawEvent;
    }
    payload_transfer(to, amount, $p /* <CoinType>*/, isJSON = false) {
        return buildPayload_transfer$1(to, amount, $p, isJSON);
    }
    transfer(_account, to, amount, $p /* <CoinType>*/, option, _isJSON = false) {
        return __awaiter(this, void 0, void 0, function* () {
            const payload__ = buildPayload_transfer$1(to, amount, $p, _isJSON);
            return $.sendPayloadTx(this.client, _account, payload__, option);
        });
    }
    payload_upgrade_supply($p /* <CoinType>*/, isJSON = false) {
        return buildPayload_upgrade_supply($p, isJSON);
    }
    upgrade_supply(_account, $p /* <CoinType>*/, option, _isJSON = false) {
        return __awaiter(this, void 0, void 0, function* () {
            const payload__ = buildPayload_upgrade_supply($p, _isJSON);
            return $.sendPayloadTx(this.client, _account, payload__, option);
        });
    }
}

var Coin$1 = /*#__PURE__*/Object.freeze({
    __proto__: null,
    packageName: packageName$1a,
    moduleAddress: moduleAddress$1a,
    moduleName: moduleName$1a,
    ECOIN_INFO_ADDRESS_MISMATCH: ECOIN_INFO_ADDRESS_MISMATCH,
    ECOIN_INFO_ALREADY_PUBLISHED: ECOIN_INFO_ALREADY_PUBLISHED,
    ECOIN_INFO_NOT_PUBLISHED: ECOIN_INFO_NOT_PUBLISHED,
    ECOIN_NAME_TOO_LONG: ECOIN_NAME_TOO_LONG,
    ECOIN_STORE_ALREADY_PUBLISHED: ECOIN_STORE_ALREADY_PUBLISHED,
    ECOIN_STORE_NOT_PUBLISHED: ECOIN_STORE_NOT_PUBLISHED,
    ECOIN_SUPPLY_UPGRADE_NOT_SUPPORTED: ECOIN_SUPPLY_UPGRADE_NOT_SUPPORTED,
    ECOIN_SYMBOL_TOO_LONG: ECOIN_SYMBOL_TOO_LONG,
    EDESTRUCTION_OF_NONZERO_TOKEN: EDESTRUCTION_OF_NONZERO_TOKEN,
    EFROZEN: EFROZEN,
    EINSUFFICIENT_BALANCE: EINSUFFICIENT_BALANCE,
    EZERO_COIN_AMOUNT: EZERO_COIN_AMOUNT,
    MAX_COIN_NAME_LENGTH: MAX_COIN_NAME_LENGTH,
    MAX_COIN_SYMBOL_LENGTH: MAX_COIN_SYMBOL_LENGTH,
    MAX_U128: MAX_U128$1,
    BurnCapability: BurnCapability,
    Coin: Coin,
    CoinInfo: CoinInfo$1,
    CoinStore: CoinStore$1,
    DepositEvent: DepositEvent,
    FreezeCapability: FreezeCapability,
    MintCapability: MintCapability,
    SupplyConfig: SupplyConfig,
    WithdrawEvent: WithdrawEvent,
    allow_supply_upgrades_: allow_supply_upgrades_,
    balance_: balance_$1,
    burn_: burn_$3,
    burn_from_: burn_from_,
    coin_address_: coin_address_,
    decimals_: decimals_,
    deposit_: deposit_$1,
    destroy_burn_cap_: destroy_burn_cap_,
    destroy_freeze_cap_: destroy_freeze_cap_,
    destroy_mint_cap_: destroy_mint_cap_$1,
    destroy_zero_: destroy_zero_,
    extract_: extract_,
    extract_all_: extract_all_,
    freeze_coin_store_: freeze_coin_store_,
    initialize_: initialize_$j,
    initialize_internal_: initialize_internal_,
    initialize_supply_config_: initialize_supply_config_,
    initialize_with_parallelizable_supply_: initialize_with_parallelizable_supply_,
    is_account_registered_: is_account_registered_,
    is_coin_initialized_: is_coin_initialized_,
    merge_: merge_,
    mint_: mint_$4,
    name_: name_,
    register_: register_$2,
    supply_: supply_,
    symbol_: symbol_,
    transfer_: transfer_$1,
    buildPayload_transfer: buildPayload_transfer$1,
    unfreeze_coin_store_: unfreeze_coin_store_,
    upgrade_supply_: upgrade_supply_,
    buildPayload_upgrade_supply: buildPayload_upgrade_supply,
    value_: value_,
    withdraw_: withdraw_$1,
    zero_: zero_$1,
    loadParsers: loadParsers$1n,
    App: App$1o
});

const packageName$19 = 'AptosFramework';
const moduleAddress$19 = new HexString('0x1');
const moduleName$19 = 'aptos_account';
const EACCOUNT_NOT_FOUND = u64('1');
const EACCOUNT_NOT_REGISTERED_FOR_APT = u64('2');
function assert_account_exists_(addr, $c) {
    if (!exists_at_($.copy(addr), $c)) {
        throw $.abortCode(not_found_($.copy(EACCOUNT_NOT_FOUND)));
    }
    return;
}
function assert_account_is_registered_for_apt_(addr, $c) {
    assert_account_exists_($.copy(addr), $c);
    if (!is_account_registered_($.copy(addr), $c, [new StructTag(new HexString('0x1'), 'aptos_coin', 'AptosCoin', [])])) {
        throw $.abortCode(not_found_($.copy(EACCOUNT_NOT_REGISTERED_FOR_APT)));
    }
    return;
}
function create_account_$1(auth_key, $c) {
    let signer;
    signer = create_account_$2($.copy(auth_key), $c);
    register_$2(signer, $c, [new StructTag(new HexString('0x1'), 'aptos_coin', 'AptosCoin', [])]);
    return;
}
function buildPayload_create_account(auth_key, isJSON = false) {
    const typeParamStrings = [];
    return $.buildPayload(new HexString('0x1'), 'aptos_account', 'create_account', typeParamStrings, [auth_key], isJSON);
}
function transfer_(source, to, amount, $c) {
    if (!exists_at_($.copy(to), $c)) {
        create_account_$1($.copy(to), $c);
    }
    return transfer_$1(source, $.copy(to), $.copy(amount), $c, [
        new StructTag(new HexString('0x1'), 'aptos_coin', 'AptosCoin', [])
    ]);
}
function buildPayload_transfer(to, amount, isJSON = false) {
    const typeParamStrings = [];
    return $.buildPayload(new HexString('0x1'), 'aptos_account', 'transfer', typeParamStrings, [to, amount], isJSON);
}
function loadParsers$1m(repo) { }
class App$1n {
    constructor(client, repo, cache) {
        this.client = client;
        this.repo = repo;
        this.cache = cache;
    }
    get moduleAddress() {
        {
            return moduleAddress$19;
        }
    }
    get moduleName() {
        {
            return moduleName$19;
        }
    }
    payload_create_account(auth_key, isJSON = false) {
        return buildPayload_create_account(auth_key, isJSON);
    }
    create_account(_account, auth_key, option, _isJSON = false) {
        return __awaiter(this, void 0, void 0, function* () {
            const payload__ = buildPayload_create_account(auth_key, _isJSON);
            return $.sendPayloadTx(this.client, _account, payload__, option);
        });
    }
    payload_transfer(to, amount, isJSON = false) {
        return buildPayload_transfer(to, amount, isJSON);
    }
    transfer(_account, to, amount, option, _isJSON = false) {
        return __awaiter(this, void 0, void 0, function* () {
            const payload__ = buildPayload_transfer(to, amount, _isJSON);
            return $.sendPayloadTx(this.client, _account, payload__, option);
        });
    }
}

var Aptos_account = /*#__PURE__*/Object.freeze({
    __proto__: null,
    packageName: packageName$19,
    moduleAddress: moduleAddress$19,
    moduleName: moduleName$19,
    EACCOUNT_NOT_FOUND: EACCOUNT_NOT_FOUND,
    EACCOUNT_NOT_REGISTERED_FOR_APT: EACCOUNT_NOT_REGISTERED_FOR_APT,
    assert_account_exists_: assert_account_exists_,
    assert_account_is_registered_for_apt_: assert_account_is_registered_for_apt_,
    create_account_: create_account_$1,
    buildPayload_create_account: buildPayload_create_account,
    transfer_: transfer_,
    buildPayload_transfer: buildPayload_transfer,
    loadParsers: loadParsers$1m,
    App: App$1n
});

const packageName$18 = 'AptosFramework';
const moduleAddress$18 = new HexString('0x1');
const moduleName$18 = 'aptos_coin';
const EALREADY_DELEGATED = u64('2');
const EDELEGATION_NOT_FOUND = u64('3');
const ENO_CAPABILITIES$1 = u64('1');
class AptosCoin {
    constructor(proto, typeTag) {
        this.typeTag = typeTag;
        this.__app = null;
    }
    static AptosCoinParser(data, typeTag, repo) {
        const proto = $.parseStructProto(data, typeTag, repo, AptosCoin);
        return new AptosCoin(proto, typeTag);
    }
    static load(repo, client, address, typeParams) {
        return __awaiter(this, void 0, void 0, function* () {
            const result = yield repo.loadResource(client, address, AptosCoin, typeParams);
            return result;
        });
    }
    static loadByApp(app, address, typeParams) {
        return __awaiter(this, void 0, void 0, function* () {
            const result = yield app.repo.loadResource(app.client, address, AptosCoin, typeParams);
            yield result.loadFullState(app);
            return result;
        });
    }
    static getTag() {
        return new StructTag(moduleAddress$18, moduleName$18, 'AptosCoin', []);
    }
    loadFullState(app) {
        return __awaiter(this, void 0, void 0, function* () {
            this.__app = app;
        });
    }
}
AptosCoin.moduleAddress = moduleAddress$18;
AptosCoin.moduleName = moduleName$18;
AptosCoin.structName = 'AptosCoin';
AptosCoin.typeParameters = [];
AptosCoin.fields = [];
class DelegatedMintCapability {
    constructor(proto, typeTag) {
        this.typeTag = typeTag;
        this.__app = null;
        this.to = proto['to'];
    }
    static DelegatedMintCapabilityParser(data, typeTag, repo) {
        const proto = $.parseStructProto(data, typeTag, repo, DelegatedMintCapability);
        return new DelegatedMintCapability(proto, typeTag);
    }
    static getTag() {
        return new StructTag(moduleAddress$18, moduleName$18, 'DelegatedMintCapability', []);
    }
    loadFullState(app) {
        return __awaiter(this, void 0, void 0, function* () {
            this.__app = app;
        });
    }
}
DelegatedMintCapability.moduleAddress = moduleAddress$18;
DelegatedMintCapability.moduleName = moduleName$18;
DelegatedMintCapability.structName = 'DelegatedMintCapability';
DelegatedMintCapability.typeParameters = [];
DelegatedMintCapability.fields = [{ name: 'to', typeTag: AtomicTypeTag.Address }];
class Delegations {
    constructor(proto, typeTag) {
        this.typeTag = typeTag;
        this.__app = null;
        this.inner = proto['inner'];
    }
    static DelegationsParser(data, typeTag, repo) {
        const proto = $.parseStructProto(data, typeTag, repo, Delegations);
        return new Delegations(proto, typeTag);
    }
    static load(repo, client, address, typeParams) {
        return __awaiter(this, void 0, void 0, function* () {
            const result = yield repo.loadResource(client, address, Delegations, typeParams);
            return result;
        });
    }
    static loadByApp(app, address, typeParams) {
        return __awaiter(this, void 0, void 0, function* () {
            const result = yield app.repo.loadResource(app.client, address, Delegations, typeParams);
            yield result.loadFullState(app);
            return result;
        });
    }
    static getTag() {
        return new StructTag(moduleAddress$18, moduleName$18, 'Delegations', []);
    }
    loadFullState(app) {
        return __awaiter(this, void 0, void 0, function* () {
            this.__app = app;
        });
    }
}
Delegations.moduleAddress = moduleAddress$18;
Delegations.moduleName = moduleName$18;
Delegations.structName = 'Delegations';
Delegations.typeParameters = [];
Delegations.fields = [
    {
        name: 'inner',
        typeTag: new VectorTag(new StructTag(new HexString('0x1'), 'aptos_coin', 'DelegatedMintCapability', []))
    }
];
class MintCapStore {
    constructor(proto, typeTag) {
        this.typeTag = typeTag;
        this.__app = null;
        this.mint_cap = proto['mint_cap'];
    }
    static MintCapStoreParser(data, typeTag, repo) {
        const proto = $.parseStructProto(data, typeTag, repo, MintCapStore);
        return new MintCapStore(proto, typeTag);
    }
    static load(repo, client, address, typeParams) {
        return __awaiter(this, void 0, void 0, function* () {
            const result = yield repo.loadResource(client, address, MintCapStore, typeParams);
            return result;
        });
    }
    static loadByApp(app, address, typeParams) {
        return __awaiter(this, void 0, void 0, function* () {
            const result = yield app.repo.loadResource(app.client, address, MintCapStore, typeParams);
            yield result.loadFullState(app);
            return result;
        });
    }
    static getTag() {
        return new StructTag(moduleAddress$18, moduleName$18, 'MintCapStore', []);
    }
    loadFullState(app) {
        return __awaiter(this, void 0, void 0, function* () {
            yield this.mint_cap.loadFullState(app);
            this.__app = app;
        });
    }
}
MintCapStore.moduleAddress = moduleAddress$18;
MintCapStore.moduleName = moduleName$18;
MintCapStore.structName = 'MintCapStore';
MintCapStore.typeParameters = [];
MintCapStore.fields = [
    {
        name: 'mint_cap',
        typeTag: new StructTag(new HexString('0x1'), 'coin', 'MintCapability', [
            new StructTag(new HexString('0x1'), 'aptos_coin', 'AptosCoin', [])
        ])
    }
];
function claim_mint_capability_(account, $c) {
    let delegations, idx, maybe_index, mint_cap;
    maybe_index = find_delegation_(address_of_(account, $c), $c);
    if (!is_some_(maybe_index, $c, [AtomicTypeTag.U64])) {
        throw $.abortCode($.copy(EDELEGATION_NOT_FOUND));
    }
    idx = $.copy(borrow_$6(maybe_index, $c, [AtomicTypeTag.U64]));
    delegations = $c.borrow_global_mut(new SimpleStructTag(Delegations), new HexString('0xa550c18')).inner;
    swap_remove_(delegations, $.copy(idx), $c, [new SimpleStructTag(DelegatedMintCapability)]);
    mint_cap = $.copy($c.borrow_global(new SimpleStructTag(MintCapStore), new HexString('0xa550c18')).mint_cap);
    $c.move_to(new SimpleStructTag(MintCapStore), account, new MintCapStore({ mint_cap: $.copy(mint_cap) }, new SimpleStructTag(MintCapStore)));
    return;
}
function buildPayload_claim_mint_capability(isJSON = false) {
    const typeParamStrings = [];
    return $.buildPayload(new HexString('0x1'), 'aptos_coin', 'claim_mint_capability', typeParamStrings, [], isJSON);
}
function configure_accounts_for_test_(aptos_framework, core_resources, mint_cap, $c) {
    let coins;
    assert_aptos_framework_(aptos_framework, $c);
    register_$2(core_resources, $c, [new SimpleStructTag(AptosCoin)]);
    coins = mint_$4(u64('18446744073709551615'), mint_cap, $c, [new SimpleStructTag(AptosCoin)]);
    deposit_$1(address_of_(core_resources, $c), coins, $c, [new SimpleStructTag(AptosCoin)]);
    $c.move_to(new SimpleStructTag(MintCapStore), core_resources, new MintCapStore({ mint_cap: $.copy(mint_cap) }, new SimpleStructTag(MintCapStore)));
    $c.move_to(new SimpleStructTag(Delegations), core_resources, new Delegations({ inner: empty_$5($c, [new SimpleStructTag(DelegatedMintCapability)]) }, new SimpleStructTag(Delegations)));
    return;
}
function delegate_mint_capability_(account, to, $c) {
    let temp$1, temp$2, delegations, element, i;
    assert_core_resource_(account, $c);
    delegations = $c.borrow_global_mut(new SimpleStructTag(Delegations), new HexString('0xa550c18')).inner;
    i = u64('0');
    while ($.copy(i).lt(length_$6(delegations, $c, [new SimpleStructTag(DelegatedMintCapability)]))) {
        {
            [temp$1, temp$2] = [delegations, $.copy(i)];
            element = borrow_$7(temp$1, temp$2, $c, [new SimpleStructTag(DelegatedMintCapability)]);
            if (!($.copy(element.to).hex() !== $.copy(to).hex())) {
                throw $.abortCode(invalid_argument_($.copy(EALREADY_DELEGATED)));
            }
            i = $.copy(i).add(u64('1'));
        }
    }
    push_back_(delegations, new DelegatedMintCapability({ to: $.copy(to) }, new SimpleStructTag(DelegatedMintCapability)), $c, [new SimpleStructTag(DelegatedMintCapability)]);
    return;
}
function buildPayload_delegate_mint_capability(to, isJSON = false) {
    const typeParamStrings = [];
    return $.buildPayload(new HexString('0x1'), 'aptos_coin', 'delegate_mint_capability', typeParamStrings, [to], isJSON);
}
function destroy_mint_cap_(aptos_framework, $c) {
    assert_aptos_framework_(aptos_framework, $c);
    let { mint_cap: mint_cap } = $c.move_from(new SimpleStructTag(MintCapStore), new HexString('0x1'));
    destroy_mint_cap_$1($.copy(mint_cap), $c, [new SimpleStructTag(AptosCoin)]);
    return;
}
function find_delegation_(addr, $c) {
    let delegations, element, i, index, len;
    delegations = $c.borrow_global(new SimpleStructTag(Delegations), new HexString('0xa550c18')).inner;
    i = u64('0');
    len = length_$6(delegations, $c, [new SimpleStructTag(DelegatedMintCapability)]);
    index = none_($c, [AtomicTypeTag.U64]);
    while ($.copy(i).lt($.copy(len))) {
        {
            element = borrow_$7(delegations, $.copy(i), $c, [new SimpleStructTag(DelegatedMintCapability)]);
            if ($.copy(element.to).hex() === $.copy(addr).hex()) {
                index = some_($.copy(i), $c, [AtomicTypeTag.U64]);
                break;
            }
            i = $.copy(i).add(u64('1'));
        }
    }
    return $.copy(index);
}
function has_mint_capability_(account, $c) {
    return $c.exists(new SimpleStructTag(MintCapStore), address_of_(account, $c));
}
function initialize_$i(aptos_framework, $c) {
    let burn_cap, freeze_cap, mint_cap;
    assert_aptos_framework_(aptos_framework, $c);
    [burn_cap, freeze_cap, mint_cap] = initialize_with_parallelizable_supply_(aptos_framework, utf8_([u8('65'), u8('112'), u8('116'), u8('111'), u8('115'), u8('32'), u8('67'), u8('111'), u8('105'), u8('110')], $c), utf8_([u8('65'), u8('80'), u8('84')], $c), u8('8'), true, $c, [new SimpleStructTag(AptosCoin)]);
    $c.move_to(new SimpleStructTag(MintCapStore), aptos_framework, new MintCapStore({ mint_cap: $.copy(mint_cap) }, new SimpleStructTag(MintCapStore)));
    destroy_freeze_cap_($.copy(freeze_cap), $c, [new SimpleStructTag(AptosCoin)]);
    return [$.copy(burn_cap), $.copy(mint_cap)];
}
function mint_$3(account, dst_addr, amount, $c) {
    let account_addr, coins_minted, mint_cap;
    account_addr = address_of_(account, $c);
    if (!$c.exists(new SimpleStructTag(MintCapStore), $.copy(account_addr))) {
        throw $.abortCode(not_found_($.copy(ENO_CAPABILITIES$1)));
    }
    mint_cap = $c.borrow_global(new SimpleStructTag(MintCapStore), $.copy(account_addr)).mint_cap;
    coins_minted = mint_$4($.copy(amount), mint_cap, $c, [new SimpleStructTag(AptosCoin)]);
    deposit_$1($.copy(dst_addr), coins_minted, $c, [new SimpleStructTag(AptosCoin)]);
    return;
}
function buildPayload_mint$2(dst_addr, amount, isJSON = false) {
    const typeParamStrings = [];
    return $.buildPayload(new HexString('0x1'), 'aptos_coin', 'mint', typeParamStrings, [dst_addr, amount], isJSON);
}
function loadParsers$1l(repo) {
    repo.addParser('0x1::aptos_coin::AptosCoin', AptosCoin.AptosCoinParser);
    repo.addParser('0x1::aptos_coin::DelegatedMintCapability', DelegatedMintCapability.DelegatedMintCapabilityParser);
    repo.addParser('0x1::aptos_coin::Delegations', Delegations.DelegationsParser);
    repo.addParser('0x1::aptos_coin::MintCapStore', MintCapStore.MintCapStoreParser);
}
class App$1m {
    constructor(client, repo, cache) {
        this.client = client;
        this.repo = repo;
        this.cache = cache;
    }
    get moduleAddress() {
        {
            return moduleAddress$18;
        }
    }
    get moduleName() {
        {
            return moduleName$18;
        }
    }
    get AptosCoin() {
        return AptosCoin;
    }
    loadAptosCoin(owner, loadFull = true, fillCache = true) {
        return __awaiter(this, void 0, void 0, function* () {
            const val = yield AptosCoin.load(this.repo, this.client, owner, []);
            if (loadFull) {
                yield val.loadFullState(this);
            }
            if (fillCache) {
                this.cache.set(val.typeTag, owner, val);
            }
            return val;
        });
    }
    get DelegatedMintCapability() {
        return DelegatedMintCapability;
    }
    get Delegations() {
        return Delegations;
    }
    loadDelegations(owner, loadFull = true, fillCache = true) {
        return __awaiter(this, void 0, void 0, function* () {
            const val = yield Delegations.load(this.repo, this.client, owner, []);
            if (loadFull) {
                yield val.loadFullState(this);
            }
            if (fillCache) {
                this.cache.set(val.typeTag, owner, val);
            }
            return val;
        });
    }
    get MintCapStore() {
        return MintCapStore;
    }
    loadMintCapStore(owner, loadFull = true, fillCache = true) {
        return __awaiter(this, void 0, void 0, function* () {
            const val = yield MintCapStore.load(this.repo, this.client, owner, []);
            if (loadFull) {
                yield val.loadFullState(this);
            }
            if (fillCache) {
                this.cache.set(val.typeTag, owner, val);
            }
            return val;
        });
    }
    payload_claim_mint_capability(isJSON = false) {
        return buildPayload_claim_mint_capability(isJSON);
    }
    claim_mint_capability(_account, option, _isJSON = false) {
        return __awaiter(this, void 0, void 0, function* () {
            const payload__ = buildPayload_claim_mint_capability(_isJSON);
            return $.sendPayloadTx(this.client, _account, payload__, option);
        });
    }
    payload_delegate_mint_capability(to, isJSON = false) {
        return buildPayload_delegate_mint_capability(to, isJSON);
    }
    delegate_mint_capability(_account, to, option, _isJSON = false) {
        return __awaiter(this, void 0, void 0, function* () {
            const payload__ = buildPayload_delegate_mint_capability(to, _isJSON);
            return $.sendPayloadTx(this.client, _account, payload__, option);
        });
    }
    payload_mint(dst_addr, amount, isJSON = false) {
        return buildPayload_mint$2(dst_addr, amount, isJSON);
    }
    mint(_account, dst_addr, amount, option, _isJSON = false) {
        return __awaiter(this, void 0, void 0, function* () {
            const payload__ = buildPayload_mint$2(dst_addr, amount, _isJSON);
            return $.sendPayloadTx(this.client, _account, payload__, option);
        });
    }
}

var Aptos_coin = /*#__PURE__*/Object.freeze({
    __proto__: null,
    packageName: packageName$18,
    moduleAddress: moduleAddress$18,
    moduleName: moduleName$18,
    EALREADY_DELEGATED: EALREADY_DELEGATED,
    EDELEGATION_NOT_FOUND: EDELEGATION_NOT_FOUND,
    ENO_CAPABILITIES: ENO_CAPABILITIES$1,
    AptosCoin: AptosCoin,
    DelegatedMintCapability: DelegatedMintCapability,
    Delegations: Delegations,
    MintCapStore: MintCapStore,
    claim_mint_capability_: claim_mint_capability_,
    buildPayload_claim_mint_capability: buildPayload_claim_mint_capability,
    configure_accounts_for_test_: configure_accounts_for_test_,
    delegate_mint_capability_: delegate_mint_capability_,
    buildPayload_delegate_mint_capability: buildPayload_delegate_mint_capability,
    destroy_mint_cap_: destroy_mint_cap_,
    find_delegation_: find_delegation_,
    has_mint_capability_: has_mint_capability_,
    initialize_: initialize_$i,
    mint_: mint_$3,
    buildPayload_mint: buildPayload_mint$2,
    loadParsers: loadParsers$1l,
    App: App$1m
});

const packageName$17 = 'AptosFramework';
const moduleAddress$17 = new HexString('0x1');
const moduleName$17 = 'governance_proposal';
class GovernanceProposal {
    constructor(proto, typeTag) {
        this.typeTag = typeTag;
        this.__app = null;
    }
    static GovernanceProposalParser(data, typeTag, repo) {
        const proto = $.parseStructProto(data, typeTag, repo, GovernanceProposal);
        return new GovernanceProposal(proto, typeTag);
    }
    static getTag() {
        return new StructTag(moduleAddress$17, moduleName$17, 'GovernanceProposal', []);
    }
    loadFullState(app) {
        return __awaiter(this, void 0, void 0, function* () {
            this.__app = app;
        });
    }
}
GovernanceProposal.moduleAddress = moduleAddress$17;
GovernanceProposal.moduleName = moduleName$17;
GovernanceProposal.structName = 'GovernanceProposal';
GovernanceProposal.typeParameters = [];
GovernanceProposal.fields = [];
function create_empty_proposal_($c) {
    return create_proposal_$2();
}
function create_proposal_$2($c) {
    return new GovernanceProposal({}, new SimpleStructTag(GovernanceProposal));
}
function loadParsers$1k(repo) {
    repo.addParser('0x1::governance_proposal::GovernanceProposal', GovernanceProposal.GovernanceProposalParser);
}
class App$1l {
    constructor(client, repo, cache) {
        this.client = client;
        this.repo = repo;
        this.cache = cache;
    }
    get moduleAddress() {
        {
            return moduleAddress$17;
        }
    }
    get moduleName() {
        {
            return moduleName$17;
        }
    }
    get GovernanceProposal() {
        return GovernanceProposal;
    }
}

var Governance_proposal = /*#__PURE__*/Object.freeze({
    __proto__: null,
    packageName: packageName$17,
    moduleAddress: moduleAddress$17,
    moduleName: moduleName$17,
    GovernanceProposal: GovernanceProposal,
    create_empty_proposal_: create_empty_proposal_,
    create_proposal_: create_proposal_$2,
    loadParsers: loadParsers$1k,
    App: App$1l
});

const packageName$16 = 'AptosFramework';
const moduleAddress$16 = new HexString('0x1');
const moduleName$16 = 'chain_status';
const ENOT_GENESIS = u64('2');
const ENOT_OPERATING$1 = u64('1');
class GenesisEndMarker {
    constructor(proto, typeTag) {
        this.typeTag = typeTag;
        this.__app = null;
    }
    static GenesisEndMarkerParser(data, typeTag, repo) {
        const proto = $.parseStructProto(data, typeTag, repo, GenesisEndMarker);
        return new GenesisEndMarker(proto, typeTag);
    }
    static load(repo, client, address, typeParams) {
        return __awaiter(this, void 0, void 0, function* () {
            const result = yield repo.loadResource(client, address, GenesisEndMarker, typeParams);
            return result;
        });
    }
    static loadByApp(app, address, typeParams) {
        return __awaiter(this, void 0, void 0, function* () {
            const result = yield app.repo.loadResource(app.client, address, GenesisEndMarker, typeParams);
            yield result.loadFullState(app);
            return result;
        });
    }
    static getTag() {
        return new StructTag(moduleAddress$16, moduleName$16, 'GenesisEndMarker', []);
    }
    loadFullState(app) {
        return __awaiter(this, void 0, void 0, function* () {
            this.__app = app;
        });
    }
}
GenesisEndMarker.moduleAddress = moduleAddress$16;
GenesisEndMarker.moduleName = moduleName$16;
GenesisEndMarker.structName = 'GenesisEndMarker';
GenesisEndMarker.typeParameters = [];
GenesisEndMarker.fields = [];
function assert_genesis_($c) {
    if (!is_genesis_($c)) {
        throw $.abortCode(invalid_state_($.copy(ENOT_OPERATING$1)));
    }
    return;
}
function assert_operating_($c) {
    if (!is_operating_($c)) {
        throw $.abortCode(invalid_state_($.copy(ENOT_OPERATING$1)));
    }
    return;
}
function is_genesis_($c) {
    return !$c.exists(new SimpleStructTag(GenesisEndMarker), new HexString('0x1'));
}
function is_operating_($c) {
    return $c.exists(new SimpleStructTag(GenesisEndMarker), new HexString('0x1'));
}
function set_genesis_end_$1(aptos_framework, $c) {
    assert_aptos_framework_(aptos_framework, $c);
    $c.move_to(new SimpleStructTag(GenesisEndMarker), aptos_framework, new GenesisEndMarker({}, new SimpleStructTag(GenesisEndMarker)));
    return;
}
function loadParsers$1j(repo) {
    repo.addParser('0x1::chain_status::GenesisEndMarker', GenesisEndMarker.GenesisEndMarkerParser);
}
class App$1k {
    constructor(client, repo, cache) {
        this.client = client;
        this.repo = repo;
        this.cache = cache;
    }
    get moduleAddress() {
        {
            return moduleAddress$16;
        }
    }
    get moduleName() {
        {
            return moduleName$16;
        }
    }
    get GenesisEndMarker() {
        return GenesisEndMarker;
    }
    loadGenesisEndMarker(owner, loadFull = true, fillCache = true) {
        return __awaiter(this, void 0, void 0, function* () {
            const val = yield GenesisEndMarker.load(this.repo, this.client, owner, []);
            if (loadFull) {
                yield val.loadFullState(this);
            }
            if (fillCache) {
                this.cache.set(val.typeTag, owner, val);
            }
            return val;
        });
    }
}

var Chain_status = /*#__PURE__*/Object.freeze({
    __proto__: null,
    packageName: packageName$16,
    moduleAddress: moduleAddress$16,
    moduleName: moduleName$16,
    ENOT_GENESIS: ENOT_GENESIS,
    ENOT_OPERATING: ENOT_OPERATING$1,
    GenesisEndMarker: GenesisEndMarker,
    assert_genesis_: assert_genesis_,
    assert_operating_: assert_operating_,
    is_genesis_: is_genesis_,
    is_operating_: is_operating_,
    set_genesis_end_: set_genesis_end_$1,
    loadParsers: loadParsers$1j,
    App: App$1k
});

const packageName$15 = 'AptosStdlib';
const moduleAddress$15 = new HexString('0x1');
const moduleName$15 = 'bls12381';
const EWRONG_SIZE = u64('2');
const EZERO_PUBKEYS = u64('1');
const PUBLIC_KEY_NUM_BYTES = u64('48');
const RANDOM_PK = [
    u8('138'),
    u8('83'),
    u8('231'),
    u8('174'),
    u8('82'),
    u8('112'),
    u8('227'),
    u8('231'),
    u8('101'),
    u8('205'),
    u8('138'),
    u8('64'),
    u8('50'),
    u8('194'),
    u8('231'),
    u8('124'),
    u8('111'),
    u8('126'),
    u8('135'),
    u8('164'),
    u8('78'),
    u8('187'),
    u8('133'),
    u8('191'),
    u8('40'),
    u8('164'),
    u8('215'),
    u8('134'),
    u8('85'),
    u8('101'),
    u8('105'),
    u8('143'),
    u8('151'),
    u8('83'),
    u8('70'),
    u8('113'),
    u8('66'),
    u8('98'),
    u8('249'),
    u8('228'),
    u8('124'),
    u8('111'),
    u8('62'),
    u8('13'),
    u8('93'),
    u8('149'),
    u8('22'),
    u8('96')
];
const RANDOM_SIGNATURE = [
    u8('160'),
    u8('26'),
    u8('101'),
    u8('133'),
    u8('79'),
    u8('152'),
    u8('125'),
    u8('52'),
    u8('52'),
    u8('20'),
    u8('155'),
    u8('127'),
    u8('8'),
    u8('247'),
    u8('7'),
    u8('48'),
    u8('227'),
    u8('11'),
    u8('36'),
    u8('25'),
    u8('132'),
    u8('232'),
    u8('113'),
    u8('43'),
    u8('194'),
    u8('172'),
    u8('168'),
    u8('133'),
    u8('214'),
    u8('50'),
    u8('170'),
    u8('252'),
    u8('237'),
    u8('76'),
    u8('63'),
    u8('102'),
    u8('18'),
    u8('9'),
    u8('222'),
    u8('187'),
    u8('107'),
    u8('28'),
    u8('134'),
    u8('1'),
    u8('50'),
    u8('102'),
    u8('35'),
    u8('204'),
    u8('22'),
    u8('202'),
    u8('47'),
    u8('108'),
    u8('158'),
    u8('220'),
    u8('83'),
    u8('183'),
    u8('184'),
    u8('139'),
    u8('116'),
    u8('53'),
    u8('251'),
    u8('107'),
    u8('5'),
    u8('221'),
    u8('236'),
    u8('228'),
    u8('24'),
    u8('210'),
    u8('195'),
    u8('77'),
    u8('198'),
    u8('172'),
    u8('162'),
    u8('245'),
    u8('161'),
    u8('26'),
    u8('121'),
    u8('230'),
    u8('119'),
    u8('116'),
    u8('88'),
    u8('44'),
    u8('20'),
    u8('8'),
    u8('74'),
    u8('1'),
    u8('220'),
    u8('183'),
    u8('130'),
    u8('14'),
    u8('76'),
    u8('180'),
    u8('186'),
    u8('208'),
    u8('234'),
    u8('141')
];
const SIGNATURE_SIZE = u64('96');
class AggrOrMultiSignature {
    constructor(proto, typeTag) {
        this.typeTag = typeTag;
        this.__app = null;
        this.bytes = proto['bytes'];
    }
    static AggrOrMultiSignatureParser(data, typeTag, repo) {
        const proto = $.parseStructProto(data, typeTag, repo, AggrOrMultiSignature);
        return new AggrOrMultiSignature(proto, typeTag);
    }
    static getTag() {
        return new StructTag(moduleAddress$15, moduleName$15, 'AggrOrMultiSignature', []);
    }
    loadFullState(app) {
        return __awaiter(this, void 0, void 0, function* () {
            this.__app = app;
        });
    }
}
AggrOrMultiSignature.moduleAddress = moduleAddress$15;
AggrOrMultiSignature.moduleName = moduleName$15;
AggrOrMultiSignature.structName = 'AggrOrMultiSignature';
AggrOrMultiSignature.typeParameters = [];
AggrOrMultiSignature.fields = [{ name: 'bytes', typeTag: new VectorTag(AtomicTypeTag.U8) }];
class AggrPublicKeysWithPoP {
    constructor(proto, typeTag) {
        this.typeTag = typeTag;
        this.__app = null;
        this.bytes = proto['bytes'];
    }
    static AggrPublicKeysWithPoPParser(data, typeTag, repo) {
        const proto = $.parseStructProto(data, typeTag, repo, AggrPublicKeysWithPoP);
        return new AggrPublicKeysWithPoP(proto, typeTag);
    }
    static getTag() {
        return new StructTag(moduleAddress$15, moduleName$15, 'AggrPublicKeysWithPoP', []);
    }
    loadFullState(app) {
        return __awaiter(this, void 0, void 0, function* () {
            this.__app = app;
        });
    }
}
AggrPublicKeysWithPoP.moduleAddress = moduleAddress$15;
AggrPublicKeysWithPoP.moduleName = moduleName$15;
AggrPublicKeysWithPoP.structName = 'AggrPublicKeysWithPoP';
AggrPublicKeysWithPoP.typeParameters = [];
AggrPublicKeysWithPoP.fields = [{ name: 'bytes', typeTag: new VectorTag(AtomicTypeTag.U8) }];
class ProofOfPossession {
    constructor(proto, typeTag) {
        this.typeTag = typeTag;
        this.__app = null;
        this.bytes = proto['bytes'];
    }
    static ProofOfPossessionParser(data, typeTag, repo) {
        const proto = $.parseStructProto(data, typeTag, repo, ProofOfPossession);
        return new ProofOfPossession(proto, typeTag);
    }
    static getTag() {
        return new StructTag(moduleAddress$15, moduleName$15, 'ProofOfPossession', []);
    }
    loadFullState(app) {
        return __awaiter(this, void 0, void 0, function* () {
            this.__app = app;
        });
    }
}
ProofOfPossession.moduleAddress = moduleAddress$15;
ProofOfPossession.moduleName = moduleName$15;
ProofOfPossession.structName = 'ProofOfPossession';
ProofOfPossession.typeParameters = [];
ProofOfPossession.fields = [{ name: 'bytes', typeTag: new VectorTag(AtomicTypeTag.U8) }];
class PublicKey {
    constructor(proto, typeTag) {
        this.typeTag = typeTag;
        this.__app = null;
        this.bytes = proto['bytes'];
    }
    static PublicKeyParser(data, typeTag, repo) {
        const proto = $.parseStructProto(data, typeTag, repo, PublicKey);
        return new PublicKey(proto, typeTag);
    }
    static getTag() {
        return new StructTag(moduleAddress$15, moduleName$15, 'PublicKey', []);
    }
    loadFullState(app) {
        return __awaiter(this, void 0, void 0, function* () {
            this.__app = app;
        });
    }
}
PublicKey.moduleAddress = moduleAddress$15;
PublicKey.moduleName = moduleName$15;
PublicKey.structName = 'PublicKey';
PublicKey.typeParameters = [];
PublicKey.fields = [{ name: 'bytes', typeTag: new VectorTag(AtomicTypeTag.U8) }];
class PublicKeyWithPoP {
    constructor(proto, typeTag) {
        this.typeTag = typeTag;
        this.__app = null;
        this.bytes = proto['bytes'];
    }
    static PublicKeyWithPoPParser(data, typeTag, repo) {
        const proto = $.parseStructProto(data, typeTag, repo, PublicKeyWithPoP);
        return new PublicKeyWithPoP(proto, typeTag);
    }
    static getTag() {
        return new StructTag(moduleAddress$15, moduleName$15, 'PublicKeyWithPoP', []);
    }
    loadFullState(app) {
        return __awaiter(this, void 0, void 0, function* () {
            this.__app = app;
        });
    }
}
PublicKeyWithPoP.moduleAddress = moduleAddress$15;
PublicKeyWithPoP.moduleName = moduleName$15;
PublicKeyWithPoP.structName = 'PublicKeyWithPoP';
PublicKeyWithPoP.typeParameters = [];
PublicKeyWithPoP.fields = [{ name: 'bytes', typeTag: new VectorTag(AtomicTypeTag.U8) }];
class Signature {
    constructor(proto, typeTag) {
        this.typeTag = typeTag;
        this.__app = null;
        this.bytes = proto['bytes'];
    }
    static SignatureParser(data, typeTag, repo) {
        const proto = $.parseStructProto(data, typeTag, repo, Signature);
        return new Signature(proto, typeTag);
    }
    static getTag() {
        return new StructTag(moduleAddress$15, moduleName$15, 'Signature', []);
    }
    loadFullState(app) {
        return __awaiter(this, void 0, void 0, function* () {
            this.__app = app;
        });
    }
}
Signature.moduleAddress = moduleAddress$15;
Signature.moduleName = moduleName$15;
Signature.structName = 'Signature';
Signature.typeParameters = [];
Signature.fields = [{ name: 'bytes', typeTag: new VectorTag(AtomicTypeTag.U8) }];
function aggr_or_multi_signature_from_bytes_(bytes, $c) {
    if (!length_$6(bytes, $c, [AtomicTypeTag.U8]).eq($.copy(SIGNATURE_SIZE))) {
        throw $.abortCode(invalid_argument_($.copy(EWRONG_SIZE)));
    }
    return new AggrOrMultiSignature({ bytes: $.copy(bytes) }, new SimpleStructTag(AggrOrMultiSignature));
}
function aggr_or_multi_signature_subgroup_check_(signature, $c) {
    return signature_subgroup_check_internal_($.copy(signature.bytes), $c);
}
function aggr_or_multi_signature_to_bytes_(sig, $c) {
    return $.copy(sig.bytes);
}
function aggregate_pubkey_to_bytes_(apk, $c) {
    return $.copy(apk.bytes);
}
function aggregate_pubkeys_(public_keys, $c) {
    let bytes, success;
    [bytes, success] = aggregate_pubkeys_internal_($.copy(public_keys), $c);
    if (!success) {
        throw $.abortCode(invalid_argument_($.copy(EZERO_PUBKEYS)));
    }
    return new AggrPublicKeysWithPoP({ bytes: $.copy(bytes) }, new SimpleStructTag(AggrPublicKeysWithPoP));
}
function aggregate_pubkeys_internal_(public_keys, $c) {
    return $.aptos_std_bls12381_aggregate_pubkeys_internal(public_keys, $c);
}
function aggregate_signatures_(signatures, $c) {
    let temp$1, bytes, success;
    [bytes, success] = aggregate_signatures_internal_($.copy(signatures), $c);
    if (success) {
        temp$1 = some_(new AggrOrMultiSignature({ bytes: $.copy(bytes) }, new SimpleStructTag(AggrOrMultiSignature)), $c, [new SimpleStructTag(AggrOrMultiSignature)]);
    }
    else {
        temp$1 = none_($c, [new SimpleStructTag(AggrOrMultiSignature)]);
    }
    return temp$1;
}
function aggregate_signatures_internal_(signatures, $c) {
    return $.aptos_std_bls12381_aggregate_signatures_internal(signatures, $c);
}
function proof_of_possession_from_bytes_(bytes, $c) {
    return new ProofOfPossession({ bytes: $.copy(bytes) }, new SimpleStructTag(ProofOfPossession));
}
function proof_of_possession_to_bytes_(pop, $c) {
    return $.copy(pop.bytes);
}
function public_key_from_bytes_(bytes, $c) {
    let temp$1;
    if (validate_pubkey_internal_($.copy(bytes), $c)) {
        temp$1 = some_(new PublicKey({ bytes: $.copy(bytes) }, new SimpleStructTag(PublicKey)), $c, [
            new SimpleStructTag(PublicKey)
        ]);
    }
    else {
        temp$1 = none_($c, [new SimpleStructTag(PublicKey)]);
    }
    return temp$1;
}
function public_key_from_bytes_with_pop_(pk_bytes, pop, $c) {
    let temp$1;
    if (verify_proof_of_possession_internal_($.copy(pk_bytes), $.copy(pop.bytes), $c)) {
        temp$1 = some_(new PublicKeyWithPoP({ bytes: $.copy(pk_bytes) }, new SimpleStructTag(PublicKeyWithPoP)), $c, [new SimpleStructTag(PublicKeyWithPoP)]);
    }
    else {
        temp$1 = none_($c, [new SimpleStructTag(PublicKeyWithPoP)]);
    }
    return temp$1;
}
function public_key_to_bytes_(pk, $c) {
    return $.copy(pk.bytes);
}
function public_key_with_pop_to_bytes_(pk, $c) {
    return $.copy(pk.bytes);
}
function signature_from_bytes_(bytes, $c) {
    return new Signature({ bytes: $.copy(bytes) }, new SimpleStructTag(Signature));
}
function signature_subgroup_check_(signature, $c) {
    return signature_subgroup_check_internal_($.copy(signature.bytes), $c);
}
function signature_subgroup_check_internal_(signature, $c) {
    return $.aptos_std_bls12381_signature_subgroup_check_internal(signature, $c);
}
function signature_to_bytes_(sig, $c) {
    return $.copy(sig.bytes);
}
function validate_pubkey_internal_(public_key, $c) {
    return $.aptos_std_bls12381_validate_pubkey_internal(public_key, $c);
}
function verify_aggregate_signature_(aggr_sig, public_keys, messages, $c) {
    return verify_aggregate_signature_internal_($.copy(aggr_sig.bytes), $.copy(public_keys), $.copy(messages), $c);
}
function verify_aggregate_signature_internal_(aggsig, public_keys, messages, $c) {
    return $.aptos_std_bls12381_verify_aggregate_signature_internal(aggsig, public_keys, messages, $c);
}
function verify_multisignature_(multisig, aggr_public_key, message, $c) {
    return verify_multisignature_internal_($.copy(multisig.bytes), $.copy(aggr_public_key.bytes), $.copy(message), $c);
}
function verify_multisignature_internal_(multisignature, agg_public_key, message, $c) {
    return $.aptos_std_bls12381_verify_multisignature_internal(multisignature, agg_public_key, message, $c);
}
function verify_normal_signature_(signature, public_key, message, $c) {
    return verify_normal_signature_internal_($.copy(signature.bytes), $.copy(public_key.bytes), $.copy(message), $c);
}
function verify_normal_signature_internal_(signature, public_key, message, $c) {
    return $.aptos_std_bls12381_verify_normal_signature_internal(signature, public_key, message, $c);
}
function verify_proof_of_possession_internal_(public_key, proof_of_possesion, $c) {
    return $.aptos_std_bls12381_verify_proof_of_possession_internal(public_key, proof_of_possesion, $c);
}
function verify_signature_share_(signature_share, public_key, message, $c) {
    return verify_signature_share_internal_($.copy(signature_share.bytes), $.copy(public_key.bytes), $.copy(message), $c);
}
function verify_signature_share_internal_(signature_share, public_key, message, $c) {
    return $.aptos_std_bls12381_verify_signature_share_internal(signature_share, public_key, message, $c);
}
function loadParsers$1i(repo) {
    repo.addParser('0x1::bls12381::AggrOrMultiSignature', AggrOrMultiSignature.AggrOrMultiSignatureParser);
    repo.addParser('0x1::bls12381::AggrPublicKeysWithPoP', AggrPublicKeysWithPoP.AggrPublicKeysWithPoPParser);
    repo.addParser('0x1::bls12381::ProofOfPossession', ProofOfPossession.ProofOfPossessionParser);
    repo.addParser('0x1::bls12381::PublicKey', PublicKey.PublicKeyParser);
    repo.addParser('0x1::bls12381::PublicKeyWithPoP', PublicKeyWithPoP.PublicKeyWithPoPParser);
    repo.addParser('0x1::bls12381::Signature', Signature.SignatureParser);
}
class App$1j {
    constructor(client, repo, cache) {
        this.client = client;
        this.repo = repo;
        this.cache = cache;
    }
    get moduleAddress() {
        {
            return moduleAddress$15;
        }
    }
    get moduleName() {
        {
            return moduleName$15;
        }
    }
    get AggrOrMultiSignature() {
        return AggrOrMultiSignature;
    }
    get AggrPublicKeysWithPoP() {
        return AggrPublicKeysWithPoP;
    }
    get ProofOfPossession() {
        return ProofOfPossession;
    }
    get PublicKey() {
        return PublicKey;
    }
    get PublicKeyWithPoP() {
        return PublicKeyWithPoP;
    }
    get Signature() {
        return Signature;
    }
}

var Bls12381 = /*#__PURE__*/Object.freeze({
    __proto__: null,
    packageName: packageName$15,
    moduleAddress: moduleAddress$15,
    moduleName: moduleName$15,
    EWRONG_SIZE: EWRONG_SIZE,
    EZERO_PUBKEYS: EZERO_PUBKEYS,
    PUBLIC_KEY_NUM_BYTES: PUBLIC_KEY_NUM_BYTES,
    RANDOM_PK: RANDOM_PK,
    RANDOM_SIGNATURE: RANDOM_SIGNATURE,
    SIGNATURE_SIZE: SIGNATURE_SIZE,
    AggrOrMultiSignature: AggrOrMultiSignature,
    AggrPublicKeysWithPoP: AggrPublicKeysWithPoP,
    ProofOfPossession: ProofOfPossession,
    PublicKey: PublicKey,
    PublicKeyWithPoP: PublicKeyWithPoP,
    Signature: Signature,
    aggr_or_multi_signature_from_bytes_: aggr_or_multi_signature_from_bytes_,
    aggr_or_multi_signature_subgroup_check_: aggr_or_multi_signature_subgroup_check_,
    aggr_or_multi_signature_to_bytes_: aggr_or_multi_signature_to_bytes_,
    aggregate_pubkey_to_bytes_: aggregate_pubkey_to_bytes_,
    aggregate_pubkeys_: aggregate_pubkeys_,
    aggregate_pubkeys_internal_: aggregate_pubkeys_internal_,
    aggregate_signatures_: aggregate_signatures_,
    aggregate_signatures_internal_: aggregate_signatures_internal_,
    proof_of_possession_from_bytes_: proof_of_possession_from_bytes_,
    proof_of_possession_to_bytes_: proof_of_possession_to_bytes_,
    public_key_from_bytes_: public_key_from_bytes_,
    public_key_from_bytes_with_pop_: public_key_from_bytes_with_pop_,
    public_key_to_bytes_: public_key_to_bytes_,
    public_key_with_pop_to_bytes_: public_key_with_pop_to_bytes_,
    signature_from_bytes_: signature_from_bytes_,
    signature_subgroup_check_: signature_subgroup_check_,
    signature_subgroup_check_internal_: signature_subgroup_check_internal_,
    signature_to_bytes_: signature_to_bytes_,
    validate_pubkey_internal_: validate_pubkey_internal_,
    verify_aggregate_signature_: verify_aggregate_signature_,
    verify_aggregate_signature_internal_: verify_aggregate_signature_internal_,
    verify_multisignature_: verify_multisignature_,
    verify_multisignature_internal_: verify_multisignature_internal_,
    verify_normal_signature_: verify_normal_signature_,
    verify_normal_signature_internal_: verify_normal_signature_internal_,
    verify_proof_of_possession_internal_: verify_proof_of_possession_internal_,
    verify_signature_share_: verify_signature_share_,
    verify_signature_share_internal_: verify_signature_share_internal_,
    loadParsers: loadParsers$1i,
    App: App$1j
});

const packageName$14 = 'AptosStdlib';
const moduleAddress$14 = new HexString('0x1');
const moduleName$14 = 'math64';
function average_$1(a, b, $c) {
    let temp$1;
    if ($.copy(a).lt($.copy(b))) {
        temp$1 = $.copy(a).add($.copy(b).sub($.copy(a)).div(u64('2')));
    }
    else {
        temp$1 = $.copy(b).add($.copy(a).sub($.copy(b)).div(u64('2')));
    }
    return temp$1;
}
function max_$1(a, b, $c) {
    let temp$1;
    if ($.copy(a).ge($.copy(b))) {
        temp$1 = $.copy(a);
    }
    else {
        temp$1 = $.copy(b);
    }
    return temp$1;
}
function min_$1(a, b, $c) {
    let temp$1;
    if ($.copy(a).lt($.copy(b))) {
        temp$1 = $.copy(a);
    }
    else {
        temp$1 = $.copy(b);
    }
    return temp$1;
}
function pow_$1(n, e, $c) {
    let temp$1, p;
    if ($.copy(e).eq(u64('0'))) {
        temp$1 = u64('1');
    }
    else {
        p = u64('1');
        while ($.copy(e).gt(u64('1'))) {
            {
                if ($.copy(e).mod(u64('2')).eq(u64('1'))) {
                    p = $.copy(p).mul($.copy(n));
                }
                e = $.copy(e).div(u64('2'));
                n = $.copy(n).mul($.copy(n));
            }
        }
        temp$1 = $.copy(p).mul($.copy(n));
    }
    return temp$1;
}
function loadParsers$1h(repo) { }
class App$1i {
    constructor(client, repo, cache) {
        this.client = client;
        this.repo = repo;
        this.cache = cache;
    }
    get moduleAddress() {
        {
            return moduleAddress$14;
        }
    }
    get moduleName() {
        {
            return moduleName$14;
        }
    }
}

var Math64 = /*#__PURE__*/Object.freeze({
    __proto__: null,
    packageName: packageName$14,
    moduleAddress: moduleAddress$14,
    moduleName: moduleName$14,
    average_: average_$1,
    max_: max_$1,
    min_: min_$1,
    pow_: pow_$1,
    loadParsers: loadParsers$1h,
    App: App$1i
});

const packageName$13 = 'AptosFramework';
const moduleAddress$13 = new HexString('0x1');
const moduleName$13 = 'staking_config';
const EINVALID_REWARDS_RATE = u64('5');
const EINVALID_STAKE_RANGE = u64('3');
const EINVALID_VOTING_POWER_INCREASE_LIMIT = u64('4');
const EZERO_LOCKUP_DURATION = u64('1');
const EZERO_REWARDS_RATE_DENOMINATOR = u64('2');
const MAX_REWARDS_RATE$1 = u64('1000000');
class StakingConfig {
    constructor(proto, typeTag) {
        this.typeTag = typeTag;
        this.__app = null;
        this.minimum_stake = proto['minimum_stake'];
        this.maximum_stake = proto['maximum_stake'];
        this.recurring_lockup_duration_secs = proto['recurring_lockup_duration_secs'];
        this.allow_validator_set_change = proto['allow_validator_set_change'];
        this.rewards_rate = proto['rewards_rate'];
        this.rewards_rate_denominator = proto['rewards_rate_denominator'];
        this.voting_power_increase_limit = proto['voting_power_increase_limit'];
    }
    static StakingConfigParser(data, typeTag, repo) {
        const proto = $.parseStructProto(data, typeTag, repo, StakingConfig);
        return new StakingConfig(proto, typeTag);
    }
    static load(repo, client, address, typeParams) {
        return __awaiter(this, void 0, void 0, function* () {
            const result = yield repo.loadResource(client, address, StakingConfig, typeParams);
            return result;
        });
    }
    static loadByApp(app, address, typeParams) {
        return __awaiter(this, void 0, void 0, function* () {
            const result = yield app.repo.loadResource(app.client, address, StakingConfig, typeParams);
            yield result.loadFullState(app);
            return result;
        });
    }
    static getTag() {
        return new StructTag(moduleAddress$13, moduleName$13, 'StakingConfig', []);
    }
    loadFullState(app) {
        return __awaiter(this, void 0, void 0, function* () {
            this.__app = app;
        });
    }
}
StakingConfig.moduleAddress = moduleAddress$13;
StakingConfig.moduleName = moduleName$13;
StakingConfig.structName = 'StakingConfig';
StakingConfig.typeParameters = [];
StakingConfig.fields = [
    { name: 'minimum_stake', typeTag: AtomicTypeTag.U64 },
    { name: 'maximum_stake', typeTag: AtomicTypeTag.U64 },
    { name: 'recurring_lockup_duration_secs', typeTag: AtomicTypeTag.U64 },
    { name: 'allow_validator_set_change', typeTag: AtomicTypeTag.Bool },
    { name: 'rewards_rate', typeTag: AtomicTypeTag.U64 },
    { name: 'rewards_rate_denominator', typeTag: AtomicTypeTag.U64 },
    { name: 'voting_power_increase_limit', typeTag: AtomicTypeTag.U64 }
];
function get_$2($c) {
    return $.copy($c.borrow_global(new SimpleStructTag(StakingConfig), new HexString('0x1')));
}
function get_allow_validator_set_change_(config, $c) {
    return $.copy(config.allow_validator_set_change);
}
function get_recurring_lockup_duration_(config, $c) {
    return $.copy(config.recurring_lockup_duration_secs);
}
function get_required_stake_(config, $c) {
    return [$.copy(config.minimum_stake), $.copy(config.maximum_stake)];
}
function get_reward_rate_(config, $c) {
    return [$.copy(config.rewards_rate), $.copy(config.rewards_rate_denominator)];
}
function get_voting_power_increase_limit_(config, $c) {
    return $.copy(config.voting_power_increase_limit);
}
function initialize_$h(aptos_framework, minimum_stake, maximum_stake, recurring_lockup_duration_secs, allow_validator_set_change, rewards_rate, rewards_rate_denominator, voting_power_increase_limit, $c) {
    let temp$1;
    assert_aptos_framework_(aptos_framework, $c);
    validate_required_stake_($.copy(minimum_stake), $.copy(maximum_stake));
    if (!$.copy(recurring_lockup_duration_secs).gt(u64('0'))) {
        throw $.abortCode(invalid_argument_($.copy(EZERO_LOCKUP_DURATION)));
    }
    if (!$.copy(rewards_rate_denominator).gt(u64('0'))) {
        throw $.abortCode(invalid_argument_($.copy(EZERO_REWARDS_RATE_DENOMINATOR)));
    }
    if ($.copy(voting_power_increase_limit).gt(u64('0'))) {
        temp$1 = $.copy(voting_power_increase_limit).le(u64('50'));
    }
    else {
        temp$1 = false;
    }
    if (!temp$1) {
        throw $.abortCode(invalid_argument_($.copy(EINVALID_VOTING_POWER_INCREASE_LIMIT)));
    }
    if (!$.copy(rewards_rate).le($.copy(MAX_REWARDS_RATE$1))) {
        throw $.abortCode(invalid_argument_($.copy(EINVALID_REWARDS_RATE)));
    }
    if (!$.copy(rewards_rate).le($.copy(rewards_rate_denominator))) {
        throw $.abortCode(invalid_argument_($.copy(EINVALID_REWARDS_RATE)));
    }
    $c.move_to(new SimpleStructTag(StakingConfig), aptos_framework, new StakingConfig({
        minimum_stake: $.copy(minimum_stake),
        maximum_stake: $.copy(maximum_stake),
        recurring_lockup_duration_secs: $.copy(recurring_lockup_duration_secs),
        allow_validator_set_change: allow_validator_set_change,
        rewards_rate: $.copy(rewards_rate),
        rewards_rate_denominator: $.copy(rewards_rate_denominator),
        voting_power_increase_limit: $.copy(voting_power_increase_limit)
    }, new SimpleStructTag(StakingConfig)));
    return;
}
function update_recurring_lockup_duration_secs_(aptos_framework, new_recurring_lockup_duration_secs, $c) {
    let staking_config;
    if (!$.copy(new_recurring_lockup_duration_secs).gt(u64('0'))) {
        throw $.abortCode(invalid_argument_($.copy(EZERO_LOCKUP_DURATION)));
    }
    assert_aptos_framework_(aptos_framework, $c);
    staking_config = $c.borrow_global_mut(new SimpleStructTag(StakingConfig), new HexString('0x1'));
    staking_config.recurring_lockup_duration_secs = $.copy(new_recurring_lockup_duration_secs);
    return;
}
function update_required_stake_(aptos_framework, minimum_stake, maximum_stake, $c) {
    let staking_config;
    assert_aptos_framework_(aptos_framework, $c);
    validate_required_stake_($.copy(minimum_stake), $.copy(maximum_stake));
    staking_config = $c.borrow_global_mut(new SimpleStructTag(StakingConfig), new HexString('0x1'));
    staking_config.minimum_stake = $.copy(minimum_stake);
    staking_config.maximum_stake = $.copy(maximum_stake);
    return;
}
function update_rewards_rate_(aptos_framework, new_rewards_rate, new_rewards_rate_denominator, $c) {
    let staking_config;
    assert_aptos_framework_(aptos_framework, $c);
    if (!$.copy(new_rewards_rate_denominator).gt(u64('0'))) {
        throw $.abortCode(invalid_argument_($.copy(EZERO_REWARDS_RATE_DENOMINATOR)));
    }
    if (!$.copy(new_rewards_rate).le($.copy(MAX_REWARDS_RATE$1))) {
        throw $.abortCode(invalid_argument_($.copy(EINVALID_REWARDS_RATE)));
    }
    if (!$.copy(new_rewards_rate).le($.copy(new_rewards_rate_denominator))) {
        throw $.abortCode(invalid_argument_($.copy(EINVALID_REWARDS_RATE)));
    }
    staking_config = $c.borrow_global_mut(new SimpleStructTag(StakingConfig), new HexString('0x1'));
    staking_config.rewards_rate = $.copy(new_rewards_rate);
    staking_config.rewards_rate_denominator = $.copy(new_rewards_rate_denominator);
    return;
}
function update_voting_power_increase_limit_(aptos_framework, new_voting_power_increase_limit, $c) {
    let temp$1, staking_config;
    assert_aptos_framework_(aptos_framework, $c);
    if ($.copy(new_voting_power_increase_limit).gt(u64('0'))) {
        temp$1 = $.copy(new_voting_power_increase_limit).le(u64('50'));
    }
    else {
        temp$1 = false;
    }
    if (!temp$1) {
        throw $.abortCode(invalid_argument_($.copy(EINVALID_VOTING_POWER_INCREASE_LIMIT)));
    }
    staking_config = $c.borrow_global_mut(new SimpleStructTag(StakingConfig), new HexString('0x1'));
    staking_config.voting_power_increase_limit = $.copy(new_voting_power_increase_limit);
    return;
}
function validate_required_stake_(minimum_stake, maximum_stake, $c) {
    let temp$1;
    if ($.copy(minimum_stake).le($.copy(maximum_stake))) {
        temp$1 = $.copy(maximum_stake).gt(u64('0'));
    }
    else {
        temp$1 = false;
    }
    if (!temp$1) {
        throw $.abortCode(invalid_argument_($.copy(EINVALID_STAKE_RANGE)));
    }
    return;
}
function loadParsers$1g(repo) {
    repo.addParser('0x1::staking_config::StakingConfig', StakingConfig.StakingConfigParser);
}
class App$1h {
    constructor(client, repo, cache) {
        this.client = client;
        this.repo = repo;
        this.cache = cache;
    }
    get moduleAddress() {
        {
            return moduleAddress$13;
        }
    }
    get moduleName() {
        {
            return moduleName$13;
        }
    }
    get StakingConfig() {
        return StakingConfig;
    }
    loadStakingConfig(owner, loadFull = true, fillCache = true) {
        return __awaiter(this, void 0, void 0, function* () {
            const val = yield StakingConfig.load(this.repo, this.client, owner, []);
            if (loadFull) {
                yield val.loadFullState(this);
            }
            if (fillCache) {
                this.cache.set(val.typeTag, owner, val);
            }
            return val;
        });
    }
}

var Staking_config = /*#__PURE__*/Object.freeze({
    __proto__: null,
    packageName: packageName$13,
    moduleAddress: moduleAddress$13,
    moduleName: moduleName$13,
    EINVALID_REWARDS_RATE: EINVALID_REWARDS_RATE,
    EINVALID_STAKE_RANGE: EINVALID_STAKE_RANGE,
    EINVALID_VOTING_POWER_INCREASE_LIMIT: EINVALID_VOTING_POWER_INCREASE_LIMIT,
    EZERO_LOCKUP_DURATION: EZERO_LOCKUP_DURATION,
    EZERO_REWARDS_RATE_DENOMINATOR: EZERO_REWARDS_RATE_DENOMINATOR,
    MAX_REWARDS_RATE: MAX_REWARDS_RATE$1,
    StakingConfig: StakingConfig,
    get_: get_$2,
    get_allow_validator_set_change_: get_allow_validator_set_change_,
    get_recurring_lockup_duration_: get_recurring_lockup_duration_,
    get_required_stake_: get_required_stake_,
    get_reward_rate_: get_reward_rate_,
    get_voting_power_increase_limit_: get_voting_power_increase_limit_,
    initialize_: initialize_$h,
    update_recurring_lockup_duration_secs_: update_recurring_lockup_duration_secs_,
    update_required_stake_: update_required_stake_,
    update_rewards_rate_: update_rewards_rate_,
    update_voting_power_increase_limit_: update_voting_power_increase_limit_,
    validate_required_stake_: validate_required_stake_,
    loadParsers: loadParsers$1g,
    App: App$1h
});

const packageName$12 = 'AptosFramework';
const moduleAddress$12 = new HexString('0x1');
const moduleName$12 = 'timestamp';
const EINVALID_TIMESTAMP = u64('2');
const ENOT_OPERATING = u64('1');
const MICRO_CONVERSION_FACTOR = u64('1000000');
class CurrentTimeMicroseconds {
    constructor(proto, typeTag) {
        this.typeTag = typeTag;
        this.__app = null;
        this.microseconds = proto['microseconds'];
    }
    static CurrentTimeMicrosecondsParser(data, typeTag, repo) {
        const proto = $.parseStructProto(data, typeTag, repo, CurrentTimeMicroseconds);
        return new CurrentTimeMicroseconds(proto, typeTag);
    }
    static load(repo, client, address, typeParams) {
        return __awaiter(this, void 0, void 0, function* () {
            const result = yield repo.loadResource(client, address, CurrentTimeMicroseconds, typeParams);
            return result;
        });
    }
    static loadByApp(app, address, typeParams) {
        return __awaiter(this, void 0, void 0, function* () {
            const result = yield app.repo.loadResource(app.client, address, CurrentTimeMicroseconds, typeParams);
            yield result.loadFullState(app);
            return result;
        });
    }
    static getTag() {
        return new StructTag(moduleAddress$12, moduleName$12, 'CurrentTimeMicroseconds', []);
    }
    loadFullState(app) {
        return __awaiter(this, void 0, void 0, function* () {
            this.__app = app;
        });
    }
}
CurrentTimeMicroseconds.moduleAddress = moduleAddress$12;
CurrentTimeMicroseconds.moduleName = moduleName$12;
CurrentTimeMicroseconds.structName = 'CurrentTimeMicroseconds';
CurrentTimeMicroseconds.typeParameters = [];
CurrentTimeMicroseconds.fields = [{ name: 'microseconds', typeTag: AtomicTypeTag.U64 }];
function now_microseconds_($c) {
    return $.copy($c.borrow_global(new SimpleStructTag(CurrentTimeMicroseconds), new HexString('0x1'))
        .microseconds);
}
function now_seconds_($c) {
    return now_microseconds_($c).div($.copy(MICRO_CONVERSION_FACTOR));
}
function set_time_has_started_(aptos_framework, $c) {
    let timer;
    assert_aptos_framework_(aptos_framework, $c);
    timer = new CurrentTimeMicroseconds({ microseconds: u64('0') }, new SimpleStructTag(CurrentTimeMicroseconds));
    $c.move_to(new SimpleStructTag(CurrentTimeMicroseconds), aptos_framework, timer);
    return;
}
function update_global_time_(account, proposer, timestamp, $c) {
    let global_timer, now;
    assert_vm_(account, $c);
    global_timer = $c.borrow_global_mut(new SimpleStructTag(CurrentTimeMicroseconds), new HexString('0x1'));
    now = $.copy(global_timer.microseconds);
    if ($.copy(proposer).hex() === new HexString('0x0').hex()) {
        if (!$.copy(now).eq($.copy(timestamp))) {
            throw $.abortCode(invalid_argument_($.copy(EINVALID_TIMESTAMP)));
        }
    }
    else {
        if (!$.copy(now).lt($.copy(timestamp))) {
            throw $.abortCode(invalid_argument_($.copy(EINVALID_TIMESTAMP)));
        }
        global_timer.microseconds = $.copy(timestamp);
    }
    return;
}
function loadParsers$1f(repo) {
    repo.addParser('0x1::timestamp::CurrentTimeMicroseconds', CurrentTimeMicroseconds.CurrentTimeMicrosecondsParser);
}
class App$1g {
    constructor(client, repo, cache) {
        this.client = client;
        this.repo = repo;
        this.cache = cache;
    }
    get moduleAddress() {
        {
            return moduleAddress$12;
        }
    }
    get moduleName() {
        {
            return moduleName$12;
        }
    }
    get CurrentTimeMicroseconds() {
        return CurrentTimeMicroseconds;
    }
    loadCurrentTimeMicroseconds(owner, loadFull = true, fillCache = true) {
        return __awaiter(this, void 0, void 0, function* () {
            const val = yield CurrentTimeMicroseconds.load(this.repo, this.client, owner, []);
            if (loadFull) {
                yield val.loadFullState(this);
            }
            if (fillCache) {
                this.cache.set(val.typeTag, owner, val);
            }
            return val;
        });
    }
}

var Timestamp = /*#__PURE__*/Object.freeze({
    __proto__: null,
    packageName: packageName$12,
    moduleAddress: moduleAddress$12,
    moduleName: moduleName$12,
    EINVALID_TIMESTAMP: EINVALID_TIMESTAMP,
    ENOT_OPERATING: ENOT_OPERATING,
    MICRO_CONVERSION_FACTOR: MICRO_CONVERSION_FACTOR,
    CurrentTimeMicroseconds: CurrentTimeMicroseconds,
    now_microseconds_: now_microseconds_,
    now_seconds_: now_seconds_,
    set_time_has_started_: set_time_has_started_,
    update_global_time_: update_global_time_,
    loadParsers: loadParsers$1f,
    App: App$1g
});

const packageName$11 = 'AptosFramework';
const moduleAddress$11 = new HexString('0x1');
const moduleName$11 = 'stake';
const EALREADY_ACTIVE_VALIDATOR = u64('4');
const EALREADY_REGISTERED = u64('8');
const EINELIGIBLE_VALIDATOR = u64('17');
const EINVALID_LOCKUP = u64('18');
const EINVALID_PUBLIC_KEY = u64('11');
const ELAST_VALIDATOR = u64('6');
const ENOT_OPERATOR = u64('9');
const ENOT_VALIDATOR = u64('5');
const ENO_POST_GENESIS_VALIDATOR_SET_CHANGE_ALLOWED = u64('10');
const EOWNER_CAP_ALREADY_EXISTS = u64('16');
const EOWNER_CAP_NOT_FOUND = u64('15');
const ESTAKE_EXCEEDS_MAX = u64('7');
const ESTAKE_POOL_DOES_NOT_EXIST = u64('14');
const ESTAKE_TOO_HIGH = u64('3');
const ESTAKE_TOO_LOW = u64('2');
const EVALIDATOR_CONFIG = u64('1');
const EVALIDATOR_SET_TOO_LARGE = u64('12');
const EVOTING_POWER_INCREASE_EXCEEDS_LIMIT = u64('13');
const MAX_REWARDS_RATE = u64('1000000');
const MAX_VALIDATOR_SET_SIZE = u64('65536');
const VALIDATOR_STATUS_ACTIVE = u64('2');
const VALIDATOR_STATUS_INACTIVE = u64('4');
const VALIDATOR_STATUS_PENDING_ACTIVE = u64('1');
const VALIDATOR_STATUS_PENDING_INACTIVE = u64('3');
class AddStakeEvent$1 {
    constructor(proto, typeTag) {
        this.typeTag = typeTag;
        this.__app = null;
        this.pool_address = proto['pool_address'];
        this.amount_added = proto['amount_added'];
    }
    static AddStakeEventParser(data, typeTag, repo) {
        const proto = $.parseStructProto(data, typeTag, repo, AddStakeEvent$1);
        return new AddStakeEvent$1(proto, typeTag);
    }
    static getTag() {
        return new StructTag(moduleAddress$11, moduleName$11, 'AddStakeEvent', []);
    }
    loadFullState(app) {
        return __awaiter(this, void 0, void 0, function* () {
            this.__app = app;
        });
    }
}
AddStakeEvent$1.moduleAddress = moduleAddress$11;
AddStakeEvent$1.moduleName = moduleName$11;
AddStakeEvent$1.structName = 'AddStakeEvent';
AddStakeEvent$1.typeParameters = [];
AddStakeEvent$1.fields = [
    { name: 'pool_address', typeTag: AtomicTypeTag.Address },
    { name: 'amount_added', typeTag: AtomicTypeTag.U64 }
];
class AllowedValidators {
    constructor(proto, typeTag) {
        this.typeTag = typeTag;
        this.__app = null;
        this.accounts = proto['accounts'];
    }
    static AllowedValidatorsParser(data, typeTag, repo) {
        const proto = $.parseStructProto(data, typeTag, repo, AllowedValidators);
        return new AllowedValidators(proto, typeTag);
    }
    static load(repo, client, address, typeParams) {
        return __awaiter(this, void 0, void 0, function* () {
            const result = yield repo.loadResource(client, address, AllowedValidators, typeParams);
            return result;
        });
    }
    static loadByApp(app, address, typeParams) {
        return __awaiter(this, void 0, void 0, function* () {
            const result = yield app.repo.loadResource(app.client, address, AllowedValidators, typeParams);
            yield result.loadFullState(app);
            return result;
        });
    }
    static getTag() {
        return new StructTag(moduleAddress$11, moduleName$11, 'AllowedValidators', []);
    }
    loadFullState(app) {
        return __awaiter(this, void 0, void 0, function* () {
            this.__app = app;
        });
    }
}
AllowedValidators.moduleAddress = moduleAddress$11;
AllowedValidators.moduleName = moduleName$11;
AllowedValidators.structName = 'AllowedValidators';
AllowedValidators.typeParameters = [];
AllowedValidators.fields = [{ name: 'accounts', typeTag: new VectorTag(AtomicTypeTag.Address) }];
class AptosCoinCapabilities$1 {
    constructor(proto, typeTag) {
        this.typeTag = typeTag;
        this.__app = null;
        this.mint_cap = proto['mint_cap'];
    }
    static AptosCoinCapabilitiesParser(data, typeTag, repo) {
        const proto = $.parseStructProto(data, typeTag, repo, AptosCoinCapabilities$1);
        return new AptosCoinCapabilities$1(proto, typeTag);
    }
    static load(repo, client, address, typeParams) {
        return __awaiter(this, void 0, void 0, function* () {
            const result = yield repo.loadResource(client, address, AptosCoinCapabilities$1, typeParams);
            return result;
        });
    }
    static loadByApp(app, address, typeParams) {
        return __awaiter(this, void 0, void 0, function* () {
            const result = yield app.repo.loadResource(app.client, address, AptosCoinCapabilities$1, typeParams);
            yield result.loadFullState(app);
            return result;
        });
    }
    static getTag() {
        return new StructTag(moduleAddress$11, moduleName$11, 'AptosCoinCapabilities', []);
    }
    loadFullState(app) {
        return __awaiter(this, void 0, void 0, function* () {
            yield this.mint_cap.loadFullState(app);
            this.__app = app;
        });
    }
}
AptosCoinCapabilities$1.moduleAddress = moduleAddress$11;
AptosCoinCapabilities$1.moduleName = moduleName$11;
AptosCoinCapabilities$1.structName = 'AptosCoinCapabilities';
AptosCoinCapabilities$1.typeParameters = [];
AptosCoinCapabilities$1.fields = [
    {
        name: 'mint_cap',
        typeTag: new StructTag(new HexString('0x1'), 'coin', 'MintCapability', [
            new StructTag(new HexString('0x1'), 'aptos_coin', 'AptosCoin', [])
        ])
    }
];
class DistributeRewardsEvent {
    constructor(proto, typeTag) {
        this.typeTag = typeTag;
        this.__app = null;
        this.pool_address = proto['pool_address'];
        this.rewards_amount = proto['rewards_amount'];
    }
    static DistributeRewardsEventParser(data, typeTag, repo) {
        const proto = $.parseStructProto(data, typeTag, repo, DistributeRewardsEvent);
        return new DistributeRewardsEvent(proto, typeTag);
    }
    static getTag() {
        return new StructTag(moduleAddress$11, moduleName$11, 'DistributeRewardsEvent', []);
    }
    loadFullState(app) {
        return __awaiter(this, void 0, void 0, function* () {
            this.__app = app;
        });
    }
}
DistributeRewardsEvent.moduleAddress = moduleAddress$11;
DistributeRewardsEvent.moduleName = moduleName$11;
DistributeRewardsEvent.structName = 'DistributeRewardsEvent';
DistributeRewardsEvent.typeParameters = [];
DistributeRewardsEvent.fields = [
    { name: 'pool_address', typeTag: AtomicTypeTag.Address },
    { name: 'rewards_amount', typeTag: AtomicTypeTag.U64 }
];
class IncreaseLockupEvent {
    constructor(proto, typeTag) {
        this.typeTag = typeTag;
        this.__app = null;
        this.pool_address = proto['pool_address'];
        this.old_locked_until_secs = proto['old_locked_until_secs'];
        this.new_locked_until_secs = proto['new_locked_until_secs'];
    }
    static IncreaseLockupEventParser(data, typeTag, repo) {
        const proto = $.parseStructProto(data, typeTag, repo, IncreaseLockupEvent);
        return new IncreaseLockupEvent(proto, typeTag);
    }
    static getTag() {
        return new StructTag(moduleAddress$11, moduleName$11, 'IncreaseLockupEvent', []);
    }
    loadFullState(app) {
        return __awaiter(this, void 0, void 0, function* () {
            this.__app = app;
        });
    }
}
IncreaseLockupEvent.moduleAddress = moduleAddress$11;
IncreaseLockupEvent.moduleName = moduleName$11;
IncreaseLockupEvent.structName = 'IncreaseLockupEvent';
IncreaseLockupEvent.typeParameters = [];
IncreaseLockupEvent.fields = [
    { name: 'pool_address', typeTag: AtomicTypeTag.Address },
    { name: 'old_locked_until_secs', typeTag: AtomicTypeTag.U64 },
    { name: 'new_locked_until_secs', typeTag: AtomicTypeTag.U64 }
];
class IndividualValidatorPerformance {
    constructor(proto, typeTag) {
        this.typeTag = typeTag;
        this.__app = null;
        this.successful_proposals = proto['successful_proposals'];
        this.failed_proposals = proto['failed_proposals'];
    }
    static IndividualValidatorPerformanceParser(data, typeTag, repo) {
        const proto = $.parseStructProto(data, typeTag, repo, IndividualValidatorPerformance);
        return new IndividualValidatorPerformance(proto, typeTag);
    }
    static getTag() {
        return new StructTag(moduleAddress$11, moduleName$11, 'IndividualValidatorPerformance', []);
    }
    loadFullState(app) {
        return __awaiter(this, void 0, void 0, function* () {
            this.__app = app;
        });
    }
}
IndividualValidatorPerformance.moduleAddress = moduleAddress$11;
IndividualValidatorPerformance.moduleName = moduleName$11;
IndividualValidatorPerformance.structName = 'IndividualValidatorPerformance';
IndividualValidatorPerformance.typeParameters = [];
IndividualValidatorPerformance.fields = [
    { name: 'successful_proposals', typeTag: AtomicTypeTag.U64 },
    { name: 'failed_proposals', typeTag: AtomicTypeTag.U64 }
];
class JoinValidatorSetEvent {
    constructor(proto, typeTag) {
        this.typeTag = typeTag;
        this.__app = null;
        this.pool_address = proto['pool_address'];
    }
    static JoinValidatorSetEventParser(data, typeTag, repo) {
        const proto = $.parseStructProto(data, typeTag, repo, JoinValidatorSetEvent);
        return new JoinValidatorSetEvent(proto, typeTag);
    }
    static getTag() {
        return new StructTag(moduleAddress$11, moduleName$11, 'JoinValidatorSetEvent', []);
    }
    loadFullState(app) {
        return __awaiter(this, void 0, void 0, function* () {
            this.__app = app;
        });
    }
}
JoinValidatorSetEvent.moduleAddress = moduleAddress$11;
JoinValidatorSetEvent.moduleName = moduleName$11;
JoinValidatorSetEvent.structName = 'JoinValidatorSetEvent';
JoinValidatorSetEvent.typeParameters = [];
JoinValidatorSetEvent.fields = [{ name: 'pool_address', typeTag: AtomicTypeTag.Address }];
class LeaveValidatorSetEvent {
    constructor(proto, typeTag) {
        this.typeTag = typeTag;
        this.__app = null;
        this.pool_address = proto['pool_address'];
    }
    static LeaveValidatorSetEventParser(data, typeTag, repo) {
        const proto = $.parseStructProto(data, typeTag, repo, LeaveValidatorSetEvent);
        return new LeaveValidatorSetEvent(proto, typeTag);
    }
    static getTag() {
        return new StructTag(moduleAddress$11, moduleName$11, 'LeaveValidatorSetEvent', []);
    }
    loadFullState(app) {
        return __awaiter(this, void 0, void 0, function* () {
            this.__app = app;
        });
    }
}
LeaveValidatorSetEvent.moduleAddress = moduleAddress$11;
LeaveValidatorSetEvent.moduleName = moduleName$11;
LeaveValidatorSetEvent.structName = 'LeaveValidatorSetEvent';
LeaveValidatorSetEvent.typeParameters = [];
LeaveValidatorSetEvent.fields = [{ name: 'pool_address', typeTag: AtomicTypeTag.Address }];
class OwnerCapability {
    constructor(proto, typeTag) {
        this.typeTag = typeTag;
        this.__app = null;
        this.pool_address = proto['pool_address'];
    }
    static OwnerCapabilityParser(data, typeTag, repo) {
        const proto = $.parseStructProto(data, typeTag, repo, OwnerCapability);
        return new OwnerCapability(proto, typeTag);
    }
    static load(repo, client, address, typeParams) {
        return __awaiter(this, void 0, void 0, function* () {
            const result = yield repo.loadResource(client, address, OwnerCapability, typeParams);
            return result;
        });
    }
    static loadByApp(app, address, typeParams) {
        return __awaiter(this, void 0, void 0, function* () {
            const result = yield app.repo.loadResource(app.client, address, OwnerCapability, typeParams);
            yield result.loadFullState(app);
            return result;
        });
    }
    static getTag() {
        return new StructTag(moduleAddress$11, moduleName$11, 'OwnerCapability', []);
    }
    loadFullState(app) {
        return __awaiter(this, void 0, void 0, function* () {
            this.__app = app;
        });
    }
}
OwnerCapability.moduleAddress = moduleAddress$11;
OwnerCapability.moduleName = moduleName$11;
OwnerCapability.structName = 'OwnerCapability';
OwnerCapability.typeParameters = [];
OwnerCapability.fields = [{ name: 'pool_address', typeTag: AtomicTypeTag.Address }];
class ReactivateStakeEvent {
    constructor(proto, typeTag) {
        this.typeTag = typeTag;
        this.__app = null;
        this.pool_address = proto['pool_address'];
        this.amount = proto['amount'];
    }
    static ReactivateStakeEventParser(data, typeTag, repo) {
        const proto = $.parseStructProto(data, typeTag, repo, ReactivateStakeEvent);
        return new ReactivateStakeEvent(proto, typeTag);
    }
    static getTag() {
        return new StructTag(moduleAddress$11, moduleName$11, 'ReactivateStakeEvent', []);
    }
    loadFullState(app) {
        return __awaiter(this, void 0, void 0, function* () {
            this.__app = app;
        });
    }
}
ReactivateStakeEvent.moduleAddress = moduleAddress$11;
ReactivateStakeEvent.moduleName = moduleName$11;
ReactivateStakeEvent.structName = 'ReactivateStakeEvent';
ReactivateStakeEvent.typeParameters = [];
ReactivateStakeEvent.fields = [
    { name: 'pool_address', typeTag: AtomicTypeTag.Address },
    { name: 'amount', typeTag: AtomicTypeTag.U64 }
];
class RegisterValidatorCandidateEvent {
    constructor(proto, typeTag) {
        this.typeTag = typeTag;
        this.__app = null;
        this.pool_address = proto['pool_address'];
    }
    static RegisterValidatorCandidateEventParser(data, typeTag, repo) {
        const proto = $.parseStructProto(data, typeTag, repo, RegisterValidatorCandidateEvent);
        return new RegisterValidatorCandidateEvent(proto, typeTag);
    }
    static getTag() {
        return new StructTag(moduleAddress$11, moduleName$11, 'RegisterValidatorCandidateEvent', []);
    }
    loadFullState(app) {
        return __awaiter(this, void 0, void 0, function* () {
            this.__app = app;
        });
    }
}
RegisterValidatorCandidateEvent.moduleAddress = moduleAddress$11;
RegisterValidatorCandidateEvent.moduleName = moduleName$11;
RegisterValidatorCandidateEvent.structName = 'RegisterValidatorCandidateEvent';
RegisterValidatorCandidateEvent.typeParameters = [];
RegisterValidatorCandidateEvent.fields = [{ name: 'pool_address', typeTag: AtomicTypeTag.Address }];
class RotateConsensusKeyEvent {
    constructor(proto, typeTag) {
        this.typeTag = typeTag;
        this.__app = null;
        this.pool_address = proto['pool_address'];
        this.old_consensus_pubkey = proto['old_consensus_pubkey'];
        this.new_consensus_pubkey = proto['new_consensus_pubkey'];
    }
    static RotateConsensusKeyEventParser(data, typeTag, repo) {
        const proto = $.parseStructProto(data, typeTag, repo, RotateConsensusKeyEvent);
        return new RotateConsensusKeyEvent(proto, typeTag);
    }
    static getTag() {
        return new StructTag(moduleAddress$11, moduleName$11, 'RotateConsensusKeyEvent', []);
    }
    loadFullState(app) {
        return __awaiter(this, void 0, void 0, function* () {
            this.__app = app;
        });
    }
}
RotateConsensusKeyEvent.moduleAddress = moduleAddress$11;
RotateConsensusKeyEvent.moduleName = moduleName$11;
RotateConsensusKeyEvent.structName = 'RotateConsensusKeyEvent';
RotateConsensusKeyEvent.typeParameters = [];
RotateConsensusKeyEvent.fields = [
    { name: 'pool_address', typeTag: AtomicTypeTag.Address },
    { name: 'old_consensus_pubkey', typeTag: new VectorTag(AtomicTypeTag.U8) },
    { name: 'new_consensus_pubkey', typeTag: new VectorTag(AtomicTypeTag.U8) }
];
class SetOperatorEvent {
    constructor(proto, typeTag) {
        this.typeTag = typeTag;
        this.__app = null;
        this.pool_address = proto['pool_address'];
        this.old_operator = proto['old_operator'];
        this.new_operator = proto['new_operator'];
    }
    static SetOperatorEventParser(data, typeTag, repo) {
        const proto = $.parseStructProto(data, typeTag, repo, SetOperatorEvent);
        return new SetOperatorEvent(proto, typeTag);
    }
    static getTag() {
        return new StructTag(moduleAddress$11, moduleName$11, 'SetOperatorEvent', []);
    }
    loadFullState(app) {
        return __awaiter(this, void 0, void 0, function* () {
            this.__app = app;
        });
    }
}
SetOperatorEvent.moduleAddress = moduleAddress$11;
SetOperatorEvent.moduleName = moduleName$11;
SetOperatorEvent.structName = 'SetOperatorEvent';
SetOperatorEvent.typeParameters = [];
SetOperatorEvent.fields = [
    { name: 'pool_address', typeTag: AtomicTypeTag.Address },
    { name: 'old_operator', typeTag: AtomicTypeTag.Address },
    { name: 'new_operator', typeTag: AtomicTypeTag.Address }
];
class StakePool {
    constructor(proto, typeTag) {
        this.typeTag = typeTag;
        this.__app = null;
        this.active = proto['active'];
        this.inactive = proto['inactive'];
        this.pending_active = proto['pending_active'];
        this.pending_inactive = proto['pending_inactive'];
        this.locked_until_secs = proto['locked_until_secs'];
        this.operator_address = proto['operator_address'];
        this.delegated_voter = proto['delegated_voter'];
        this.initialize_validator_events = proto['initialize_validator_events'];
        this.set_operator_events = proto['set_operator_events'];
        this.add_stake_events = proto['add_stake_events'];
        this.reactivate_stake_events = proto['reactivate_stake_events'];
        this.rotate_consensus_key_events = proto['rotate_consensus_key_events'];
        this.update_network_and_fullnode_addresses_events = proto['update_network_and_fullnode_addresses_events'];
        this.increase_lockup_events = proto['increase_lockup_events'];
        this.join_validator_set_events = proto['join_validator_set_events'];
        this.distribute_rewards_events = proto['distribute_rewards_events'];
        this.unlock_stake_events = proto['unlock_stake_events'];
        this.withdraw_stake_events = proto['withdraw_stake_events'];
        this.leave_validator_set_events = proto['leave_validator_set_events'];
    }
    static StakePoolParser(data, typeTag, repo) {
        const proto = $.parseStructProto(data, typeTag, repo, StakePool);
        return new StakePool(proto, typeTag);
    }
    static load(repo, client, address, typeParams) {
        return __awaiter(this, void 0, void 0, function* () {
            const result = yield repo.loadResource(client, address, StakePool, typeParams);
            return result;
        });
    }
    static loadByApp(app, address, typeParams) {
        return __awaiter(this, void 0, void 0, function* () {
            const result = yield app.repo.loadResource(app.client, address, StakePool, typeParams);
            yield result.loadFullState(app);
            return result;
        });
    }
    static getTag() {
        return new StructTag(moduleAddress$11, moduleName$11, 'StakePool', []);
    }
    loadFullState(app) {
        return __awaiter(this, void 0, void 0, function* () {
            yield this.active.loadFullState(app);
            yield this.inactive.loadFullState(app);
            yield this.pending_active.loadFullState(app);
            yield this.pending_inactive.loadFullState(app);
            yield this.initialize_validator_events.loadFullState(app);
            yield this.set_operator_events.loadFullState(app);
            yield this.add_stake_events.loadFullState(app);
            yield this.reactivate_stake_events.loadFullState(app);
            yield this.rotate_consensus_key_events.loadFullState(app);
            yield this.update_network_and_fullnode_addresses_events.loadFullState(app);
            yield this.increase_lockup_events.loadFullState(app);
            yield this.join_validator_set_events.loadFullState(app);
            yield this.distribute_rewards_events.loadFullState(app);
            yield this.unlock_stake_events.loadFullState(app);
            yield this.withdraw_stake_events.loadFullState(app);
            yield this.leave_validator_set_events.loadFullState(app);
            this.__app = app;
        });
    }
}
StakePool.moduleAddress = moduleAddress$11;
StakePool.moduleName = moduleName$11;
StakePool.structName = 'StakePool';
StakePool.typeParameters = [];
StakePool.fields = [
    {
        name: 'active',
        typeTag: new StructTag(new HexString('0x1'), 'coin', 'Coin', [
            new StructTag(new HexString('0x1'), 'aptos_coin', 'AptosCoin', [])
        ])
    },
    {
        name: 'inactive',
        typeTag: new StructTag(new HexString('0x1'), 'coin', 'Coin', [
            new StructTag(new HexString('0x1'), 'aptos_coin', 'AptosCoin', [])
        ])
    },
    {
        name: 'pending_active',
        typeTag: new StructTag(new HexString('0x1'), 'coin', 'Coin', [
            new StructTag(new HexString('0x1'), 'aptos_coin', 'AptosCoin', [])
        ])
    },
    {
        name: 'pending_inactive',
        typeTag: new StructTag(new HexString('0x1'), 'coin', 'Coin', [
            new StructTag(new HexString('0x1'), 'aptos_coin', 'AptosCoin', [])
        ])
    },
    { name: 'locked_until_secs', typeTag: AtomicTypeTag.U64 },
    { name: 'operator_address', typeTag: AtomicTypeTag.Address },
    { name: 'delegated_voter', typeTag: AtomicTypeTag.Address },
    {
        name: 'initialize_validator_events',
        typeTag: new StructTag(new HexString('0x1'), 'event', 'EventHandle', [
            new StructTag(new HexString('0x1'), 'stake', 'RegisterValidatorCandidateEvent', [])
        ])
    },
    {
        name: 'set_operator_events',
        typeTag: new StructTag(new HexString('0x1'), 'event', 'EventHandle', [
            new StructTag(new HexString('0x1'), 'stake', 'SetOperatorEvent', [])
        ])
    },
    {
        name: 'add_stake_events',
        typeTag: new StructTag(new HexString('0x1'), 'event', 'EventHandle', [
            new StructTag(new HexString('0x1'), 'stake', 'AddStakeEvent', [])
        ])
    },
    {
        name: 'reactivate_stake_events',
        typeTag: new StructTag(new HexString('0x1'), 'event', 'EventHandle', [
            new StructTag(new HexString('0x1'), 'stake', 'ReactivateStakeEvent', [])
        ])
    },
    {
        name: 'rotate_consensus_key_events',
        typeTag: new StructTag(new HexString('0x1'), 'event', 'EventHandle', [
            new StructTag(new HexString('0x1'), 'stake', 'RotateConsensusKeyEvent', [])
        ])
    },
    {
        name: 'update_network_and_fullnode_addresses_events',
        typeTag: new StructTag(new HexString('0x1'), 'event', 'EventHandle', [
            new StructTag(new HexString('0x1'), 'stake', 'UpdateNetworkAndFullnodeAddressesEvent', [])
        ])
    },
    {
        name: 'increase_lockup_events',
        typeTag: new StructTag(new HexString('0x1'), 'event', 'EventHandle', [
            new StructTag(new HexString('0x1'), 'stake', 'IncreaseLockupEvent', [])
        ])
    },
    {
        name: 'join_validator_set_events',
        typeTag: new StructTag(new HexString('0x1'), 'event', 'EventHandle', [
            new StructTag(new HexString('0x1'), 'stake', 'JoinValidatorSetEvent', [])
        ])
    },
    {
        name: 'distribute_rewards_events',
        typeTag: new StructTag(new HexString('0x1'), 'event', 'EventHandle', [
            new StructTag(new HexString('0x1'), 'stake', 'DistributeRewardsEvent', [])
        ])
    },
    {
        name: 'unlock_stake_events',
        typeTag: new StructTag(new HexString('0x1'), 'event', 'EventHandle', [
            new StructTag(new HexString('0x1'), 'stake', 'UnlockStakeEvent', [])
        ])
    },
    {
        name: 'withdraw_stake_events',
        typeTag: new StructTag(new HexString('0x1'), 'event', 'EventHandle', [
            new StructTag(new HexString('0x1'), 'stake', 'WithdrawStakeEvent', [])
        ])
    },
    {
        name: 'leave_validator_set_events',
        typeTag: new StructTag(new HexString('0x1'), 'event', 'EventHandle', [
            new StructTag(new HexString('0x1'), 'stake', 'LeaveValidatorSetEvent', [])
        ])
    }
];
class UnlockStakeEvent$1 {
    constructor(proto, typeTag) {
        this.typeTag = typeTag;
        this.__app = null;
        this.pool_address = proto['pool_address'];
        this.amount_unlocked = proto['amount_unlocked'];
    }
    static UnlockStakeEventParser(data, typeTag, repo) {
        const proto = $.parseStructProto(data, typeTag, repo, UnlockStakeEvent$1);
        return new UnlockStakeEvent$1(proto, typeTag);
    }
    static getTag() {
        return new StructTag(moduleAddress$11, moduleName$11, 'UnlockStakeEvent', []);
    }
    loadFullState(app) {
        return __awaiter(this, void 0, void 0, function* () {
            this.__app = app;
        });
    }
}
UnlockStakeEvent$1.moduleAddress = moduleAddress$11;
UnlockStakeEvent$1.moduleName = moduleName$11;
UnlockStakeEvent$1.structName = 'UnlockStakeEvent';
UnlockStakeEvent$1.typeParameters = [];
UnlockStakeEvent$1.fields = [
    { name: 'pool_address', typeTag: AtomicTypeTag.Address },
    { name: 'amount_unlocked', typeTag: AtomicTypeTag.U64 }
];
class UpdateNetworkAndFullnodeAddressesEvent {
    constructor(proto, typeTag) {
        this.typeTag = typeTag;
        this.__app = null;
        this.pool_address = proto['pool_address'];
        this.old_network_addresses = proto['old_network_addresses'];
        this.new_network_addresses = proto['new_network_addresses'];
        this.old_fullnode_addresses = proto['old_fullnode_addresses'];
        this.new_fullnode_addresses = proto['new_fullnode_addresses'];
    }
    static UpdateNetworkAndFullnodeAddressesEventParser(data, typeTag, repo) {
        const proto = $.parseStructProto(data, typeTag, repo, UpdateNetworkAndFullnodeAddressesEvent);
        return new UpdateNetworkAndFullnodeAddressesEvent(proto, typeTag);
    }
    static getTag() {
        return new StructTag(moduleAddress$11, moduleName$11, 'UpdateNetworkAndFullnodeAddressesEvent', []);
    }
    loadFullState(app) {
        return __awaiter(this, void 0, void 0, function* () {
            this.__app = app;
        });
    }
}
UpdateNetworkAndFullnodeAddressesEvent.moduleAddress = moduleAddress$11;
UpdateNetworkAndFullnodeAddressesEvent.moduleName = moduleName$11;
UpdateNetworkAndFullnodeAddressesEvent.structName = 'UpdateNetworkAndFullnodeAddressesEvent';
UpdateNetworkAndFullnodeAddressesEvent.typeParameters = [];
UpdateNetworkAndFullnodeAddressesEvent.fields = [
    { name: 'pool_address', typeTag: AtomicTypeTag.Address },
    { name: 'old_network_addresses', typeTag: new VectorTag(AtomicTypeTag.U8) },
    { name: 'new_network_addresses', typeTag: new VectorTag(AtomicTypeTag.U8) },
    { name: 'old_fullnode_addresses', typeTag: new VectorTag(AtomicTypeTag.U8) },
    { name: 'new_fullnode_addresses', typeTag: new VectorTag(AtomicTypeTag.U8) }
];
class ValidatorConfig {
    constructor(proto, typeTag) {
        this.typeTag = typeTag;
        this.__app = null;
        this.consensus_pubkey = proto['consensus_pubkey'];
        this.network_addresses = proto['network_addresses'];
        this.fullnode_addresses = proto['fullnode_addresses'];
        this.validator_index = proto['validator_index'];
    }
    static ValidatorConfigParser(data, typeTag, repo) {
        const proto = $.parseStructProto(data, typeTag, repo, ValidatorConfig);
        return new ValidatorConfig(proto, typeTag);
    }
    static load(repo, client, address, typeParams) {
        return __awaiter(this, void 0, void 0, function* () {
            const result = yield repo.loadResource(client, address, ValidatorConfig, typeParams);
            return result;
        });
    }
    static loadByApp(app, address, typeParams) {
        return __awaiter(this, void 0, void 0, function* () {
            const result = yield app.repo.loadResource(app.client, address, ValidatorConfig, typeParams);
            yield result.loadFullState(app);
            return result;
        });
    }
    static getTag() {
        return new StructTag(moduleAddress$11, moduleName$11, 'ValidatorConfig', []);
    }
    loadFullState(app) {
        return __awaiter(this, void 0, void 0, function* () {
            this.__app = app;
        });
    }
}
ValidatorConfig.moduleAddress = moduleAddress$11;
ValidatorConfig.moduleName = moduleName$11;
ValidatorConfig.structName = 'ValidatorConfig';
ValidatorConfig.typeParameters = [];
ValidatorConfig.fields = [
    { name: 'consensus_pubkey', typeTag: new VectorTag(AtomicTypeTag.U8) },
    { name: 'network_addresses', typeTag: new VectorTag(AtomicTypeTag.U8) },
    { name: 'fullnode_addresses', typeTag: new VectorTag(AtomicTypeTag.U8) },
    { name: 'validator_index', typeTag: AtomicTypeTag.U64 }
];
class ValidatorInfo {
    constructor(proto, typeTag) {
        this.typeTag = typeTag;
        this.__app = null;
        this.addr = proto['addr'];
        this.voting_power = proto['voting_power'];
        this.config = proto['config'];
    }
    static ValidatorInfoParser(data, typeTag, repo) {
        const proto = $.parseStructProto(data, typeTag, repo, ValidatorInfo);
        return new ValidatorInfo(proto, typeTag);
    }
    static getTag() {
        return new StructTag(moduleAddress$11, moduleName$11, 'ValidatorInfo', []);
    }
    loadFullState(app) {
        return __awaiter(this, void 0, void 0, function* () {
            yield this.config.loadFullState(app);
            this.__app = app;
        });
    }
}
ValidatorInfo.moduleAddress = moduleAddress$11;
ValidatorInfo.moduleName = moduleName$11;
ValidatorInfo.structName = 'ValidatorInfo';
ValidatorInfo.typeParameters = [];
ValidatorInfo.fields = [
    { name: 'addr', typeTag: AtomicTypeTag.Address },
    { name: 'voting_power', typeTag: AtomicTypeTag.U64 },
    { name: 'config', typeTag: new StructTag(new HexString('0x1'), 'stake', 'ValidatorConfig', []) }
];
class ValidatorPerformance {
    constructor(proto, typeTag) {
        this.typeTag = typeTag;
        this.__app = null;
        this.validators = proto['validators'];
    }
    static ValidatorPerformanceParser(data, typeTag, repo) {
        const proto = $.parseStructProto(data, typeTag, repo, ValidatorPerformance);
        return new ValidatorPerformance(proto, typeTag);
    }
    static load(repo, client, address, typeParams) {
        return __awaiter(this, void 0, void 0, function* () {
            const result = yield repo.loadResource(client, address, ValidatorPerformance, typeParams);
            return result;
        });
    }
    static loadByApp(app, address, typeParams) {
        return __awaiter(this, void 0, void 0, function* () {
            const result = yield app.repo.loadResource(app.client, address, ValidatorPerformance, typeParams);
            yield result.loadFullState(app);
            return result;
        });
    }
    static getTag() {
        return new StructTag(moduleAddress$11, moduleName$11, 'ValidatorPerformance', []);
    }
    loadFullState(app) {
        return __awaiter(this, void 0, void 0, function* () {
            this.__app = app;
        });
    }
}
ValidatorPerformance.moduleAddress = moduleAddress$11;
ValidatorPerformance.moduleName = moduleName$11;
ValidatorPerformance.structName = 'ValidatorPerformance';
ValidatorPerformance.typeParameters = [];
ValidatorPerformance.fields = [
    {
        name: 'validators',
        typeTag: new VectorTag(new StructTag(new HexString('0x1'), 'stake', 'IndividualValidatorPerformance', []))
    }
];
class ValidatorSet {
    constructor(proto, typeTag) {
        this.typeTag = typeTag;
        this.__app = null;
        this.consensus_scheme = proto['consensus_scheme'];
        this.active_validators = proto['active_validators'];
        this.pending_inactive = proto['pending_inactive'];
        this.pending_active = proto['pending_active'];
        this.total_voting_power = proto['total_voting_power'];
        this.total_joining_power = proto['total_joining_power'];
    }
    static ValidatorSetParser(data, typeTag, repo) {
        const proto = $.parseStructProto(data, typeTag, repo, ValidatorSet);
        return new ValidatorSet(proto, typeTag);
    }
    static load(repo, client, address, typeParams) {
        return __awaiter(this, void 0, void 0, function* () {
            const result = yield repo.loadResource(client, address, ValidatorSet, typeParams);
            return result;
        });
    }
    static loadByApp(app, address, typeParams) {
        return __awaiter(this, void 0, void 0, function* () {
            const result = yield app.repo.loadResource(app.client, address, ValidatorSet, typeParams);
            yield result.loadFullState(app);
            return result;
        });
    }
    static getTag() {
        return new StructTag(moduleAddress$11, moduleName$11, 'ValidatorSet', []);
    }
    loadFullState(app) {
        return __awaiter(this, void 0, void 0, function* () {
            this.__app = app;
        });
    }
}
ValidatorSet.moduleAddress = moduleAddress$11;
ValidatorSet.moduleName = moduleName$11;
ValidatorSet.structName = 'ValidatorSet';
ValidatorSet.typeParameters = [];
ValidatorSet.fields = [
    { name: 'consensus_scheme', typeTag: AtomicTypeTag.U8 },
    {
        name: 'active_validators',
        typeTag: new VectorTag(new StructTag(new HexString('0x1'), 'stake', 'ValidatorInfo', []))
    },
    {
        name: 'pending_inactive',
        typeTag: new VectorTag(new StructTag(new HexString('0x1'), 'stake', 'ValidatorInfo', []))
    },
    {
        name: 'pending_active',
        typeTag: new VectorTag(new StructTag(new HexString('0x1'), 'stake', 'ValidatorInfo', []))
    },
    { name: 'total_voting_power', typeTag: AtomicTypeTag.U128 },
    { name: 'total_joining_power', typeTag: AtomicTypeTag.U128 }
];
class WithdrawStakeEvent {
    constructor(proto, typeTag) {
        this.typeTag = typeTag;
        this.__app = null;
        this.pool_address = proto['pool_address'];
        this.amount_withdrawn = proto['amount_withdrawn'];
    }
    static WithdrawStakeEventParser(data, typeTag, repo) {
        const proto = $.parseStructProto(data, typeTag, repo, WithdrawStakeEvent);
        return new WithdrawStakeEvent(proto, typeTag);
    }
    static getTag() {
        return new StructTag(moduleAddress$11, moduleName$11, 'WithdrawStakeEvent', []);
    }
    loadFullState(app) {
        return __awaiter(this, void 0, void 0, function* () {
            this.__app = app;
        });
    }
}
WithdrawStakeEvent.moduleAddress = moduleAddress$11;
WithdrawStakeEvent.moduleName = moduleName$11;
WithdrawStakeEvent.structName = 'WithdrawStakeEvent';
WithdrawStakeEvent.typeParameters = [];
WithdrawStakeEvent.fields = [
    { name: 'pool_address', typeTag: AtomicTypeTag.Address },
    { name: 'amount_withdrawn', typeTag: AtomicTypeTag.U64 }
];
function add_stake_$1(owner, amount, $c) {
    let owner_address, ownership_cap;
    owner_address = address_of_(owner, $c);
    assert_owner_cap_exists_($.copy(owner_address), $c);
    ownership_cap = $c.borrow_global(new SimpleStructTag(OwnerCapability), $.copy(owner_address));
    add_stake_with_cap_(ownership_cap, withdraw_$1(owner, $.copy(amount), $c, [new StructTag(new HexString('0x1'), 'aptos_coin', 'AptosCoin', [])]), $c);
    return;
}
function buildPayload_add_stake$1(amount, isJSON = false) {
    const typeParamStrings = [];
    return $.buildPayload(new HexString('0x1'), 'stake', 'add_stake', typeParamStrings, [amount], isJSON);
}
function add_stake_with_cap_(owner_cap, coins, $c) {
    let temp$1, temp$2, temp$3, temp$4, amount, maximum_stake, pool_address, stake_pool, validator_set, voting_power;
    pool_address = $.copy(owner_cap.pool_address);
    assert_stake_pool_exists_($.copy(pool_address), $c);
    amount = value_(coins, $c, [new StructTag(new HexString('0x1'), 'aptos_coin', 'AptosCoin', [])]);
    if ($.copy(amount).eq(u64('0'))) {
        destroy_zero_(coins, $c, [new StructTag(new HexString('0x1'), 'aptos_coin', 'AptosCoin', [])]);
        return;
    }
    validator_set = $c.borrow_global_mut(new SimpleStructTag(ValidatorSet), new HexString('0x1'));
    temp$1 = find_validator_(validator_set.active_validators, $.copy(pool_address), $c);
    if (is_some_(temp$1, $c, [AtomicTypeTag.U64])) {
        temp$3 = true;
    }
    else {
        temp$2 = find_validator_(validator_set.pending_active, $.copy(pool_address), $c);
        temp$3 = is_some_(temp$2, $c, [AtomicTypeTag.U64]);
    }
    if (temp$3) {
        update_voting_power_increase_($.copy(amount), $c);
    }
    stake_pool = $c.borrow_global_mut(new SimpleStructTag(StakePool), $.copy(pool_address));
    if (is_current_epoch_validator_($.copy(pool_address), $c)) {
        merge_(stake_pool.pending_active, coins, $c, [
            new StructTag(new HexString('0x1'), 'aptos_coin', 'AptosCoin', [])
        ]);
    }
    else {
        merge_(stake_pool.active, coins, $c, [new StructTag(new HexString('0x1'), 'aptos_coin', 'AptosCoin', [])]);
    }
    temp$4 = get_$2($c);
    [, maximum_stake] = get_required_stake_(temp$4);
    voting_power = get_next_epoch_voting_power_(stake_pool, $c);
    if (!$.copy(voting_power).le($.copy(maximum_stake))) {
        throw $.abortCode(invalid_argument_($.copy(ESTAKE_EXCEEDS_MAX)));
    }
    emit_event_(stake_pool.add_stake_events, new AddStakeEvent$1({ pool_address: $.copy(pool_address), amount_added: $.copy(amount) }, new SimpleStructTag(AddStakeEvent$1)), $c, [new SimpleStructTag(AddStakeEvent$1)]);
    return;
}
function append_$1(v1, v2, $c, $p /* <T>*/) {
    while (!is_empty_$2(v2, $c, [$p[0]])) {
        {
            push_back_(v1, pop_back_(v2, $c, [$p[0]]), $c, [$p[0]]);
        }
    }
    return;
}
function assert_owner_cap_exists_(owner, $c) {
    if (!$c.exists(new SimpleStructTag(OwnerCapability), $.copy(owner))) {
        throw $.abortCode(not_found_($.copy(EOWNER_CAP_NOT_FOUND)));
    }
    return;
}
function assert_stake_pool_exists_(pool_address, $c) {
    if (!stake_pool_exists_($.copy(pool_address), $c)) {
        throw $.abortCode(invalid_argument_($.copy(ESTAKE_POOL_DOES_NOT_EXIST)));
    }
    return;
}
function calculate_rewards_amount_(stake_amount, num_successful_proposals, num_total_proposals, rewards_rate, rewards_rate_denominator, $c) {
    let temp$1, rewards_denominator, rewards_numerator;
    rewards_numerator = u128($.copy(stake_amount))
        .mul(u128($.copy(rewards_rate)))
        .mul(u128($.copy(num_successful_proposals)));
    rewards_denominator = u128($.copy(rewards_rate_denominator)).mul(u128($.copy(num_total_proposals)));
    if ($.copy(rewards_denominator).gt(u128('0'))) {
        temp$1 = u64($.copy(rewards_numerator).div($.copy(rewards_denominator)));
    }
    else {
        temp$1 = u64('0');
    }
    return temp$1;
}
function configure_allowed_validators_(aptos_framework, accounts, $c) {
    let allowed, aptos_framework_address;
    aptos_framework_address = address_of_(aptos_framework, $c);
    assert_aptos_framework_(aptos_framework, $c);
    if (!$c.exists(new SimpleStructTag(AllowedValidators), $.copy(aptos_framework_address))) {
        $c.move_to(new SimpleStructTag(AllowedValidators), aptos_framework, new AllowedValidators({ accounts: $.copy(accounts) }, new SimpleStructTag(AllowedValidators)));
    }
    else {
        allowed = $c.borrow_global_mut(new SimpleStructTag(AllowedValidators), $.copy(aptos_framework_address));
        allowed.accounts = $.copy(accounts);
    }
    return;
}
function deposit_owner_cap_(owner, owner_cap, $c) {
    if (!!$c.exists(new SimpleStructTag(OwnerCapability), address_of_(owner, $c))) {
        throw $.abortCode(not_found_($.copy(EOWNER_CAP_ALREADY_EXISTS)));
    }
    $c.move_to(new SimpleStructTag(OwnerCapability), owner, owner_cap);
    return;
}
function destroy_owner_cap_(owner_cap, $c) {
    return;
}
function distribute_rewards_(stake, num_successful_proposals, num_total_proposals, rewards_rate, rewards_rate_denominator, $c) {
    let temp$1, mint_cap, rewards, rewards_amount, stake_amount;
    stake_amount = value_(stake, $c, [new StructTag(new HexString('0x1'), 'aptos_coin', 'AptosCoin', [])]);
    if ($.copy(stake_amount).gt(u64('0'))) {
        temp$1 = calculate_rewards_amount_($.copy(stake_amount), $.copy(num_successful_proposals), $.copy(num_total_proposals), $.copy(rewards_rate), $.copy(rewards_rate_denominator));
    }
    else {
        temp$1 = u64('0');
    }
    rewards_amount = temp$1;
    if ($.copy(rewards_amount).gt(u64('0'))) {
        mint_cap = $c.borrow_global(new SimpleStructTag(AptosCoinCapabilities$1), new HexString('0x1')).mint_cap;
        rewards = mint_$4($.copy(rewards_amount), mint_cap, $c, [
            new StructTag(new HexString('0x1'), 'aptos_coin', 'AptosCoin', [])
        ]);
        merge_(stake, rewards, $c, [new StructTag(new HexString('0x1'), 'aptos_coin', 'AptosCoin', [])]);
    }
    return $.copy(rewards_amount);
}
function extract_owner_cap_(owner, $c) {
    let owner_address;
    owner_address = address_of_(owner, $c);
    assert_owner_cap_exists_($.copy(owner_address), $c);
    return $c.move_from(new SimpleStructTag(OwnerCapability), $.copy(owner_address));
}
function find_validator_(v, addr, $c) {
    let i, len;
    i = u64('0');
    len = length_$6(v, $c, [new SimpleStructTag(ValidatorInfo)]);
    while (true) {
        if (!$.copy(i).lt($.copy(len)))
            break;
        {
            if ($.copy(borrow_$7(v, $.copy(i), $c, [new SimpleStructTag(ValidatorInfo)]).addr).hex() === $.copy(addr).hex()) {
                return some_($.copy(i), $c, [AtomicTypeTag.U64]);
            }
            i = $.copy(i).add(u64('1'));
        }
    }
    return none_($c, [AtomicTypeTag.U64]);
}
function generate_validator_info_(addr, stake_pool, config, $c) {
    let voting_power;
    voting_power = get_next_epoch_voting_power_(stake_pool, $c);
    return new ValidatorInfo({ addr: $.copy(addr), voting_power: $.copy(voting_power), config: $.copy(config) }, new SimpleStructTag(ValidatorInfo));
}
function get_current_epoch_proposal_counts_(validator_index, $c) {
    let validator_performance, validator_performances;
    validator_performances = $c.borrow_global(new SimpleStructTag(ValidatorPerformance), new HexString('0x1')).validators;
    validator_performance = borrow_$7(validator_performances, $.copy(validator_index), $c, [
        new SimpleStructTag(IndividualValidatorPerformance)
    ]);
    return [$.copy(validator_performance.successful_proposals), $.copy(validator_performance.failed_proposals)];
}
function get_current_epoch_voting_power_(pool_address, $c) {
    let temp$1, temp$2, active_stake, pending_inactive_stake, validator_state;
    assert_stake_pool_exists_($.copy(pool_address), $c);
    validator_state = get_validator_state_($.copy(pool_address), $c);
    if ($.copy(validator_state).eq($.copy(VALIDATOR_STATUS_ACTIVE))) {
        temp$1 = true;
    }
    else {
        temp$1 = $.copy(validator_state).eq($.copy(VALIDATOR_STATUS_PENDING_INACTIVE));
    }
    if (temp$1) {
        active_stake = value_($c.borrow_global(new SimpleStructTag(StakePool), $.copy(pool_address)).active, $c, [new StructTag(new HexString('0x1'), 'aptos_coin', 'AptosCoin', [])]);
        pending_inactive_stake = value_($c.borrow_global(new SimpleStructTag(StakePool), $.copy(pool_address)).pending_inactive, $c, [new StructTag(new HexString('0x1'), 'aptos_coin', 'AptosCoin', [])]);
        temp$2 = $.copy(active_stake).add($.copy(pending_inactive_stake));
    }
    else {
        temp$2 = u64('0');
    }
    return temp$2;
}
function get_delegated_voter_(pool_address, $c) {
    assert_stake_pool_exists_($.copy(pool_address), $c);
    return $.copy($c.borrow_global(new SimpleStructTag(StakePool), $.copy(pool_address)).delegated_voter);
}
function get_lockup_secs_(pool_address, $c) {
    assert_stake_pool_exists_($.copy(pool_address), $c);
    return $.copy($c.borrow_global(new SimpleStructTag(StakePool), $.copy(pool_address)).locked_until_secs);
}
function get_next_epoch_voting_power_(stake_pool, $c) {
    let value_active, value_pending_active, value_pending_inactive;
    value_pending_active = value_(stake_pool.pending_active, $c, [
        new StructTag(new HexString('0x1'), 'aptos_coin', 'AptosCoin', [])
    ]);
    value_active = value_(stake_pool.active, $c, [
        new StructTag(new HexString('0x1'), 'aptos_coin', 'AptosCoin', [])
    ]);
    value_pending_inactive = value_(stake_pool.pending_inactive, $c, [
        new StructTag(new HexString('0x1'), 'aptos_coin', 'AptosCoin', [])
    ]);
    return $.copy(value_pending_active).add($.copy(value_active)).add($.copy(value_pending_inactive));
}
function get_operator_(pool_address, $c) {
    assert_stake_pool_exists_($.copy(pool_address), $c);
    return $.copy($c.borrow_global(new SimpleStructTag(StakePool), $.copy(pool_address)).operator_address);
}
function get_owned_pool_address_(owner_cap, $c) {
    return $.copy(owner_cap.pool_address);
}
function get_remaining_lockup_secs_(pool_address, $c) {
    let temp$1, lockup_time;
    assert_stake_pool_exists_($.copy(pool_address), $c);
    lockup_time = $.copy($c.borrow_global(new SimpleStructTag(StakePool), $.copy(pool_address)).locked_until_secs);
    if ($.copy(lockup_time).le(now_seconds_($c))) {
        temp$1 = u64('0');
    }
    else {
        temp$1 = $.copy(lockup_time).sub(now_seconds_($c));
    }
    return temp$1;
}
function get_stake_(pool_address, $c) {
    let stake_pool;
    assert_stake_pool_exists_($.copy(pool_address), $c);
    stake_pool = $c.borrow_global(new SimpleStructTag(StakePool), $.copy(pool_address));
    return [
        value_(stake_pool.active, $c, [new StructTag(new HexString('0x1'), 'aptos_coin', 'AptosCoin', [])]),
        value_(stake_pool.inactive, $c, [new StructTag(new HexString('0x1'), 'aptos_coin', 'AptosCoin', [])]),
        value_(stake_pool.pending_active, $c, [new StructTag(new HexString('0x1'), 'aptos_coin', 'AptosCoin', [])]),
        value_(stake_pool.pending_inactive, $c, [new StructTag(new HexString('0x1'), 'aptos_coin', 'AptosCoin', [])])
    ];
}
function get_validator_config_(pool_address, $c) {
    let validator_config;
    assert_stake_pool_exists_($.copy(pool_address), $c);
    validator_config = $c.borrow_global(new SimpleStructTag(ValidatorConfig), $.copy(pool_address));
    return [
        $.copy(validator_config.consensus_pubkey),
        $.copy(validator_config.network_addresses),
        $.copy(validator_config.fullnode_addresses)
    ];
}
function get_validator_index_(pool_address, $c) {
    assert_stake_pool_exists_($.copy(pool_address), $c);
    return $.copy($c.borrow_global(new SimpleStructTag(ValidatorConfig), $.copy(pool_address)).validator_index);
}
function get_validator_state_(pool_address, $c) {
    let temp$1, temp$2, temp$3, temp$4, temp$5, temp$6, validator_set;
    validator_set = $c.borrow_global(new SimpleStructTag(ValidatorSet), new HexString('0x1'));
    temp$1 = find_validator_(validator_set.pending_active, $.copy(pool_address), $c);
    if (is_some_(temp$1, $c, [AtomicTypeTag.U64])) {
        temp$6 = $.copy(VALIDATOR_STATUS_PENDING_ACTIVE);
    }
    else {
        temp$2 = find_validator_(validator_set.active_validators, $.copy(pool_address), $c);
        if (is_some_(temp$2, $c, [AtomicTypeTag.U64])) {
            temp$5 = $.copy(VALIDATOR_STATUS_ACTIVE);
        }
        else {
            temp$3 = find_validator_(validator_set.pending_inactive, $.copy(pool_address), $c);
            if (is_some_(temp$3, $c, [AtomicTypeTag.U64])) {
                temp$4 = $.copy(VALIDATOR_STATUS_PENDING_INACTIVE);
            }
            else {
                temp$4 = $.copy(VALIDATOR_STATUS_INACTIVE);
            }
            temp$5 = temp$4;
        }
        temp$6 = temp$5;
    }
    return temp$6;
}
function increase_lockup_(owner, $c) {
    let owner_address, ownership_cap;
    owner_address = address_of_(owner, $c);
    assert_owner_cap_exists_($.copy(owner_address), $c);
    ownership_cap = $c.borrow_global(new SimpleStructTag(OwnerCapability), $.copy(owner_address));
    increase_lockup_with_cap_(ownership_cap, $c);
    return;
}
function buildPayload_increase_lockup(isJSON = false) {
    const typeParamStrings = [];
    return $.buildPayload(new HexString('0x1'), 'stake', 'increase_lockup', typeParamStrings, [], isJSON);
}
function increase_lockup_with_cap_(owner_cap, $c) {
    let config, new_locked_until_secs, old_locked_until_secs, pool_address, stake_pool;
    pool_address = $.copy(owner_cap.pool_address);
    assert_stake_pool_exists_($.copy(pool_address), $c);
    config = get_$2($c);
    stake_pool = $c.borrow_global_mut(new SimpleStructTag(StakePool), $.copy(pool_address));
    old_locked_until_secs = $.copy(stake_pool.locked_until_secs);
    new_locked_until_secs = now_seconds_($c).add(get_recurring_lockup_duration_(config));
    if (!$.copy(old_locked_until_secs).lt($.copy(new_locked_until_secs))) {
        throw $.abortCode(invalid_argument_($.copy(EINVALID_LOCKUP)));
    }
    stake_pool.locked_until_secs = $.copy(new_locked_until_secs);
    emit_event_(stake_pool.increase_lockup_events, new IncreaseLockupEvent({
        pool_address: $.copy(pool_address),
        old_locked_until_secs: $.copy(old_locked_until_secs),
        new_locked_until_secs: $.copy(new_locked_until_secs)
    }, new SimpleStructTag(IncreaseLockupEvent)), $c, [new SimpleStructTag(IncreaseLockupEvent)]);
    return;
}
function initialize_$g(aptos_framework, $c) {
    let temp$1, temp$2, temp$3, temp$4, temp$5, temp$6, temp$7;
    assert_aptos_framework_(aptos_framework, $c);
    temp$7 = aptos_framework;
    temp$1 = u8('0');
    temp$2 = empty_$5($c, [new SimpleStructTag(ValidatorInfo)]);
    temp$3 = empty_$5($c, [new SimpleStructTag(ValidatorInfo)]);
    temp$4 = empty_$5($c, [new SimpleStructTag(ValidatorInfo)]);
    temp$5 = u128('0');
    temp$6 = u128('0');
    $c.move_to(new SimpleStructTag(ValidatorSet), temp$7, new ValidatorSet({
        consensus_scheme: temp$1,
        active_validators: temp$2,
        pending_inactive: temp$4,
        pending_active: temp$3,
        total_voting_power: temp$5,
        total_joining_power: temp$6
    }, new SimpleStructTag(ValidatorSet)));
    $c.move_to(new SimpleStructTag(ValidatorPerformance), aptos_framework, new ValidatorPerformance({ validators: empty_$5($c, [new SimpleStructTag(IndividualValidatorPerformance)]) }, new SimpleStructTag(ValidatorPerformance)));
    return;
}
function initialize_owner_(owner, $c) {
    let temp$1, temp$10, temp$11, temp$12, temp$13, temp$14, temp$15, temp$16, temp$17, temp$18, temp$19, temp$2, temp$20, temp$3, temp$4, temp$5, temp$6, temp$7, temp$8, temp$9, owner_address;
    owner_address = address_of_(owner, $c);
    if (!is_allowed_($.copy(owner_address), $c)) {
        throw $.abortCode(not_found_($.copy(EINELIGIBLE_VALIDATOR)));
    }
    if (!!stake_pool_exists_($.copy(owner_address), $c)) {
        throw $.abortCode(already_exists_($.copy(EALREADY_REGISTERED)));
    }
    temp$20 = owner;
    temp$1 = zero_$1($c, [new StructTag(new HexString('0x1'), 'aptos_coin', 'AptosCoin', [])]);
    temp$2 = zero_$1($c, [new StructTag(new HexString('0x1'), 'aptos_coin', 'AptosCoin', [])]);
    temp$3 = zero_$1($c, [new StructTag(new HexString('0x1'), 'aptos_coin', 'AptosCoin', [])]);
    temp$4 = zero_$1($c, [new StructTag(new HexString('0x1'), 'aptos_coin', 'AptosCoin', [])]);
    temp$5 = u64('0');
    temp$6 = $.copy(owner_address);
    temp$7 = $.copy(owner_address);
    temp$8 = new_event_handle_(owner, $c, [new SimpleStructTag(RegisterValidatorCandidateEvent)]);
    temp$9 = new_event_handle_(owner, $c, [new SimpleStructTag(SetOperatorEvent)]);
    temp$10 = new_event_handle_(owner, $c, [new SimpleStructTag(AddStakeEvent$1)]);
    temp$11 = new_event_handle_(owner, $c, [new SimpleStructTag(ReactivateStakeEvent)]);
    temp$12 = new_event_handle_(owner, $c, [new SimpleStructTag(RotateConsensusKeyEvent)]);
    temp$13 = new_event_handle_(owner, $c, [new SimpleStructTag(UpdateNetworkAndFullnodeAddressesEvent)]);
    temp$14 = new_event_handle_(owner, $c, [new SimpleStructTag(IncreaseLockupEvent)]);
    temp$15 = new_event_handle_(owner, $c, [new SimpleStructTag(JoinValidatorSetEvent)]);
    temp$16 = new_event_handle_(owner, $c, [new SimpleStructTag(DistributeRewardsEvent)]);
    temp$17 = new_event_handle_(owner, $c, [new SimpleStructTag(UnlockStakeEvent$1)]);
    temp$18 = new_event_handle_(owner, $c, [new SimpleStructTag(WithdrawStakeEvent)]);
    temp$19 = new_event_handle_(owner, $c, [new SimpleStructTag(LeaveValidatorSetEvent)]);
    $c.move_to(new SimpleStructTag(StakePool), temp$20, new StakePool({
        active: temp$1,
        inactive: temp$4,
        pending_active: temp$2,
        pending_inactive: temp$3,
        locked_until_secs: temp$5,
        operator_address: temp$6,
        delegated_voter: temp$7,
        initialize_validator_events: temp$8,
        set_operator_events: temp$9,
        add_stake_events: temp$10,
        reactivate_stake_events: temp$11,
        rotate_consensus_key_events: temp$12,
        update_network_and_fullnode_addresses_events: temp$13,
        increase_lockup_events: temp$14,
        join_validator_set_events: temp$15,
        distribute_rewards_events: temp$16,
        unlock_stake_events: temp$17,
        withdraw_stake_events: temp$18,
        leave_validator_set_events: temp$19
    }, new SimpleStructTag(StakePool)));
    $c.move_to(new SimpleStructTag(OwnerCapability), owner, new OwnerCapability({ pool_address: $.copy(owner_address) }, new SimpleStructTag(OwnerCapability)));
    return;
}
function initialize_stake_owner_(owner, initial_stake_amount, operator, voter, $c) {
    let account_address;
    initialize_owner_(owner, $c);
    $c.move_to(new SimpleStructTag(ValidatorConfig), owner, new ValidatorConfig({
        consensus_pubkey: empty_$5($c, [AtomicTypeTag.U8]),
        network_addresses: empty_$5($c, [AtomicTypeTag.U8]),
        fullnode_addresses: empty_$5($c, [AtomicTypeTag.U8]),
        validator_index: u64('0')
    }, new SimpleStructTag(ValidatorConfig)));
    if ($.copy(initial_stake_amount).gt(u64('0'))) {
        add_stake_$1(owner, $.copy(initial_stake_amount), $c);
    }
    account_address = address_of_(owner, $c);
    if ($.copy(account_address).hex() !== $.copy(operator).hex()) {
        set_operator_$1(owner, $.copy(operator), $c);
    }
    if ($.copy(account_address).hex() !== $.copy(voter).hex()) {
        set_delegated_voter_(owner, $.copy(voter), $c);
    }
    return;
}
function buildPayload_initialize_stake_owner(initial_stake_amount, operator, voter, isJSON = false) {
    const typeParamStrings = [];
    return $.buildPayload(new HexString('0x1'), 'stake', 'initialize_stake_owner', typeParamStrings, [initial_stake_amount, operator, voter], isJSON);
}
function initialize_validator_$1(account, consensus_pubkey, proof_of_possession, network_addresses, fullnode_addresses, $c) {
    let temp$1, temp$2, temp$3, pubkey_from_pop;
    temp$2 = $.copy(consensus_pubkey);
    temp$1 = proof_of_possession_from_bytes_($.copy(proof_of_possession));
    temp$3 = public_key_from_bytes_with_pop_(temp$2, temp$1, $c);
    pubkey_from_pop = temp$3;
    if (!is_some_(pubkey_from_pop, $c, [new StructTag(new HexString('0x1'), 'bls12381', 'PublicKeyWithPoP', [])])) {
        throw $.abortCode(invalid_argument_($.copy(EINVALID_PUBLIC_KEY)));
    }
    initialize_owner_(account, $c);
    $c.move_to(new SimpleStructTag(ValidatorConfig), account, new ValidatorConfig({
        consensus_pubkey: $.copy(consensus_pubkey),
        network_addresses: $.copy(network_addresses),
        fullnode_addresses: $.copy(fullnode_addresses),
        validator_index: u64('0')
    }, new SimpleStructTag(ValidatorConfig)));
    return;
}
function buildPayload_initialize_validator(consensus_pubkey, proof_of_possession, network_addresses, fullnode_addresses, isJSON = false) {
    const typeParamStrings = [];
    return $.buildPayload(new HexString('0x1'), 'stake', 'initialize_validator', typeParamStrings, [consensus_pubkey, proof_of_possession, network_addresses, fullnode_addresses], isJSON);
}
function is_allowed_(account, $c) {
    let temp$1, allowed;
    if (!$c.exists(new SimpleStructTag(AllowedValidators), new HexString('0x1'))) {
        temp$1 = true;
    }
    else {
        allowed = $c.borrow_global(new SimpleStructTag(AllowedValidators), new HexString('0x1'));
        temp$1 = contains_$8(allowed.accounts, account, $c, [AtomicTypeTag.Address]);
    }
    return temp$1;
}
function is_current_epoch_validator_(pool_address, $c) {
    let temp$1, validator_state;
    assert_stake_pool_exists_($.copy(pool_address), $c);
    validator_state = get_validator_state_($.copy(pool_address), $c);
    if ($.copy(validator_state).eq($.copy(VALIDATOR_STATUS_ACTIVE))) {
        temp$1 = true;
    }
    else {
        temp$1 = $.copy(validator_state).eq($.copy(VALIDATOR_STATUS_PENDING_INACTIVE));
    }
    return temp$1;
}
function join_validator_set_(operator, pool_address, $c) {
    let temp$1;
    temp$1 = get_$2($c);
    if (!get_allow_validator_set_change_(temp$1)) {
        throw $.abortCode(invalid_argument_($.copy(ENO_POST_GENESIS_VALIDATOR_SET_CHANGE_ALLOWED)));
    }
    join_validator_set_internal_(operator, $.copy(pool_address), $c);
    return;
}
function buildPayload_join_validator_set(pool_address, isJSON = false) {
    const typeParamStrings = [];
    return $.buildPayload(new HexString('0x1'), 'stake', 'join_validator_set', typeParamStrings, [pool_address], isJSON);
}
function join_validator_set_internal_(operator, pool_address, $c) {
    let temp$1, temp$2, temp$3, temp$4, config, maximum_stake, minimum_stake, stake_pool, validator_config, validator_set, validator_set_size, voting_power;
    assert_stake_pool_exists_($.copy(pool_address), $c);
    stake_pool = $c.borrow_global_mut(new SimpleStructTag(StakePool), $.copy(pool_address));
    if (!(address_of_(operator, $c).hex() === $.copy(stake_pool.operator_address).hex())) {
        throw $.abortCode(unauthenticated_($.copy(ENOT_OPERATOR)));
    }
    if (!get_validator_state_($.copy(pool_address), $c).eq($.copy(VALIDATOR_STATUS_INACTIVE))) {
        throw $.abortCode(invalid_state_($.copy(EALREADY_ACTIVE_VALIDATOR)));
    }
    config = get_$2($c);
    [minimum_stake, maximum_stake] = get_required_stake_(config);
    voting_power = get_next_epoch_voting_power_(stake_pool, $c);
    if (!$.copy(voting_power).ge($.copy(minimum_stake))) {
        throw $.abortCode(invalid_argument_($.copy(ESTAKE_TOO_LOW)));
    }
    if (!$.copy(voting_power).le($.copy(maximum_stake))) {
        throw $.abortCode(invalid_argument_($.copy(ESTAKE_TOO_HIGH)));
    }
    update_voting_power_increase_($.copy(voting_power), $c);
    validator_config = $c.borrow_global_mut(new SimpleStructTag(ValidatorConfig), $.copy(pool_address));
    if (!!is_empty_$2(validator_config.consensus_pubkey, $c, [AtomicTypeTag.U8])) {
        throw $.abortCode(invalid_argument_($.copy(EINVALID_PUBLIC_KEY)));
    }
    validator_set = $c.borrow_global_mut(new SimpleStructTag(ValidatorSet), new HexString('0x1'));
    temp$4 = validator_set.pending_active;
    [temp$1, temp$2, temp$3] = [$.copy(pool_address), stake_pool, $.copy(validator_config)];
    push_back_(temp$4, generate_validator_info_(temp$1, temp$2, temp$3, $c), $c, [
        new SimpleStructTag(ValidatorInfo)
    ]);
    validator_set_size = length_$6(validator_set.active_validators, $c, [new SimpleStructTag(ValidatorInfo)]).add(length_$6(validator_set.pending_active, $c, [new SimpleStructTag(ValidatorInfo)]));
    if (!$.copy(validator_set_size).le($.copy(MAX_VALIDATOR_SET_SIZE))) {
        throw $.abortCode(invalid_argument_($.copy(EVALIDATOR_SET_TOO_LARGE)));
    }
    emit_event_(stake_pool.join_validator_set_events, new JoinValidatorSetEvent({ pool_address: $.copy(pool_address) }, new SimpleStructTag(JoinValidatorSetEvent)), $c, [new SimpleStructTag(JoinValidatorSetEvent)]);
    return;
}
function leave_validator_set_(operator, pool_address, $c) {
    let config, maybe_active_index, maybe_pending_active_index, stake_pool, validator_info, validator_set, validator_stake;
    config = get_$2($c);
    if (!get_allow_validator_set_change_(config)) {
        throw $.abortCode(invalid_argument_($.copy(ENO_POST_GENESIS_VALIDATOR_SET_CHANGE_ALLOWED)));
    }
    assert_stake_pool_exists_($.copy(pool_address), $c);
    stake_pool = $c.borrow_global_mut(new SimpleStructTag(StakePool), $.copy(pool_address));
    if (!(address_of_(operator, $c).hex() === $.copy(stake_pool.operator_address).hex())) {
        throw $.abortCode(unauthenticated_($.copy(ENOT_OPERATOR)));
    }
    validator_set = $c.borrow_global_mut(new SimpleStructTag(ValidatorSet), new HexString('0x1'));
    maybe_pending_active_index = find_validator_(validator_set.pending_active, $.copy(pool_address), $c);
    if (is_some_(maybe_pending_active_index, $c, [AtomicTypeTag.U64])) {
        swap_remove_(validator_set.pending_active, extract_$1(maybe_pending_active_index, $c, [AtomicTypeTag.U64]), $c, [new SimpleStructTag(ValidatorInfo)]);
        validator_stake = u128(get_next_epoch_voting_power_(stake_pool, $c));
        if ($.copy(validator_set.total_joining_power).gt($.copy(validator_stake))) {
            validator_set.total_joining_power = $.copy(validator_set.total_joining_power).sub($.copy(validator_stake));
        }
        else {
            validator_set.total_joining_power = u128('0');
        }
    }
    else {
        maybe_active_index = find_validator_(validator_set.active_validators, $.copy(pool_address), $c);
        if (!is_some_(maybe_active_index, $c, [AtomicTypeTag.U64])) {
            throw $.abortCode(invalid_state_($.copy(ENOT_VALIDATOR)));
        }
        validator_info = swap_remove_(validator_set.active_validators, extract_$1(maybe_active_index, $c, [AtomicTypeTag.U64]), $c, [new SimpleStructTag(ValidatorInfo)]);
        if (!length_$6(validator_set.active_validators, $c, [new SimpleStructTag(ValidatorInfo)]).gt(u64('0'))) {
            throw $.abortCode(invalid_state_($.copy(ELAST_VALIDATOR)));
        }
        push_back_(validator_set.pending_inactive, $.copy(validator_info), $c, [new SimpleStructTag(ValidatorInfo)]);
        emit_event_(stake_pool.leave_validator_set_events, new LeaveValidatorSetEvent({ pool_address: $.copy(pool_address) }, new SimpleStructTag(LeaveValidatorSetEvent)), $c, [new SimpleStructTag(LeaveValidatorSetEvent)]);
    }
    return;
}
function buildPayload_leave_validator_set(pool_address, isJSON = false) {
    const typeParamStrings = [];
    return $.buildPayload(new HexString('0x1'), 'stake', 'leave_validator_set', typeParamStrings, [pool_address], isJSON);
}
function on_new_epoch_($c) {
    let temp$1, temp$11, temp$12, temp$13, temp$2, temp$3, temp$7, temp$8, temp$9, config, i, i__10, i__4, len, len__5, minimum_stake, new_validator_info, next_epoch_validators, old_validator_info, pool_address, recurring_lockup_duration_secs, stake_pool, stake_pool__16, total_voting_power, validator, validator__6, validator_config, validator_config__15, validator_index, validator_info, validator_perf, validator_set, vlen, vlen__14;
    validator_set = $c.borrow_global_mut(new SimpleStructTag(ValidatorSet), new HexString('0x1'));
    config = get_$2($c);
    validator_perf = $c.borrow_global_mut(new SimpleStructTag(ValidatorPerformance), new HexString('0x1'));
    i = u64('0');
    len = length_$6(validator_set.active_validators, $c, [new SimpleStructTag(ValidatorInfo)]);
    while ($.copy(i).lt($.copy(len))) {
        {
            validator = borrow_$7(validator_set.active_validators, $.copy(i), $c, [new SimpleStructTag(ValidatorInfo)]);
            [temp$1, temp$2, temp$3] = [validator_perf, $.copy(validator.addr), config];
            update_stake_pool_(temp$1, temp$2, temp$3, $c);
            i = $.copy(i).add(u64('1'));
        }
    }
    i__4 = u64('0');
    len__5 = length_$6(validator_set.pending_inactive, $c, [new SimpleStructTag(ValidatorInfo)]);
    while ($.copy(i__4).lt($.copy(len__5))) {
        {
            validator__6 = borrow_$7(validator_set.pending_inactive, $.copy(i__4), $c, [
                new SimpleStructTag(ValidatorInfo)
            ]);
            [temp$7, temp$8, temp$9] = [validator_perf, $.copy(validator__6.addr), config];
            update_stake_pool_(temp$7, temp$8, temp$9, $c);
            i__4 = $.copy(i__4).add(u64('1'));
        }
    }
    append_$1(validator_set.active_validators, validator_set.pending_active, $c, [new SimpleStructTag(ValidatorInfo)]);
    validator_set.pending_inactive = empty_$5($c, [new SimpleStructTag(ValidatorInfo)]);
    next_epoch_validators = empty_$5($c, [new SimpleStructTag(ValidatorInfo)]);
    [minimum_stake] = get_required_stake_(config);
    vlen = length_$6(validator_set.active_validators, $c, [new SimpleStructTag(ValidatorInfo)]);
    total_voting_power = u128('0');
    i__10 = u64('0');
    while (true) {
        if (!$.copy(i__10).lt($.copy(vlen)))
            break;
        {
            old_validator_info = borrow_mut_$7(validator_set.active_validators, $.copy(i__10), $c, [
                new SimpleStructTag(ValidatorInfo)
            ]);
            pool_address = $.copy(old_validator_info.addr);
            validator_config = $c.borrow_global_mut(new SimpleStructTag(ValidatorConfig), $.copy(pool_address));
            stake_pool = $c.borrow_global_mut(new SimpleStructTag(StakePool), $.copy(pool_address));
            [temp$11, temp$12, temp$13] = [$.copy(pool_address), stake_pool, $.copy(validator_config)];
            new_validator_info = generate_validator_info_(temp$11, temp$12, temp$13, $c);
            if ($.copy(new_validator_info.voting_power).ge($.copy(minimum_stake))) {
                total_voting_power = $.copy(total_voting_power).add(u128($.copy(new_validator_info.voting_power)));
                push_back_(next_epoch_validators, $.copy(new_validator_info), $c, [new SimpleStructTag(ValidatorInfo)]);
            }
            i__10 = $.copy(i__10).add(u64('1'));
        }
    }
    validator_set.active_validators = $.copy(next_epoch_validators);
    validator_set.total_voting_power = $.copy(total_voting_power);
    validator_set.total_joining_power = u128('0');
    validator_perf.validators = empty_$5($c, [new SimpleStructTag(IndividualValidatorPerformance)]);
    recurring_lockup_duration_secs = get_recurring_lockup_duration_(config);
    vlen__14 = length_$6(validator_set.active_validators, $c, [new SimpleStructTag(ValidatorInfo)]);
    validator_index = u64('0');
    while (true) {
        if (!$.copy(validator_index).lt($.copy(vlen__14)))
            break;
        {
            validator_info = borrow_mut_$7(validator_set.active_validators, $.copy(validator_index), $c, [
                new SimpleStructTag(ValidatorInfo)
            ]);
            validator_info.config.validator_index = $.copy(validator_index);
            validator_config__15 = $c.borrow_global_mut(new SimpleStructTag(ValidatorConfig), $.copy(validator_info.addr));
            validator_config__15.validator_index = $.copy(validator_index);
            push_back_(validator_perf.validators, new IndividualValidatorPerformance({ successful_proposals: u64('0'), failed_proposals: u64('0') }, new SimpleStructTag(IndividualValidatorPerformance)), $c, [new SimpleStructTag(IndividualValidatorPerformance)]);
            stake_pool__16 = $c.borrow_global_mut(new SimpleStructTag(StakePool), $.copy(validator_info.addr));
            if ($.copy(stake_pool__16.locked_until_secs).le(now_seconds_($c))) {
                stake_pool__16.locked_until_secs = now_seconds_($c).add($.copy(recurring_lockup_duration_secs));
            }
            validator_index = $.copy(validator_index).add(u64('1'));
        }
    }
    return;
}
function reactivate_stake_(owner, amount, $c) {
    let owner_address, ownership_cap;
    owner_address = address_of_(owner, $c);
    assert_owner_cap_exists_($.copy(owner_address), $c);
    ownership_cap = $c.borrow_global(new SimpleStructTag(OwnerCapability), $.copy(owner_address));
    reactivate_stake_with_cap_(ownership_cap, $.copy(amount), $c);
    return;
}
function buildPayload_reactivate_stake(amount, isJSON = false) {
    const typeParamStrings = [];
    return $.buildPayload(new HexString('0x1'), 'stake', 'reactivate_stake', typeParamStrings, [amount], isJSON);
}
function reactivate_stake_with_cap_(owner_cap, amount, $c) {
    let pool_address, reactivated_coins, stake_pool, total_pending_inactive;
    pool_address = $.copy(owner_cap.pool_address);
    assert_stake_pool_exists_($.copy(pool_address), $c);
    stake_pool = $c.borrow_global_mut(new SimpleStructTag(StakePool), $.copy(pool_address));
    total_pending_inactive = value_(stake_pool.pending_inactive, $c, [
        new StructTag(new HexString('0x1'), 'aptos_coin', 'AptosCoin', [])
    ]);
    amount = min_$1($.copy(amount), $.copy(total_pending_inactive));
    reactivated_coins = extract_(stake_pool.pending_inactive, $.copy(amount), $c, [
        new StructTag(new HexString('0x1'), 'aptos_coin', 'AptosCoin', [])
    ]);
    merge_(stake_pool.active, reactivated_coins, $c, [
        new StructTag(new HexString('0x1'), 'aptos_coin', 'AptosCoin', [])
    ]);
    emit_event_(stake_pool.reactivate_stake_events, new ReactivateStakeEvent({ pool_address: $.copy(pool_address), amount: $.copy(amount) }, new SimpleStructTag(ReactivateStakeEvent)), $c, [new SimpleStructTag(ReactivateStakeEvent)]);
    return;
}
function remove_validators_(aptos_framework, validators, $c) {
    let temp$1, temp$2, active_validators, i, len, pending_inactive, validator, validator_index, validator_info, validator_set;
    assert_aptos_framework_(aptos_framework, $c);
    validator_set = $c.borrow_global_mut(new SimpleStructTag(ValidatorSet), new HexString('0x1'));
    active_validators = validator_set.active_validators;
    pending_inactive = validator_set.pending_inactive;
    len = length_$6(validators, $c, [AtomicTypeTag.Address]);
    i = u64('0');
    while (true) {
        if (!$.copy(i).lt($.copy(len)))
            break;
        {
            validator = $.copy(borrow_$7(validators, $.copy(i), $c, [AtomicTypeTag.Address]));
            [temp$1, temp$2] = [active_validators, $.copy(validator)];
            validator_index = find_validator_(temp$1, temp$2, $c);
            if (is_some_(validator_index, $c, [AtomicTypeTag.U64])) {
                validator_info = swap_remove_(active_validators, $.copy(borrow_$6(validator_index, $c, [AtomicTypeTag.U64])), $c, [new SimpleStructTag(ValidatorInfo)]);
                push_back_(pending_inactive, $.copy(validator_info), $c, [new SimpleStructTag(ValidatorInfo)]);
            }
            i = $.copy(i).add(u64('1'));
        }
    }
    return;
}
function rotate_consensus_key_(operator, pool_address, new_consensus_pubkey, proof_of_possession, $c) {
    let temp$1, temp$2, temp$3, old_consensus_pubkey, pubkey_from_pop, stake_pool, validator_info;
    assert_stake_pool_exists_($.copy(pool_address), $c);
    stake_pool = $c.borrow_global_mut(new SimpleStructTag(StakePool), $.copy(pool_address));
    if (!(address_of_(operator, $c).hex() === $.copy(stake_pool.operator_address).hex())) {
        throw $.abortCode(unauthenticated_($.copy(ENOT_OPERATOR)));
    }
    if (!$c.exists(new SimpleStructTag(ValidatorConfig), $.copy(pool_address))) {
        throw $.abortCode(not_found_($.copy(EVALIDATOR_CONFIG)));
    }
    validator_info = $c.borrow_global_mut(new SimpleStructTag(ValidatorConfig), $.copy(pool_address));
    old_consensus_pubkey = $.copy(validator_info.consensus_pubkey);
    temp$2 = $.copy(new_consensus_pubkey);
    temp$1 = proof_of_possession_from_bytes_($.copy(proof_of_possession));
    temp$3 = public_key_from_bytes_with_pop_(temp$2, temp$1, $c);
    pubkey_from_pop = temp$3;
    if (!is_some_(pubkey_from_pop, $c, [new StructTag(new HexString('0x1'), 'bls12381', 'PublicKeyWithPoP', [])])) {
        throw $.abortCode(invalid_argument_($.copy(EINVALID_PUBLIC_KEY)));
    }
    validator_info.consensus_pubkey = $.copy(new_consensus_pubkey);
    emit_event_(stake_pool.rotate_consensus_key_events, new RotateConsensusKeyEvent({
        pool_address: $.copy(pool_address),
        old_consensus_pubkey: $.copy(old_consensus_pubkey),
        new_consensus_pubkey: $.copy(new_consensus_pubkey)
    }, new SimpleStructTag(RotateConsensusKeyEvent)), $c, [new SimpleStructTag(RotateConsensusKeyEvent)]);
    return;
}
function buildPayload_rotate_consensus_key(pool_address, new_consensus_pubkey, proof_of_possession, isJSON = false) {
    const typeParamStrings = [];
    return $.buildPayload(new HexString('0x1'), 'stake', 'rotate_consensus_key', typeParamStrings, [pool_address, new_consensus_pubkey, proof_of_possession], isJSON);
}
function set_delegated_voter_(owner, new_voter, $c) {
    let owner_address, ownership_cap;
    owner_address = address_of_(owner, $c);
    assert_owner_cap_exists_($.copy(owner_address), $c);
    ownership_cap = $c.borrow_global(new SimpleStructTag(OwnerCapability), $.copy(owner_address));
    set_delegated_voter_with_cap_(ownership_cap, $.copy(new_voter), $c);
    return;
}
function buildPayload_set_delegated_voter(new_voter, isJSON = false) {
    const typeParamStrings = [];
    return $.buildPayload(new HexString('0x1'), 'stake', 'set_delegated_voter', typeParamStrings, [new_voter], isJSON);
}
function set_delegated_voter_with_cap_(owner_cap, new_voter, $c) {
    let pool_address, stake_pool;
    pool_address = $.copy(owner_cap.pool_address);
    assert_stake_pool_exists_($.copy(pool_address), $c);
    stake_pool = $c.borrow_global_mut(new SimpleStructTag(StakePool), $.copy(pool_address));
    stake_pool.delegated_voter = $.copy(new_voter);
    return;
}
function set_operator_$1(owner, new_operator, $c) {
    let owner_address, ownership_cap;
    owner_address = address_of_(owner, $c);
    assert_owner_cap_exists_($.copy(owner_address), $c);
    ownership_cap = $c.borrow_global(new SimpleStructTag(OwnerCapability), $.copy(owner_address));
    set_operator_with_cap_(ownership_cap, $.copy(new_operator), $c);
    return;
}
function buildPayload_set_operator$1(new_operator, isJSON = false) {
    const typeParamStrings = [];
    return $.buildPayload(new HexString('0x1'), 'stake', 'set_operator', typeParamStrings, [new_operator], isJSON);
}
function set_operator_with_cap_(owner_cap, new_operator, $c) {
    let old_operator, pool_address, stake_pool;
    pool_address = $.copy(owner_cap.pool_address);
    assert_stake_pool_exists_($.copy(pool_address), $c);
    stake_pool = $c.borrow_global_mut(new SimpleStructTag(StakePool), $.copy(pool_address));
    old_operator = $.copy(stake_pool.operator_address);
    stake_pool.operator_address = $.copy(new_operator);
    emit_event_(stake_pool.set_operator_events, new SetOperatorEvent({ pool_address: $.copy(pool_address), old_operator: $.copy(old_operator), new_operator: $.copy(new_operator) }, new SimpleStructTag(SetOperatorEvent)), $c, [new SimpleStructTag(SetOperatorEvent)]);
    return;
}
function stake_pool_exists_(addr, $c) {
    return $c.exists(new SimpleStructTag(StakePool), $.copy(addr));
}
function store_aptos_coin_mint_cap_(aptos_framework, mint_cap, $c) {
    assert_aptos_framework_(aptos_framework, $c);
    return $c.move_to(new SimpleStructTag(AptosCoinCapabilities$1), aptos_framework, new AptosCoinCapabilities$1({ mint_cap: $.copy(mint_cap) }, new SimpleStructTag(AptosCoinCapabilities$1)));
}
function unlock_(owner, amount, $c) {
    let owner_address, ownership_cap;
    owner_address = address_of_(owner, $c);
    assert_owner_cap_exists_($.copy(owner_address), $c);
    ownership_cap = $c.borrow_global(new SimpleStructTag(OwnerCapability), $.copy(owner_address));
    unlock_with_cap_($.copy(amount), ownership_cap, $c);
    return;
}
function buildPayload_unlock(amount, isJSON = false) {
    const typeParamStrings = [];
    return $.buildPayload(new HexString('0x1'), 'stake', 'unlock', typeParamStrings, [amount], isJSON);
}
function unlock_with_cap_(amount, owner_cap, $c) {
    let amount__1, pool_address, stake_pool, unlocked_stake;
    if ($.copy(amount).eq(u64('0'))) {
        return;
    }
    pool_address = $.copy(owner_cap.pool_address);
    assert_stake_pool_exists_($.copy(pool_address), $c);
    stake_pool = $c.borrow_global_mut(new SimpleStructTag(StakePool), $.copy(pool_address));
    amount__1 = min_$1($.copy(amount), value_(stake_pool.active, $c, [new StructTag(new HexString('0x1'), 'aptos_coin', 'AptosCoin', [])]));
    unlocked_stake = extract_(stake_pool.active, $.copy(amount__1), $c, [
        new StructTag(new HexString('0x1'), 'aptos_coin', 'AptosCoin', [])
    ]);
    merge_(stake_pool.pending_inactive, unlocked_stake, $c, [
        new StructTag(new HexString('0x1'), 'aptos_coin', 'AptosCoin', [])
    ]);
    emit_event_(stake_pool.unlock_stake_events, new UnlockStakeEvent$1({ pool_address: $.copy(pool_address), amount_unlocked: $.copy(amount__1) }, new SimpleStructTag(UnlockStakeEvent$1)), $c, [new SimpleStructTag(UnlockStakeEvent$1)]);
    return;
}
function update_network_and_fullnode_addresses_(operator, pool_address, new_network_addresses, new_fullnode_addresses, $c) {
    let old_fullnode_addresses, old_network_addresses, stake_pool, validator_info;
    assert_stake_pool_exists_($.copy(pool_address), $c);
    stake_pool = $c.borrow_global_mut(new SimpleStructTag(StakePool), $.copy(pool_address));
    if (!(address_of_(operator, $c).hex() === $.copy(stake_pool.operator_address).hex())) {
        throw $.abortCode(unauthenticated_($.copy(ENOT_OPERATOR)));
    }
    if (!$c.exists(new SimpleStructTag(ValidatorConfig), $.copy(pool_address))) {
        throw $.abortCode(not_found_($.copy(EVALIDATOR_CONFIG)));
    }
    validator_info = $c.borrow_global_mut(new SimpleStructTag(ValidatorConfig), $.copy(pool_address));
    old_network_addresses = $.copy(validator_info.network_addresses);
    validator_info.network_addresses = $.copy(new_network_addresses);
    old_fullnode_addresses = $.copy(validator_info.fullnode_addresses);
    validator_info.fullnode_addresses = $.copy(new_fullnode_addresses);
    emit_event_(stake_pool.update_network_and_fullnode_addresses_events, new UpdateNetworkAndFullnodeAddressesEvent({
        pool_address: $.copy(pool_address),
        old_network_addresses: $.copy(old_network_addresses),
        new_network_addresses: $.copy(new_network_addresses),
        old_fullnode_addresses: $.copy(old_fullnode_addresses),
        new_fullnode_addresses: $.copy(new_fullnode_addresses)
    }, new SimpleStructTag(UpdateNetworkAndFullnodeAddressesEvent)), $c, [new SimpleStructTag(UpdateNetworkAndFullnodeAddressesEvent)]);
    return;
}
function buildPayload_update_network_and_fullnode_addresses(pool_address, new_network_addresses, new_fullnode_addresses, isJSON = false) {
    const typeParamStrings = [];
    return $.buildPayload(new HexString('0x1'), 'stake', 'update_network_and_fullnode_addresses', typeParamStrings, [pool_address, new_network_addresses, new_fullnode_addresses], isJSON);
}
function update_performance_statistics_(proposer_index, failed_proposer_indices, $c) {
    let cur_proposer_index, f, f_len, validator, validator__1, validator_index, validator_len, validator_perf;
    validator_perf = $c.borrow_global_mut(new SimpleStructTag(ValidatorPerformance), new HexString('0x1'));
    validator_len = length_$6(validator_perf.validators, $c, [new SimpleStructTag(IndividualValidatorPerformance)]);
    if (is_some_(proposer_index, $c, [AtomicTypeTag.U64])) {
        cur_proposer_index = extract_$1(proposer_index, $c, [AtomicTypeTag.U64]);
        if ($.copy(cur_proposer_index).lt($.copy(validator_len))) {
            validator = borrow_mut_$7(validator_perf.validators, $.copy(cur_proposer_index), $c, [
                new SimpleStructTag(IndividualValidatorPerformance)
            ]);
            validator.successful_proposals = $.copy(validator.successful_proposals).add(u64('1'));
        }
    }
    f = u64('0');
    f_len = length_$6(failed_proposer_indices, $c, [AtomicTypeTag.U64]);
    while (true) {
        if (!$.copy(f).lt($.copy(f_len)))
            break;
        {
            validator_index = $.copy(borrow_$7(failed_proposer_indices, $.copy(f), $c, [AtomicTypeTag.U64]));
            if ($.copy(validator_index).lt($.copy(validator_len))) {
                validator__1 = borrow_mut_$7(validator_perf.validators, $.copy(validator_index), $c, [
                    new SimpleStructTag(IndividualValidatorPerformance)
                ]);
                validator__1.failed_proposals = $.copy(validator__1.failed_proposals).add(u64('1'));
            }
            f = $.copy(f).add(u64('1'));
        }
    }
    return;
}
function update_stake_pool_(validator_perf, pool_address, staking_config, $c) {
    let cur_validator_perf, current_lockup_expiration, num_successful_proposals, num_total_proposals, rewards_active, rewards_amount, rewards_pending_inactive, rewards_rate, rewards_rate_denominator, stake_pool, validator_config;
    stake_pool = $c.borrow_global_mut(new SimpleStructTag(StakePool), $.copy(pool_address));
    validator_config = $c.borrow_global(new SimpleStructTag(ValidatorConfig), $.copy(pool_address));
    cur_validator_perf = borrow_$7(validator_perf.validators, $.copy(validator_config.validator_index), $c, [
        new SimpleStructTag(IndividualValidatorPerformance)
    ]);
    num_successful_proposals = $.copy(cur_validator_perf.successful_proposals);
    num_total_proposals = $.copy(cur_validator_perf.successful_proposals).add($.copy(cur_validator_perf.failed_proposals));
    [rewards_rate, rewards_rate_denominator] = get_reward_rate_(staking_config);
    rewards_active = distribute_rewards_(stake_pool.active, $.copy(num_successful_proposals), $.copy(num_total_proposals), $.copy(rewards_rate), $.copy(rewards_rate_denominator), $c);
    rewards_pending_inactive = distribute_rewards_(stake_pool.pending_inactive, $.copy(num_successful_proposals), $.copy(num_total_proposals), $.copy(rewards_rate), $.copy(rewards_rate_denominator), $c);
    rewards_amount = $.copy(rewards_active).add($.copy(rewards_pending_inactive));
    merge_(stake_pool.active, extract_all_(stake_pool.pending_active, $c, [
        new StructTag(new HexString('0x1'), 'aptos_coin', 'AptosCoin', [])
    ]), $c, [new StructTag(new HexString('0x1'), 'aptos_coin', 'AptosCoin', [])]);
    current_lockup_expiration = $.copy(stake_pool.locked_until_secs);
    if (now_seconds_($c).ge($.copy(current_lockup_expiration))) {
        merge_(stake_pool.inactive, extract_all_(stake_pool.pending_inactive, $c, [
            new StructTag(new HexString('0x1'), 'aptos_coin', 'AptosCoin', [])
        ]), $c, [new StructTag(new HexString('0x1'), 'aptos_coin', 'AptosCoin', [])]);
    }
    emit_event_(stake_pool.distribute_rewards_events, new DistributeRewardsEvent({ pool_address: $.copy(pool_address), rewards_amount: $.copy(rewards_amount) }, new SimpleStructTag(DistributeRewardsEvent)), $c, [new SimpleStructTag(DistributeRewardsEvent)]);
    return;
}
function update_voting_power_increase_(increase_amount, $c) {
    let temp$1, validator_set, voting_power_increase_limit;
    validator_set = $c.borrow_global_mut(new SimpleStructTag(ValidatorSet), new HexString('0x1'));
    temp$1 = get_$2($c);
    voting_power_increase_limit = u128(get_voting_power_increase_limit_(temp$1));
    validator_set.total_joining_power = $.copy(validator_set.total_joining_power).add(u128($.copy(increase_amount)));
    if ($.copy(validator_set.total_voting_power).gt(u128('0'))) {
        if (!$.copy(validator_set.total_joining_power).le($.copy(validator_set.total_voting_power).mul($.copy(voting_power_increase_limit)).div(u128('100')))) {
            throw $.abortCode(invalid_argument_($.copy(EVOTING_POWER_INCREASE_EXCEEDS_LIMIT)));
        }
    }
    return;
}
function withdraw_(owner, withdraw_amount, $c) {
    let coins, owner_address, ownership_cap;
    owner_address = address_of_(owner, $c);
    assert_owner_cap_exists_($.copy(owner_address), $c);
    ownership_cap = $c.borrow_global(new SimpleStructTag(OwnerCapability), $.copy(owner_address));
    coins = withdraw_with_cap_(ownership_cap, $.copy(withdraw_amount), $c);
    deposit_$1($.copy(owner_address), coins, $c, [new StructTag(new HexString('0x1'), 'aptos_coin', 'AptosCoin', [])]);
    return;
}
function buildPayload_withdraw(withdraw_amount, isJSON = false) {
    const typeParamStrings = [];
    return $.buildPayload(new HexString('0x1'), 'stake', 'withdraw', typeParamStrings, [withdraw_amount], isJSON);
}
function withdraw_with_cap_(owner_cap, withdraw_amount, $c) {
    let temp$1, pending_inactive_stake, pool_address, stake_pool;
    pool_address = $.copy(owner_cap.pool_address);
    assert_stake_pool_exists_($.copy(pool_address), $c);
    stake_pool = $c.borrow_global_mut(new SimpleStructTag(StakePool), $.copy(pool_address));
    if (get_validator_state_($.copy(pool_address), $c).eq($.copy(VALIDATOR_STATUS_INACTIVE))) {
        temp$1 = now_seconds_($c).ge($.copy(stake_pool.locked_until_secs));
    }
    else {
        temp$1 = false;
    }
    if (temp$1) {
        pending_inactive_stake = extract_all_(stake_pool.pending_inactive, $c, [
            new StructTag(new HexString('0x1'), 'aptos_coin', 'AptosCoin', [])
        ]);
        merge_(stake_pool.inactive, pending_inactive_stake, $c, [
            new StructTag(new HexString('0x1'), 'aptos_coin', 'AptosCoin', [])
        ]);
    }
    withdraw_amount = min_$1($.copy(withdraw_amount), value_(stake_pool.inactive, $c, [new StructTag(new HexString('0x1'), 'aptos_coin', 'AptosCoin', [])]));
    if ($.copy(withdraw_amount).eq(u64('0'))) {
        return zero_$1($c, [new StructTag(new HexString('0x1'), 'aptos_coin', 'AptosCoin', [])]);
    }
    emit_event_(stake_pool.withdraw_stake_events, new WithdrawStakeEvent({ pool_address: $.copy(pool_address), amount_withdrawn: $.copy(withdraw_amount) }, new SimpleStructTag(WithdrawStakeEvent)), $c, [new SimpleStructTag(WithdrawStakeEvent)]);
    return extract_(stake_pool.inactive, $.copy(withdraw_amount), $c, [
        new StructTag(new HexString('0x1'), 'aptos_coin', 'AptosCoin', [])
    ]);
}
function loadParsers$1e(repo) {
    repo.addParser('0x1::stake::AddStakeEvent', AddStakeEvent$1.AddStakeEventParser);
    repo.addParser('0x1::stake::AllowedValidators', AllowedValidators.AllowedValidatorsParser);
    repo.addParser('0x1::stake::AptosCoinCapabilities', AptosCoinCapabilities$1.AptosCoinCapabilitiesParser);
    repo.addParser('0x1::stake::DistributeRewardsEvent', DistributeRewardsEvent.DistributeRewardsEventParser);
    repo.addParser('0x1::stake::IncreaseLockupEvent', IncreaseLockupEvent.IncreaseLockupEventParser);
    repo.addParser('0x1::stake::IndividualValidatorPerformance', IndividualValidatorPerformance.IndividualValidatorPerformanceParser);
    repo.addParser('0x1::stake::JoinValidatorSetEvent', JoinValidatorSetEvent.JoinValidatorSetEventParser);
    repo.addParser('0x1::stake::LeaveValidatorSetEvent', LeaveValidatorSetEvent.LeaveValidatorSetEventParser);
    repo.addParser('0x1::stake::OwnerCapability', OwnerCapability.OwnerCapabilityParser);
    repo.addParser('0x1::stake::ReactivateStakeEvent', ReactivateStakeEvent.ReactivateStakeEventParser);
    repo.addParser('0x1::stake::RegisterValidatorCandidateEvent', RegisterValidatorCandidateEvent.RegisterValidatorCandidateEventParser);
    repo.addParser('0x1::stake::RotateConsensusKeyEvent', RotateConsensusKeyEvent.RotateConsensusKeyEventParser);
    repo.addParser('0x1::stake::SetOperatorEvent', SetOperatorEvent.SetOperatorEventParser);
    repo.addParser('0x1::stake::StakePool', StakePool.StakePoolParser);
    repo.addParser('0x1::stake::UnlockStakeEvent', UnlockStakeEvent$1.UnlockStakeEventParser);
    repo.addParser('0x1::stake::UpdateNetworkAndFullnodeAddressesEvent', UpdateNetworkAndFullnodeAddressesEvent.UpdateNetworkAndFullnodeAddressesEventParser);
    repo.addParser('0x1::stake::ValidatorConfig', ValidatorConfig.ValidatorConfigParser);
    repo.addParser('0x1::stake::ValidatorInfo', ValidatorInfo.ValidatorInfoParser);
    repo.addParser('0x1::stake::ValidatorPerformance', ValidatorPerformance.ValidatorPerformanceParser);
    repo.addParser('0x1::stake::ValidatorSet', ValidatorSet.ValidatorSetParser);
    repo.addParser('0x1::stake::WithdrawStakeEvent', WithdrawStakeEvent.WithdrawStakeEventParser);
}
class App$1f {
    constructor(client, repo, cache) {
        this.client = client;
        this.repo = repo;
        this.cache = cache;
    }
    get moduleAddress() {
        {
            return moduleAddress$11;
        }
    }
    get moduleName() {
        {
            return moduleName$11;
        }
    }
    get AddStakeEvent() {
        return AddStakeEvent$1;
    }
    get AllowedValidators() {
        return AllowedValidators;
    }
    loadAllowedValidators(owner, loadFull = true, fillCache = true) {
        return __awaiter(this, void 0, void 0, function* () {
            const val = yield AllowedValidators.load(this.repo, this.client, owner, []);
            if (loadFull) {
                yield val.loadFullState(this);
            }
            if (fillCache) {
                this.cache.set(val.typeTag, owner, val);
            }
            return val;
        });
    }
    get AptosCoinCapabilities() {
        return AptosCoinCapabilities$1;
    }
    loadAptosCoinCapabilities(owner, loadFull = true, fillCache = true) {
        return __awaiter(this, void 0, void 0, function* () {
            const val = yield AptosCoinCapabilities$1.load(this.repo, this.client, owner, []);
            if (loadFull) {
                yield val.loadFullState(this);
            }
            if (fillCache) {
                this.cache.set(val.typeTag, owner, val);
            }
            return val;
        });
    }
    get DistributeRewardsEvent() {
        return DistributeRewardsEvent;
    }
    get IncreaseLockupEvent() {
        return IncreaseLockupEvent;
    }
    get IndividualValidatorPerformance() {
        return IndividualValidatorPerformance;
    }
    get JoinValidatorSetEvent() {
        return JoinValidatorSetEvent;
    }
    get LeaveValidatorSetEvent() {
        return LeaveValidatorSetEvent;
    }
    get OwnerCapability() {
        return OwnerCapability;
    }
    loadOwnerCapability(owner, loadFull = true, fillCache = true) {
        return __awaiter(this, void 0, void 0, function* () {
            const val = yield OwnerCapability.load(this.repo, this.client, owner, []);
            if (loadFull) {
                yield val.loadFullState(this);
            }
            if (fillCache) {
                this.cache.set(val.typeTag, owner, val);
            }
            return val;
        });
    }
    get ReactivateStakeEvent() {
        return ReactivateStakeEvent;
    }
    get RegisterValidatorCandidateEvent() {
        return RegisterValidatorCandidateEvent;
    }
    get RotateConsensusKeyEvent() {
        return RotateConsensusKeyEvent;
    }
    get SetOperatorEvent() {
        return SetOperatorEvent;
    }
    get StakePool() {
        return StakePool;
    }
    loadStakePool(owner, loadFull = true, fillCache = true) {
        return __awaiter(this, void 0, void 0, function* () {
            const val = yield StakePool.load(this.repo, this.client, owner, []);
            if (loadFull) {
                yield val.loadFullState(this);
            }
            if (fillCache) {
                this.cache.set(val.typeTag, owner, val);
            }
            return val;
        });
    }
    get UnlockStakeEvent() {
        return UnlockStakeEvent$1;
    }
    get UpdateNetworkAndFullnodeAddressesEvent() {
        return UpdateNetworkAndFullnodeAddressesEvent;
    }
    get ValidatorConfig() {
        return ValidatorConfig;
    }
    loadValidatorConfig(owner, loadFull = true, fillCache = true) {
        return __awaiter(this, void 0, void 0, function* () {
            const val = yield ValidatorConfig.load(this.repo, this.client, owner, []);
            if (loadFull) {
                yield val.loadFullState(this);
            }
            if (fillCache) {
                this.cache.set(val.typeTag, owner, val);
            }
            return val;
        });
    }
    get ValidatorInfo() {
        return ValidatorInfo;
    }
    get ValidatorPerformance() {
        return ValidatorPerformance;
    }
    loadValidatorPerformance(owner, loadFull = true, fillCache = true) {
        return __awaiter(this, void 0, void 0, function* () {
            const val = yield ValidatorPerformance.load(this.repo, this.client, owner, []);
            if (loadFull) {
                yield val.loadFullState(this);
            }
            if (fillCache) {
                this.cache.set(val.typeTag, owner, val);
            }
            return val;
        });
    }
    get ValidatorSet() {
        return ValidatorSet;
    }
    loadValidatorSet(owner, loadFull = true, fillCache = true) {
        return __awaiter(this, void 0, void 0, function* () {
            const val = yield ValidatorSet.load(this.repo, this.client, owner, []);
            if (loadFull) {
                yield val.loadFullState(this);
            }
            if (fillCache) {
                this.cache.set(val.typeTag, owner, val);
            }
            return val;
        });
    }
    get WithdrawStakeEvent() {
        return WithdrawStakeEvent;
    }
    payload_add_stake(amount, isJSON = false) {
        return buildPayload_add_stake$1(amount, isJSON);
    }
    add_stake(_account, amount, option, _isJSON = false) {
        return __awaiter(this, void 0, void 0, function* () {
            const payload__ = buildPayload_add_stake$1(amount, _isJSON);
            return $.sendPayloadTx(this.client, _account, payload__, option);
        });
    }
    payload_increase_lockup(isJSON = false) {
        return buildPayload_increase_lockup(isJSON);
    }
    increase_lockup(_account, option, _isJSON = false) {
        return __awaiter(this, void 0, void 0, function* () {
            const payload__ = buildPayload_increase_lockup(_isJSON);
            return $.sendPayloadTx(this.client, _account, payload__, option);
        });
    }
    payload_initialize_stake_owner(initial_stake_amount, operator, voter, isJSON = false) {
        return buildPayload_initialize_stake_owner(initial_stake_amount, operator, voter, isJSON);
    }
    initialize_stake_owner(_account, initial_stake_amount, operator, voter, option, _isJSON = false) {
        return __awaiter(this, void 0, void 0, function* () {
            const payload__ = buildPayload_initialize_stake_owner(initial_stake_amount, operator, voter, _isJSON);
            return $.sendPayloadTx(this.client, _account, payload__, option);
        });
    }
    payload_initialize_validator(consensus_pubkey, proof_of_possession, network_addresses, fullnode_addresses, isJSON = false) {
        return buildPayload_initialize_validator(consensus_pubkey, proof_of_possession, network_addresses, fullnode_addresses, isJSON);
    }
    initialize_validator(_account, consensus_pubkey, proof_of_possession, network_addresses, fullnode_addresses, option, _isJSON = false) {
        return __awaiter(this, void 0, void 0, function* () {
            const payload__ = buildPayload_initialize_validator(consensus_pubkey, proof_of_possession, network_addresses, fullnode_addresses, _isJSON);
            return $.sendPayloadTx(this.client, _account, payload__, option);
        });
    }
    payload_join_validator_set(pool_address, isJSON = false) {
        return buildPayload_join_validator_set(pool_address, isJSON);
    }
    join_validator_set(_account, pool_address, option, _isJSON = false) {
        return __awaiter(this, void 0, void 0, function* () {
            const payload__ = buildPayload_join_validator_set(pool_address, _isJSON);
            return $.sendPayloadTx(this.client, _account, payload__, option);
        });
    }
    payload_leave_validator_set(pool_address, isJSON = false) {
        return buildPayload_leave_validator_set(pool_address, isJSON);
    }
    leave_validator_set(_account, pool_address, option, _isJSON = false) {
        return __awaiter(this, void 0, void 0, function* () {
            const payload__ = buildPayload_leave_validator_set(pool_address, _isJSON);
            return $.sendPayloadTx(this.client, _account, payload__, option);
        });
    }
    payload_reactivate_stake(amount, isJSON = false) {
        return buildPayload_reactivate_stake(amount, isJSON);
    }
    reactivate_stake(_account, amount, option, _isJSON = false) {
        return __awaiter(this, void 0, void 0, function* () {
            const payload__ = buildPayload_reactivate_stake(amount, _isJSON);
            return $.sendPayloadTx(this.client, _account, payload__, option);
        });
    }
    payload_rotate_consensus_key(pool_address, new_consensus_pubkey, proof_of_possession, isJSON = false) {
        return buildPayload_rotate_consensus_key(pool_address, new_consensus_pubkey, proof_of_possession, isJSON);
    }
    rotate_consensus_key(_account, pool_address, new_consensus_pubkey, proof_of_possession, option, _isJSON = false) {
        return __awaiter(this, void 0, void 0, function* () {
            const payload__ = buildPayload_rotate_consensus_key(pool_address, new_consensus_pubkey, proof_of_possession, _isJSON);
            return $.sendPayloadTx(this.client, _account, payload__, option);
        });
    }
    payload_set_delegated_voter(new_voter, isJSON = false) {
        return buildPayload_set_delegated_voter(new_voter, isJSON);
    }
    set_delegated_voter(_account, new_voter, option, _isJSON = false) {
        return __awaiter(this, void 0, void 0, function* () {
            const payload__ = buildPayload_set_delegated_voter(new_voter, _isJSON);
            return $.sendPayloadTx(this.client, _account, payload__, option);
        });
    }
    payload_set_operator(new_operator, isJSON = false) {
        return buildPayload_set_operator$1(new_operator, isJSON);
    }
    set_operator(_account, new_operator, option, _isJSON = false) {
        return __awaiter(this, void 0, void 0, function* () {
            const payload__ = buildPayload_set_operator$1(new_operator, _isJSON);
            return $.sendPayloadTx(this.client, _account, payload__, option);
        });
    }
    payload_unlock(amount, isJSON = false) {
        return buildPayload_unlock(amount, isJSON);
    }
    unlock(_account, amount, option, _isJSON = false) {
        return __awaiter(this, void 0, void 0, function* () {
            const payload__ = buildPayload_unlock(amount, _isJSON);
            return $.sendPayloadTx(this.client, _account, payload__, option);
        });
    }
    payload_update_network_and_fullnode_addresses(pool_address, new_network_addresses, new_fullnode_addresses, isJSON = false) {
        return buildPayload_update_network_and_fullnode_addresses(pool_address, new_network_addresses, new_fullnode_addresses, isJSON);
    }
    update_network_and_fullnode_addresses(_account, pool_address, new_network_addresses, new_fullnode_addresses, option, _isJSON = false) {
        return __awaiter(this, void 0, void 0, function* () {
            const payload__ = buildPayload_update_network_and_fullnode_addresses(pool_address, new_network_addresses, new_fullnode_addresses, _isJSON);
            return $.sendPayloadTx(this.client, _account, payload__, option);
        });
    }
    payload_withdraw(withdraw_amount, isJSON = false) {
        return buildPayload_withdraw(withdraw_amount, isJSON);
    }
    withdraw(_account, withdraw_amount, option, _isJSON = false) {
        return __awaiter(this, void 0, void 0, function* () {
            const payload__ = buildPayload_withdraw(withdraw_amount, _isJSON);
            return $.sendPayloadTx(this.client, _account, payload__, option);
        });
    }
}

var Stake = /*#__PURE__*/Object.freeze({
    __proto__: null,
    packageName: packageName$11,
    moduleAddress: moduleAddress$11,
    moduleName: moduleName$11,
    EALREADY_ACTIVE_VALIDATOR: EALREADY_ACTIVE_VALIDATOR,
    EALREADY_REGISTERED: EALREADY_REGISTERED,
    EINELIGIBLE_VALIDATOR: EINELIGIBLE_VALIDATOR,
    EINVALID_LOCKUP: EINVALID_LOCKUP,
    EINVALID_PUBLIC_KEY: EINVALID_PUBLIC_KEY,
    ELAST_VALIDATOR: ELAST_VALIDATOR,
    ENOT_OPERATOR: ENOT_OPERATOR,
    ENOT_VALIDATOR: ENOT_VALIDATOR,
    ENO_POST_GENESIS_VALIDATOR_SET_CHANGE_ALLOWED: ENO_POST_GENESIS_VALIDATOR_SET_CHANGE_ALLOWED,
    EOWNER_CAP_ALREADY_EXISTS: EOWNER_CAP_ALREADY_EXISTS,
    EOWNER_CAP_NOT_FOUND: EOWNER_CAP_NOT_FOUND,
    ESTAKE_EXCEEDS_MAX: ESTAKE_EXCEEDS_MAX,
    ESTAKE_POOL_DOES_NOT_EXIST: ESTAKE_POOL_DOES_NOT_EXIST,
    ESTAKE_TOO_HIGH: ESTAKE_TOO_HIGH,
    ESTAKE_TOO_LOW: ESTAKE_TOO_LOW,
    EVALIDATOR_CONFIG: EVALIDATOR_CONFIG,
    EVALIDATOR_SET_TOO_LARGE: EVALIDATOR_SET_TOO_LARGE,
    EVOTING_POWER_INCREASE_EXCEEDS_LIMIT: EVOTING_POWER_INCREASE_EXCEEDS_LIMIT,
    MAX_REWARDS_RATE: MAX_REWARDS_RATE,
    MAX_VALIDATOR_SET_SIZE: MAX_VALIDATOR_SET_SIZE,
    VALIDATOR_STATUS_ACTIVE: VALIDATOR_STATUS_ACTIVE,
    VALIDATOR_STATUS_INACTIVE: VALIDATOR_STATUS_INACTIVE,
    VALIDATOR_STATUS_PENDING_ACTIVE: VALIDATOR_STATUS_PENDING_ACTIVE,
    VALIDATOR_STATUS_PENDING_INACTIVE: VALIDATOR_STATUS_PENDING_INACTIVE,
    AddStakeEvent: AddStakeEvent$1,
    AllowedValidators: AllowedValidators,
    AptosCoinCapabilities: AptosCoinCapabilities$1,
    DistributeRewardsEvent: DistributeRewardsEvent,
    IncreaseLockupEvent: IncreaseLockupEvent,
    IndividualValidatorPerformance: IndividualValidatorPerformance,
    JoinValidatorSetEvent: JoinValidatorSetEvent,
    LeaveValidatorSetEvent: LeaveValidatorSetEvent,
    OwnerCapability: OwnerCapability,
    ReactivateStakeEvent: ReactivateStakeEvent,
    RegisterValidatorCandidateEvent: RegisterValidatorCandidateEvent,
    RotateConsensusKeyEvent: RotateConsensusKeyEvent,
    SetOperatorEvent: SetOperatorEvent,
    StakePool: StakePool,
    UnlockStakeEvent: UnlockStakeEvent$1,
    UpdateNetworkAndFullnodeAddressesEvent: UpdateNetworkAndFullnodeAddressesEvent,
    ValidatorConfig: ValidatorConfig,
    ValidatorInfo: ValidatorInfo,
    ValidatorPerformance: ValidatorPerformance,
    ValidatorSet: ValidatorSet,
    WithdrawStakeEvent: WithdrawStakeEvent,
    add_stake_: add_stake_$1,
    buildPayload_add_stake: buildPayload_add_stake$1,
    add_stake_with_cap_: add_stake_with_cap_,
    append_: append_$1,
    assert_owner_cap_exists_: assert_owner_cap_exists_,
    assert_stake_pool_exists_: assert_stake_pool_exists_,
    calculate_rewards_amount_: calculate_rewards_amount_,
    configure_allowed_validators_: configure_allowed_validators_,
    deposit_owner_cap_: deposit_owner_cap_,
    destroy_owner_cap_: destroy_owner_cap_,
    distribute_rewards_: distribute_rewards_,
    extract_owner_cap_: extract_owner_cap_,
    find_validator_: find_validator_,
    generate_validator_info_: generate_validator_info_,
    get_current_epoch_proposal_counts_: get_current_epoch_proposal_counts_,
    get_current_epoch_voting_power_: get_current_epoch_voting_power_,
    get_delegated_voter_: get_delegated_voter_,
    get_lockup_secs_: get_lockup_secs_,
    get_next_epoch_voting_power_: get_next_epoch_voting_power_,
    get_operator_: get_operator_,
    get_owned_pool_address_: get_owned_pool_address_,
    get_remaining_lockup_secs_: get_remaining_lockup_secs_,
    get_stake_: get_stake_,
    get_validator_config_: get_validator_config_,
    get_validator_index_: get_validator_index_,
    get_validator_state_: get_validator_state_,
    increase_lockup_: increase_lockup_,
    buildPayload_increase_lockup: buildPayload_increase_lockup,
    increase_lockup_with_cap_: increase_lockup_with_cap_,
    initialize_: initialize_$g,
    initialize_owner_: initialize_owner_,
    initialize_stake_owner_: initialize_stake_owner_,
    buildPayload_initialize_stake_owner: buildPayload_initialize_stake_owner,
    initialize_validator_: initialize_validator_$1,
    buildPayload_initialize_validator: buildPayload_initialize_validator,
    is_allowed_: is_allowed_,
    is_current_epoch_validator_: is_current_epoch_validator_,
    join_validator_set_: join_validator_set_,
    buildPayload_join_validator_set: buildPayload_join_validator_set,
    join_validator_set_internal_: join_validator_set_internal_,
    leave_validator_set_: leave_validator_set_,
    buildPayload_leave_validator_set: buildPayload_leave_validator_set,
    on_new_epoch_: on_new_epoch_,
    reactivate_stake_: reactivate_stake_,
    buildPayload_reactivate_stake: buildPayload_reactivate_stake,
    reactivate_stake_with_cap_: reactivate_stake_with_cap_,
    remove_validators_: remove_validators_,
    rotate_consensus_key_: rotate_consensus_key_,
    buildPayload_rotate_consensus_key: buildPayload_rotate_consensus_key,
    set_delegated_voter_: set_delegated_voter_,
    buildPayload_set_delegated_voter: buildPayload_set_delegated_voter,
    set_delegated_voter_with_cap_: set_delegated_voter_with_cap_,
    set_operator_: set_operator_$1,
    buildPayload_set_operator: buildPayload_set_operator$1,
    set_operator_with_cap_: set_operator_with_cap_,
    stake_pool_exists_: stake_pool_exists_,
    store_aptos_coin_mint_cap_: store_aptos_coin_mint_cap_,
    unlock_: unlock_,
    buildPayload_unlock: buildPayload_unlock,
    unlock_with_cap_: unlock_with_cap_,
    update_network_and_fullnode_addresses_: update_network_and_fullnode_addresses_,
    buildPayload_update_network_and_fullnode_addresses: buildPayload_update_network_and_fullnode_addresses,
    update_performance_statistics_: update_performance_statistics_,
    update_stake_pool_: update_stake_pool_,
    update_voting_power_increase_: update_voting_power_increase_,
    withdraw_: withdraw_,
    buildPayload_withdraw: buildPayload_withdraw,
    withdraw_with_cap_: withdraw_with_cap_,
    loadParsers: loadParsers$1e,
    App: App$1f
});

const packageName$10 = 'AptosFramework';
const moduleAddress$10 = new HexString('0x1');
const moduleName$10 = 'state_storage';
const ESTATE_STORAGE_USAGE = u64('0');
class GasParameter {
    constructor(proto, typeTag) {
        this.typeTag = typeTag;
        this.__app = null;
        this.usage = proto['usage'];
    }
    static GasParameterParser(data, typeTag, repo) {
        const proto = $.parseStructProto(data, typeTag, repo, GasParameter);
        return new GasParameter(proto, typeTag);
    }
    static load(repo, client, address, typeParams) {
        return __awaiter(this, void 0, void 0, function* () {
            const result = yield repo.loadResource(client, address, GasParameter, typeParams);
            return result;
        });
    }
    static loadByApp(app, address, typeParams) {
        return __awaiter(this, void 0, void 0, function* () {
            const result = yield app.repo.loadResource(app.client, address, GasParameter, typeParams);
            yield result.loadFullState(app);
            return result;
        });
    }
    static getTag() {
        return new StructTag(moduleAddress$10, moduleName$10, 'GasParameter', []);
    }
    loadFullState(app) {
        return __awaiter(this, void 0, void 0, function* () {
            yield this.usage.loadFullState(app);
            this.__app = app;
        });
    }
}
GasParameter.moduleAddress = moduleAddress$10;
GasParameter.moduleName = moduleName$10;
GasParameter.structName = 'GasParameter';
GasParameter.typeParameters = [];
GasParameter.fields = [
    { name: 'usage', typeTag: new StructTag(new HexString('0x1'), 'state_storage', 'Usage', []) }
];
class StateStorageUsage {
    constructor(proto, typeTag) {
        this.typeTag = typeTag;
        this.__app = null;
        this.epoch = proto['epoch'];
        this.usage = proto['usage'];
    }
    static StateStorageUsageParser(data, typeTag, repo) {
        const proto = $.parseStructProto(data, typeTag, repo, StateStorageUsage);
        return new StateStorageUsage(proto, typeTag);
    }
    static load(repo, client, address, typeParams) {
        return __awaiter(this, void 0, void 0, function* () {
            const result = yield repo.loadResource(client, address, StateStorageUsage, typeParams);
            return result;
        });
    }
    static loadByApp(app, address, typeParams) {
        return __awaiter(this, void 0, void 0, function* () {
            const result = yield app.repo.loadResource(app.client, address, StateStorageUsage, typeParams);
            yield result.loadFullState(app);
            return result;
        });
    }
    static getTag() {
        return new StructTag(moduleAddress$10, moduleName$10, 'StateStorageUsage', []);
    }
    loadFullState(app) {
        return __awaiter(this, void 0, void 0, function* () {
            yield this.usage.loadFullState(app);
            this.__app = app;
        });
    }
}
StateStorageUsage.moduleAddress = moduleAddress$10;
StateStorageUsage.moduleName = moduleName$10;
StateStorageUsage.structName = 'StateStorageUsage';
StateStorageUsage.typeParameters = [];
StateStorageUsage.fields = [
    { name: 'epoch', typeTag: AtomicTypeTag.U64 },
    { name: 'usage', typeTag: new StructTag(new HexString('0x1'), 'state_storage', 'Usage', []) }
];
class Usage {
    constructor(proto, typeTag) {
        this.typeTag = typeTag;
        this.__app = null;
        this.items = proto['items'];
        this.bytes = proto['bytes'];
    }
    static UsageParser(data, typeTag, repo) {
        const proto = $.parseStructProto(data, typeTag, repo, Usage);
        return new Usage(proto, typeTag);
    }
    static getTag() {
        return new StructTag(moduleAddress$10, moduleName$10, 'Usage', []);
    }
    loadFullState(app) {
        return __awaiter(this, void 0, void 0, function* () {
            this.__app = app;
        });
    }
}
Usage.moduleAddress = moduleAddress$10;
Usage.moduleName = moduleName$10;
Usage.structName = 'Usage';
Usage.typeParameters = [];
Usage.fields = [
    { name: 'items', typeTag: AtomicTypeTag.U64 },
    { name: 'bytes', typeTag: AtomicTypeTag.U64 }
];
function current_items_and_bytes_($c) {
    let usage;
    if (!$c.exists(new SimpleStructTag(StateStorageUsage), new HexString('0x1'))) {
        throw $.abortCode(not_found_($.copy(ESTATE_STORAGE_USAGE)));
    }
    usage = $c.borrow_global(new SimpleStructTag(StateStorageUsage), new HexString('0x1'));
    return [$.copy(usage.usage.items), $.copy(usage.usage.bytes)];
}
function get_state_storage_usage_only_at_epoch_beginning_($c) {
    return $.aptos_framework_state_storage_get_state_storage_usage_only_at_epoch_beginning($c);
}
function initialize_$f(aptos_framework, $c) {
    assert_aptos_framework_(aptos_framework, $c);
    if (!!$c.exists(new SimpleStructTag(StateStorageUsage), new HexString('0x1'))) {
        throw $.abortCode(already_exists_($.copy(ESTATE_STORAGE_USAGE)));
    }
    $c.move_to(new SimpleStructTag(StateStorageUsage), aptos_framework, new StateStorageUsage({ epoch: u64('0'), usage: new Usage({ items: u64('0'), bytes: u64('0') }, new SimpleStructTag(Usage)) }, new SimpleStructTag(StateStorageUsage)));
    return;
}
function on_new_block_(epoch, $c) {
    let usage;
    if (!$c.exists(new SimpleStructTag(StateStorageUsage), new HexString('0x1'))) {
        throw $.abortCode(not_found_($.copy(ESTATE_STORAGE_USAGE)));
    }
    usage = $c.borrow_global_mut(new SimpleStructTag(StateStorageUsage), new HexString('0x1'));
    if ($.copy(epoch).neq($.copy(usage.epoch))) {
        usage.epoch = $.copy(epoch);
        usage.usage = get_state_storage_usage_only_at_epoch_beginning_($c);
    }
    return;
}
function on_reconfig_$1($c) {
    throw $.abortCode(u64('0'));
}
function loadParsers$1d(repo) {
    repo.addParser('0x1::state_storage::GasParameter', GasParameter.GasParameterParser);
    repo.addParser('0x1::state_storage::StateStorageUsage', StateStorageUsage.StateStorageUsageParser);
    repo.addParser('0x1::state_storage::Usage', Usage.UsageParser);
}
class App$1e {
    constructor(client, repo, cache) {
        this.client = client;
        this.repo = repo;
        this.cache = cache;
    }
    get moduleAddress() {
        {
            return moduleAddress$10;
        }
    }
    get moduleName() {
        {
            return moduleName$10;
        }
    }
    get GasParameter() {
        return GasParameter;
    }
    loadGasParameter(owner, loadFull = true, fillCache = true) {
        return __awaiter(this, void 0, void 0, function* () {
            const val = yield GasParameter.load(this.repo, this.client, owner, []);
            if (loadFull) {
                yield val.loadFullState(this);
            }
            if (fillCache) {
                this.cache.set(val.typeTag, owner, val);
            }
            return val;
        });
    }
    get StateStorageUsage() {
        return StateStorageUsage;
    }
    loadStateStorageUsage(owner, loadFull = true, fillCache = true) {
        return __awaiter(this, void 0, void 0, function* () {
            const val = yield StateStorageUsage.load(this.repo, this.client, owner, []);
            if (loadFull) {
                yield val.loadFullState(this);
            }
            if (fillCache) {
                this.cache.set(val.typeTag, owner, val);
            }
            return val;
        });
    }
    get Usage() {
        return Usage;
    }
}

var State_storage = /*#__PURE__*/Object.freeze({
    __proto__: null,
    packageName: packageName$10,
    moduleAddress: moduleAddress$10,
    moduleName: moduleName$10,
    ESTATE_STORAGE_USAGE: ESTATE_STORAGE_USAGE,
    GasParameter: GasParameter,
    StateStorageUsage: StateStorageUsage,
    Usage: Usage,
    current_items_and_bytes_: current_items_and_bytes_,
    get_state_storage_usage_only_at_epoch_beginning_: get_state_storage_usage_only_at_epoch_beginning_,
    initialize_: initialize_$f,
    on_new_block_: on_new_block_,
    on_reconfig_: on_reconfig_$1,
    loadParsers: loadParsers$1d,
    App: App$1e
});

const packageName$$ = 'AptosFramework';
const moduleAddress$$ = new HexString('0x1');
const moduleName$$ = 'storage_gas';
const BASIS_POINT_DENOMINATION = u64('10000');
const EINVALID_GAS_RANGE = u64('2');
const EINVALID_MONOTONICALLY_NON_DECREASING_CURVE = u64('5');
const EINVALID_POINT_RANGE = u64('6');
const ESTORAGE_GAS = u64('1');
const ESTORAGE_GAS_CONFIG = u64('0');
const ETARGET_USAGE_TOO_BIG = u64('4');
const EZERO_TARGET_USAGE = u64('3');
const MAX_U64$4 = u64('18446744073709551615');
class GasCurve {
    constructor(proto, typeTag) {
        this.typeTag = typeTag;
        this.__app = null;
        this.min_gas = proto['min_gas'];
        this.max_gas = proto['max_gas'];
        this.points = proto['points'];
    }
    static GasCurveParser(data, typeTag, repo) {
        const proto = $.parseStructProto(data, typeTag, repo, GasCurve);
        return new GasCurve(proto, typeTag);
    }
    static getTag() {
        return new StructTag(moduleAddress$$, moduleName$$, 'GasCurve', []);
    }
    loadFullState(app) {
        return __awaiter(this, void 0, void 0, function* () {
            this.__app = app;
        });
    }
}
GasCurve.moduleAddress = moduleAddress$$;
GasCurve.moduleName = moduleName$$;
GasCurve.structName = 'GasCurve';
GasCurve.typeParameters = [];
GasCurve.fields = [
    { name: 'min_gas', typeTag: AtomicTypeTag.U64 },
    { name: 'max_gas', typeTag: AtomicTypeTag.U64 },
    { name: 'points', typeTag: new VectorTag(new StructTag(new HexString('0x1'), 'storage_gas', 'Point', [])) }
];
class Point {
    constructor(proto, typeTag) {
        this.typeTag = typeTag;
        this.__app = null;
        this.x = proto['x'];
        this.y = proto['y'];
    }
    static PointParser(data, typeTag, repo) {
        const proto = $.parseStructProto(data, typeTag, repo, Point);
        return new Point(proto, typeTag);
    }
    static getTag() {
        return new StructTag(moduleAddress$$, moduleName$$, 'Point', []);
    }
    loadFullState(app) {
        return __awaiter(this, void 0, void 0, function* () {
            this.__app = app;
        });
    }
}
Point.moduleAddress = moduleAddress$$;
Point.moduleName = moduleName$$;
Point.structName = 'Point';
Point.typeParameters = [];
Point.fields = [
    { name: 'x', typeTag: AtomicTypeTag.U64 },
    { name: 'y', typeTag: AtomicTypeTag.U64 }
];
class StorageGas {
    constructor(proto, typeTag) {
        this.typeTag = typeTag;
        this.__app = null;
        this.per_item_read = proto['per_item_read'];
        this.per_item_create = proto['per_item_create'];
        this.per_item_write = proto['per_item_write'];
        this.per_byte_read = proto['per_byte_read'];
        this.per_byte_create = proto['per_byte_create'];
        this.per_byte_write = proto['per_byte_write'];
    }
    static StorageGasParser(data, typeTag, repo) {
        const proto = $.parseStructProto(data, typeTag, repo, StorageGas);
        return new StorageGas(proto, typeTag);
    }
    static load(repo, client, address, typeParams) {
        return __awaiter(this, void 0, void 0, function* () {
            const result = yield repo.loadResource(client, address, StorageGas, typeParams);
            return result;
        });
    }
    static loadByApp(app, address, typeParams) {
        return __awaiter(this, void 0, void 0, function* () {
            const result = yield app.repo.loadResource(app.client, address, StorageGas, typeParams);
            yield result.loadFullState(app);
            return result;
        });
    }
    static getTag() {
        return new StructTag(moduleAddress$$, moduleName$$, 'StorageGas', []);
    }
    loadFullState(app) {
        return __awaiter(this, void 0, void 0, function* () {
            this.__app = app;
        });
    }
}
StorageGas.moduleAddress = moduleAddress$$;
StorageGas.moduleName = moduleName$$;
StorageGas.structName = 'StorageGas';
StorageGas.typeParameters = [];
StorageGas.fields = [
    { name: 'per_item_read', typeTag: AtomicTypeTag.U64 },
    { name: 'per_item_create', typeTag: AtomicTypeTag.U64 },
    { name: 'per_item_write', typeTag: AtomicTypeTag.U64 },
    { name: 'per_byte_read', typeTag: AtomicTypeTag.U64 },
    { name: 'per_byte_create', typeTag: AtomicTypeTag.U64 },
    { name: 'per_byte_write', typeTag: AtomicTypeTag.U64 }
];
class StorageGasConfig {
    constructor(proto, typeTag) {
        this.typeTag = typeTag;
        this.__app = null;
        this.item_config = proto['item_config'];
        this.byte_config = proto['byte_config'];
    }
    static StorageGasConfigParser(data, typeTag, repo) {
        const proto = $.parseStructProto(data, typeTag, repo, StorageGasConfig);
        return new StorageGasConfig(proto, typeTag);
    }
    static load(repo, client, address, typeParams) {
        return __awaiter(this, void 0, void 0, function* () {
            const result = yield repo.loadResource(client, address, StorageGasConfig, typeParams);
            return result;
        });
    }
    static loadByApp(app, address, typeParams) {
        return __awaiter(this, void 0, void 0, function* () {
            const result = yield app.repo.loadResource(app.client, address, StorageGasConfig, typeParams);
            yield result.loadFullState(app);
            return result;
        });
    }
    static getTag() {
        return new StructTag(moduleAddress$$, moduleName$$, 'StorageGasConfig', []);
    }
    loadFullState(app) {
        return __awaiter(this, void 0, void 0, function* () {
            yield this.item_config.loadFullState(app);
            yield this.byte_config.loadFullState(app);
            this.__app = app;
        });
    }
}
StorageGasConfig.moduleAddress = moduleAddress$$;
StorageGasConfig.moduleName = moduleName$$;
StorageGasConfig.structName = 'StorageGasConfig';
StorageGasConfig.typeParameters = [];
StorageGasConfig.fields = [
    { name: 'item_config', typeTag: new StructTag(new HexString('0x1'), 'storage_gas', 'UsageGasConfig', []) },
    { name: 'byte_config', typeTag: new StructTag(new HexString('0x1'), 'storage_gas', 'UsageGasConfig', []) }
];
class UsageGasConfig {
    constructor(proto, typeTag) {
        this.typeTag = typeTag;
        this.__app = null;
        this.target_usage = proto['target_usage'];
        this.read_curve = proto['read_curve'];
        this.create_curve = proto['create_curve'];
        this.write_curve = proto['write_curve'];
    }
    static UsageGasConfigParser(data, typeTag, repo) {
        const proto = $.parseStructProto(data, typeTag, repo, UsageGasConfig);
        return new UsageGasConfig(proto, typeTag);
    }
    static getTag() {
        return new StructTag(moduleAddress$$, moduleName$$, 'UsageGasConfig', []);
    }
    loadFullState(app) {
        return __awaiter(this, void 0, void 0, function* () {
            yield this.read_curve.loadFullState(app);
            yield this.create_curve.loadFullState(app);
            yield this.write_curve.loadFullState(app);
            this.__app = app;
        });
    }
}
UsageGasConfig.moduleAddress = moduleAddress$$;
UsageGasConfig.moduleName = moduleName$$;
UsageGasConfig.structName = 'UsageGasConfig';
UsageGasConfig.typeParameters = [];
UsageGasConfig.fields = [
    { name: 'target_usage', typeTag: AtomicTypeTag.U64 },
    { name: 'read_curve', typeTag: new StructTag(new HexString('0x1'), 'storage_gas', 'GasCurve', []) },
    { name: 'create_curve', typeTag: new StructTag(new HexString('0x1'), 'storage_gas', 'GasCurve', []) },
    { name: 'write_curve', typeTag: new StructTag(new HexString('0x1'), 'storage_gas', 'GasCurve', []) }
];
function base_8192_exponential_curve_(min_gas, max_gas, $c) {
    return new_gas_curve_($.copy(min_gas), $.copy(max_gas), [
        new_point_(u64('1000'), u64('2')),
        new_point_(u64('2000'), u64('6')),
        new_point_(u64('3000'), u64('17')),
        new_point_(u64('4000'), u64('44')),
        new_point_(u64('5000'), u64('109')),
        new_point_(u64('6000'), u64('271')),
        new_point_(u64('7000'), u64('669')),
        new_point_(u64('8000'), u64('1648')),
        new_point_(u64('9000'), u64('4061')),
        new_point_(u64('9500'), u64('6372')),
        new_point_(u64('9900'), u64('9138'))
    ], $c);
}
function calculate_create_gas_(config, usage, $c) {
    return calculate_gas_($.copy(config.target_usage), $.copy(usage), config.create_curve, $c);
}
function calculate_gas_(max_usage, current_usage, curve, $c) {
    let temp$1, temp$10, temp$11, temp$12, temp$13, temp$2, temp$3, temp$4, temp$5, temp$6, temp$7, temp$8, temp$9, capped_current_usage, current_usage_bps, i, j, left, mid, num_points, points, right, y_interpolated;
    if ($.copy(current_usage).gt($.copy(max_usage))) {
        temp$1 = $.copy(max_usage);
    }
    else {
        temp$1 = $.copy(current_usage);
    }
    capped_current_usage = temp$1;
    points = curve.points;
    num_points = length_$6(points, $c, [new SimpleStructTag(Point)]);
    current_usage_bps = $.copy(capped_current_usage).mul($.copy(BASIS_POINT_DENOMINATION)).div($.copy(max_usage));
    if ($.copy(num_points).eq(u64('0'))) {
        temp$3 = new Point({ x: u64('0'), y: u64('0') }, new SimpleStructTag(Point));
        temp$4 = temp$3;
        temp$2 = new Point({ x: $.copy(BASIS_POINT_DENOMINATION), y: $.copy(BASIS_POINT_DENOMINATION) }, new SimpleStructTag(Point));
        [temp$12, temp$13] = [temp$4, temp$2];
    }
    else {
        if ($.copy(current_usage_bps).lt($.copy(borrow_$7(points, u64('0'), $c, [new SimpleStructTag(Point)]).x))) {
            temp$5 = new Point({ x: u64('0'), y: u64('0') }, new SimpleStructTag(Point));
            [temp$10, temp$11] = [temp$5, borrow_$7(points, u64('0'), $c, [new SimpleStructTag(Point)])];
        }
        else {
            if ($.copy(borrow_$7(points, $.copy(num_points).sub(u64('1')), $c, [new SimpleStructTag(Point)]).x).le($.copy(current_usage_bps))) {
                temp$7 = borrow_$7(points, $.copy(num_points).sub(u64('1')), $c, [new SimpleStructTag(Point)]);
                temp$6 = new Point({ x: $.copy(BASIS_POINT_DENOMINATION), y: $.copy(BASIS_POINT_DENOMINATION) }, new SimpleStructTag(Point));
                [temp$8, temp$9] = [temp$7, temp$6];
            }
            else {
                [i, j] = [u64('0'), $.copy(num_points).sub(u64('2'))];
                while (true) {
                    if (!$.copy(i).lt($.copy(j)))
                        break;
                    {
                        mid = $.copy(j).sub($.copy(j).sub($.copy(i)).div(u64('2')));
                        if ($.copy(current_usage_bps).lt($.copy(borrow_$7(points, $.copy(mid), $c, [new SimpleStructTag(Point)]).x))) {
                            j = $.copy(mid).sub(u64('1'));
                        }
                        else {
                            i = $.copy(mid);
                        }
                    }
                }
                [temp$8, temp$9] = [
                    borrow_$7(points, $.copy(i), $c, [new SimpleStructTag(Point)]),
                    borrow_$7(points, $.copy(i).add(u64('1')), $c, [new SimpleStructTag(Point)])
                ];
            }
            [temp$10, temp$11] = [temp$8, temp$9];
        }
        [temp$12, temp$13] = [temp$10, temp$11];
    }
    [left, right] = [temp$12, temp$13];
    y_interpolated = interpolate_($.copy(left.x), $.copy(right.x), $.copy(left.y), $.copy(right.y), $.copy(current_usage_bps));
    return interpolate_(u64('0'), $.copy(BASIS_POINT_DENOMINATION), $.copy(curve.min_gas), $.copy(curve.max_gas), $.copy(y_interpolated));
}
function calculate_read_gas_(config, usage, $c) {
    return calculate_gas_($.copy(config.target_usage), $.copy(usage), config.read_curve, $c);
}
function calculate_write_gas_(config, usage, $c) {
    return calculate_gas_($.copy(config.target_usage), $.copy(usage), config.write_curve, $c);
}
function initialize_$e(aptos_framework, $c) {
    let byte_config, item_config, k, m;
    assert_aptos_framework_(aptos_framework, $c);
    if (!!$c.exists(new SimpleStructTag(StorageGasConfig), new HexString('0x1'))) {
        throw $.abortCode(already_exists_($.copy(ESTORAGE_GAS_CONFIG)));
    }
    k = u64('1000');
    m = u64('1000').mul(u64('1000'));
    item_config = new UsageGasConfig({
        target_usage: u64('2').mul($.copy(k)).mul($.copy(m)),
        read_curve: base_8192_exponential_curve_(u64('300').mul($.copy(k)), u64('300').mul($.copy(k)).mul(u64('100')), $c),
        create_curve: base_8192_exponential_curve_(u64('5').mul($.copy(m)), u64('5').mul($.copy(m)).mul(u64('100')), $c),
        write_curve: base_8192_exponential_curve_(u64('300').mul($.copy(k)), u64('300').mul($.copy(k)).mul(u64('100')), $c)
    }, new SimpleStructTag(UsageGasConfig));
    byte_config = new UsageGasConfig({
        target_usage: u64('1').mul($.copy(m)).mul($.copy(m)),
        read_curve: base_8192_exponential_curve_(u64('300'), u64('300').mul(u64('100')), $c),
        create_curve: base_8192_exponential_curve_(u64('5').mul($.copy(k)), u64('5').mul($.copy(k)).mul(u64('100')), $c),
        write_curve: base_8192_exponential_curve_(u64('5').mul($.copy(k)), u64('5').mul($.copy(k)).mul(u64('100')), $c)
    }, new SimpleStructTag(UsageGasConfig));
    $c.move_to(new SimpleStructTag(StorageGasConfig), aptos_framework, new StorageGasConfig({ item_config: $.copy(item_config), byte_config: $.copy(byte_config) }, new SimpleStructTag(StorageGasConfig)));
    if (!!$c.exists(new SimpleStructTag(StorageGas), new HexString('0x1'))) {
        throw $.abortCode(already_exists_($.copy(ESTORAGE_GAS)));
    }
    $c.move_to(new SimpleStructTag(StorageGas), aptos_framework, new StorageGas({
        per_item_read: u64('300').mul($.copy(k)),
        per_item_create: u64('5').mul($.copy(m)),
        per_item_write: u64('300').mul($.copy(k)),
        per_byte_read: u64('300'),
        per_byte_create: u64('5').mul($.copy(k)),
        per_byte_write: u64('5').mul($.copy(k))
    }, new SimpleStructTag(StorageGas)));
    return;
}
function interpolate_(x0, x1, y0, y1, x, $c) {
    return $.copy(y0).add($.copy(x)
        .sub($.copy(x0))
        .mul($.copy(y1).sub($.copy(y0)))
        .div($.copy(x1).sub($.copy(x0))));
}
function new_gas_curve_(min_gas, max_gas, points, $c) {
    if (!$.copy(max_gas).ge($.copy(min_gas))) {
        throw $.abortCode(invalid_argument_($.copy(EINVALID_GAS_RANGE)));
    }
    if (!$.copy(max_gas).le($.copy(MAX_U64$4).div($.copy(BASIS_POINT_DENOMINATION)))) {
        throw $.abortCode(invalid_argument_($.copy(EINVALID_GAS_RANGE)));
    }
    validate_points_(points, $c);
    return new GasCurve({ min_gas: $.copy(min_gas), max_gas: $.copy(max_gas), points: $.copy(points) }, new SimpleStructTag(GasCurve));
}
function new_point_(x, y, $c) {
    let temp$1;
    if ($.copy(x).le($.copy(BASIS_POINT_DENOMINATION))) {
        temp$1 = $.copy(y).le($.copy(BASIS_POINT_DENOMINATION));
    }
    else {
        temp$1 = false;
    }
    if (!temp$1) {
        throw $.abortCode(invalid_argument_($.copy(EINVALID_POINT_RANGE)));
    }
    return new Point({ x: $.copy(x), y: $.copy(y) }, new SimpleStructTag(Point));
}
function new_storage_gas_config_(item_config, byte_config, $c) {
    return new StorageGasConfig({ item_config: $.copy(item_config), byte_config: $.copy(byte_config) }, new SimpleStructTag(StorageGasConfig));
}
function new_usage_gas_config_(target_usage, read_curve, create_curve, write_curve, $c) {
    if (!$.copy(target_usage).gt(u64('0'))) {
        throw $.abortCode(invalid_argument_($.copy(EZERO_TARGET_USAGE)));
    }
    if (!$.copy(target_usage).le($.copy(MAX_U64$4).div($.copy(BASIS_POINT_DENOMINATION)))) {
        throw $.abortCode(invalid_argument_($.copy(ETARGET_USAGE_TOO_BIG)));
    }
    return new UsageGasConfig({
        target_usage: $.copy(target_usage),
        read_curve: $.copy(read_curve),
        create_curve: $.copy(create_curve),
        write_curve: $.copy(write_curve)
    }, new SimpleStructTag(UsageGasConfig));
}
function on_reconfig_($c) {
    let bytes, gas, gas_config, items;
    if (!$c.exists(new SimpleStructTag(StorageGasConfig), new HexString('0x1'))) {
        throw $.abortCode(not_found_($.copy(ESTORAGE_GAS_CONFIG)));
    }
    if (!$c.exists(new SimpleStructTag(StorageGas), new HexString('0x1'))) {
        throw $.abortCode(not_found_($.copy(ESTORAGE_GAS)));
    }
    [items, bytes] = current_items_and_bytes_($c);
    gas_config = $c.borrow_global(new SimpleStructTag(StorageGasConfig), new HexString('0x1'));
    gas = $c.borrow_global_mut(new SimpleStructTag(StorageGas), new HexString('0x1'));
    gas.per_item_read = calculate_read_gas_(gas_config.item_config, $.copy(items), $c);
    gas.per_item_create = calculate_create_gas_(gas_config.item_config, $.copy(items), $c);
    gas.per_item_write = calculate_write_gas_(gas_config.item_config, $.copy(items), $c);
    gas.per_byte_read = calculate_read_gas_(gas_config.byte_config, $.copy(bytes), $c);
    gas.per_byte_create = calculate_create_gas_(gas_config.byte_config, $.copy(bytes), $c);
    gas.per_byte_write = calculate_write_gas_(gas_config.byte_config, $.copy(bytes), $c);
    return;
}
function set_config_(aptos_framework, config, $c) {
    assert_aptos_framework_(aptos_framework, $c);
    $.set($c.borrow_global_mut(new SimpleStructTag(StorageGasConfig), new HexString('0x1')), $.copy(config));
    return;
}
function validate_points_(points, $c) {
    let temp$1, temp$2, temp$3, temp$4, temp$5, cur, i, len, next;
    len = length_$6(points, $c, [new SimpleStructTag(Point)]);
    i = u64('0');
    while (true) {
        if (!$.copy(i).le($.copy(len)))
            break;
        {
            if ($.copy(i).eq(u64('0'))) {
                temp$1 = new Point({ x: u64('0'), y: u64('0') }, new SimpleStructTag(Point));
                temp$2 = temp$1;
            }
            else {
                temp$2 = borrow_$7(points, $.copy(i).sub(u64('1')), $c, [new SimpleStructTag(Point)]);
            }
            cur = temp$2;
            if ($.copy(i).eq($.copy(len))) {
                temp$3 = new Point({ x: $.copy(BASIS_POINT_DENOMINATION), y: $.copy(BASIS_POINT_DENOMINATION) }, new SimpleStructTag(Point));
                temp$4 = temp$3;
            }
            else {
                temp$4 = borrow_$7(points, $.copy(i), $c, [new SimpleStructTag(Point)]);
            }
            next = temp$4;
            if ($.copy(cur.x).lt($.copy(next.x))) {
                temp$5 = $.copy(cur.y).le($.copy(next.y));
            }
            else {
                temp$5 = false;
            }
            if (!temp$5) {
                throw $.abortCode(invalid_argument_($.copy(EINVALID_MONOTONICALLY_NON_DECREASING_CURVE)));
            }
            i = $.copy(i).add(u64('1'));
        }
    }
    return;
}
function loadParsers$1c(repo) {
    repo.addParser('0x1::storage_gas::GasCurve', GasCurve.GasCurveParser);
    repo.addParser('0x1::storage_gas::Point', Point.PointParser);
    repo.addParser('0x1::storage_gas::StorageGas', StorageGas.StorageGasParser);
    repo.addParser('0x1::storage_gas::StorageGasConfig', StorageGasConfig.StorageGasConfigParser);
    repo.addParser('0x1::storage_gas::UsageGasConfig', UsageGasConfig.UsageGasConfigParser);
}
class App$1d {
    constructor(client, repo, cache) {
        this.client = client;
        this.repo = repo;
        this.cache = cache;
    }
    get moduleAddress() {
        {
            return moduleAddress$$;
        }
    }
    get moduleName() {
        {
            return moduleName$$;
        }
    }
    get GasCurve() {
        return GasCurve;
    }
    get Point() {
        return Point;
    }
    get StorageGas() {
        return StorageGas;
    }
    loadStorageGas(owner, loadFull = true, fillCache = true) {
        return __awaiter(this, void 0, void 0, function* () {
            const val = yield StorageGas.load(this.repo, this.client, owner, []);
            if (loadFull) {
                yield val.loadFullState(this);
            }
            if (fillCache) {
                this.cache.set(val.typeTag, owner, val);
            }
            return val;
        });
    }
    get StorageGasConfig() {
        return StorageGasConfig;
    }
    loadStorageGasConfig(owner, loadFull = true, fillCache = true) {
        return __awaiter(this, void 0, void 0, function* () {
            const val = yield StorageGasConfig.load(this.repo, this.client, owner, []);
            if (loadFull) {
                yield val.loadFullState(this);
            }
            if (fillCache) {
                this.cache.set(val.typeTag, owner, val);
            }
            return val;
        });
    }
    get UsageGasConfig() {
        return UsageGasConfig;
    }
}

var Storage_gas = /*#__PURE__*/Object.freeze({
    __proto__: null,
    packageName: packageName$$,
    moduleAddress: moduleAddress$$,
    moduleName: moduleName$$,
    BASIS_POINT_DENOMINATION: BASIS_POINT_DENOMINATION,
    EINVALID_GAS_RANGE: EINVALID_GAS_RANGE,
    EINVALID_MONOTONICALLY_NON_DECREASING_CURVE: EINVALID_MONOTONICALLY_NON_DECREASING_CURVE,
    EINVALID_POINT_RANGE: EINVALID_POINT_RANGE,
    ESTORAGE_GAS: ESTORAGE_GAS,
    ESTORAGE_GAS_CONFIG: ESTORAGE_GAS_CONFIG,
    ETARGET_USAGE_TOO_BIG: ETARGET_USAGE_TOO_BIG,
    EZERO_TARGET_USAGE: EZERO_TARGET_USAGE,
    MAX_U64: MAX_U64$4,
    GasCurve: GasCurve,
    Point: Point,
    StorageGas: StorageGas,
    StorageGasConfig: StorageGasConfig,
    UsageGasConfig: UsageGasConfig,
    base_8192_exponential_curve_: base_8192_exponential_curve_,
    calculate_create_gas_: calculate_create_gas_,
    calculate_gas_: calculate_gas_,
    calculate_read_gas_: calculate_read_gas_,
    calculate_write_gas_: calculate_write_gas_,
    initialize_: initialize_$e,
    interpolate_: interpolate_,
    new_gas_curve_: new_gas_curve_,
    new_point_: new_point_,
    new_storage_gas_config_: new_storage_gas_config_,
    new_usage_gas_config_: new_usage_gas_config_,
    on_reconfig_: on_reconfig_,
    set_config_: set_config_,
    validate_points_: validate_points_,
    loadParsers: loadParsers$1c,
    App: App$1d
});

const packageName$_ = 'AptosFramework';
const moduleAddress$_ = new HexString('0x1');
const moduleName$_ = 'reconfiguration';
const ECONFIG = u64('2');
const ECONFIGURATION = u64('1');
const EINVALID_BLOCK_TIME = u64('4');
const EINVALID_GUID_FOR_EVENT = u64('5');
const EMODIFY_CAPABILITY = u64('3');
class Configuration {
    constructor(proto, typeTag) {
        this.typeTag = typeTag;
        this.__app = null;
        this.epoch = proto['epoch'];
        this.last_reconfiguration_time = proto['last_reconfiguration_time'];
        this.events = proto['events'];
    }
    static ConfigurationParser(data, typeTag, repo) {
        const proto = $.parseStructProto(data, typeTag, repo, Configuration);
        return new Configuration(proto, typeTag);
    }
    static load(repo, client, address, typeParams) {
        return __awaiter(this, void 0, void 0, function* () {
            const result = yield repo.loadResource(client, address, Configuration, typeParams);
            return result;
        });
    }
    static loadByApp(app, address, typeParams) {
        return __awaiter(this, void 0, void 0, function* () {
            const result = yield app.repo.loadResource(app.client, address, Configuration, typeParams);
            yield result.loadFullState(app);
            return result;
        });
    }
    static getTag() {
        return new StructTag(moduleAddress$_, moduleName$_, 'Configuration', []);
    }
    loadFullState(app) {
        return __awaiter(this, void 0, void 0, function* () {
            yield this.events.loadFullState(app);
            this.__app = app;
        });
    }
}
Configuration.moduleAddress = moduleAddress$_;
Configuration.moduleName = moduleName$_;
Configuration.structName = 'Configuration';
Configuration.typeParameters = [];
Configuration.fields = [
    { name: 'epoch', typeTag: AtomicTypeTag.U64 },
    { name: 'last_reconfiguration_time', typeTag: AtomicTypeTag.U64 },
    {
        name: 'events',
        typeTag: new StructTag(new HexString('0x1'), 'event', 'EventHandle', [
            new StructTag(new HexString('0x1'), 'reconfiguration', 'NewEpochEvent', [])
        ])
    }
];
class DisableReconfiguration {
    constructor(proto, typeTag) {
        this.typeTag = typeTag;
        this.__app = null;
    }
    static DisableReconfigurationParser(data, typeTag, repo) {
        const proto = $.parseStructProto(data, typeTag, repo, DisableReconfiguration);
        return new DisableReconfiguration(proto, typeTag);
    }
    static load(repo, client, address, typeParams) {
        return __awaiter(this, void 0, void 0, function* () {
            const result = yield repo.loadResource(client, address, DisableReconfiguration, typeParams);
            return result;
        });
    }
    static loadByApp(app, address, typeParams) {
        return __awaiter(this, void 0, void 0, function* () {
            const result = yield app.repo.loadResource(app.client, address, DisableReconfiguration, typeParams);
            yield result.loadFullState(app);
            return result;
        });
    }
    static getTag() {
        return new StructTag(moduleAddress$_, moduleName$_, 'DisableReconfiguration', []);
    }
    loadFullState(app) {
        return __awaiter(this, void 0, void 0, function* () {
            this.__app = app;
        });
    }
}
DisableReconfiguration.moduleAddress = moduleAddress$_;
DisableReconfiguration.moduleName = moduleName$_;
DisableReconfiguration.structName = 'DisableReconfiguration';
DisableReconfiguration.typeParameters = [];
DisableReconfiguration.fields = [];
class NewEpochEvent {
    constructor(proto, typeTag) {
        this.typeTag = typeTag;
        this.__app = null;
        this.epoch = proto['epoch'];
    }
    static NewEpochEventParser(data, typeTag, repo) {
        const proto = $.parseStructProto(data, typeTag, repo, NewEpochEvent);
        return new NewEpochEvent(proto, typeTag);
    }
    static getTag() {
        return new StructTag(moduleAddress$_, moduleName$_, 'NewEpochEvent', []);
    }
    loadFullState(app) {
        return __awaiter(this, void 0, void 0, function* () {
            this.__app = app;
        });
    }
}
NewEpochEvent.moduleAddress = moduleAddress$_;
NewEpochEvent.moduleName = moduleName$_;
NewEpochEvent.structName = 'NewEpochEvent';
NewEpochEvent.typeParameters = [];
NewEpochEvent.fields = [{ name: 'epoch', typeTag: AtomicTypeTag.U64 }];
function current_epoch_($c) {
    return $.copy($c.borrow_global(new SimpleStructTag(Configuration), new HexString('0x1')).epoch);
}
function disable_reconfiguration_(aptos_framework, $c) {
    assert_aptos_framework_(aptos_framework, $c);
    if (!reconfiguration_enabled_($c)) {
        throw $.abortCode(invalid_state_($.copy(ECONFIGURATION)));
    }
    return $c.move_to(new SimpleStructTag(DisableReconfiguration), aptos_framework, new DisableReconfiguration({}, new SimpleStructTag(DisableReconfiguration)));
}
function emit_genesis_reconfiguration_event_($c) {
    let temp$1, config_ref;
    config_ref = $c.borrow_global_mut(new SimpleStructTag(Configuration), new HexString('0x1'));
    if ($.copy(config_ref.epoch).eq(u64('0'))) {
        temp$1 = $.copy(config_ref.last_reconfiguration_time).eq(u64('0'));
    }
    else {
        temp$1 = false;
    }
    if (!temp$1) {
        throw $.abortCode(invalid_state_($.copy(ECONFIGURATION)));
    }
    config_ref.epoch = u64('1');
    emit_event_(config_ref.events, new NewEpochEvent({ epoch: $.copy(config_ref.epoch) }, new SimpleStructTag(NewEpochEvent)), $c, [new SimpleStructTag(NewEpochEvent)]);
    return;
}
function enable_reconfiguration_(aptos_framework, $c) {
    assert_aptos_framework_(aptos_framework, $c);
    if (!!reconfiguration_enabled_($c)) {
        throw $.abortCode(invalid_state_($.copy(ECONFIGURATION)));
    }
    $c.move_from(new SimpleStructTag(DisableReconfiguration), address_of_(aptos_framework, $c));
    return;
}
function initialize_$d(aptos_framework, $c) {
    assert_aptos_framework_(aptos_framework, $c);
    if (!get_guid_next_creation_num_(address_of_(aptos_framework, $c), $c).eq(u64('2'))) {
        throw $.abortCode(invalid_state_($.copy(EINVALID_GUID_FOR_EVENT)));
    }
    $c.move_to(new SimpleStructTag(Configuration), aptos_framework, new Configuration({
        epoch: u64('0'),
        last_reconfiguration_time: u64('0'),
        events: new_event_handle_(aptos_framework, $c, [new SimpleStructTag(NewEpochEvent)])
    }, new SimpleStructTag(Configuration)));
    return;
}
function last_reconfiguration_time_($c) {
    return $.copy($c.borrow_global(new SimpleStructTag(Configuration), new HexString('0x1')).last_reconfiguration_time);
}
function reconfiguration_enabled_($c) {
    return !$c.exists(new SimpleStructTag(DisableReconfiguration), new HexString('0x1'));
}
function reconfigure_$1($c) {
    let temp$1, temp$2, config_ref, current_time;
    if (is_genesis_($c)) {
        temp$1 = true;
    }
    else {
        temp$1 = now_microseconds_($c).eq(u64('0'));
    }
    if (temp$1) {
        temp$2 = true;
    }
    else {
        temp$2 = !reconfiguration_enabled_($c);
    }
    if (temp$2) {
        return;
    }
    config_ref = $c.borrow_global_mut(new SimpleStructTag(Configuration), new HexString('0x1'));
    current_time = now_microseconds_($c);
    if ($.copy(current_time).eq($.copy(config_ref.last_reconfiguration_time))) {
        return;
    }
    on_new_epoch_($c);
    on_reconfig_($c);
    if (!$.copy(current_time).gt($.copy(config_ref.last_reconfiguration_time))) {
        throw $.abortCode(invalid_state_($.copy(EINVALID_BLOCK_TIME)));
    }
    config_ref.last_reconfiguration_time = $.copy(current_time);
    config_ref.epoch = $.copy(config_ref.epoch).add(u64('1'));
    emit_event_(config_ref.events, new NewEpochEvent({ epoch: $.copy(config_ref.epoch) }, new SimpleStructTag(NewEpochEvent)), $c, [new SimpleStructTag(NewEpochEvent)]);
    return;
}
function loadParsers$1b(repo) {
    repo.addParser('0x1::reconfiguration::Configuration', Configuration.ConfigurationParser);
    repo.addParser('0x1::reconfiguration::DisableReconfiguration', DisableReconfiguration.DisableReconfigurationParser);
    repo.addParser('0x1::reconfiguration::NewEpochEvent', NewEpochEvent.NewEpochEventParser);
}
class App$1c {
    constructor(client, repo, cache) {
        this.client = client;
        this.repo = repo;
        this.cache = cache;
    }
    get moduleAddress() {
        {
            return moduleAddress$_;
        }
    }
    get moduleName() {
        {
            return moduleName$_;
        }
    }
    get Configuration() {
        return Configuration;
    }
    loadConfiguration(owner, loadFull = true, fillCache = true) {
        return __awaiter(this, void 0, void 0, function* () {
            const val = yield Configuration.load(this.repo, this.client, owner, []);
            if (loadFull) {
                yield val.loadFullState(this);
            }
            if (fillCache) {
                this.cache.set(val.typeTag, owner, val);
            }
            return val;
        });
    }
    get DisableReconfiguration() {
        return DisableReconfiguration;
    }
    loadDisableReconfiguration(owner, loadFull = true, fillCache = true) {
        return __awaiter(this, void 0, void 0, function* () {
            const val = yield DisableReconfiguration.load(this.repo, this.client, owner, []);
            if (loadFull) {
                yield val.loadFullState(this);
            }
            if (fillCache) {
                this.cache.set(val.typeTag, owner, val);
            }
            return val;
        });
    }
    get NewEpochEvent() {
        return NewEpochEvent;
    }
}

var Reconfiguration = /*#__PURE__*/Object.freeze({
    __proto__: null,
    packageName: packageName$_,
    moduleAddress: moduleAddress$_,
    moduleName: moduleName$_,
    ECONFIG: ECONFIG,
    ECONFIGURATION: ECONFIGURATION,
    EINVALID_BLOCK_TIME: EINVALID_BLOCK_TIME,
    EINVALID_GUID_FOR_EVENT: EINVALID_GUID_FOR_EVENT,
    EMODIFY_CAPABILITY: EMODIFY_CAPABILITY,
    Configuration: Configuration,
    DisableReconfiguration: DisableReconfiguration,
    NewEpochEvent: NewEpochEvent,
    current_epoch_: current_epoch_,
    disable_reconfiguration_: disable_reconfiguration_,
    emit_genesis_reconfiguration_event_: emit_genesis_reconfiguration_event_,
    enable_reconfiguration_: enable_reconfiguration_,
    initialize_: initialize_$d,
    last_reconfiguration_time_: last_reconfiguration_time_,
    reconfiguration_enabled_: reconfiguration_enabled_,
    reconfigure_: reconfigure_$1,
    loadParsers: loadParsers$1b,
    App: App$1c
});

const packageName$Z = 'AptosStdlib';
const moduleAddress$Z = new HexString('0x1');
const moduleName$Z = 'comparator';
const EQUAL$2 = u8('0');
const GREATER = u8('2');
const SMALLER = u8('1');
class Result {
    constructor(proto, typeTag) {
        this.typeTag = typeTag;
        this.__app = null;
        this.inner = proto['inner'];
    }
    static ResultParser(data, typeTag, repo) {
        const proto = $.parseStructProto(data, typeTag, repo, Result);
        return new Result(proto, typeTag);
    }
    static getTag() {
        return new StructTag(moduleAddress$Z, moduleName$Z, 'Result', []);
    }
    loadFullState(app) {
        return __awaiter(this, void 0, void 0, function* () {
            this.__app = app;
        });
    }
}
Result.moduleAddress = moduleAddress$Z;
Result.moduleName = moduleName$Z;
Result.structName = 'Result';
Result.typeParameters = [];
Result.fields = [{ name: 'inner', typeTag: AtomicTypeTag.U8 }];
function compare_$3(left, right, $c, $p /* <T>*/) {
    let left_bytes, right_bytes;
    left_bytes = to_bytes_(left, $c, [$p[0]]);
    right_bytes = to_bytes_(right, $c, [$p[0]]);
    return compare_u8_vector_($.copy(left_bytes), $.copy(right_bytes), $c);
}
function compare_u8_vector_(left, right, $c) {
    let temp$1, temp$2, temp$3, idx, left_byte, left_length, right_byte, right_length;
    left_length = length_$6(left, $c, [AtomicTypeTag.U8]);
    right_length = length_$6(right, $c, [AtomicTypeTag.U8]);
    idx = u64('0');
    while (true) {
        {
            if ($.copy(idx).lt($.copy(left_length))) {
                temp$1 = $.copy(idx).lt($.copy(right_length));
            }
            else {
                temp$1 = false;
            }
        }
        if (!temp$1)
            break;
        {
            left_byte = $.copy(borrow_$7(left, $.copy(idx), $c, [AtomicTypeTag.U8]));
            right_byte = $.copy(borrow_$7(right, $.copy(idx), $c, [AtomicTypeTag.U8]));
            if ($.copy(left_byte).lt($.copy(right_byte))) {
                return new Result({ inner: $.copy(SMALLER) }, new SimpleStructTag(Result));
            }
            else {
                if ($.copy(left_byte).gt($.copy(right_byte))) {
                    return new Result({ inner: $.copy(GREATER) }, new SimpleStructTag(Result));
                }
            }
            idx = $.copy(idx).add(u64('1'));
        }
    }
    if ($.copy(left_length).lt($.copy(right_length))) {
        temp$3 = new Result({ inner: $.copy(SMALLER) }, new SimpleStructTag(Result));
    }
    else {
        if ($.copy(left_length).gt($.copy(right_length))) {
            temp$2 = new Result({ inner: $.copy(GREATER) }, new SimpleStructTag(Result));
        }
        else {
            temp$2 = new Result({ inner: $.copy(EQUAL$2) }, new SimpleStructTag(Result));
        }
        temp$3 = temp$2;
    }
    return temp$3;
}
function is_equal_(result, $c) {
    return $.copy(result.inner).eq($.copy(EQUAL$2));
}
function is_greater_than_(result, $c) {
    return $.copy(result.inner).eq($.copy(GREATER));
}
function is_smaller_than_(result, $c) {
    return $.copy(result.inner).eq($.copy(SMALLER));
}
function loadParsers$1a(repo) {
    repo.addParser('0x1::comparator::Result', Result.ResultParser);
}
class App$1b {
    constructor(client, repo, cache) {
        this.client = client;
        this.repo = repo;
        this.cache = cache;
    }
    get moduleAddress() {
        {
            return moduleAddress$Z;
        }
    }
    get moduleName() {
        {
            return moduleName$Z;
        }
    }
    get Result() {
        return Result;
    }
}

var Comparator = /*#__PURE__*/Object.freeze({
    __proto__: null,
    packageName: packageName$Z,
    moduleAddress: moduleAddress$Z,
    moduleName: moduleName$Z,
    EQUAL: EQUAL$2,
    GREATER: GREATER,
    SMALLER: SMALLER,
    Result: Result,
    compare_: compare_$3,
    compare_u8_vector_: compare_u8_vector_,
    is_equal_: is_equal_,
    is_greater_than_: is_greater_than_,
    is_smaller_than_: is_smaller_than_,
    loadParsers: loadParsers$1a,
    App: App$1b
});

const packageName$Y = 'AptosStdlib';
const moduleAddress$Y = new HexString('0x1');
const moduleName$Y = 'simple_map';
const EKEY_ALREADY_EXISTS = u64('1');
const EKEY_NOT_FOUND = u64('2');
class Element {
    constructor(proto, typeTag) {
        this.typeTag = typeTag;
        this.__app = null;
        this.key = proto['key'];
        this.value = proto['value'];
    }
    static ElementParser(data, typeTag, repo) {
        const proto = $.parseStructProto(data, typeTag, repo, Element);
        return new Element(proto, typeTag);
    }
    static makeTag($p) {
        return new StructTag(moduleAddress$Y, moduleName$Y, 'Element', $p);
    }
    loadFullState(app) {
        return __awaiter(this, void 0, void 0, function* () {
            if (this.key.typeTag instanceof StructTag) {
                yield this.key.loadFullState(app);
            }
            if (this.value.typeTag instanceof StructTag) {
                yield this.value.loadFullState(app);
            }
            this.__app = app;
        });
    }
}
Element.moduleAddress = moduleAddress$Y;
Element.moduleName = moduleName$Y;
Element.structName = 'Element';
Element.typeParameters = [
    { name: 'Key', isPhantom: false },
    { name: 'Value', isPhantom: false }
];
Element.fields = [
    { name: 'key', typeTag: new $.TypeParamIdx(0) },
    { name: 'value', typeTag: new $.TypeParamIdx(1) }
];
class SimpleMap {
    constructor(proto, typeTag) {
        this.typeTag = typeTag;
        this.__app = null;
        this.data = proto['data'];
    }
    static SimpleMapParser(data, typeTag, repo) {
        const proto = $.parseStructProto(data, typeTag, repo, SimpleMap);
        return new SimpleMap(proto, typeTag);
    }
    static makeTag($p) {
        return new StructTag(moduleAddress$Y, moduleName$Y, 'SimpleMap', $p);
    }
    loadFullState(app) {
        return __awaiter(this, void 0, void 0, function* () {
            this.__app = app;
        });
    }
}
SimpleMap.moduleAddress = moduleAddress$Y;
SimpleMap.moduleName = moduleName$Y;
SimpleMap.structName = 'SimpleMap';
SimpleMap.typeParameters = [
    { name: 'Key', isPhantom: false },
    { name: 'Value', isPhantom: false }
];
SimpleMap.fields = [
    {
        name: 'data',
        typeTag: new VectorTag(new StructTag(new HexString('0x1'), 'simple_map', 'Element', [new $.TypeParamIdx(0), new $.TypeParamIdx(1)]))
    }
];
function add_$4(map, key, value, $c, $p /* <Key, Value>*/) {
    let temp$1, temp$2, end, maybe_idx, maybe_placement, placement;
    [temp$1, temp$2] = [map, key];
    [maybe_idx, maybe_placement] = find_(temp$1, temp$2, $c, [$p[0], $p[1]]);
    if (!is_none_(maybe_idx, $c, [AtomicTypeTag.U64])) {
        throw $.abortCode(invalid_argument_($.copy(EKEY_ALREADY_EXISTS)));
    }
    push_back_(map.data, new Element({ key: key, value: value }, new SimpleStructTag(Element, [$p[0], $p[1]])), $c, [new SimpleStructTag(Element, [$p[0], $p[1]])]);
    placement = extract_$1(maybe_placement, $c, [AtomicTypeTag.U64]);
    end = length_$6(map.data, $c, [new SimpleStructTag(Element, [$p[0], $p[1]])]).sub(u64('1'));
    while ($.copy(placement).lt($.copy(end))) {
        {
            swap_$4(map.data, $.copy(placement), $.copy(end), $c, [new SimpleStructTag(Element, [$p[0], $p[1]])]);
            placement = $.copy(placement).add(u64('1'));
        }
    }
    return;
}
function borrow_$4(map, key, $c, $p /* <Key, Value>*/) {
    let idx, maybe_idx;
    [maybe_idx] = find_(map, key, $c, [$p[0], $p[1]]);
    if (!is_some_(maybe_idx, $c, [AtomicTypeTag.U64])) {
        throw $.abortCode(invalid_argument_($.copy(EKEY_NOT_FOUND)));
    }
    idx = extract_$1(maybe_idx, $c, [AtomicTypeTag.U64]);
    return borrow_$7(map.data, $.copy(idx), $c, [new SimpleStructTag(Element, [$p[0], $p[1]])]).value;
}
function borrow_mut_$4(map, key, $c, $p /* <Key, Value>*/) {
    let temp$1, temp$2, idx, maybe_idx;
    [temp$1, temp$2] = [map, key];
    [maybe_idx] = find_(temp$1, temp$2, $c, [$p[0], $p[1]]);
    if (!is_some_(maybe_idx, $c, [AtomicTypeTag.U64])) {
        throw $.abortCode(invalid_argument_($.copy(EKEY_NOT_FOUND)));
    }
    idx = extract_$1(maybe_idx, $c, [AtomicTypeTag.U64]);
    return borrow_mut_$7(map.data, $.copy(idx), $c, [new SimpleStructTag(Element, [$p[0], $p[1]])]).value;
}
function contains_key_(map, key, $c, $p /* <Key, Value>*/) {
    let maybe_idx;
    [maybe_idx] = find_(map, key, $c, [$p[0], $p[1]]);
    return is_some_(maybe_idx, $c, [AtomicTypeTag.U64]);
}
function create_$2($c, $p /* <Key, Value>*/) {
    return new SimpleMap({ data: empty_$5($c, [new SimpleStructTag(Element, [$p[0], $p[1]])]) }, new SimpleStructTag(SimpleMap, [$p[0], $p[1]]));
}
function destroy_empty_$4(map, $c, $p /* <Key, Value>*/) {
    let { data: data } = map;
    destroy_empty_$5(data, $c, [new SimpleStructTag(Element, [$p[0], $p[1]])]);
    return;
}
function find_(map, key, $c, $p /* <Key, Value>*/) {
    let temp$1, temp$2, temp$3, temp$4, left, length, mid, potential_key, right;
    length = length_$6(map.data, $c, [new SimpleStructTag(Element, [$p[0], $p[1]])]);
    if ($.copy(length).eq(u64('0'))) {
        return [none_($c, [AtomicTypeTag.U64]), some_(u64('0'), $c, [AtomicTypeTag.U64])];
    }
    left = u64('0');
    right = $.copy(length);
    while ($.copy(left).neq($.copy(right))) {
        {
            mid = $.copy(left).add($.copy(right).sub($.copy(left)).div(u64('2')));
            potential_key = borrow_$7(map.data, $.copy(mid), $c, [new SimpleStructTag(Element, [$p[0], $p[1]])]).key;
            temp$1 = compare_$3(potential_key, key, $c, [$p[0]]);
            if (is_smaller_than_(temp$1)) {
                left = $.copy(mid).add(u64('1'));
            }
            else {
                right = $.copy(mid);
            }
        }
    }
    if ($.copy(left).neq($.copy(length))) {
        temp$2 = $.dyn_eq($p[0], key, borrow_$7(map.data, $.copy(left), $c, [new SimpleStructTag(Element, [$p[0], $p[1]])]).key);
    }
    else {
        temp$2 = false;
    }
    if (temp$2) {
        [temp$3, temp$4] = [some_($.copy(left), $c, [AtomicTypeTag.U64]), none_($c, [AtomicTypeTag.U64])];
    }
    else {
        [temp$3, temp$4] = [none_($c, [AtomicTypeTag.U64]), some_($.copy(left), $c, [AtomicTypeTag.U64])];
    }
    return [temp$3, temp$4];
}
function length_$4(map, $c, $p /* <Key, Value>*/) {
    return length_$6(map.data, $c, [new SimpleStructTag(Element, [$p[0], $p[1]])]);
}
function remove_$2(map, key, $c, $p /* <Key, Value>*/) {
    let temp$1, temp$2, end, maybe_idx, placement;
    [temp$1, temp$2] = [map, key];
    [maybe_idx] = find_(temp$1, temp$2, $c, [$p[0], $p[1]]);
    if (!is_some_(maybe_idx, $c, [AtomicTypeTag.U64])) {
        throw $.abortCode(invalid_argument_($.copy(EKEY_NOT_FOUND)));
    }
    placement = extract_$1(maybe_idx, $c, [AtomicTypeTag.U64]);
    end = length_$6(map.data, $c, [new SimpleStructTag(Element, [$p[0], $p[1]])]).sub(u64('1'));
    while ($.copy(placement).lt($.copy(end))) {
        {
            swap_$4(map.data, $.copy(placement), $.copy(placement).add(u64('1')), $c, [
                new SimpleStructTag(Element, [$p[0], $p[1]])
            ]);
            placement = $.copy(placement).add(u64('1'));
        }
    }
    let { key: key__3, value: value } = pop_back_(map.data, $c, [new SimpleStructTag(Element, [$p[0], $p[1]])]);
    return [key__3, value];
}
function loadParsers$19(repo) {
    repo.addParser('0x1::simple_map::Element', Element.ElementParser);
    repo.addParser('0x1::simple_map::SimpleMap', SimpleMap.SimpleMapParser);
}
class App$1a {
    constructor(client, repo, cache) {
        this.client = client;
        this.repo = repo;
        this.cache = cache;
    }
    get moduleAddress() {
        {
            return moduleAddress$Y;
        }
    }
    get moduleName() {
        {
            return moduleName$Y;
        }
    }
    get Element() {
        return Element;
    }
    get SimpleMap() {
        return SimpleMap;
    }
}

var Simple_map = /*#__PURE__*/Object.freeze({
    __proto__: null,
    packageName: packageName$Y,
    moduleAddress: moduleAddress$Y,
    moduleName: moduleName$Y,
    EKEY_ALREADY_EXISTS: EKEY_ALREADY_EXISTS,
    EKEY_NOT_FOUND: EKEY_NOT_FOUND,
    Element: Element,
    SimpleMap: SimpleMap,
    add_: add_$4,
    borrow_: borrow_$4,
    borrow_mut_: borrow_mut_$4,
    contains_key_: contains_key_,
    create_: create_$2,
    destroy_empty_: destroy_empty_$4,
    find_: find_,
    length_: length_$4,
    remove_: remove_$2,
    loadParsers: loadParsers$19,
    App: App$1a
});

const packageName$X = 'AptosFramework';
const moduleAddress$X = new HexString('0x1');
const moduleName$X = 'transaction_context';
function get_script_hash_($c) {
    return $.aptos_framework_transaction_context_get_script_hash($c);
}
function loadParsers$18(repo) { }
class App$19 {
    constructor(client, repo, cache) {
        this.client = client;
        this.repo = repo;
        this.cache = cache;
    }
    get moduleAddress() {
        {
            return moduleAddress$X;
        }
    }
    get moduleName() {
        {
            return moduleName$X;
        }
    }
}

var Transaction_context = /*#__PURE__*/Object.freeze({
    __proto__: null,
    packageName: packageName$X,
    moduleAddress: moduleAddress$X,
    moduleName: moduleName$X,
    get_script_hash_: get_script_hash_,
    loadParsers: loadParsers$18,
    App: App$19
});

const packageName$W = 'AptosFramework';
const moduleAddress$W = new HexString('0x1');
const moduleName$W = 'voting';
const EINVALID_MIN_VOTE_THRESHOLD = u64('7');
const EPROPOSAL_ALREADY_RESOLVED = u64('3');
const EPROPOSAL_CANNOT_BE_RESOLVED = u64('2');
const EPROPOSAL_EMPTY_EXECUTION_HASH = u64('4');
const EPROPOSAL_EXECUTION_HASH_NOT_MATCHING = u64('1');
const EPROPOSAL_VOTING_ALREADY_ENDED = u64('5');
const ERESOLUTION_CANNOT_BE_ATOMIC = u64('8');
const EVOTING_FORUM_ALREADY_REGISTERED = u64('6');
const PROPOSAL_STATE_FAILED = u64('3');
const PROPOSAL_STATE_PENDING = u64('0');
const PROPOSAL_STATE_SUCCEEDED$1 = u64('1');
const RESOLVABLE_TIME_METADATA_KEY = [
    u8('82'),
    u8('69'),
    u8('83'),
    u8('79'),
    u8('76'),
    u8('86'),
    u8('65'),
    u8('66'),
    u8('76'),
    u8('69'),
    u8('95'),
    u8('84'),
    u8('73'),
    u8('77'),
    u8('69'),
    u8('95'),
    u8('77'),
    u8('69'),
    u8('84'),
    u8('65'),
    u8('68'),
    u8('65'),
    u8('84'),
    u8('65'),
    u8('95'),
    u8('75'),
    u8('69'),
    u8('89')
];
class CreateProposalEvent$1 {
    constructor(proto, typeTag) {
        this.typeTag = typeTag;
        this.__app = null;
        this.proposal_id = proto['proposal_id'];
        this.early_resolution_vote_threshold = proto['early_resolution_vote_threshold'];
        this.execution_hash = proto['execution_hash'];
        this.expiration_secs = proto['expiration_secs'];
        this.metadata = proto['metadata'];
        this.min_vote_threshold = proto['min_vote_threshold'];
    }
    static CreateProposalEventParser(data, typeTag, repo) {
        const proto = $.parseStructProto(data, typeTag, repo, CreateProposalEvent$1);
        return new CreateProposalEvent$1(proto, typeTag);
    }
    static getTag() {
        return new StructTag(moduleAddress$W, moduleName$W, 'CreateProposalEvent', []);
    }
    loadFullState(app) {
        return __awaiter(this, void 0, void 0, function* () {
            yield this.early_resolution_vote_threshold.loadFullState(app);
            yield this.metadata.loadFullState(app);
            this.__app = app;
        });
    }
}
CreateProposalEvent$1.moduleAddress = moduleAddress$W;
CreateProposalEvent$1.moduleName = moduleName$W;
CreateProposalEvent$1.structName = 'CreateProposalEvent';
CreateProposalEvent$1.typeParameters = [];
CreateProposalEvent$1.fields = [
    { name: 'proposal_id', typeTag: AtomicTypeTag.U64 },
    {
        name: 'early_resolution_vote_threshold',
        typeTag: new StructTag(new HexString('0x1'), 'option', 'Option', [AtomicTypeTag.U128])
    },
    { name: 'execution_hash', typeTag: new VectorTag(AtomicTypeTag.U8) },
    { name: 'expiration_secs', typeTag: AtomicTypeTag.U64 },
    {
        name: 'metadata',
        typeTag: new StructTag(new HexString('0x1'), 'simple_map', 'SimpleMap', [
            new StructTag(new HexString('0x1'), 'string', 'String', []),
            new VectorTag(AtomicTypeTag.U8)
        ])
    },
    { name: 'min_vote_threshold', typeTag: AtomicTypeTag.U128 }
];
class Proposal {
    constructor(proto, typeTag) {
        this.typeTag = typeTag;
        this.__app = null;
        this.proposer = proto['proposer'];
        this.execution_content = proto['execution_content'];
        this.metadata = proto['metadata'];
        this.creation_time_secs = proto['creation_time_secs'];
        this.execution_hash = proto['execution_hash'];
        this.min_vote_threshold = proto['min_vote_threshold'];
        this.expiration_secs = proto['expiration_secs'];
        this.early_resolution_vote_threshold = proto['early_resolution_vote_threshold'];
        this.yes_votes = proto['yes_votes'];
        this.no_votes = proto['no_votes'];
        this.is_resolved = proto['is_resolved'];
        this.resolution_time_secs = proto['resolution_time_secs'];
    }
    static ProposalParser(data, typeTag, repo) {
        const proto = $.parseStructProto(data, typeTag, repo, Proposal);
        return new Proposal(proto, typeTag);
    }
    static makeTag($p) {
        return new StructTag(moduleAddress$W, moduleName$W, 'Proposal', $p);
    }
    loadFullState(app) {
        return __awaiter(this, void 0, void 0, function* () {
            yield this.execution_content.loadFullState(app);
            yield this.metadata.loadFullState(app);
            yield this.early_resolution_vote_threshold.loadFullState(app);
            this.__app = app;
        });
    }
}
Proposal.moduleAddress = moduleAddress$W;
Proposal.moduleName = moduleName$W;
Proposal.structName = 'Proposal';
Proposal.typeParameters = [{ name: 'ProposalType', isPhantom: false }];
Proposal.fields = [
    { name: 'proposer', typeTag: AtomicTypeTag.Address },
    {
        name: 'execution_content',
        typeTag: new StructTag(new HexString('0x1'), 'option', 'Option', [new $.TypeParamIdx(0)])
    },
    {
        name: 'metadata',
        typeTag: new StructTag(new HexString('0x1'), 'simple_map', 'SimpleMap', [
            new StructTag(new HexString('0x1'), 'string', 'String', []),
            new VectorTag(AtomicTypeTag.U8)
        ])
    },
    { name: 'creation_time_secs', typeTag: AtomicTypeTag.U64 },
    { name: 'execution_hash', typeTag: new VectorTag(AtomicTypeTag.U8) },
    { name: 'min_vote_threshold', typeTag: AtomicTypeTag.U128 },
    { name: 'expiration_secs', typeTag: AtomicTypeTag.U64 },
    {
        name: 'early_resolution_vote_threshold',
        typeTag: new StructTag(new HexString('0x1'), 'option', 'Option', [AtomicTypeTag.U128])
    },
    { name: 'yes_votes', typeTag: AtomicTypeTag.U128 },
    { name: 'no_votes', typeTag: AtomicTypeTag.U128 },
    { name: 'is_resolved', typeTag: AtomicTypeTag.Bool },
    { name: 'resolution_time_secs', typeTag: AtomicTypeTag.U64 }
];
class RegisterForumEvent {
    constructor(proto, typeTag) {
        this.typeTag = typeTag;
        this.__app = null;
        this.hosting_account = proto['hosting_account'];
        this.proposal_type_info = proto['proposal_type_info'];
    }
    static RegisterForumEventParser(data, typeTag, repo) {
        const proto = $.parseStructProto(data, typeTag, repo, RegisterForumEvent);
        return new RegisterForumEvent(proto, typeTag);
    }
    static getTag() {
        return new StructTag(moduleAddress$W, moduleName$W, 'RegisterForumEvent', []);
    }
    loadFullState(app) {
        return __awaiter(this, void 0, void 0, function* () {
            yield this.proposal_type_info.loadFullState(app);
            this.__app = app;
        });
    }
}
RegisterForumEvent.moduleAddress = moduleAddress$W;
RegisterForumEvent.moduleName = moduleName$W;
RegisterForumEvent.structName = 'RegisterForumEvent';
RegisterForumEvent.typeParameters = [];
RegisterForumEvent.fields = [
    { name: 'hosting_account', typeTag: AtomicTypeTag.Address },
    { name: 'proposal_type_info', typeTag: new StructTag(new HexString('0x1'), 'type_info', 'TypeInfo', []) }
];
class ResolveProposal {
    constructor(proto, typeTag) {
        this.typeTag = typeTag;
        this.__app = null;
        this.proposal_id = proto['proposal_id'];
        this.yes_votes = proto['yes_votes'];
        this.no_votes = proto['no_votes'];
        this.resolved_early = proto['resolved_early'];
    }
    static ResolveProposalParser(data, typeTag, repo) {
        const proto = $.parseStructProto(data, typeTag, repo, ResolveProposal);
        return new ResolveProposal(proto, typeTag);
    }
    static getTag() {
        return new StructTag(moduleAddress$W, moduleName$W, 'ResolveProposal', []);
    }
    loadFullState(app) {
        return __awaiter(this, void 0, void 0, function* () {
            this.__app = app;
        });
    }
}
ResolveProposal.moduleAddress = moduleAddress$W;
ResolveProposal.moduleName = moduleName$W;
ResolveProposal.structName = 'ResolveProposal';
ResolveProposal.typeParameters = [];
ResolveProposal.fields = [
    { name: 'proposal_id', typeTag: AtomicTypeTag.U64 },
    { name: 'yes_votes', typeTag: AtomicTypeTag.U128 },
    { name: 'no_votes', typeTag: AtomicTypeTag.U128 },
    { name: 'resolved_early', typeTag: AtomicTypeTag.Bool }
];
class VoteEvent$1 {
    constructor(proto, typeTag) {
        this.typeTag = typeTag;
        this.__app = null;
        this.proposal_id = proto['proposal_id'];
        this.num_votes = proto['num_votes'];
    }
    static VoteEventParser(data, typeTag, repo) {
        const proto = $.parseStructProto(data, typeTag, repo, VoteEvent$1);
        return new VoteEvent$1(proto, typeTag);
    }
    static getTag() {
        return new StructTag(moduleAddress$W, moduleName$W, 'VoteEvent', []);
    }
    loadFullState(app) {
        return __awaiter(this, void 0, void 0, function* () {
            this.__app = app;
        });
    }
}
VoteEvent$1.moduleAddress = moduleAddress$W;
VoteEvent$1.moduleName = moduleName$W;
VoteEvent$1.structName = 'VoteEvent';
VoteEvent$1.typeParameters = [];
VoteEvent$1.fields = [
    { name: 'proposal_id', typeTag: AtomicTypeTag.U64 },
    { name: 'num_votes', typeTag: AtomicTypeTag.U64 }
];
class VotingEvents {
    constructor(proto, typeTag) {
        this.typeTag = typeTag;
        this.__app = null;
        this.create_proposal_events = proto['create_proposal_events'];
        this.register_forum_events = proto['register_forum_events'];
        this.resolve_proposal_events = proto['resolve_proposal_events'];
        this.vote_events = proto['vote_events'];
    }
    static VotingEventsParser(data, typeTag, repo) {
        const proto = $.parseStructProto(data, typeTag, repo, VotingEvents);
        return new VotingEvents(proto, typeTag);
    }
    static getTag() {
        return new StructTag(moduleAddress$W, moduleName$W, 'VotingEvents', []);
    }
    loadFullState(app) {
        return __awaiter(this, void 0, void 0, function* () {
            yield this.create_proposal_events.loadFullState(app);
            yield this.register_forum_events.loadFullState(app);
            yield this.resolve_proposal_events.loadFullState(app);
            yield this.vote_events.loadFullState(app);
            this.__app = app;
        });
    }
}
VotingEvents.moduleAddress = moduleAddress$W;
VotingEvents.moduleName = moduleName$W;
VotingEvents.structName = 'VotingEvents';
VotingEvents.typeParameters = [];
VotingEvents.fields = [
    {
        name: 'create_proposal_events',
        typeTag: new StructTag(new HexString('0x1'), 'event', 'EventHandle', [
            new StructTag(new HexString('0x1'), 'voting', 'CreateProposalEvent', [])
        ])
    },
    {
        name: 'register_forum_events',
        typeTag: new StructTag(new HexString('0x1'), 'event', 'EventHandle', [
            new StructTag(new HexString('0x1'), 'voting', 'RegisterForumEvent', [])
        ])
    },
    {
        name: 'resolve_proposal_events',
        typeTag: new StructTag(new HexString('0x1'), 'event', 'EventHandle', [
            new StructTag(new HexString('0x1'), 'voting', 'ResolveProposal', [])
        ])
    },
    {
        name: 'vote_events',
        typeTag: new StructTag(new HexString('0x1'), 'event', 'EventHandle', [
            new StructTag(new HexString('0x1'), 'voting', 'VoteEvent', [])
        ])
    }
];
class VotingForum {
    constructor(proto, typeTag) {
        this.typeTag = typeTag;
        this.__app = null;
        this.proposals = proto['proposals'];
        this.events = proto['events'];
        this.next_proposal_id = proto['next_proposal_id'];
    }
    static VotingForumParser(data, typeTag, repo) {
        const proto = $.parseStructProto(data, typeTag, repo, VotingForum);
        return new VotingForum(proto, typeTag);
    }
    static load(repo, client, address, typeParams) {
        return __awaiter(this, void 0, void 0, function* () {
            const result = yield repo.loadResource(client, address, VotingForum, typeParams);
            return result;
        });
    }
    static loadByApp(app, address, typeParams) {
        return __awaiter(this, void 0, void 0, function* () {
            const result = yield app.repo.loadResource(app.client, address, VotingForum, typeParams);
            yield result.loadFullState(app);
            return result;
        });
    }
    static makeTag($p) {
        return new StructTag(moduleAddress$W, moduleName$W, 'VotingForum', $p);
    }
    loadFullState(app) {
        return __awaiter(this, void 0, void 0, function* () {
            yield this.proposals.loadFullState(app);
            yield this.events.loadFullState(app);
            this.__app = app;
        });
    }
}
VotingForum.moduleAddress = moduleAddress$W;
VotingForum.moduleName = moduleName$W;
VotingForum.structName = 'VotingForum';
VotingForum.typeParameters = [{ name: 'ProposalType', isPhantom: false }];
VotingForum.fields = [
    {
        name: 'proposals',
        typeTag: new StructTag(new HexString('0x1'), 'table', 'Table', [
            AtomicTypeTag.U64,
            new StructTag(new HexString('0x1'), 'voting', 'Proposal', [new $.TypeParamIdx(0)])
        ])
    },
    { name: 'events', typeTag: new StructTag(new HexString('0x1'), 'voting', 'VotingEvents', []) },
    { name: 'next_proposal_id', typeTag: AtomicTypeTag.U64 }
];
function can_be_resolved_early_(proposal, $c, $p /* <ProposalType>*/) {
    let temp$1, early_resolution_threshold;
    if (is_some_(proposal.early_resolution_vote_threshold, $c, [AtomicTypeTag.U128])) {
        early_resolution_threshold = $.copy(borrow_$6(proposal.early_resolution_vote_threshold, $c, [AtomicTypeTag.U128]));
        if ($.copy(proposal.yes_votes).ge($.copy(early_resolution_threshold))) {
            temp$1 = true;
        }
        else {
            temp$1 = $.copy(proposal.no_votes).ge($.copy(early_resolution_threshold));
        }
        if (temp$1) {
            return true;
        }
    }
    return false;
}
function create_proposal_$1(proposer, voting_forum_address, execution_content, execution_hash, min_vote_threshold, expiration_secs, early_resolution_vote_threshold, metadata, $c, $p /* <ProposalType>*/) {
    let temp$1, temp$10, temp$11, temp$12, temp$13, temp$14, temp$2, temp$3, temp$4, temp$5, temp$6, temp$7, temp$8, temp$9, proposal_id, voting_forum;
    if (is_some_(early_resolution_vote_threshold, $c, [AtomicTypeTag.U128])) {
        if (!$.copy(min_vote_threshold).le($.copy(borrow_$6(early_resolution_vote_threshold, $c, [AtomicTypeTag.U128])))) {
            throw $.abortCode(invalid_argument_($.copy(EINVALID_MIN_VOTE_THRESHOLD)));
        }
    }
    if (!length_$6(execution_hash, $c, [AtomicTypeTag.U8]).gt(u64('0'))) {
        throw $.abortCode(invalid_argument_($.copy(EPROPOSAL_EMPTY_EXECUTION_HASH)));
    }
    voting_forum = $c.borrow_global_mut(new SimpleStructTag(VotingForum, [$p[0]]), $.copy(voting_forum_address));
    proposal_id = $.copy(voting_forum.next_proposal_id);
    voting_forum.next_proposal_id = $.copy(voting_forum.next_proposal_id).add(u64('1'));
    temp$14 = voting_forum.proposals;
    temp$13 = $.copy(proposal_id);
    temp$1 = $.copy(proposer);
    temp$2 = now_seconds_($c);
    temp$3 = some_(execution_content, $c, [$p[0]]);
    temp$4 = $.copy(execution_hash);
    temp$5 = $.copy(metadata);
    temp$6 = $.copy(min_vote_threshold);
    temp$7 = $.copy(expiration_secs);
    temp$8 = $.copy(early_resolution_vote_threshold);
    temp$9 = u128('0');
    temp$10 = u128('0');
    temp$11 = false;
    temp$12 = u64('0');
    add_$8(temp$14, temp$13, new Proposal({
        proposer: temp$1,
        execution_content: temp$3,
        metadata: temp$5,
        creation_time_secs: temp$2,
        execution_hash: temp$4,
        min_vote_threshold: temp$6,
        expiration_secs: temp$7,
        early_resolution_vote_threshold: temp$8,
        yes_votes: temp$9,
        no_votes: temp$10,
        is_resolved: temp$11,
        resolution_time_secs: temp$12
    }, new SimpleStructTag(Proposal, [$p[0]])), $c, [AtomicTypeTag.U64, new SimpleStructTag(Proposal, [$p[0]])]);
    emit_event_(voting_forum.events.create_proposal_events, new CreateProposalEvent$1({
        proposal_id: $.copy(proposal_id),
        early_resolution_vote_threshold: $.copy(early_resolution_vote_threshold),
        execution_hash: $.copy(execution_hash),
        expiration_secs: $.copy(expiration_secs),
        metadata: $.copy(metadata),
        min_vote_threshold: $.copy(min_vote_threshold)
    }, new SimpleStructTag(CreateProposalEvent$1)), $c, [new SimpleStructTag(CreateProposalEvent$1)]);
    return $.copy(proposal_id);
}
function get_execution_hash_(voting_forum_address, proposal_id, $c, $p /* <ProposalType>*/) {
    let proposal, voting_forum;
    voting_forum = $c.borrow_global_mut(new SimpleStructTag(VotingForum, [$p[0]]), $.copy(voting_forum_address));
    proposal = borrow_mut_$5(voting_forum.proposals, $.copy(proposal_id), $c, [
        AtomicTypeTag.U64,
        new SimpleStructTag(Proposal, [$p[0]])
    ]);
    return $.copy(proposal.execution_hash);
}
function get_proposal_expiration_secs_(voting_forum_address, proposal_id, $c, $p /* <ProposalType>*/) {
    let proposal, voting_forum;
    voting_forum = $c.borrow_global_mut(new SimpleStructTag(VotingForum, [$p[0]]), $.copy(voting_forum_address));
    proposal = borrow_mut_$5(voting_forum.proposals, $.copy(proposal_id), $c, [
        AtomicTypeTag.U64,
        new SimpleStructTag(Proposal, [$p[0]])
    ]);
    return $.copy(proposal.expiration_secs);
}
function get_proposal_state_(voting_forum_address, proposal_id, $c, $p /* <ProposalType>*/) {
    let temp$1, temp$2, temp$3, no_votes, proposal, voting_forum, yes_votes;
    if (is_voting_closed_($.copy(voting_forum_address), $.copy(proposal_id), $c, [$p[0]])) {
        voting_forum = $c.borrow_global(new SimpleStructTag(VotingForum, [$p[0]]), $.copy(voting_forum_address));
        proposal = borrow_$5(voting_forum.proposals, $.copy(proposal_id), $c, [
            AtomicTypeTag.U64,
            new SimpleStructTag(Proposal, [$p[0]])
        ]);
        yes_votes = $.copy(proposal.yes_votes);
        no_votes = $.copy(proposal.no_votes);
        if ($.copy(yes_votes).gt($.copy(no_votes))) {
            temp$1 = $.copy(yes_votes).add($.copy(no_votes)).ge($.copy(proposal.min_vote_threshold));
        }
        else {
            temp$1 = false;
        }
        if (temp$1) {
            temp$2 = $.copy(PROPOSAL_STATE_SUCCEEDED$1);
        }
        else {
            temp$2 = $.copy(PROPOSAL_STATE_FAILED);
        }
        temp$3 = temp$2;
    }
    else {
        temp$3 = $.copy(PROPOSAL_STATE_PENDING);
    }
    return temp$3;
}
function is_resolved_(voting_forum_address, proposal_id, $c, $p /* <ProposalType>*/) {
    let proposal, voting_forum;
    voting_forum = $c.borrow_global_mut(new SimpleStructTag(VotingForum, [$p[0]]), $.copy(voting_forum_address));
    proposal = borrow_mut_$5(voting_forum.proposals, $.copy(proposal_id), $c, [
        AtomicTypeTag.U64,
        new SimpleStructTag(Proposal, [$p[0]])
    ]);
    return $.copy(proposal.is_resolved);
}
function is_voting_closed_(voting_forum_address, proposal_id, $c, $p /* <ProposalType>*/) {
    let temp$1, proposal, voting_forum;
    voting_forum = $c.borrow_global_mut(new SimpleStructTag(VotingForum, [$p[0]]), $.copy(voting_forum_address));
    proposal = borrow_mut_$5(voting_forum.proposals, $.copy(proposal_id), $c, [
        AtomicTypeTag.U64,
        new SimpleStructTag(Proposal, [$p[0]])
    ]);
    if (can_be_resolved_early_(proposal, $c, [$p[0]])) {
        temp$1 = true;
    }
    else {
        temp$1 = is_voting_period_over_(proposal, $c, [$p[0]]);
    }
    return temp$1;
}
function is_voting_period_over_(proposal, $c, $p /* <ProposalType>*/) {
    return now_seconds_($c).gt($.copy(proposal.expiration_secs));
}
function register_$1(account, $c, $p /* <ProposalType>*/) {
    let temp$1, temp$2, temp$3, addr, voting_forum;
    addr = address_of_(account, $c);
    if (!!$c.exists(new SimpleStructTag(VotingForum, [$p[0]]), $.copy(addr))) {
        throw $.abortCode(already_exists_($.copy(EVOTING_FORUM_ALREADY_REGISTERED)));
    }
    temp$1 = u64('0');
    temp$2 = new___$5($c, [AtomicTypeTag.U64, new SimpleStructTag(Proposal, [$p[0]])]);
    temp$3 = new VotingEvents({
        create_proposal_events: new_event_handle_(account, $c, [new SimpleStructTag(CreateProposalEvent$1)]),
        register_forum_events: new_event_handle_(account, $c, [new SimpleStructTag(RegisterForumEvent)]),
        resolve_proposal_events: new_event_handle_(account, $c, [new SimpleStructTag(ResolveProposal)]),
        vote_events: new_event_handle_(account, $c, [new SimpleStructTag(VoteEvent$1)])
    }, new SimpleStructTag(VotingEvents));
    voting_forum = new VotingForum({ proposals: temp$2, events: temp$3, next_proposal_id: temp$1 }, new SimpleStructTag(VotingForum, [$p[0]]));
    emit_event_(voting_forum.events.register_forum_events, new RegisterForumEvent({ hosting_account: $.copy(addr), proposal_type_info: type_of_($c, [$p[0]]) }, new SimpleStructTag(RegisterForumEvent)), $c, [new SimpleStructTag(RegisterForumEvent)]);
    $c.move_to(new SimpleStructTag(VotingForum, [$p[0]]), account, voting_forum);
    return;
}
function resolve_$1(voting_forum_address, proposal_id, $c, $p /* <ProposalType>*/) {
    let temp$1, temp$2, proposal, proposal_state, resolvable_time, resolved_early, voting_forum;
    proposal_state = get_proposal_state_($.copy(voting_forum_address), $.copy(proposal_id), $c, [$p[0]]);
    if (!$.copy(proposal_state).eq($.copy(PROPOSAL_STATE_SUCCEEDED$1))) {
        throw $.abortCode(invalid_state_($.copy(EPROPOSAL_CANNOT_BE_RESOLVED)));
    }
    voting_forum = $c.borrow_global_mut(new SimpleStructTag(VotingForum, [$p[0]]), $.copy(voting_forum_address));
    proposal = borrow_mut_$5(voting_forum.proposals, $.copy(proposal_id), $c, [
        AtomicTypeTag.U64,
        new SimpleStructTag(Proposal, [$p[0]])
    ]);
    if (!!$.copy(proposal.is_resolved)) {
        throw $.abortCode(invalid_state_($.copy(EPROPOSAL_ALREADY_RESOLVED)));
    }
    temp$2 = proposal.metadata;
    temp$1 = utf8_($.copy(RESOLVABLE_TIME_METADATA_KEY), $c);
    resolvable_time = to_u64_($.copy(borrow_$4(temp$2, temp$1, $c, [
        new StructTag(new HexString('0x1'), 'string', 'String', []),
        new VectorTag(AtomicTypeTag.U8)
    ])), $c);
    if (!now_seconds_($c).gt($.copy(resolvable_time))) {
        throw $.abortCode(invalid_state_($.copy(ERESOLUTION_CANNOT_BE_ATOMIC)));
    }
    resolved_early = can_be_resolved_early_(proposal, $c, [$p[0]]);
    proposal.is_resolved = true;
    proposal.resolution_time_secs = now_seconds_($c);
    if (!$.veq(get_script_hash_($c), $.copy(proposal.execution_hash))) {
        throw $.abortCode(invalid_argument_($.copy(EPROPOSAL_EXECUTION_HASH_NOT_MATCHING)));
    }
    emit_event_(voting_forum.events.resolve_proposal_events, new ResolveProposal({
        proposal_id: $.copy(proposal_id),
        yes_votes: $.copy(proposal.yes_votes),
        no_votes: $.copy(proposal.no_votes),
        resolved_early: resolved_early
    }, new SimpleStructTag(ResolveProposal)), $c, [new SimpleStructTag(ResolveProposal)]);
    return extract_$1(proposal.execution_content, $c, [$p[0]]);
}
function vote_$1(_proof, voting_forum_address, proposal_id, num_votes, should_pass, $c, $p /* <ProposalType>*/) {
    let temp$1, key, proposal, timestamp_secs_bytes, voting_forum;
    voting_forum = $c.borrow_global_mut(new SimpleStructTag(VotingForum, [$p[0]]), $.copy(voting_forum_address));
    proposal = borrow_mut_$5(voting_forum.proposals, $.copy(proposal_id), $c, [
        AtomicTypeTag.U64,
        new SimpleStructTag(Proposal, [$p[0]])
    ]);
    if (!!is_voting_period_over_(proposal, $c, [$p[0]])) {
        throw $.abortCode(invalid_state_($.copy(EPROPOSAL_VOTING_ALREADY_ENDED)));
    }
    if (!!$.copy(proposal.is_resolved)) {
        throw $.abortCode(invalid_state_($.copy(EPROPOSAL_ALREADY_RESOLVED)));
    }
    if (should_pass) {
        proposal.yes_votes = $.copy(proposal.yes_votes).add(u128($.copy(num_votes)));
    }
    else {
        proposal.no_votes = $.copy(proposal.no_votes).add(u128($.copy(num_votes)));
    }
    temp$1 = now_seconds_($c);
    timestamp_secs_bytes = to_bytes_(temp$1, $c, [AtomicTypeTag.U64]);
    key = utf8_($.copy(RESOLVABLE_TIME_METADATA_KEY), $c);
    if (contains_key_(proposal.metadata, key, $c, [
        new StructTag(new HexString('0x1'), 'string', 'String', []),
        new VectorTag(AtomicTypeTag.U8)
    ])) {
        $.set(borrow_mut_$4(proposal.metadata, key, $c, [
            new StructTag(new HexString('0x1'), 'string', 'String', []),
            new VectorTag(AtomicTypeTag.U8)
        ]), $.copy(timestamp_secs_bytes));
    }
    else {
        add_$4(proposal.metadata, $.copy(key), $.copy(timestamp_secs_bytes), $c, [
            new StructTag(new HexString('0x1'), 'string', 'String', []),
            new VectorTag(AtomicTypeTag.U8)
        ]);
    }
    emit_event_(voting_forum.events.vote_events, new VoteEvent$1({ proposal_id: $.copy(proposal_id), num_votes: $.copy(num_votes) }, new SimpleStructTag(VoteEvent$1)), $c, [new SimpleStructTag(VoteEvent$1)]);
    return;
}
function loadParsers$17(repo) {
    repo.addParser('0x1::voting::CreateProposalEvent', CreateProposalEvent$1.CreateProposalEventParser);
    repo.addParser('0x1::voting::Proposal', Proposal.ProposalParser);
    repo.addParser('0x1::voting::RegisterForumEvent', RegisterForumEvent.RegisterForumEventParser);
    repo.addParser('0x1::voting::ResolveProposal', ResolveProposal.ResolveProposalParser);
    repo.addParser('0x1::voting::VoteEvent', VoteEvent$1.VoteEventParser);
    repo.addParser('0x1::voting::VotingEvents', VotingEvents.VotingEventsParser);
    repo.addParser('0x1::voting::VotingForum', VotingForum.VotingForumParser);
}
class App$18 {
    constructor(client, repo, cache) {
        this.client = client;
        this.repo = repo;
        this.cache = cache;
    }
    get moduleAddress() {
        {
            return moduleAddress$W;
        }
    }
    get moduleName() {
        {
            return moduleName$W;
        }
    }
    get CreateProposalEvent() {
        return CreateProposalEvent$1;
    }
    get Proposal() {
        return Proposal;
    }
    get RegisterForumEvent() {
        return RegisterForumEvent;
    }
    get ResolveProposal() {
        return ResolveProposal;
    }
    get VoteEvent() {
        return VoteEvent$1;
    }
    get VotingEvents() {
        return VotingEvents;
    }
    get VotingForum() {
        return VotingForum;
    }
    loadVotingForum(owner, $p /* <ProposalType> */, loadFull = true, fillCache = true) {
        return __awaiter(this, void 0, void 0, function* () {
            const val = yield VotingForum.load(this.repo, this.client, owner, $p);
            if (loadFull) {
                yield val.loadFullState(this);
            }
            if (fillCache) {
                this.cache.set(val.typeTag, owner, val);
            }
            return val;
        });
    }
}

var Voting = /*#__PURE__*/Object.freeze({
    __proto__: null,
    packageName: packageName$W,
    moduleAddress: moduleAddress$W,
    moduleName: moduleName$W,
    EINVALID_MIN_VOTE_THRESHOLD: EINVALID_MIN_VOTE_THRESHOLD,
    EPROPOSAL_ALREADY_RESOLVED: EPROPOSAL_ALREADY_RESOLVED,
    EPROPOSAL_CANNOT_BE_RESOLVED: EPROPOSAL_CANNOT_BE_RESOLVED,
    EPROPOSAL_EMPTY_EXECUTION_HASH: EPROPOSAL_EMPTY_EXECUTION_HASH,
    EPROPOSAL_EXECUTION_HASH_NOT_MATCHING: EPROPOSAL_EXECUTION_HASH_NOT_MATCHING,
    EPROPOSAL_VOTING_ALREADY_ENDED: EPROPOSAL_VOTING_ALREADY_ENDED,
    ERESOLUTION_CANNOT_BE_ATOMIC: ERESOLUTION_CANNOT_BE_ATOMIC,
    EVOTING_FORUM_ALREADY_REGISTERED: EVOTING_FORUM_ALREADY_REGISTERED,
    PROPOSAL_STATE_FAILED: PROPOSAL_STATE_FAILED,
    PROPOSAL_STATE_PENDING: PROPOSAL_STATE_PENDING,
    PROPOSAL_STATE_SUCCEEDED: PROPOSAL_STATE_SUCCEEDED$1,
    RESOLVABLE_TIME_METADATA_KEY: RESOLVABLE_TIME_METADATA_KEY,
    CreateProposalEvent: CreateProposalEvent$1,
    Proposal: Proposal,
    RegisterForumEvent: RegisterForumEvent,
    ResolveProposal: ResolveProposal,
    VoteEvent: VoteEvent$1,
    VotingEvents: VotingEvents,
    VotingForum: VotingForum,
    can_be_resolved_early_: can_be_resolved_early_,
    create_proposal_: create_proposal_$1,
    get_execution_hash_: get_execution_hash_,
    get_proposal_expiration_secs_: get_proposal_expiration_secs_,
    get_proposal_state_: get_proposal_state_,
    is_resolved_: is_resolved_,
    is_voting_closed_: is_voting_closed_,
    is_voting_period_over_: is_voting_period_over_,
    register_: register_$1,
    resolve_: resolve_$1,
    vote_: vote_$1,
    loadParsers: loadParsers$17,
    App: App$18
});

const packageName$V = 'AptosFramework';
const moduleAddress$V = new HexString('0x1');
const moduleName$V = 'aptos_governance';
const EALREADY_VOTED = u64('4');
const EINSUFFICIENT_PROPOSER_STAKE = u64('1');
const EINSUFFICIENT_STAKE_LOCKUP = u64('3');
const EMETADATA_HASH_TOO_LONG = u64('10');
const EMETADATA_LOCATION_TOO_LONG = u64('9');
const ENOT_DELEGATED_VOTER = u64('2');
const ENO_VOTING_POWER = u64('5');
const EPROPOSAL_NOT_RESOLVABLE_YET = u64('6');
const EPROPOSAL_NOT_RESOLVED_YET = u64('8');
const EUNAUTHORIZED = u64('11');
const METADATA_HASH_KEY = [
    u8('109'),
    u8('101'),
    u8('116'),
    u8('97'),
    u8('100'),
    u8('97'),
    u8('116'),
    u8('97'),
    u8('95'),
    u8('104'),
    u8('97'),
    u8('115'),
    u8('104')
];
const METADATA_LOCATION_KEY = [
    u8('109'),
    u8('101'),
    u8('116'),
    u8('97'),
    u8('100'),
    u8('97'),
    u8('116'),
    u8('97'),
    u8('95'),
    u8('108'),
    u8('111'),
    u8('99'),
    u8('97'),
    u8('116'),
    u8('105'),
    u8('111'),
    u8('110')
];
const PROPOSAL_STATE_SUCCEEDED = u64('1');
class ApprovedExecutionHashes {
    constructor(proto, typeTag) {
        this.typeTag = typeTag;
        this.__app = null;
        this.hashes = proto['hashes'];
    }
    static ApprovedExecutionHashesParser(data, typeTag, repo) {
        const proto = $.parseStructProto(data, typeTag, repo, ApprovedExecutionHashes);
        return new ApprovedExecutionHashes(proto, typeTag);
    }
    static load(repo, client, address, typeParams) {
        return __awaiter(this, void 0, void 0, function* () {
            const result = yield repo.loadResource(client, address, ApprovedExecutionHashes, typeParams);
            return result;
        });
    }
    static loadByApp(app, address, typeParams) {
        return __awaiter(this, void 0, void 0, function* () {
            const result = yield app.repo.loadResource(app.client, address, ApprovedExecutionHashes, typeParams);
            yield result.loadFullState(app);
            return result;
        });
    }
    static getTag() {
        return new StructTag(moduleAddress$V, moduleName$V, 'ApprovedExecutionHashes', []);
    }
    loadFullState(app) {
        return __awaiter(this, void 0, void 0, function* () {
            yield this.hashes.loadFullState(app);
            this.__app = app;
        });
    }
}
ApprovedExecutionHashes.moduleAddress = moduleAddress$V;
ApprovedExecutionHashes.moduleName = moduleName$V;
ApprovedExecutionHashes.structName = 'ApprovedExecutionHashes';
ApprovedExecutionHashes.typeParameters = [];
ApprovedExecutionHashes.fields = [
    {
        name: 'hashes',
        typeTag: new StructTag(new HexString('0x1'), 'simple_map', 'SimpleMap', [
            AtomicTypeTag.U64,
            new VectorTag(AtomicTypeTag.U8)
        ])
    }
];
class CreateProposalEvent {
    constructor(proto, typeTag) {
        this.typeTag = typeTag;
        this.__app = null;
        this.proposer = proto['proposer'];
        this.stake_pool = proto['stake_pool'];
        this.proposal_id = proto['proposal_id'];
        this.execution_hash = proto['execution_hash'];
        this.proposal_metadata = proto['proposal_metadata'];
    }
    static CreateProposalEventParser(data, typeTag, repo) {
        const proto = $.parseStructProto(data, typeTag, repo, CreateProposalEvent);
        return new CreateProposalEvent(proto, typeTag);
    }
    static getTag() {
        return new StructTag(moduleAddress$V, moduleName$V, 'CreateProposalEvent', []);
    }
    loadFullState(app) {
        return __awaiter(this, void 0, void 0, function* () {
            yield this.proposal_metadata.loadFullState(app);
            this.__app = app;
        });
    }
}
CreateProposalEvent.moduleAddress = moduleAddress$V;
CreateProposalEvent.moduleName = moduleName$V;
CreateProposalEvent.structName = 'CreateProposalEvent';
CreateProposalEvent.typeParameters = [];
CreateProposalEvent.fields = [
    { name: 'proposer', typeTag: AtomicTypeTag.Address },
    { name: 'stake_pool', typeTag: AtomicTypeTag.Address },
    { name: 'proposal_id', typeTag: AtomicTypeTag.U64 },
    { name: 'execution_hash', typeTag: new VectorTag(AtomicTypeTag.U8) },
    {
        name: 'proposal_metadata',
        typeTag: new StructTag(new HexString('0x1'), 'simple_map', 'SimpleMap', [
            new StructTag(new HexString('0x1'), 'string', 'String', []),
            new VectorTag(AtomicTypeTag.U8)
        ])
    }
];
class GovernanceConfig {
    constructor(proto, typeTag) {
        this.typeTag = typeTag;
        this.__app = null;
        this.min_voting_threshold = proto['min_voting_threshold'];
        this.required_proposer_stake = proto['required_proposer_stake'];
        this.voting_duration_secs = proto['voting_duration_secs'];
    }
    static GovernanceConfigParser(data, typeTag, repo) {
        const proto = $.parseStructProto(data, typeTag, repo, GovernanceConfig);
        return new GovernanceConfig(proto, typeTag);
    }
    static load(repo, client, address, typeParams) {
        return __awaiter(this, void 0, void 0, function* () {
            const result = yield repo.loadResource(client, address, GovernanceConfig, typeParams);
            return result;
        });
    }
    static loadByApp(app, address, typeParams) {
        return __awaiter(this, void 0, void 0, function* () {
            const result = yield app.repo.loadResource(app.client, address, GovernanceConfig, typeParams);
            yield result.loadFullState(app);
            return result;
        });
    }
    static getTag() {
        return new StructTag(moduleAddress$V, moduleName$V, 'GovernanceConfig', []);
    }
    loadFullState(app) {
        return __awaiter(this, void 0, void 0, function* () {
            this.__app = app;
        });
    }
}
GovernanceConfig.moduleAddress = moduleAddress$V;
GovernanceConfig.moduleName = moduleName$V;
GovernanceConfig.structName = 'GovernanceConfig';
GovernanceConfig.typeParameters = [];
GovernanceConfig.fields = [
    { name: 'min_voting_threshold', typeTag: AtomicTypeTag.U128 },
    { name: 'required_proposer_stake', typeTag: AtomicTypeTag.U64 },
    { name: 'voting_duration_secs', typeTag: AtomicTypeTag.U64 }
];
class GovernanceEvents {
    constructor(proto, typeTag) {
        this.typeTag = typeTag;
        this.__app = null;
        this.create_proposal_events = proto['create_proposal_events'];
        this.update_config_events = proto['update_config_events'];
        this.vote_events = proto['vote_events'];
    }
    static GovernanceEventsParser(data, typeTag, repo) {
        const proto = $.parseStructProto(data, typeTag, repo, GovernanceEvents);
        return new GovernanceEvents(proto, typeTag);
    }
    static load(repo, client, address, typeParams) {
        return __awaiter(this, void 0, void 0, function* () {
            const result = yield repo.loadResource(client, address, GovernanceEvents, typeParams);
            return result;
        });
    }
    static loadByApp(app, address, typeParams) {
        return __awaiter(this, void 0, void 0, function* () {
            const result = yield app.repo.loadResource(app.client, address, GovernanceEvents, typeParams);
            yield result.loadFullState(app);
            return result;
        });
    }
    static getTag() {
        return new StructTag(moduleAddress$V, moduleName$V, 'GovernanceEvents', []);
    }
    loadFullState(app) {
        return __awaiter(this, void 0, void 0, function* () {
            yield this.create_proposal_events.loadFullState(app);
            yield this.update_config_events.loadFullState(app);
            yield this.vote_events.loadFullState(app);
            this.__app = app;
        });
    }
}
GovernanceEvents.moduleAddress = moduleAddress$V;
GovernanceEvents.moduleName = moduleName$V;
GovernanceEvents.structName = 'GovernanceEvents';
GovernanceEvents.typeParameters = [];
GovernanceEvents.fields = [
    {
        name: 'create_proposal_events',
        typeTag: new StructTag(new HexString('0x1'), 'event', 'EventHandle', [
            new StructTag(new HexString('0x1'), 'aptos_governance', 'CreateProposalEvent', [])
        ])
    },
    {
        name: 'update_config_events',
        typeTag: new StructTag(new HexString('0x1'), 'event', 'EventHandle', [
            new StructTag(new HexString('0x1'), 'aptos_governance', 'UpdateConfigEvent', [])
        ])
    },
    {
        name: 'vote_events',
        typeTag: new StructTag(new HexString('0x1'), 'event', 'EventHandle', [
            new StructTag(new HexString('0x1'), 'aptos_governance', 'VoteEvent', [])
        ])
    }
];
class GovernanceResponsbility {
    constructor(proto, typeTag) {
        this.typeTag = typeTag;
        this.__app = null;
        this.signer_caps = proto['signer_caps'];
    }
    static GovernanceResponsbilityParser(data, typeTag, repo) {
        const proto = $.parseStructProto(data, typeTag, repo, GovernanceResponsbility);
        return new GovernanceResponsbility(proto, typeTag);
    }
    static load(repo, client, address, typeParams) {
        return __awaiter(this, void 0, void 0, function* () {
            const result = yield repo.loadResource(client, address, GovernanceResponsbility, typeParams);
            return result;
        });
    }
    static loadByApp(app, address, typeParams) {
        return __awaiter(this, void 0, void 0, function* () {
            const result = yield app.repo.loadResource(app.client, address, GovernanceResponsbility, typeParams);
            yield result.loadFullState(app);
            return result;
        });
    }
    static getTag() {
        return new StructTag(moduleAddress$V, moduleName$V, 'GovernanceResponsbility', []);
    }
    loadFullState(app) {
        return __awaiter(this, void 0, void 0, function* () {
            yield this.signer_caps.loadFullState(app);
            this.__app = app;
        });
    }
}
GovernanceResponsbility.moduleAddress = moduleAddress$V;
GovernanceResponsbility.moduleName = moduleName$V;
GovernanceResponsbility.structName = 'GovernanceResponsbility';
GovernanceResponsbility.typeParameters = [];
GovernanceResponsbility.fields = [
    {
        name: 'signer_caps',
        typeTag: new StructTag(new HexString('0x1'), 'simple_map', 'SimpleMap', [
            AtomicTypeTag.Address,
            new StructTag(new HexString('0x1'), 'account', 'SignerCapability', [])
        ])
    }
];
class RecordKey {
    constructor(proto, typeTag) {
        this.typeTag = typeTag;
        this.__app = null;
        this.stake_pool = proto['stake_pool'];
        this.proposal_id = proto['proposal_id'];
    }
    static RecordKeyParser(data, typeTag, repo) {
        const proto = $.parseStructProto(data, typeTag, repo, RecordKey);
        return new RecordKey(proto, typeTag);
    }
    static getTag() {
        return new StructTag(moduleAddress$V, moduleName$V, 'RecordKey', []);
    }
    loadFullState(app) {
        return __awaiter(this, void 0, void 0, function* () {
            this.__app = app;
        });
    }
}
RecordKey.moduleAddress = moduleAddress$V;
RecordKey.moduleName = moduleName$V;
RecordKey.structName = 'RecordKey';
RecordKey.typeParameters = [];
RecordKey.fields = [
    { name: 'stake_pool', typeTag: AtomicTypeTag.Address },
    { name: 'proposal_id', typeTag: AtomicTypeTag.U64 }
];
class UpdateConfigEvent {
    constructor(proto, typeTag) {
        this.typeTag = typeTag;
        this.__app = null;
        this.min_voting_threshold = proto['min_voting_threshold'];
        this.required_proposer_stake = proto['required_proposer_stake'];
        this.voting_duration_secs = proto['voting_duration_secs'];
    }
    static UpdateConfigEventParser(data, typeTag, repo) {
        const proto = $.parseStructProto(data, typeTag, repo, UpdateConfigEvent);
        return new UpdateConfigEvent(proto, typeTag);
    }
    static getTag() {
        return new StructTag(moduleAddress$V, moduleName$V, 'UpdateConfigEvent', []);
    }
    loadFullState(app) {
        return __awaiter(this, void 0, void 0, function* () {
            this.__app = app;
        });
    }
}
UpdateConfigEvent.moduleAddress = moduleAddress$V;
UpdateConfigEvent.moduleName = moduleName$V;
UpdateConfigEvent.structName = 'UpdateConfigEvent';
UpdateConfigEvent.typeParameters = [];
UpdateConfigEvent.fields = [
    { name: 'min_voting_threshold', typeTag: AtomicTypeTag.U128 },
    { name: 'required_proposer_stake', typeTag: AtomicTypeTag.U64 },
    { name: 'voting_duration_secs', typeTag: AtomicTypeTag.U64 }
];
class VoteEvent {
    constructor(proto, typeTag) {
        this.typeTag = typeTag;
        this.__app = null;
        this.proposal_id = proto['proposal_id'];
        this.voter = proto['voter'];
        this.stake_pool = proto['stake_pool'];
        this.num_votes = proto['num_votes'];
        this.should_pass = proto['should_pass'];
    }
    static VoteEventParser(data, typeTag, repo) {
        const proto = $.parseStructProto(data, typeTag, repo, VoteEvent);
        return new VoteEvent(proto, typeTag);
    }
    static getTag() {
        return new StructTag(moduleAddress$V, moduleName$V, 'VoteEvent', []);
    }
    loadFullState(app) {
        return __awaiter(this, void 0, void 0, function* () {
            this.__app = app;
        });
    }
}
VoteEvent.moduleAddress = moduleAddress$V;
VoteEvent.moduleName = moduleName$V;
VoteEvent.structName = 'VoteEvent';
VoteEvent.typeParameters = [];
VoteEvent.fields = [
    { name: 'proposal_id', typeTag: AtomicTypeTag.U64 },
    { name: 'voter', typeTag: AtomicTypeTag.Address },
    { name: 'stake_pool', typeTag: AtomicTypeTag.Address },
    { name: 'num_votes', typeTag: AtomicTypeTag.U64 },
    { name: 'should_pass', typeTag: AtomicTypeTag.Bool }
];
class VotingRecords {
    constructor(proto, typeTag) {
        this.typeTag = typeTag;
        this.__app = null;
        this.votes = proto['votes'];
    }
    static VotingRecordsParser(data, typeTag, repo) {
        const proto = $.parseStructProto(data, typeTag, repo, VotingRecords);
        return new VotingRecords(proto, typeTag);
    }
    static load(repo, client, address, typeParams) {
        return __awaiter(this, void 0, void 0, function* () {
            const result = yield repo.loadResource(client, address, VotingRecords, typeParams);
            return result;
        });
    }
    static loadByApp(app, address, typeParams) {
        return __awaiter(this, void 0, void 0, function* () {
            const result = yield app.repo.loadResource(app.client, address, VotingRecords, typeParams);
            yield result.loadFullState(app);
            return result;
        });
    }
    static getTag() {
        return new StructTag(moduleAddress$V, moduleName$V, 'VotingRecords', []);
    }
    loadFullState(app) {
        return __awaiter(this, void 0, void 0, function* () {
            yield this.votes.loadFullState(app);
            this.__app = app;
        });
    }
}
VotingRecords.moduleAddress = moduleAddress$V;
VotingRecords.moduleName = moduleName$V;
VotingRecords.structName = 'VotingRecords';
VotingRecords.typeParameters = [];
VotingRecords.fields = [
    {
        name: 'votes',
        typeTag: new StructTag(new HexString('0x1'), 'table', 'Table', [
            new StructTag(new HexString('0x1'), 'aptos_governance', 'RecordKey', []),
            AtomicTypeTag.Bool
        ])
    }
];
function add_approved_script_hash_(proposal_id, $c) {
    let approved_hashes, execution_hash, proposal_state;
    approved_hashes = $c.borrow_global_mut(new SimpleStructTag(ApprovedExecutionHashes), new HexString('0x1'));
    if (contains_key_(approved_hashes.hashes, proposal_id, $c, [
        AtomicTypeTag.U64,
        new VectorTag(AtomicTypeTag.U8)
    ])) {
        return;
    }
    proposal_state = get_proposal_state_(new HexString('0x1'), $.copy(proposal_id), $c, [
        new StructTag(new HexString('0x1'), 'governance_proposal', 'GovernanceProposal', [])
    ]);
    if (!$.copy(proposal_state).eq($.copy(PROPOSAL_STATE_SUCCEEDED))) {
        throw $.abortCode(invalid_argument_($.copy(EPROPOSAL_NOT_RESOLVABLE_YET)));
    }
    execution_hash = get_execution_hash_(new HexString('0x1'), $.copy(proposal_id), $c, [
        new StructTag(new HexString('0x1'), 'governance_proposal', 'GovernanceProposal', [])
    ]);
    add_$4(approved_hashes.hashes, $.copy(proposal_id), $.copy(execution_hash), $c, [
        AtomicTypeTag.U64,
        new VectorTag(AtomicTypeTag.U8)
    ]);
    return;
}
function add_approved_script_hash_script_(proposal_id, $c) {
    return add_approved_script_hash_($.copy(proposal_id), $c);
}
function buildPayload_add_approved_script_hash_script(proposal_id, isJSON = false) {
    const typeParamStrings = [];
    return $.buildPayload(new HexString('0x1'), 'aptos_governance', 'add_approved_script_hash_script', typeParamStrings, [proposal_id], isJSON);
}
function create_proposal_(proposer, stake_pool, execution_hash, metadata_location, metadata_hash, $c) {
    let temp$1, temp$2, temp$3, temp$4, temp$5, temp$6, current_time, early_resolution_vote_threshold, events, governance_config, proposal_expiration, proposal_id, proposal_metadata, proposer_address, stake_balance, total_supply, total_voting_token_supply;
    proposer_address = address_of_(proposer, $c);
    if (!(get_delegated_voter_($.copy(stake_pool), $c).hex() === $.copy(proposer_address).hex())) {
        throw $.abortCode(invalid_argument_($.copy(ENOT_DELEGATED_VOTER)));
    }
    governance_config = $c.borrow_global(new SimpleStructTag(GovernanceConfig), new HexString('0x1'));
    stake_balance = get_voting_power_($.copy(stake_pool), $c);
    if (!$.copy(stake_balance).ge($.copy(governance_config.required_proposer_stake))) {
        throw $.abortCode(invalid_argument_($.copy(EINSUFFICIENT_PROPOSER_STAKE)));
    }
    current_time = now_seconds_($c);
    proposal_expiration = $.copy(current_time).add($.copy(governance_config.voting_duration_secs));
    if (!get_lockup_secs_($.copy(stake_pool), $c).ge($.copy(proposal_expiration))) {
        throw $.abortCode(invalid_argument_($.copy(EINSUFFICIENT_STAKE_LOCKUP)));
    }
    proposal_metadata = create_proposal_metadata_($.copy(metadata_location), $.copy(metadata_hash), $c);
    total_voting_token_supply = supply_($c, [new StructTag(new HexString('0x1'), 'aptos_coin', 'AptosCoin', [])]);
    early_resolution_vote_threshold = none_($c, [AtomicTypeTag.U128]);
    if (is_some_(total_voting_token_supply, $c, [AtomicTypeTag.U128])) {
        total_supply = $.copy(borrow_$6(total_voting_token_supply, $c, [AtomicTypeTag.U128]));
        early_resolution_vote_threshold = some_($.copy(total_supply).div(u128('2')).add(u128('1')), $c, [
            AtomicTypeTag.U128
        ]);
    }
    proposal_id = create_proposal_$1($.copy(proposer_address), new HexString('0x1'), create_proposal_$2(), $.copy(execution_hash), $.copy(governance_config.min_voting_threshold), $.copy(proposal_expiration), $.copy(early_resolution_vote_threshold), $.copy(proposal_metadata), $c, [new StructTag(new HexString('0x1'), 'governance_proposal', 'GovernanceProposal', [])]);
    events = $c.borrow_global_mut(new SimpleStructTag(GovernanceEvents), new HexString('0x1'));
    temp$6 = events.create_proposal_events;
    temp$1 = $.copy(proposal_id);
    temp$2 = $.copy(proposer_address);
    temp$3 = $.copy(stake_pool);
    temp$4 = $.copy(execution_hash);
    temp$5 = $.copy(proposal_metadata);
    emit_event_(temp$6, new CreateProposalEvent({ proposer: temp$2, stake_pool: temp$3, proposal_id: temp$1, execution_hash: temp$4, proposal_metadata: temp$5 }, new SimpleStructTag(CreateProposalEvent)), $c, [new SimpleStructTag(CreateProposalEvent)]);
    return;
}
function buildPayload_create_proposal(stake_pool, execution_hash, metadata_location, metadata_hash, isJSON = false) {
    const typeParamStrings = [];
    return $.buildPayload(new HexString('0x1'), 'aptos_governance', 'create_proposal', typeParamStrings, [stake_pool, execution_hash, metadata_location, metadata_hash], isJSON);
}
function create_proposal_metadata_(metadata_location, metadata_hash, $c) {
    let temp$1, temp$2, metadata;
    temp$1 = utf8_($.copy(metadata_location), $c);
    if (!length_$5(temp$1, $c).le(u64('256'))) {
        throw $.abortCode(invalid_argument_($.copy(EMETADATA_LOCATION_TOO_LONG)));
    }
    temp$2 = utf8_($.copy(metadata_hash), $c);
    if (!length_$5(temp$2, $c).le(u64('256'))) {
        throw $.abortCode(invalid_argument_($.copy(EMETADATA_HASH_TOO_LONG)));
    }
    metadata = create_$2($c, [
        new StructTag(new HexString('0x1'), 'string', 'String', []),
        new VectorTag(AtomicTypeTag.U8)
    ]);
    add_$4(metadata, utf8_($.copy(METADATA_LOCATION_KEY), $c), $.copy(metadata_location), $c, [
        new StructTag(new HexString('0x1'), 'string', 'String', []),
        new VectorTag(AtomicTypeTag.U8)
    ]);
    add_$4(metadata, utf8_($.copy(METADATA_HASH_KEY), $c), $.copy(metadata_hash), $c, [
        new StructTag(new HexString('0x1'), 'string', 'String', []),
        new VectorTag(AtomicTypeTag.U8)
    ]);
    return $.copy(metadata);
}
function get_min_voting_threshold_($c) {
    return $.copy($c.borrow_global(new SimpleStructTag(GovernanceConfig), new HexString('0x1')).min_voting_threshold);
}
function get_required_proposer_stake_($c) {
    return $.copy($c.borrow_global(new SimpleStructTag(GovernanceConfig), new HexString('0x1'))
        .required_proposer_stake);
}
function get_signer_(signer_address, $c) {
    let governance_responsibility, signer_cap;
    governance_responsibility = $c.borrow_global(new SimpleStructTag(GovernanceResponsbility), new HexString('0x1'));
    signer_cap = borrow_$4(governance_responsibility.signer_caps, signer_address, $c, [
        AtomicTypeTag.Address,
        new StructTag(new HexString('0x1'), 'account', 'SignerCapability', [])
    ]);
    return create_signer_with_capability_(signer_cap, $c);
}
function get_signer_testnet_only_(core_resources, signer_address, $c) {
    assert_core_resource_(core_resources, $c);
    if (!has_mint_capability_(core_resources, $c)) {
        throw $.abortCode(unauthenticated_($.copy(EUNAUTHORIZED)));
    }
    return get_signer_($.copy(signer_address), $c);
}
function get_voting_duration_secs_($c) {
    return $.copy($c.borrow_global(new SimpleStructTag(GovernanceConfig), new HexString('0x1')).voting_duration_secs);
}
function get_voting_power_(pool_address, $c) {
    let temp$1, temp$2, active, allow_validator_set_change, pending_active, pending_inactive;
    temp$1 = get_$2($c);
    allow_validator_set_change = get_allow_validator_set_change_(temp$1);
    if (allow_validator_set_change) {
        [active, , pending_active, pending_inactive] = get_stake_($.copy(pool_address), $c);
        temp$2 = $.copy(active).add($.copy(pending_active)).add($.copy(pending_inactive));
    }
    else {
        temp$2 = get_current_epoch_voting_power_($.copy(pool_address), $c);
    }
    return temp$2;
}
function initialize_$c(aptos_framework, min_voting_threshold, required_proposer_stake, voting_duration_secs, $c) {
    let temp$1, temp$2, temp$3, temp$4;
    assert_aptos_framework_(aptos_framework, $c);
    register_$1(aptos_framework, $c, [
        new StructTag(new HexString('0x1'), 'governance_proposal', 'GovernanceProposal', [])
    ]);
    temp$4 = aptos_framework;
    temp$1 = $.copy(voting_duration_secs);
    temp$2 = $.copy(min_voting_threshold);
    temp$3 = $.copy(required_proposer_stake);
    $c.move_to(new SimpleStructTag(GovernanceConfig), temp$4, new GovernanceConfig({ min_voting_threshold: temp$2, required_proposer_stake: temp$3, voting_duration_secs: temp$1 }, new SimpleStructTag(GovernanceConfig)));
    $c.move_to(new SimpleStructTag(GovernanceEvents), aptos_framework, new GovernanceEvents({
        create_proposal_events: new_event_handle_(aptos_framework, $c, [
            new SimpleStructTag(CreateProposalEvent)
        ]),
        update_config_events: new_event_handle_(aptos_framework, $c, [new SimpleStructTag(UpdateConfigEvent)]),
        vote_events: new_event_handle_(aptos_framework, $c, [new SimpleStructTag(VoteEvent)])
    }, new SimpleStructTag(GovernanceEvents)));
    $c.move_to(new SimpleStructTag(VotingRecords), aptos_framework, new VotingRecords({ votes: new___$5($c, [new SimpleStructTag(RecordKey), AtomicTypeTag.Bool]) }, new SimpleStructTag(VotingRecords)));
    return $c.move_to(new SimpleStructTag(ApprovedExecutionHashes), aptos_framework, new ApprovedExecutionHashes({ hashes: create_$2($c, [AtomicTypeTag.U64, new VectorTag(AtomicTypeTag.U8)]) }, new SimpleStructTag(ApprovedExecutionHashes)));
}
function initialize_for_verification_$1(aptos_framework, min_voting_threshold, required_proposer_stake, voting_duration_secs, $c) {
    initialize_$c(aptos_framework, $.copy(min_voting_threshold), $.copy(required_proposer_stake), $.copy(voting_duration_secs), $c);
    return;
}
function reconfigure_(aptos_framework, $c) {
    assert_aptos_framework_(aptos_framework, $c);
    reconfigure_$1($c);
    return;
}
function remove_approved_hash_(proposal_id, $c) {
    let temp$1, temp$2, approved_hashes;
    if (!is_resolved_(new HexString('0x1'), $.copy(proposal_id), $c, [
        new StructTag(new HexString('0x1'), 'governance_proposal', 'GovernanceProposal', [])
    ])) {
        throw $.abortCode(invalid_argument_($.copy(EPROPOSAL_NOT_RESOLVED_YET)));
    }
    approved_hashes = $c.borrow_global_mut(new SimpleStructTag(ApprovedExecutionHashes), new HexString('0x1')).hashes;
    [temp$1, temp$2] = [approved_hashes, proposal_id];
    if (contains_key_(temp$1, temp$2, $c, [AtomicTypeTag.U64, new VectorTag(AtomicTypeTag.U8)])) {
        remove_$2(approved_hashes, proposal_id, $c, [AtomicTypeTag.U64, new VectorTag(AtomicTypeTag.U8)]);
    }
    return;
}
function resolve_(proposal_id, signer_address, $c) {
    resolve_$1(new HexString('0x1'), $.copy(proposal_id), $c, [
        new StructTag(new HexString('0x1'), 'governance_proposal', 'GovernanceProposal', [])
    ]);
    remove_approved_hash_($.copy(proposal_id), $c);
    return get_signer_($.copy(signer_address), $c);
}
function store_signer_cap_(aptos_framework, signer_address, signer_cap, $c) {
    let signer_caps;
    assert_framework_reserved_address_(aptos_framework, $c);
    if (!$c.exists(new SimpleStructTag(GovernanceResponsbility), new HexString('0x1'))) {
        $c.move_to(new SimpleStructTag(GovernanceResponsbility), aptos_framework, new GovernanceResponsbility({
            signer_caps: create_$2($c, [
                AtomicTypeTag.Address,
                new StructTag(new HexString('0x1'), 'account', 'SignerCapability', [])
            ])
        }, new SimpleStructTag(GovernanceResponsbility)));
    }
    signer_caps = $c.borrow_global_mut(new SimpleStructTag(GovernanceResponsbility), new HexString('0x1')).signer_caps;
    add_$4(signer_caps, $.copy(signer_address), signer_cap, $c, [
        AtomicTypeTag.Address,
        new StructTag(new HexString('0x1'), 'account', 'SignerCapability', [])
    ]);
    return;
}
function update_governance_config_(aptos_framework, min_voting_threshold, required_proposer_stake, voting_duration_secs, $c) {
    let events, governance_config;
    assert_aptos_framework_(aptos_framework, $c);
    governance_config = $c.borrow_global_mut(new SimpleStructTag(GovernanceConfig), new HexString('0x1'));
    governance_config.voting_duration_secs = $.copy(voting_duration_secs);
    governance_config.min_voting_threshold = $.copy(min_voting_threshold);
    governance_config.required_proposer_stake = $.copy(required_proposer_stake);
    events = $c.borrow_global_mut(new SimpleStructTag(GovernanceEvents), new HexString('0x1'));
    emit_event_(events.update_config_events, new UpdateConfigEvent({
        min_voting_threshold: $.copy(min_voting_threshold),
        required_proposer_stake: $.copy(required_proposer_stake),
        voting_duration_secs: $.copy(voting_duration_secs)
    }, new SimpleStructTag(UpdateConfigEvent)), $c, [new SimpleStructTag(UpdateConfigEvent)]);
    return;
}
function vote_(voter, stake_pool, proposal_id, should_pass, $c) {
    let temp$1, events, proposal_expiration, proposal_state, record_key, voter_address, voting_power, voting_records;
    voter_address = address_of_(voter, $c);
    if (!(get_delegated_voter_($.copy(stake_pool), $c).hex() === $.copy(voter_address).hex())) {
        throw $.abortCode(invalid_argument_($.copy(ENOT_DELEGATED_VOTER)));
    }
    voting_records = $c.borrow_global_mut(new SimpleStructTag(VotingRecords), new HexString('0x1'));
    record_key = new RecordKey({ stake_pool: $.copy(stake_pool), proposal_id: $.copy(proposal_id) }, new SimpleStructTag(RecordKey));
    if (!!contains_$6(voting_records.votes, $.copy(record_key), $c, [
        new SimpleStructTag(RecordKey),
        AtomicTypeTag.Bool
    ])) {
        throw $.abortCode(invalid_argument_($.copy(EALREADY_VOTED)));
    }
    add_$8(voting_records.votes, $.copy(record_key), true, $c, [new SimpleStructTag(RecordKey), AtomicTypeTag.Bool]);
    voting_power = get_voting_power_($.copy(stake_pool), $c);
    if (!$.copy(voting_power).gt(u64('0'))) {
        throw $.abortCode(invalid_argument_($.copy(ENO_VOTING_POWER)));
    }
    proposal_expiration = get_proposal_expiration_secs_(new HexString('0x1'), $.copy(proposal_id), $c, [
        new StructTag(new HexString('0x1'), 'governance_proposal', 'GovernanceProposal', [])
    ]);
    if (!get_lockup_secs_($.copy(stake_pool), $c).ge($.copy(proposal_expiration))) {
        throw $.abortCode(invalid_argument_($.copy(EINSUFFICIENT_STAKE_LOCKUP)));
    }
    temp$1 = create_empty_proposal_();
    vote_$1(temp$1, new HexString('0x1'), $.copy(proposal_id), $.copy(voting_power), should_pass, $c, [
        new StructTag(new HexString('0x1'), 'governance_proposal', 'GovernanceProposal', [])
    ]);
    events = $c.borrow_global_mut(new SimpleStructTag(GovernanceEvents), new HexString('0x1'));
    emit_event_(events.vote_events, new VoteEvent({
        proposal_id: $.copy(proposal_id),
        voter: $.copy(voter_address),
        stake_pool: $.copy(stake_pool),
        num_votes: $.copy(voting_power),
        should_pass: should_pass
    }, new SimpleStructTag(VoteEvent)), $c, [new SimpleStructTag(VoteEvent)]);
    proposal_state = get_proposal_state_(new HexString('0x1'), $.copy(proposal_id), $c, [
        new StructTag(new HexString('0x1'), 'governance_proposal', 'GovernanceProposal', [])
    ]);
    if ($.copy(proposal_state).eq($.copy(PROPOSAL_STATE_SUCCEEDED))) {
        add_approved_script_hash_($.copy(proposal_id), $c);
    }
    return;
}
function buildPayload_vote(stake_pool, proposal_id, should_pass, isJSON = false) {
    const typeParamStrings = [];
    return $.buildPayload(new HexString('0x1'), 'aptos_governance', 'vote', typeParamStrings, [stake_pool, proposal_id, should_pass], isJSON);
}
function loadParsers$16(repo) {
    repo.addParser('0x1::aptos_governance::ApprovedExecutionHashes', ApprovedExecutionHashes.ApprovedExecutionHashesParser);
    repo.addParser('0x1::aptos_governance::CreateProposalEvent', CreateProposalEvent.CreateProposalEventParser);
    repo.addParser('0x1::aptos_governance::GovernanceConfig', GovernanceConfig.GovernanceConfigParser);
    repo.addParser('0x1::aptos_governance::GovernanceEvents', GovernanceEvents.GovernanceEventsParser);
    repo.addParser('0x1::aptos_governance::GovernanceResponsbility', GovernanceResponsbility.GovernanceResponsbilityParser);
    repo.addParser('0x1::aptos_governance::RecordKey', RecordKey.RecordKeyParser);
    repo.addParser('0x1::aptos_governance::UpdateConfigEvent', UpdateConfigEvent.UpdateConfigEventParser);
    repo.addParser('0x1::aptos_governance::VoteEvent', VoteEvent.VoteEventParser);
    repo.addParser('0x1::aptos_governance::VotingRecords', VotingRecords.VotingRecordsParser);
}
class App$17 {
    constructor(client, repo, cache) {
        this.client = client;
        this.repo = repo;
        this.cache = cache;
    }
    get moduleAddress() {
        {
            return moduleAddress$V;
        }
    }
    get moduleName() {
        {
            return moduleName$V;
        }
    }
    get ApprovedExecutionHashes() {
        return ApprovedExecutionHashes;
    }
    loadApprovedExecutionHashes(owner, loadFull = true, fillCache = true) {
        return __awaiter(this, void 0, void 0, function* () {
            const val = yield ApprovedExecutionHashes.load(this.repo, this.client, owner, []);
            if (loadFull) {
                yield val.loadFullState(this);
            }
            if (fillCache) {
                this.cache.set(val.typeTag, owner, val);
            }
            return val;
        });
    }
    get CreateProposalEvent() {
        return CreateProposalEvent;
    }
    get GovernanceConfig() {
        return GovernanceConfig;
    }
    loadGovernanceConfig(owner, loadFull = true, fillCache = true) {
        return __awaiter(this, void 0, void 0, function* () {
            const val = yield GovernanceConfig.load(this.repo, this.client, owner, []);
            if (loadFull) {
                yield val.loadFullState(this);
            }
            if (fillCache) {
                this.cache.set(val.typeTag, owner, val);
            }
            return val;
        });
    }
    get GovernanceEvents() {
        return GovernanceEvents;
    }
    loadGovernanceEvents(owner, loadFull = true, fillCache = true) {
        return __awaiter(this, void 0, void 0, function* () {
            const val = yield GovernanceEvents.load(this.repo, this.client, owner, []);
            if (loadFull) {
                yield val.loadFullState(this);
            }
            if (fillCache) {
                this.cache.set(val.typeTag, owner, val);
            }
            return val;
        });
    }
    get GovernanceResponsbility() {
        return GovernanceResponsbility;
    }
    loadGovernanceResponsbility(owner, loadFull = true, fillCache = true) {
        return __awaiter(this, void 0, void 0, function* () {
            const val = yield GovernanceResponsbility.load(this.repo, this.client, owner, []);
            if (loadFull) {
                yield val.loadFullState(this);
            }
            if (fillCache) {
                this.cache.set(val.typeTag, owner, val);
            }
            return val;
        });
    }
    get RecordKey() {
        return RecordKey;
    }
    get UpdateConfigEvent() {
        return UpdateConfigEvent;
    }
    get VoteEvent() {
        return VoteEvent;
    }
    get VotingRecords() {
        return VotingRecords;
    }
    loadVotingRecords(owner, loadFull = true, fillCache = true) {
        return __awaiter(this, void 0, void 0, function* () {
            const val = yield VotingRecords.load(this.repo, this.client, owner, []);
            if (loadFull) {
                yield val.loadFullState(this);
            }
            if (fillCache) {
                this.cache.set(val.typeTag, owner, val);
            }
            return val;
        });
    }
    payload_add_approved_script_hash_script(proposal_id, isJSON = false) {
        return buildPayload_add_approved_script_hash_script(proposal_id, isJSON);
    }
    add_approved_script_hash_script(_account, proposal_id, option, _isJSON = false) {
        return __awaiter(this, void 0, void 0, function* () {
            const payload__ = buildPayload_add_approved_script_hash_script(proposal_id, _isJSON);
            return $.sendPayloadTx(this.client, _account, payload__, option);
        });
    }
    payload_create_proposal(stake_pool, execution_hash, metadata_location, metadata_hash, isJSON = false) {
        return buildPayload_create_proposal(stake_pool, execution_hash, metadata_location, metadata_hash, isJSON);
    }
    create_proposal(_account, stake_pool, execution_hash, metadata_location, metadata_hash, option, _isJSON = false) {
        return __awaiter(this, void 0, void 0, function* () {
            const payload__ = buildPayload_create_proposal(stake_pool, execution_hash, metadata_location, metadata_hash, _isJSON);
            return $.sendPayloadTx(this.client, _account, payload__, option);
        });
    }
    payload_vote(stake_pool, proposal_id, should_pass, isJSON = false) {
        return buildPayload_vote(stake_pool, proposal_id, should_pass, isJSON);
    }
    vote(_account, stake_pool, proposal_id, should_pass, option, _isJSON = false) {
        return __awaiter(this, void 0, void 0, function* () {
            const payload__ = buildPayload_vote(stake_pool, proposal_id, should_pass, _isJSON);
            return $.sendPayloadTx(this.client, _account, payload__, option);
        });
    }
}

var Aptos_governance = /*#__PURE__*/Object.freeze({
    __proto__: null,
    packageName: packageName$V,
    moduleAddress: moduleAddress$V,
    moduleName: moduleName$V,
    EALREADY_VOTED: EALREADY_VOTED,
    EINSUFFICIENT_PROPOSER_STAKE: EINSUFFICIENT_PROPOSER_STAKE,
    EINSUFFICIENT_STAKE_LOCKUP: EINSUFFICIENT_STAKE_LOCKUP,
    EMETADATA_HASH_TOO_LONG: EMETADATA_HASH_TOO_LONG,
    EMETADATA_LOCATION_TOO_LONG: EMETADATA_LOCATION_TOO_LONG,
    ENOT_DELEGATED_VOTER: ENOT_DELEGATED_VOTER,
    ENO_VOTING_POWER: ENO_VOTING_POWER,
    EPROPOSAL_NOT_RESOLVABLE_YET: EPROPOSAL_NOT_RESOLVABLE_YET,
    EPROPOSAL_NOT_RESOLVED_YET: EPROPOSAL_NOT_RESOLVED_YET,
    EUNAUTHORIZED: EUNAUTHORIZED,
    METADATA_HASH_KEY: METADATA_HASH_KEY,
    METADATA_LOCATION_KEY: METADATA_LOCATION_KEY,
    PROPOSAL_STATE_SUCCEEDED: PROPOSAL_STATE_SUCCEEDED,
    ApprovedExecutionHashes: ApprovedExecutionHashes,
    CreateProposalEvent: CreateProposalEvent,
    GovernanceConfig: GovernanceConfig,
    GovernanceEvents: GovernanceEvents,
    GovernanceResponsbility: GovernanceResponsbility,
    RecordKey: RecordKey,
    UpdateConfigEvent: UpdateConfigEvent,
    VoteEvent: VoteEvent,
    VotingRecords: VotingRecords,
    add_approved_script_hash_: add_approved_script_hash_,
    add_approved_script_hash_script_: add_approved_script_hash_script_,
    buildPayload_add_approved_script_hash_script: buildPayload_add_approved_script_hash_script,
    create_proposal_: create_proposal_,
    buildPayload_create_proposal: buildPayload_create_proposal,
    create_proposal_metadata_: create_proposal_metadata_,
    get_min_voting_threshold_: get_min_voting_threshold_,
    get_required_proposer_stake_: get_required_proposer_stake_,
    get_signer_: get_signer_,
    get_signer_testnet_only_: get_signer_testnet_only_,
    get_voting_duration_secs_: get_voting_duration_secs_,
    get_voting_power_: get_voting_power_,
    initialize_: initialize_$c,
    initialize_for_verification_: initialize_for_verification_$1,
    reconfigure_: reconfigure_,
    remove_approved_hash_: remove_approved_hash_,
    resolve_: resolve_,
    store_signer_cap_: store_signer_cap_,
    update_governance_config_: update_governance_config_,
    vote_: vote_,
    buildPayload_vote: buildPayload_vote,
    loadParsers: loadParsers$16,
    App: App$17
});

const packageName$U = 'AptosStdlib';
const moduleAddress$U = new HexString('0x1');
const moduleName$U = 'aptos_hash';
function keccak256_(bytes, $c) {
    return $.aptos_std_aptos_hash_keccak256(bytes, $c);
}
function sip_hash_(bytes, $c) {
    return $.aptos_std_aptos_hash_sip_hash(bytes, $c);
}
function sip_hash_from_value_(v, $c, $p /* <MoveValue>*/) {
    let bytes;
    bytes = to_bytes_(v, $c, [$p[0]]);
    return sip_hash_($.copy(bytes), $c);
}
function loadParsers$15(repo) { }
class App$16 {
    constructor(client, repo, cache) {
        this.client = client;
        this.repo = repo;
        this.cache = cache;
    }
    get moduleAddress() {
        {
            return moduleAddress$U;
        }
    }
    get moduleName() {
        {
            return moduleName$U;
        }
    }
}

var Aptos_hash = /*#__PURE__*/Object.freeze({
    __proto__: null,
    packageName: packageName$U,
    moduleAddress: moduleAddress$U,
    moduleName: moduleName$U,
    keccak256_: keccak256_,
    sip_hash_: sip_hash_,
    sip_hash_from_value_: sip_hash_from_value_,
    loadParsers: loadParsers$15,
    App: App$16
});

const packageName$T = 'MoveStdlib';
const moduleAddress$T = new HexString('0x1');
const moduleName$T = 'bit_vector';
const EINDEX = u64('131072');
const ELENGTH = u64('131073');
const MAX_SIZE = u64('1024');
const WORD_SIZE = u64('1');
class BitVector {
    constructor(proto, typeTag) {
        this.typeTag = typeTag;
        this.__app = null;
        this.length = proto['length'];
        this.bit_field = proto['bit_field'];
    }
    static BitVectorParser(data, typeTag, repo) {
        const proto = $.parseStructProto(data, typeTag, repo, BitVector);
        return new BitVector(proto, typeTag);
    }
    static getTag() {
        return new StructTag(moduleAddress$T, moduleName$T, 'BitVector', []);
    }
    loadFullState(app) {
        return __awaiter(this, void 0, void 0, function* () {
            this.__app = app;
        });
    }
}
BitVector.moduleAddress = moduleAddress$T;
BitVector.moduleName = moduleName$T;
BitVector.structName = 'BitVector';
BitVector.typeParameters = [];
BitVector.fields = [
    { name: 'length', typeTag: AtomicTypeTag.U64 },
    { name: 'bit_field', typeTag: new VectorTag(AtomicTypeTag.Bool) }
];
function is_index_set_(bitvector, bit_index, $c) {
    if (!$.copy(bit_index).lt(length_$6(bitvector.bit_field, $c, [AtomicTypeTag.Bool]))) {
        throw $.abortCode($.copy(EINDEX));
    }
    return $.copy(borrow_$7(bitvector.bit_field, $.copy(bit_index), $c, [AtomicTypeTag.Bool]));
}
function length_$3(bitvector, $c) {
    return length_$6(bitvector.bit_field, $c, [AtomicTypeTag.Bool]);
}
function longest_set_sequence_starting_at_(bitvector, start_index, $c) {
    let index;
    if (!$.copy(start_index).lt($.copy(bitvector.length))) {
        throw $.abortCode($.copy(EINDEX));
    }
    index = $.copy(start_index);
    while ($.copy(index).lt($.copy(bitvector.length))) {
        {
            if (!is_index_set_(bitvector, $.copy(index), $c)) {
                break;
            }
            index = $.copy(index).add(u64('1'));
        }
    }
    return $.copy(index).sub($.copy(start_index));
}
function new___$3(length, $c) {
    let bit_field, counter;
    if (!$.copy(length).gt(u64('0'))) {
        throw $.abortCode($.copy(ELENGTH));
    }
    if (!$.copy(length).lt($.copy(MAX_SIZE))) {
        throw $.abortCode($.copy(ELENGTH));
    }
    counter = u64('0');
    bit_field = empty_$5($c, [AtomicTypeTag.Bool]);
    while (true) {
        if (!$.copy(counter).lt($.copy(length)))
            break;
        {
            push_back_(bit_field, false, $c, [AtomicTypeTag.Bool]);
            counter = $.copy(counter).add(u64('1'));
        }
    }
    return new BitVector({ length: $.copy(length), bit_field: $.copy(bit_field) }, new SimpleStructTag(BitVector));
}
function set_$2(bitvector, bit_index, $c) {
    let x;
    if (!$.copy(bit_index).lt(length_$6(bitvector.bit_field, $c, [AtomicTypeTag.Bool]))) {
        throw $.abortCode($.copy(EINDEX));
    }
    x = borrow_mut_$7(bitvector.bit_field, $.copy(bit_index), $c, [AtomicTypeTag.Bool]);
    $.set(x, true);
    return;
}
function shift_left_(bitvector, amount, $c) {
    let temp$2, temp$3, elem, i, i__1, len;
    if ($.copy(amount).ge($.copy(bitvector.length))) {
        len = length_$6(bitvector.bit_field, $c, [AtomicTypeTag.Bool]);
        i = u64('0');
        while ($.copy(i).lt($.copy(len))) {
            {
                elem = borrow_mut_$7(bitvector.bit_field, $.copy(i), $c, [AtomicTypeTag.Bool]);
                $.set(elem, false);
                i = $.copy(i).add(u64('1'));
            }
        }
    }
    else {
        i__1 = $.copy(amount);
        while ($.copy(i__1).lt($.copy(bitvector.length))) {
            {
                [temp$2, temp$3] = [bitvector, $.copy(i__1)];
                if (is_index_set_(temp$2, temp$3, $c)) {
                    set_$2(bitvector, $.copy(i__1).sub($.copy(amount)), $c);
                }
                else {
                    unset_(bitvector, $.copy(i__1).sub($.copy(amount)), $c);
                }
                i__1 = $.copy(i__1).add(u64('1'));
            }
        }
        i__1 = $.copy(bitvector.length).sub($.copy(amount));
        while ($.copy(i__1).lt($.copy(bitvector.length))) {
            {
                unset_(bitvector, $.copy(i__1), $c);
                i__1 = $.copy(i__1).add(u64('1'));
            }
        }
    }
    return;
}
function unset_(bitvector, bit_index, $c) {
    let x;
    if (!$.copy(bit_index).lt(length_$6(bitvector.bit_field, $c, [AtomicTypeTag.Bool]))) {
        throw $.abortCode($.copy(EINDEX));
    }
    x = borrow_mut_$7(bitvector.bit_field, $.copy(bit_index), $c, [AtomicTypeTag.Bool]);
    $.set(x, false);
    return;
}
function loadParsers$14(repo) {
    repo.addParser('0x1::bit_vector::BitVector', BitVector.BitVectorParser);
}
class App$15 {
    constructor(client, repo, cache) {
        this.client = client;
        this.repo = repo;
        this.cache = cache;
    }
    get moduleAddress() {
        {
            return moduleAddress$T;
        }
    }
    get moduleName() {
        {
            return moduleName$T;
        }
    }
    get BitVector() {
        return BitVector;
    }
}

var Bit_vector = /*#__PURE__*/Object.freeze({
    __proto__: null,
    packageName: packageName$T,
    moduleAddress: moduleAddress$T,
    moduleName: moduleName$T,
    EINDEX: EINDEX,
    ELENGTH: ELENGTH,
    MAX_SIZE: MAX_SIZE,
    WORD_SIZE: WORD_SIZE,
    BitVector: BitVector,
    is_index_set_: is_index_set_,
    length_: length_$3,
    longest_set_sequence_starting_at_: longest_set_sequence_starting_at_,
    new___: new___$3,
    set_: set_$2,
    shift_left_: shift_left_,
    unset_: unset_,
    loadParsers: loadParsers$14,
    App: App$15
});

const packageName$S = 'AptosFramework';
const moduleAddress$S = new HexString('0x1');
const moduleName$S = 'block';
const EINVALID_PROPOSER = u64('2');
const ENUM_NEW_BLOCK_EVENTS_DOES_NOT_MATCH_BLOCK_HEIGHT = u64('1');
const EZERO_EPOCH_INTERVAL = u64('3');
const MAX_U64$3 = u64('18446744073709551615');
class BlockResource {
    constructor(proto, typeTag) {
        this.typeTag = typeTag;
        this.__app = null;
        this.height = proto['height'];
        this.epoch_interval = proto['epoch_interval'];
        this.new_block_events = proto['new_block_events'];
        this.update_epoch_interval_events = proto['update_epoch_interval_events'];
    }
    static BlockResourceParser(data, typeTag, repo) {
        const proto = $.parseStructProto(data, typeTag, repo, BlockResource);
        return new BlockResource(proto, typeTag);
    }
    static load(repo, client, address, typeParams) {
        return __awaiter(this, void 0, void 0, function* () {
            const result = yield repo.loadResource(client, address, BlockResource, typeParams);
            return result;
        });
    }
    static loadByApp(app, address, typeParams) {
        return __awaiter(this, void 0, void 0, function* () {
            const result = yield app.repo.loadResource(app.client, address, BlockResource, typeParams);
            yield result.loadFullState(app);
            return result;
        });
    }
    static getTag() {
        return new StructTag(moduleAddress$S, moduleName$S, 'BlockResource', []);
    }
    loadFullState(app) {
        return __awaiter(this, void 0, void 0, function* () {
            yield this.new_block_events.loadFullState(app);
            yield this.update_epoch_interval_events.loadFullState(app);
            this.__app = app;
        });
    }
}
BlockResource.moduleAddress = moduleAddress$S;
BlockResource.moduleName = moduleName$S;
BlockResource.structName = 'BlockResource';
BlockResource.typeParameters = [];
BlockResource.fields = [
    { name: 'height', typeTag: AtomicTypeTag.U64 },
    { name: 'epoch_interval', typeTag: AtomicTypeTag.U64 },
    {
        name: 'new_block_events',
        typeTag: new StructTag(new HexString('0x1'), 'event', 'EventHandle', [
            new StructTag(new HexString('0x1'), 'block', 'NewBlockEvent', [])
        ])
    },
    {
        name: 'update_epoch_interval_events',
        typeTag: new StructTag(new HexString('0x1'), 'event', 'EventHandle', [
            new StructTag(new HexString('0x1'), 'block', 'UpdateEpochIntervalEvent', [])
        ])
    }
];
class NewBlockEvent {
    constructor(proto, typeTag) {
        this.typeTag = typeTag;
        this.__app = null;
        this.hash = proto['hash'];
        this.epoch = proto['epoch'];
        this.round = proto['round'];
        this.height = proto['height'];
        this.previous_block_votes_bitvec = proto['previous_block_votes_bitvec'];
        this.proposer = proto['proposer'];
        this.failed_proposer_indices = proto['failed_proposer_indices'];
        this.time_microseconds = proto['time_microseconds'];
    }
    static NewBlockEventParser(data, typeTag, repo) {
        const proto = $.parseStructProto(data, typeTag, repo, NewBlockEvent);
        return new NewBlockEvent(proto, typeTag);
    }
    static getTag() {
        return new StructTag(moduleAddress$S, moduleName$S, 'NewBlockEvent', []);
    }
    loadFullState(app) {
        return __awaiter(this, void 0, void 0, function* () {
            this.__app = app;
        });
    }
}
NewBlockEvent.moduleAddress = moduleAddress$S;
NewBlockEvent.moduleName = moduleName$S;
NewBlockEvent.structName = 'NewBlockEvent';
NewBlockEvent.typeParameters = [];
NewBlockEvent.fields = [
    { name: 'hash', typeTag: AtomicTypeTag.Address },
    { name: 'epoch', typeTag: AtomicTypeTag.U64 },
    { name: 'round', typeTag: AtomicTypeTag.U64 },
    { name: 'height', typeTag: AtomicTypeTag.U64 },
    { name: 'previous_block_votes_bitvec', typeTag: new VectorTag(AtomicTypeTag.U8) },
    { name: 'proposer', typeTag: AtomicTypeTag.Address },
    { name: 'failed_proposer_indices', typeTag: new VectorTag(AtomicTypeTag.U64) },
    { name: 'time_microseconds', typeTag: AtomicTypeTag.U64 }
];
class UpdateEpochIntervalEvent {
    constructor(proto, typeTag) {
        this.typeTag = typeTag;
        this.__app = null;
        this.old_epoch_interval = proto['old_epoch_interval'];
        this.new_epoch_interval = proto['new_epoch_interval'];
    }
    static UpdateEpochIntervalEventParser(data, typeTag, repo) {
        const proto = $.parseStructProto(data, typeTag, repo, UpdateEpochIntervalEvent);
        return new UpdateEpochIntervalEvent(proto, typeTag);
    }
    static getTag() {
        return new StructTag(moduleAddress$S, moduleName$S, 'UpdateEpochIntervalEvent', []);
    }
    loadFullState(app) {
        return __awaiter(this, void 0, void 0, function* () {
            this.__app = app;
        });
    }
}
UpdateEpochIntervalEvent.moduleAddress = moduleAddress$S;
UpdateEpochIntervalEvent.moduleName = moduleName$S;
UpdateEpochIntervalEvent.structName = 'UpdateEpochIntervalEvent';
UpdateEpochIntervalEvent.typeParameters = [];
UpdateEpochIntervalEvent.fields = [
    { name: 'old_epoch_interval', typeTag: AtomicTypeTag.U64 },
    { name: 'new_epoch_interval', typeTag: AtomicTypeTag.U64 }
];
function block_prologue_(vm, hash, epoch, round, proposer, failed_proposer_indices, previous_block_votes_bitvec, timestamp, $c) {
    let temp$1, block_metadata_ref, new_block_event, proposer_index;
    assert_vm_(vm, $c);
    if ($.copy(proposer).hex() === new HexString('0x0').hex()) {
        temp$1 = true;
    }
    else {
        temp$1 = is_current_epoch_validator_($.copy(proposer), $c);
    }
    if (!temp$1) {
        throw $.abortCode(permission_denied_($.copy(EINVALID_PROPOSER)));
    }
    proposer_index = none_($c, [AtomicTypeTag.U64]);
    if ($.copy(proposer).hex() !== new HexString('0x0').hex()) {
        proposer_index = some_(get_validator_index_($.copy(proposer), $c), $c, [AtomicTypeTag.U64]);
    }
    block_metadata_ref = $c.borrow_global_mut(new SimpleStructTag(BlockResource), new HexString('0x1'));
    block_metadata_ref.height = counter_(block_metadata_ref.new_block_events, $c, [
        new SimpleStructTag(NewBlockEvent)
    ]);
    new_block_event = new NewBlockEvent({
        hash: $.copy(hash),
        epoch: $.copy(epoch),
        round: $.copy(round),
        height: $.copy(block_metadata_ref.height),
        previous_block_votes_bitvec: $.copy(previous_block_votes_bitvec),
        proposer: $.copy(proposer),
        failed_proposer_indices: $.copy(failed_proposer_indices),
        time_microseconds: $.copy(timestamp)
    }, new SimpleStructTag(NewBlockEvent));
    emit_new_block_event_(vm, block_metadata_ref.new_block_events, new_block_event, $c);
    update_performance_statistics_($.copy(proposer_index), $.copy(failed_proposer_indices), $c);
    on_new_block_(current_epoch_($c), $c);
    if ($.copy(timestamp).sub(last_reconfiguration_time_($c)).ge($.copy(block_metadata_ref.epoch_interval))) {
        reconfigure_$1($c);
    }
    return;
}
function emit_genesis_block_event_(vm, $c) {
    let block_metadata_ref, genesis_id;
    block_metadata_ref = $c.borrow_global_mut(new SimpleStructTag(BlockResource), new HexString('0x1'));
    genesis_id = new HexString('0x0');
    emit_new_block_event_(vm, block_metadata_ref.new_block_events, new NewBlockEvent({
        hash: $.copy(genesis_id),
        epoch: u64('0'),
        round: u64('0'),
        height: u64('0'),
        previous_block_votes_bitvec: empty_$5($c, [AtomicTypeTag.U8]),
        proposer: new HexString('0x0'),
        failed_proposer_indices: empty_$5($c, [AtomicTypeTag.U64]),
        time_microseconds: u64('0')
    }, new SimpleStructTag(NewBlockEvent)), $c);
    return;
}
function emit_new_block_event_(vm, event_handle, new_block_event, $c) {
    update_global_time_(vm, $.copy(new_block_event.proposer), $.copy(new_block_event.time_microseconds), $c);
    if (!counter_(event_handle, $c, [new SimpleStructTag(NewBlockEvent)]).eq($.copy(new_block_event.height))) {
        throw $.abortCode(invalid_argument_($.copy(ENUM_NEW_BLOCK_EVENTS_DOES_NOT_MATCH_BLOCK_HEIGHT)));
    }
    emit_event_(event_handle, new_block_event, $c, [new SimpleStructTag(NewBlockEvent)]);
    return;
}
function emit_writeset_block_event_(vm_signer, fake_block_hash, $c) {
    let block_metadata_ref;
    assert_vm_(vm_signer, $c);
    block_metadata_ref = $c.borrow_global_mut(new SimpleStructTag(BlockResource), new HexString('0x1'));
    block_metadata_ref.height = counter_(block_metadata_ref.new_block_events, $c, [
        new SimpleStructTag(NewBlockEvent)
    ]);
    emit_event_(block_metadata_ref.new_block_events, new NewBlockEvent({
        hash: $.copy(fake_block_hash),
        epoch: current_epoch_($c),
        round: $.copy(MAX_U64$3),
        height: $.copy(block_metadata_ref.height),
        previous_block_votes_bitvec: empty_$5($c, [AtomicTypeTag.U8]),
        proposer: new HexString('0x0'),
        failed_proposer_indices: empty_$5($c, [AtomicTypeTag.U64]),
        time_microseconds: now_microseconds_($c)
    }, new SimpleStructTag(NewBlockEvent)), $c, [new SimpleStructTag(NewBlockEvent)]);
    return;
}
function get_current_block_height_($c) {
    return $.copy($c.borrow_global(new SimpleStructTag(BlockResource), new HexString('0x1')).height);
}
function get_epoch_interval_secs_($c) {
    return $.copy($c.borrow_global(new SimpleStructTag(BlockResource), new HexString('0x1')).epoch_interval).div(u64('1000000'));
}
function initialize_$b(aptos_framework, epoch_interval_microsecs, $c) {
    assert_aptos_framework_(aptos_framework, $c);
    if (!$.copy(epoch_interval_microsecs).gt(u64('0'))) {
        throw $.abortCode(invalid_argument_($.copy(EZERO_EPOCH_INTERVAL)));
    }
    $c.move_to(new SimpleStructTag(BlockResource), aptos_framework, new BlockResource({
        height: u64('0'),
        epoch_interval: $.copy(epoch_interval_microsecs),
        new_block_events: new_event_handle_(aptos_framework, $c, [new SimpleStructTag(NewBlockEvent)]),
        update_epoch_interval_events: new_event_handle_(aptos_framework, $c, [
            new SimpleStructTag(UpdateEpochIntervalEvent)
        ])
    }, new SimpleStructTag(BlockResource)));
    return;
}
function update_epoch_interval_microsecs_(aptos_framework, new_epoch_interval, $c) {
    let block_resource, old_epoch_interval;
    assert_aptos_framework_(aptos_framework, $c);
    if (!$.copy(new_epoch_interval).gt(u64('0'))) {
        throw $.abortCode(invalid_argument_($.copy(EZERO_EPOCH_INTERVAL)));
    }
    block_resource = $c.borrow_global_mut(new SimpleStructTag(BlockResource), new HexString('0x1'));
    old_epoch_interval = $.copy(block_resource.epoch_interval);
    block_resource.epoch_interval = $.copy(new_epoch_interval);
    emit_event_(block_resource.update_epoch_interval_events, new UpdateEpochIntervalEvent({ old_epoch_interval: $.copy(old_epoch_interval), new_epoch_interval: $.copy(new_epoch_interval) }, new SimpleStructTag(UpdateEpochIntervalEvent)), $c, [new SimpleStructTag(UpdateEpochIntervalEvent)]);
    return;
}
function loadParsers$13(repo) {
    repo.addParser('0x1::block::BlockResource', BlockResource.BlockResourceParser);
    repo.addParser('0x1::block::NewBlockEvent', NewBlockEvent.NewBlockEventParser);
    repo.addParser('0x1::block::UpdateEpochIntervalEvent', UpdateEpochIntervalEvent.UpdateEpochIntervalEventParser);
}
class App$14 {
    constructor(client, repo, cache) {
        this.client = client;
        this.repo = repo;
        this.cache = cache;
    }
    get moduleAddress() {
        {
            return moduleAddress$S;
        }
    }
    get moduleName() {
        {
            return moduleName$S;
        }
    }
    get BlockResource() {
        return BlockResource;
    }
    loadBlockResource(owner, loadFull = true, fillCache = true) {
        return __awaiter(this, void 0, void 0, function* () {
            const val = yield BlockResource.load(this.repo, this.client, owner, []);
            if (loadFull) {
                yield val.loadFullState(this);
            }
            if (fillCache) {
                this.cache.set(val.typeTag, owner, val);
            }
            return val;
        });
    }
    get NewBlockEvent() {
        return NewBlockEvent;
    }
    get UpdateEpochIntervalEvent() {
        return UpdateEpochIntervalEvent;
    }
}

var Block = /*#__PURE__*/Object.freeze({
    __proto__: null,
    packageName: packageName$S,
    moduleAddress: moduleAddress$S,
    moduleName: moduleName$S,
    EINVALID_PROPOSER: EINVALID_PROPOSER,
    ENUM_NEW_BLOCK_EVENTS_DOES_NOT_MATCH_BLOCK_HEIGHT: ENUM_NEW_BLOCK_EVENTS_DOES_NOT_MATCH_BLOCK_HEIGHT,
    EZERO_EPOCH_INTERVAL: EZERO_EPOCH_INTERVAL,
    MAX_U64: MAX_U64$3,
    BlockResource: BlockResource,
    NewBlockEvent: NewBlockEvent,
    UpdateEpochIntervalEvent: UpdateEpochIntervalEvent,
    block_prologue_: block_prologue_,
    emit_genesis_block_event_: emit_genesis_block_event_,
    emit_new_block_event_: emit_new_block_event_,
    emit_writeset_block_event_: emit_writeset_block_event_,
    get_current_block_height_: get_current_block_height_,
    get_epoch_interval_secs_: get_epoch_interval_secs_,
    initialize_: initialize_$b,
    update_epoch_interval_microsecs_: update_epoch_interval_microsecs_,
    loadParsers: loadParsers$13,
    App: App$14
});

const packageName$R = 'AptosStdlib';
const moduleAddress$R = new HexString('0x1');
const moduleName$R = 'capability';
const ECAPABILITY_ALREADY_EXISTS = u64('1');
const ECAPABILITY_NOT_FOUND = u64('2');
const EDELEGATE = u64('3');
class Cap {
    constructor(proto, typeTag) {
        this.typeTag = typeTag;
        this.__app = null;
        this.root = proto['root'];
    }
    static CapParser(data, typeTag, repo) {
        const proto = $.parseStructProto(data, typeTag, repo, Cap);
        return new Cap(proto, typeTag);
    }
    static makeTag($p) {
        return new StructTag(moduleAddress$R, moduleName$R, 'Cap', $p);
    }
    loadFullState(app) {
        return __awaiter(this, void 0, void 0, function* () {
            this.__app = app;
        });
    }
}
Cap.moduleAddress = moduleAddress$R;
Cap.moduleName = moduleName$R;
Cap.structName = 'Cap';
Cap.typeParameters = [{ name: 'Feature', isPhantom: true }];
Cap.fields = [{ name: 'root', typeTag: AtomicTypeTag.Address }];
class CapDelegateState {
    constructor(proto, typeTag) {
        this.typeTag = typeTag;
        this.__app = null;
        this.root = proto['root'];
    }
    static CapDelegateStateParser(data, typeTag, repo) {
        const proto = $.parseStructProto(data, typeTag, repo, CapDelegateState);
        return new CapDelegateState(proto, typeTag);
    }
    static load(repo, client, address, typeParams) {
        return __awaiter(this, void 0, void 0, function* () {
            const result = yield repo.loadResource(client, address, CapDelegateState, typeParams);
            return result;
        });
    }
    static loadByApp(app, address, typeParams) {
        return __awaiter(this, void 0, void 0, function* () {
            const result = yield app.repo.loadResource(app.client, address, CapDelegateState, typeParams);
            yield result.loadFullState(app);
            return result;
        });
    }
    static makeTag($p) {
        return new StructTag(moduleAddress$R, moduleName$R, 'CapDelegateState', $p);
    }
    loadFullState(app) {
        return __awaiter(this, void 0, void 0, function* () {
            this.__app = app;
        });
    }
}
CapDelegateState.moduleAddress = moduleAddress$R;
CapDelegateState.moduleName = moduleName$R;
CapDelegateState.structName = 'CapDelegateState';
CapDelegateState.typeParameters = [{ name: 'Feature', isPhantom: true }];
CapDelegateState.fields = [{ name: 'root', typeTag: AtomicTypeTag.Address }];
class CapState {
    constructor(proto, typeTag) {
        this.typeTag = typeTag;
        this.__app = null;
        this.delegates = proto['delegates'];
    }
    static CapStateParser(data, typeTag, repo) {
        const proto = $.parseStructProto(data, typeTag, repo, CapState);
        return new CapState(proto, typeTag);
    }
    static load(repo, client, address, typeParams) {
        return __awaiter(this, void 0, void 0, function* () {
            const result = yield repo.loadResource(client, address, CapState, typeParams);
            return result;
        });
    }
    static loadByApp(app, address, typeParams) {
        return __awaiter(this, void 0, void 0, function* () {
            const result = yield app.repo.loadResource(app.client, address, CapState, typeParams);
            yield result.loadFullState(app);
            return result;
        });
    }
    static makeTag($p) {
        return new StructTag(moduleAddress$R, moduleName$R, 'CapState', $p);
    }
    loadFullState(app) {
        return __awaiter(this, void 0, void 0, function* () {
            this.__app = app;
        });
    }
}
CapState.moduleAddress = moduleAddress$R;
CapState.moduleName = moduleName$R;
CapState.structName = 'CapState';
CapState.typeParameters = [{ name: 'Feature', isPhantom: true }];
CapState.fields = [{ name: 'delegates', typeTag: new VectorTag(AtomicTypeTag.Address) }];
class LinearCap {
    constructor(proto, typeTag) {
        this.typeTag = typeTag;
        this.__app = null;
        this.root = proto['root'];
    }
    static LinearCapParser(data, typeTag, repo) {
        const proto = $.parseStructProto(data, typeTag, repo, LinearCap);
        return new LinearCap(proto, typeTag);
    }
    static makeTag($p) {
        return new StructTag(moduleAddress$R, moduleName$R, 'LinearCap', $p);
    }
    loadFullState(app) {
        return __awaiter(this, void 0, void 0, function* () {
            this.__app = app;
        });
    }
}
LinearCap.moduleAddress = moduleAddress$R;
LinearCap.moduleName = moduleName$R;
LinearCap.structName = 'LinearCap';
LinearCap.typeParameters = [{ name: 'Feature', isPhantom: true }];
LinearCap.fields = [{ name: 'root', typeTag: AtomicTypeTag.Address }];
function acquire_(requester, _feature_witness, $c, $p /* <Feature>*/) {
    return new Cap({ root: validate_acquire_(requester, $c, [$p[0]]) }, new SimpleStructTag(Cap, [$p[0]]));
}
function acquire_linear_(requester, _feature_witness, $c, $p /* <Feature>*/) {
    return new LinearCap({ root: validate_acquire_(requester, $c, [$p[0]]) }, new SimpleStructTag(LinearCap, [$p[0]]));
}
function add_element_(v, x, $c, $p /* <E>*/) {
    let temp$1, temp$2;
    [temp$1, temp$2] = [v, x];
    if (!contains_$8(temp$1, temp$2, $c, [$p[0]])) {
        push_back_(v, x, $c, [$p[0]]);
    }
    return;
}
function create_$1(owner, _feature_witness, $c, $p /* <Feature>*/) {
    let addr;
    addr = address_of_(owner, $c);
    if (!!$c.exists(new SimpleStructTag(CapState, [$p[0]]), $.copy(addr))) {
        throw $.abortCode(already_exists_($.copy(ECAPABILITY_ALREADY_EXISTS)));
    }
    $c.move_to(new SimpleStructTag(CapState, [$p[0]]), owner, new CapState({ delegates: empty_$5($c, [AtomicTypeTag.Address]) }, new SimpleStructTag(CapState, [$p[0]])));
    return;
}
function delegate_(cap, _feature_witness, to, $c, $p /* <Feature>*/) {
    let addr;
    addr = address_of_(to, $c);
    if ($c.exists(new SimpleStructTag(CapDelegateState, [$p[0]]), $.copy(addr))) {
        return;
    }
    $c.move_to(new SimpleStructTag(CapDelegateState, [$p[0]]), to, new CapDelegateState({ root: $.copy(cap.root) }, new SimpleStructTag(CapDelegateState, [$p[0]])));
    add_element_($c.borrow_global_mut(new SimpleStructTag(CapState, [$p[0]]), $.copy(cap.root)).delegates, $.copy(addr), $c, [AtomicTypeTag.Address]);
    return;
}
function linear_root_addr_(cap, _feature_witness, $c, $p /* <Feature>*/) {
    return $.copy(cap.root);
}
function remove_element_(v, x, $c, $p /* <E>*/) {
    let temp$1, temp$2, found, index;
    [temp$1, temp$2] = [v, x];
    [found, index] = index_of_$1(temp$1, temp$2, $c, [$p[0]]);
    if (found) {
        remove_$5(v, $.copy(index), $c, [$p[0]]);
    }
    return;
}
function revoke_(cap, _feature_witness, from, $c, $p /* <Feature>*/) {
    if (!$c.exists(new SimpleStructTag(CapDelegateState, [$p[0]]), $.copy(from))) {
        return;
    }
    $c.move_from(new SimpleStructTag(CapDelegateState, [$p[0]]), $.copy(from));
    remove_element_($c.borrow_global_mut(new SimpleStructTag(CapState, [$p[0]]), $.copy(cap.root)).delegates, from, $c, [AtomicTypeTag.Address]);
    return;
}
function root_addr_(cap, _feature_witness, $c, $p /* <Feature>*/) {
    return $.copy(cap.root);
}
function validate_acquire_(requester, $c, $p /* <Feature>*/) {
    let temp$1, addr, root_addr;
    addr = address_of_(requester, $c);
    if ($c.exists(new SimpleStructTag(CapDelegateState, [$p[0]]), $.copy(addr))) {
        root_addr = $.copy($c.borrow_global(new SimpleStructTag(CapDelegateState, [$p[0]]), $.copy(addr)).root);
        if (!$c.exists(new SimpleStructTag(CapState, [$p[0]]), $.copy(root_addr))) {
            throw $.abortCode(invalid_state_($.copy(EDELEGATE)));
        }
        if (!contains_$8($c.borrow_global(new SimpleStructTag(CapState, [$p[0]]), $.copy(root_addr)).delegates, addr, $c, [AtomicTypeTag.Address])) {
            throw $.abortCode(invalid_state_($.copy(EDELEGATE)));
        }
        temp$1 = $.copy(root_addr);
    }
    else {
        if (!$c.exists(new SimpleStructTag(CapState, [$p[0]]), $.copy(addr))) {
            throw $.abortCode(not_found_($.copy(ECAPABILITY_NOT_FOUND)));
        }
        temp$1 = $.copy(addr);
    }
    return temp$1;
}
function loadParsers$12(repo) {
    repo.addParser('0x1::capability::Cap', Cap.CapParser);
    repo.addParser('0x1::capability::CapDelegateState', CapDelegateState.CapDelegateStateParser);
    repo.addParser('0x1::capability::CapState', CapState.CapStateParser);
    repo.addParser('0x1::capability::LinearCap', LinearCap.LinearCapParser);
}
class App$13 {
    constructor(client, repo, cache) {
        this.client = client;
        this.repo = repo;
        this.cache = cache;
    }
    get moduleAddress() {
        {
            return moduleAddress$R;
        }
    }
    get moduleName() {
        {
            return moduleName$R;
        }
    }
    get Cap() {
        return Cap;
    }
    get CapDelegateState() {
        return CapDelegateState;
    }
    loadCapDelegateState(owner, $p /* <Feature> */, loadFull = true, fillCache = true) {
        return __awaiter(this, void 0, void 0, function* () {
            const val = yield CapDelegateState.load(this.repo, this.client, owner, $p);
            if (loadFull) {
                yield val.loadFullState(this);
            }
            if (fillCache) {
                this.cache.set(val.typeTag, owner, val);
            }
            return val;
        });
    }
    get CapState() {
        return CapState;
    }
    loadCapState(owner, $p /* <Feature> */, loadFull = true, fillCache = true) {
        return __awaiter(this, void 0, void 0, function* () {
            const val = yield CapState.load(this.repo, this.client, owner, $p);
            if (loadFull) {
                yield val.loadFullState(this);
            }
            if (fillCache) {
                this.cache.set(val.typeTag, owner, val);
            }
            return val;
        });
    }
    get LinearCap() {
        return LinearCap;
    }
}

var Capability = /*#__PURE__*/Object.freeze({
    __proto__: null,
    packageName: packageName$R,
    moduleAddress: moduleAddress$R,
    moduleName: moduleName$R,
    ECAPABILITY_ALREADY_EXISTS: ECAPABILITY_ALREADY_EXISTS,
    ECAPABILITY_NOT_FOUND: ECAPABILITY_NOT_FOUND,
    EDELEGATE: EDELEGATE,
    Cap: Cap,
    CapDelegateState: CapDelegateState,
    CapState: CapState,
    LinearCap: LinearCap,
    acquire_: acquire_,
    acquire_linear_: acquire_linear_,
    add_element_: add_element_,
    create_: create_$1,
    delegate_: delegate_,
    linear_root_addr_: linear_root_addr_,
    remove_element_: remove_element_,
    revoke_: revoke_,
    root_addr_: root_addr_,
    validate_acquire_: validate_acquire_,
    loadParsers: loadParsers$12,
    App: App$13
});

const packageName$Q = 'AptosFramework';
const moduleAddress$Q = new HexString('0x1');
const moduleName$Q = 'chain_id';
class ChainId {
    constructor(proto, typeTag) {
        this.typeTag = typeTag;
        this.__app = null;
        this.id = proto['id'];
    }
    static ChainIdParser(data, typeTag, repo) {
        const proto = $.parseStructProto(data, typeTag, repo, ChainId);
        return new ChainId(proto, typeTag);
    }
    static load(repo, client, address, typeParams) {
        return __awaiter(this, void 0, void 0, function* () {
            const result = yield repo.loadResource(client, address, ChainId, typeParams);
            return result;
        });
    }
    static loadByApp(app, address, typeParams) {
        return __awaiter(this, void 0, void 0, function* () {
            const result = yield app.repo.loadResource(app.client, address, ChainId, typeParams);
            yield result.loadFullState(app);
            return result;
        });
    }
    static getTag() {
        return new StructTag(moduleAddress$Q, moduleName$Q, 'ChainId', []);
    }
    loadFullState(app) {
        return __awaiter(this, void 0, void 0, function* () {
            this.__app = app;
        });
    }
}
ChainId.moduleAddress = moduleAddress$Q;
ChainId.moduleName = moduleName$Q;
ChainId.structName = 'ChainId';
ChainId.typeParameters = [];
ChainId.fields = [{ name: 'id', typeTag: AtomicTypeTag.U8 }];
function get_$1($c) {
    return $.copy($c.borrow_global(new SimpleStructTag(ChainId), new HexString('0x1')).id);
}
function initialize_$a(aptos_framework, id, $c) {
    assert_aptos_framework_(aptos_framework, $c);
    return $c.move_to(new SimpleStructTag(ChainId), aptos_framework, new ChainId({ id: $.copy(id) }, new SimpleStructTag(ChainId)));
}
function loadParsers$11(repo) {
    repo.addParser('0x1::chain_id::ChainId', ChainId.ChainIdParser);
}
class App$12 {
    constructor(client, repo, cache) {
        this.client = client;
        this.repo = repo;
        this.cache = cache;
    }
    get moduleAddress() {
        {
            return moduleAddress$Q;
        }
    }
    get moduleName() {
        {
            return moduleName$Q;
        }
    }
    get ChainId() {
        return ChainId;
    }
    loadChainId(owner, loadFull = true, fillCache = true) {
        return __awaiter(this, void 0, void 0, function* () {
            const val = yield ChainId.load(this.repo, this.client, owner, []);
            if (loadFull) {
                yield val.loadFullState(this);
            }
            if (fillCache) {
                this.cache.set(val.typeTag, owner, val);
            }
            return val;
        });
    }
}

var Chain_id = /*#__PURE__*/Object.freeze({
    __proto__: null,
    packageName: packageName$Q,
    moduleAddress: moduleAddress$Q,
    moduleName: moduleName$Q,
    ChainId: ChainId,
    get_: get_$1,
    initialize_: initialize_$a,
    loadParsers: loadParsers$11,
    App: App$12
});

const packageName$P = 'MoveStdlib';
const moduleAddress$P = new HexString('0x1');
const moduleName$P = 'features';
const CODE_DEPENDENCY_CHECK = u64('1');
const EFRAMEWORK_SIGNER_NEEDED = u64('1');
const TREAT_FRIEND_AS_PRIVATE = u64('2');
class Features {
    constructor(proto, typeTag) {
        this.typeTag = typeTag;
        this.__app = null;
        this.features = proto['features'];
    }
    static FeaturesParser(data, typeTag, repo) {
        const proto = $.parseStructProto(data, typeTag, repo, Features);
        return new Features(proto, typeTag);
    }
    static load(repo, client, address, typeParams) {
        return __awaiter(this, void 0, void 0, function* () {
            const result = yield repo.loadResource(client, address, Features, typeParams);
            return result;
        });
    }
    static loadByApp(app, address, typeParams) {
        return __awaiter(this, void 0, void 0, function* () {
            const result = yield app.repo.loadResource(app.client, address, Features, typeParams);
            yield result.loadFullState(app);
            return result;
        });
    }
    static getTag() {
        return new StructTag(moduleAddress$P, moduleName$P, 'Features', []);
    }
    loadFullState(app) {
        return __awaiter(this, void 0, void 0, function* () {
            this.__app = app;
        });
    }
}
Features.moduleAddress = moduleAddress$P;
Features.moduleName = moduleName$P;
Features.structName = 'Features';
Features.typeParameters = [];
Features.fields = [{ name: 'features', typeTag: new VectorTag(AtomicTypeTag.U8) }];
function change_feature_flags_(framework, enable, disable, $c) {
    let features, i, i__1, n, n__2;
    if (!(address_of_(framework, $c).hex() === new HexString('0x1').hex())) {
        throw $.abortCode(permission_denied_($.copy(EFRAMEWORK_SIGNER_NEEDED)));
    }
    if (!$c.exists(new SimpleStructTag(Features), new HexString('0x1'))) {
        $c.move_to(new SimpleStructTag(Features), framework, new Features({ features: [] }, new SimpleStructTag(Features)));
    }
    features = $c.borrow_global_mut(new SimpleStructTag(Features), new HexString('0x1')).features;
    i = u64('0');
    n = length_$6(enable, $c, [AtomicTypeTag.U64]);
    while ($.copy(i).lt($.copy(n))) {
        {
            set_$1(features, $.copy(borrow_$7(enable, $.copy(i), $c, [AtomicTypeTag.U64])), true, $c);
            i = $.copy(i).add(u64('1'));
        }
    }
    i__1 = u64('0');
    n__2 = length_$6(disable, $c, [AtomicTypeTag.U64]);
    while ($.copy(i__1).lt($.copy(n__2))) {
        {
            set_$1(features, $.copy(borrow_$7(disable, $.copy(i__1), $c, [AtomicTypeTag.U64])), false, $c);
            i__1 = $.copy(i__1).add(u64('1'));
        }
    }
    return;
}
function code_dependency_check_enabled_($c) {
    return is_enabled_($.copy(CODE_DEPENDENCY_CHECK), $c);
}
function contains_$4(features, feature, $c) {
    let temp$1, bit_mask, byte_index;
    byte_index = $.copy(feature).div(u64('8'));
    bit_mask = u8('1').shl(u8($.copy(feature).mod(u64('8'))));
    if ($.copy(byte_index).lt(length_$6(features, $c, [AtomicTypeTag.U8]))) {
        temp$1 = $.copy(borrow_$7(features, $.copy(byte_index), $c, [AtomicTypeTag.U8]))
            .and($.copy(bit_mask))
            .neq(u8('0'));
    }
    else {
        temp$1 = false;
    }
    return temp$1;
}
function is_enabled_(feature, $c) {
    let temp$1;
    if ($c.exists(new SimpleStructTag(Features), new HexString('0x1'))) {
        temp$1 = contains_$4($c.borrow_global(new SimpleStructTag(Features), new HexString('0x1')).features, $.copy(feature), $c);
    }
    else {
        temp$1 = false;
    }
    return temp$1;
}
function set_$1(features, feature, include, $c) {
    let bit_mask, byte_index, entry;
    byte_index = $.copy(feature).div(u64('8'));
    bit_mask = u8('1').shl(u8($.copy(feature).mod(u64('8'))));
    while (length_$6(features, $c, [AtomicTypeTag.U8]).le($.copy(byte_index))) {
        {
            push_back_(features, u8('0'), $c, [AtomicTypeTag.U8]);
        }
    }
    entry = borrow_mut_$7(features, $.copy(byte_index), $c, [AtomicTypeTag.U8]);
    if (include) {
        $.set(entry, $.copy(entry).or($.copy(bit_mask)));
    }
    else {
        $.set(entry, $.copy(entry).and(u8('255').xor($.copy(bit_mask))));
    }
    return;
}
function treat_friend_as_private_($c) {
    return is_enabled_($.copy(TREAT_FRIEND_AS_PRIVATE), $c);
}
function loadParsers$10(repo) {
    repo.addParser('0x1::features::Features', Features.FeaturesParser);
}
class App$11 {
    constructor(client, repo, cache) {
        this.client = client;
        this.repo = repo;
        this.cache = cache;
    }
    get moduleAddress() {
        {
            return moduleAddress$P;
        }
    }
    get moduleName() {
        {
            return moduleName$P;
        }
    }
    get Features() {
        return Features;
    }
    loadFeatures(owner, loadFull = true, fillCache = true) {
        return __awaiter(this, void 0, void 0, function* () {
            const val = yield Features.load(this.repo, this.client, owner, []);
            if (loadFull) {
                yield val.loadFullState(this);
            }
            if (fillCache) {
                this.cache.set(val.typeTag, owner, val);
            }
            return val;
        });
    }
}

var Features$1 = /*#__PURE__*/Object.freeze({
    __proto__: null,
    packageName: packageName$P,
    moduleAddress: moduleAddress$P,
    moduleName: moduleName$P,
    CODE_DEPENDENCY_CHECK: CODE_DEPENDENCY_CHECK,
    EFRAMEWORK_SIGNER_NEEDED: EFRAMEWORK_SIGNER_NEEDED,
    TREAT_FRIEND_AS_PRIVATE: TREAT_FRIEND_AS_PRIVATE,
    Features: Features,
    change_feature_flags_: change_feature_flags_,
    code_dependency_check_enabled_: code_dependency_check_enabled_,
    contains_: contains_$4,
    is_enabled_: is_enabled_,
    set_: set_$1,
    treat_friend_as_private_: treat_friend_as_private_,
    loadParsers: loadParsers$10,
    App: App$11
});

const packageName$O = 'AptosFramework';
const moduleAddress$O = new HexString('0x1');
const moduleName$O = 'util';
function address_from_bytes_(bytes, $c) {
    return from_bytes_($.copy(bytes), $c, [AtomicTypeTag.Address]);
}
function from_bytes_(bytes, $c, $p /* <T>*/) {
    return $.aptos_framework_util_from_bytes(bytes, $c, [$p[0]]);
}
function loadParsers$$(repo) { }
class App$10 {
    constructor(client, repo, cache) {
        this.client = client;
        this.repo = repo;
        this.cache = cache;
    }
    get moduleAddress() {
        {
            return moduleAddress$O;
        }
    }
    get moduleName() {
        {
            return moduleName$O;
        }
    }
}

var Util = /*#__PURE__*/Object.freeze({
    __proto__: null,
    packageName: packageName$O,
    moduleAddress: moduleAddress$O,
    moduleName: moduleName$O,
    address_from_bytes_: address_from_bytes_,
    from_bytes_: from_bytes_,
    loadParsers: loadParsers$$,
    App: App$10
});

const packageName$N = 'AptosFramework';
const moduleAddress$N = new HexString('0x1');
const moduleName$N = 'code';
const EDEP_ARBITRARY_NOT_SAME_ADDRESS = u64('7');
const EDEP_WEAKER_POLICY = u64('6');
const EINCOMPATIBLE_POLICY_DISABLED = u64('8');
const EMODULE_MISSING = u64('4');
const EMODULE_NAME_CLASH = u64('1');
const EPACKAGE_DEP_MISSING = u64('5');
const EUPGRADE_IMMUTABLE = u64('2');
const EUPGRADE_WEAKER_POLICY = u64('3');
class AllowedDep {
    constructor(proto, typeTag) {
        this.typeTag = typeTag;
        this.__app = null;
        this.account = proto['account'];
        this.module_name = proto['module_name'];
    }
    static AllowedDepParser(data, typeTag, repo) {
        const proto = $.parseStructProto(data, typeTag, repo, AllowedDep);
        return new AllowedDep(proto, typeTag);
    }
    static getTag() {
        return new StructTag(moduleAddress$N, moduleName$N, 'AllowedDep', []);
    }
    loadFullState(app) {
        return __awaiter(this, void 0, void 0, function* () {
            yield this.module_name.loadFullState(app);
            this.__app = app;
        });
    }
}
AllowedDep.moduleAddress = moduleAddress$N;
AllowedDep.moduleName = moduleName$N;
AllowedDep.structName = 'AllowedDep';
AllowedDep.typeParameters = [];
AllowedDep.fields = [
    { name: 'account', typeTag: AtomicTypeTag.Address },
    { name: 'module_name', typeTag: new StructTag(new HexString('0x1'), 'string', 'String', []) }
];
class ModuleMetadata {
    constructor(proto, typeTag) {
        this.typeTag = typeTag;
        this.__app = null;
        this.name = proto['name'];
        this.source = proto['source'];
        this.source_map = proto['source_map'];
        this.extension = proto['extension'];
    }
    static ModuleMetadataParser(data, typeTag, repo) {
        const proto = $.parseStructProto(data, typeTag, repo, ModuleMetadata);
        return new ModuleMetadata(proto, typeTag);
    }
    static getTag() {
        return new StructTag(moduleAddress$N, moduleName$N, 'ModuleMetadata', []);
    }
    loadFullState(app) {
        return __awaiter(this, void 0, void 0, function* () {
            yield this.name.loadFullState(app);
            yield this.extension.loadFullState(app);
            this.__app = app;
        });
    }
}
ModuleMetadata.moduleAddress = moduleAddress$N;
ModuleMetadata.moduleName = moduleName$N;
ModuleMetadata.structName = 'ModuleMetadata';
ModuleMetadata.typeParameters = [];
ModuleMetadata.fields = [
    { name: 'name', typeTag: new StructTag(new HexString('0x1'), 'string', 'String', []) },
    { name: 'source', typeTag: new VectorTag(AtomicTypeTag.U8) },
    { name: 'source_map', typeTag: new VectorTag(AtomicTypeTag.U8) },
    {
        name: 'extension',
        typeTag: new StructTag(new HexString('0x1'), 'option', 'Option', [
            new StructTag(new HexString('0x1'), 'copyable_any', 'Any', [])
        ])
    }
];
class PackageDep {
    constructor(proto, typeTag) {
        this.typeTag = typeTag;
        this.__app = null;
        this.account = proto['account'];
        this.package_name = proto['package_name'];
    }
    static PackageDepParser(data, typeTag, repo) {
        const proto = $.parseStructProto(data, typeTag, repo, PackageDep);
        return new PackageDep(proto, typeTag);
    }
    static getTag() {
        return new StructTag(moduleAddress$N, moduleName$N, 'PackageDep', []);
    }
    loadFullState(app) {
        return __awaiter(this, void 0, void 0, function* () {
            yield this.package_name.loadFullState(app);
            this.__app = app;
        });
    }
}
PackageDep.moduleAddress = moduleAddress$N;
PackageDep.moduleName = moduleName$N;
PackageDep.structName = 'PackageDep';
PackageDep.typeParameters = [];
PackageDep.fields = [
    { name: 'account', typeTag: AtomicTypeTag.Address },
    { name: 'package_name', typeTag: new StructTag(new HexString('0x1'), 'string', 'String', []) }
];
class PackageMetadata {
    constructor(proto, typeTag) {
        this.typeTag = typeTag;
        this.__app = null;
        this.name = proto['name'];
        this.upgrade_policy = proto['upgrade_policy'];
        this.upgrade_number = proto['upgrade_number'];
        this.source_digest = proto['source_digest'];
        this.manifest = proto['manifest'];
        this.modules = proto['modules'];
        this.deps = proto['deps'];
        this.extension = proto['extension'];
    }
    static PackageMetadataParser(data, typeTag, repo) {
        const proto = $.parseStructProto(data, typeTag, repo, PackageMetadata);
        return new PackageMetadata(proto, typeTag);
    }
    static getTag() {
        return new StructTag(moduleAddress$N, moduleName$N, 'PackageMetadata', []);
    }
    loadFullState(app) {
        return __awaiter(this, void 0, void 0, function* () {
            yield this.name.loadFullState(app);
            yield this.upgrade_policy.loadFullState(app);
            yield this.source_digest.loadFullState(app);
            yield this.extension.loadFullState(app);
            this.__app = app;
        });
    }
}
PackageMetadata.moduleAddress = moduleAddress$N;
PackageMetadata.moduleName = moduleName$N;
PackageMetadata.structName = 'PackageMetadata';
PackageMetadata.typeParameters = [];
PackageMetadata.fields = [
    { name: 'name', typeTag: new StructTag(new HexString('0x1'), 'string', 'String', []) },
    { name: 'upgrade_policy', typeTag: new StructTag(new HexString('0x1'), 'code', 'UpgradePolicy', []) },
    { name: 'upgrade_number', typeTag: AtomicTypeTag.U64 },
    { name: 'source_digest', typeTag: new StructTag(new HexString('0x1'), 'string', 'String', []) },
    { name: 'manifest', typeTag: new VectorTag(AtomicTypeTag.U8) },
    { name: 'modules', typeTag: new VectorTag(new StructTag(new HexString('0x1'), 'code', 'ModuleMetadata', [])) },
    { name: 'deps', typeTag: new VectorTag(new StructTag(new HexString('0x1'), 'code', 'PackageDep', [])) },
    {
        name: 'extension',
        typeTag: new StructTag(new HexString('0x1'), 'option', 'Option', [
            new StructTag(new HexString('0x1'), 'copyable_any', 'Any', [])
        ])
    }
];
class PackageRegistry {
    constructor(proto, typeTag) {
        this.typeTag = typeTag;
        this.__app = null;
        this.packages = proto['packages'];
    }
    static PackageRegistryParser(data, typeTag, repo) {
        const proto = $.parseStructProto(data, typeTag, repo, PackageRegistry);
        return new PackageRegistry(proto, typeTag);
    }
    static load(repo, client, address, typeParams) {
        return __awaiter(this, void 0, void 0, function* () {
            const result = yield repo.loadResource(client, address, PackageRegistry, typeParams);
            return result;
        });
    }
    static loadByApp(app, address, typeParams) {
        return __awaiter(this, void 0, void 0, function* () {
            const result = yield app.repo.loadResource(app.client, address, PackageRegistry, typeParams);
            yield result.loadFullState(app);
            return result;
        });
    }
    static getTag() {
        return new StructTag(moduleAddress$N, moduleName$N, 'PackageRegistry', []);
    }
    loadFullState(app) {
        return __awaiter(this, void 0, void 0, function* () {
            this.__app = app;
        });
    }
}
PackageRegistry.moduleAddress = moduleAddress$N;
PackageRegistry.moduleName = moduleName$N;
PackageRegistry.structName = 'PackageRegistry';
PackageRegistry.typeParameters = [];
PackageRegistry.fields = [
    { name: 'packages', typeTag: new VectorTag(new StructTag(new HexString('0x1'), 'code', 'PackageMetadata', [])) }
];
class UpgradePolicy {
    constructor(proto, typeTag) {
        this.typeTag = typeTag;
        this.__app = null;
        this.policy = proto['policy'];
    }
    static UpgradePolicyParser(data, typeTag, repo) {
        const proto = $.parseStructProto(data, typeTag, repo, UpgradePolicy);
        return new UpgradePolicy(proto, typeTag);
    }
    static getTag() {
        return new StructTag(moduleAddress$N, moduleName$N, 'UpgradePolicy', []);
    }
    loadFullState(app) {
        return __awaiter(this, void 0, void 0, function* () {
            this.__app = app;
        });
    }
}
UpgradePolicy.moduleAddress = moduleAddress$N;
UpgradePolicy.moduleName = moduleName$N;
UpgradePolicy.structName = 'UpgradePolicy';
UpgradePolicy.typeParameters = [];
UpgradePolicy.fields = [{ name: 'policy', typeTag: AtomicTypeTag.U8 }];
function can_change_upgrade_policy_to_(from, to, $c) {
    return $.copy(from.policy).le($.copy(to.policy));
}
function check_coexistence_(old_pack, new_modules, $c) {
    let i, j, name, old_mod;
    i = u64('0');
    while ($.copy(i).lt(length_$6(old_pack.modules, $c, [new SimpleStructTag(ModuleMetadata)]))) {
        {
            old_mod = borrow_$7(old_pack.modules, $.copy(i), $c, [new SimpleStructTag(ModuleMetadata)]);
            j = u64('0');
            while ($.copy(j).lt(length_$6(new_modules, $c, [new StructTag(new HexString('0x1'), 'string', 'String', [])]))) {
                {
                    name = borrow_$7(new_modules, $.copy(j), $c, [
                        new StructTag(new HexString('0x1'), 'string', 'String', [])
                    ]);
                    if (!!$.deep_eq(old_mod.name, name)) {
                        throw $.abortCode(already_exists_($.copy(EMODULE_NAME_CLASH)));
                    }
                    j = $.copy(j).add(u64('1'));
                }
            }
            i = $.copy(i).add(u64('1'));
        }
    }
    return;
}
function check_dependencies_(publish_address, pack, $c) {
    let account, account__1, allowed_module_deps, dep, dep_pack, deps, found, i, j, k, m, module_name, module_name__2, n, r, registry;
    allowed_module_deps = empty_$5($c, [new SimpleStructTag(AllowedDep)]);
    deps = pack.deps;
    i = u64('0');
    n = length_$6(deps, $c, [new SimpleStructTag(PackageDep)]);
    while ($.copy(i).lt($.copy(n))) {
        {
            dep = borrow_$7(deps, $.copy(i), $c, [new SimpleStructTag(PackageDep)]);
            if (!$c.exists(new SimpleStructTag(PackageRegistry), $.copy(dep.account))) {
                throw $.abortCode(not_found_($.copy(EPACKAGE_DEP_MISSING)));
            }
            if (is_policy_exempted_address_($.copy(dep.account))) {
                account = $.copy(dep.account);
                module_name = utf8_([], $c);
                push_back_(allowed_module_deps, new AllowedDep({ account: $.copy(account), module_name: $.copy(module_name) }, new SimpleStructTag(AllowedDep)), $c, [new SimpleStructTag(AllowedDep)]);
                i = $.copy(i).add(u64('1'));
                continue;
            }
            registry = $c.borrow_global(new SimpleStructTag(PackageRegistry), $.copy(dep.account));
            j = u64('0');
            m = length_$6(registry.packages, $c, [new SimpleStructTag(PackageMetadata)]);
            found = false;
            while ($.copy(j).lt($.copy(m))) {
                {
                    dep_pack = borrow_$7(registry.packages, $.copy(j), $c, [new SimpleStructTag(PackageMetadata)]);
                    if ($.deep_eq($.copy(dep_pack.name), $.copy(dep.package_name))) {
                        found = true;
                        if (!$.copy(dep_pack.upgrade_policy.policy).ge($.copy(pack.upgrade_policy.policy))) {
                            throw $.abortCode(invalid_argument_($.copy(EDEP_WEAKER_POLICY)));
                        }
                        if ($.deep_eq($.copy(dep_pack.upgrade_policy), upgrade_policy_arbitrary_())) {
                            if (!($.copy(dep.account).hex() === $.copy(publish_address).hex())) {
                                throw $.abortCode(invalid_argument_($.copy(EDEP_ARBITRARY_NOT_SAME_ADDRESS)));
                            }
                        }
                        k = u64('0');
                        r = length_$6(dep_pack.modules, $c, [new SimpleStructTag(ModuleMetadata)]);
                        while ($.copy(k).lt($.copy(r))) {
                            {
                                account__1 = $.copy(dep.account);
                                module_name__2 = $.copy(borrow_$7(dep_pack.modules, $.copy(k), $c, [new SimpleStructTag(ModuleMetadata)]).name);
                                push_back_(allowed_module_deps, new AllowedDep({ account: $.copy(account__1), module_name: $.copy(module_name__2) }, new SimpleStructTag(AllowedDep)), $c, [new SimpleStructTag(AllowedDep)]);
                                k = $.copy(k).add(u64('1'));
                            }
                        }
                        break;
                    }
                    j = $.copy(j).add(u64('1'));
                }
            }
            if (!found) {
                throw $.abortCode(not_found_($.copy(EPACKAGE_DEP_MISSING)));
            }
            i = $.copy(i).add(u64('1'));
        }
    }
    return allowed_module_deps;
}
function check_upgradability_(old_pack, new_pack, new_modules, $c) {
    let temp$1, i, old_modules;
    temp$1 = upgrade_policy_immutable_();
    if (!$.copy(old_pack.upgrade_policy.policy).lt($.copy(temp$1.policy))) {
        throw $.abortCode(invalid_argument_($.copy(EUPGRADE_IMMUTABLE)));
    }
    if (!can_change_upgrade_policy_to_($.copy(old_pack.upgrade_policy), $.copy(new_pack.upgrade_policy))) {
        throw $.abortCode(invalid_argument_($.copy(EUPGRADE_WEAKER_POLICY)));
    }
    old_modules = get_module_names_(old_pack, $c);
    i = u64('0');
    while ($.copy(i).lt(length_$6(old_modules, $c, [new StructTag(new HexString('0x1'), 'string', 'String', [])]))) {
        {
            if (!contains_$8(new_modules, borrow_$7(old_modules, $.copy(i), $c, [new StructTag(new HexString('0x1'), 'string', 'String', [])]), $c, [new StructTag(new HexString('0x1'), 'string', 'String', [])])) {
                throw $.abortCode($.copy(EMODULE_MISSING));
            }
            i = $.copy(i).add(u64('1'));
        }
    }
    return;
}
function get_module_names_(pack, $c) {
    let i, module_names;
    module_names = empty_$5($c, [new StructTag(new HexString('0x1'), 'string', 'String', [])]);
    i = u64('0');
    while ($.copy(i).lt(length_$6(pack.modules, $c, [new SimpleStructTag(ModuleMetadata)]))) {
        {
            push_back_(module_names, $.copy(borrow_$7(pack.modules, $.copy(i), $c, [new SimpleStructTag(ModuleMetadata)]).name), $c, [new StructTag(new HexString('0x1'), 'string', 'String', [])]);
            i = $.copy(i).add(u64('1'));
        }
    }
    return $.copy(module_names);
}
function initialize_$9(aptos_framework, package_owner, metadata, $c) {
    let addr;
    assert_aptos_framework_(aptos_framework, $c);
    addr = address_of_(package_owner, $c);
    if (!$c.exists(new SimpleStructTag(PackageRegistry), $.copy(addr))) {
        $c.move_to(new SimpleStructTag(PackageRegistry), package_owner, new PackageRegistry({ packages: [metadata] }, new SimpleStructTag(PackageRegistry)));
    }
    else {
        push_back_($c.borrow_global_mut(new SimpleStructTag(PackageRegistry), $.copy(addr)).packages, metadata, $c, [new SimpleStructTag(PackageMetadata)]);
    }
    return;
}
function is_policy_exempted_address_(addr, $c) {
    let temp$1, temp$2, temp$3, temp$4, temp$5, temp$6, temp$7, temp$8, temp$9;
    if ($.copy(addr).hex() === new HexString('0x1').hex()) {
        temp$1 = true;
    }
    else {
        temp$1 = $.copy(addr).hex() === new HexString('0x2').hex();
    }
    if (temp$1) {
        temp$2 = true;
    }
    else {
        temp$2 = $.copy(addr).hex() === new HexString('0x3').hex();
    }
    if (temp$2) {
        temp$3 = true;
    }
    else {
        temp$3 = $.copy(addr).hex() === new HexString('0x4').hex();
    }
    if (temp$3) {
        temp$4 = true;
    }
    else {
        temp$4 = $.copy(addr).hex() === new HexString('0x5').hex();
    }
    if (temp$4) {
        temp$5 = true;
    }
    else {
        temp$5 = $.copy(addr).hex() === new HexString('0x6').hex();
    }
    if (temp$5) {
        temp$6 = true;
    }
    else {
        temp$6 = $.copy(addr).hex() === new HexString('0x7').hex();
    }
    if (temp$6) {
        temp$7 = true;
    }
    else {
        temp$7 = $.copy(addr).hex() === new HexString('0x8').hex();
    }
    if (temp$7) {
        temp$8 = true;
    }
    else {
        temp$8 = $.copy(addr).hex() === new HexString('0x9').hex();
    }
    if (temp$8) {
        temp$9 = true;
    }
    else {
        temp$9 = $.copy(addr).hex() === new HexString('0xa').hex();
    }
    return temp$9;
}
function publish_package_(owner, pack, code, $c) {
    let temp$1, temp$2, temp$3, addr, allowed_deps, i, index, len, module_names, old, packages, policy, upgrade_number;
    temp$1 = upgrade_policy_arbitrary_();
    if (!$.copy(pack.upgrade_policy.policy).gt($.copy(temp$1.policy))) {
        throw $.abortCode(invalid_argument_($.copy(EINCOMPATIBLE_POLICY_DISABLED)));
    }
    addr = address_of_(owner, $c);
    if (!$c.exists(new SimpleStructTag(PackageRegistry), $.copy(addr))) {
        $c.move_to(new SimpleStructTag(PackageRegistry), owner, new PackageRegistry({ packages: empty_$5($c, [new SimpleStructTag(PackageMetadata)]) }, new SimpleStructTag(PackageRegistry)));
    }
    allowed_deps = check_dependencies_($.copy(addr), pack, $c);
    module_names = get_module_names_(pack, $c);
    packages = $c.borrow_global_mut(new SimpleStructTag(PackageRegistry), $.copy(addr)).packages;
    len = length_$6(packages, $c, [new SimpleStructTag(PackageMetadata)]);
    index = $.copy(len);
    i = u64('0');
    upgrade_number = u64('0');
    while ($.copy(i).lt($.copy(len))) {
        {
            [temp$2, temp$3] = [packages, $.copy(i)];
            old = borrow_$7(temp$2, temp$3, $c, [new SimpleStructTag(PackageMetadata)]);
            if ($.deep_eq($.copy(old.name), $.copy(pack.name))) {
                upgrade_number = $.copy(old.upgrade_number).add(u64('1'));
                check_upgradability_(old, pack, module_names, $c);
                index = $.copy(i);
            }
            else {
                check_coexistence_(old, module_names, $c);
            }
            i = $.copy(i).add(u64('1'));
        }
    }
    pack.upgrade_number = $.copy(upgrade_number);
    policy = $.copy(pack.upgrade_policy);
    if ($.copy(index).lt($.copy(len))) {
        $.set(borrow_mut_$7(packages, $.copy(index), $c, [new SimpleStructTag(PackageMetadata)]), pack);
    }
    else {
        push_back_(packages, pack, $c, [new SimpleStructTag(PackageMetadata)]);
    }
    if (code_dependency_check_enabled_($c)) {
        request_publish_with_allowed_deps_($.copy(addr), $.copy(module_names), allowed_deps, $.copy(code), $.copy(policy.policy), $c);
    }
    else {
        request_publish_($.copy(addr), $.copy(module_names), $.copy(code), $.copy(policy.policy), $c);
    }
    return;
}
function publish_package_txn_(owner, metadata_serialized, code, $c) {
    return publish_package_(owner, from_bytes_($.copy(metadata_serialized), $c, [new SimpleStructTag(PackageMetadata)]), $.copy(code), $c);
}
function buildPayload_publish_package_txn(metadata_serialized, code, isJSON = false) {
    const typeParamStrings = [];
    return $.buildPayload(new HexString('0x1'), 'code', 'publish_package_txn', typeParamStrings, [metadata_serialized, code], isJSON);
}
function request_publish_(owner, expected_modules, bundle, policy, $c) {
    return $.aptos_framework_code_request_publish(owner, expected_modules, bundle, policy, $c);
}
function request_publish_with_allowed_deps_(owner, expected_modules, allowed_deps, bundle, policy, $c) {
    return $.aptos_framework_code_request_publish_with_allowed_deps(owner, expected_modules, allowed_deps, bundle, policy, $c);
}
function upgrade_policy_arbitrary_($c) {
    return new UpgradePolicy({ policy: u8('0') }, new SimpleStructTag(UpgradePolicy));
}
function upgrade_policy_compat_($c) {
    return new UpgradePolicy({ policy: u8('1') }, new SimpleStructTag(UpgradePolicy));
}
function upgrade_policy_immutable_($c) {
    return new UpgradePolicy({ policy: u8('2') }, new SimpleStructTag(UpgradePolicy));
}
function loadParsers$_(repo) {
    repo.addParser('0x1::code::AllowedDep', AllowedDep.AllowedDepParser);
    repo.addParser('0x1::code::ModuleMetadata', ModuleMetadata.ModuleMetadataParser);
    repo.addParser('0x1::code::PackageDep', PackageDep.PackageDepParser);
    repo.addParser('0x1::code::PackageMetadata', PackageMetadata.PackageMetadataParser);
    repo.addParser('0x1::code::PackageRegistry', PackageRegistry.PackageRegistryParser);
    repo.addParser('0x1::code::UpgradePolicy', UpgradePolicy.UpgradePolicyParser);
}
class App$$ {
    constructor(client, repo, cache) {
        this.client = client;
        this.repo = repo;
        this.cache = cache;
    }
    get moduleAddress() {
        {
            return moduleAddress$N;
        }
    }
    get moduleName() {
        {
            return moduleName$N;
        }
    }
    get AllowedDep() {
        return AllowedDep;
    }
    get ModuleMetadata() {
        return ModuleMetadata;
    }
    get PackageDep() {
        return PackageDep;
    }
    get PackageMetadata() {
        return PackageMetadata;
    }
    get PackageRegistry() {
        return PackageRegistry;
    }
    loadPackageRegistry(owner, loadFull = true, fillCache = true) {
        return __awaiter(this, void 0, void 0, function* () {
            const val = yield PackageRegistry.load(this.repo, this.client, owner, []);
            if (loadFull) {
                yield val.loadFullState(this);
            }
            if (fillCache) {
                this.cache.set(val.typeTag, owner, val);
            }
            return val;
        });
    }
    get UpgradePolicy() {
        return UpgradePolicy;
    }
    payload_publish_package_txn(metadata_serialized, code, isJSON = false) {
        return buildPayload_publish_package_txn(metadata_serialized, code, isJSON);
    }
    publish_package_txn(_account, metadata_serialized, code, option, _isJSON = false) {
        return __awaiter(this, void 0, void 0, function* () {
            const payload__ = buildPayload_publish_package_txn(metadata_serialized, code, _isJSON);
            return $.sendPayloadTx(this.client, _account, payload__, option);
        });
    }
}

var Code = /*#__PURE__*/Object.freeze({
    __proto__: null,
    packageName: packageName$N,
    moduleAddress: moduleAddress$N,
    moduleName: moduleName$N,
    EDEP_ARBITRARY_NOT_SAME_ADDRESS: EDEP_ARBITRARY_NOT_SAME_ADDRESS,
    EDEP_WEAKER_POLICY: EDEP_WEAKER_POLICY,
    EINCOMPATIBLE_POLICY_DISABLED: EINCOMPATIBLE_POLICY_DISABLED,
    EMODULE_MISSING: EMODULE_MISSING,
    EMODULE_NAME_CLASH: EMODULE_NAME_CLASH,
    EPACKAGE_DEP_MISSING: EPACKAGE_DEP_MISSING,
    EUPGRADE_IMMUTABLE: EUPGRADE_IMMUTABLE,
    EUPGRADE_WEAKER_POLICY: EUPGRADE_WEAKER_POLICY,
    AllowedDep: AllowedDep,
    ModuleMetadata: ModuleMetadata,
    PackageDep: PackageDep,
    PackageMetadata: PackageMetadata,
    PackageRegistry: PackageRegistry,
    UpgradePolicy: UpgradePolicy,
    can_change_upgrade_policy_to_: can_change_upgrade_policy_to_,
    check_coexistence_: check_coexistence_,
    check_dependencies_: check_dependencies_,
    check_upgradability_: check_upgradability_,
    get_module_names_: get_module_names_,
    initialize_: initialize_$9,
    is_policy_exempted_address_: is_policy_exempted_address_,
    publish_package_: publish_package_,
    publish_package_txn_: publish_package_txn_,
    buildPayload_publish_package_txn: buildPayload_publish_package_txn,
    request_publish_: request_publish_,
    request_publish_with_allowed_deps_: request_publish_with_allowed_deps_,
    upgrade_policy_arbitrary_: upgrade_policy_arbitrary_,
    upgrade_policy_compat_: upgrade_policy_compat_,
    upgrade_policy_immutable_: upgrade_policy_immutable_,
    loadParsers: loadParsers$_,
    App: App$$
});

const packageName$M = 'AptosFramework';
const moduleAddress$M = new HexString('0x1');
const moduleName$M = 'consensus_config';
const EINVALID_CONFIG = u64('1');
class ConsensusConfig {
    constructor(proto, typeTag) {
        this.typeTag = typeTag;
        this.__app = null;
        this.config = proto['config'];
    }
    static ConsensusConfigParser(data, typeTag, repo) {
        const proto = $.parseStructProto(data, typeTag, repo, ConsensusConfig);
        return new ConsensusConfig(proto, typeTag);
    }
    static load(repo, client, address, typeParams) {
        return __awaiter(this, void 0, void 0, function* () {
            const result = yield repo.loadResource(client, address, ConsensusConfig, typeParams);
            return result;
        });
    }
    static loadByApp(app, address, typeParams) {
        return __awaiter(this, void 0, void 0, function* () {
            const result = yield app.repo.loadResource(app.client, address, ConsensusConfig, typeParams);
            yield result.loadFullState(app);
            return result;
        });
    }
    static getTag() {
        return new StructTag(moduleAddress$M, moduleName$M, 'ConsensusConfig', []);
    }
    loadFullState(app) {
        return __awaiter(this, void 0, void 0, function* () {
            this.__app = app;
        });
    }
}
ConsensusConfig.moduleAddress = moduleAddress$M;
ConsensusConfig.moduleName = moduleName$M;
ConsensusConfig.structName = 'ConsensusConfig';
ConsensusConfig.typeParameters = [];
ConsensusConfig.fields = [{ name: 'config', typeTag: new VectorTag(AtomicTypeTag.U8) }];
function initialize_$8(aptos_framework, config, $c) {
    assert_aptos_framework_(aptos_framework, $c);
    if (!length_$6(config, $c, [AtomicTypeTag.U8]).gt(u64('0'))) {
        throw $.abortCode(invalid_argument_($.copy(EINVALID_CONFIG)));
    }
    $c.move_to(new SimpleStructTag(ConsensusConfig), aptos_framework, new ConsensusConfig({ config: $.copy(config) }, new SimpleStructTag(ConsensusConfig)));
    return;
}
function set_(account, config, $c) {
    let config_ref;
    assert_aptos_framework_(account, $c);
    if (!length_$6(config, $c, [AtomicTypeTag.U8]).gt(u64('0'))) {
        throw $.abortCode(invalid_argument_($.copy(EINVALID_CONFIG)));
    }
    config_ref = $c.borrow_global_mut(new SimpleStructTag(ConsensusConfig), new HexString('0x1')).config;
    $.set(config_ref, $.copy(config));
    reconfigure_$1($c);
    return;
}
function loadParsers$Z(repo) {
    repo.addParser('0x1::consensus_config::ConsensusConfig', ConsensusConfig.ConsensusConfigParser);
}
class App$_ {
    constructor(client, repo, cache) {
        this.client = client;
        this.repo = repo;
        this.cache = cache;
    }
    get moduleAddress() {
        {
            return moduleAddress$M;
        }
    }
    get moduleName() {
        {
            return moduleName$M;
        }
    }
    get ConsensusConfig() {
        return ConsensusConfig;
    }
    loadConsensusConfig(owner, loadFull = true, fillCache = true) {
        return __awaiter(this, void 0, void 0, function* () {
            const val = yield ConsensusConfig.load(this.repo, this.client, owner, []);
            if (loadFull) {
                yield val.loadFullState(this);
            }
            if (fillCache) {
                this.cache.set(val.typeTag, owner, val);
            }
            return val;
        });
    }
}

var Consensus_config = /*#__PURE__*/Object.freeze({
    __proto__: null,
    packageName: packageName$M,
    moduleAddress: moduleAddress$M,
    moduleName: moduleName$M,
    EINVALID_CONFIG: EINVALID_CONFIG,
    ConsensusConfig: ConsensusConfig,
    initialize_: initialize_$8,
    set_: set_,
    loadParsers: loadParsers$Z,
    App: App$_
});

const packageName$L = 'AptosStdlib';
const moduleAddress$L = new HexString('0x1');
const moduleName$L = 'copyable_any';
const ETYPE_MISMATCH = u64('0');
class Any {
    constructor(proto, typeTag) {
        this.typeTag = typeTag;
        this.__app = null;
        this.type_name = proto['type_name'];
        this.data = proto['data'];
    }
    static AnyParser(data, typeTag, repo) {
        const proto = $.parseStructProto(data, typeTag, repo, Any);
        return new Any(proto, typeTag);
    }
    static getTag() {
        return new StructTag(moduleAddress$L, moduleName$L, 'Any', []);
    }
    loadFullState(app) {
        return __awaiter(this, void 0, void 0, function* () {
            yield this.type_name.loadFullState(app);
            this.__app = app;
        });
    }
}
Any.moduleAddress = moduleAddress$L;
Any.moduleName = moduleName$L;
Any.structName = 'Any';
Any.typeParameters = [];
Any.fields = [
    { name: 'type_name', typeTag: new StructTag(new HexString('0x1'), 'string', 'String', []) },
    { name: 'data', typeTag: new VectorTag(AtomicTypeTag.U8) }
];
function pack_(x, $c, $p /* <T>*/) {
    return new Any({ type_name: type_name_$2($c, [$p[0]]), data: to_bytes_(x, $c, [$p[0]]) }, new SimpleStructTag(Any));
}
function type_name_(x, $c) {
    return x.type_name;
}
function unpack_(x, $c, $p /* <T>*/) {
    if (!$.deep_eq(type_name_$2($c, [$p[0]]), $.copy(x.type_name))) {
        throw $.abortCode(invalid_argument_($.copy(ETYPE_MISMATCH)));
    }
    return from_bytes_$1($.copy(x.data), $c, [$p[0]]);
}
function loadParsers$Y(repo) {
    repo.addParser('0x1::copyable_any::Any', Any.AnyParser);
}
class App$Z {
    constructor(client, repo, cache) {
        this.client = client;
        this.repo = repo;
        this.cache = cache;
    }
    get moduleAddress() {
        {
            return moduleAddress$L;
        }
    }
    get moduleName() {
        {
            return moduleName$L;
        }
    }
    get Any() {
        return Any;
    }
}

var Copyable_any = /*#__PURE__*/Object.freeze({
    __proto__: null,
    packageName: packageName$L,
    moduleAddress: moduleAddress$L,
    moduleName: moduleName$L,
    ETYPE_MISMATCH: ETYPE_MISMATCH,
    Any: Any,
    pack_: pack_,
    type_name_: type_name_,
    unpack_: unpack_,
    loadParsers: loadParsers$Y,
    App: App$Z
});

const packageName$K = 'AptosStdlib';
const moduleAddress$K = new HexString('0x1');
const moduleName$K = 'debug';
function print_(x, $c, $p /* <T>*/) {
    return $.aptos_std_debug_print(x, $c, [$p[0]]);
}
function print_stack_trace_($c) {
    return $.aptos_std_debug_print_stack_trace($c);
}
function loadParsers$X(repo) { }
class App$Y {
    constructor(client, repo, cache) {
        this.client = client;
        this.repo = repo;
        this.cache = cache;
    }
    get moduleAddress() {
        {
            return moduleAddress$K;
        }
    }
    get moduleName() {
        {
            return moduleName$K;
        }
    }
}

var Debug = /*#__PURE__*/Object.freeze({
    __proto__: null,
    packageName: packageName$K,
    moduleAddress: moduleAddress$K,
    moduleName: moduleName$K,
    print_: print_,
    print_stack_trace_: print_stack_trace_,
    loadParsers: loadParsers$X,
    App: App$Y
});

const packageName$J = 'MoveStdlib';
const moduleAddress$J = new HexString('0x1');
const moduleName$J = 'fixed_point32';
const EDENOMINATOR = u64('65537');
const EDIVISION = u64('131074');
const EDIVISION_BY_ZERO = u64('65540');
const EMULTIPLICATION = u64('131075');
const ERATIO_OUT_OF_RANGE = u64('131077');
const MAX_U64$2 = u128('18446744073709551615');
class FixedPoint32 {
    constructor(proto, typeTag) {
        this.typeTag = typeTag;
        this.__app = null;
        this.value = proto['value'];
    }
    static FixedPoint32Parser(data, typeTag, repo) {
        const proto = $.parseStructProto(data, typeTag, repo, FixedPoint32);
        return new FixedPoint32(proto, typeTag);
    }
    static getTag() {
        return new StructTag(moduleAddress$J, moduleName$J, 'FixedPoint32', []);
    }
    loadFullState(app) {
        return __awaiter(this, void 0, void 0, function* () {
            this.__app = app;
        });
    }
}
FixedPoint32.moduleAddress = moduleAddress$J;
FixedPoint32.moduleName = moduleName$J;
FixedPoint32.structName = 'FixedPoint32';
FixedPoint32.typeParameters = [];
FixedPoint32.fields = [{ name: 'value', typeTag: AtomicTypeTag.U64 }];
function create_from_rational_(numerator, denominator, $c) {
    let temp$1, quotient, scaled_denominator, scaled_numerator;
    scaled_numerator = u128($.copy(numerator)).shl(u8('64'));
    scaled_denominator = u128($.copy(denominator)).shl(u8('32'));
    if (!$.copy(scaled_denominator).neq(u128('0'))) {
        throw $.abortCode($.copy(EDENOMINATOR));
    }
    quotient = $.copy(scaled_numerator).div($.copy(scaled_denominator));
    if ($.copy(quotient).neq(u128('0'))) {
        temp$1 = true;
    }
    else {
        temp$1 = $.copy(numerator).eq(u64('0'));
    }
    if (!temp$1) {
        throw $.abortCode($.copy(ERATIO_OUT_OF_RANGE));
    }
    if (!$.copy(quotient).le($.copy(MAX_U64$2))) {
        throw $.abortCode($.copy(ERATIO_OUT_OF_RANGE));
    }
    return new FixedPoint32({ value: u64($.copy(quotient)) }, new SimpleStructTag(FixedPoint32));
}
function create_from_raw_value_(value, $c) {
    return new FixedPoint32({ value: $.copy(value) }, new SimpleStructTag(FixedPoint32));
}
function divide_u64_(val, divisor, $c) {
    let quotient, scaled_value;
    if (!$.copy(divisor.value).neq(u64('0'))) {
        throw $.abortCode($.copy(EDIVISION_BY_ZERO));
    }
    scaled_value = u128($.copy(val)).shl(u8('32'));
    quotient = $.copy(scaled_value).div(u128($.copy(divisor.value)));
    if (!$.copy(quotient).le($.copy(MAX_U64$2))) {
        throw $.abortCode($.copy(EDIVISION));
    }
    return u64($.copy(quotient));
}
function get_raw_value_(num, $c) {
    return $.copy(num.value);
}
function is_zero_$1(num, $c) {
    return $.copy(num.value).eq(u64('0'));
}
function multiply_u64_(val, multiplier, $c) {
    let product, unscaled_product;
    unscaled_product = u128($.copy(val)).mul(u128($.copy(multiplier.value)));
    product = $.copy(unscaled_product).shr(u8('32'));
    if (!$.copy(product).le($.copy(MAX_U64$2))) {
        throw $.abortCode($.copy(EMULTIPLICATION));
    }
    return u64($.copy(product));
}
function loadParsers$W(repo) {
    repo.addParser('0x1::fixed_point32::FixedPoint32', FixedPoint32.FixedPoint32Parser);
}
class App$X {
    constructor(client, repo, cache) {
        this.client = client;
        this.repo = repo;
        this.cache = cache;
    }
    get moduleAddress() {
        {
            return moduleAddress$J;
        }
    }
    get moduleName() {
        {
            return moduleName$J;
        }
    }
    get FixedPoint32() {
        return FixedPoint32;
    }
}

var Fixed_point32 = /*#__PURE__*/Object.freeze({
    __proto__: null,
    packageName: packageName$J,
    moduleAddress: moduleAddress$J,
    moduleName: moduleName$J,
    EDENOMINATOR: EDENOMINATOR,
    EDIVISION: EDIVISION,
    EDIVISION_BY_ZERO: EDIVISION_BY_ZERO,
    EMULTIPLICATION: EMULTIPLICATION,
    ERATIO_OUT_OF_RANGE: ERATIO_OUT_OF_RANGE,
    MAX_U64: MAX_U64$2,
    FixedPoint32: FixedPoint32,
    create_from_rational_: create_from_rational_,
    create_from_raw_value_: create_from_raw_value_,
    divide_u64_: divide_u64_,
    get_raw_value_: get_raw_value_,
    is_zero_: is_zero_$1,
    multiply_u64_: multiply_u64_,
    loadParsers: loadParsers$W,
    App: App$X
});

const packageName$I = 'AptosFramework';
const moduleAddress$I = new HexString('0x1');
const moduleName$I = 'gas_schedule';
const EINVALID_GAS_FEATURE_VERSION = u64('2');
const EINVALID_GAS_SCHEDULE = u64('1');
class GasEntry {
    constructor(proto, typeTag) {
        this.typeTag = typeTag;
        this.__app = null;
        this.key = proto['key'];
        this.val = proto['val'];
    }
    static GasEntryParser(data, typeTag, repo) {
        const proto = $.parseStructProto(data, typeTag, repo, GasEntry);
        return new GasEntry(proto, typeTag);
    }
    static getTag() {
        return new StructTag(moduleAddress$I, moduleName$I, 'GasEntry', []);
    }
    loadFullState(app) {
        return __awaiter(this, void 0, void 0, function* () {
            yield this.key.loadFullState(app);
            this.__app = app;
        });
    }
}
GasEntry.moduleAddress = moduleAddress$I;
GasEntry.moduleName = moduleName$I;
GasEntry.structName = 'GasEntry';
GasEntry.typeParameters = [];
GasEntry.fields = [
    { name: 'key', typeTag: new StructTag(new HexString('0x1'), 'string', 'String', []) },
    { name: 'val', typeTag: AtomicTypeTag.U64 }
];
class GasSchedule {
    constructor(proto, typeTag) {
        this.typeTag = typeTag;
        this.__app = null;
        this.entries = proto['entries'];
    }
    static GasScheduleParser(data, typeTag, repo) {
        const proto = $.parseStructProto(data, typeTag, repo, GasSchedule);
        return new GasSchedule(proto, typeTag);
    }
    static load(repo, client, address, typeParams) {
        return __awaiter(this, void 0, void 0, function* () {
            const result = yield repo.loadResource(client, address, GasSchedule, typeParams);
            return result;
        });
    }
    static loadByApp(app, address, typeParams) {
        return __awaiter(this, void 0, void 0, function* () {
            const result = yield app.repo.loadResource(app.client, address, GasSchedule, typeParams);
            yield result.loadFullState(app);
            return result;
        });
    }
    static getTag() {
        return new StructTag(moduleAddress$I, moduleName$I, 'GasSchedule', []);
    }
    loadFullState(app) {
        return __awaiter(this, void 0, void 0, function* () {
            this.__app = app;
        });
    }
}
GasSchedule.moduleAddress = moduleAddress$I;
GasSchedule.moduleName = moduleName$I;
GasSchedule.structName = 'GasSchedule';
GasSchedule.typeParameters = [];
GasSchedule.fields = [
    { name: 'entries', typeTag: new VectorTag(new StructTag(new HexString('0x1'), 'gas_schedule', 'GasEntry', [])) }
];
class GasScheduleV2 {
    constructor(proto, typeTag) {
        this.typeTag = typeTag;
        this.__app = null;
        this.feature_version = proto['feature_version'];
        this.entries = proto['entries'];
    }
    static GasScheduleV2Parser(data, typeTag, repo) {
        const proto = $.parseStructProto(data, typeTag, repo, GasScheduleV2);
        return new GasScheduleV2(proto, typeTag);
    }
    static load(repo, client, address, typeParams) {
        return __awaiter(this, void 0, void 0, function* () {
            const result = yield repo.loadResource(client, address, GasScheduleV2, typeParams);
            return result;
        });
    }
    static loadByApp(app, address, typeParams) {
        return __awaiter(this, void 0, void 0, function* () {
            const result = yield app.repo.loadResource(app.client, address, GasScheduleV2, typeParams);
            yield result.loadFullState(app);
            return result;
        });
    }
    static getTag() {
        return new StructTag(moduleAddress$I, moduleName$I, 'GasScheduleV2', []);
    }
    loadFullState(app) {
        return __awaiter(this, void 0, void 0, function* () {
            this.__app = app;
        });
    }
}
GasScheduleV2.moduleAddress = moduleAddress$I;
GasScheduleV2.moduleName = moduleName$I;
GasScheduleV2.structName = 'GasScheduleV2';
GasScheduleV2.typeParameters = [];
GasScheduleV2.fields = [
    { name: 'feature_version', typeTag: AtomicTypeTag.U64 },
    { name: 'entries', typeTag: new VectorTag(new StructTag(new HexString('0x1'), 'gas_schedule', 'GasEntry', [])) }
];
function initialize_$7(aptos_framework, gas_schedule_blob, $c) {
    let gas_schedule;
    assert_aptos_framework_(aptos_framework, $c);
    if (!!is_empty_$2(gas_schedule_blob, $c, [AtomicTypeTag.U8])) {
        throw $.abortCode(invalid_argument_($.copy(EINVALID_GAS_SCHEDULE)));
    }
    gas_schedule = from_bytes_($.copy(gas_schedule_blob), $c, [new SimpleStructTag(GasScheduleV2)]);
    $c.move_to(new SimpleStructTag(GasScheduleV2), aptos_framework, $.copy(gas_schedule));
    return;
}
function set_gas_schedule_(aptos_framework, gas_schedule_blob, $c) {
    let gas_schedule, new_gas_schedule, new_gas_schedule__1;
    assert_aptos_framework_(aptos_framework, $c);
    if (!!is_empty_$2(gas_schedule_blob, $c, [AtomicTypeTag.U8])) {
        throw $.abortCode(invalid_argument_($.copy(EINVALID_GAS_SCHEDULE)));
    }
    if ($c.exists(new SimpleStructTag(GasScheduleV2), new HexString('0x1'))) {
        gas_schedule = $c.borrow_global_mut(new SimpleStructTag(GasScheduleV2), new HexString('0x1'));
        new_gas_schedule = from_bytes_($.copy(gas_schedule_blob), $c, [new SimpleStructTag(GasScheduleV2)]);
        if (!$.copy(new_gas_schedule.feature_version).ge($.copy(gas_schedule.feature_version))) {
            throw $.abortCode(invalid_argument_($.copy(EINVALID_GAS_FEATURE_VERSION)));
        }
        $.set(gas_schedule, $.copy(new_gas_schedule));
    }
    else {
        if ($c.exists(new SimpleStructTag(GasSchedule), new HexString('0x1'))) {
            $c.move_from(new SimpleStructTag(GasSchedule), new HexString('0x1'));
        }
        new_gas_schedule__1 = from_bytes_($.copy(gas_schedule_blob), $c, [new SimpleStructTag(GasScheduleV2)]);
        $c.move_to(new SimpleStructTag(GasScheduleV2), aptos_framework, $.copy(new_gas_schedule__1));
    }
    reconfigure_$1($c);
    return;
}
function set_storage_gas_config_(aptos_framework, config, $c) {
    set_config_(aptos_framework, $.copy(config), $c);
    reconfigure_$1($c);
    return;
}
function loadParsers$V(repo) {
    repo.addParser('0x1::gas_schedule::GasEntry', GasEntry.GasEntryParser);
    repo.addParser('0x1::gas_schedule::GasSchedule', GasSchedule.GasScheduleParser);
    repo.addParser('0x1::gas_schedule::GasScheduleV2', GasScheduleV2.GasScheduleV2Parser);
}
class App$W {
    constructor(client, repo, cache) {
        this.client = client;
        this.repo = repo;
        this.cache = cache;
    }
    get moduleAddress() {
        {
            return moduleAddress$I;
        }
    }
    get moduleName() {
        {
            return moduleName$I;
        }
    }
    get GasEntry() {
        return GasEntry;
    }
    get GasSchedule() {
        return GasSchedule;
    }
    loadGasSchedule(owner, loadFull = true, fillCache = true) {
        return __awaiter(this, void 0, void 0, function* () {
            const val = yield GasSchedule.load(this.repo, this.client, owner, []);
            if (loadFull) {
                yield val.loadFullState(this);
            }
            if (fillCache) {
                this.cache.set(val.typeTag, owner, val);
            }
            return val;
        });
    }
    get GasScheduleV2() {
        return GasScheduleV2;
    }
    loadGasScheduleV2(owner, loadFull = true, fillCache = true) {
        return __awaiter(this, void 0, void 0, function* () {
            const val = yield GasScheduleV2.load(this.repo, this.client, owner, []);
            if (loadFull) {
                yield val.loadFullState(this);
            }
            if (fillCache) {
                this.cache.set(val.typeTag, owner, val);
            }
            return val;
        });
    }
}

var Gas_schedule = /*#__PURE__*/Object.freeze({
    __proto__: null,
    packageName: packageName$I,
    moduleAddress: moduleAddress$I,
    moduleName: moduleName$I,
    EINVALID_GAS_FEATURE_VERSION: EINVALID_GAS_FEATURE_VERSION,
    EINVALID_GAS_SCHEDULE: EINVALID_GAS_SCHEDULE,
    GasEntry: GasEntry,
    GasSchedule: GasSchedule,
    GasScheduleV2: GasScheduleV2,
    initialize_: initialize_$7,
    set_gas_schedule_: set_gas_schedule_,
    set_storage_gas_config_: set_storage_gas_config_,
    loadParsers: loadParsers$V,
    App: App$W
});

const packageName$H = 'AptosStdlib';
const moduleAddress$H = new HexString('0x1');
const moduleName$H = 'pool_u64';
const EINSUFFICIENT_SHARES = u64('4');
const EPOOL_IS_NOT_EMPTY = u64('3');
const EPOOL_TOTAL_COINS_OVERFLOW = u64('6');
const EPOOL_TOTAL_SHARES_OVERFLOW = u64('7');
const ESHAREHOLDER_NOT_FOUND = u64('1');
const ESHAREHOLDER_SHARES_OVERFLOW = u64('5');
const ETOO_MANY_SHAREHOLDERS = u64('2');
const MAX_U64$1 = u64('18446744073709551615');
class Pool$2 {
    constructor(proto, typeTag) {
        this.typeTag = typeTag;
        this.__app = null;
        this.shareholders_limit = proto['shareholders_limit'];
        this.total_coins = proto['total_coins'];
        this.total_shares = proto['total_shares'];
        this.shares = proto['shares'];
        this.shareholders = proto['shareholders'];
        this.scaling_factor = proto['scaling_factor'];
    }
    static PoolParser(data, typeTag, repo) {
        const proto = $.parseStructProto(data, typeTag, repo, Pool$2);
        return new Pool$2(proto, typeTag);
    }
    static getTag() {
        return new StructTag(moduleAddress$H, moduleName$H, 'Pool', []);
    }
    loadFullState(app) {
        return __awaiter(this, void 0, void 0, function* () {
            yield this.shares.loadFullState(app);
            this.__app = app;
        });
    }
}
Pool$2.moduleAddress = moduleAddress$H;
Pool$2.moduleName = moduleName$H;
Pool$2.structName = 'Pool';
Pool$2.typeParameters = [];
Pool$2.fields = [
    { name: 'shareholders_limit', typeTag: AtomicTypeTag.U64 },
    { name: 'total_coins', typeTag: AtomicTypeTag.U64 },
    { name: 'total_shares', typeTag: AtomicTypeTag.U64 },
    {
        name: 'shares',
        typeTag: new StructTag(new HexString('0x1'), 'simple_map', 'SimpleMap', [
            AtomicTypeTag.Address,
            AtomicTypeTag.U64
        ])
    },
    { name: 'shareholders', typeTag: new VectorTag(AtomicTypeTag.Address) },
    { name: 'scaling_factor', typeTag: AtomicTypeTag.U64 }
];
function add_shares_(pool, shareholder, new_shares, $c) {
    let temp$1, temp$2, temp$3, temp$4, current_shares, existing_shares;
    [temp$1, temp$2] = [pool, $.copy(shareholder)];
    if (contains_$3(temp$1, temp$2, $c)) {
        existing_shares = borrow_mut_$4(pool.shares, shareholder, $c, [AtomicTypeTag.Address, AtomicTypeTag.U64]);
        current_shares = $.copy(existing_shares);
        if (!$.copy(MAX_U64$1).sub($.copy(current_shares)).ge($.copy(new_shares))) {
            throw $.abortCode(invalid_argument_($.copy(ESHAREHOLDER_SHARES_OVERFLOW)));
        }
        $.set(existing_shares, $.copy(current_shares).add($.copy(new_shares)));
        temp$4 = $.copy(existing_shares);
    }
    else {
        if ($.copy(new_shares).gt(u64('0'))) {
            if (!length_$6(pool.shareholders, $c, [AtomicTypeTag.Address]).lt($.copy(pool.shareholders_limit))) {
                throw $.abortCode(invalid_state_($.copy(ETOO_MANY_SHAREHOLDERS)));
            }
            push_back_(pool.shareholders, $.copy(shareholder), $c, [AtomicTypeTag.Address]);
            add_$4(pool.shares, $.copy(shareholder), $.copy(new_shares), $c, [
                AtomicTypeTag.Address,
                AtomicTypeTag.U64
            ]);
            temp$3 = $.copy(new_shares);
        }
        else {
            temp$3 = $.copy(new_shares);
        }
        temp$4 = temp$3;
    }
    return temp$4;
}
function amount_to_shares_(pool, coins_amount, $c) {
    return amount_to_shares_with_total_coins_(pool, $.copy(coins_amount), $.copy(pool.total_coins));
}
function amount_to_shares_with_total_coins_(pool, coins_amount, total_coins, $c) {
    let temp$1, temp$2;
    if ($.copy(pool.total_coins).eq(u64('0'))) {
        temp$1 = true;
    }
    else {
        temp$1 = $.copy(pool.total_shares).eq(u64('0'));
    }
    if (temp$1) {
        temp$2 = $.copy(coins_amount).mul($.copy(pool.scaling_factor));
    }
    else {
        temp$2 = multiply_then_divide_(pool, $.copy(coins_amount), $.copy(pool.total_shares), $.copy(total_coins));
    }
    return temp$2;
}
function balance_(pool, shareholder, $c) {
    let num_shares;
    num_shares = shares_(pool, $.copy(shareholder), $c);
    return shares_to_amount_(pool, $.copy(num_shares));
}
function buy_in_(pool, shareholder, coins_amount, $c) {
    let temp$1, temp$2, new_shares;
    if ($.copy(coins_amount).eq(u64('0'))) {
        return u64('0');
    }
    [temp$1, temp$2] = [pool, $.copy(coins_amount)];
    new_shares = amount_to_shares_(temp$1, temp$2);
    if (!$.copy(MAX_U64$1).sub($.copy(pool.total_coins)).ge($.copy(coins_amount))) {
        throw $.abortCode(invalid_argument_($.copy(EPOOL_TOTAL_COINS_OVERFLOW)));
    }
    if (!$.copy(MAX_U64$1).sub($.copy(pool.total_shares)).ge($.copy(new_shares))) {
        throw $.abortCode(invalid_argument_($.copy(EPOOL_TOTAL_COINS_OVERFLOW)));
    }
    pool.total_coins = $.copy(pool.total_coins).add($.copy(coins_amount));
    pool.total_shares = $.copy(pool.total_shares).add($.copy(new_shares));
    add_shares_(pool, $.copy(shareholder), $.copy(new_shares), $c);
    return $.copy(new_shares);
}
function contains_$3(pool, shareholder, $c) {
    return contains_key_(pool.shares, shareholder, $c, [AtomicTypeTag.Address, AtomicTypeTag.U64]);
}
function create_(shareholders_limit, $c) {
    return create_with_scaling_factor_($.copy(shareholders_limit), u64('1'), $c);
}
function create_with_scaling_factor_(shareholders_limit, scaling_factor, $c) {
    return new Pool$2({
        shareholders_limit: $.copy(shareholders_limit),
        total_coins: u64('0'),
        total_shares: u64('0'),
        shares: create_$2($c, [AtomicTypeTag.Address, AtomicTypeTag.U64]),
        shareholders: empty_$5($c, [AtomicTypeTag.Address]),
        scaling_factor: $.copy(scaling_factor)
    }, new SimpleStructTag(Pool$2));
}
function deduct_shares_(pool, shareholder, num_shares, $c) {
    let temp$1, temp$2, temp$3, temp$4, existing_shares, remaining_shares, shareholder_index;
    [temp$1, temp$2] = [pool, $.copy(shareholder)];
    if (!contains_$3(temp$1, temp$2, $c)) {
        throw $.abortCode(invalid_argument_($.copy(ESHAREHOLDER_NOT_FOUND)));
    }
    [temp$3, temp$4] = [pool, $.copy(shareholder)];
    if (!shares_(temp$3, temp$4, $c).ge($.copy(num_shares))) {
        throw $.abortCode(invalid_argument_($.copy(EINSUFFICIENT_SHARES)));
    }
    existing_shares = borrow_mut_$4(pool.shares, shareholder, $c, [AtomicTypeTag.Address, AtomicTypeTag.U64]);
    $.set(existing_shares, $.copy(existing_shares).sub($.copy(num_shares)));
    remaining_shares = $.copy(existing_shares);
    if ($.copy(remaining_shares).eq(u64('0'))) {
        [, shareholder_index] = index_of_$1(pool.shareholders, shareholder, $c, [AtomicTypeTag.Address]);
        remove_$5(pool.shareholders, $.copy(shareholder_index), $c, [AtomicTypeTag.Address]);
        remove_$2(pool.shares, shareholder, $c, [AtomicTypeTag.Address, AtomicTypeTag.U64]);
    }
    return $.copy(remaining_shares);
}
function destroy_empty_$3(pool, $c) {
    if (!$.copy(pool.total_coins).eq(u64('0'))) {
        throw $.abortCode(invalid_state_($.copy(EPOOL_IS_NOT_EMPTY)));
    }
    return;
}
function multiply_then_divide_(_pool, x, y, z, $c) {
    let result;
    result = to_u128_$1($.copy(x))
        .mul(to_u128_$1($.copy(y)))
        .div(to_u128_$1($.copy(z)));
    return u64($.copy(result));
}
function redeem_shares_(pool, shareholder, shares_to_redeem, $c) {
    let temp$1, temp$2, temp$3, temp$4, temp$5, temp$6, redeemed_coins;
    [temp$1, temp$2] = [pool, $.copy(shareholder)];
    if (!contains_$3(temp$1, temp$2, $c)) {
        throw $.abortCode(invalid_argument_($.copy(ESHAREHOLDER_NOT_FOUND)));
    }
    [temp$3, temp$4] = [pool, $.copy(shareholder)];
    if (!shares_(temp$3, temp$4, $c).ge($.copy(shares_to_redeem))) {
        throw $.abortCode(invalid_argument_($.copy(EINSUFFICIENT_SHARES)));
    }
    if ($.copy(shares_to_redeem).eq(u64('0'))) {
        return u64('0');
    }
    [temp$5, temp$6] = [pool, $.copy(shares_to_redeem)];
    redeemed_coins = shares_to_amount_(temp$5, temp$6);
    pool.total_coins = $.copy(pool.total_coins).sub($.copy(redeemed_coins));
    pool.total_shares = $.copy(pool.total_shares).sub($.copy(shares_to_redeem));
    deduct_shares_(pool, $.copy(shareholder), $.copy(shares_to_redeem), $c);
    return $.copy(redeemed_coins);
}
function shareholders_(pool, $c) {
    return $.copy(pool.shareholders);
}
function shareholders_count_(pool, $c) {
    return length_$6(pool.shareholders, $c, [AtomicTypeTag.Address]);
}
function shares_(pool, shareholder, $c) {
    let temp$1;
    if (contains_$3(pool, $.copy(shareholder), $c)) {
        temp$1 = $.copy(borrow_$4(pool.shares, shareholder, $c, [AtomicTypeTag.Address, AtomicTypeTag.U64]));
    }
    else {
        temp$1 = u64('0');
    }
    return temp$1;
}
function shares_to_amount_(pool, shares, $c) {
    return shares_to_amount_with_total_coins_(pool, $.copy(shares), $.copy(pool.total_coins));
}
function shares_to_amount_with_total_coins_(pool, shares, total_coins, $c) {
    let temp$1, temp$2;
    if ($.copy(pool.total_coins).eq(u64('0'))) {
        temp$1 = true;
    }
    else {
        temp$1 = $.copy(pool.total_shares).eq(u64('0'));
    }
    if (temp$1) {
        temp$2 = u64('0');
    }
    else {
        temp$2 = multiply_then_divide_(pool, $.copy(shares), $.copy(total_coins), $.copy(pool.total_shares));
    }
    return temp$2;
}
function to_u128_$1(num, $c) {
    return u128($.copy(num));
}
function total_coins_(pool, $c) {
    return $.copy(pool.total_coins);
}
function total_shares_(pool, $c) {
    return $.copy(pool.total_shares);
}
function transfer_shares_(pool, shareholder_1, shareholder_2, shares_to_transfer, $c) {
    let temp$1, temp$2, temp$3, temp$4;
    [temp$1, temp$2] = [pool, $.copy(shareholder_1)];
    if (!contains_$3(temp$1, temp$2, $c)) {
        throw $.abortCode(invalid_argument_($.copy(ESHAREHOLDER_NOT_FOUND)));
    }
    [temp$3, temp$4] = [pool, $.copy(shareholder_1)];
    if (!shares_(temp$3, temp$4, $c).ge($.copy(shares_to_transfer))) {
        throw $.abortCode(invalid_argument_($.copy(EINSUFFICIENT_SHARES)));
    }
    if ($.copy(shares_to_transfer).eq(u64('0'))) {
        return;
    }
    deduct_shares_(pool, $.copy(shareholder_1), $.copy(shares_to_transfer), $c);
    add_shares_(pool, $.copy(shareholder_2), $.copy(shares_to_transfer), $c);
    return;
}
function update_total_coins_(pool, new_total_coins, $c) {
    pool.total_coins = $.copy(new_total_coins);
    return;
}
function loadParsers$U(repo) {
    repo.addParser('0x1::pool_u64::Pool', Pool$2.PoolParser);
}
class App$V {
    constructor(client, repo, cache) {
        this.client = client;
        this.repo = repo;
        this.cache = cache;
    }
    get moduleAddress() {
        {
            return moduleAddress$H;
        }
    }
    get moduleName() {
        {
            return moduleName$H;
        }
    }
    get Pool() {
        return Pool$2;
    }
}

var Pool_u64 = /*#__PURE__*/Object.freeze({
    __proto__: null,
    packageName: packageName$H,
    moduleAddress: moduleAddress$H,
    moduleName: moduleName$H,
    EINSUFFICIENT_SHARES: EINSUFFICIENT_SHARES,
    EPOOL_IS_NOT_EMPTY: EPOOL_IS_NOT_EMPTY,
    EPOOL_TOTAL_COINS_OVERFLOW: EPOOL_TOTAL_COINS_OVERFLOW,
    EPOOL_TOTAL_SHARES_OVERFLOW: EPOOL_TOTAL_SHARES_OVERFLOW,
    ESHAREHOLDER_NOT_FOUND: ESHAREHOLDER_NOT_FOUND,
    ESHAREHOLDER_SHARES_OVERFLOW: ESHAREHOLDER_SHARES_OVERFLOW,
    ETOO_MANY_SHAREHOLDERS: ETOO_MANY_SHAREHOLDERS,
    MAX_U64: MAX_U64$1,
    Pool: Pool$2,
    add_shares_: add_shares_,
    amount_to_shares_: amount_to_shares_,
    amount_to_shares_with_total_coins_: amount_to_shares_with_total_coins_,
    balance_: balance_,
    buy_in_: buy_in_,
    contains_: contains_$3,
    create_: create_,
    create_with_scaling_factor_: create_with_scaling_factor_,
    deduct_shares_: deduct_shares_,
    destroy_empty_: destroy_empty_$3,
    multiply_then_divide_: multiply_then_divide_,
    redeem_shares_: redeem_shares_,
    shareholders_: shareholders_,
    shareholders_count_: shareholders_count_,
    shares_: shares_,
    shares_to_amount_: shares_to_amount_,
    shares_to_amount_with_total_coins_: shares_to_amount_with_total_coins_,
    to_u128_: to_u128_$1,
    total_coins_: total_coins_,
    total_shares_: total_shares_,
    transfer_shares_: transfer_shares_,
    update_total_coins_: update_total_coins_,
    loadParsers: loadParsers$U,
    App: App$V
});

const packageName$G = 'AptosFramework';
const moduleAddress$G = new HexString('0x1');
const moduleName$G = 'staking_contract';
const ECANT_MERGE_STAKING_CONTRACTS = u64('5');
const EINSUFFICIENT_ACTIVE_STAKE_TO_WITHDRAW = u64('7');
const EINSUFFICIENT_STAKE_AMOUNT = u64('1');
const EINVALID_COMMISSION_PERCENTAGE = u64('2');
const ENOT_STAKER_OR_OPERATOR = u64('8');
const ENO_STAKING_CONTRACT_FOUND_FOR_OPERATOR = u64('4');
const ENO_STAKING_CONTRACT_FOUND_FOR_STAKER = u64('3');
const ESTAKING_CONTRACT_ALREADY_EXISTS = u64('6');
const MAXIMUM_PENDING_DISTRIBUTIONS = u64('20');
const SALT = [
    u8('97'),
    u8('112'),
    u8('116'),
    u8('111'),
    u8('115'),
    u8('95'),
    u8('102'),
    u8('114'),
    u8('97'),
    u8('109'),
    u8('101'),
    u8('119'),
    u8('111'),
    u8('114'),
    u8('107'),
    u8('58'),
    u8('58'),
    u8('115'),
    u8('116'),
    u8('97'),
    u8('107'),
    u8('105'),
    u8('110'),
    u8('103'),
    u8('95'),
    u8('99'),
    u8('111'),
    u8('110'),
    u8('116'),
    u8('114'),
    u8('97'),
    u8('99'),
    u8('116')
];
class AddDistributionEvent {
    constructor(proto, typeTag) {
        this.typeTag = typeTag;
        this.__app = null;
        this.operator = proto['operator'];
        this.pool_address = proto['pool_address'];
        this.amount = proto['amount'];
    }
    static AddDistributionEventParser(data, typeTag, repo) {
        const proto = $.parseStructProto(data, typeTag, repo, AddDistributionEvent);
        return new AddDistributionEvent(proto, typeTag);
    }
    static getTag() {
        return new StructTag(moduleAddress$G, moduleName$G, 'AddDistributionEvent', []);
    }
    loadFullState(app) {
        return __awaiter(this, void 0, void 0, function* () {
            this.__app = app;
        });
    }
}
AddDistributionEvent.moduleAddress = moduleAddress$G;
AddDistributionEvent.moduleName = moduleName$G;
AddDistributionEvent.structName = 'AddDistributionEvent';
AddDistributionEvent.typeParameters = [];
AddDistributionEvent.fields = [
    { name: 'operator', typeTag: AtomicTypeTag.Address },
    { name: 'pool_address', typeTag: AtomicTypeTag.Address },
    { name: 'amount', typeTag: AtomicTypeTag.U64 }
];
class AddStakeEvent {
    constructor(proto, typeTag) {
        this.typeTag = typeTag;
        this.__app = null;
        this.operator = proto['operator'];
        this.pool_address = proto['pool_address'];
        this.amount = proto['amount'];
    }
    static AddStakeEventParser(data, typeTag, repo) {
        const proto = $.parseStructProto(data, typeTag, repo, AddStakeEvent);
        return new AddStakeEvent(proto, typeTag);
    }
    static getTag() {
        return new StructTag(moduleAddress$G, moduleName$G, 'AddStakeEvent', []);
    }
    loadFullState(app) {
        return __awaiter(this, void 0, void 0, function* () {
            this.__app = app;
        });
    }
}
AddStakeEvent.moduleAddress = moduleAddress$G;
AddStakeEvent.moduleName = moduleName$G;
AddStakeEvent.structName = 'AddStakeEvent';
AddStakeEvent.typeParameters = [];
AddStakeEvent.fields = [
    { name: 'operator', typeTag: AtomicTypeTag.Address },
    { name: 'pool_address', typeTag: AtomicTypeTag.Address },
    { name: 'amount', typeTag: AtomicTypeTag.U64 }
];
class CreateStakingContractEvent {
    constructor(proto, typeTag) {
        this.typeTag = typeTag;
        this.__app = null;
        this.operator = proto['operator'];
        this.voter = proto['voter'];
        this.pool_address = proto['pool_address'];
        this.principal = proto['principal'];
        this.commission_percentage = proto['commission_percentage'];
    }
    static CreateStakingContractEventParser(data, typeTag, repo) {
        const proto = $.parseStructProto(data, typeTag, repo, CreateStakingContractEvent);
        return new CreateStakingContractEvent(proto, typeTag);
    }
    static getTag() {
        return new StructTag(moduleAddress$G, moduleName$G, 'CreateStakingContractEvent', []);
    }
    loadFullState(app) {
        return __awaiter(this, void 0, void 0, function* () {
            this.__app = app;
        });
    }
}
CreateStakingContractEvent.moduleAddress = moduleAddress$G;
CreateStakingContractEvent.moduleName = moduleName$G;
CreateStakingContractEvent.structName = 'CreateStakingContractEvent';
CreateStakingContractEvent.typeParameters = [];
CreateStakingContractEvent.fields = [
    { name: 'operator', typeTag: AtomicTypeTag.Address },
    { name: 'voter', typeTag: AtomicTypeTag.Address },
    { name: 'pool_address', typeTag: AtomicTypeTag.Address },
    { name: 'principal', typeTag: AtomicTypeTag.U64 },
    { name: 'commission_percentage', typeTag: AtomicTypeTag.U64 }
];
class DistributeEvent$1 {
    constructor(proto, typeTag) {
        this.typeTag = typeTag;
        this.__app = null;
        this.operator = proto['operator'];
        this.pool_address = proto['pool_address'];
        this.recipient = proto['recipient'];
        this.amount = proto['amount'];
    }
    static DistributeEventParser(data, typeTag, repo) {
        const proto = $.parseStructProto(data, typeTag, repo, DistributeEvent$1);
        return new DistributeEvent$1(proto, typeTag);
    }
    static getTag() {
        return new StructTag(moduleAddress$G, moduleName$G, 'DistributeEvent', []);
    }
    loadFullState(app) {
        return __awaiter(this, void 0, void 0, function* () {
            this.__app = app;
        });
    }
}
DistributeEvent$1.moduleAddress = moduleAddress$G;
DistributeEvent$1.moduleName = moduleName$G;
DistributeEvent$1.structName = 'DistributeEvent';
DistributeEvent$1.typeParameters = [];
DistributeEvent$1.fields = [
    { name: 'operator', typeTag: AtomicTypeTag.Address },
    { name: 'pool_address', typeTag: AtomicTypeTag.Address },
    { name: 'recipient', typeTag: AtomicTypeTag.Address },
    { name: 'amount', typeTag: AtomicTypeTag.U64 }
];
class RequestCommissionEvent {
    constructor(proto, typeTag) {
        this.typeTag = typeTag;
        this.__app = null;
        this.operator = proto['operator'];
        this.pool_address = proto['pool_address'];
        this.accumulated_rewards = proto['accumulated_rewards'];
        this.commission_amount = proto['commission_amount'];
    }
    static RequestCommissionEventParser(data, typeTag, repo) {
        const proto = $.parseStructProto(data, typeTag, repo, RequestCommissionEvent);
        return new RequestCommissionEvent(proto, typeTag);
    }
    static getTag() {
        return new StructTag(moduleAddress$G, moduleName$G, 'RequestCommissionEvent', []);
    }
    loadFullState(app) {
        return __awaiter(this, void 0, void 0, function* () {
            this.__app = app;
        });
    }
}
RequestCommissionEvent.moduleAddress = moduleAddress$G;
RequestCommissionEvent.moduleName = moduleName$G;
RequestCommissionEvent.structName = 'RequestCommissionEvent';
RequestCommissionEvent.typeParameters = [];
RequestCommissionEvent.fields = [
    { name: 'operator', typeTag: AtomicTypeTag.Address },
    { name: 'pool_address', typeTag: AtomicTypeTag.Address },
    { name: 'accumulated_rewards', typeTag: AtomicTypeTag.U64 },
    { name: 'commission_amount', typeTag: AtomicTypeTag.U64 }
];
class ResetLockupEvent$1 {
    constructor(proto, typeTag) {
        this.typeTag = typeTag;
        this.__app = null;
        this.operator = proto['operator'];
        this.pool_address = proto['pool_address'];
    }
    static ResetLockupEventParser(data, typeTag, repo) {
        const proto = $.parseStructProto(data, typeTag, repo, ResetLockupEvent$1);
        return new ResetLockupEvent$1(proto, typeTag);
    }
    static getTag() {
        return new StructTag(moduleAddress$G, moduleName$G, 'ResetLockupEvent', []);
    }
    loadFullState(app) {
        return __awaiter(this, void 0, void 0, function* () {
            this.__app = app;
        });
    }
}
ResetLockupEvent$1.moduleAddress = moduleAddress$G;
ResetLockupEvent$1.moduleName = moduleName$G;
ResetLockupEvent$1.structName = 'ResetLockupEvent';
ResetLockupEvent$1.typeParameters = [];
ResetLockupEvent$1.fields = [
    { name: 'operator', typeTag: AtomicTypeTag.Address },
    { name: 'pool_address', typeTag: AtomicTypeTag.Address }
];
class StakingContract {
    constructor(proto, typeTag) {
        this.typeTag = typeTag;
        this.__app = null;
        this.principal = proto['principal'];
        this.pool_address = proto['pool_address'];
        this.owner_cap = proto['owner_cap'];
        this.commission_percentage = proto['commission_percentage'];
        this.distribution_pool = proto['distribution_pool'];
        this.signer_cap = proto['signer_cap'];
    }
    static StakingContractParser(data, typeTag, repo) {
        const proto = $.parseStructProto(data, typeTag, repo, StakingContract);
        return new StakingContract(proto, typeTag);
    }
    static getTag() {
        return new StructTag(moduleAddress$G, moduleName$G, 'StakingContract', []);
    }
    loadFullState(app) {
        return __awaiter(this, void 0, void 0, function* () {
            yield this.owner_cap.loadFullState(app);
            yield this.distribution_pool.loadFullState(app);
            yield this.signer_cap.loadFullState(app);
            this.__app = app;
        });
    }
}
StakingContract.moduleAddress = moduleAddress$G;
StakingContract.moduleName = moduleName$G;
StakingContract.structName = 'StakingContract';
StakingContract.typeParameters = [];
StakingContract.fields = [
    { name: 'principal', typeTag: AtomicTypeTag.U64 },
    { name: 'pool_address', typeTag: AtomicTypeTag.Address },
    { name: 'owner_cap', typeTag: new StructTag(new HexString('0x1'), 'stake', 'OwnerCapability', []) },
    { name: 'commission_percentage', typeTag: AtomicTypeTag.U64 },
    { name: 'distribution_pool', typeTag: new StructTag(new HexString('0x1'), 'pool_u64', 'Pool', []) },
    { name: 'signer_cap', typeTag: new StructTag(new HexString('0x1'), 'account', 'SignerCapability', []) }
];
class Store {
    constructor(proto, typeTag) {
        this.typeTag = typeTag;
        this.__app = null;
        this.staking_contracts = proto['staking_contracts'];
        this.create_staking_contract_events = proto['create_staking_contract_events'];
        this.update_voter_events = proto['update_voter_events'];
        this.reset_lockup_events = proto['reset_lockup_events'];
        this.add_stake_events = proto['add_stake_events'];
        this.request_commission_events = proto['request_commission_events'];
        this.unlock_stake_events = proto['unlock_stake_events'];
        this.switch_operator_events = proto['switch_operator_events'];
        this.add_distribution_events = proto['add_distribution_events'];
        this.distribute_events = proto['distribute_events'];
    }
    static StoreParser(data, typeTag, repo) {
        const proto = $.parseStructProto(data, typeTag, repo, Store);
        return new Store(proto, typeTag);
    }
    static load(repo, client, address, typeParams) {
        return __awaiter(this, void 0, void 0, function* () {
            const result = yield repo.loadResource(client, address, Store, typeParams);
            return result;
        });
    }
    static loadByApp(app, address, typeParams) {
        return __awaiter(this, void 0, void 0, function* () {
            const result = yield app.repo.loadResource(app.client, address, Store, typeParams);
            yield result.loadFullState(app);
            return result;
        });
    }
    static getTag() {
        return new StructTag(moduleAddress$G, moduleName$G, 'Store', []);
    }
    loadFullState(app) {
        return __awaiter(this, void 0, void 0, function* () {
            yield this.staking_contracts.loadFullState(app);
            yield this.create_staking_contract_events.loadFullState(app);
            yield this.update_voter_events.loadFullState(app);
            yield this.reset_lockup_events.loadFullState(app);
            yield this.add_stake_events.loadFullState(app);
            yield this.request_commission_events.loadFullState(app);
            yield this.unlock_stake_events.loadFullState(app);
            yield this.switch_operator_events.loadFullState(app);
            yield this.add_distribution_events.loadFullState(app);
            yield this.distribute_events.loadFullState(app);
            this.__app = app;
        });
    }
}
Store.moduleAddress = moduleAddress$G;
Store.moduleName = moduleName$G;
Store.structName = 'Store';
Store.typeParameters = [];
Store.fields = [
    {
        name: 'staking_contracts',
        typeTag: new StructTag(new HexString('0x1'), 'simple_map', 'SimpleMap', [
            AtomicTypeTag.Address,
            new StructTag(new HexString('0x1'), 'staking_contract', 'StakingContract', [])
        ])
    },
    {
        name: 'create_staking_contract_events',
        typeTag: new StructTag(new HexString('0x1'), 'event', 'EventHandle', [
            new StructTag(new HexString('0x1'), 'staking_contract', 'CreateStakingContractEvent', [])
        ])
    },
    {
        name: 'update_voter_events',
        typeTag: new StructTag(new HexString('0x1'), 'event', 'EventHandle', [
            new StructTag(new HexString('0x1'), 'staking_contract', 'UpdateVoterEvent', [])
        ])
    },
    {
        name: 'reset_lockup_events',
        typeTag: new StructTag(new HexString('0x1'), 'event', 'EventHandle', [
            new StructTag(new HexString('0x1'), 'staking_contract', 'ResetLockupEvent', [])
        ])
    },
    {
        name: 'add_stake_events',
        typeTag: new StructTag(new HexString('0x1'), 'event', 'EventHandle', [
            new StructTag(new HexString('0x1'), 'staking_contract', 'AddStakeEvent', [])
        ])
    },
    {
        name: 'request_commission_events',
        typeTag: new StructTag(new HexString('0x1'), 'event', 'EventHandle', [
            new StructTag(new HexString('0x1'), 'staking_contract', 'RequestCommissionEvent', [])
        ])
    },
    {
        name: 'unlock_stake_events',
        typeTag: new StructTag(new HexString('0x1'), 'event', 'EventHandle', [
            new StructTag(new HexString('0x1'), 'staking_contract', 'UnlockStakeEvent', [])
        ])
    },
    {
        name: 'switch_operator_events',
        typeTag: new StructTag(new HexString('0x1'), 'event', 'EventHandle', [
            new StructTag(new HexString('0x1'), 'staking_contract', 'SwitchOperatorEvent', [])
        ])
    },
    {
        name: 'add_distribution_events',
        typeTag: new StructTag(new HexString('0x1'), 'event', 'EventHandle', [
            new StructTag(new HexString('0x1'), 'staking_contract', 'AddDistributionEvent', [])
        ])
    },
    {
        name: 'distribute_events',
        typeTag: new StructTag(new HexString('0x1'), 'event', 'EventHandle', [
            new StructTag(new HexString('0x1'), 'staking_contract', 'DistributeEvent', [])
        ])
    }
];
class SwitchOperatorEvent {
    constructor(proto, typeTag) {
        this.typeTag = typeTag;
        this.__app = null;
        this.old_operator = proto['old_operator'];
        this.new_operator = proto['new_operator'];
        this.pool_address = proto['pool_address'];
    }
    static SwitchOperatorEventParser(data, typeTag, repo) {
        const proto = $.parseStructProto(data, typeTag, repo, SwitchOperatorEvent);
        return new SwitchOperatorEvent(proto, typeTag);
    }
    static getTag() {
        return new StructTag(moduleAddress$G, moduleName$G, 'SwitchOperatorEvent', []);
    }
    loadFullState(app) {
        return __awaiter(this, void 0, void 0, function* () {
            this.__app = app;
        });
    }
}
SwitchOperatorEvent.moduleAddress = moduleAddress$G;
SwitchOperatorEvent.moduleName = moduleName$G;
SwitchOperatorEvent.structName = 'SwitchOperatorEvent';
SwitchOperatorEvent.typeParameters = [];
SwitchOperatorEvent.fields = [
    { name: 'old_operator', typeTag: AtomicTypeTag.Address },
    { name: 'new_operator', typeTag: AtomicTypeTag.Address },
    { name: 'pool_address', typeTag: AtomicTypeTag.Address }
];
class UnlockStakeEvent {
    constructor(proto, typeTag) {
        this.typeTag = typeTag;
        this.__app = null;
        this.operator = proto['operator'];
        this.pool_address = proto['pool_address'];
        this.amount = proto['amount'];
        this.commission_paid = proto['commission_paid'];
    }
    static UnlockStakeEventParser(data, typeTag, repo) {
        const proto = $.parseStructProto(data, typeTag, repo, UnlockStakeEvent);
        return new UnlockStakeEvent(proto, typeTag);
    }
    static getTag() {
        return new StructTag(moduleAddress$G, moduleName$G, 'UnlockStakeEvent', []);
    }
    loadFullState(app) {
        return __awaiter(this, void 0, void 0, function* () {
            this.__app = app;
        });
    }
}
UnlockStakeEvent.moduleAddress = moduleAddress$G;
UnlockStakeEvent.moduleName = moduleName$G;
UnlockStakeEvent.structName = 'UnlockStakeEvent';
UnlockStakeEvent.typeParameters = [];
UnlockStakeEvent.fields = [
    { name: 'operator', typeTag: AtomicTypeTag.Address },
    { name: 'pool_address', typeTag: AtomicTypeTag.Address },
    { name: 'amount', typeTag: AtomicTypeTag.U64 },
    { name: 'commission_paid', typeTag: AtomicTypeTag.U64 }
];
class UpdateVoterEvent$1 {
    constructor(proto, typeTag) {
        this.typeTag = typeTag;
        this.__app = null;
        this.operator = proto['operator'];
        this.pool_address = proto['pool_address'];
        this.old_voter = proto['old_voter'];
        this.new_voter = proto['new_voter'];
    }
    static UpdateVoterEventParser(data, typeTag, repo) {
        const proto = $.parseStructProto(data, typeTag, repo, UpdateVoterEvent$1);
        return new UpdateVoterEvent$1(proto, typeTag);
    }
    static getTag() {
        return new StructTag(moduleAddress$G, moduleName$G, 'UpdateVoterEvent', []);
    }
    loadFullState(app) {
        return __awaiter(this, void 0, void 0, function* () {
            this.__app = app;
        });
    }
}
UpdateVoterEvent$1.moduleAddress = moduleAddress$G;
UpdateVoterEvent$1.moduleName = moduleName$G;
UpdateVoterEvent$1.structName = 'UpdateVoterEvent';
UpdateVoterEvent$1.typeParameters = [];
UpdateVoterEvent$1.fields = [
    { name: 'operator', typeTag: AtomicTypeTag.Address },
    { name: 'pool_address', typeTag: AtomicTypeTag.Address },
    { name: 'old_voter', typeTag: AtomicTypeTag.Address },
    { name: 'new_voter', typeTag: AtomicTypeTag.Address }
];
function add_distribution_(operator, staking_contract, recipient, coins_amount, add_distribution_events, $c) {
    let distribution_pool, pool_address, total_distribution_amount;
    distribution_pool = staking_contract.distribution_pool;
    [, , , total_distribution_amount] = get_stake_($.copy(staking_contract.pool_address), $c);
    update_distribution_pool_(distribution_pool, $.copy(total_distribution_amount), $.copy(operator), $.copy(staking_contract.commission_percentage), $c);
    buy_in_(distribution_pool, $.copy(recipient), $.copy(coins_amount), $c);
    pool_address = $.copy(staking_contract.pool_address);
    emit_event_(add_distribution_events, new AddDistributionEvent({ operator: $.copy(operator), pool_address: $.copy(pool_address), amount: $.copy(coins_amount) }, new SimpleStructTag(AddDistributionEvent)), $c, [new SimpleStructTag(AddDistributionEvent)]);
    return;
}
function add_stake_(staker, operator, amount, $c) {
    let pool_address, staked_coins, staker_address, staking_contract, store;
    staker_address = address_of_(staker, $c);
    assert_staking_contract_exists_($.copy(staker_address), $.copy(operator), $c);
    store = $c.borrow_global_mut(new SimpleStructTag(Store), $.copy(staker_address));
    staking_contract = borrow_mut_$4(store.staking_contracts, operator, $c, [
        AtomicTypeTag.Address,
        new SimpleStructTag(StakingContract)
    ]);
    staked_coins = withdraw_$1(staker, $.copy(amount), $c, [
        new StructTag(new HexString('0x1'), 'aptos_coin', 'AptosCoin', [])
    ]);
    add_stake_with_cap_(staking_contract.owner_cap, staked_coins, $c);
    staking_contract.principal = $.copy(staking_contract.principal).add($.copy(amount));
    pool_address = $.copy(staking_contract.pool_address);
    emit_event_(store.add_stake_events, new AddStakeEvent({ operator: $.copy(operator), pool_address: $.copy(pool_address), amount: $.copy(amount) }, new SimpleStructTag(AddStakeEvent)), $c, [new SimpleStructTag(AddStakeEvent)]);
    return;
}
function buildPayload_add_stake(operator, amount, isJSON = false) {
    const typeParamStrings = [];
    return $.buildPayload(new HexString('0x1'), 'staking_contract', 'add_stake', typeParamStrings, [operator, amount], isJSON);
}
function assert_staking_contract_exists_(staker, operator, $c) {
    let temp$1, temp$2, staking_contracts;
    if (!$c.exists(new SimpleStructTag(Store), $.copy(staker))) {
        throw $.abortCode(not_found_($.copy(ENO_STAKING_CONTRACT_FOUND_FOR_STAKER)));
    }
    staking_contracts = $c.borrow_global_mut(new SimpleStructTag(Store), $.copy(staker)).staking_contracts;
    [temp$1, temp$2] = [staking_contracts, operator];
    if (!contains_key_(temp$1, temp$2, $c, [AtomicTypeTag.Address, new SimpleStructTag(StakingContract)])) {
        throw $.abortCode(not_found_($.copy(ENO_STAKING_CONTRACT_FOUND_FOR_OPERATOR)));
    }
    return;
}
function commission_percentage_(staker, operator, $c) {
    let staking_contracts;
    assert_staking_contract_exists_($.copy(staker), $.copy(operator), $c);
    staking_contracts = $c.borrow_global(new SimpleStructTag(Store), $.copy(staker)).staking_contracts;
    return $.copy(borrow_$4(staking_contracts, operator, $c, [AtomicTypeTag.Address, new SimpleStructTag(StakingContract)])
        .commission_percentage);
}
function create_stake_pool_(staker, operator, voter, contract_creation_seed, $c) {
    let temp$1, owner_cap, seed, stake_pool_signer, stake_pool_signer_cap;
    temp$1 = address_of_(staker, $c);
    seed = to_bytes_(temp$1, $c, [AtomicTypeTag.Address]);
    append_$3(seed, to_bytes_(operator, $c, [AtomicTypeTag.Address]), $c, [AtomicTypeTag.U8]);
    append_$3(seed, $.copy(SALT), $c, [AtomicTypeTag.U8]);
    append_$3(seed, $.copy(contract_creation_seed), $c, [AtomicTypeTag.U8]);
    [stake_pool_signer, stake_pool_signer_cap] = create_resource_account_$1(staker, $.copy(seed), $c);
    initialize_stake_owner_(stake_pool_signer, u64('0'), $.copy(operator), $.copy(voter), $c);
    owner_cap = extract_owner_cap_(stake_pool_signer, $c);
    return [stake_pool_signer, stake_pool_signer_cap, owner_cap];
}
function create_staking_contract_(staker, operator, voter, amount, commission_percentage, contract_creation_seed, $c) {
    let staked_coins;
    staked_coins = withdraw_$1(staker, $.copy(amount), $c, [
        new StructTag(new HexString('0x1'), 'aptos_coin', 'AptosCoin', [])
    ]);
    create_staking_contract_with_coins_(staker, $.copy(operator), $.copy(voter), staked_coins, $.copy(commission_percentage), $.copy(contract_creation_seed), $c);
    return;
}
function buildPayload_create_staking_contract(operator, voter, amount, commission_percentage, contract_creation_seed, isJSON = false) {
    const typeParamStrings = [];
    return $.buildPayload(new HexString('0x1'), 'staking_contract', 'create_staking_contract', typeParamStrings, [operator, voter, amount, commission_percentage, contract_creation_seed], isJSON);
}
function create_staking_contract_with_coins_(staker, operator, voter, coins, commission_percentage, contract_creation_seed, $c) {
    let temp$1, temp$2, temp$3, temp$4, min_stake_required, owner_cap, pool_address, principal, stake_pool_signer, stake_pool_signer_cap, staker_address, staking_contracts, store;
    if ($.copy(commission_percentage).ge(u64('0'))) {
        temp$1 = $.copy(commission_percentage).le(u64('100'));
    }
    else {
        temp$1 = false;
    }
    if (!temp$1) {
        throw $.abortCode(invalid_argument_($.copy(EINVALID_COMMISSION_PERCENTAGE)));
    }
    temp$2 = get_$2($c);
    [min_stake_required] = get_required_stake_(temp$2);
    principal = value_(coins, $c, [new StructTag(new HexString('0x1'), 'aptos_coin', 'AptosCoin', [])]);
    if (!$.copy(principal).ge($.copy(min_stake_required))) {
        throw $.abortCode(invalid_argument_($.copy(EINSUFFICIENT_STAKE_AMOUNT)));
    }
    staker_address = address_of_(staker, $c);
    if (!$c.exists(new SimpleStructTag(Store), $.copy(staker_address))) {
        $c.move_to(new SimpleStructTag(Store), staker, new_staking_contracts_holder_(staker, $c));
    }
    store = $c.borrow_global_mut(new SimpleStructTag(Store), $.copy(staker_address));
    staking_contracts = store.staking_contracts;
    [temp$3, temp$4] = [staking_contracts, operator];
    if (!!contains_key_(temp$3, temp$4, $c, [AtomicTypeTag.Address, new SimpleStructTag(StakingContract)])) {
        throw $.abortCode(already_exists_($.copy(ESTAKING_CONTRACT_ALREADY_EXISTS)));
    }
    [stake_pool_signer, stake_pool_signer_cap, owner_cap] = create_stake_pool_(staker, $.copy(operator), $.copy(voter), $.copy(contract_creation_seed), $c);
    add_stake_with_cap_(owner_cap, coins, $c);
    pool_address = address_of_(stake_pool_signer, $c);
    add_$4(staking_contracts, $.copy(operator), new StakingContract({
        principal: $.copy(principal),
        pool_address: $.copy(pool_address),
        owner_cap: owner_cap,
        commission_percentage: $.copy(commission_percentage),
        distribution_pool: create_($.copy(MAXIMUM_PENDING_DISTRIBUTIONS), $c),
        signer_cap: stake_pool_signer_cap
    }, new SimpleStructTag(StakingContract)), $c, [AtomicTypeTag.Address, new SimpleStructTag(StakingContract)]);
    emit_event_(store.create_staking_contract_events, new CreateStakingContractEvent({
        operator: $.copy(operator),
        voter: $.copy(voter),
        pool_address: $.copy(pool_address),
        principal: $.copy(principal),
        commission_percentage: $.copy(commission_percentage)
    }, new SimpleStructTag(CreateStakingContractEvent)), $c, [new SimpleStructTag(CreateStakingContractEvent)]);
    return $.copy(pool_address);
}
function distribute_$1(staker, operator, $c) {
    let staking_contract, store;
    assert_staking_contract_exists_($.copy(staker), $.copy(operator), $c);
    store = $c.borrow_global_mut(new SimpleStructTag(Store), $.copy(staker));
    staking_contract = borrow_mut_$4(store.staking_contracts, operator, $c, [
        AtomicTypeTag.Address,
        new SimpleStructTag(StakingContract)
    ]);
    distribute_internal_($.copy(staker), $.copy(operator), staking_contract, store.distribute_events, $c);
    return;
}
function buildPayload_distribute$1(staker, operator, isJSON = false) {
    const typeParamStrings = [];
    return $.buildPayload(new HexString('0x1'), 'staking_contract', 'distribute', typeParamStrings, [staker, operator], isJSON);
}
function distribute_internal_(staker, operator, staking_contract, distribute_events, $c) {
    let temp$1, temp$2, temp$3, temp$4, amount_to_distribute, coins, current_shares, distribution_amount, distribution_pool, inactive, pending_inactive, pool_address, recipient, recipients, total_potential_withdrawable;
    pool_address = $.copy(staking_contract.pool_address);
    [, inactive, , pending_inactive] = get_stake_($.copy(pool_address), $c);
    total_potential_withdrawable = $.copy(inactive).add($.copy(pending_inactive));
    coins = withdraw_with_cap_(staking_contract.owner_cap, $.copy(total_potential_withdrawable), $c);
    distribution_amount = value_(coins, $c, [new StructTag(new HexString('0x1'), 'aptos_coin', 'AptosCoin', [])]);
    if ($.copy(distribution_amount).eq(u64('0'))) {
        destroy_zero_(coins, $c, [new StructTag(new HexString('0x1'), 'aptos_coin', 'AptosCoin', [])]);
        return;
    }
    distribution_pool = staking_contract.distribution_pool;
    update_distribution_pool_(distribution_pool, $.copy(distribution_amount), $.copy(operator), $.copy(staking_contract.commission_percentage), $c);
    while (shareholders_count_(distribution_pool, $c).gt(u64('0'))) {
        {
            recipients = shareholders_(distribution_pool);
            [temp$1, temp$2] = [recipients, u64('0')];
            recipient = $.copy(borrow_$7(temp$1, temp$2, $c, [AtomicTypeTag.Address]));
            [temp$3, temp$4] = [distribution_pool, $.copy(recipient)];
            current_shares = shares_(temp$3, temp$4, $c);
            amount_to_distribute = redeem_shares_(distribution_pool, $.copy(recipient), $.copy(current_shares), $c);
            deposit_$1($.copy(recipient), extract_(coins, $.copy(amount_to_distribute), $c, [
                new StructTag(new HexString('0x1'), 'aptos_coin', 'AptosCoin', [])
            ]), $c, [new StructTag(new HexString('0x1'), 'aptos_coin', 'AptosCoin', [])]);
            emit_event_(distribute_events, new DistributeEvent$1({
                operator: $.copy(operator),
                pool_address: $.copy(pool_address),
                recipient: $.copy(recipient),
                amount: $.copy(amount_to_distribute)
            }, new SimpleStructTag(DistributeEvent$1)), $c, [new SimpleStructTag(DistributeEvent$1)]);
        }
    }
    if (value_(coins, $c, [new StructTag(new HexString('0x1'), 'aptos_coin', 'AptosCoin', [])]).gt(u64('0'))) {
        deposit_$1($.copy(staker), coins, $c, [new StructTag(new HexString('0x1'), 'aptos_coin', 'AptosCoin', [])]);
        update_total_coins_(distribution_pool, u64('0'));
    }
    else {
        destroy_zero_(coins, $c, [new StructTag(new HexString('0x1'), 'aptos_coin', 'AptosCoin', [])]);
    }
    return;
}
function get_staking_contract_amounts_internal_(staking_contract, $c) {
    let accumulated_rewards, active, commission_amount, pending_active, total_active_stake;
    [active, , pending_active] = get_stake_($.copy(staking_contract.pool_address), $c);
    total_active_stake = $.copy(active).add($.copy(pending_active));
    accumulated_rewards = $.copy(total_active_stake).sub($.copy(staking_contract.principal));
    commission_amount = $.copy(accumulated_rewards).mul($.copy(staking_contract.commission_percentage)).div(u64('100'));
    return [$.copy(total_active_stake), $.copy(accumulated_rewards), $.copy(commission_amount)];
}
function last_recorded_principal_(staker, operator, $c) {
    let staking_contracts;
    assert_staking_contract_exists_($.copy(staker), $.copy(operator), $c);
    staking_contracts = $c.borrow_global(new SimpleStructTag(Store), $.copy(staker)).staking_contracts;
    return $.copy(borrow_$4(staking_contracts, operator, $c, [AtomicTypeTag.Address, new SimpleStructTag(StakingContract)])
        .principal);
}
function new_staking_contracts_holder_(staker, $c) {
    return new Store({
        staking_contracts: create_$2($c, [AtomicTypeTag.Address, new SimpleStructTag(StakingContract)]),
        create_staking_contract_events: new_event_handle_(staker, $c, [
            new SimpleStructTag(CreateStakingContractEvent)
        ]),
        update_voter_events: new_event_handle_(staker, $c, [new SimpleStructTag(UpdateVoterEvent$1)]),
        reset_lockup_events: new_event_handle_(staker, $c, [new SimpleStructTag(ResetLockupEvent$1)]),
        add_stake_events: new_event_handle_(staker, $c, [new SimpleStructTag(AddStakeEvent)]),
        request_commission_events: new_event_handle_(staker, $c, [new SimpleStructTag(RequestCommissionEvent)]),
        unlock_stake_events: new_event_handle_(staker, $c, [new SimpleStructTag(UnlockStakeEvent)]),
        switch_operator_events: new_event_handle_(staker, $c, [new SimpleStructTag(SwitchOperatorEvent)]),
        add_distribution_events: new_event_handle_(staker, $c, [new SimpleStructTag(AddDistributionEvent)]),
        distribute_events: new_event_handle_(staker, $c, [new SimpleStructTag(DistributeEvent$1)])
    }, new SimpleStructTag(Store));
}
function pending_distribution_counts_(staker, operator, $c) {
    let staking_contracts;
    assert_staking_contract_exists_($.copy(staker), $.copy(operator), $c);
    staking_contracts = $c.borrow_global(new SimpleStructTag(Store), $.copy(staker)).staking_contracts;
    return shareholders_count_(borrow_$4(staking_contracts, operator, $c, [AtomicTypeTag.Address, new SimpleStructTag(StakingContract)])
        .distribution_pool, $c);
}
function request_commission_(account, staker, operator, $c) {
    let temp$1, account_addr, staking_contract, store;
    account_addr = address_of_(account, $c);
    if ($.copy(account_addr).hex() === $.copy(staker).hex()) {
        temp$1 = true;
    }
    else {
        temp$1 = $.copy(account_addr).hex() === $.copy(operator).hex();
    }
    if (!temp$1) {
        throw $.abortCode(unauthenticated_($.copy(ENOT_STAKER_OR_OPERATOR)));
    }
    assert_staking_contract_exists_($.copy(staker), $.copy(operator), $c);
    store = $c.borrow_global_mut(new SimpleStructTag(Store), $.copy(staker));
    staking_contract = borrow_mut_$4(store.staking_contracts, operator, $c, [
        AtomicTypeTag.Address,
        new SimpleStructTag(StakingContract)
    ]);
    if ($.copy(staking_contract.commission_percentage).eq(u64('0'))) {
        return;
    }
    distribute_internal_($.copy(staker), $.copy(operator), staking_contract, store.distribute_events, $c);
    request_commission_internal_($.copy(operator), staking_contract, store.add_distribution_events, store.request_commission_events, $c);
    return;
}
function buildPayload_request_commission(staker, operator, isJSON = false) {
    const typeParamStrings = [];
    return $.buildPayload(new HexString('0x1'), 'staking_contract', 'request_commission', typeParamStrings, [staker, operator], isJSON);
}
function request_commission_internal_(operator, staking_contract, add_distribution_events, request_commission_events, $c) {
    let accumulated_rewards, commission_amount, pool_address, total_active_stake;
    [total_active_stake, accumulated_rewards, commission_amount] = get_staking_contract_amounts_internal_(staking_contract, $c);
    staking_contract.principal = $.copy(total_active_stake).sub($.copy(commission_amount));
    if ($.copy(commission_amount).eq(u64('0'))) {
        return u64('0');
    }
    add_distribution_($.copy(operator), staking_contract, $.copy(operator), $.copy(commission_amount), add_distribution_events, $c);
    unlock_with_cap_($.copy(commission_amount), staking_contract.owner_cap, $c);
    pool_address = $.copy(staking_contract.pool_address);
    emit_event_(request_commission_events, new RequestCommissionEvent({
        operator: $.copy(operator),
        pool_address: $.copy(pool_address),
        accumulated_rewards: $.copy(accumulated_rewards),
        commission_amount: $.copy(commission_amount)
    }, new SimpleStructTag(RequestCommissionEvent)), $c, [new SimpleStructTag(RequestCommissionEvent)]);
    return $.copy(commission_amount);
}
function reset_lockup_$1(staker, operator, $c) {
    let pool_address, staker_address, staking_contract, store;
    staker_address = address_of_(staker, $c);
    assert_staking_contract_exists_($.copy(staker_address), $.copy(operator), $c);
    store = $c.borrow_global_mut(new SimpleStructTag(Store), $.copy(staker_address));
    staking_contract = borrow_mut_$4(store.staking_contracts, operator, $c, [
        AtomicTypeTag.Address,
        new SimpleStructTag(StakingContract)
    ]);
    pool_address = $.copy(staking_contract.pool_address);
    increase_lockup_with_cap_(staking_contract.owner_cap, $c);
    emit_event_(store.reset_lockup_events, new ResetLockupEvent$1({ operator: $.copy(operator), pool_address: $.copy(pool_address) }, new SimpleStructTag(ResetLockupEvent$1)), $c, [new SimpleStructTag(ResetLockupEvent$1)]);
    return;
}
function buildPayload_reset_lockup$1(operator, isJSON = false) {
    const typeParamStrings = [];
    return $.buildPayload(new HexString('0x1'), 'staking_contract', 'reset_lockup', typeParamStrings, [operator], isJSON);
}
function stake_pool_address_$1(staker, operator, $c) {
    let staking_contracts;
    assert_staking_contract_exists_($.copy(staker), $.copy(operator), $c);
    staking_contracts = $c.borrow_global(new SimpleStructTag(Store), $.copy(staker)).staking_contracts;
    return $.copy(borrow_$4(staking_contracts, operator, $c, [AtomicTypeTag.Address, new SimpleStructTag(StakingContract)])
        .pool_address);
}
function staking_contract_amounts_(staker, operator, $c) {
    let staking_contract, staking_contracts;
    assert_staking_contract_exists_($.copy(staker), $.copy(operator), $c);
    staking_contracts = $c.borrow_global(new SimpleStructTag(Store), $.copy(staker)).staking_contracts;
    staking_contract = borrow_$4(staking_contracts, operator, $c, [
        AtomicTypeTag.Address,
        new SimpleStructTag(StakingContract)
    ]);
    return get_staking_contract_amounts_internal_(staking_contract, $c);
}
function staking_contract_exists_(staker, operator, $c) {
    let store;
    if (!$c.exists(new SimpleStructTag(Store), $.copy(staker))) {
        return false;
    }
    store = $c.borrow_global(new SimpleStructTag(Store), $.copy(staker));
    return contains_key_(store.staking_contracts, operator, $c, [
        AtomicTypeTag.Address,
        new SimpleStructTag(StakingContract)
    ]);
}
function switch_operator_(staker, old_operator, new_operator, new_commission_percentage, $c) {
    let temp$1, temp$2, temp$3, temp$4, temp$5, temp$6, pool_address, staker_address, staking_contract, staking_contracts, store;
    staker_address = address_of_(staker, $c);
    assert_staking_contract_exists_($.copy(staker_address), $.copy(old_operator), $c);
    store = $c.borrow_global_mut(new SimpleStructTag(Store), $.copy(staker_address));
    staking_contracts = store.staking_contracts;
    [temp$1, temp$2] = [staking_contracts, new_operator];
    if (!!contains_key_(temp$1, temp$2, $c, [AtomicTypeTag.Address, new SimpleStructTag(StakingContract)])) {
        throw $.abortCode(invalid_state_($.copy(ECANT_MERGE_STAKING_CONTRACTS)));
    }
    [, staking_contract] = remove_$2(staking_contracts, old_operator, $c, [
        AtomicTypeTag.Address,
        new SimpleStructTag(StakingContract)
    ]);
    distribute_internal_($.copy(staker_address), $.copy(old_operator), staking_contract, store.distribute_events, $c);
    request_commission_internal_($.copy(old_operator), staking_contract, store.add_distribution_events, store.request_commission_events, $c);
    set_operator_with_cap_(staking_contract.owner_cap, $.copy(new_operator), $c);
    staking_contract.commission_percentage = $.copy(new_commission_percentage);
    pool_address = $.copy(staking_contract.pool_address);
    add_$4(staking_contracts, $.copy(new_operator), staking_contract, $c, [
        AtomicTypeTag.Address,
        new SimpleStructTag(StakingContract)
    ]);
    temp$6 = store.switch_operator_events;
    temp$3 = $.copy(pool_address);
    temp$4 = $.copy(old_operator);
    temp$5 = $.copy(new_operator);
    emit_event_(temp$6, new SwitchOperatorEvent({ old_operator: temp$4, new_operator: temp$5, pool_address: temp$3 }, new SimpleStructTag(SwitchOperatorEvent)), $c, [new SimpleStructTag(SwitchOperatorEvent)]);
    return;
}
function buildPayload_switch_operator(old_operator, new_operator, new_commission_percentage, isJSON = false) {
    const typeParamStrings = [];
    return $.buildPayload(new HexString('0x1'), 'staking_contract', 'switch_operator', typeParamStrings, [old_operator, new_operator, new_commission_percentage], isJSON);
}
function switch_operator_with_same_commission_(staker, old_operator, new_operator, $c) {
    let commission_percentage, staker_address;
    staker_address = address_of_(staker, $c);
    assert_staking_contract_exists_($.copy(staker_address), $.copy(old_operator), $c);
    commission_percentage = commission_percentage_($.copy(staker_address), $.copy(old_operator), $c);
    switch_operator_(staker, $.copy(old_operator), $.copy(new_operator), $.copy(commission_percentage), $c);
    return;
}
function buildPayload_switch_operator_with_same_commission(old_operator, new_operator, isJSON = false) {
    const typeParamStrings = [];
    return $.buildPayload(new HexString('0x1'), 'staking_contract', 'switch_operator_with_same_commission', typeParamStrings, [old_operator, new_operator], isJSON);
}
function unlock_rewards_$1(staker, operator, $c) {
    let accumulated_rewards, staker_address, staker_rewards, unpaid_commission;
    staker_address = address_of_(staker, $c);
    assert_staking_contract_exists_($.copy(staker_address), $.copy(operator), $c);
    [, accumulated_rewards, unpaid_commission] = staking_contract_amounts_($.copy(staker_address), $.copy(operator), $c);
    staker_rewards = $.copy(accumulated_rewards).sub($.copy(unpaid_commission));
    unlock_stake_$1(staker, $.copy(operator), $.copy(staker_rewards), $c);
    return;
}
function buildPayload_unlock_rewards$1(operator, isJSON = false) {
    const typeParamStrings = [];
    return $.buildPayload(new HexString('0x1'), 'staking_contract', 'unlock_rewards', typeParamStrings, [operator], isJSON);
}
function unlock_stake_$1(staker, operator, amount, $c) {
    let temp$1, temp$2, temp$3, temp$4, temp$5, active, commission_paid, pool_address, staker_address, staking_contract, store;
    if ($.copy(amount).eq(u64('0'))) {
        return;
    }
    staker_address = address_of_(staker, $c);
    assert_staking_contract_exists_($.copy(staker_address), $.copy(operator), $c);
    store = $c.borrow_global_mut(new SimpleStructTag(Store), $.copy(staker_address));
    staking_contract = borrow_mut_$4(store.staking_contracts, operator, $c, [
        AtomicTypeTag.Address,
        new SimpleStructTag(StakingContract)
    ]);
    distribute_internal_($.copy(staker_address), $.copy(operator), staking_contract, store.distribute_events, $c);
    commission_paid = request_commission_internal_($.copy(operator), staking_contract, store.add_distribution_events, store.request_commission_events, $c);
    [active, , ,] = get_stake_($.copy(staking_contract.pool_address), $c);
    if ($.copy(active).lt($.copy(amount))) {
        amount = $.copy(active);
    }
    staking_contract.principal = $.copy(staking_contract.principal).sub($.copy(amount));
    add_distribution_($.copy(operator), staking_contract, $.copy(staker_address), $.copy(amount), store.add_distribution_events, $c);
    unlock_with_cap_($.copy(amount), staking_contract.owner_cap, $c);
    pool_address = $.copy(staking_contract.pool_address);
    temp$5 = store.unlock_stake_events;
    temp$1 = $.copy(pool_address);
    temp$2 = $.copy(operator);
    temp$3 = $.copy(amount);
    temp$4 = $.copy(commission_paid);
    emit_event_(temp$5, new UnlockStakeEvent({ operator: temp$2, pool_address: temp$1, amount: temp$3, commission_paid: temp$4 }, new SimpleStructTag(UnlockStakeEvent)), $c, [new SimpleStructTag(UnlockStakeEvent)]);
    return;
}
function buildPayload_unlock_stake(operator, amount, isJSON = false) {
    const typeParamStrings = [];
    return $.buildPayload(new HexString('0x1'), 'staking_contract', 'unlock_stake', typeParamStrings, [operator, amount], isJSON);
}
function update_distribution_pool_(distribution_pool, updated_total_coins, operator, commission_percentage, $c) {
    let temp$1, temp$10, temp$11, temp$2, temp$3, temp$4, temp$5, temp$6, temp$7, temp$8, temp$9, current_worth, i, len, previous_worth, shareholder, shareholders, shares, shares_to_transfer, unpaid_commission;
    if (total_coins_(distribution_pool).eq($.copy(updated_total_coins))) {
        return;
    }
    temp$1 = shareholders_(distribution_pool);
    shareholders = temp$1;
    len = length_$6(shareholders, $c, [AtomicTypeTag.Address]);
    i = u64('0');
    while ($.copy(i).lt($.copy(len))) {
        {
            shareholder = $.copy(borrow_$7(shareholders, $.copy(i), $c, [AtomicTypeTag.Address]));
            if ($.copy(shareholder).hex() !== $.copy(operator).hex()) {
                [temp$2, temp$3] = [distribution_pool, $.copy(shareholder)];
                shares = shares_(temp$2, temp$3, $c);
                [temp$4, temp$5] = [distribution_pool, $.copy(shareholder)];
                previous_worth = balance_(temp$4, temp$5, $c);
                [temp$6, temp$7, temp$8] = [distribution_pool, $.copy(shares), $.copy(updated_total_coins)];
                current_worth = shares_to_amount_with_total_coins_(temp$6, temp$7, temp$8);
                unpaid_commission = $.copy(current_worth)
                    .sub($.copy(previous_worth))
                    .mul($.copy(commission_percentage))
                    .div(u64('100'));
                [temp$9, temp$10, temp$11] = [distribution_pool, $.copy(unpaid_commission), $.copy(updated_total_coins)];
                shares_to_transfer = amount_to_shares_with_total_coins_(temp$9, temp$10, temp$11);
                transfer_shares_(distribution_pool, $.copy(shareholder), $.copy(operator), $.copy(shares_to_transfer), $c);
            }
            i = $.copy(i).add(u64('1'));
        }
    }
    update_total_coins_(distribution_pool, $.copy(updated_total_coins));
    return;
}
function update_voter_$1(staker, operator, new_voter, $c) {
    let old_voter, pool_address, staker_address, staking_contract, store;
    staker_address = address_of_(staker, $c);
    assert_staking_contract_exists_($.copy(staker_address), $.copy(operator), $c);
    store = $c.borrow_global_mut(new SimpleStructTag(Store), $.copy(staker_address));
    staking_contract = borrow_mut_$4(store.staking_contracts, operator, $c, [
        AtomicTypeTag.Address,
        new SimpleStructTag(StakingContract)
    ]);
    pool_address = $.copy(staking_contract.pool_address);
    old_voter = get_delegated_voter_($.copy(pool_address), $c);
    set_delegated_voter_with_cap_(staking_contract.owner_cap, $.copy(new_voter), $c);
    emit_event_(store.update_voter_events, new UpdateVoterEvent$1({
        operator: $.copy(operator),
        pool_address: $.copy(pool_address),
        old_voter: $.copy(old_voter),
        new_voter: $.copy(new_voter)
    }, new SimpleStructTag(UpdateVoterEvent$1)), $c, [new SimpleStructTag(UpdateVoterEvent$1)]);
    return;
}
function buildPayload_update_voter$1(operator, new_voter, isJSON = false) {
    const typeParamStrings = [];
    return $.buildPayload(new HexString('0x1'), 'staking_contract', 'update_voter', typeParamStrings, [operator, new_voter], isJSON);
}
function loadParsers$T(repo) {
    repo.addParser('0x1::staking_contract::AddDistributionEvent', AddDistributionEvent.AddDistributionEventParser);
    repo.addParser('0x1::staking_contract::AddStakeEvent', AddStakeEvent.AddStakeEventParser);
    repo.addParser('0x1::staking_contract::CreateStakingContractEvent', CreateStakingContractEvent.CreateStakingContractEventParser);
    repo.addParser('0x1::staking_contract::DistributeEvent', DistributeEvent$1.DistributeEventParser);
    repo.addParser('0x1::staking_contract::RequestCommissionEvent', RequestCommissionEvent.RequestCommissionEventParser);
    repo.addParser('0x1::staking_contract::ResetLockupEvent', ResetLockupEvent$1.ResetLockupEventParser);
    repo.addParser('0x1::staking_contract::StakingContract', StakingContract.StakingContractParser);
    repo.addParser('0x1::staking_contract::Store', Store.StoreParser);
    repo.addParser('0x1::staking_contract::SwitchOperatorEvent', SwitchOperatorEvent.SwitchOperatorEventParser);
    repo.addParser('0x1::staking_contract::UnlockStakeEvent', UnlockStakeEvent.UnlockStakeEventParser);
    repo.addParser('0x1::staking_contract::UpdateVoterEvent', UpdateVoterEvent$1.UpdateVoterEventParser);
}
class App$U {
    constructor(client, repo, cache) {
        this.client = client;
        this.repo = repo;
        this.cache = cache;
    }
    get moduleAddress() {
        {
            return moduleAddress$G;
        }
    }
    get moduleName() {
        {
            return moduleName$G;
        }
    }
    get AddDistributionEvent() {
        return AddDistributionEvent;
    }
    get AddStakeEvent() {
        return AddStakeEvent;
    }
    get CreateStakingContractEvent() {
        return CreateStakingContractEvent;
    }
    get DistributeEvent() {
        return DistributeEvent$1;
    }
    get RequestCommissionEvent() {
        return RequestCommissionEvent;
    }
    get ResetLockupEvent() {
        return ResetLockupEvent$1;
    }
    get StakingContract() {
        return StakingContract;
    }
    get Store() {
        return Store;
    }
    loadStore(owner, loadFull = true, fillCache = true) {
        return __awaiter(this, void 0, void 0, function* () {
            const val = yield Store.load(this.repo, this.client, owner, []);
            if (loadFull) {
                yield val.loadFullState(this);
            }
            if (fillCache) {
                this.cache.set(val.typeTag, owner, val);
            }
            return val;
        });
    }
    get SwitchOperatorEvent() {
        return SwitchOperatorEvent;
    }
    get UnlockStakeEvent() {
        return UnlockStakeEvent;
    }
    get UpdateVoterEvent() {
        return UpdateVoterEvent$1;
    }
    payload_add_stake(operator, amount, isJSON = false) {
        return buildPayload_add_stake(operator, amount, isJSON);
    }
    add_stake(_account, operator, amount, option, _isJSON = false) {
        return __awaiter(this, void 0, void 0, function* () {
            const payload__ = buildPayload_add_stake(operator, amount, _isJSON);
            return $.sendPayloadTx(this.client, _account, payload__, option);
        });
    }
    payload_create_staking_contract(operator, voter, amount, commission_percentage, contract_creation_seed, isJSON = false) {
        return buildPayload_create_staking_contract(operator, voter, amount, commission_percentage, contract_creation_seed, isJSON);
    }
    create_staking_contract(_account, operator, voter, amount, commission_percentage, contract_creation_seed, option, _isJSON = false) {
        return __awaiter(this, void 0, void 0, function* () {
            const payload__ = buildPayload_create_staking_contract(operator, voter, amount, commission_percentage, contract_creation_seed, _isJSON);
            return $.sendPayloadTx(this.client, _account, payload__, option);
        });
    }
    payload_distribute(staker, operator, isJSON = false) {
        return buildPayload_distribute$1(staker, operator, isJSON);
    }
    distribute(_account, staker, operator, option, _isJSON = false) {
        return __awaiter(this, void 0, void 0, function* () {
            const payload__ = buildPayload_distribute$1(staker, operator, _isJSON);
            return $.sendPayloadTx(this.client, _account, payload__, option);
        });
    }
    payload_request_commission(staker, operator, isJSON = false) {
        return buildPayload_request_commission(staker, operator, isJSON);
    }
    request_commission(_account, staker, operator, option, _isJSON = false) {
        return __awaiter(this, void 0, void 0, function* () {
            const payload__ = buildPayload_request_commission(staker, operator, _isJSON);
            return $.sendPayloadTx(this.client, _account, payload__, option);
        });
    }
    payload_reset_lockup(operator, isJSON = false) {
        return buildPayload_reset_lockup$1(operator, isJSON);
    }
    reset_lockup(_account, operator, option, _isJSON = false) {
        return __awaiter(this, void 0, void 0, function* () {
            const payload__ = buildPayload_reset_lockup$1(operator, _isJSON);
            return $.sendPayloadTx(this.client, _account, payload__, option);
        });
    }
    payload_switch_operator(old_operator, new_operator, new_commission_percentage, isJSON = false) {
        return buildPayload_switch_operator(old_operator, new_operator, new_commission_percentage, isJSON);
    }
    switch_operator(_account, old_operator, new_operator, new_commission_percentage, option, _isJSON = false) {
        return __awaiter(this, void 0, void 0, function* () {
            const payload__ = buildPayload_switch_operator(old_operator, new_operator, new_commission_percentage, _isJSON);
            return $.sendPayloadTx(this.client, _account, payload__, option);
        });
    }
    payload_switch_operator_with_same_commission(old_operator, new_operator, isJSON = false) {
        return buildPayload_switch_operator_with_same_commission(old_operator, new_operator, isJSON);
    }
    switch_operator_with_same_commission(_account, old_operator, new_operator, option, _isJSON = false) {
        return __awaiter(this, void 0, void 0, function* () {
            const payload__ = buildPayload_switch_operator_with_same_commission(old_operator, new_operator, _isJSON);
            return $.sendPayloadTx(this.client, _account, payload__, option);
        });
    }
    payload_unlock_rewards(operator, isJSON = false) {
        return buildPayload_unlock_rewards$1(operator, isJSON);
    }
    unlock_rewards(_account, operator, option, _isJSON = false) {
        return __awaiter(this, void 0, void 0, function* () {
            const payload__ = buildPayload_unlock_rewards$1(operator, _isJSON);
            return $.sendPayloadTx(this.client, _account, payload__, option);
        });
    }
    payload_unlock_stake(operator, amount, isJSON = false) {
        return buildPayload_unlock_stake(operator, amount, isJSON);
    }
    unlock_stake(_account, operator, amount, option, _isJSON = false) {
        return __awaiter(this, void 0, void 0, function* () {
            const payload__ = buildPayload_unlock_stake(operator, amount, _isJSON);
            return $.sendPayloadTx(this.client, _account, payload__, option);
        });
    }
    payload_update_voter(operator, new_voter, isJSON = false) {
        return buildPayload_update_voter$1(operator, new_voter, isJSON);
    }
    update_voter(_account, operator, new_voter, option, _isJSON = false) {
        return __awaiter(this, void 0, void 0, function* () {
            const payload__ = buildPayload_update_voter$1(operator, new_voter, _isJSON);
            return $.sendPayloadTx(this.client, _account, payload__, option);
        });
    }
}

var Staking_contract = /*#__PURE__*/Object.freeze({
    __proto__: null,
    packageName: packageName$G,
    moduleAddress: moduleAddress$G,
    moduleName: moduleName$G,
    ECANT_MERGE_STAKING_CONTRACTS: ECANT_MERGE_STAKING_CONTRACTS,
    EINSUFFICIENT_ACTIVE_STAKE_TO_WITHDRAW: EINSUFFICIENT_ACTIVE_STAKE_TO_WITHDRAW,
    EINSUFFICIENT_STAKE_AMOUNT: EINSUFFICIENT_STAKE_AMOUNT,
    EINVALID_COMMISSION_PERCENTAGE: EINVALID_COMMISSION_PERCENTAGE,
    ENOT_STAKER_OR_OPERATOR: ENOT_STAKER_OR_OPERATOR,
    ENO_STAKING_CONTRACT_FOUND_FOR_OPERATOR: ENO_STAKING_CONTRACT_FOUND_FOR_OPERATOR,
    ENO_STAKING_CONTRACT_FOUND_FOR_STAKER: ENO_STAKING_CONTRACT_FOUND_FOR_STAKER,
    ESTAKING_CONTRACT_ALREADY_EXISTS: ESTAKING_CONTRACT_ALREADY_EXISTS,
    MAXIMUM_PENDING_DISTRIBUTIONS: MAXIMUM_PENDING_DISTRIBUTIONS,
    SALT: SALT,
    AddDistributionEvent: AddDistributionEvent,
    AddStakeEvent: AddStakeEvent,
    CreateStakingContractEvent: CreateStakingContractEvent,
    DistributeEvent: DistributeEvent$1,
    RequestCommissionEvent: RequestCommissionEvent,
    ResetLockupEvent: ResetLockupEvent$1,
    StakingContract: StakingContract,
    Store: Store,
    SwitchOperatorEvent: SwitchOperatorEvent,
    UnlockStakeEvent: UnlockStakeEvent,
    UpdateVoterEvent: UpdateVoterEvent$1,
    add_distribution_: add_distribution_,
    add_stake_: add_stake_,
    buildPayload_add_stake: buildPayload_add_stake,
    assert_staking_contract_exists_: assert_staking_contract_exists_,
    commission_percentage_: commission_percentage_,
    create_stake_pool_: create_stake_pool_,
    create_staking_contract_: create_staking_contract_,
    buildPayload_create_staking_contract: buildPayload_create_staking_contract,
    create_staking_contract_with_coins_: create_staking_contract_with_coins_,
    distribute_: distribute_$1,
    buildPayload_distribute: buildPayload_distribute$1,
    distribute_internal_: distribute_internal_,
    get_staking_contract_amounts_internal_: get_staking_contract_amounts_internal_,
    last_recorded_principal_: last_recorded_principal_,
    new_staking_contracts_holder_: new_staking_contracts_holder_,
    pending_distribution_counts_: pending_distribution_counts_,
    request_commission_: request_commission_,
    buildPayload_request_commission: buildPayload_request_commission,
    request_commission_internal_: request_commission_internal_,
    reset_lockup_: reset_lockup_$1,
    buildPayload_reset_lockup: buildPayload_reset_lockup$1,
    stake_pool_address_: stake_pool_address_$1,
    staking_contract_amounts_: staking_contract_amounts_,
    staking_contract_exists_: staking_contract_exists_,
    switch_operator_: switch_operator_,
    buildPayload_switch_operator: buildPayload_switch_operator,
    switch_operator_with_same_commission_: switch_operator_with_same_commission_,
    buildPayload_switch_operator_with_same_commission: buildPayload_switch_operator_with_same_commission,
    unlock_rewards_: unlock_rewards_$1,
    buildPayload_unlock_rewards: buildPayload_unlock_rewards$1,
    unlock_stake_: unlock_stake_$1,
    buildPayload_unlock_stake: buildPayload_unlock_stake,
    update_distribution_pool_: update_distribution_pool_,
    update_voter_: update_voter_$1,
    buildPayload_update_voter: buildPayload_update_voter$1,
    loadParsers: loadParsers$T,
    App: App$U
});

const packageName$F = 'AptosFramework';
const moduleAddress$F = new HexString('0x1');
const moduleName$F = 'transaction_fee';
class AptosCoinCapabilities {
    constructor(proto, typeTag) {
        this.typeTag = typeTag;
        this.__app = null;
        this.burn_cap = proto['burn_cap'];
    }
    static AptosCoinCapabilitiesParser(data, typeTag, repo) {
        const proto = $.parseStructProto(data, typeTag, repo, AptosCoinCapabilities);
        return new AptosCoinCapabilities(proto, typeTag);
    }
    static load(repo, client, address, typeParams) {
        return __awaiter(this, void 0, void 0, function* () {
            const result = yield repo.loadResource(client, address, AptosCoinCapabilities, typeParams);
            return result;
        });
    }
    static loadByApp(app, address, typeParams) {
        return __awaiter(this, void 0, void 0, function* () {
            const result = yield app.repo.loadResource(app.client, address, AptosCoinCapabilities, typeParams);
            yield result.loadFullState(app);
            return result;
        });
    }
    static getTag() {
        return new StructTag(moduleAddress$F, moduleName$F, 'AptosCoinCapabilities', []);
    }
    loadFullState(app) {
        return __awaiter(this, void 0, void 0, function* () {
            yield this.burn_cap.loadFullState(app);
            this.__app = app;
        });
    }
}
AptosCoinCapabilities.moduleAddress = moduleAddress$F;
AptosCoinCapabilities.moduleName = moduleName$F;
AptosCoinCapabilities.structName = 'AptosCoinCapabilities';
AptosCoinCapabilities.typeParameters = [];
AptosCoinCapabilities.fields = [
    {
        name: 'burn_cap',
        typeTag: new StructTag(new HexString('0x1'), 'coin', 'BurnCapability', [
            new StructTag(new HexString('0x1'), 'aptos_coin', 'AptosCoin', [])
        ])
    }
];
function burn_fee_(account, fee, $c) {
    burn_from_($.copy(account), $.copy(fee), $c.borrow_global(new SimpleStructTag(AptosCoinCapabilities), new HexString('0x1')).burn_cap, $c, [new StructTag(new HexString('0x1'), 'aptos_coin', 'AptosCoin', [])]);
    return;
}
function store_aptos_coin_burn_cap_(aptos_framework, burn_cap, $c) {
    assert_aptos_framework_(aptos_framework, $c);
    return $c.move_to(new SimpleStructTag(AptosCoinCapabilities), aptos_framework, new AptosCoinCapabilities({ burn_cap: $.copy(burn_cap) }, new SimpleStructTag(AptosCoinCapabilities)));
}
function loadParsers$S(repo) {
    repo.addParser('0x1::transaction_fee::AptosCoinCapabilities', AptosCoinCapabilities.AptosCoinCapabilitiesParser);
}
class App$T {
    constructor(client, repo, cache) {
        this.client = client;
        this.repo = repo;
        this.cache = cache;
    }
    get moduleAddress() {
        {
            return moduleAddress$F;
        }
    }
    get moduleName() {
        {
            return moduleName$F;
        }
    }
    get AptosCoinCapabilities() {
        return AptosCoinCapabilities;
    }
    loadAptosCoinCapabilities(owner, loadFull = true, fillCache = true) {
        return __awaiter(this, void 0, void 0, function* () {
            const val = yield AptosCoinCapabilities.load(this.repo, this.client, owner, []);
            if (loadFull) {
                yield val.loadFullState(this);
            }
            if (fillCache) {
                this.cache.set(val.typeTag, owner, val);
            }
            return val;
        });
    }
}

var Transaction_fee = /*#__PURE__*/Object.freeze({
    __proto__: null,
    packageName: packageName$F,
    moduleAddress: moduleAddress$F,
    moduleName: moduleName$F,
    AptosCoinCapabilities: AptosCoinCapabilities,
    burn_fee_: burn_fee_,
    store_aptos_coin_burn_cap_: store_aptos_coin_burn_cap_,
    loadParsers: loadParsers$S,
    App: App$T
});

const packageName$E = 'AptosFramework';
const moduleAddress$E = new HexString('0x1');
const moduleName$E = 'transaction_validation';
const EOUT_OF_GAS = u64('6');
const MAX_U64 = u128('18446744073709551615');
const PROLOGUE_EACCOUNT_DOES_NOT_EXIST = u64('1004');
const PROLOGUE_EBAD_CHAIN_ID = u64('1007');
const PROLOGUE_ECANT_PAY_GAS_DEPOSIT = u64('1005');
const PROLOGUE_EINVALID_ACCOUNT_AUTH_KEY = u64('1001');
const PROLOGUE_ESECONDARY_KEYS_ADDRESSES_COUNT_MISMATCH = u64('1009');
const PROLOGUE_ESEQUENCE_NUMBER_TOO_BIG = u64('1008');
const PROLOGUE_ESEQUENCE_NUMBER_TOO_NEW = u64('1003');
const PROLOGUE_ESEQUENCE_NUMBER_TOO_OLD = u64('1002');
const PROLOGUE_ETRANSACTION_EXPIRED = u64('1006');
class TransactionValidation {
    constructor(proto, typeTag) {
        this.typeTag = typeTag;
        this.__app = null;
        this.module_addr = proto['module_addr'];
        this.module_name = proto['module_name'];
        this.script_prologue_name = proto['script_prologue_name'];
        this.module_prologue_name = proto['module_prologue_name'];
        this.multi_agent_prologue_name = proto['multi_agent_prologue_name'];
        this.user_epilogue_name = proto['user_epilogue_name'];
    }
    static TransactionValidationParser(data, typeTag, repo) {
        const proto = $.parseStructProto(data, typeTag, repo, TransactionValidation);
        return new TransactionValidation(proto, typeTag);
    }
    static load(repo, client, address, typeParams) {
        return __awaiter(this, void 0, void 0, function* () {
            const result = yield repo.loadResource(client, address, TransactionValidation, typeParams);
            return result;
        });
    }
    static loadByApp(app, address, typeParams) {
        return __awaiter(this, void 0, void 0, function* () {
            const result = yield app.repo.loadResource(app.client, address, TransactionValidation, typeParams);
            yield result.loadFullState(app);
            return result;
        });
    }
    static getTag() {
        return new StructTag(moduleAddress$E, moduleName$E, 'TransactionValidation', []);
    }
    loadFullState(app) {
        return __awaiter(this, void 0, void 0, function* () {
            this.__app = app;
        });
    }
}
TransactionValidation.moduleAddress = moduleAddress$E;
TransactionValidation.moduleName = moduleName$E;
TransactionValidation.structName = 'TransactionValidation';
TransactionValidation.typeParameters = [];
TransactionValidation.fields = [
    { name: 'module_addr', typeTag: AtomicTypeTag.Address },
    { name: 'module_name', typeTag: new VectorTag(AtomicTypeTag.U8) },
    { name: 'script_prologue_name', typeTag: new VectorTag(AtomicTypeTag.U8) },
    { name: 'module_prologue_name', typeTag: new VectorTag(AtomicTypeTag.U8) },
    { name: 'multi_agent_prologue_name', typeTag: new VectorTag(AtomicTypeTag.U8) },
    { name: 'user_epilogue_name', typeTag: new VectorTag(AtomicTypeTag.U8) }
];
function epilogue_(account, _txn_sequence_number, txn_gas_price, txn_max_gas_units, gas_units_remaining, $c) {
    let addr, gas_used, transaction_fee_amount;
    if (!$.copy(txn_max_gas_units).ge($.copy(gas_units_remaining))) {
        throw $.abortCode(invalid_argument_($.copy(EOUT_OF_GAS)));
    }
    gas_used = $.copy(txn_max_gas_units).sub($.copy(gas_units_remaining));
    if (!u128($.copy(txn_gas_price))
        .mul(u128($.copy(gas_used)))
        .le($.copy(MAX_U64))) {
        throw $.abortCode(out_of_range_($.copy(EOUT_OF_GAS)));
    }
    transaction_fee_amount = $.copy(txn_gas_price).mul($.copy(gas_used));
    addr = address_of_(account, $c);
    if (!balance_$1($.copy(addr), $c, [new StructTag(new HexString('0x1'), 'aptos_coin', 'AptosCoin', [])]).ge($.copy(transaction_fee_amount))) {
        throw $.abortCode(out_of_range_($.copy(PROLOGUE_ECANT_PAY_GAS_DEPOSIT)));
    }
    burn_fee_($.copy(addr), $.copy(transaction_fee_amount), $c);
    increment_sequence_number_($.copy(addr), $c);
    return;
}
function initialize_$6(aptos_framework, script_prologue_name, module_prologue_name, multi_agent_prologue_name, user_epilogue_name, $c) {
    assert_aptos_framework_(aptos_framework, $c);
    $c.move_to(new SimpleStructTag(TransactionValidation), aptos_framework, new TransactionValidation({
        module_addr: new HexString('0x1'),
        module_name: [
            u8('116'),
            u8('114'),
            u8('97'),
            u8('110'),
            u8('115'),
            u8('97'),
            u8('99'),
            u8('116'),
            u8('105'),
            u8('111'),
            u8('110'),
            u8('95'),
            u8('118'),
            u8('97'),
            u8('108'),
            u8('105'),
            u8('100'),
            u8('97'),
            u8('116'),
            u8('105'),
            u8('111'),
            u8('110')
        ],
        script_prologue_name: $.copy(script_prologue_name),
        module_prologue_name: $.copy(module_prologue_name),
        multi_agent_prologue_name: $.copy(multi_agent_prologue_name),
        user_epilogue_name: $.copy(user_epilogue_name)
    }, new SimpleStructTag(TransactionValidation)));
    return;
}
function module_prologue_(sender, txn_sequence_number, txn_public_key, txn_gas_price, txn_max_gas_units, txn_expiration_time, chain_id, $c) {
    return prologue_common_(sender, $.copy(txn_sequence_number), $.copy(txn_public_key), $.copy(txn_gas_price), $.copy(txn_max_gas_units), $.copy(txn_expiration_time), $.copy(chain_id), $c);
}
function multi_agent_script_prologue_(sender, txn_sequence_number, txn_sender_public_key, secondary_signer_addresses, secondary_signer_public_key_hashes, txn_gas_price, txn_max_gas_units, txn_expiration_time, chain_id, $c) {
    let i, num_secondary_signers, secondary_address, signer_public_key_hash;
    prologue_common_(sender, $.copy(txn_sequence_number), $.copy(txn_sender_public_key), $.copy(txn_gas_price), $.copy(txn_max_gas_units), $.copy(txn_expiration_time), $.copy(chain_id), $c);
    num_secondary_signers = length_$6(secondary_signer_addresses, $c, [AtomicTypeTag.Address]);
    if (!length_$6(secondary_signer_public_key_hashes, $c, [new VectorTag(AtomicTypeTag.U8)]).eq($.copy(num_secondary_signers))) {
        throw $.abortCode(invalid_argument_($.copy(PROLOGUE_ESECONDARY_KEYS_ADDRESSES_COUNT_MISMATCH)));
    }
    i = u64('0');
    while ($.copy(i).lt($.copy(num_secondary_signers))) {
        {
            secondary_address = $.copy(borrow_$7(secondary_signer_addresses, $.copy(i), $c, [AtomicTypeTag.Address]));
            if (!exists_at_($.copy(secondary_address), $c)) {
                throw $.abortCode(invalid_argument_($.copy(PROLOGUE_EACCOUNT_DOES_NOT_EXIST)));
            }
            signer_public_key_hash = $.copy(borrow_$7(secondary_signer_public_key_hashes, $.copy(i), $c, [new VectorTag(AtomicTypeTag.U8)]));
            if (!$.veq($.copy(signer_public_key_hash), get_authentication_key_($.copy(secondary_address), $c))) {
                throw $.abortCode(invalid_argument_($.copy(PROLOGUE_EINVALID_ACCOUNT_AUTH_KEY)));
            }
            i = $.copy(i).add(u64('1'));
        }
    }
    return;
}
function prologue_common_(sender, txn_sequence_number, txn_authentication_key, txn_gas_price, txn_max_gas_units, txn_expiration_time, chain_id, $c) {
    let account_sequence_number, balance, max_transaction_fee, transaction_sender;
    if (!now_seconds_($c).lt($.copy(txn_expiration_time))) {
        throw $.abortCode(invalid_argument_($.copy(PROLOGUE_ETRANSACTION_EXPIRED)));
    }
    if (!get_$1($c).eq($.copy(chain_id))) {
        throw $.abortCode(invalid_argument_($.copy(PROLOGUE_EBAD_CHAIN_ID)));
    }
    transaction_sender = address_of_(sender, $c);
    if (!exists_at_($.copy(transaction_sender), $c)) {
        throw $.abortCode(invalid_argument_($.copy(PROLOGUE_EACCOUNT_DOES_NOT_EXIST)));
    }
    if (!$.veq($.copy(txn_authentication_key), get_authentication_key_($.copy(transaction_sender), $c))) {
        throw $.abortCode(invalid_argument_($.copy(PROLOGUE_EINVALID_ACCOUNT_AUTH_KEY)));
    }
    if (!u128($.copy(txn_sequence_number)).lt($.copy(MAX_U64))) {
        throw $.abortCode(out_of_range_($.copy(PROLOGUE_ESEQUENCE_NUMBER_TOO_BIG)));
    }
    account_sequence_number = get_sequence_number_($.copy(transaction_sender), $c);
    if (!$.copy(txn_sequence_number).ge($.copy(account_sequence_number))) {
        throw $.abortCode(invalid_argument_($.copy(PROLOGUE_ESEQUENCE_NUMBER_TOO_OLD)));
    }
    if (!$.copy(txn_sequence_number).eq($.copy(account_sequence_number))) {
        throw $.abortCode(invalid_argument_($.copy(PROLOGUE_ESEQUENCE_NUMBER_TOO_NEW)));
    }
    max_transaction_fee = $.copy(txn_gas_price).mul($.copy(txn_max_gas_units));
    if (!is_account_registered_($.copy(transaction_sender), $c, [
        new StructTag(new HexString('0x1'), 'aptos_coin', 'AptosCoin', [])
    ])) {
        throw $.abortCode(invalid_argument_($.copy(PROLOGUE_ECANT_PAY_GAS_DEPOSIT)));
    }
    balance = balance_$1($.copy(transaction_sender), $c, [
        new StructTag(new HexString('0x1'), 'aptos_coin', 'AptosCoin', [])
    ]);
    if (!$.copy(balance).ge($.copy(max_transaction_fee))) {
        throw $.abortCode(invalid_argument_($.copy(PROLOGUE_ECANT_PAY_GAS_DEPOSIT)));
    }
    return;
}
function script_prologue_(sender, txn_sequence_number, txn_public_key, txn_gas_price, txn_max_gas_units, txn_expiration_time, chain_id, _script_hash, $c) {
    return prologue_common_(sender, $.copy(txn_sequence_number), $.copy(txn_public_key), $.copy(txn_gas_price), $.copy(txn_max_gas_units), $.copy(txn_expiration_time), $.copy(chain_id), $c);
}
function loadParsers$R(repo) {
    repo.addParser('0x1::transaction_validation::TransactionValidation', TransactionValidation.TransactionValidationParser);
}
class App$S {
    constructor(client, repo, cache) {
        this.client = client;
        this.repo = repo;
        this.cache = cache;
    }
    get moduleAddress() {
        {
            return moduleAddress$E;
        }
    }
    get moduleName() {
        {
            return moduleName$E;
        }
    }
    get TransactionValidation() {
        return TransactionValidation;
    }
    loadTransactionValidation(owner, loadFull = true, fillCache = true) {
        return __awaiter(this, void 0, void 0, function* () {
            const val = yield TransactionValidation.load(this.repo, this.client, owner, []);
            if (loadFull) {
                yield val.loadFullState(this);
            }
            if (fillCache) {
                this.cache.set(val.typeTag, owner, val);
            }
            return val;
        });
    }
}

var Transaction_validation = /*#__PURE__*/Object.freeze({
    __proto__: null,
    packageName: packageName$E,
    moduleAddress: moduleAddress$E,
    moduleName: moduleName$E,
    EOUT_OF_GAS: EOUT_OF_GAS,
    MAX_U64: MAX_U64,
    PROLOGUE_EACCOUNT_DOES_NOT_EXIST: PROLOGUE_EACCOUNT_DOES_NOT_EXIST,
    PROLOGUE_EBAD_CHAIN_ID: PROLOGUE_EBAD_CHAIN_ID,
    PROLOGUE_ECANT_PAY_GAS_DEPOSIT: PROLOGUE_ECANT_PAY_GAS_DEPOSIT,
    PROLOGUE_EINVALID_ACCOUNT_AUTH_KEY: PROLOGUE_EINVALID_ACCOUNT_AUTH_KEY,
    PROLOGUE_ESECONDARY_KEYS_ADDRESSES_COUNT_MISMATCH: PROLOGUE_ESECONDARY_KEYS_ADDRESSES_COUNT_MISMATCH,
    PROLOGUE_ESEQUENCE_NUMBER_TOO_BIG: PROLOGUE_ESEQUENCE_NUMBER_TOO_BIG,
    PROLOGUE_ESEQUENCE_NUMBER_TOO_NEW: PROLOGUE_ESEQUENCE_NUMBER_TOO_NEW,
    PROLOGUE_ESEQUENCE_NUMBER_TOO_OLD: PROLOGUE_ESEQUENCE_NUMBER_TOO_OLD,
    PROLOGUE_ETRANSACTION_EXPIRED: PROLOGUE_ETRANSACTION_EXPIRED,
    TransactionValidation: TransactionValidation,
    epilogue_: epilogue_,
    initialize_: initialize_$6,
    module_prologue_: module_prologue_,
    multi_agent_script_prologue_: multi_agent_script_prologue_,
    prologue_common_: prologue_common_,
    script_prologue_: script_prologue_,
    loadParsers: loadParsers$R,
    App: App$S
});

const packageName$D = 'AptosFramework';
const moduleAddress$D = new HexString('0x1');
const moduleName$D = 'version';
const EINVALID_MAJOR_VERSION_NUMBER = u64('1');
const ENOT_AUTHORIZED = u64('2');
class SetVersionCapability {
    constructor(proto, typeTag) {
        this.typeTag = typeTag;
        this.__app = null;
    }
    static SetVersionCapabilityParser(data, typeTag, repo) {
        const proto = $.parseStructProto(data, typeTag, repo, SetVersionCapability);
        return new SetVersionCapability(proto, typeTag);
    }
    static load(repo, client, address, typeParams) {
        return __awaiter(this, void 0, void 0, function* () {
            const result = yield repo.loadResource(client, address, SetVersionCapability, typeParams);
            return result;
        });
    }
    static loadByApp(app, address, typeParams) {
        return __awaiter(this, void 0, void 0, function* () {
            const result = yield app.repo.loadResource(app.client, address, SetVersionCapability, typeParams);
            yield result.loadFullState(app);
            return result;
        });
    }
    static getTag() {
        return new StructTag(moduleAddress$D, moduleName$D, 'SetVersionCapability', []);
    }
    loadFullState(app) {
        return __awaiter(this, void 0, void 0, function* () {
            this.__app = app;
        });
    }
}
SetVersionCapability.moduleAddress = moduleAddress$D;
SetVersionCapability.moduleName = moduleName$D;
SetVersionCapability.structName = 'SetVersionCapability';
SetVersionCapability.typeParameters = [];
SetVersionCapability.fields = [];
class Version {
    constructor(proto, typeTag) {
        this.typeTag = typeTag;
        this.__app = null;
        this.major = proto['major'];
    }
    static VersionParser(data, typeTag, repo) {
        const proto = $.parseStructProto(data, typeTag, repo, Version);
        return new Version(proto, typeTag);
    }
    static load(repo, client, address, typeParams) {
        return __awaiter(this, void 0, void 0, function* () {
            const result = yield repo.loadResource(client, address, Version, typeParams);
            return result;
        });
    }
    static loadByApp(app, address, typeParams) {
        return __awaiter(this, void 0, void 0, function* () {
            const result = yield app.repo.loadResource(app.client, address, Version, typeParams);
            yield result.loadFullState(app);
            return result;
        });
    }
    static getTag() {
        return new StructTag(moduleAddress$D, moduleName$D, 'Version', []);
    }
    loadFullState(app) {
        return __awaiter(this, void 0, void 0, function* () {
            this.__app = app;
        });
    }
}
Version.moduleAddress = moduleAddress$D;
Version.moduleName = moduleName$D;
Version.structName = 'Version';
Version.typeParameters = [];
Version.fields = [{ name: 'major', typeTag: AtomicTypeTag.U64 }];
function initialize_$5(aptos_framework, initial_version, $c) {
    assert_aptos_framework_(aptos_framework, $c);
    $c.move_to(new SimpleStructTag(Version), aptos_framework, new Version({ major: $.copy(initial_version) }, new SimpleStructTag(Version)));
    $c.move_to(new SimpleStructTag(SetVersionCapability), aptos_framework, new SetVersionCapability({}, new SimpleStructTag(SetVersionCapability)));
    return;
}
function initialize_for_test_(core_resources, $c) {
    assert_core_resource_(core_resources, $c);
    $c.move_to(new SimpleStructTag(SetVersionCapability), core_resources, new SetVersionCapability({}, new SimpleStructTag(SetVersionCapability)));
    return;
}
function set_version_(account, major, $c) {
    let config, old_major;
    if (!$c.exists(new SimpleStructTag(SetVersionCapability), address_of_(account, $c))) {
        throw $.abortCode(permission_denied_($.copy(ENOT_AUTHORIZED)));
    }
    old_major = $.copy($c.borrow_global(new SimpleStructTag(Version), new HexString('0x1')).major);
    if (!$.copy(old_major).lt($.copy(major))) {
        throw $.abortCode(invalid_argument_($.copy(EINVALID_MAJOR_VERSION_NUMBER)));
    }
    config = $c.borrow_global_mut(new SimpleStructTag(Version), new HexString('0x1'));
    config.major = $.copy(major);
    reconfigure_$1($c);
    return;
}
function buildPayload_set_version(major, isJSON = false) {
    const typeParamStrings = [];
    return $.buildPayload(new HexString('0x1'), 'version', 'set_version', typeParamStrings, [major], isJSON);
}
function loadParsers$Q(repo) {
    repo.addParser('0x1::version::SetVersionCapability', SetVersionCapability.SetVersionCapabilityParser);
    repo.addParser('0x1::version::Version', Version.VersionParser);
}
class App$R {
    constructor(client, repo, cache) {
        this.client = client;
        this.repo = repo;
        this.cache = cache;
    }
    get moduleAddress() {
        {
            return moduleAddress$D;
        }
    }
    get moduleName() {
        {
            return moduleName$D;
        }
    }
    get SetVersionCapability() {
        return SetVersionCapability;
    }
    loadSetVersionCapability(owner, loadFull = true, fillCache = true) {
        return __awaiter(this, void 0, void 0, function* () {
            const val = yield SetVersionCapability.load(this.repo, this.client, owner, []);
            if (loadFull) {
                yield val.loadFullState(this);
            }
            if (fillCache) {
                this.cache.set(val.typeTag, owner, val);
            }
            return val;
        });
    }
    get Version() {
        return Version;
    }
    loadVersion(owner, loadFull = true, fillCache = true) {
        return __awaiter(this, void 0, void 0, function* () {
            const val = yield Version.load(this.repo, this.client, owner, []);
            if (loadFull) {
                yield val.loadFullState(this);
            }
            if (fillCache) {
                this.cache.set(val.typeTag, owner, val);
            }
            return val;
        });
    }
    payload_set_version(major, isJSON = false) {
        return buildPayload_set_version(major, isJSON);
    }
    set_version(_account, major, option, _isJSON = false) {
        return __awaiter(this, void 0, void 0, function* () {
            const payload__ = buildPayload_set_version(major, _isJSON);
            return $.sendPayloadTx(this.client, _account, payload__, option);
        });
    }
}

var Version$1 = /*#__PURE__*/Object.freeze({
    __proto__: null,
    packageName: packageName$D,
    moduleAddress: moduleAddress$D,
    moduleName: moduleName$D,
    EINVALID_MAJOR_VERSION_NUMBER: EINVALID_MAJOR_VERSION_NUMBER,
    ENOT_AUTHORIZED: ENOT_AUTHORIZED,
    SetVersionCapability: SetVersionCapability,
    Version: Version,
    initialize_: initialize_$5,
    initialize_for_test_: initialize_for_test_,
    set_version_: set_version_,
    buildPayload_set_version: buildPayload_set_version,
    loadParsers: loadParsers$Q,
    App: App$R
});

const packageName$C = 'AptosFramework';
const moduleAddress$C = new HexString('0x1');
const moduleName$C = 'vesting';
const EEMPTY_VESTING_SCHEDULE = u64('2');
const EINVALID_WITHDRAWAL_ADDRESS = u64('1');
const ENOT_ADMIN = u64('7');
const ENO_SHAREHOLDERS = u64('4');
const EPENDING_STAKE_FOUND = u64('11');
const EPERMISSION_DENIED = u64('15');
const EROLE_NOT_FOUND = u64('14');
const ESHARES_LENGTH_MISMATCH = u64('5');
const EVESTING_ACCOUNT_HAS_NO_ROLES = u64('13');
const EVESTING_CONTRACT_NOT_ACTIVE = u64('8');
const EVESTING_CONTRACT_NOT_FOUND = u64('10');
const EVESTING_CONTRACT_STILL_ACTIVE = u64('9');
const EVESTING_START_TOO_SOON = u64('6');
const EZERO_GRANT = u64('12');
const EZERO_VESTING_SCHEDULE_PERIOD = u64('3');
const MAXIMUM_SHAREHOLDERS = u64('30');
const ROLE_BENEFICIARY_RESETTER = [
    u8('82'),
    u8('79'),
    u8('76'),
    u8('69'),
    u8('95'),
    u8('66'),
    u8('69'),
    u8('78'),
    u8('69'),
    u8('70'),
    u8('73'),
    u8('67'),
    u8('73'),
    u8('65'),
    u8('82'),
    u8('89'),
    u8('95'),
    u8('82'),
    u8('69'),
    u8('83'),
    u8('69'),
    u8('84'),
    u8('84'),
    u8('69'),
    u8('82')
];
const VESTING_POOL_ACTIVE = u64('1');
const VESTING_POOL_SALT = [
    u8('97'),
    u8('112'),
    u8('116'),
    u8('111'),
    u8('115'),
    u8('95'),
    u8('102'),
    u8('114'),
    u8('97'),
    u8('109'),
    u8('101'),
    u8('119'),
    u8('111'),
    u8('114'),
    u8('107'),
    u8('58'),
    u8('58'),
    u8('118'),
    u8('101'),
    u8('115'),
    u8('116'),
    u8('105'),
    u8('110'),
    u8('103')
];
const VESTING_POOL_TERMINATED = u64('2');
class AdminStore {
    constructor(proto, typeTag) {
        this.typeTag = typeTag;
        this.__app = null;
        this.vesting_contracts = proto['vesting_contracts'];
        this.nonce = proto['nonce'];
        this.create_events = proto['create_events'];
    }
    static AdminStoreParser(data, typeTag, repo) {
        const proto = $.parseStructProto(data, typeTag, repo, AdminStore);
        return new AdminStore(proto, typeTag);
    }
    static load(repo, client, address, typeParams) {
        return __awaiter(this, void 0, void 0, function* () {
            const result = yield repo.loadResource(client, address, AdminStore, typeParams);
            return result;
        });
    }
    static loadByApp(app, address, typeParams) {
        return __awaiter(this, void 0, void 0, function* () {
            const result = yield app.repo.loadResource(app.client, address, AdminStore, typeParams);
            yield result.loadFullState(app);
            return result;
        });
    }
    static getTag() {
        return new StructTag(moduleAddress$C, moduleName$C, 'AdminStore', []);
    }
    loadFullState(app) {
        return __awaiter(this, void 0, void 0, function* () {
            yield this.create_events.loadFullState(app);
            this.__app = app;
        });
    }
}
AdminStore.moduleAddress = moduleAddress$C;
AdminStore.moduleName = moduleName$C;
AdminStore.structName = 'AdminStore';
AdminStore.typeParameters = [];
AdminStore.fields = [
    { name: 'vesting_contracts', typeTag: new VectorTag(AtomicTypeTag.Address) },
    { name: 'nonce', typeTag: AtomicTypeTag.U64 },
    {
        name: 'create_events',
        typeTag: new StructTag(new HexString('0x1'), 'event', 'EventHandle', [
            new StructTag(new HexString('0x1'), 'vesting', 'CreateVestingContractEvent', [])
        ])
    }
];
class AdminWithdrawEvent {
    constructor(proto, typeTag) {
        this.typeTag = typeTag;
        this.__app = null;
        this.admin = proto['admin'];
        this.vesting_contract_address = proto['vesting_contract_address'];
        this.amount = proto['amount'];
    }
    static AdminWithdrawEventParser(data, typeTag, repo) {
        const proto = $.parseStructProto(data, typeTag, repo, AdminWithdrawEvent);
        return new AdminWithdrawEvent(proto, typeTag);
    }
    static getTag() {
        return new StructTag(moduleAddress$C, moduleName$C, 'AdminWithdrawEvent', []);
    }
    loadFullState(app) {
        return __awaiter(this, void 0, void 0, function* () {
            this.__app = app;
        });
    }
}
AdminWithdrawEvent.moduleAddress = moduleAddress$C;
AdminWithdrawEvent.moduleName = moduleName$C;
AdminWithdrawEvent.structName = 'AdminWithdrawEvent';
AdminWithdrawEvent.typeParameters = [];
AdminWithdrawEvent.fields = [
    { name: 'admin', typeTag: AtomicTypeTag.Address },
    { name: 'vesting_contract_address', typeTag: AtomicTypeTag.Address },
    { name: 'amount', typeTag: AtomicTypeTag.U64 }
];
class CreateVestingContractEvent {
    constructor(proto, typeTag) {
        this.typeTag = typeTag;
        this.__app = null;
        this.operator = proto['operator'];
        this.voter = proto['voter'];
        this.grant_amount = proto['grant_amount'];
        this.withdrawal_address = proto['withdrawal_address'];
        this.vesting_contract_address = proto['vesting_contract_address'];
        this.staking_pool_address = proto['staking_pool_address'];
        this.commission_percentage = proto['commission_percentage'];
    }
    static CreateVestingContractEventParser(data, typeTag, repo) {
        const proto = $.parseStructProto(data, typeTag, repo, CreateVestingContractEvent);
        return new CreateVestingContractEvent(proto, typeTag);
    }
    static getTag() {
        return new StructTag(moduleAddress$C, moduleName$C, 'CreateVestingContractEvent', []);
    }
    loadFullState(app) {
        return __awaiter(this, void 0, void 0, function* () {
            this.__app = app;
        });
    }
}
CreateVestingContractEvent.moduleAddress = moduleAddress$C;
CreateVestingContractEvent.moduleName = moduleName$C;
CreateVestingContractEvent.structName = 'CreateVestingContractEvent';
CreateVestingContractEvent.typeParameters = [];
CreateVestingContractEvent.fields = [
    { name: 'operator', typeTag: AtomicTypeTag.Address },
    { name: 'voter', typeTag: AtomicTypeTag.Address },
    { name: 'grant_amount', typeTag: AtomicTypeTag.U64 },
    { name: 'withdrawal_address', typeTag: AtomicTypeTag.Address },
    { name: 'vesting_contract_address', typeTag: AtomicTypeTag.Address },
    { name: 'staking_pool_address', typeTag: AtomicTypeTag.Address },
    { name: 'commission_percentage', typeTag: AtomicTypeTag.U64 }
];
class DistributeEvent {
    constructor(proto, typeTag) {
        this.typeTag = typeTag;
        this.__app = null;
        this.admin = proto['admin'];
        this.vesting_contract_address = proto['vesting_contract_address'];
        this.amount = proto['amount'];
    }
    static DistributeEventParser(data, typeTag, repo) {
        const proto = $.parseStructProto(data, typeTag, repo, DistributeEvent);
        return new DistributeEvent(proto, typeTag);
    }
    static getTag() {
        return new StructTag(moduleAddress$C, moduleName$C, 'DistributeEvent', []);
    }
    loadFullState(app) {
        return __awaiter(this, void 0, void 0, function* () {
            this.__app = app;
        });
    }
}
DistributeEvent.moduleAddress = moduleAddress$C;
DistributeEvent.moduleName = moduleName$C;
DistributeEvent.structName = 'DistributeEvent';
DistributeEvent.typeParameters = [];
DistributeEvent.fields = [
    { name: 'admin', typeTag: AtomicTypeTag.Address },
    { name: 'vesting_contract_address', typeTag: AtomicTypeTag.Address },
    { name: 'amount', typeTag: AtomicTypeTag.U64 }
];
class ResetLockupEvent {
    constructor(proto, typeTag) {
        this.typeTag = typeTag;
        this.__app = null;
        this.admin = proto['admin'];
        this.vesting_contract_address = proto['vesting_contract_address'];
        this.staking_pool_address = proto['staking_pool_address'];
        this.new_lockup_expiration_secs = proto['new_lockup_expiration_secs'];
    }
    static ResetLockupEventParser(data, typeTag, repo) {
        const proto = $.parseStructProto(data, typeTag, repo, ResetLockupEvent);
        return new ResetLockupEvent(proto, typeTag);
    }
    static getTag() {
        return new StructTag(moduleAddress$C, moduleName$C, 'ResetLockupEvent', []);
    }
    loadFullState(app) {
        return __awaiter(this, void 0, void 0, function* () {
            this.__app = app;
        });
    }
}
ResetLockupEvent.moduleAddress = moduleAddress$C;
ResetLockupEvent.moduleName = moduleName$C;
ResetLockupEvent.structName = 'ResetLockupEvent';
ResetLockupEvent.typeParameters = [];
ResetLockupEvent.fields = [
    { name: 'admin', typeTag: AtomicTypeTag.Address },
    { name: 'vesting_contract_address', typeTag: AtomicTypeTag.Address },
    { name: 'staking_pool_address', typeTag: AtomicTypeTag.Address },
    { name: 'new_lockup_expiration_secs', typeTag: AtomicTypeTag.U64 }
];
class SetBeneficiaryEvent {
    constructor(proto, typeTag) {
        this.typeTag = typeTag;
        this.__app = null;
        this.admin = proto['admin'];
        this.vesting_contract_address = proto['vesting_contract_address'];
        this.shareholder = proto['shareholder'];
        this.old_beneficiary = proto['old_beneficiary'];
        this.new_beneficiary = proto['new_beneficiary'];
    }
    static SetBeneficiaryEventParser(data, typeTag, repo) {
        const proto = $.parseStructProto(data, typeTag, repo, SetBeneficiaryEvent);
        return new SetBeneficiaryEvent(proto, typeTag);
    }
    static getTag() {
        return new StructTag(moduleAddress$C, moduleName$C, 'SetBeneficiaryEvent', []);
    }
    loadFullState(app) {
        return __awaiter(this, void 0, void 0, function* () {
            this.__app = app;
        });
    }
}
SetBeneficiaryEvent.moduleAddress = moduleAddress$C;
SetBeneficiaryEvent.moduleName = moduleName$C;
SetBeneficiaryEvent.structName = 'SetBeneficiaryEvent';
SetBeneficiaryEvent.typeParameters = [];
SetBeneficiaryEvent.fields = [
    { name: 'admin', typeTag: AtomicTypeTag.Address },
    { name: 'vesting_contract_address', typeTag: AtomicTypeTag.Address },
    { name: 'shareholder', typeTag: AtomicTypeTag.Address },
    { name: 'old_beneficiary', typeTag: AtomicTypeTag.Address },
    { name: 'new_beneficiary', typeTag: AtomicTypeTag.Address }
];
class StakingInfo {
    constructor(proto, typeTag) {
        this.typeTag = typeTag;
        this.__app = null;
        this.pool_address = proto['pool_address'];
        this.operator = proto['operator'];
        this.voter = proto['voter'];
        this.commission_percentage = proto['commission_percentage'];
    }
    static StakingInfoParser(data, typeTag, repo) {
        const proto = $.parseStructProto(data, typeTag, repo, StakingInfo);
        return new StakingInfo(proto, typeTag);
    }
    static getTag() {
        return new StructTag(moduleAddress$C, moduleName$C, 'StakingInfo', []);
    }
    loadFullState(app) {
        return __awaiter(this, void 0, void 0, function* () {
            this.__app = app;
        });
    }
}
StakingInfo.moduleAddress = moduleAddress$C;
StakingInfo.moduleName = moduleName$C;
StakingInfo.structName = 'StakingInfo';
StakingInfo.typeParameters = [];
StakingInfo.fields = [
    { name: 'pool_address', typeTag: AtomicTypeTag.Address },
    { name: 'operator', typeTag: AtomicTypeTag.Address },
    { name: 'voter', typeTag: AtomicTypeTag.Address },
    { name: 'commission_percentage', typeTag: AtomicTypeTag.U64 }
];
class TerminateEvent {
    constructor(proto, typeTag) {
        this.typeTag = typeTag;
        this.__app = null;
        this.admin = proto['admin'];
        this.vesting_contract_address = proto['vesting_contract_address'];
    }
    static TerminateEventParser(data, typeTag, repo) {
        const proto = $.parseStructProto(data, typeTag, repo, TerminateEvent);
        return new TerminateEvent(proto, typeTag);
    }
    static getTag() {
        return new StructTag(moduleAddress$C, moduleName$C, 'TerminateEvent', []);
    }
    loadFullState(app) {
        return __awaiter(this, void 0, void 0, function* () {
            this.__app = app;
        });
    }
}
TerminateEvent.moduleAddress = moduleAddress$C;
TerminateEvent.moduleName = moduleName$C;
TerminateEvent.structName = 'TerminateEvent';
TerminateEvent.typeParameters = [];
TerminateEvent.fields = [
    { name: 'admin', typeTag: AtomicTypeTag.Address },
    { name: 'vesting_contract_address', typeTag: AtomicTypeTag.Address }
];
class UnlockRewardsEvent {
    constructor(proto, typeTag) {
        this.typeTag = typeTag;
        this.__app = null;
        this.admin = proto['admin'];
        this.vesting_contract_address = proto['vesting_contract_address'];
        this.staking_pool_address = proto['staking_pool_address'];
        this.amount = proto['amount'];
    }
    static UnlockRewardsEventParser(data, typeTag, repo) {
        const proto = $.parseStructProto(data, typeTag, repo, UnlockRewardsEvent);
        return new UnlockRewardsEvent(proto, typeTag);
    }
    static getTag() {
        return new StructTag(moduleAddress$C, moduleName$C, 'UnlockRewardsEvent', []);
    }
    loadFullState(app) {
        return __awaiter(this, void 0, void 0, function* () {
            this.__app = app;
        });
    }
}
UnlockRewardsEvent.moduleAddress = moduleAddress$C;
UnlockRewardsEvent.moduleName = moduleName$C;
UnlockRewardsEvent.structName = 'UnlockRewardsEvent';
UnlockRewardsEvent.typeParameters = [];
UnlockRewardsEvent.fields = [
    { name: 'admin', typeTag: AtomicTypeTag.Address },
    { name: 'vesting_contract_address', typeTag: AtomicTypeTag.Address },
    { name: 'staking_pool_address', typeTag: AtomicTypeTag.Address },
    { name: 'amount', typeTag: AtomicTypeTag.U64 }
];
class UpdateOperatorEvent {
    constructor(proto, typeTag) {
        this.typeTag = typeTag;
        this.__app = null;
        this.admin = proto['admin'];
        this.vesting_contract_address = proto['vesting_contract_address'];
        this.staking_pool_address = proto['staking_pool_address'];
        this.old_operator = proto['old_operator'];
        this.new_operator = proto['new_operator'];
        this.commission_percentage = proto['commission_percentage'];
    }
    static UpdateOperatorEventParser(data, typeTag, repo) {
        const proto = $.parseStructProto(data, typeTag, repo, UpdateOperatorEvent);
        return new UpdateOperatorEvent(proto, typeTag);
    }
    static getTag() {
        return new StructTag(moduleAddress$C, moduleName$C, 'UpdateOperatorEvent', []);
    }
    loadFullState(app) {
        return __awaiter(this, void 0, void 0, function* () {
            this.__app = app;
        });
    }
}
UpdateOperatorEvent.moduleAddress = moduleAddress$C;
UpdateOperatorEvent.moduleName = moduleName$C;
UpdateOperatorEvent.structName = 'UpdateOperatorEvent';
UpdateOperatorEvent.typeParameters = [];
UpdateOperatorEvent.fields = [
    { name: 'admin', typeTag: AtomicTypeTag.Address },
    { name: 'vesting_contract_address', typeTag: AtomicTypeTag.Address },
    { name: 'staking_pool_address', typeTag: AtomicTypeTag.Address },
    { name: 'old_operator', typeTag: AtomicTypeTag.Address },
    { name: 'new_operator', typeTag: AtomicTypeTag.Address },
    { name: 'commission_percentage', typeTag: AtomicTypeTag.U64 }
];
class UpdateVoterEvent {
    constructor(proto, typeTag) {
        this.typeTag = typeTag;
        this.__app = null;
        this.admin = proto['admin'];
        this.vesting_contract_address = proto['vesting_contract_address'];
        this.staking_pool_address = proto['staking_pool_address'];
        this.old_voter = proto['old_voter'];
        this.new_voter = proto['new_voter'];
    }
    static UpdateVoterEventParser(data, typeTag, repo) {
        const proto = $.parseStructProto(data, typeTag, repo, UpdateVoterEvent);
        return new UpdateVoterEvent(proto, typeTag);
    }
    static getTag() {
        return new StructTag(moduleAddress$C, moduleName$C, 'UpdateVoterEvent', []);
    }
    loadFullState(app) {
        return __awaiter(this, void 0, void 0, function* () {
            this.__app = app;
        });
    }
}
UpdateVoterEvent.moduleAddress = moduleAddress$C;
UpdateVoterEvent.moduleName = moduleName$C;
UpdateVoterEvent.structName = 'UpdateVoterEvent';
UpdateVoterEvent.typeParameters = [];
UpdateVoterEvent.fields = [
    { name: 'admin', typeTag: AtomicTypeTag.Address },
    { name: 'vesting_contract_address', typeTag: AtomicTypeTag.Address },
    { name: 'staking_pool_address', typeTag: AtomicTypeTag.Address },
    { name: 'old_voter', typeTag: AtomicTypeTag.Address },
    { name: 'new_voter', typeTag: AtomicTypeTag.Address }
];
class VestEvent {
    constructor(proto, typeTag) {
        this.typeTag = typeTag;
        this.__app = null;
        this.admin = proto['admin'];
        this.vesting_contract_address = proto['vesting_contract_address'];
        this.staking_pool_address = proto['staking_pool_address'];
        this.period_vested = proto['period_vested'];
        this.amount = proto['amount'];
    }
    static VestEventParser(data, typeTag, repo) {
        const proto = $.parseStructProto(data, typeTag, repo, VestEvent);
        return new VestEvent(proto, typeTag);
    }
    static getTag() {
        return new StructTag(moduleAddress$C, moduleName$C, 'VestEvent', []);
    }
    loadFullState(app) {
        return __awaiter(this, void 0, void 0, function* () {
            this.__app = app;
        });
    }
}
VestEvent.moduleAddress = moduleAddress$C;
VestEvent.moduleName = moduleName$C;
VestEvent.structName = 'VestEvent';
VestEvent.typeParameters = [];
VestEvent.fields = [
    { name: 'admin', typeTag: AtomicTypeTag.Address },
    { name: 'vesting_contract_address', typeTag: AtomicTypeTag.Address },
    { name: 'staking_pool_address', typeTag: AtomicTypeTag.Address },
    { name: 'period_vested', typeTag: AtomicTypeTag.U64 },
    { name: 'amount', typeTag: AtomicTypeTag.U64 }
];
class VestingAccountManagement {
    constructor(proto, typeTag) {
        this.typeTag = typeTag;
        this.__app = null;
        this.roles = proto['roles'];
    }
    static VestingAccountManagementParser(data, typeTag, repo) {
        const proto = $.parseStructProto(data, typeTag, repo, VestingAccountManagement);
        return new VestingAccountManagement(proto, typeTag);
    }
    static load(repo, client, address, typeParams) {
        return __awaiter(this, void 0, void 0, function* () {
            const result = yield repo.loadResource(client, address, VestingAccountManagement, typeParams);
            return result;
        });
    }
    static loadByApp(app, address, typeParams) {
        return __awaiter(this, void 0, void 0, function* () {
            const result = yield app.repo.loadResource(app.client, address, VestingAccountManagement, typeParams);
            yield result.loadFullState(app);
            return result;
        });
    }
    static getTag() {
        return new StructTag(moduleAddress$C, moduleName$C, 'VestingAccountManagement', []);
    }
    loadFullState(app) {
        return __awaiter(this, void 0, void 0, function* () {
            yield this.roles.loadFullState(app);
            this.__app = app;
        });
    }
}
VestingAccountManagement.moduleAddress = moduleAddress$C;
VestingAccountManagement.moduleName = moduleName$C;
VestingAccountManagement.structName = 'VestingAccountManagement';
VestingAccountManagement.typeParameters = [];
VestingAccountManagement.fields = [
    {
        name: 'roles',
        typeTag: new StructTag(new HexString('0x1'), 'simple_map', 'SimpleMap', [
            new StructTag(new HexString('0x1'), 'string', 'String', []),
            AtomicTypeTag.Address
        ])
    }
];
class VestingContract {
    constructor(proto, typeTag) {
        this.typeTag = typeTag;
        this.__app = null;
        this.state = proto['state'];
        this.admin = proto['admin'];
        this.grant_pool = proto['grant_pool'];
        this.beneficiaries = proto['beneficiaries'];
        this.vesting_schedule = proto['vesting_schedule'];
        this.withdrawal_address = proto['withdrawal_address'];
        this.staking = proto['staking'];
        this.remaining_grant = proto['remaining_grant'];
        this.signer_cap = proto['signer_cap'];
        this.update_operator_events = proto['update_operator_events'];
        this.update_voter_events = proto['update_voter_events'];
        this.reset_lockup_events = proto['reset_lockup_events'];
        this.set_beneficiary_events = proto['set_beneficiary_events'];
        this.unlock_rewards_events = proto['unlock_rewards_events'];
        this.vest_events = proto['vest_events'];
        this.distribute_events = proto['distribute_events'];
        this.terminate_events = proto['terminate_events'];
        this.admin_withdraw_events = proto['admin_withdraw_events'];
    }
    static VestingContractParser(data, typeTag, repo) {
        const proto = $.parseStructProto(data, typeTag, repo, VestingContract);
        return new VestingContract(proto, typeTag);
    }
    static load(repo, client, address, typeParams) {
        return __awaiter(this, void 0, void 0, function* () {
            const result = yield repo.loadResource(client, address, VestingContract, typeParams);
            return result;
        });
    }
    static loadByApp(app, address, typeParams) {
        return __awaiter(this, void 0, void 0, function* () {
            const result = yield app.repo.loadResource(app.client, address, VestingContract, typeParams);
            yield result.loadFullState(app);
            return result;
        });
    }
    static getTag() {
        return new StructTag(moduleAddress$C, moduleName$C, 'VestingContract', []);
    }
    loadFullState(app) {
        return __awaiter(this, void 0, void 0, function* () {
            yield this.grant_pool.loadFullState(app);
            yield this.beneficiaries.loadFullState(app);
            yield this.vesting_schedule.loadFullState(app);
            yield this.staking.loadFullState(app);
            yield this.signer_cap.loadFullState(app);
            yield this.update_operator_events.loadFullState(app);
            yield this.update_voter_events.loadFullState(app);
            yield this.reset_lockup_events.loadFullState(app);
            yield this.set_beneficiary_events.loadFullState(app);
            yield this.unlock_rewards_events.loadFullState(app);
            yield this.vest_events.loadFullState(app);
            yield this.distribute_events.loadFullState(app);
            yield this.terminate_events.loadFullState(app);
            yield this.admin_withdraw_events.loadFullState(app);
            this.__app = app;
        });
    }
}
VestingContract.moduleAddress = moduleAddress$C;
VestingContract.moduleName = moduleName$C;
VestingContract.structName = 'VestingContract';
VestingContract.typeParameters = [];
VestingContract.fields = [
    { name: 'state', typeTag: AtomicTypeTag.U64 },
    { name: 'admin', typeTag: AtomicTypeTag.Address },
    { name: 'grant_pool', typeTag: new StructTag(new HexString('0x1'), 'pool_u64', 'Pool', []) },
    {
        name: 'beneficiaries',
        typeTag: new StructTag(new HexString('0x1'), 'simple_map', 'SimpleMap', [
            AtomicTypeTag.Address,
            AtomicTypeTag.Address
        ])
    },
    { name: 'vesting_schedule', typeTag: new StructTag(new HexString('0x1'), 'vesting', 'VestingSchedule', []) },
    { name: 'withdrawal_address', typeTag: AtomicTypeTag.Address },
    { name: 'staking', typeTag: new StructTag(new HexString('0x1'), 'vesting', 'StakingInfo', []) },
    { name: 'remaining_grant', typeTag: AtomicTypeTag.U64 },
    { name: 'signer_cap', typeTag: new StructTag(new HexString('0x1'), 'account', 'SignerCapability', []) },
    {
        name: 'update_operator_events',
        typeTag: new StructTag(new HexString('0x1'), 'event', 'EventHandle', [
            new StructTag(new HexString('0x1'), 'vesting', 'UpdateOperatorEvent', [])
        ])
    },
    {
        name: 'update_voter_events',
        typeTag: new StructTag(new HexString('0x1'), 'event', 'EventHandle', [
            new StructTag(new HexString('0x1'), 'vesting', 'UpdateVoterEvent', [])
        ])
    },
    {
        name: 'reset_lockup_events',
        typeTag: new StructTag(new HexString('0x1'), 'event', 'EventHandle', [
            new StructTag(new HexString('0x1'), 'vesting', 'ResetLockupEvent', [])
        ])
    },
    {
        name: 'set_beneficiary_events',
        typeTag: new StructTag(new HexString('0x1'), 'event', 'EventHandle', [
            new StructTag(new HexString('0x1'), 'vesting', 'SetBeneficiaryEvent', [])
        ])
    },
    {
        name: 'unlock_rewards_events',
        typeTag: new StructTag(new HexString('0x1'), 'event', 'EventHandle', [
            new StructTag(new HexString('0x1'), 'vesting', 'UnlockRewardsEvent', [])
        ])
    },
    {
        name: 'vest_events',
        typeTag: new StructTag(new HexString('0x1'), 'event', 'EventHandle', [
            new StructTag(new HexString('0x1'), 'vesting', 'VestEvent', [])
        ])
    },
    {
        name: 'distribute_events',
        typeTag: new StructTag(new HexString('0x1'), 'event', 'EventHandle', [
            new StructTag(new HexString('0x1'), 'vesting', 'DistributeEvent', [])
        ])
    },
    {
        name: 'terminate_events',
        typeTag: new StructTag(new HexString('0x1'), 'event', 'EventHandle', [
            new StructTag(new HexString('0x1'), 'vesting', 'TerminateEvent', [])
        ])
    },
    {
        name: 'admin_withdraw_events',
        typeTag: new StructTag(new HexString('0x1'), 'event', 'EventHandle', [
            new StructTag(new HexString('0x1'), 'vesting', 'AdminWithdrawEvent', [])
        ])
    }
];
class VestingSchedule {
    constructor(proto, typeTag) {
        this.typeTag = typeTag;
        this.__app = null;
        this.schedule = proto['schedule'];
        this.start_timestamp_secs = proto['start_timestamp_secs'];
        this.period_duration = proto['period_duration'];
        this.last_vested_period = proto['last_vested_period'];
    }
    static VestingScheduleParser(data, typeTag, repo) {
        const proto = $.parseStructProto(data, typeTag, repo, VestingSchedule);
        return new VestingSchedule(proto, typeTag);
    }
    static getTag() {
        return new StructTag(moduleAddress$C, moduleName$C, 'VestingSchedule', []);
    }
    loadFullState(app) {
        return __awaiter(this, void 0, void 0, function* () {
            this.__app = app;
        });
    }
}
VestingSchedule.moduleAddress = moduleAddress$C;
VestingSchedule.moduleName = moduleName$C;
VestingSchedule.structName = 'VestingSchedule';
VestingSchedule.typeParameters = [];
VestingSchedule.fields = [
    {
        name: 'schedule',
        typeTag: new VectorTag(new StructTag(new HexString('0x1'), 'fixed_point32', 'FixedPoint32', []))
    },
    { name: 'start_timestamp_secs', typeTag: AtomicTypeTag.U64 },
    { name: 'period_duration', typeTag: AtomicTypeTag.U64 },
    { name: 'last_vested_period', typeTag: AtomicTypeTag.U64 }
];
function admin_withdraw_(admin, contract_address, $c) {
    let temp$2, temp$3, temp$4, temp$5, amount, coins, vesting_contract, vesting_contract__1;
    vesting_contract = $c.borrow_global(new SimpleStructTag(VestingContract), $.copy(contract_address));
    if (!$.copy(vesting_contract.state).eq($.copy(VESTING_POOL_TERMINATED))) {
        throw $.abortCode(invalid_state_($.copy(EVESTING_CONTRACT_STILL_ACTIVE)));
    }
    vesting_contract__1 = $c.borrow_global_mut(new SimpleStructTag(VestingContract), $.copy(contract_address));
    [temp$2, temp$3] = [admin, vesting_contract__1];
    verify_admin_(temp$2, temp$3, $c);
    [temp$4, temp$5] = [vesting_contract__1, $.copy(contract_address)];
    coins = withdraw_stake_(temp$4, temp$5, $c);
    amount = value_(coins, $c, [new StructTag(new HexString('0x1'), 'aptos_coin', 'AptosCoin', [])]);
    if ($.copy(amount).eq(u64('0'))) {
        destroy_zero_(coins, $c, [new StructTag(new HexString('0x1'), 'aptos_coin', 'AptosCoin', [])]);
        return;
    }
    deposit_$1($.copy(vesting_contract__1.withdrawal_address), coins, $c, [
        new StructTag(new HexString('0x1'), 'aptos_coin', 'AptosCoin', [])
    ]);
    emit_event_(vesting_contract__1.admin_withdraw_events, new AdminWithdrawEvent({
        admin: $.copy(vesting_contract__1.admin),
        vesting_contract_address: $.copy(contract_address),
        amount: $.copy(amount)
    }, new SimpleStructTag(AdminWithdrawEvent)), $c, [new SimpleStructTag(AdminWithdrawEvent)]);
    return;
}
function buildPayload_admin_withdraw(contract_address, isJSON = false) {
    const typeParamStrings = [];
    return $.buildPayload(new HexString('0x1'), 'vesting', 'admin_withdraw', typeParamStrings, [contract_address], isJSON);
}
function assert_active_vesting_contract_(contract_address, $c) {
    let vesting_contract;
    assert_vesting_contract_exists_($.copy(contract_address), $c);
    vesting_contract = $c.borrow_global(new SimpleStructTag(VestingContract), $.copy(contract_address));
    if (!$.copy(vesting_contract.state).eq($.copy(VESTING_POOL_ACTIVE))) {
        throw $.abortCode(invalid_state_($.copy(EVESTING_CONTRACT_NOT_ACTIVE)));
    }
    return;
}
function assert_vesting_contract_exists_(contract_address, $c) {
    if (!$c.exists(new SimpleStructTag(VestingContract), $.copy(contract_address))) {
        throw $.abortCode(not_found_($.copy(EVESTING_CONTRACT_NOT_FOUND)));
    }
    return;
}
function beneficiary_(vesting_contract_address, shareholder, $c) {
    assert_vesting_contract_exists_($.copy(vesting_contract_address), $c);
    return get_beneficiary_($c.borrow_global(new SimpleStructTag(VestingContract), $.copy(vesting_contract_address)), $.copy(shareholder), $c);
}
function create_vesting_contract_(admin, shareholders, buy_ins, vesting_schedule, withdrawal_address, operator, voter, commission_percentage, contract_creation_seed, $c) {
    let temp$1, temp$2, temp$3, temp$4, temp$5, temp$6, temp$7, temp$8, admin_address, admin_store, buy_in, buy_in_amount, contract_address, contract_signer, contract_signer_cap, grant, grant_amount, grant_pool, i, len, pool_address, shareholder;
    if (!!is_reserved_address_($.copy(withdrawal_address))) {
        throw $.abortCode(invalid_argument_($.copy(EINVALID_WITHDRAWAL_ADDRESS)));
    }
    assert_account_is_registered_for_apt_($.copy(withdrawal_address), $c);
    if (!length_$6(shareholders, $c, [AtomicTypeTag.Address]).gt(u64('0'))) {
        throw $.abortCode(invalid_argument_($.copy(ENO_SHAREHOLDERS)));
    }
    if (!length_$4(buy_ins, $c, [
        AtomicTypeTag.Address,
        new StructTag(new HexString('0x1'), 'coin', 'Coin', [
            new StructTag(new HexString('0x1'), 'aptos_coin', 'AptosCoin', [])
        ])
    ]).eq(length_$6(shareholders, $c, [AtomicTypeTag.Address]))) {
        throw $.abortCode(invalid_argument_($.copy(ESHARES_LENGTH_MISMATCH)));
    }
    grant = zero_$1($c, [new StructTag(new HexString('0x1'), 'aptos_coin', 'AptosCoin', [])]);
    grant_amount = u64('0');
    grant_pool = create_($.copy(MAXIMUM_SHAREHOLDERS), $c);
    len = length_$6(shareholders, $c, [AtomicTypeTag.Address]);
    i = u64('0');
    while ($.copy(i).lt($.copy(len))) {
        {
            shareholder = $.copy(borrow_$7(shareholders, $.copy(i), $c, [AtomicTypeTag.Address]));
            [, buy_in] = remove_$2(buy_ins, shareholder, $c, [
                AtomicTypeTag.Address,
                new StructTag(new HexString('0x1'), 'coin', 'Coin', [
                    new StructTag(new HexString('0x1'), 'aptos_coin', 'AptosCoin', [])
                ])
            ]);
            buy_in_amount = value_(buy_in, $c, [new StructTag(new HexString('0x1'), 'aptos_coin', 'AptosCoin', [])]);
            merge_(grant, buy_in, $c, [new StructTag(new HexString('0x1'), 'aptos_coin', 'AptosCoin', [])]);
            buy_in_(grant_pool, $.copy(borrow_$7(shareholders, $.copy(i), $c, [AtomicTypeTag.Address])), $.copy(buy_in_amount), $c);
            grant_amount = $.copy(grant_amount).add($.copy(buy_in_amount));
            i = $.copy(i).add(u64('1'));
        }
    }
    if (!$.copy(grant_amount).gt(u64('0'))) {
        throw $.abortCode(invalid_argument_($.copy(EZERO_GRANT)));
    }
    admin_address = address_of_(admin, $c);
    if (!$c.exists(new SimpleStructTag(AdminStore), $.copy(admin_address))) {
        $c.move_to(new SimpleStructTag(AdminStore), admin, new AdminStore({
            vesting_contracts: empty_$5($c, [AtomicTypeTag.Address]),
            nonce: u64('0'),
            create_events: new_event_handle_(admin, $c, [new SimpleStructTag(CreateVestingContractEvent)])
        }, new SimpleStructTag(AdminStore)));
    }
    [contract_signer, contract_signer_cap] = create_vesting_contract_account_(admin, $.copy(contract_creation_seed), $c);
    pool_address = create_staking_contract_with_coins_(contract_signer, $.copy(operator), $.copy(voter), grant, $.copy(commission_percentage), $.copy(contract_creation_seed), $c);
    contract_address = address_of_(contract_signer, $c);
    admin_store = $c.borrow_global_mut(new SimpleStructTag(AdminStore), $.copy(admin_address));
    push_back_(admin_store.vesting_contracts, $.copy(contract_address), $c, [AtomicTypeTag.Address]);
    temp$8 = admin_store.create_events;
    temp$1 = $.copy(operator);
    temp$2 = $.copy(voter);
    temp$3 = $.copy(withdrawal_address);
    temp$4 = $.copy(grant_amount);
    temp$5 = $.copy(contract_address);
    temp$6 = $.copy(pool_address);
    temp$7 = $.copy(commission_percentage);
    emit_event_(temp$8, new CreateVestingContractEvent({
        operator: temp$1,
        voter: temp$2,
        grant_amount: temp$4,
        withdrawal_address: temp$3,
        vesting_contract_address: temp$5,
        staking_pool_address: temp$6,
        commission_percentage: temp$7
    }, new SimpleStructTag(CreateVestingContractEvent)), $c, [new SimpleStructTag(CreateVestingContractEvent)]);
    $c.move_to(new SimpleStructTag(VestingContract), contract_signer, new VestingContract({
        state: $.copy(VESTING_POOL_ACTIVE),
        admin: $.copy(admin_address),
        grant_pool: grant_pool,
        beneficiaries: create_$2($c, [AtomicTypeTag.Address, AtomicTypeTag.Address]),
        vesting_schedule: $.copy(vesting_schedule),
        withdrawal_address: $.copy(withdrawal_address),
        staking: new StakingInfo({
            pool_address: $.copy(pool_address),
            operator: $.copy(operator),
            voter: $.copy(voter),
            commission_percentage: $.copy(commission_percentage)
        }, new SimpleStructTag(StakingInfo)),
        remaining_grant: $.copy(grant_amount),
        signer_cap: contract_signer_cap,
        update_operator_events: new_event_handle_(contract_signer, $c, [
            new SimpleStructTag(UpdateOperatorEvent)
        ]),
        update_voter_events: new_event_handle_(contract_signer, $c, [new SimpleStructTag(UpdateVoterEvent)]),
        reset_lockup_events: new_event_handle_(contract_signer, $c, [new SimpleStructTag(ResetLockupEvent)]),
        set_beneficiary_events: new_event_handle_(contract_signer, $c, [
            new SimpleStructTag(SetBeneficiaryEvent)
        ]),
        unlock_rewards_events: new_event_handle_(contract_signer, $c, [
            new SimpleStructTag(UnlockRewardsEvent)
        ]),
        vest_events: new_event_handle_(contract_signer, $c, [new SimpleStructTag(VestEvent)]),
        distribute_events: new_event_handle_(contract_signer, $c, [new SimpleStructTag(DistributeEvent)]),
        terminate_events: new_event_handle_(contract_signer, $c, [new SimpleStructTag(TerminateEvent)]),
        admin_withdraw_events: new_event_handle_(contract_signer, $c, [new SimpleStructTag(AdminWithdrawEvent)])
    }, new SimpleStructTag(VestingContract)));
    destroy_empty_$4(buy_ins, $c, [
        AtomicTypeTag.Address,
        new StructTag(new HexString('0x1'), 'coin', 'Coin', [
            new StructTag(new HexString('0x1'), 'aptos_coin', 'AptosCoin', [])
        ])
    ]);
    return $.copy(contract_address);
}
function create_vesting_contract_account_(admin, contract_creation_seed, $c) {
    let temp$1, account_signer, admin_store, seed, signer_cap;
    admin_store = $c.borrow_global_mut(new SimpleStructTag(AdminStore), address_of_(admin, $c));
    temp$1 = address_of_(admin, $c);
    seed = to_bytes_(temp$1, $c, [AtomicTypeTag.Address]);
    append_$3(seed, to_bytes_(admin_store.nonce, $c, [AtomicTypeTag.U64]), $c, [AtomicTypeTag.U8]);
    admin_store.nonce = $.copy(admin_store.nonce).add(u64('1'));
    append_$3(seed, $.copy(VESTING_POOL_SALT), $c, [AtomicTypeTag.U8]);
    append_$3(seed, $.copy(contract_creation_seed), $c, [AtomicTypeTag.U8]);
    [account_signer, signer_cap] = create_resource_account_$1(admin, $.copy(seed), $c);
    register_$2(account_signer, $c, [new StructTag(new HexString('0x1'), 'aptos_coin', 'AptosCoin', [])]);
    return [account_signer, signer_cap];
}
function create_vesting_schedule_(schedule, start_timestamp_secs, period_duration, $c) {
    if (!length_$6(schedule, $c, [new StructTag(new HexString('0x1'), 'fixed_point32', 'FixedPoint32', [])]).gt(u64('0'))) {
        throw $.abortCode(invalid_argument_($.copy(EEMPTY_VESTING_SCHEDULE)));
    }
    if (!$.copy(period_duration).gt(u64('0'))) {
        throw $.abortCode(invalid_argument_($.copy(EZERO_VESTING_SCHEDULE_PERIOD)));
    }
    if (!$.copy(start_timestamp_secs).ge(now_seconds_($c))) {
        throw $.abortCode(invalid_argument_($.copy(EVESTING_START_TOO_SOON)));
    }
    return new VestingSchedule({
        schedule: $.copy(schedule),
        start_timestamp_secs: $.copy(start_timestamp_secs),
        period_duration: $.copy(period_duration),
        last_vested_period: u64('0')
    }, new SimpleStructTag(VestingSchedule));
}
function distribute_(contract_address, $c) {
    let temp$1, temp$2, temp$3, temp$4, temp$5, amount, coins, grant_pool, i, len, recipient_address, share_of_coins, shareholder, shareholders, shares, total_distribution_amount, vesting_contract;
    assert_active_vesting_contract_($.copy(contract_address), $c);
    vesting_contract = $c.borrow_global_mut(new SimpleStructTag(VestingContract), $.copy(contract_address));
    [temp$1, temp$2] = [vesting_contract, $.copy(contract_address)];
    coins = withdraw_stake_(temp$1, temp$2, $c);
    total_distribution_amount = value_(coins, $c, [
        new StructTag(new HexString('0x1'), 'aptos_coin', 'AptosCoin', [])
    ]);
    if ($.copy(total_distribution_amount).eq(u64('0'))) {
        destroy_zero_(coins, $c, [new StructTag(new HexString('0x1'), 'aptos_coin', 'AptosCoin', [])]);
        return;
    }
    grant_pool = vesting_contract.grant_pool;
    temp$3 = shareholders_(grant_pool);
    shareholders = temp$3;
    len = length_$6(shareholders, $c, [AtomicTypeTag.Address]);
    i = u64('0');
    while ($.copy(i).lt($.copy(len))) {
        {
            shareholder = $.copy(borrow_$7(shareholders, $.copy(i), $c, [AtomicTypeTag.Address]));
            shares = shares_(grant_pool, $.copy(shareholder), $c);
            amount = shares_to_amount_with_total_coins_(grant_pool, $.copy(shares), $.copy(total_distribution_amount));
            share_of_coins = extract_(coins, $.copy(amount), $c, [
                new StructTag(new HexString('0x1'), 'aptos_coin', 'AptosCoin', [])
            ]);
            [temp$4, temp$5] = [vesting_contract, $.copy(shareholder)];
            recipient_address = get_beneficiary_(temp$4, temp$5, $c);
            deposit_$1($.copy(recipient_address), share_of_coins, $c, [
                new StructTag(new HexString('0x1'), 'aptos_coin', 'AptosCoin', [])
            ]);
            i = $.copy(i).add(u64('1'));
        }
    }
    if (value_(coins, $c, [new StructTag(new HexString('0x1'), 'aptos_coin', 'AptosCoin', [])]).gt(u64('0'))) {
        deposit_$1($.copy(vesting_contract.withdrawal_address), coins, $c, [
            new StructTag(new HexString('0x1'), 'aptos_coin', 'AptosCoin', [])
        ]);
    }
    else {
        destroy_zero_(coins, $c, [new StructTag(new HexString('0x1'), 'aptos_coin', 'AptosCoin', [])]);
    }
    emit_event_(vesting_contract.distribute_events, new DistributeEvent({
        admin: $.copy(vesting_contract.admin),
        vesting_contract_address: $.copy(contract_address),
        amount: $.copy(total_distribution_amount)
    }, new SimpleStructTag(DistributeEvent)), $c, [new SimpleStructTag(DistributeEvent)]);
    return;
}
function buildPayload_distribute(contract_address, isJSON = false) {
    const typeParamStrings = [];
    return $.buildPayload(new HexString('0x1'), 'vesting', 'distribute', typeParamStrings, [contract_address], isJSON);
}
function get_beneficiary_(contract, shareholder, $c) {
    let temp$1;
    if (contains_key_(contract.beneficiaries, shareholder, $c, [AtomicTypeTag.Address, AtomicTypeTag.Address])) {
        temp$1 = $.copy(borrow_$4(contract.beneficiaries, shareholder, $c, [AtomicTypeTag.Address, AtomicTypeTag.Address]));
    }
    else {
        temp$1 = $.copy(shareholder);
    }
    return temp$1;
}
function get_role_holder_(contract_address, role, $c) {
    let roles;
    if (!$c.exists(new SimpleStructTag(VestingAccountManagement), $.copy(contract_address))) {
        throw $.abortCode(not_found_($.copy(EVESTING_ACCOUNT_HAS_NO_ROLES)));
    }
    roles = $c.borrow_global(new SimpleStructTag(VestingAccountManagement), $.copy(contract_address)).roles;
    if (!contains_key_(roles, role, $c, [
        new StructTag(new HexString('0x1'), 'string', 'String', []),
        AtomicTypeTag.Address
    ])) {
        throw $.abortCode(not_found_($.copy(EROLE_NOT_FOUND)));
    }
    return $.copy(borrow_$4(roles, role, $c, [
        new StructTag(new HexString('0x1'), 'string', 'String', []),
        AtomicTypeTag.Address
    ]));
}
function get_vesting_account_signer_(admin, contract_address, $c) {
    let temp$1, temp$2, vesting_contract;
    vesting_contract = $c.borrow_global_mut(new SimpleStructTag(VestingContract), $.copy(contract_address));
    [temp$1, temp$2] = [admin, vesting_contract];
    verify_admin_(temp$1, temp$2, $c);
    return get_vesting_account_signer_internal_(vesting_contract, $c);
}
function get_vesting_account_signer_internal_(vesting_contract, $c) {
    return create_signer_with_capability_(vesting_contract.signer_cap, $c);
}
function operator_(vesting_contract_address, $c) {
    assert_vesting_contract_exists_($.copy(vesting_contract_address), $c);
    return $.copy($c.borrow_global(new SimpleStructTag(VestingContract), $.copy(vesting_contract_address)).staking
        .operator);
}
function operator_commission_percentage_(vesting_contract_address, $c) {
    assert_vesting_contract_exists_($.copy(vesting_contract_address), $c);
    return $.copy($c.borrow_global(new SimpleStructTag(VestingContract), $.copy(vesting_contract_address)).staking
        .commission_percentage);
}
function remaining_grant_(vesting_contract_address, $c) {
    assert_vesting_contract_exists_($.copy(vesting_contract_address), $c);
    return $.copy($c.borrow_global(new SimpleStructTag(VestingContract), $.copy(vesting_contract_address))
        .remaining_grant);
}
function reset_beneficiary_(account, contract_address, shareholder, $c) {
    let temp$1, temp$2, temp$3, addr, beneficiaries, vesting_contract;
    vesting_contract = $c.borrow_global_mut(new SimpleStructTag(VestingContract), $.copy(contract_address));
    addr = address_of_(account, $c);
    if ($.copy(addr).hex() === $.copy(vesting_contract.admin).hex()) {
        temp$1 = true;
    }
    else {
        temp$1 =
            $.copy(addr).hex() ===
                get_role_holder_($.copy(contract_address), utf8_($.copy(ROLE_BENEFICIARY_RESETTER), $c), $c).hex();
    }
    if (!temp$1) {
        throw $.abortCode(permission_denied_($.copy(EPERMISSION_DENIED)));
    }
    beneficiaries = vesting_contract.beneficiaries;
    [temp$2, temp$3] = [beneficiaries, shareholder];
    if (contains_key_(temp$2, temp$3, $c, [AtomicTypeTag.Address, AtomicTypeTag.Address])) {
        remove_$2(beneficiaries, shareholder, $c, [AtomicTypeTag.Address, AtomicTypeTag.Address]);
    }
    return;
}
function buildPayload_reset_beneficiary(contract_address, shareholder, isJSON = false) {
    const typeParamStrings = [];
    return $.buildPayload(new HexString('0x1'), 'vesting', 'reset_beneficiary', typeParamStrings, [contract_address, shareholder], isJSON);
}
function reset_lockup_(admin, contract_address, $c) {
    let temp$1, temp$2, temp$3, contract_signer, vesting_contract;
    vesting_contract = $c.borrow_global_mut(new SimpleStructTag(VestingContract), $.copy(contract_address));
    [temp$1, temp$2] = [admin, vesting_contract];
    verify_admin_(temp$1, temp$2, $c);
    temp$3 = get_vesting_account_signer_internal_(vesting_contract, $c);
    contract_signer = temp$3;
    reset_lockup_$1(contract_signer, $.copy(vesting_contract.staking.operator), $c);
    emit_event_(vesting_contract.reset_lockup_events, new ResetLockupEvent({
        admin: $.copy(vesting_contract.admin),
        vesting_contract_address: $.copy(contract_address),
        staking_pool_address: $.copy(vesting_contract.staking.pool_address),
        new_lockup_expiration_secs: get_lockup_secs_($.copy(vesting_contract.staking.pool_address), $c)
    }, new SimpleStructTag(ResetLockupEvent)), $c, [new SimpleStructTag(ResetLockupEvent)]);
    return;
}
function buildPayload_reset_lockup(contract_address, isJSON = false) {
    const typeParamStrings = [];
    return $.buildPayload(new HexString('0x1'), 'vesting', 'reset_lockup', typeParamStrings, [contract_address], isJSON);
}
function set_beneficiary_(admin, contract_address, shareholder, new_beneficiary, $c) {
    let temp$1, temp$2, temp$3, temp$4, temp$5, temp$6, beneficiaries, beneficiary, old_beneficiary, vesting_contract;
    assert_account_is_registered_for_apt_($.copy(new_beneficiary), $c);
    vesting_contract = $c.borrow_global_mut(new SimpleStructTag(VestingContract), $.copy(contract_address));
    [temp$1, temp$2] = [admin, vesting_contract];
    verify_admin_(temp$1, temp$2, $c);
    [temp$3, temp$4] = [vesting_contract, $.copy(shareholder)];
    old_beneficiary = get_beneficiary_(temp$3, temp$4, $c);
    beneficiaries = vesting_contract.beneficiaries;
    [temp$5, temp$6] = [beneficiaries, shareholder];
    if (contains_key_(temp$5, temp$6, $c, [AtomicTypeTag.Address, AtomicTypeTag.Address])) {
        beneficiary = borrow_mut_$4(beneficiaries, shareholder, $c, [
            AtomicTypeTag.Address,
            AtomicTypeTag.Address
        ]);
        $.set(beneficiary, $.copy(new_beneficiary));
    }
    else {
        add_$4(beneficiaries, $.copy(shareholder), $.copy(new_beneficiary), $c, [
            AtomicTypeTag.Address,
            AtomicTypeTag.Address
        ]);
    }
    emit_event_(vesting_contract.set_beneficiary_events, new SetBeneficiaryEvent({
        admin: $.copy(vesting_contract.admin),
        vesting_contract_address: $.copy(contract_address),
        shareholder: $.copy(shareholder),
        old_beneficiary: $.copy(old_beneficiary),
        new_beneficiary: $.copy(new_beneficiary)
    }, new SimpleStructTag(SetBeneficiaryEvent)), $c, [new SimpleStructTag(SetBeneficiaryEvent)]);
    return;
}
function buildPayload_set_beneficiary(contract_address, shareholder, new_beneficiary, isJSON = false) {
    const typeParamStrings = [];
    return $.buildPayload(new HexString('0x1'), 'vesting', 'set_beneficiary', typeParamStrings, [contract_address, shareholder, new_beneficiary], isJSON);
}
function set_beneficiary_resetter_(admin, contract_address, beneficiary_resetter, $c) {
    set_management_role_(admin, $.copy(contract_address), utf8_($.copy(ROLE_BENEFICIARY_RESETTER), $c), $.copy(beneficiary_resetter), $c);
    return;
}
function buildPayload_set_beneficiary_resetter(contract_address, beneficiary_resetter, isJSON = false) {
    const typeParamStrings = [];
    return $.buildPayload(new HexString('0x1'), 'vesting', 'set_beneficiary_resetter', typeParamStrings, [contract_address, beneficiary_resetter], isJSON);
}
function set_management_role_(admin, contract_address, role, role_holder, $c) {
    let temp$1, temp$2, temp$3, temp$4, temp$5, contract_signer, roles, vesting_contract;
    vesting_contract = $c.borrow_global_mut(new SimpleStructTag(VestingContract), $.copy(contract_address));
    [temp$1, temp$2] = [admin, vesting_contract];
    verify_admin_(temp$1, temp$2, $c);
    if (!$c.exists(new SimpleStructTag(VestingAccountManagement), $.copy(contract_address))) {
        temp$3 = get_vesting_account_signer_internal_(vesting_contract, $c);
        contract_signer = temp$3;
        $c.move_to(new SimpleStructTag(VestingAccountManagement), contract_signer, new VestingAccountManagement({
            roles: create_$2($c, [
                new StructTag(new HexString('0x1'), 'string', 'String', []),
                AtomicTypeTag.Address
            ])
        }, new SimpleStructTag(VestingAccountManagement)));
    }
    roles = $c.borrow_global_mut(new SimpleStructTag(VestingAccountManagement), $.copy(contract_address)).roles;
    [temp$4, temp$5] = [roles, role];
    if (contains_key_(temp$4, temp$5, $c, [
        new StructTag(new HexString('0x1'), 'string', 'String', []),
        AtomicTypeTag.Address
    ])) {
        $.set(borrow_mut_$4(roles, role, $c, [
            new StructTag(new HexString('0x1'), 'string', 'String', []),
            AtomicTypeTag.Address
        ]), $.copy(role_holder));
    }
    else {
        add_$4(roles, $.copy(role), $.copy(role_holder), $c, [
            new StructTag(new HexString('0x1'), 'string', 'String', []),
            AtomicTypeTag.Address
        ]);
    }
    return;
}
function buildPayload_set_management_role(contract_address, role, role_holder, isJSON = false) {
    const typeParamStrings = [];
    return $.buildPayload(new HexString('0x1'), 'vesting', 'set_management_role', typeParamStrings, [contract_address, role, role_holder], isJSON);
}
function stake_pool_address_(vesting_contract_address, $c) {
    assert_vesting_contract_exists_($.copy(vesting_contract_address), $c);
    return $.copy($c.borrow_global(new SimpleStructTag(VestingContract), $.copy(vesting_contract_address)).staking
        .pool_address);
}
function terminate_vesting_contract_(admin, contract_address, $c) {
    let temp$1, temp$2, temp$3, temp$4, active_stake, pending_active_stake, vesting_contract;
    assert_active_vesting_contract_($.copy(contract_address), $c);
    distribute_($.copy(contract_address), $c);
    vesting_contract = $c.borrow_global_mut(new SimpleStructTag(VestingContract), $.copy(contract_address));
    [temp$1, temp$2] = [admin, vesting_contract];
    verify_admin_(temp$1, temp$2, $c);
    [active_stake, , pending_active_stake] = get_stake_($.copy(vesting_contract.staking.pool_address), $c);
    if (!$.copy(pending_active_stake).eq(u64('0'))) {
        throw $.abortCode(invalid_state_($.copy(EPENDING_STAKE_FOUND)));
    }
    vesting_contract.state = $.copy(VESTING_POOL_TERMINATED);
    vesting_contract.remaining_grant = u64('0');
    [temp$3, temp$4] = [vesting_contract, $.copy(active_stake)];
    unlock_stake_(temp$3, temp$4, $c);
    emit_event_(vesting_contract.terminate_events, new TerminateEvent({ admin: $.copy(vesting_contract.admin), vesting_contract_address: $.copy(contract_address) }, new SimpleStructTag(TerminateEvent)), $c, [new SimpleStructTag(TerminateEvent)]);
    return;
}
function buildPayload_terminate_vesting_contract(contract_address, isJSON = false) {
    const typeParamStrings = [];
    return $.buildPayload(new HexString('0x1'), 'vesting', 'terminate_vesting_contract', typeParamStrings, [contract_address], isJSON);
}
function unlock_rewards_(contract_address, $c) {
    let temp$1, contract_signer, vesting_contract;
    assert_active_vesting_contract_($.copy(contract_address), $c);
    vesting_contract = $c.borrow_global_mut(new SimpleStructTag(VestingContract), $.copy(contract_address));
    temp$1 = get_vesting_account_signer_internal_(vesting_contract, $c);
    contract_signer = temp$1;
    unlock_rewards_$1(contract_signer, $.copy(vesting_contract.staking.operator), $c);
    return;
}
function buildPayload_unlock_rewards(contract_address, isJSON = false) {
    const typeParamStrings = [];
    return $.buildPayload(new HexString('0x1'), 'vesting', 'unlock_rewards', typeParamStrings, [contract_address], isJSON);
}
function unlock_stake_(vesting_contract, amount, $c) {
    let temp$1, contract_signer;
    temp$1 = get_vesting_account_signer_internal_(vesting_contract, $c);
    contract_signer = temp$1;
    unlock_stake_$1(contract_signer, $.copy(vesting_contract.staking.operator), $.copy(amount), $c);
    return;
}
function update_operator_(admin, contract_address, new_operator, commission_percentage, $c) {
    let temp$1, temp$2, temp$3, contract_signer, old_operator, vesting_contract;
    vesting_contract = $c.borrow_global_mut(new SimpleStructTag(VestingContract), $.copy(contract_address));
    [temp$1, temp$2] = [admin, vesting_contract];
    verify_admin_(temp$1, temp$2, $c);
    temp$3 = get_vesting_account_signer_internal_(vesting_contract, $c);
    contract_signer = temp$3;
    old_operator = $.copy(vesting_contract.staking.operator);
    switch_operator_(contract_signer, $.copy(old_operator), $.copy(new_operator), $.copy(commission_percentage), $c);
    vesting_contract.staking.operator = $.copy(new_operator);
    vesting_contract.staking.commission_percentage = $.copy(commission_percentage);
    emit_event_(vesting_contract.update_operator_events, new UpdateOperatorEvent({
        admin: $.copy(vesting_contract.admin),
        vesting_contract_address: $.copy(contract_address),
        staking_pool_address: $.copy(vesting_contract.staking.pool_address),
        old_operator: $.copy(old_operator),
        new_operator: $.copy(new_operator),
        commission_percentage: $.copy(commission_percentage)
    }, new SimpleStructTag(UpdateOperatorEvent)), $c, [new SimpleStructTag(UpdateOperatorEvent)]);
    return;
}
function buildPayload_update_operator(contract_address, new_operator, commission_percentage, isJSON = false) {
    const typeParamStrings = [];
    return $.buildPayload(new HexString('0x1'), 'vesting', 'update_operator', typeParamStrings, [contract_address, new_operator, commission_percentage], isJSON);
}
function update_operator_with_same_commission_(admin, contract_address, new_operator, $c) {
    let commission_percentage;
    commission_percentage = operator_commission_percentage_($.copy(contract_address), $c);
    update_operator_(admin, $.copy(contract_address), $.copy(new_operator), $.copy(commission_percentage), $c);
    return;
}
function buildPayload_update_operator_with_same_commission(contract_address, new_operator, isJSON = false) {
    const typeParamStrings = [];
    return $.buildPayload(new HexString('0x1'), 'vesting', 'update_operator_with_same_commission', typeParamStrings, [contract_address, new_operator], isJSON);
}
function update_voter_(admin, contract_address, new_voter, $c) {
    let temp$1, temp$2, temp$3, contract_signer, old_voter, vesting_contract;
    vesting_contract = $c.borrow_global_mut(new SimpleStructTag(VestingContract), $.copy(contract_address));
    [temp$1, temp$2] = [admin, vesting_contract];
    verify_admin_(temp$1, temp$2, $c);
    temp$3 = get_vesting_account_signer_internal_(vesting_contract, $c);
    contract_signer = temp$3;
    old_voter = $.copy(vesting_contract.staking.voter);
    update_voter_$1(contract_signer, $.copy(vesting_contract.staking.operator), $.copy(new_voter), $c);
    vesting_contract.staking.voter = $.copy(new_voter);
    emit_event_(vesting_contract.update_voter_events, new UpdateVoterEvent({
        admin: $.copy(vesting_contract.admin),
        vesting_contract_address: $.copy(contract_address),
        staking_pool_address: $.copy(vesting_contract.staking.pool_address),
        old_voter: $.copy(old_voter),
        new_voter: $.copy(new_voter)
    }, new SimpleStructTag(UpdateVoterEvent)), $c, [new SimpleStructTag(UpdateVoterEvent)]);
    return;
}
function buildPayload_update_voter(contract_address, new_voter, isJSON = false) {
    const typeParamStrings = [];
    return $.buildPayload(new HexString('0x1'), 'vesting', 'update_voter', typeParamStrings, [contract_address, new_voter], isJSON);
}
function verify_admin_(admin, vesting_contract, $c) {
    if (!(address_of_(admin, $c).hex() === $.copy(vesting_contract.admin).hex())) {
        throw $.abortCode(unauthenticated_($.copy(ENOT_ADMIN)));
    }
    return;
}
function vest_(contract_address, $c) {
    let temp$1, temp$2, temp$3, last_completed_period, last_vested_period, next_period_to_vest, schedule, schedule_index, total_grant, vested_amount, vesting_contract, vesting_fraction, vesting_schedule;
    unlock_rewards_($.copy(contract_address), $c);
    vesting_contract = $c.borrow_global_mut(new SimpleStructTag(VestingContract), $.copy(contract_address));
    if ($.copy(vesting_contract.vesting_schedule.start_timestamp_secs).gt(now_seconds_($c))) {
        return;
    }
    vesting_schedule = vesting_contract.vesting_schedule;
    last_vested_period = $.copy(vesting_schedule.last_vested_period);
    next_period_to_vest = $.copy(last_vested_period).add(u64('1'));
    last_completed_period = now_seconds_($c)
        .sub($.copy(vesting_schedule.start_timestamp_secs))
        .div($.copy(vesting_schedule.period_duration));
    if ($.copy(last_completed_period).lt($.copy(next_period_to_vest))) {
        return;
    }
    schedule = vesting_schedule.schedule;
    schedule_index = $.copy(next_period_to_vest).sub(u64('1'));
    if ($.copy(schedule_index).lt(length_$6(schedule, $c, [new StructTag(new HexString('0x1'), 'fixed_point32', 'FixedPoint32', [])]))) {
        temp$1 = $.copy(borrow_$7(schedule, $.copy(schedule_index), $c, [
            new StructTag(new HexString('0x1'), 'fixed_point32', 'FixedPoint32', [])
        ]));
    }
    else {
        temp$1 = $.copy(borrow_$7(schedule, length_$6(schedule, $c, [new StructTag(new HexString('0x1'), 'fixed_point32', 'FixedPoint32', [])]).sub(u64('1')), $c, [new StructTag(new HexString('0x1'), 'fixed_point32', 'FixedPoint32', [])]));
    }
    vesting_fraction = temp$1;
    total_grant = total_coins_(vesting_contract.grant_pool);
    vested_amount = multiply_u64_($.copy(total_grant), $.copy(vesting_fraction));
    vested_amount = min_$1($.copy(vested_amount), $.copy(vesting_contract.remaining_grant));
    vesting_contract.remaining_grant = $.copy(vesting_contract.remaining_grant).sub($.copy(vested_amount));
    vesting_schedule.last_vested_period = $.copy(next_period_to_vest);
    [temp$2, temp$3] = [vesting_contract, $.copy(vested_amount)];
    unlock_stake_(temp$2, temp$3, $c);
    emit_event_(vesting_contract.vest_events, new VestEvent({
        admin: $.copy(vesting_contract.admin),
        vesting_contract_address: $.copy(contract_address),
        staking_pool_address: $.copy(vesting_contract.staking.pool_address),
        period_vested: $.copy(next_period_to_vest),
        amount: $.copy(vested_amount)
    }, new SimpleStructTag(VestEvent)), $c, [new SimpleStructTag(VestEvent)]);
    return;
}
function buildPayload_vest(contract_address, isJSON = false) {
    const typeParamStrings = [];
    return $.buildPayload(new HexString('0x1'), 'vesting', 'vest', typeParamStrings, [contract_address], isJSON);
}
function vesting_contracts_(admin, $c) {
    let temp$1;
    if (!$c.exists(new SimpleStructTag(AdminStore), $.copy(admin))) {
        temp$1 = empty_$5($c, [AtomicTypeTag.Address]);
    }
    else {
        temp$1 = $.copy($c.borrow_global(new SimpleStructTag(AdminStore), $.copy(admin)).vesting_contracts);
    }
    return temp$1;
}
function vesting_start_secs_(vesting_contract_address, $c) {
    assert_vesting_contract_exists_($.copy(vesting_contract_address), $c);
    return $.copy($c.borrow_global(new SimpleStructTag(VestingContract), $.copy(vesting_contract_address))
        .vesting_schedule.start_timestamp_secs);
}
function voter_(vesting_contract_address, $c) {
    assert_vesting_contract_exists_($.copy(vesting_contract_address), $c);
    return $.copy($c.borrow_global(new SimpleStructTag(VestingContract), $.copy(vesting_contract_address)).staking
        .voter);
}
function withdraw_stake_(vesting_contract, contract_address, $c) {
    let temp$1, contract_signer, withdrawn_coins;
    distribute_$1($.copy(contract_address), $.copy(vesting_contract.staking.operator), $c);
    withdrawn_coins = balance_$1($.copy(contract_address), $c, [
        new StructTag(new HexString('0x1'), 'aptos_coin', 'AptosCoin', [])
    ]);
    temp$1 = get_vesting_account_signer_internal_(vesting_contract, $c);
    contract_signer = temp$1;
    return withdraw_$1(contract_signer, $.copy(withdrawn_coins), $c, [
        new StructTag(new HexString('0x1'), 'aptos_coin', 'AptosCoin', [])
    ]);
}
function loadParsers$P(repo) {
    repo.addParser('0x1::vesting::AdminStore', AdminStore.AdminStoreParser);
    repo.addParser('0x1::vesting::AdminWithdrawEvent', AdminWithdrawEvent.AdminWithdrawEventParser);
    repo.addParser('0x1::vesting::CreateVestingContractEvent', CreateVestingContractEvent.CreateVestingContractEventParser);
    repo.addParser('0x1::vesting::DistributeEvent', DistributeEvent.DistributeEventParser);
    repo.addParser('0x1::vesting::ResetLockupEvent', ResetLockupEvent.ResetLockupEventParser);
    repo.addParser('0x1::vesting::SetBeneficiaryEvent', SetBeneficiaryEvent.SetBeneficiaryEventParser);
    repo.addParser('0x1::vesting::StakingInfo', StakingInfo.StakingInfoParser);
    repo.addParser('0x1::vesting::TerminateEvent', TerminateEvent.TerminateEventParser);
    repo.addParser('0x1::vesting::UnlockRewardsEvent', UnlockRewardsEvent.UnlockRewardsEventParser);
    repo.addParser('0x1::vesting::UpdateOperatorEvent', UpdateOperatorEvent.UpdateOperatorEventParser);
    repo.addParser('0x1::vesting::UpdateVoterEvent', UpdateVoterEvent.UpdateVoterEventParser);
    repo.addParser('0x1::vesting::VestEvent', VestEvent.VestEventParser);
    repo.addParser('0x1::vesting::VestingAccountManagement', VestingAccountManagement.VestingAccountManagementParser);
    repo.addParser('0x1::vesting::VestingContract', VestingContract.VestingContractParser);
    repo.addParser('0x1::vesting::VestingSchedule', VestingSchedule.VestingScheduleParser);
}
class App$Q {
    constructor(client, repo, cache) {
        this.client = client;
        this.repo = repo;
        this.cache = cache;
    }
    get moduleAddress() {
        {
            return moduleAddress$C;
        }
    }
    get moduleName() {
        {
            return moduleName$C;
        }
    }
    get AdminStore() {
        return AdminStore;
    }
    loadAdminStore(owner, loadFull = true, fillCache = true) {
        return __awaiter(this, void 0, void 0, function* () {
            const val = yield AdminStore.load(this.repo, this.client, owner, []);
            if (loadFull) {
                yield val.loadFullState(this);
            }
            if (fillCache) {
                this.cache.set(val.typeTag, owner, val);
            }
            return val;
        });
    }
    get AdminWithdrawEvent() {
        return AdminWithdrawEvent;
    }
    get CreateVestingContractEvent() {
        return CreateVestingContractEvent;
    }
    get DistributeEvent() {
        return DistributeEvent;
    }
    get ResetLockupEvent() {
        return ResetLockupEvent;
    }
    get SetBeneficiaryEvent() {
        return SetBeneficiaryEvent;
    }
    get StakingInfo() {
        return StakingInfo;
    }
    get TerminateEvent() {
        return TerminateEvent;
    }
    get UnlockRewardsEvent() {
        return UnlockRewardsEvent;
    }
    get UpdateOperatorEvent() {
        return UpdateOperatorEvent;
    }
    get UpdateVoterEvent() {
        return UpdateVoterEvent;
    }
    get VestEvent() {
        return VestEvent;
    }
    get VestingAccountManagement() {
        return VestingAccountManagement;
    }
    loadVestingAccountManagement(owner, loadFull = true, fillCache = true) {
        return __awaiter(this, void 0, void 0, function* () {
            const val = yield VestingAccountManagement.load(this.repo, this.client, owner, []);
            if (loadFull) {
                yield val.loadFullState(this);
            }
            if (fillCache) {
                this.cache.set(val.typeTag, owner, val);
            }
            return val;
        });
    }
    get VestingContract() {
        return VestingContract;
    }
    loadVestingContract(owner, loadFull = true, fillCache = true) {
        return __awaiter(this, void 0, void 0, function* () {
            const val = yield VestingContract.load(this.repo, this.client, owner, []);
            if (loadFull) {
                yield val.loadFullState(this);
            }
            if (fillCache) {
                this.cache.set(val.typeTag, owner, val);
            }
            return val;
        });
    }
    get VestingSchedule() {
        return VestingSchedule;
    }
    payload_admin_withdraw(contract_address, isJSON = false) {
        return buildPayload_admin_withdraw(contract_address, isJSON);
    }
    admin_withdraw(_account, contract_address, option, _isJSON = false) {
        return __awaiter(this, void 0, void 0, function* () {
            const payload__ = buildPayload_admin_withdraw(contract_address, _isJSON);
            return $.sendPayloadTx(this.client, _account, payload__, option);
        });
    }
    payload_distribute(contract_address, isJSON = false) {
        return buildPayload_distribute(contract_address, isJSON);
    }
    distribute(_account, contract_address, option, _isJSON = false) {
        return __awaiter(this, void 0, void 0, function* () {
            const payload__ = buildPayload_distribute(contract_address, _isJSON);
            return $.sendPayloadTx(this.client, _account, payload__, option);
        });
    }
    payload_reset_beneficiary(contract_address, shareholder, isJSON = false) {
        return buildPayload_reset_beneficiary(contract_address, shareholder, isJSON);
    }
    reset_beneficiary(_account, contract_address, shareholder, option, _isJSON = false) {
        return __awaiter(this, void 0, void 0, function* () {
            const payload__ = buildPayload_reset_beneficiary(contract_address, shareholder, _isJSON);
            return $.sendPayloadTx(this.client, _account, payload__, option);
        });
    }
    payload_reset_lockup(contract_address, isJSON = false) {
        return buildPayload_reset_lockup(contract_address, isJSON);
    }
    reset_lockup(_account, contract_address, option, _isJSON = false) {
        return __awaiter(this, void 0, void 0, function* () {
            const payload__ = buildPayload_reset_lockup(contract_address, _isJSON);
            return $.sendPayloadTx(this.client, _account, payload__, option);
        });
    }
    payload_set_beneficiary(contract_address, shareholder, new_beneficiary, isJSON = false) {
        return buildPayload_set_beneficiary(contract_address, shareholder, new_beneficiary, isJSON);
    }
    set_beneficiary(_account, contract_address, shareholder, new_beneficiary, option, _isJSON = false) {
        return __awaiter(this, void 0, void 0, function* () {
            const payload__ = buildPayload_set_beneficiary(contract_address, shareholder, new_beneficiary, _isJSON);
            return $.sendPayloadTx(this.client, _account, payload__, option);
        });
    }
    payload_set_beneficiary_resetter(contract_address, beneficiary_resetter, isJSON = false) {
        return buildPayload_set_beneficiary_resetter(contract_address, beneficiary_resetter, isJSON);
    }
    set_beneficiary_resetter(_account, contract_address, beneficiary_resetter, option, _isJSON = false) {
        return __awaiter(this, void 0, void 0, function* () {
            const payload__ = buildPayload_set_beneficiary_resetter(contract_address, beneficiary_resetter, _isJSON);
            return $.sendPayloadTx(this.client, _account, payload__, option);
        });
    }
    payload_set_management_role(contract_address, role, role_holder, isJSON = false) {
        return buildPayload_set_management_role(contract_address, role, role_holder, isJSON);
    }
    set_management_role(_account, contract_address, role, role_holder, option, _isJSON = false) {
        return __awaiter(this, void 0, void 0, function* () {
            const payload__ = buildPayload_set_management_role(contract_address, role, role_holder, _isJSON);
            return $.sendPayloadTx(this.client, _account, payload__, option);
        });
    }
    payload_terminate_vesting_contract(contract_address, isJSON = false) {
        return buildPayload_terminate_vesting_contract(contract_address, isJSON);
    }
    terminate_vesting_contract(_account, contract_address, option, _isJSON = false) {
        return __awaiter(this, void 0, void 0, function* () {
            const payload__ = buildPayload_terminate_vesting_contract(contract_address, _isJSON);
            return $.sendPayloadTx(this.client, _account, payload__, option);
        });
    }
    payload_unlock_rewards(contract_address, isJSON = false) {
        return buildPayload_unlock_rewards(contract_address, isJSON);
    }
    unlock_rewards(_account, contract_address, option, _isJSON = false) {
        return __awaiter(this, void 0, void 0, function* () {
            const payload__ = buildPayload_unlock_rewards(contract_address, _isJSON);
            return $.sendPayloadTx(this.client, _account, payload__, option);
        });
    }
    payload_update_operator(contract_address, new_operator, commission_percentage, isJSON = false) {
        return buildPayload_update_operator(contract_address, new_operator, commission_percentage, isJSON);
    }
    update_operator(_account, contract_address, new_operator, commission_percentage, option, _isJSON = false) {
        return __awaiter(this, void 0, void 0, function* () {
            const payload__ = buildPayload_update_operator(contract_address, new_operator, commission_percentage, _isJSON);
            return $.sendPayloadTx(this.client, _account, payload__, option);
        });
    }
    payload_update_operator_with_same_commission(contract_address, new_operator, isJSON = false) {
        return buildPayload_update_operator_with_same_commission(contract_address, new_operator, isJSON);
    }
    update_operator_with_same_commission(_account, contract_address, new_operator, option, _isJSON = false) {
        return __awaiter(this, void 0, void 0, function* () {
            const payload__ = buildPayload_update_operator_with_same_commission(contract_address, new_operator, _isJSON);
            return $.sendPayloadTx(this.client, _account, payload__, option);
        });
    }
    payload_update_voter(contract_address, new_voter, isJSON = false) {
        return buildPayload_update_voter(contract_address, new_voter, isJSON);
    }
    update_voter(_account, contract_address, new_voter, option, _isJSON = false) {
        return __awaiter(this, void 0, void 0, function* () {
            const payload__ = buildPayload_update_voter(contract_address, new_voter, _isJSON);
            return $.sendPayloadTx(this.client, _account, payload__, option);
        });
    }
    payload_vest(contract_address, isJSON = false) {
        return buildPayload_vest(contract_address, isJSON);
    }
    vest(_account, contract_address, option, _isJSON = false) {
        return __awaiter(this, void 0, void 0, function* () {
            const payload__ = buildPayload_vest(contract_address, _isJSON);
            return $.sendPayloadTx(this.client, _account, payload__, option);
        });
    }
}

var Vesting = /*#__PURE__*/Object.freeze({
    __proto__: null,
    packageName: packageName$C,
    moduleAddress: moduleAddress$C,
    moduleName: moduleName$C,
    EEMPTY_VESTING_SCHEDULE: EEMPTY_VESTING_SCHEDULE,
    EINVALID_WITHDRAWAL_ADDRESS: EINVALID_WITHDRAWAL_ADDRESS,
    ENOT_ADMIN: ENOT_ADMIN,
    ENO_SHAREHOLDERS: ENO_SHAREHOLDERS,
    EPENDING_STAKE_FOUND: EPENDING_STAKE_FOUND,
    EPERMISSION_DENIED: EPERMISSION_DENIED,
    EROLE_NOT_FOUND: EROLE_NOT_FOUND,
    ESHARES_LENGTH_MISMATCH: ESHARES_LENGTH_MISMATCH,
    EVESTING_ACCOUNT_HAS_NO_ROLES: EVESTING_ACCOUNT_HAS_NO_ROLES,
    EVESTING_CONTRACT_NOT_ACTIVE: EVESTING_CONTRACT_NOT_ACTIVE,
    EVESTING_CONTRACT_NOT_FOUND: EVESTING_CONTRACT_NOT_FOUND,
    EVESTING_CONTRACT_STILL_ACTIVE: EVESTING_CONTRACT_STILL_ACTIVE,
    EVESTING_START_TOO_SOON: EVESTING_START_TOO_SOON,
    EZERO_GRANT: EZERO_GRANT,
    EZERO_VESTING_SCHEDULE_PERIOD: EZERO_VESTING_SCHEDULE_PERIOD,
    MAXIMUM_SHAREHOLDERS: MAXIMUM_SHAREHOLDERS,
    ROLE_BENEFICIARY_RESETTER: ROLE_BENEFICIARY_RESETTER,
    VESTING_POOL_ACTIVE: VESTING_POOL_ACTIVE,
    VESTING_POOL_SALT: VESTING_POOL_SALT,
    VESTING_POOL_TERMINATED: VESTING_POOL_TERMINATED,
    AdminStore: AdminStore,
    AdminWithdrawEvent: AdminWithdrawEvent,
    CreateVestingContractEvent: CreateVestingContractEvent,
    DistributeEvent: DistributeEvent,
    ResetLockupEvent: ResetLockupEvent,
    SetBeneficiaryEvent: SetBeneficiaryEvent,
    StakingInfo: StakingInfo,
    TerminateEvent: TerminateEvent,
    UnlockRewardsEvent: UnlockRewardsEvent,
    UpdateOperatorEvent: UpdateOperatorEvent,
    UpdateVoterEvent: UpdateVoterEvent,
    VestEvent: VestEvent,
    VestingAccountManagement: VestingAccountManagement,
    VestingContract: VestingContract,
    VestingSchedule: VestingSchedule,
    admin_withdraw_: admin_withdraw_,
    buildPayload_admin_withdraw: buildPayload_admin_withdraw,
    assert_active_vesting_contract_: assert_active_vesting_contract_,
    assert_vesting_contract_exists_: assert_vesting_contract_exists_,
    beneficiary_: beneficiary_,
    create_vesting_contract_: create_vesting_contract_,
    create_vesting_contract_account_: create_vesting_contract_account_,
    create_vesting_schedule_: create_vesting_schedule_,
    distribute_: distribute_,
    buildPayload_distribute: buildPayload_distribute,
    get_beneficiary_: get_beneficiary_,
    get_role_holder_: get_role_holder_,
    get_vesting_account_signer_: get_vesting_account_signer_,
    get_vesting_account_signer_internal_: get_vesting_account_signer_internal_,
    operator_: operator_,
    operator_commission_percentage_: operator_commission_percentage_,
    remaining_grant_: remaining_grant_,
    reset_beneficiary_: reset_beneficiary_,
    buildPayload_reset_beneficiary: buildPayload_reset_beneficiary,
    reset_lockup_: reset_lockup_,
    buildPayload_reset_lockup: buildPayload_reset_lockup,
    set_beneficiary_: set_beneficiary_,
    buildPayload_set_beneficiary: buildPayload_set_beneficiary,
    set_beneficiary_resetter_: set_beneficiary_resetter_,
    buildPayload_set_beneficiary_resetter: buildPayload_set_beneficiary_resetter,
    set_management_role_: set_management_role_,
    buildPayload_set_management_role: buildPayload_set_management_role,
    stake_pool_address_: stake_pool_address_,
    terminate_vesting_contract_: terminate_vesting_contract_,
    buildPayload_terminate_vesting_contract: buildPayload_terminate_vesting_contract,
    unlock_rewards_: unlock_rewards_,
    buildPayload_unlock_rewards: buildPayload_unlock_rewards,
    unlock_stake_: unlock_stake_,
    update_operator_: update_operator_,
    buildPayload_update_operator: buildPayload_update_operator,
    update_operator_with_same_commission_: update_operator_with_same_commission_,
    buildPayload_update_operator_with_same_commission: buildPayload_update_operator_with_same_commission,
    update_voter_: update_voter_,
    buildPayload_update_voter: buildPayload_update_voter,
    verify_admin_: verify_admin_,
    vest_: vest_,
    buildPayload_vest: buildPayload_vest,
    vesting_contracts_: vesting_contracts_,
    vesting_start_secs_: vesting_start_secs_,
    voter_: voter_,
    withdraw_stake_: withdraw_stake_,
    loadParsers: loadParsers$P,
    App: App$Q
});

const packageName$B = 'AptosFramework';
const moduleAddress$B = new HexString('0x1');
const moduleName$B = 'genesis';
const EACCOUNT_DOES_NOT_EXIST = u64('2');
const EDUPLICATE_ACCOUNT = u64('1');
class AccountMap {
    constructor(proto, typeTag) {
        this.typeTag = typeTag;
        this.__app = null;
        this.account_address = proto['account_address'];
        this.balance = proto['balance'];
    }
    static AccountMapParser(data, typeTag, repo) {
        const proto = $.parseStructProto(data, typeTag, repo, AccountMap);
        return new AccountMap(proto, typeTag);
    }
    static getTag() {
        return new StructTag(moduleAddress$B, moduleName$B, 'AccountMap', []);
    }
    loadFullState(app) {
        return __awaiter(this, void 0, void 0, function* () {
            this.__app = app;
        });
    }
}
AccountMap.moduleAddress = moduleAddress$B;
AccountMap.moduleName = moduleName$B;
AccountMap.structName = 'AccountMap';
AccountMap.typeParameters = [];
AccountMap.fields = [
    { name: 'account_address', typeTag: AtomicTypeTag.Address },
    { name: 'balance', typeTag: AtomicTypeTag.U64 }
];
class EmployeeAccountMap {
    constructor(proto, typeTag) {
        this.typeTag = typeTag;
        this.__app = null;
        this.accounts = proto['accounts'];
        this.validator = proto['validator'];
        this.vesting_schedule_numerator = proto['vesting_schedule_numerator'];
        this.vesting_schedule_denominator = proto['vesting_schedule_denominator'];
        this.beneficiary_resetter = proto['beneficiary_resetter'];
    }
    static EmployeeAccountMapParser(data, typeTag, repo) {
        const proto = $.parseStructProto(data, typeTag, repo, EmployeeAccountMap);
        return new EmployeeAccountMap(proto, typeTag);
    }
    static getTag() {
        return new StructTag(moduleAddress$B, moduleName$B, 'EmployeeAccountMap', []);
    }
    loadFullState(app) {
        return __awaiter(this, void 0, void 0, function* () {
            yield this.validator.loadFullState(app);
            this.__app = app;
        });
    }
}
EmployeeAccountMap.moduleAddress = moduleAddress$B;
EmployeeAccountMap.moduleName = moduleName$B;
EmployeeAccountMap.structName = 'EmployeeAccountMap';
EmployeeAccountMap.typeParameters = [];
EmployeeAccountMap.fields = [
    { name: 'accounts', typeTag: new VectorTag(AtomicTypeTag.Address) },
    {
        name: 'validator',
        typeTag: new StructTag(new HexString('0x1'), 'genesis', 'ValidatorConfigurationWithCommission', [])
    },
    { name: 'vesting_schedule_numerator', typeTag: new VectorTag(AtomicTypeTag.U64) },
    { name: 'vesting_schedule_denominator', typeTag: AtomicTypeTag.U64 },
    { name: 'beneficiary_resetter', typeTag: AtomicTypeTag.Address }
];
class ValidatorConfiguration {
    constructor(proto, typeTag) {
        this.typeTag = typeTag;
        this.__app = null;
        this.owner_address = proto['owner_address'];
        this.operator_address = proto['operator_address'];
        this.voter_address = proto['voter_address'];
        this.stake_amount = proto['stake_amount'];
        this.consensus_pubkey = proto['consensus_pubkey'];
        this.proof_of_possession = proto['proof_of_possession'];
        this.network_addresses = proto['network_addresses'];
        this.full_node_network_addresses = proto['full_node_network_addresses'];
    }
    static ValidatorConfigurationParser(data, typeTag, repo) {
        const proto = $.parseStructProto(data, typeTag, repo, ValidatorConfiguration);
        return new ValidatorConfiguration(proto, typeTag);
    }
    static getTag() {
        return new StructTag(moduleAddress$B, moduleName$B, 'ValidatorConfiguration', []);
    }
    loadFullState(app) {
        return __awaiter(this, void 0, void 0, function* () {
            this.__app = app;
        });
    }
}
ValidatorConfiguration.moduleAddress = moduleAddress$B;
ValidatorConfiguration.moduleName = moduleName$B;
ValidatorConfiguration.structName = 'ValidatorConfiguration';
ValidatorConfiguration.typeParameters = [];
ValidatorConfiguration.fields = [
    { name: 'owner_address', typeTag: AtomicTypeTag.Address },
    { name: 'operator_address', typeTag: AtomicTypeTag.Address },
    { name: 'voter_address', typeTag: AtomicTypeTag.Address },
    { name: 'stake_amount', typeTag: AtomicTypeTag.U64 },
    { name: 'consensus_pubkey', typeTag: new VectorTag(AtomicTypeTag.U8) },
    { name: 'proof_of_possession', typeTag: new VectorTag(AtomicTypeTag.U8) },
    { name: 'network_addresses', typeTag: new VectorTag(AtomicTypeTag.U8) },
    { name: 'full_node_network_addresses', typeTag: new VectorTag(AtomicTypeTag.U8) }
];
class ValidatorConfigurationWithCommission {
    constructor(proto, typeTag) {
        this.typeTag = typeTag;
        this.__app = null;
        this.validator_config = proto['validator_config'];
        this.commission_percentage = proto['commission_percentage'];
        this.join_during_genesis = proto['join_during_genesis'];
    }
    static ValidatorConfigurationWithCommissionParser(data, typeTag, repo) {
        const proto = $.parseStructProto(data, typeTag, repo, ValidatorConfigurationWithCommission);
        return new ValidatorConfigurationWithCommission(proto, typeTag);
    }
    static getTag() {
        return new StructTag(moduleAddress$B, moduleName$B, 'ValidatorConfigurationWithCommission', []);
    }
    loadFullState(app) {
        return __awaiter(this, void 0, void 0, function* () {
            yield this.validator_config.loadFullState(app);
            this.__app = app;
        });
    }
}
ValidatorConfigurationWithCommission.moduleAddress = moduleAddress$B;
ValidatorConfigurationWithCommission.moduleName = moduleName$B;
ValidatorConfigurationWithCommission.structName = 'ValidatorConfigurationWithCommission';
ValidatorConfigurationWithCommission.typeParameters = [];
ValidatorConfigurationWithCommission.fields = [
    { name: 'validator_config', typeTag: new StructTag(new HexString('0x1'), 'genesis', 'ValidatorConfiguration', []) },
    { name: 'commission_percentage', typeTag: AtomicTypeTag.U64 },
    { name: 'join_during_genesis', typeTag: AtomicTypeTag.Bool }
];
function create_account_(aptos_framework, account_address, balance, $c) {
    let temp$1, account;
    if (exists_at_($.copy(account_address), $c)) {
        temp$1 = create_signer_($.copy(account_address), $c);
    }
    else {
        account = create_account_$2($.copy(account_address), $c);
        register_$2(account, $c, [new StructTag(new HexString('0x1'), 'aptos_coin', 'AptosCoin', [])]);
        mint_$3(aptos_framework, $.copy(account_address), $.copy(balance), $c);
        temp$1 = account;
    }
    return temp$1;
}
function create_accounts_(aptos_framework, accounts, $c) {
    let account_map, i, num_accounts, unique_accounts;
    i = u64('0');
    num_accounts = length_$6(accounts, $c, [new SimpleStructTag(AccountMap)]);
    unique_accounts = empty_$5($c, [AtomicTypeTag.Address]);
    while ($.copy(i).lt($.copy(num_accounts))) {
        {
            account_map = borrow_$7(accounts, $.copy(i), $c, [new SimpleStructTag(AccountMap)]);
            if (!!contains_$8(unique_accounts, account_map.account_address, $c, [AtomicTypeTag.Address])) {
                throw $.abortCode(already_exists_($.copy(EDUPLICATE_ACCOUNT)));
            }
            push_back_(unique_accounts, $.copy(account_map.account_address), $c, [AtomicTypeTag.Address]);
            create_account_(aptos_framework, $.copy(account_map.account_address), $.copy(account_map.balance), $c);
            i = $.copy(i).add(u64('1'));
        }
    }
    return;
}
function create_employee_validators_(employee_vesting_start, employee_vesting_period_duration, employees, $c) {
    let temp$2, account, admin, admin_signer, buy_ins, coins, contract_address, employee, employee_group, event, i, j, j__1, num_employee_groups, num_employees_in_group, num_vesting_events, numerator, pool_address, schedule, total, unique_accounts, validator, vesting_schedule;
    i = u64('0');
    num_employee_groups = length_$6(employees, $c, [new SimpleStructTag(EmployeeAccountMap)]);
    unique_accounts = empty_$5($c, [AtomicTypeTag.Address]);
    while ($.copy(i).lt($.copy(num_employee_groups))) {
        {
            j = u64('0');
            employee_group = borrow_$7(employees, $.copy(i), $c, [new SimpleStructTag(EmployeeAccountMap)]);
            num_employees_in_group = length_$6(employee_group.accounts, $c, [AtomicTypeTag.Address]);
            buy_ins = create_$2($c, [
                AtomicTypeTag.Address,
                new StructTag(new HexString('0x1'), 'coin', 'Coin', [
                    new StructTag(new HexString('0x1'), 'aptos_coin', 'AptosCoin', [])
                ])
            ]);
            while ($.copy(j).lt($.copy(num_employees_in_group))) {
                {
                    account = borrow_$7(employee_group.accounts, $.copy(j), $c, [AtomicTypeTag.Address]);
                    if (!!contains_$8(unique_accounts, account, $c, [AtomicTypeTag.Address])) {
                        throw $.abortCode(already_exists_($.copy(EDUPLICATE_ACCOUNT)));
                    }
                    push_back_(unique_accounts, $.copy(account), $c, [AtomicTypeTag.Address]);
                    employee = create_signer_($.copy(account), $c);
                    total = balance_$1($.copy(account), $c, [
                        new StructTag(new HexString('0x1'), 'aptos_coin', 'AptosCoin', [])
                    ]);
                    coins = withdraw_$1(employee, $.copy(total), $c, [
                        new StructTag(new HexString('0x1'), 'aptos_coin', 'AptosCoin', [])
                    ]);
                    add_$4(buy_ins, $.copy(account), coins, $c, [
                        AtomicTypeTag.Address,
                        new StructTag(new HexString('0x1'), 'coin', 'Coin', [
                            new StructTag(new HexString('0x1'), 'aptos_coin', 'AptosCoin', [])
                        ])
                    ]);
                    j = $.copy(j).add(u64('1'));
                }
            }
            j__1 = u64('0');
            num_vesting_events = length_$6(employee_group.vesting_schedule_numerator, $c, [AtomicTypeTag.U64]);
            schedule = empty_$5($c, [new StructTag(new HexString('0x1'), 'fixed_point32', 'FixedPoint32', [])]);
            while ($.copy(j__1).lt($.copy(num_vesting_events))) {
                {
                    numerator = borrow_$7(employee_group.vesting_schedule_numerator, $.copy(j__1), $c, [AtomicTypeTag.U64]);
                    event = create_from_rational_($.copy(numerator), $.copy(employee_group.vesting_schedule_denominator));
                    push_back_(schedule, $.copy(event), $c, [
                        new StructTag(new HexString('0x1'), 'fixed_point32', 'FixedPoint32', [])
                    ]);
                    j__1 = $.copy(j__1).add(u64('1'));
                }
            }
            vesting_schedule = create_vesting_schedule_($.copy(schedule), $.copy(employee_vesting_start), $.copy(employee_vesting_period_duration), $c);
            admin = $.copy(employee_group.validator.validator_config.owner_address);
            temp$2 = create_signer_($.copy(admin), $c);
            admin_signer = temp$2;
            contract_address = create_vesting_contract_(admin_signer, employee_group.accounts, buy_ins, $.copy(vesting_schedule), $.copy(admin), $.copy(employee_group.validator.validator_config.operator_address), $.copy(employee_group.validator.validator_config.voter_address), $.copy(employee_group.validator.commission_percentage), [], $c);
            pool_address = stake_pool_address_($.copy(contract_address), $c);
            if ($.copy(employee_group.beneficiary_resetter).hex() !== new HexString('0x0').hex()) {
                set_beneficiary_resetter_(admin_signer, $.copy(contract_address), $.copy(employee_group.beneficiary_resetter), $c);
            }
            validator = employee_group.validator.validator_config;
            if (!exists_at_($.copy(validator.owner_address), $c)) {
                throw $.abortCode(not_found_($.copy(EACCOUNT_DOES_NOT_EXIST)));
            }
            if (!exists_at_($.copy(validator.operator_address), $c)) {
                throw $.abortCode(not_found_($.copy(EACCOUNT_DOES_NOT_EXIST)));
            }
            if (!exists_at_($.copy(validator.voter_address), $c)) {
                throw $.abortCode(not_found_($.copy(EACCOUNT_DOES_NOT_EXIST)));
            }
            if ($.copy(employee_group.validator.join_during_genesis)) {
                initialize_validator_($.copy(pool_address), validator, $c);
            }
            i = $.copy(i).add(u64('1'));
        }
    }
    return;
}
function create_initialize_validator_(aptos_framework, commission_config, use_staking_contract, $c) {
    let temp$1, temp$2, owner, pool_address, validator;
    validator = commission_config.validator_config;
    temp$1 = create_account_(aptos_framework, $.copy(validator.owner_address), $.copy(validator.stake_amount), $c);
    owner = temp$1;
    create_account_(aptos_framework, $.copy(validator.operator_address), u64('0'), $c);
    create_account_(aptos_framework, $.copy(validator.voter_address), u64('0'), $c);
    if (use_staking_contract) {
        create_staking_contract_(owner, $.copy(validator.operator_address), $.copy(validator.voter_address), $.copy(validator.stake_amount), $.copy(commission_config.commission_percentage), [], $c);
        temp$2 = stake_pool_address_$1($.copy(validator.owner_address), $.copy(validator.operator_address), $c);
    }
    else {
        initialize_stake_owner_(owner, $.copy(validator.stake_amount), $.copy(validator.operator_address), $.copy(validator.voter_address), $c);
        temp$2 = $.copy(validator.owner_address);
    }
    pool_address = temp$2;
    if ($.copy(commission_config.join_during_genesis)) {
        initialize_validator_($.copy(pool_address), validator, $c);
    }
    return;
}
function create_initialize_validators_(aptos_framework, validators, $c) {
    let i, num_validators, validator_with_commission, validators_with_commission;
    i = u64('0');
    num_validators = length_$6(validators, $c, [new SimpleStructTag(ValidatorConfiguration)]);
    validators_with_commission = empty_$5($c, [new SimpleStructTag(ValidatorConfigurationWithCommission)]);
    while ($.copy(i).lt($.copy(num_validators))) {
        {
            validator_with_commission = new ValidatorConfigurationWithCommission({
                validator_config: pop_back_(validators, $c, [new SimpleStructTag(ValidatorConfiguration)]),
                commission_percentage: u64('0'),
                join_during_genesis: true
            }, new SimpleStructTag(ValidatorConfigurationWithCommission));
            push_back_(validators_with_commission, $.copy(validator_with_commission), $c, [
                new SimpleStructTag(ValidatorConfigurationWithCommission)
            ]);
            i = $.copy(i).add(u64('1'));
        }
    }
    create_initialize_validators_with_commission_(aptos_framework, false, $.copy(validators_with_commission), $c);
    return;
}
function create_initialize_validators_with_commission_(aptos_framework, use_staking_contract, validators, $c) {
    let i, num_validators, validator;
    i = u64('0');
    num_validators = length_$6(validators, $c, [new SimpleStructTag(ValidatorConfigurationWithCommission)]);
    while ($.copy(i).lt($.copy(num_validators))) {
        {
            validator = borrow_$7(validators, $.copy(i), $c, [
                new SimpleStructTag(ValidatorConfigurationWithCommission)
            ]);
            create_initialize_validator_(aptos_framework, validator, use_staking_contract, $c);
            i = $.copy(i).add(u64('1'));
        }
    }
    destroy_mint_cap_(aptos_framework, $c);
    on_new_epoch_($c);
    return;
}
function create_signer_(addr, $c) {
    return $.aptos_framework_genesis_create_signer(addr, $c);
}
function initialize_$4(gas_schedule, chain_id, initial_version, consensus_config, epoch_interval_microsecs, minimum_stake, maximum_stake, recurring_lockup_duration_secs, allow_validator_set_change, rewards_rate, rewards_rate_denominator, voting_power_increase_limit, $c) {
    let address, aptos_account, aptos_framework_account, aptos_framework_signer_cap, framework_reserved_addresses, framework_signer_cap;
    [aptos_framework_account, aptos_framework_signer_cap] = create_framework_reserved_account_(new HexString('0x1'), $c);
    initialize_$k(aptos_framework_account, $c);
    initialize_$6(aptos_framework_account, [
        u8('115'),
        u8('99'),
        u8('114'),
        u8('105'),
        u8('112'),
        u8('116'),
        u8('95'),
        u8('112'),
        u8('114'),
        u8('111'),
        u8('108'),
        u8('111'),
        u8('103'),
        u8('117'),
        u8('101')
    ], [
        u8('109'),
        u8('111'),
        u8('100'),
        u8('117'),
        u8('108'),
        u8('101'),
        u8('95'),
        u8('112'),
        u8('114'),
        u8('111'),
        u8('108'),
        u8('111'),
        u8('103'),
        u8('117'),
        u8('101')
    ], [
        u8('109'),
        u8('117'),
        u8('108'),
        u8('116'),
        u8('105'),
        u8('95'),
        u8('97'),
        u8('103'),
        u8('101'),
        u8('110'),
        u8('116'),
        u8('95'),
        u8('115'),
        u8('99'),
        u8('114'),
        u8('105'),
        u8('112'),
        u8('116'),
        u8('95'),
        u8('112'),
        u8('114'),
        u8('111'),
        u8('108'),
        u8('111'),
        u8('103'),
        u8('117'),
        u8('101')
    ], [u8('101'), u8('112'), u8('105'), u8('108'), u8('111'), u8('103'), u8('117'), u8('101')], $c);
    store_signer_cap_(aptos_framework_account, new HexString('0x1'), aptos_framework_signer_cap, $c);
    framework_reserved_addresses = [
        new HexString('0x2'),
        new HexString('0x3'),
        new HexString('0x4'),
        new HexString('0x5'),
        new HexString('0x6'),
        new HexString('0x7'),
        new HexString('0x8'),
        new HexString('0x9'),
        new HexString('0xa')
    ];
    while (!is_empty_$2(framework_reserved_addresses, $c, [AtomicTypeTag.Address])) {
        {
            address = pop_back_(framework_reserved_addresses, $c, [AtomicTypeTag.Address]);
            [aptos_account, framework_signer_cap] = create_framework_reserved_account_($.copy(address), $c);
            store_signer_cap_(aptos_account, $.copy(address), framework_signer_cap, $c);
        }
    }
    initialize_$8(aptos_framework_account, $.copy(consensus_config), $c);
    initialize_$5(aptos_framework_account, $.copy(initial_version), $c);
    initialize_$g(aptos_framework_account, $c);
    initialize_$h(aptos_framework_account, $.copy(minimum_stake), $.copy(maximum_stake), $.copy(recurring_lockup_duration_secs), allow_validator_set_change, $.copy(rewards_rate), $.copy(rewards_rate_denominator), $.copy(voting_power_increase_limit), $c);
    initialize_$e(aptos_framework_account, $c);
    initialize_$7(aptos_framework_account, $.copy(gas_schedule), $c);
    initialize_aggregator_factory_(aptos_framework_account, $c);
    initialize_supply_config_(aptos_framework_account, $c);
    initialize_$a(aptos_framework_account, $.copy(chain_id), $c);
    initialize_$d(aptos_framework_account, $c);
    initialize_$b(aptos_framework_account, $.copy(epoch_interval_microsecs), $c);
    initialize_$f(aptos_framework_account, $c);
    set_time_has_started_(aptos_framework_account, $c);
    return;
}
function initialize_aptos_coin_(aptos_framework, $c) {
    let burn_cap, mint_cap;
    [burn_cap, mint_cap] = initialize_$i(aptos_framework, $c);
    store_aptos_coin_mint_cap_(aptos_framework, $.copy(mint_cap), $c);
    store_aptos_coin_burn_cap_(aptos_framework, $.copy(burn_cap), $c);
    return;
}
function initialize_core_resources_and_aptos_coin_(aptos_framework, core_resources_auth_key, $c) {
    let burn_cap, core_resources, mint_cap;
    [burn_cap, mint_cap] = initialize_$i(aptos_framework, $c);
    store_aptos_coin_mint_cap_(aptos_framework, $.copy(mint_cap), $c);
    store_aptos_coin_burn_cap_(aptos_framework, $.copy(burn_cap), $c);
    core_resources = create_account_$2(new HexString('0xa550c18'), $c);
    rotate_authentication_key_internal_(core_resources, $.copy(core_resources_auth_key), $c);
    configure_accounts_for_test_(aptos_framework, core_resources, $.copy(mint_cap), $c);
    return;
}
function initialize_for_verification_(gas_schedule, chain_id, initial_version, consensus_config, epoch_interval_microsecs, minimum_stake, maximum_stake, recurring_lockup_duration_secs, allow_validator_set_change, rewards_rate, rewards_rate_denominator, voting_power_increase_limit, aptos_framework, validators, min_voting_threshold, required_proposer_stake, voting_duration_secs, $c) {
    initialize_$4($.copy(gas_schedule), $.copy(chain_id), $.copy(initial_version), $.copy(consensus_config), $.copy(epoch_interval_microsecs), $.copy(minimum_stake), $.copy(maximum_stake), $.copy(recurring_lockup_duration_secs), allow_validator_set_change, $.copy(rewards_rate), $.copy(rewards_rate_denominator), $.copy(voting_power_increase_limit), $c);
    initialize_aptos_coin_(aptos_framework, $c);
    initialize_for_verification_$1(aptos_framework, $.copy(min_voting_threshold), $.copy(required_proposer_stake), $.copy(voting_duration_secs), $c);
    create_initialize_validators_(aptos_framework, $.copy(validators), $c);
    set_genesis_end_(aptos_framework, $c);
    return;
}
function initialize_validator_(pool_address, validator, $c) {
    let temp$1, operator;
    temp$1 = create_signer_($.copy(validator.operator_address), $c);
    operator = temp$1;
    rotate_consensus_key_(operator, $.copy(pool_address), $.copy(validator.consensus_pubkey), $.copy(validator.proof_of_possession), $c);
    update_network_and_fullnode_addresses_(operator, $.copy(pool_address), $.copy(validator.network_addresses), $.copy(validator.full_node_network_addresses), $c);
    join_validator_set_internal_(operator, $.copy(pool_address), $c);
    return;
}
function set_genesis_end_(aptos_framework, $c) {
    set_genesis_end_$1(aptos_framework, $c);
    return;
}
function loadParsers$O(repo) {
    repo.addParser('0x1::genesis::AccountMap', AccountMap.AccountMapParser);
    repo.addParser('0x1::genesis::EmployeeAccountMap', EmployeeAccountMap.EmployeeAccountMapParser);
    repo.addParser('0x1::genesis::ValidatorConfiguration', ValidatorConfiguration.ValidatorConfigurationParser);
    repo.addParser('0x1::genesis::ValidatorConfigurationWithCommission', ValidatorConfigurationWithCommission.ValidatorConfigurationWithCommissionParser);
}
class App$P {
    constructor(client, repo, cache) {
        this.client = client;
        this.repo = repo;
        this.cache = cache;
    }
    get moduleAddress() {
        {
            return moduleAddress$B;
        }
    }
    get moduleName() {
        {
            return moduleName$B;
        }
    }
    get AccountMap() {
        return AccountMap;
    }
    get EmployeeAccountMap() {
        return EmployeeAccountMap;
    }
    get ValidatorConfiguration() {
        return ValidatorConfiguration;
    }
    get ValidatorConfigurationWithCommission() {
        return ValidatorConfigurationWithCommission;
    }
}

var Genesis = /*#__PURE__*/Object.freeze({
    __proto__: null,
    packageName: packageName$B,
    moduleAddress: moduleAddress$B,
    moduleName: moduleName$B,
    EACCOUNT_DOES_NOT_EXIST: EACCOUNT_DOES_NOT_EXIST,
    EDUPLICATE_ACCOUNT: EDUPLICATE_ACCOUNT,
    AccountMap: AccountMap,
    EmployeeAccountMap: EmployeeAccountMap,
    ValidatorConfiguration: ValidatorConfiguration,
    ValidatorConfigurationWithCommission: ValidatorConfigurationWithCommission,
    create_account_: create_account_,
    create_accounts_: create_accounts_,
    create_employee_validators_: create_employee_validators_,
    create_initialize_validator_: create_initialize_validator_,
    create_initialize_validators_: create_initialize_validators_,
    create_initialize_validators_with_commission_: create_initialize_validators_with_commission_,
    create_signer_: create_signer_,
    initialize_: initialize_$4,
    initialize_aptos_coin_: initialize_aptos_coin_,
    initialize_core_resources_and_aptos_coin_: initialize_core_resources_and_aptos_coin_,
    initialize_for_verification_: initialize_for_verification_,
    initialize_validator_: initialize_validator_,
    set_genesis_end_: set_genesis_end_,
    loadParsers: loadParsers$O,
    App: App$P
});

const packageName$A = 'AptosFramework';
const moduleAddress$A = new HexString('0x1');
const moduleName$A = 'managed_coin';
const ENO_CAPABILITIES = u64('1');
class Capabilities {
    constructor(proto, typeTag) {
        this.typeTag = typeTag;
        this.__app = null;
        this.burn_cap = proto['burn_cap'];
        this.freeze_cap = proto['freeze_cap'];
        this.mint_cap = proto['mint_cap'];
    }
    static CapabilitiesParser(data, typeTag, repo) {
        const proto = $.parseStructProto(data, typeTag, repo, Capabilities);
        return new Capabilities(proto, typeTag);
    }
    static load(repo, client, address, typeParams) {
        return __awaiter(this, void 0, void 0, function* () {
            const result = yield repo.loadResource(client, address, Capabilities, typeParams);
            return result;
        });
    }
    static loadByApp(app, address, typeParams) {
        return __awaiter(this, void 0, void 0, function* () {
            const result = yield app.repo.loadResource(app.client, address, Capabilities, typeParams);
            yield result.loadFullState(app);
            return result;
        });
    }
    static makeTag($p) {
        return new StructTag(moduleAddress$A, moduleName$A, 'Capabilities', $p);
    }
    loadFullState(app) {
        return __awaiter(this, void 0, void 0, function* () {
            yield this.burn_cap.loadFullState(app);
            yield this.freeze_cap.loadFullState(app);
            yield this.mint_cap.loadFullState(app);
            this.__app = app;
        });
    }
}
Capabilities.moduleAddress = moduleAddress$A;
Capabilities.moduleName = moduleName$A;
Capabilities.structName = 'Capabilities';
Capabilities.typeParameters = [{ name: 'CoinType', isPhantom: true }];
Capabilities.fields = [
    {
        name: 'burn_cap',
        typeTag: new StructTag(new HexString('0x1'), 'coin', 'BurnCapability', [new $.TypeParamIdx(0)])
    },
    {
        name: 'freeze_cap',
        typeTag: new StructTag(new HexString('0x1'), 'coin', 'FreezeCapability', [new $.TypeParamIdx(0)])
    },
    {
        name: 'mint_cap',
        typeTag: new StructTag(new HexString('0x1'), 'coin', 'MintCapability', [new $.TypeParamIdx(0)])
    }
];
function burn_$2(account, amount, $c, $p /* <CoinType>*/) {
    let account_addr, capabilities, to_burn;
    account_addr = address_of_(account, $c);
    if (!$c.exists(new SimpleStructTag(Capabilities, [$p[0]]), $.copy(account_addr))) {
        throw $.abortCode(not_found_($.copy(ENO_CAPABILITIES)));
    }
    capabilities = $c.borrow_global(new SimpleStructTag(Capabilities, [$p[0]]), $.copy(account_addr));
    to_burn = withdraw_$1(account, $.copy(amount), $c, [$p[0]]);
    burn_$3(to_burn, capabilities.burn_cap, $c, [$p[0]]);
    return;
}
function buildPayload_burn(amount, $p /* <CoinType>*/, isJSON = false) {
    const typeParamStrings = $p.map((t) => $.getTypeTagFullname(t));
    return $.buildPayload(new HexString('0x1'), 'managed_coin', 'burn', typeParamStrings, [amount], isJSON);
}
function initialize_$3(account, name, symbol, decimals, monitor_supply, $c, $p /* <CoinType>*/) {
    let burn_cap, freeze_cap, mint_cap;
    [burn_cap, freeze_cap, mint_cap] = initialize_$j(account, utf8_($.copy(name), $c), utf8_($.copy(symbol), $c), $.copy(decimals), monitor_supply, $c, [$p[0]]);
    $c.move_to(new SimpleStructTag(Capabilities, [$p[0]]), account, new Capabilities({ burn_cap: $.copy(burn_cap), freeze_cap: $.copy(freeze_cap), mint_cap: $.copy(mint_cap) }, new SimpleStructTag(Capabilities, [$p[0]])));
    return;
}
function buildPayload_initialize$2(name, symbol, decimals, monitor_supply, $p /* <CoinType>*/, isJSON = false) {
    const typeParamStrings = $p.map((t) => $.getTypeTagFullname(t));
    return $.buildPayload(new HexString('0x1'), 'managed_coin', 'initialize', typeParamStrings, [name, symbol, decimals, monitor_supply], isJSON);
}
function mint_$2(account, dst_addr, amount, $c, $p /* <CoinType>*/) {
    let account_addr, capabilities, coins_minted;
    account_addr = address_of_(account, $c);
    if (!$c.exists(new SimpleStructTag(Capabilities, [$p[0]]), $.copy(account_addr))) {
        throw $.abortCode(not_found_($.copy(ENO_CAPABILITIES)));
    }
    capabilities = $c.borrow_global(new SimpleStructTag(Capabilities, [$p[0]]), $.copy(account_addr));
    coins_minted = mint_$4($.copy(amount), capabilities.mint_cap, $c, [$p[0]]);
    deposit_$1($.copy(dst_addr), coins_minted, $c, [$p[0]]);
    return;
}
function buildPayload_mint$1(dst_addr, amount, $p /* <CoinType>*/, isJSON = false) {
    const typeParamStrings = $p.map((t) => $.getTypeTagFullname(t));
    return $.buildPayload(new HexString('0x1'), 'managed_coin', 'mint', typeParamStrings, [dst_addr, amount], isJSON);
}
function register_(account, $c, $p /* <CoinType>*/) {
    register_$2(account, $c, [$p[0]]);
    return;
}
function buildPayload_register($p /* <CoinType>*/, isJSON = false) {
    const typeParamStrings = $p.map((t) => $.getTypeTagFullname(t));
    return $.buildPayload(new HexString('0x1'), 'managed_coin', 'register', typeParamStrings, [], isJSON);
}
function loadParsers$N(repo) {
    repo.addParser('0x1::managed_coin::Capabilities', Capabilities.CapabilitiesParser);
}
class App$O {
    constructor(client, repo, cache) {
        this.client = client;
        this.repo = repo;
        this.cache = cache;
    }
    get moduleAddress() {
        {
            return moduleAddress$A;
        }
    }
    get moduleName() {
        {
            return moduleName$A;
        }
    }
    get Capabilities() {
        return Capabilities;
    }
    loadCapabilities(owner, $p /* <CoinType> */, loadFull = true, fillCache = true) {
        return __awaiter(this, void 0, void 0, function* () {
            const val = yield Capabilities.load(this.repo, this.client, owner, $p);
            if (loadFull) {
                yield val.loadFullState(this);
            }
            if (fillCache) {
                this.cache.set(val.typeTag, owner, val);
            }
            return val;
        });
    }
    payload_burn(amount, $p /* <CoinType>*/, isJSON = false) {
        return buildPayload_burn(amount, $p, isJSON);
    }
    burn(_account, amount, $p /* <CoinType>*/, option, _isJSON = false) {
        return __awaiter(this, void 0, void 0, function* () {
            const payload__ = buildPayload_burn(amount, $p, _isJSON);
            return $.sendPayloadTx(this.client, _account, payload__, option);
        });
    }
    payload_initialize(name, symbol, decimals, monitor_supply, $p /* <CoinType>*/, isJSON = false) {
        return buildPayload_initialize$2(name, symbol, decimals, monitor_supply, $p, isJSON);
    }
    initialize(_account, name, symbol, decimals, monitor_supply, $p /* <CoinType>*/, option, _isJSON = false) {
        return __awaiter(this, void 0, void 0, function* () {
            const payload__ = buildPayload_initialize$2(name, symbol, decimals, monitor_supply, $p, _isJSON);
            return $.sendPayloadTx(this.client, _account, payload__, option);
        });
    }
    payload_mint(dst_addr, amount, $p /* <CoinType>*/, isJSON = false) {
        return buildPayload_mint$1(dst_addr, amount, $p, isJSON);
    }
    mint(_account, dst_addr, amount, $p /* <CoinType>*/, option, _isJSON = false) {
        return __awaiter(this, void 0, void 0, function* () {
            const payload__ = buildPayload_mint$1(dst_addr, amount, $p, _isJSON);
            return $.sendPayloadTx(this.client, _account, payload__, option);
        });
    }
    payload_register($p /* <CoinType>*/, isJSON = false) {
        return buildPayload_register($p, isJSON);
    }
    register(_account, $p /* <CoinType>*/, option, _isJSON = false) {
        return __awaiter(this, void 0, void 0, function* () {
            const payload__ = buildPayload_register($p, _isJSON);
            return $.sendPayloadTx(this.client, _account, payload__, option);
        });
    }
}

var Managed_coin = /*#__PURE__*/Object.freeze({
    __proto__: null,
    packageName: packageName$A,
    moduleAddress: moduleAddress$A,
    moduleName: moduleName$A,
    ENO_CAPABILITIES: ENO_CAPABILITIES,
    Capabilities: Capabilities,
    burn_: burn_$2,
    buildPayload_burn: buildPayload_burn,
    initialize_: initialize_$3,
    buildPayload_initialize: buildPayload_initialize$2,
    mint_: mint_$2,
    buildPayload_mint: buildPayload_mint$1,
    register_: register_,
    buildPayload_register: buildPayload_register,
    loadParsers: loadParsers$N,
    App: App$O
});

const packageName$z = 'AptosStdlib';
const moduleAddress$z = new HexString('0x1');
const moduleName$z = 'math128';
function average_(a, b, $c) {
    let temp$1;
    if ($.copy(a).lt($.copy(b))) {
        temp$1 = $.copy(a).add($.copy(b).sub($.copy(a)).div(u128('2')));
    }
    else {
        temp$1 = $.copy(b).add($.copy(a).sub($.copy(b)).div(u128('2')));
    }
    return temp$1;
}
function max_(a, b, $c) {
    let temp$1;
    if ($.copy(a).ge($.copy(b))) {
        temp$1 = $.copy(a);
    }
    else {
        temp$1 = $.copy(b);
    }
    return temp$1;
}
function min_(a, b, $c) {
    let temp$1;
    if ($.copy(a).lt($.copy(b))) {
        temp$1 = $.copy(a);
    }
    else {
        temp$1 = $.copy(b);
    }
    return temp$1;
}
function pow_(n, e, $c) {
    let temp$1, p;
    if ($.copy(e).eq(u128('0'))) {
        temp$1 = u128('1');
    }
    else {
        p = u128('1');
        while ($.copy(e).gt(u128('1'))) {
            {
                if ($.copy(e).mod(u128('2')).eq(u128('1'))) {
                    p = $.copy(p).mul($.copy(n));
                }
                e = $.copy(e).div(u128('2'));
                n = $.copy(n).mul($.copy(n));
            }
        }
        temp$1 = $.copy(p).mul($.copy(n));
    }
    return temp$1;
}
function loadParsers$M(repo) { }
class App$N {
    constructor(client, repo, cache) {
        this.client = client;
        this.repo = repo;
        this.cache = cache;
    }
    get moduleAddress() {
        {
            return moduleAddress$z;
        }
    }
    get moduleName() {
        {
            return moduleName$z;
        }
    }
}

var Math128 = /*#__PURE__*/Object.freeze({
    __proto__: null,
    packageName: packageName$z,
    moduleAddress: moduleAddress$z,
    moduleName: moduleName$z,
    average_: average_,
    max_: max_,
    min_: min_,
    pow_: pow_,
    loadParsers: loadParsers$M,
    App: App$N
});

const packageName$y = 'AptosFramework';
const moduleAddress$y = new HexString('0x1');
const moduleName$y = 'resource_account';
const ECONTAINER_NOT_PUBLISHED = u64('1');
const ZERO_AUTH_KEY = [
    u8('0'),
    u8('0'),
    u8('0'),
    u8('0'),
    u8('0'),
    u8('0'),
    u8('0'),
    u8('0'),
    u8('0'),
    u8('0'),
    u8('0'),
    u8('0'),
    u8('0'),
    u8('0'),
    u8('0'),
    u8('0'),
    u8('0'),
    u8('0'),
    u8('0'),
    u8('0'),
    u8('0'),
    u8('0'),
    u8('0'),
    u8('0'),
    u8('0'),
    u8('0'),
    u8('0'),
    u8('0'),
    u8('0'),
    u8('0'),
    u8('0'),
    u8('0')
];
class Container {
    constructor(proto, typeTag) {
        this.typeTag = typeTag;
        this.__app = null;
        this.store = proto['store'];
    }
    static ContainerParser(data, typeTag, repo) {
        const proto = $.parseStructProto(data, typeTag, repo, Container);
        return new Container(proto, typeTag);
    }
    static load(repo, client, address, typeParams) {
        return __awaiter(this, void 0, void 0, function* () {
            const result = yield repo.loadResource(client, address, Container, typeParams);
            return result;
        });
    }
    static loadByApp(app, address, typeParams) {
        return __awaiter(this, void 0, void 0, function* () {
            const result = yield app.repo.loadResource(app.client, address, Container, typeParams);
            yield result.loadFullState(app);
            return result;
        });
    }
    static getTag() {
        return new StructTag(moduleAddress$y, moduleName$y, 'Container', []);
    }
    loadFullState(app) {
        return __awaiter(this, void 0, void 0, function* () {
            yield this.store.loadFullState(app);
            this.__app = app;
        });
    }
}
Container.moduleAddress = moduleAddress$y;
Container.moduleName = moduleName$y;
Container.structName = 'Container';
Container.typeParameters = [];
Container.fields = [
    {
        name: 'store',
        typeTag: new StructTag(new HexString('0x1'), 'simple_map', 'SimpleMap', [
            AtomicTypeTag.Address,
            new StructTag(new HexString('0x1'), 'account', 'SignerCapability', [])
        ])
    }
];
function create_resource_account_(origin, seed, optional_auth_key, $c) {
    let resource, resource_signer_cap;
    [resource, resource_signer_cap] = create_resource_account_$1(origin, $.copy(seed), $c);
    rotate_account_authentication_key_and_store_capability_(origin, resource, resource_signer_cap, $.copy(optional_auth_key), $c);
    return;
}
function buildPayload_create_resource_account(seed, optional_auth_key, isJSON = false) {
    const typeParamStrings = [];
    return $.buildPayload(new HexString('0x1'), 'resource_account', 'create_resource_account', typeParamStrings, [seed, optional_auth_key], isJSON);
}
function create_resource_account_and_fund_(origin, seed, optional_auth_key, fund_amount, $c) {
    let resource, resource_signer_cap;
    [resource, resource_signer_cap] = create_resource_account_$1(origin, $.copy(seed), $c);
    register_$2(resource, $c, [new StructTag(new HexString('0x1'), 'aptos_coin', 'AptosCoin', [])]);
    transfer_$1(origin, address_of_(resource, $c), $.copy(fund_amount), $c, [
        new StructTag(new HexString('0x1'), 'aptos_coin', 'AptosCoin', [])
    ]);
    rotate_account_authentication_key_and_store_capability_(origin, resource, resource_signer_cap, $.copy(optional_auth_key), $c);
    return;
}
function buildPayload_create_resource_account_and_fund(seed, optional_auth_key, fund_amount, isJSON = false) {
    const typeParamStrings = [];
    return $.buildPayload(new HexString('0x1'), 'resource_account', 'create_resource_account_and_fund', typeParamStrings, [seed, optional_auth_key, fund_amount], isJSON);
}
function create_resource_account_and_publish_package_(origin, seed, metadata_serialized, code, $c) {
    let resource, resource_signer_cap;
    [resource, resource_signer_cap] = create_resource_account_$1(origin, $.copy(seed), $c);
    publish_package_txn_(resource, $.copy(metadata_serialized), $.copy(code), $c);
    rotate_account_authentication_key_and_store_capability_(origin, resource, resource_signer_cap, $.copy(ZERO_AUTH_KEY), $c);
    return;
}
function buildPayload_create_resource_account_and_publish_package(seed, metadata_serialized, code, isJSON = false) {
    const typeParamStrings = [];
    return $.buildPayload(new HexString('0x1'), 'resource_account', 'create_resource_account_and_publish_package', typeParamStrings, [seed, metadata_serialized, code], isJSON);
}
function retrieve_resource_account_cap_(resource, source_addr, $c) {
    let _resource_addr, container, container__1, empty_container, resource__2, resource_addr, resource_signer_cap, signer_cap;
    if (!$c.exists(new SimpleStructTag(Container), $.copy(source_addr))) {
        throw $.abortCode(not_found_($.copy(ECONTAINER_NOT_PUBLISHED)));
    }
    resource_addr = address_of_(resource, $c);
    container = $c.borrow_global_mut(new SimpleStructTag(Container), $.copy(source_addr));
    [_resource_addr, signer_cap] = remove_$2(container.store, resource_addr, $c, [
        AtomicTypeTag.Address,
        new StructTag(new HexString('0x1'), 'account', 'SignerCapability', [])
    ]);
    [resource_signer_cap, empty_container] = [
        signer_cap,
        length_$4(container.store, $c, [
            AtomicTypeTag.Address,
            new StructTag(new HexString('0x1'), 'account', 'SignerCapability', [])
        ]).eq(u64('0'))
    ];
    if (empty_container) {
        container__1 = $c.move_from(new SimpleStructTag(Container), $.copy(source_addr));
        let { store: store } = container__1;
        destroy_empty_$4(store, $c, [
            AtomicTypeTag.Address,
            new StructTag(new HexString('0x1'), 'account', 'SignerCapability', [])
        ]);
    }
    resource__2 = create_signer_with_capability_(resource_signer_cap, $c);
    rotate_authentication_key_internal_(resource__2, $.copy(ZERO_AUTH_KEY), $c);
    return resource_signer_cap;
}
function rotate_account_authentication_key_and_store_capability_(origin, resource, resource_signer_cap, optional_auth_key, $c) {
    let temp$1, auth_key, container, origin_addr, resource_addr;
    origin_addr = address_of_(origin, $c);
    if (!$c.exists(new SimpleStructTag(Container), $.copy(origin_addr))) {
        $c.move_to(new SimpleStructTag(Container), origin, new Container({
            store: create_$2($c, [
                AtomicTypeTag.Address,
                new StructTag(new HexString('0x1'), 'account', 'SignerCapability', [])
            ])
        }, new SimpleStructTag(Container)));
    }
    container = $c.borrow_global_mut(new SimpleStructTag(Container), $.copy(origin_addr));
    resource_addr = address_of_(resource, $c);
    add_$4(container.store, $.copy(resource_addr), resource_signer_cap, $c, [
        AtomicTypeTag.Address,
        new StructTag(new HexString('0x1'), 'account', 'SignerCapability', [])
    ]);
    if (is_empty_$2(optional_auth_key, $c, [AtomicTypeTag.U8])) {
        temp$1 = get_authentication_key_($.copy(origin_addr), $c);
    }
    else {
        temp$1 = $.copy(optional_auth_key);
    }
    auth_key = temp$1;
    rotate_authentication_key_internal_(resource, $.copy(auth_key), $c);
    return;
}
function loadParsers$L(repo) {
    repo.addParser('0x1::resource_account::Container', Container.ContainerParser);
}
class App$M {
    constructor(client, repo, cache) {
        this.client = client;
        this.repo = repo;
        this.cache = cache;
    }
    get moduleAddress() {
        {
            return moduleAddress$y;
        }
    }
    get moduleName() {
        {
            return moduleName$y;
        }
    }
    get Container() {
        return Container;
    }
    loadContainer(owner, loadFull = true, fillCache = true) {
        return __awaiter(this, void 0, void 0, function* () {
            const val = yield Container.load(this.repo, this.client, owner, []);
            if (loadFull) {
                yield val.loadFullState(this);
            }
            if (fillCache) {
                this.cache.set(val.typeTag, owner, val);
            }
            return val;
        });
    }
    payload_create_resource_account(seed, optional_auth_key, isJSON = false) {
        return buildPayload_create_resource_account(seed, optional_auth_key, isJSON);
    }
    create_resource_account(_account, seed, optional_auth_key, option, _isJSON = false) {
        return __awaiter(this, void 0, void 0, function* () {
            const payload__ = buildPayload_create_resource_account(seed, optional_auth_key, _isJSON);
            return $.sendPayloadTx(this.client, _account, payload__, option);
        });
    }
    payload_create_resource_account_and_fund(seed, optional_auth_key, fund_amount, isJSON = false) {
        return buildPayload_create_resource_account_and_fund(seed, optional_auth_key, fund_amount, isJSON);
    }
    create_resource_account_and_fund(_account, seed, optional_auth_key, fund_amount, option, _isJSON = false) {
        return __awaiter(this, void 0, void 0, function* () {
            const payload__ = buildPayload_create_resource_account_and_fund(seed, optional_auth_key, fund_amount, _isJSON);
            return $.sendPayloadTx(this.client, _account, payload__, option);
        });
    }
    payload_create_resource_account_and_publish_package(seed, metadata_serialized, code, isJSON = false) {
        return buildPayload_create_resource_account_and_publish_package(seed, metadata_serialized, code, isJSON);
    }
    create_resource_account_and_publish_package(_account, seed, metadata_serialized, code, option, _isJSON = false) {
        return __awaiter(this, void 0, void 0, function* () {
            const payload__ = buildPayload_create_resource_account_and_publish_package(seed, metadata_serialized, code, _isJSON);
            return $.sendPayloadTx(this.client, _account, payload__, option);
        });
    }
}

var Resource_account = /*#__PURE__*/Object.freeze({
    __proto__: null,
    packageName: packageName$y,
    moduleAddress: moduleAddress$y,
    moduleName: moduleName$y,
    ECONTAINER_NOT_PUBLISHED: ECONTAINER_NOT_PUBLISHED,
    ZERO_AUTH_KEY: ZERO_AUTH_KEY,
    Container: Container,
    create_resource_account_: create_resource_account_,
    buildPayload_create_resource_account: buildPayload_create_resource_account,
    create_resource_account_and_fund_: create_resource_account_and_fund_,
    buildPayload_create_resource_account_and_fund: buildPayload_create_resource_account_and_fund,
    create_resource_account_and_publish_package_: create_resource_account_and_publish_package_,
    buildPayload_create_resource_account_and_publish_package: buildPayload_create_resource_account_and_publish_package,
    retrieve_resource_account_cap_: retrieve_resource_account_cap_,
    rotate_account_authentication_key_and_store_capability_: rotate_account_authentication_key_and_store_capability_,
    loadParsers: loadParsers$L,
    App: App$M
});

const packageName$x = 'AptosStdlib';
const moduleAddress$x = new HexString('0x1');
const moduleName$x = 'ristretto255';
const A_PLUS_B_POINT = [
    u8('112'),
    u8('207'),
    u8('55'),
    u8('83'),
    u8('71'),
    u8('91'),
    u8('159'),
    u8('243'),
    u8('62'),
    u8('47'),
    u8('132'),
    u8('65'),
    u8('62'),
    u8('214'),
    u8('181'),
    u8('5'),
    u8('32'),
    u8('115'),
    u8('188'),
    u8('204'),
    u8('10'),
    u8('10'),
    u8('129'),
    u8('120'),
    u8('157'),
    u8('62'),
    u8('86'),
    u8('117'),
    u8('220'),
    u8('37'),
    u8('128'),
    u8('86')
];
const A_PLUS_B_SCALAR = [
    u8('8'),
    u8('56'),
    u8('57'),
    u8('221'),
    u8('73'),
    u8('30'),
    u8('87'),
    u8('197'),
    u8('116'),
    u8('55'),
    u8('16'),
    u8('195'),
    u8('154'),
    u8('145'),
    u8('214'),
    u8('229'),
    u8('2'),
    u8('202'),
    u8('179'),
    u8('207'),
    u8('14'),
    u8('39'),
    u8('154'),
    u8('228'),
    u8('23'),
    u8('217'),
    u8('31'),
    u8('242'),
    u8('203'),
    u8('99'),
    u8('62'),
    u8('7')
];
const A_POINT = [
    u8('232'),
    u8('127'),
    u8('237'),
    u8('161'),
    u8('153'),
    u8('215'),
    u8('43'),
    u8('131'),
    u8('222'),
    u8('79'),
    u8('91'),
    u8('45'),
    u8('69'),
    u8('211'),
    u8('72'),
    u8('5'),
    u8('197'),
    u8('112'),
    u8('25'),
    u8('198'),
    u8('197'),
    u8('156'),
    u8('66'),
    u8('203'),
    u8('112'),
    u8('238'),
    u8('61'),
    u8('25'),
    u8('170'),
    u8('153'),
    u8('111'),
    u8('117')
];
const A_SCALAR = [
    u8('26'),
    u8('14'),
    u8('151'),
    u8('138'),
    u8('144'),
    u8('246'),
    u8('98'),
    u8('45'),
    u8('55'),
    u8('71'),
    u8('2'),
    u8('63'),
    u8('138'),
    u8('216'),
    u8('38'),
    u8('77'),
    u8('167'),
    u8('88'),
    u8('170'),
    u8('27'),
    u8('136'),
    u8('224'),
    u8('64'),
    u8('209'),
    u8('88'),
    u8('158'),
    u8('123'),
    u8('127'),
    u8('35'),
    u8('118'),
    u8('239'),
    u8('9')
];
const A_TIMES_BASE_POINT = [
    u8('150'),
    u8('213'),
    u8('45'),
    u8('146'),
    u8('98'),
    u8('238'),
    u8('30'),
    u8('26'),
    u8('174'),
    u8('121'),
    u8('251'),
    u8('174'),
    u8('232'),
    u8('193'),
    u8('217'),
    u8('6'),
    u8('139'),
    u8('13'),
    u8('1'),
    u8('191'),
    u8('154'),
    u8('69'),
    u8('121'),
    u8('230'),
    u8('24'),
    u8('9'),
    u8('12'),
    u8('61'),
    u8('16'),
    u8('136'),
    u8('174'),
    u8('16')
];
const A_TIMES_B_SCALAR = [
    u8('42'),
    u8('181'),
    u8('14'),
    u8('56'),
    u8('61'),
    u8('124'),
    u8('33'),
    u8('15'),
    u8('116'),
    u8('213'),
    u8('56'),
    u8('115'),
    u8('48'),
    u8('115'),
    u8('95'),
    u8('24'),
    u8('49'),
    u8('81'),
    u8('18'),
    u8('209'),
    u8('13'),
    u8('251'),
    u8('152'),
    u8('252'),
    u8('206'),
    u8('30'),
    u8('38'),
    u8('32'),
    u8('192'),
    u8('192'),
    u8('20'),
    u8('2')
];
const BASE_POINT = [
    u8('226'),
    u8('242'),
    u8('174'),
    u8('10'),
    u8('106'),
    u8('188'),
    u8('78'),
    u8('113'),
    u8('168'),
    u8('132'),
    u8('169'),
    u8('97'),
    u8('197'),
    u8('0'),
    u8('81'),
    u8('95'),
    u8('88'),
    u8('227'),
    u8('11'),
    u8('106'),
    u8('165'),
    u8('130'),
    u8('221'),
    u8('141'),
    u8('182'),
    u8('166'),
    u8('89'),
    u8('69'),
    u8('224'),
    u8('141'),
    u8('45'),
    u8('118')
];
const B_POINT = [
    u8('250'),
    u8('11'),
    u8('54'),
    u8('36'),
    u8('176'),
    u8('129'),
    u8('198'),
    u8('47'),
    u8('54'),
    u8('77'),
    u8('11'),
    u8('40'),
    u8('57'),
    u8('220'),
    u8('199'),
    u8('109'),
    u8('124'),
    u8('58'),
    u8('176'),
    u8('226'),
    u8('126'),
    u8('49'),
    u8('190'),
    u8('178'),
    u8('185'),
    u8('237'),
    u8('118'),
    u8('101'),
    u8('117'),
    u8('242'),
    u8('142'),
    u8('118')
];
const B_SCALAR = [
    u8('219'),
    u8('253'),
    u8('151'),
    u8('175'),
    u8('211'),
    u8('138'),
    u8('6'),
    u8('240'),
    u8('19'),
    u8('141'),
    u8('5'),
    u8('39'),
    u8('239'),
    u8('178'),
    u8('142'),
    u8('173'),
    u8('91'),
    u8('113'),
    u8('9'),
    u8('180'),
    u8('134'),
    u8('70'),
    u8('89'),
    u8('19'),
    u8('191'),
    u8('58'),
    u8('164'),
    u8('114'),
    u8('168'),
    u8('237'),
    u8('78'),
    u8('13')
];
const E_DIFFERENT_NUM_POINTS_AND_SCALARS = u64('1');
const E_ZERO_POINTS = u64('2');
const E_ZERO_SCALARS = u64('3');
const L_MINUS_ONE = [
    u8('236'),
    u8('211'),
    u8('245'),
    u8('92'),
    u8('26'),
    u8('99'),
    u8('18'),
    u8('88'),
    u8('214'),
    u8('156'),
    u8('247'),
    u8('162'),
    u8('222'),
    u8('249'),
    u8('222'),
    u8('20'),
    u8('0'),
    u8('0'),
    u8('0'),
    u8('0'),
    u8('0'),
    u8('0'),
    u8('0'),
    u8('0'),
    u8('0'),
    u8('0'),
    u8('0'),
    u8('0'),
    u8('0'),
    u8('0'),
    u8('0'),
    u8('16')
];
const L_PLUS_ONE = [
    u8('238'),
    u8('211'),
    u8('245'),
    u8('92'),
    u8('26'),
    u8('99'),
    u8('18'),
    u8('88'),
    u8('214'),
    u8('156'),
    u8('247'),
    u8('162'),
    u8('222'),
    u8('249'),
    u8('222'),
    u8('20'),
    u8('0'),
    u8('0'),
    u8('0'),
    u8('0'),
    u8('0'),
    u8('0'),
    u8('0'),
    u8('0'),
    u8('0'),
    u8('0'),
    u8('0'),
    u8('0'),
    u8('0'),
    u8('0'),
    u8('0'),
    u8('16')
];
const L_PLUS_TWO = [
    u8('239'),
    u8('211'),
    u8('245'),
    u8('92'),
    u8('26'),
    u8('99'),
    u8('18'),
    u8('88'),
    u8('214'),
    u8('156'),
    u8('247'),
    u8('162'),
    u8('222'),
    u8('249'),
    u8('222'),
    u8('20'),
    u8('0'),
    u8('0'),
    u8('0'),
    u8('0'),
    u8('0'),
    u8('0'),
    u8('0'),
    u8('0'),
    u8('0'),
    u8('0'),
    u8('0'),
    u8('0'),
    u8('0'),
    u8('0'),
    u8('0'),
    u8('16')
];
const MAX_POINT_NUM_BYTES = u64('32');
const MAX_SCALAR_NUM_BITS = u64('256');
const MAX_SCALAR_NUM_BYTES = u64('32');
const NON_CANONICAL_ALL_ONES = [
    u8('255'),
    u8('255'),
    u8('255'),
    u8('255'),
    u8('255'),
    u8('255'),
    u8('255'),
    u8('255'),
    u8('255'),
    u8('255'),
    u8('255'),
    u8('255'),
    u8('255'),
    u8('255'),
    u8('255'),
    u8('255'),
    u8('255'),
    u8('255'),
    u8('255'),
    u8('255'),
    u8('255'),
    u8('255'),
    u8('255'),
    u8('255'),
    u8('255'),
    u8('255'),
    u8('255'),
    u8('255'),
    u8('255'),
    u8('255'),
    u8('255'),
    u8('255')
];
const ORDER_ELL = [
    u8('237'),
    u8('211'),
    u8('245'),
    u8('92'),
    u8('26'),
    u8('99'),
    u8('18'),
    u8('88'),
    u8('214'),
    u8('156'),
    u8('247'),
    u8('162'),
    u8('222'),
    u8('249'),
    u8('222'),
    u8('20'),
    u8('0'),
    u8('0'),
    u8('0'),
    u8('0'),
    u8('0'),
    u8('0'),
    u8('0'),
    u8('0'),
    u8('0'),
    u8('0'),
    u8('0'),
    u8('0'),
    u8('0'),
    u8('0'),
    u8('0'),
    u8('16')
];
const REDUCED_2_256_MINUS_1_SCALAR = [
    u8('28'),
    u8('149'),
    u8('152'),
    u8('141'),
    u8('116'),
    u8('49'),
    u8('236'),
    u8('214'),
    u8('112'),
    u8('207'),
    u8('125'),
    u8('115'),
    u8('244'),
    u8('91'),
    u8('239'),
    u8('198'),
    u8('254'),
    u8('255'),
    u8('255'),
    u8('255'),
    u8('255'),
    u8('255'),
    u8('255'),
    u8('255'),
    u8('255'),
    u8('255'),
    u8('255'),
    u8('255'),
    u8('255'),
    u8('255'),
    u8('255'),
    u8('15')
];
const REDUCED_X_PLUS_2_TO_256_TIMES_X_SCALAR = [
    u8('216'),
    u8('154'),
    u8('179'),
    u8('139'),
    u8('210'),
    u8('121'),
    u8('2'),
    u8('71'),
    u8('69'),
    u8('99'),
    u8('158'),
    u8('216'),
    u8('23'),
    u8('173'),
    u8('63'),
    u8('100'),
    u8('204'),
    u8('0'),
    u8('91'),
    u8('50'),
    u8('219'),
    u8('153'),
    u8('57'),
    u8('249'),
    u8('28'),
    u8('82'),
    u8('31'),
    u8('197'),
    u8('100'),
    u8('165'),
    u8('192'),
    u8('8')
];
const TWO_SCALAR = [
    u8('2'),
    u8('0'),
    u8('0'),
    u8('0'),
    u8('0'),
    u8('0'),
    u8('0'),
    u8('0'),
    u8('0'),
    u8('0'),
    u8('0'),
    u8('0'),
    u8('0'),
    u8('0'),
    u8('0'),
    u8('0'),
    u8('0'),
    u8('0'),
    u8('0'),
    u8('0'),
    u8('0'),
    u8('0'),
    u8('0'),
    u8('0'),
    u8('0'),
    u8('0'),
    u8('0'),
    u8('0'),
    u8('0'),
    u8('0'),
    u8('0'),
    u8('0')
];
const X_INV_SCALAR = [
    u8('28'),
    u8('220'),
    u8('23'),
    u8('252'),
    u8('224'),
    u8('233'),
    u8('165'),
    u8('187'),
    u8('217'),
    u8('36'),
    u8('126'),
    u8('86'),
    u8('187'),
    u8('1'),
    u8('99'),
    u8('71'),
    u8('187'),
    u8('186'),
    u8('49'),
    u8('237'),
    u8('213'),
    u8('169'),
    u8('187'),
    u8('150'),
    u8('213'),
    u8('11'),
    u8('205'),
    u8('122'),
    u8('63'),
    u8('150'),
    u8('42'),
    u8('15')
];
const X_SCALAR = [
    u8('78'),
    u8('90'),
    u8('180'),
    u8('52'),
    u8('93'),
    u8('71'),
    u8('8'),
    u8('132'),
    u8('89'),
    u8('19'),
    u8('180'),
    u8('100'),
    u8('27'),
    u8('194'),
    u8('125'),
    u8('82'),
    u8('82'),
    u8('165'),
    u8('133'),
    u8('16'),
    u8('27'),
    u8('204'),
    u8('66'),
    u8('68'),
    u8('212'),
    u8('73'),
    u8('244'),
    u8('168'),
    u8('121'),
    u8('217'),
    u8('242'),
    u8('4')
];
const X_TIMES_Y_SCALAR = [
    u8('108'),
    u8('51'),
    u8('116'),
    u8('161'),
    u8('137'),
    u8('79'),
    u8('98'),
    u8('33'),
    u8('10'),
    u8('170'),
    u8('47'),
    u8('225'),
    u8('134'),
    u8('166'),
    u8('249'),
    u8('44'),
    u8('224'),
    u8('170'),
    u8('117'),
    u8('194'),
    u8('119'),
    u8('149'),
    u8('129'),
    u8('194'),
    u8('149'),
    u8('252'),
    u8('8'),
    u8('23'),
    u8('154'),
    u8('115'),
    u8('148'),
    u8('12')
];
const Y_SCALAR = [
    u8('144'),
    u8('118'),
    u8('51'),
    u8('254'),
    u8('28'),
    u8('75'),
    u8('102'),
    u8('164'),
    u8('162'),
    u8('141'),
    u8('45'),
    u8('215'),
    u8('103'),
    u8('131'),
    u8('134'),
    u8('195'),
    u8('83'),
    u8('208'),
    u8('222'),
    u8('84'),
    u8('85'),
    u8('212'),
    u8('252'),
    u8('157'),
    u8('232'),
    u8('239'),
    u8('122'),
    u8('195'),
    u8('31'),
    u8('53'),
    u8('187'),
    u8('5')
];
class CompressedRistretto {
    constructor(proto, typeTag) {
        this.typeTag = typeTag;
        this.__app = null;
        this.data = proto['data'];
    }
    static CompressedRistrettoParser(data, typeTag, repo) {
        const proto = $.parseStructProto(data, typeTag, repo, CompressedRistretto);
        return new CompressedRistretto(proto, typeTag);
    }
    static getTag() {
        return new StructTag(moduleAddress$x, moduleName$x, 'CompressedRistretto', []);
    }
    loadFullState(app) {
        return __awaiter(this, void 0, void 0, function* () {
            this.__app = app;
        });
    }
}
CompressedRistretto.moduleAddress = moduleAddress$x;
CompressedRistretto.moduleName = moduleName$x;
CompressedRistretto.structName = 'CompressedRistretto';
CompressedRistretto.typeParameters = [];
CompressedRistretto.fields = [{ name: 'data', typeTag: new VectorTag(AtomicTypeTag.U8) }];
class RistrettoPoint {
    constructor(proto, typeTag) {
        this.typeTag = typeTag;
        this.__app = null;
        this.handle = proto['handle'];
    }
    static RistrettoPointParser(data, typeTag, repo) {
        const proto = $.parseStructProto(data, typeTag, repo, RistrettoPoint);
        return new RistrettoPoint(proto, typeTag);
    }
    static getTag() {
        return new StructTag(moduleAddress$x, moduleName$x, 'RistrettoPoint', []);
    }
    loadFullState(app) {
        return __awaiter(this, void 0, void 0, function* () {
            this.__app = app;
        });
    }
}
RistrettoPoint.moduleAddress = moduleAddress$x;
RistrettoPoint.moduleName = moduleName$x;
RistrettoPoint.structName = 'RistrettoPoint';
RistrettoPoint.typeParameters = [];
RistrettoPoint.fields = [{ name: 'handle', typeTag: AtomicTypeTag.U64 }];
class Scalar {
    constructor(proto, typeTag) {
        this.typeTag = typeTag;
        this.__app = null;
        this.data = proto['data'];
    }
    static ScalarParser(data, typeTag, repo) {
        const proto = $.parseStructProto(data, typeTag, repo, Scalar);
        return new Scalar(proto, typeTag);
    }
    static getTag() {
        return new StructTag(moduleAddress$x, moduleName$x, 'Scalar', []);
    }
    loadFullState(app) {
        return __awaiter(this, void 0, void 0, function* () {
            this.__app = app;
        });
    }
}
Scalar.moduleAddress = moduleAddress$x;
Scalar.moduleName = moduleName$x;
Scalar.structName = 'Scalar';
Scalar.typeParameters = [];
Scalar.fields = [{ name: 'data', typeTag: new VectorTag(AtomicTypeTag.U8) }];
function basepoint_($c) {
    let handle;
    [handle] = point_decompress_internal_($.copy(BASE_POINT));
    return new RistrettoPoint({ handle: $.copy(handle) }, new SimpleStructTag(RistrettoPoint));
}
function basepoint_compressed_($c) {
    return new CompressedRistretto({ data: $.copy(BASE_POINT) }, new SimpleStructTag(CompressedRistretto));
}
function basepoint_double_mul_(a, some_point, b, $c) {
    return new RistrettoPoint({ handle: basepoint_double_mul_internal_($.copy(a.data), some_point, $.copy(b.data)) }, new SimpleStructTag(RistrettoPoint));
}
function basepoint_double_mul_internal_(a, some_point, b, $c) {
    throw 'Not Implemented';
}
function basepoint_mul_(a, $c) {
    return new RistrettoPoint({ handle: basepoint_mul_internal_($.copy(a.data)) }, new SimpleStructTag(RistrettoPoint));
}
function basepoint_mul_internal_(a, $c) {
    throw 'Not Implemented';
}
function multi_scalar_mul_(points, scalars, $c) {
    if (!!is_empty_$2(points, $c, [new SimpleStructTag(RistrettoPoint)])) {
        throw $.abortCode(invalid_argument_($.copy(E_ZERO_POINTS)));
    }
    if (!!is_empty_$2(scalars, $c, [new SimpleStructTag(Scalar)])) {
        throw $.abortCode(invalid_argument_($.copy(E_ZERO_SCALARS)));
    }
    if (!length_$6(points, $c, [new SimpleStructTag(RistrettoPoint)]).eq(length_$6(scalars, $c, [new SimpleStructTag(Scalar)]))) {
        throw $.abortCode(invalid_argument_($.copy(E_DIFFERENT_NUM_POINTS_AND_SCALARS)));
    }
    return new RistrettoPoint({
        handle: multi_scalar_mul_internal_(points, scalars, $c, [
            new SimpleStructTag(RistrettoPoint),
            new SimpleStructTag(Scalar)
        ])
    }, new SimpleStructTag(RistrettoPoint));
}
function multi_scalar_mul_internal_(points, scalars, $c, $p /* <P, S>*/) {
    throw 'Not Implemented';
}
function new_compressed_point_from_bytes_(bytes, $c) {
    let temp$1;
    if (point_is_canonical_internal_($.copy(bytes))) {
        temp$1 = some_(new CompressedRistretto({ data: $.copy(bytes) }, new SimpleStructTag(CompressedRistretto)), $c, [new SimpleStructTag(CompressedRistretto)]);
    }
    else {
        temp$1 = none_($c, [new SimpleStructTag(CompressedRistretto)]);
    }
    return temp$1;
}
function new_point_from_64_uniform_bytes_(bytes, $c) {
    let temp$1;
    if (length_$6(bytes, $c, [AtomicTypeTag.U8]).eq(u64('64'))) {
        temp$1 = some_(new RistrettoPoint({ handle: new_point_from_64_uniform_bytes_internal_($.copy(bytes)) }, new SimpleStructTag(RistrettoPoint)), $c, [new SimpleStructTag(RistrettoPoint)]);
    }
    else {
        temp$1 = none_($c, [new SimpleStructTag(RistrettoPoint)]);
    }
    return temp$1;
}
function new_point_from_64_uniform_bytes_internal_(bytes, $c) {
    throw 'Not Implemented';
}
function new_point_from_bytes_(bytes, $c) {
    let temp$1, handle, is_canonical;
    [handle, is_canonical] = point_decompress_internal_($.copy(bytes));
    if (is_canonical) {
        temp$1 = some_(new RistrettoPoint({ handle: $.copy(handle) }, new SimpleStructTag(RistrettoPoint)), $c, [
            new SimpleStructTag(RistrettoPoint)
        ]);
    }
    else {
        temp$1 = none_($c, [new SimpleStructTag(RistrettoPoint)]);
    }
    return temp$1;
}
function new_point_from_sha512_(sha512, $c) {
    return new RistrettoPoint({ handle: new_point_from_sha512_internal_($.copy(sha512)) }, new SimpleStructTag(RistrettoPoint));
}
function new_point_from_sha512_internal_(sha512, $c) {
    throw 'Not Implemented';
}
function new_scalar_from_bytes_(bytes, $c) {
    let temp$1;
    if (scalar_is_canonical_internal_($.copy(bytes))) {
        temp$1 = some_(new Scalar({ data: $.copy(bytes) }, new SimpleStructTag(Scalar)), $c, [
            new SimpleStructTag(Scalar)
        ]);
    }
    else {
        temp$1 = none_($c, [new SimpleStructTag(Scalar)]);
    }
    return temp$1;
}
function new_scalar_from_sha512_(sha512_input, $c) {
    return new Scalar({ data: scalar_from_sha512_internal_($.copy(sha512_input)) }, new SimpleStructTag(Scalar));
}
function new_scalar_from_u128_(sixteen_bytes, $c) {
    return new Scalar({ data: scalar_from_u128_internal_($.copy(sixteen_bytes)) }, new SimpleStructTag(Scalar));
}
function new_scalar_from_u64_(eight_bytes, $c) {
    return new Scalar({ data: scalar_from_u64_internal_($.copy(eight_bytes)) }, new SimpleStructTag(Scalar));
}
function new_scalar_from_u8_(byte, $c) {
    let byte_zero, s;
    s = scalar_zero_();
    byte_zero = borrow_mut_$7(s.data, u64('0'), $c, [AtomicTypeTag.U8]);
    $.set(byte_zero, $.copy(byte));
    return $.copy(s);
}
function new_scalar_reduced_from_32_bytes_(bytes, $c) {
    let temp$1;
    if (length_$6(bytes, $c, [AtomicTypeTag.U8]).eq(u64('32'))) {
        temp$1 = some_(new Scalar({ data: scalar_reduced_from_32_bytes_internal_($.copy(bytes)) }, new SimpleStructTag(Scalar)), $c, [new SimpleStructTag(Scalar)]);
    }
    else {
        temp$1 = none_($c, [new SimpleStructTag(Scalar)]);
    }
    return temp$1;
}
function new_scalar_uniform_from_64_bytes_(bytes, $c) {
    let temp$1;
    if (length_$6(bytes, $c, [AtomicTypeTag.U8]).eq(u64('64'))) {
        temp$1 = some_(new Scalar({ data: scalar_uniform_from_64_bytes_internal_($.copy(bytes)) }, new SimpleStructTag(Scalar)), $c, [new SimpleStructTag(Scalar)]);
    }
    else {
        temp$1 = none_($c, [new SimpleStructTag(Scalar)]);
    }
    return temp$1;
}
function point_add_(a, b, $c) {
    return new RistrettoPoint({ handle: point_add_internal_() }, new SimpleStructTag(RistrettoPoint));
}
function point_add_assign_(a, b, $c) {
    point_add_internal_();
    return a;
}
function point_add_internal_(a, b, in_place, $c) {
    throw 'Not Implemented';
}
function point_compress_(point, $c) {
    return new CompressedRistretto({ data: point_compress_internal_() }, new SimpleStructTag(CompressedRistretto));
}
function point_compress_internal_(point, $c) {
    throw 'Not Implemented';
}
function point_decompress_(point, $c) {
    let handle;
    [handle] = point_decompress_internal_($.copy(point.data));
    return new RistrettoPoint({ handle: $.copy(handle) }, new SimpleStructTag(RistrettoPoint));
}
function point_decompress_internal_(maybe_non_canonical_bytes, $c) {
    throw 'Not Implemented';
}
function point_equals_(g, h, $c) {
    throw 'Not Implemented';
}
function point_identity_($c) {
    return new RistrettoPoint({ handle: point_identity_internal_() }, new SimpleStructTag(RistrettoPoint));
}
function point_identity_compressed_($c) {
    return new CompressedRistretto({
        data: [
            u8('0'),
            u8('0'),
            u8('0'),
            u8('0'),
            u8('0'),
            u8('0'),
            u8('0'),
            u8('0'),
            u8('0'),
            u8('0'),
            u8('0'),
            u8('0'),
            u8('0'),
            u8('0'),
            u8('0'),
            u8('0'),
            u8('0'),
            u8('0'),
            u8('0'),
            u8('0'),
            u8('0'),
            u8('0'),
            u8('0'),
            u8('0'),
            u8('0'),
            u8('0'),
            u8('0'),
            u8('0'),
            u8('0'),
            u8('0'),
            u8('0'),
            u8('0')
        ]
    }, new SimpleStructTag(CompressedRistretto));
}
function point_identity_internal_($c) {
    throw 'Not Implemented';
}
function point_is_canonical_internal_(bytes, $c) {
    throw 'Not Implemented';
}
function point_mul_(point, a, $c) {
    return new RistrettoPoint({ handle: point_mul_internal_(point, $.copy(a.data)) }, new SimpleStructTag(RistrettoPoint));
}
function point_mul_assign_(point, a, $c) {
    [point, $.copy(a.data), true];
    point_mul_internal_();
    return point;
}
function point_mul_internal_(point, a, in_place, $c) {
    throw 'Not Implemented';
}
function point_neg_(a, $c) {
    return new RistrettoPoint({ handle: point_neg_internal_() }, new SimpleStructTag(RistrettoPoint));
}
function point_neg_assign_(a, $c) {
    point_neg_internal_();
    return a;
}
function point_neg_internal_(a, in_place, $c) {
    throw 'Not Implemented';
}
function point_sub_(a, b, $c) {
    return new RistrettoPoint({ handle: point_sub_internal_() }, new SimpleStructTag(RistrettoPoint));
}
function point_sub_assign_(a, b, $c) {
    point_sub_internal_();
    return a;
}
function point_sub_internal_(a, b, in_place, $c) {
    throw 'Not Implemented';
}
function point_to_bytes_(point, $c) {
    return $.copy(point.data);
}
function scalar_add_(a, b, $c) {
    return new Scalar({ data: scalar_add_internal_($.copy(a.data), $.copy(b.data)) }, new SimpleStructTag(Scalar));
}
function scalar_add_assign_(a, b, $c) {
    let temp$1, temp$2, temp$3;
    [temp$1, temp$2] = [a, b];
    temp$3 = scalar_add_(temp$1, temp$2);
    a.data = $.copy(temp$3.data);
    return a;
}
function scalar_add_internal_(a_bytes, b_bytes, $c) {
    throw 'Not Implemented';
}
function scalar_equals_(lhs, rhs, $c) {
    return $.veq($.copy(lhs.data), $.copy(rhs.data));
}
function scalar_from_sha512_internal_(sha512_input, $c) {
    throw 'Not Implemented';
}
function scalar_from_u128_internal_(num, $c) {
    throw 'Not Implemented';
}
function scalar_from_u64_internal_(num, $c) {
    throw 'Not Implemented';
}
function scalar_invert_(s, $c) {
    let temp$1;
    if (scalar_is_zero_(s)) {
        temp$1 = none_($c, [new SimpleStructTag(Scalar)]);
    }
    else {
        temp$1 = some_(new Scalar({ data: scalar_invert_internal_($.copy(s.data)) }, new SimpleStructTag(Scalar)), $c, [new SimpleStructTag(Scalar)]);
    }
    return temp$1;
}
function scalar_invert_internal_(bytes, $c) {
    throw 'Not Implemented';
}
function scalar_is_canonical_internal_(s, $c) {
    throw 'Not Implemented';
}
function scalar_is_one_(s, $c) {
    return $.veq($.copy(s.data), [
        u8('1'),
        u8('0'),
        u8('0'),
        u8('0'),
        u8('0'),
        u8('0'),
        u8('0'),
        u8('0'),
        u8('0'),
        u8('0'),
        u8('0'),
        u8('0'),
        u8('0'),
        u8('0'),
        u8('0'),
        u8('0'),
        u8('0'),
        u8('0'),
        u8('0'),
        u8('0'),
        u8('0'),
        u8('0'),
        u8('0'),
        u8('0'),
        u8('0'),
        u8('0'),
        u8('0'),
        u8('0'),
        u8('0'),
        u8('0'),
        u8('0'),
        u8('0')
    ]);
}
function scalar_is_zero_(s, $c) {
    return $.veq($.copy(s.data), [
        u8('0'),
        u8('0'),
        u8('0'),
        u8('0'),
        u8('0'),
        u8('0'),
        u8('0'),
        u8('0'),
        u8('0'),
        u8('0'),
        u8('0'),
        u8('0'),
        u8('0'),
        u8('0'),
        u8('0'),
        u8('0'),
        u8('0'),
        u8('0'),
        u8('0'),
        u8('0'),
        u8('0'),
        u8('0'),
        u8('0'),
        u8('0'),
        u8('0'),
        u8('0'),
        u8('0'),
        u8('0'),
        u8('0'),
        u8('0'),
        u8('0'),
        u8('0')
    ]);
}
function scalar_mul_(a, b, $c) {
    return new Scalar({ data: scalar_mul_internal_($.copy(a.data), $.copy(b.data)) }, new SimpleStructTag(Scalar));
}
function scalar_mul_assign_(a, b, $c) {
    let temp$1, temp$2, temp$3;
    [temp$1, temp$2] = [a, b];
    temp$3 = scalar_mul_(temp$1, temp$2);
    a.data = $.copy(temp$3.data);
    return a;
}
function scalar_mul_internal_(a_bytes, b_bytes, $c) {
    throw 'Not Implemented';
}
function scalar_neg_(a, $c) {
    return new Scalar({ data: scalar_neg_internal_($.copy(a.data)) }, new SimpleStructTag(Scalar));
}
function scalar_neg_assign_(a, $c) {
    let temp$1;
    temp$1 = scalar_neg_(a);
    a.data = $.copy(temp$1.data);
    return a;
}
function scalar_neg_internal_(a_bytes, $c) {
    throw 'Not Implemented';
}
function scalar_one_($c) {
    return new Scalar({
        data: [
            u8('1'),
            u8('0'),
            u8('0'),
            u8('0'),
            u8('0'),
            u8('0'),
            u8('0'),
            u8('0'),
            u8('0'),
            u8('0'),
            u8('0'),
            u8('0'),
            u8('0'),
            u8('0'),
            u8('0'),
            u8('0'),
            u8('0'),
            u8('0'),
            u8('0'),
            u8('0'),
            u8('0'),
            u8('0'),
            u8('0'),
            u8('0'),
            u8('0'),
            u8('0'),
            u8('0'),
            u8('0'),
            u8('0'),
            u8('0'),
            u8('0'),
            u8('0')
        ]
    }, new SimpleStructTag(Scalar));
}
function scalar_reduced_from_32_bytes_internal_(bytes, $c) {
    throw 'Not Implemented';
}
function scalar_sub_(a, b, $c) {
    return new Scalar({ data: scalar_sub_internal_($.copy(a.data), $.copy(b.data)) }, new SimpleStructTag(Scalar));
}
function scalar_sub_assign_(a, b, $c) {
    let temp$1, temp$2, temp$3;
    [temp$1, temp$2] = [a, b];
    temp$3 = scalar_sub_(temp$1, temp$2);
    a.data = $.copy(temp$3.data);
    return a;
}
function scalar_sub_internal_(a_bytes, b_bytes, $c) {
    throw 'Not Implemented';
}
function scalar_to_bytes_(s, $c) {
    return $.copy(s.data);
}
function scalar_uniform_from_64_bytes_internal_(bytes, $c) {
    throw 'Not Implemented';
}
function scalar_zero_($c) {
    return new Scalar({
        data: [
            u8('0'),
            u8('0'),
            u8('0'),
            u8('0'),
            u8('0'),
            u8('0'),
            u8('0'),
            u8('0'),
            u8('0'),
            u8('0'),
            u8('0'),
            u8('0'),
            u8('0'),
            u8('0'),
            u8('0'),
            u8('0'),
            u8('0'),
            u8('0'),
            u8('0'),
            u8('0'),
            u8('0'),
            u8('0'),
            u8('0'),
            u8('0'),
            u8('0'),
            u8('0'),
            u8('0'),
            u8('0'),
            u8('0'),
            u8('0'),
            u8('0'),
            u8('0')
        ]
    }, new SimpleStructTag(Scalar));
}
function loadParsers$K(repo) {
    repo.addParser('0x1::ristretto255::CompressedRistretto', CompressedRistretto.CompressedRistrettoParser);
    repo.addParser('0x1::ristretto255::RistrettoPoint', RistrettoPoint.RistrettoPointParser);
    repo.addParser('0x1::ristretto255::Scalar', Scalar.ScalarParser);
}
class App$L {
    constructor(client, repo, cache) {
        this.client = client;
        this.repo = repo;
        this.cache = cache;
    }
    get moduleAddress() {
        {
            return moduleAddress$x;
        }
    }
    get moduleName() {
        {
            return moduleName$x;
        }
    }
    get CompressedRistretto() {
        return CompressedRistretto;
    }
    get RistrettoPoint() {
        return RistrettoPoint;
    }
    get Scalar() {
        return Scalar;
    }
}

var Ristretto255 = /*#__PURE__*/Object.freeze({
    __proto__: null,
    packageName: packageName$x,
    moduleAddress: moduleAddress$x,
    moduleName: moduleName$x,
    A_PLUS_B_POINT: A_PLUS_B_POINT,
    A_PLUS_B_SCALAR: A_PLUS_B_SCALAR,
    A_POINT: A_POINT,
    A_SCALAR: A_SCALAR,
    A_TIMES_BASE_POINT: A_TIMES_BASE_POINT,
    A_TIMES_B_SCALAR: A_TIMES_B_SCALAR,
    BASE_POINT: BASE_POINT,
    B_POINT: B_POINT,
    B_SCALAR: B_SCALAR,
    E_DIFFERENT_NUM_POINTS_AND_SCALARS: E_DIFFERENT_NUM_POINTS_AND_SCALARS,
    E_ZERO_POINTS: E_ZERO_POINTS,
    E_ZERO_SCALARS: E_ZERO_SCALARS,
    L_MINUS_ONE: L_MINUS_ONE,
    L_PLUS_ONE: L_PLUS_ONE,
    L_PLUS_TWO: L_PLUS_TWO,
    MAX_POINT_NUM_BYTES: MAX_POINT_NUM_BYTES,
    MAX_SCALAR_NUM_BITS: MAX_SCALAR_NUM_BITS,
    MAX_SCALAR_NUM_BYTES: MAX_SCALAR_NUM_BYTES,
    NON_CANONICAL_ALL_ONES: NON_CANONICAL_ALL_ONES,
    ORDER_ELL: ORDER_ELL,
    REDUCED_2_256_MINUS_1_SCALAR: REDUCED_2_256_MINUS_1_SCALAR,
    REDUCED_X_PLUS_2_TO_256_TIMES_X_SCALAR: REDUCED_X_PLUS_2_TO_256_TIMES_X_SCALAR,
    TWO_SCALAR: TWO_SCALAR,
    X_INV_SCALAR: X_INV_SCALAR,
    X_SCALAR: X_SCALAR,
    X_TIMES_Y_SCALAR: X_TIMES_Y_SCALAR,
    Y_SCALAR: Y_SCALAR,
    CompressedRistretto: CompressedRistretto,
    RistrettoPoint: RistrettoPoint,
    Scalar: Scalar,
    basepoint_: basepoint_,
    basepoint_compressed_: basepoint_compressed_,
    basepoint_double_mul_: basepoint_double_mul_,
    basepoint_double_mul_internal_: basepoint_double_mul_internal_,
    basepoint_mul_: basepoint_mul_,
    basepoint_mul_internal_: basepoint_mul_internal_,
    multi_scalar_mul_: multi_scalar_mul_,
    multi_scalar_mul_internal_: multi_scalar_mul_internal_,
    new_compressed_point_from_bytes_: new_compressed_point_from_bytes_,
    new_point_from_64_uniform_bytes_: new_point_from_64_uniform_bytes_,
    new_point_from_64_uniform_bytes_internal_: new_point_from_64_uniform_bytes_internal_,
    new_point_from_bytes_: new_point_from_bytes_,
    new_point_from_sha512_: new_point_from_sha512_,
    new_point_from_sha512_internal_: new_point_from_sha512_internal_,
    new_scalar_from_bytes_: new_scalar_from_bytes_,
    new_scalar_from_sha512_: new_scalar_from_sha512_,
    new_scalar_from_u128_: new_scalar_from_u128_,
    new_scalar_from_u64_: new_scalar_from_u64_,
    new_scalar_from_u8_: new_scalar_from_u8_,
    new_scalar_reduced_from_32_bytes_: new_scalar_reduced_from_32_bytes_,
    new_scalar_uniform_from_64_bytes_: new_scalar_uniform_from_64_bytes_,
    point_add_: point_add_,
    point_add_assign_: point_add_assign_,
    point_add_internal_: point_add_internal_,
    point_compress_: point_compress_,
    point_compress_internal_: point_compress_internal_,
    point_decompress_: point_decompress_,
    point_decompress_internal_: point_decompress_internal_,
    point_equals_: point_equals_,
    point_identity_: point_identity_,
    point_identity_compressed_: point_identity_compressed_,
    point_identity_internal_: point_identity_internal_,
    point_is_canonical_internal_: point_is_canonical_internal_,
    point_mul_: point_mul_,
    point_mul_assign_: point_mul_assign_,
    point_mul_internal_: point_mul_internal_,
    point_neg_: point_neg_,
    point_neg_assign_: point_neg_assign_,
    point_neg_internal_: point_neg_internal_,
    point_sub_: point_sub_,
    point_sub_assign_: point_sub_assign_,
    point_sub_internal_: point_sub_internal_,
    point_to_bytes_: point_to_bytes_,
    scalar_add_: scalar_add_,
    scalar_add_assign_: scalar_add_assign_,
    scalar_add_internal_: scalar_add_internal_,
    scalar_equals_: scalar_equals_,
    scalar_from_sha512_internal_: scalar_from_sha512_internal_,
    scalar_from_u128_internal_: scalar_from_u128_internal_,
    scalar_from_u64_internal_: scalar_from_u64_internal_,
    scalar_invert_: scalar_invert_,
    scalar_invert_internal_: scalar_invert_internal_,
    scalar_is_canonical_internal_: scalar_is_canonical_internal_,
    scalar_is_one_: scalar_is_one_,
    scalar_is_zero_: scalar_is_zero_,
    scalar_mul_: scalar_mul_,
    scalar_mul_assign_: scalar_mul_assign_,
    scalar_mul_internal_: scalar_mul_internal_,
    scalar_neg_: scalar_neg_,
    scalar_neg_assign_: scalar_neg_assign_,
    scalar_neg_internal_: scalar_neg_internal_,
    scalar_one_: scalar_one_,
    scalar_reduced_from_32_bytes_internal_: scalar_reduced_from_32_bytes_internal_,
    scalar_sub_: scalar_sub_,
    scalar_sub_assign_: scalar_sub_assign_,
    scalar_sub_internal_: scalar_sub_internal_,
    scalar_to_bytes_: scalar_to_bytes_,
    scalar_uniform_from_64_bytes_internal_: scalar_uniform_from_64_bytes_internal_,
    scalar_zero_: scalar_zero_,
    loadParsers: loadParsers$K,
    App: App$L
});

const packageName$w = 'AptosStdlib';
const moduleAddress$w = new HexString('0x1');
const moduleName$w = 'secp256k1';
const E_DESERIALIZE = u64('1');
const RAW_PUBLIC_KEY_NUM_BYTES = u64('64');
const SIGNATURE_NUM_BYTES = u64('64');
class ECDSARawPublicKey {
    constructor(proto, typeTag) {
        this.typeTag = typeTag;
        this.__app = null;
        this.bytes = proto['bytes'];
    }
    static ECDSARawPublicKeyParser(data, typeTag, repo) {
        const proto = $.parseStructProto(data, typeTag, repo, ECDSARawPublicKey);
        return new ECDSARawPublicKey(proto, typeTag);
    }
    static getTag() {
        return new StructTag(moduleAddress$w, moduleName$w, 'ECDSARawPublicKey', []);
    }
    loadFullState(app) {
        return __awaiter(this, void 0, void 0, function* () {
            this.__app = app;
        });
    }
}
ECDSARawPublicKey.moduleAddress = moduleAddress$w;
ECDSARawPublicKey.moduleName = moduleName$w;
ECDSARawPublicKey.structName = 'ECDSARawPublicKey';
ECDSARawPublicKey.typeParameters = [];
ECDSARawPublicKey.fields = [{ name: 'bytes', typeTag: new VectorTag(AtomicTypeTag.U8) }];
class ECDSASignature {
    constructor(proto, typeTag) {
        this.typeTag = typeTag;
        this.__app = null;
        this.bytes = proto['bytes'];
    }
    static ECDSASignatureParser(data, typeTag, repo) {
        const proto = $.parseStructProto(data, typeTag, repo, ECDSASignature);
        return new ECDSASignature(proto, typeTag);
    }
    static getTag() {
        return new StructTag(moduleAddress$w, moduleName$w, 'ECDSASignature', []);
    }
    loadFullState(app) {
        return __awaiter(this, void 0, void 0, function* () {
            this.__app = app;
        });
    }
}
ECDSASignature.moduleAddress = moduleAddress$w;
ECDSASignature.moduleName = moduleName$w;
ECDSASignature.structName = 'ECDSASignature';
ECDSASignature.typeParameters = [];
ECDSASignature.fields = [{ name: 'bytes', typeTag: new VectorTag(AtomicTypeTag.U8) }];
function ecdsa_raw_public_key_from_64_bytes_(bytes, $c) {
    if (!length_$6(bytes, $c, [AtomicTypeTag.U8]).eq($.copy(RAW_PUBLIC_KEY_NUM_BYTES))) {
        throw $.abortCode(invalid_argument_($.copy(E_DESERIALIZE)));
    }
    return new ECDSARawPublicKey({ bytes: $.copy(bytes) }, new SimpleStructTag(ECDSARawPublicKey));
}
function ecdsa_raw_public_key_to_bytes_(pk, $c) {
    return $.copy(pk.bytes);
}
function ecdsa_recover_(message, recovery_id, signature, $c) {
    let temp$1, pk, success;
    [pk, success] = ecdsa_recover_internal_($.copy(message), $.copy(recovery_id), $.copy(signature.bytes), $c);
    if (success) {
        temp$1 = some_(ecdsa_raw_public_key_from_64_bytes_($.copy(pk), $c), $c, [
            new SimpleStructTag(ECDSARawPublicKey)
        ]);
    }
    else {
        temp$1 = none_($c, [new SimpleStructTag(ECDSARawPublicKey)]);
    }
    return temp$1;
}
function ecdsa_recover_internal_(message, recovery_id, signature, $c) {
    return $.aptos_std_secp256k1_ecdsa_recover_internal(message, recovery_id, signature, $c);
}
function ecdsa_signature_from_bytes_(bytes, $c) {
    if (!length_$6(bytes, $c, [AtomicTypeTag.U8]).eq($.copy(SIGNATURE_NUM_BYTES))) {
        throw $.abortCode(invalid_argument_($.copy(E_DESERIALIZE)));
    }
    return new ECDSASignature({ bytes: $.copy(bytes) }, new SimpleStructTag(ECDSASignature));
}
function ecdsa_signature_to_bytes_(sig, $c) {
    return $.copy(sig.bytes);
}
function loadParsers$J(repo) {
    repo.addParser('0x1::secp256k1::ECDSARawPublicKey', ECDSARawPublicKey.ECDSARawPublicKeyParser);
    repo.addParser('0x1::secp256k1::ECDSASignature', ECDSASignature.ECDSASignatureParser);
}
class App$K {
    constructor(client, repo, cache) {
        this.client = client;
        this.repo = repo;
        this.cache = cache;
    }
    get moduleAddress() {
        {
            return moduleAddress$w;
        }
    }
    get moduleName() {
        {
            return moduleName$w;
        }
    }
    get ECDSARawPublicKey() {
        return ECDSARawPublicKey;
    }
    get ECDSASignature() {
        return ECDSASignature;
    }
}

var Secp256k1 = /*#__PURE__*/Object.freeze({
    __proto__: null,
    packageName: packageName$w,
    moduleAddress: moduleAddress$w,
    moduleName: moduleName$w,
    E_DESERIALIZE: E_DESERIALIZE,
    RAW_PUBLIC_KEY_NUM_BYTES: RAW_PUBLIC_KEY_NUM_BYTES,
    SIGNATURE_NUM_BYTES: SIGNATURE_NUM_BYTES,
    ECDSARawPublicKey: ECDSARawPublicKey,
    ECDSASignature: ECDSASignature,
    ecdsa_raw_public_key_from_64_bytes_: ecdsa_raw_public_key_from_64_bytes_,
    ecdsa_raw_public_key_to_bytes_: ecdsa_raw_public_key_to_bytes_,
    ecdsa_recover_: ecdsa_recover_,
    ecdsa_recover_internal_: ecdsa_recover_internal_,
    ecdsa_signature_from_bytes_: ecdsa_signature_from_bytes_,
    ecdsa_signature_to_bytes_: ecdsa_signature_to_bytes_,
    loadParsers: loadParsers$J,
    App: App$K
});

const packageName$v = 'AptosFramework';
const moduleAddress$v = new HexString('0x1');
const moduleName$v = 'staking_proxy';
function set_operator_(owner, old_operator, new_operator, $c) {
    set_vesting_contract_operator_(owner, $.copy(old_operator), $.copy(new_operator), $c);
    set_staking_contract_operator_(owner, $.copy(old_operator), $.copy(new_operator), $c);
    set_stake_pool_operator_(owner, $.copy(new_operator), $c);
    return;
}
function buildPayload_set_operator(old_operator, new_operator, isJSON = false) {
    const typeParamStrings = [];
    return $.buildPayload(new HexString('0x1'), 'staking_proxy', 'set_operator', typeParamStrings, [old_operator, new_operator], isJSON);
}
function set_stake_pool_operator_(owner, new_operator, $c) {
    let owner_address;
    owner_address = address_of_(owner, $c);
    if (stake_pool_exists_($.copy(owner_address), $c)) {
        set_operator_$1(owner, $.copy(new_operator), $c);
    }
    return;
}
function buildPayload_set_stake_pool_operator(new_operator, isJSON = false) {
    const typeParamStrings = [];
    return $.buildPayload(new HexString('0x1'), 'staking_proxy', 'set_stake_pool_operator', typeParamStrings, [new_operator], isJSON);
}
function set_stake_pool_voter_(owner, new_voter, $c) {
    if (stake_pool_exists_(address_of_(owner, $c), $c)) {
        set_delegated_voter_(owner, $.copy(new_voter), $c);
    }
    return;
}
function buildPayload_set_stake_pool_voter(new_voter, isJSON = false) {
    const typeParamStrings = [];
    return $.buildPayload(new HexString('0x1'), 'staking_proxy', 'set_stake_pool_voter', typeParamStrings, [new_voter], isJSON);
}
function set_staking_contract_operator_(owner, old_operator, new_operator, $c) {
    let current_commission_percentage, owner_address;
    owner_address = address_of_(owner, $c);
    if (staking_contract_exists_($.copy(owner_address), $.copy(old_operator), $c)) {
        current_commission_percentage = commission_percentage_($.copy(owner_address), $.copy(old_operator), $c);
        switch_operator_(owner, $.copy(old_operator), $.copy(new_operator), $.copy(current_commission_percentage), $c);
    }
    return;
}
function buildPayload_set_staking_contract_operator(old_operator, new_operator, isJSON = false) {
    const typeParamStrings = [];
    return $.buildPayload(new HexString('0x1'), 'staking_proxy', 'set_staking_contract_operator', typeParamStrings, [old_operator, new_operator], isJSON);
}
function set_staking_contract_voter_(owner, operator, new_voter, $c) {
    let owner_address;
    owner_address = address_of_(owner, $c);
    if (staking_contract_exists_($.copy(owner_address), $.copy(operator), $c)) {
        update_voter_$1(owner, $.copy(operator), $.copy(new_voter), $c);
    }
    return;
}
function buildPayload_set_staking_contract_voter(operator, new_voter, isJSON = false) {
    const typeParamStrings = [];
    return $.buildPayload(new HexString('0x1'), 'staking_proxy', 'set_staking_contract_voter', typeParamStrings, [operator, new_voter], isJSON);
}
function set_vesting_contract_operator_(owner, old_operator, new_operator, $c) {
    let temp$1, current_commission_percentage, i, len, owner_address, vesting_contract, vesting_contracts;
    owner_address = address_of_(owner, $c);
    temp$1 = vesting_contracts_($.copy(owner_address), $c);
    vesting_contracts = temp$1;
    i = u64('0');
    len = length_$6(vesting_contracts, $c, [AtomicTypeTag.Address]);
    while ($.copy(i).lt($.copy(len))) {
        {
            vesting_contract = $.copy(borrow_$7(vesting_contracts, $.copy(i), $c, [AtomicTypeTag.Address]));
            if (operator_($.copy(vesting_contract), $c).hex() === $.copy(old_operator).hex()) {
                current_commission_percentage = operator_commission_percentage_($.copy(vesting_contract), $c);
                update_operator_(owner, $.copy(vesting_contract), $.copy(new_operator), $.copy(current_commission_percentage), $c);
            }
            i = $.copy(i).add(u64('1'));
        }
    }
    return;
}
function buildPayload_set_vesting_contract_operator(old_operator, new_operator, isJSON = false) {
    const typeParamStrings = [];
    return $.buildPayload(new HexString('0x1'), 'staking_proxy', 'set_vesting_contract_operator', typeParamStrings, [old_operator, new_operator], isJSON);
}
function set_vesting_contract_voter_(owner, operator, new_voter, $c) {
    let temp$1, i, len, owner_address, vesting_contract, vesting_contracts;
    owner_address = address_of_(owner, $c);
    temp$1 = vesting_contracts_($.copy(owner_address), $c);
    vesting_contracts = temp$1;
    i = u64('0');
    len = length_$6(vesting_contracts, $c, [AtomicTypeTag.Address]);
    while ($.copy(i).lt($.copy(len))) {
        {
            vesting_contract = $.copy(borrow_$7(vesting_contracts, $.copy(i), $c, [AtomicTypeTag.Address]));
            if (operator_($.copy(vesting_contract), $c).hex() === $.copy(operator).hex()) {
                update_voter_(owner, $.copy(vesting_contract), $.copy(new_voter), $c);
            }
            i = $.copy(i).add(u64('1'));
        }
    }
    return;
}
function buildPayload_set_vesting_contract_voter(operator, new_voter, isJSON = false) {
    const typeParamStrings = [];
    return $.buildPayload(new HexString('0x1'), 'staking_proxy', 'set_vesting_contract_voter', typeParamStrings, [operator, new_voter], isJSON);
}
function set_voter_(owner, operator, new_voter, $c) {
    set_vesting_contract_voter_(owner, $.copy(operator), $.copy(new_voter), $c);
    set_staking_contract_voter_(owner, $.copy(operator), $.copy(new_voter), $c);
    set_stake_pool_voter_(owner, $.copy(new_voter), $c);
    return;
}
function buildPayload_set_voter(operator, new_voter, isJSON = false) {
    const typeParamStrings = [];
    return $.buildPayload(new HexString('0x1'), 'staking_proxy', 'set_voter', typeParamStrings, [operator, new_voter], isJSON);
}
function loadParsers$I(repo) { }
class App$J {
    constructor(client, repo, cache) {
        this.client = client;
        this.repo = repo;
        this.cache = cache;
    }
    get moduleAddress() {
        {
            return moduleAddress$v;
        }
    }
    get moduleName() {
        {
            return moduleName$v;
        }
    }
    payload_set_operator(old_operator, new_operator, isJSON = false) {
        return buildPayload_set_operator(old_operator, new_operator, isJSON);
    }
    set_operator(_account, old_operator, new_operator, option, _isJSON = false) {
        return __awaiter(this, void 0, void 0, function* () {
            const payload__ = buildPayload_set_operator(old_operator, new_operator, _isJSON);
            return $.sendPayloadTx(this.client, _account, payload__, option);
        });
    }
    payload_set_stake_pool_operator(new_operator, isJSON = false) {
        return buildPayload_set_stake_pool_operator(new_operator, isJSON);
    }
    set_stake_pool_operator(_account, new_operator, option, _isJSON = false) {
        return __awaiter(this, void 0, void 0, function* () {
            const payload__ = buildPayload_set_stake_pool_operator(new_operator, _isJSON);
            return $.sendPayloadTx(this.client, _account, payload__, option);
        });
    }
    payload_set_stake_pool_voter(new_voter, isJSON = false) {
        return buildPayload_set_stake_pool_voter(new_voter, isJSON);
    }
    set_stake_pool_voter(_account, new_voter, option, _isJSON = false) {
        return __awaiter(this, void 0, void 0, function* () {
            const payload__ = buildPayload_set_stake_pool_voter(new_voter, _isJSON);
            return $.sendPayloadTx(this.client, _account, payload__, option);
        });
    }
    payload_set_staking_contract_operator(old_operator, new_operator, isJSON = false) {
        return buildPayload_set_staking_contract_operator(old_operator, new_operator, isJSON);
    }
    set_staking_contract_operator(_account, old_operator, new_operator, option, _isJSON = false) {
        return __awaiter(this, void 0, void 0, function* () {
            const payload__ = buildPayload_set_staking_contract_operator(old_operator, new_operator, _isJSON);
            return $.sendPayloadTx(this.client, _account, payload__, option);
        });
    }
    payload_set_staking_contract_voter(operator, new_voter, isJSON = false) {
        return buildPayload_set_staking_contract_voter(operator, new_voter, isJSON);
    }
    set_staking_contract_voter(_account, operator, new_voter, option, _isJSON = false) {
        return __awaiter(this, void 0, void 0, function* () {
            const payload__ = buildPayload_set_staking_contract_voter(operator, new_voter, _isJSON);
            return $.sendPayloadTx(this.client, _account, payload__, option);
        });
    }
    payload_set_vesting_contract_operator(old_operator, new_operator, isJSON = false) {
        return buildPayload_set_vesting_contract_operator(old_operator, new_operator, isJSON);
    }
    set_vesting_contract_operator(_account, old_operator, new_operator, option, _isJSON = false) {
        return __awaiter(this, void 0, void 0, function* () {
            const payload__ = buildPayload_set_vesting_contract_operator(old_operator, new_operator, _isJSON);
            return $.sendPayloadTx(this.client, _account, payload__, option);
        });
    }
    payload_set_vesting_contract_voter(operator, new_voter, isJSON = false) {
        return buildPayload_set_vesting_contract_voter(operator, new_voter, isJSON);
    }
    set_vesting_contract_voter(_account, operator, new_voter, option, _isJSON = false) {
        return __awaiter(this, void 0, void 0, function* () {
            const payload__ = buildPayload_set_vesting_contract_voter(operator, new_voter, _isJSON);
            return $.sendPayloadTx(this.client, _account, payload__, option);
        });
    }
    payload_set_voter(operator, new_voter, isJSON = false) {
        return buildPayload_set_voter(operator, new_voter, isJSON);
    }
    set_voter(_account, operator, new_voter, option, _isJSON = false) {
        return __awaiter(this, void 0, void 0, function* () {
            const payload__ = buildPayload_set_voter(operator, new_voter, _isJSON);
            return $.sendPayloadTx(this.client, _account, payload__, option);
        });
    }
}

var Staking_proxy = /*#__PURE__*/Object.freeze({
    __proto__: null,
    packageName: packageName$v,
    moduleAddress: moduleAddress$v,
    moduleName: moduleName$v,
    set_operator_: set_operator_,
    buildPayload_set_operator: buildPayload_set_operator,
    set_stake_pool_operator_: set_stake_pool_operator_,
    buildPayload_set_stake_pool_operator: buildPayload_set_stake_pool_operator,
    set_stake_pool_voter_: set_stake_pool_voter_,
    buildPayload_set_stake_pool_voter: buildPayload_set_stake_pool_voter,
    set_staking_contract_operator_: set_staking_contract_operator_,
    buildPayload_set_staking_contract_operator: buildPayload_set_staking_contract_operator,
    set_staking_contract_voter_: set_staking_contract_voter_,
    buildPayload_set_staking_contract_voter: buildPayload_set_staking_contract_voter,
    set_vesting_contract_operator_: set_vesting_contract_operator_,
    buildPayload_set_vesting_contract_operator: buildPayload_set_vesting_contract_operator,
    set_vesting_contract_voter_: set_vesting_contract_voter_,
    buildPayload_set_vesting_contract_voter: buildPayload_set_vesting_contract_voter,
    set_voter_: set_voter_,
    buildPayload_set_voter: buildPayload_set_voter,
    loadParsers: loadParsers$I,
    App: App$J
});

const packageName$u = 'AptosStdlib';
const moduleAddress$u = new HexString('0x1');
const moduleName$u = 'table_with_length';
const EALREADY_EXISTS = u64('100');
const ENOT_EMPTY = u64('102');
const ENOT_FOUND = u64('101');
class TableWithLength {
    constructor(proto, typeTag) {
        this.typeTag = typeTag;
        this.__app = null;
        this.inner = proto['inner'];
        this.length = proto['length'];
    }
    static TableWithLengthParser(data, typeTag, repo) {
        const proto = $.parseStructProto(data, typeTag, repo, TableWithLength);
        return new TableWithLength(proto, typeTag);
    }
    static makeTag($p) {
        return new StructTag(moduleAddress$u, moduleName$u, 'TableWithLength', $p);
    }
    loadFullState(app) {
        return __awaiter(this, void 0, void 0, function* () {
            yield this.inner.loadFullState(app);
            this.__app = app;
        });
    }
}
TableWithLength.moduleAddress = moduleAddress$u;
TableWithLength.moduleName = moduleName$u;
TableWithLength.structName = 'TableWithLength';
TableWithLength.typeParameters = [
    { name: 'K', isPhantom: true },
    { name: 'V', isPhantom: true }
];
TableWithLength.fields = [
    {
        name: 'inner',
        typeTag: new StructTag(new HexString('0x1'), 'table', 'Table', [new $.TypeParamIdx(0), new $.TypeParamIdx(1)])
    },
    { name: 'length', typeTag: AtomicTypeTag.U64 }
];
function add_$3(table, key, val, $c, $p /* <K, V>*/) {
    add_$8(table.inner, $.copy(key), val, $c, [$p[0], $p[1]]);
    table.length = $.copy(table.length).add(u64('1'));
    return;
}
function borrow_$3(table, key, $c, $p /* <K, V>*/) {
    return borrow_$5(table.inner, $.copy(key), $c, [$p[0], $p[1]]);
}
function borrow_mut_$3(table, key, $c, $p /* <K, V>*/) {
    return borrow_mut_$5(table.inner, $.copy(key), $c, [$p[0], $p[1]]);
}
function borrow_mut_with_default_$1(table, key, default__, $c, $p /* <K, V>*/) {
    let temp$1;
    if (contains_$6(table.inner, $.copy(key), $c, [$p[0], $p[1]])) {
        temp$1 = borrow_mut_$5(table.inner, $.copy(key), $c, [$p[0], $p[1]]);
    }
    else {
        add_$8(table.inner, $.copy(key), default__, $c, [$p[0], $p[1]]);
        table.length = $.copy(table.length).add(u64('1'));
        temp$1 = borrow_mut_$5(table.inner, $.copy(key), $c, [$p[0], $p[1]]);
    }
    return temp$1;
}
function contains_$2(table, key, $c, $p /* <K, V>*/) {
    return contains_$6(table.inner, $.copy(key), $c, [$p[0], $p[1]]);
}
function destroy_empty_$2(table, $c, $p /* <K, V>*/) {
    if (!$.copy(table.length).eq(u64('0'))) {
        throw $.abortCode(invalid_state_($.copy(ENOT_EMPTY)));
    }
    let { inner: inner } = table;
    return destroy_$2(inner, $c, [$p[0], $p[1]]);
}
function empty_$3(table, $c, $p /* <K, V>*/) {
    return $.copy(table.length).eq(u64('0'));
}
function length_$2(table, $c, $p /* <K, V>*/) {
    return $.copy(table.length);
}
function new___$2($c, $p /* <K, V>*/) {
    return new TableWithLength({ inner: new___$5($c, [$p[0], $p[1]]), length: u64('0') }, new SimpleStructTag(TableWithLength, [$p[0], $p[1]]));
}
function remove_$1(table, key, $c, $p /* <K, V>*/) {
    let val;
    val = remove_$4(table.inner, $.copy(key), $c, [$p[0], $p[1]]);
    table.length = $.copy(table.length).sub(u64('1'));
    return val;
}
function upsert_(table, key, value, $c, $p /* <K, V>*/) {
    let ref;
    if (!contains_$6(table.inner, $.copy(key), $c, [$p[0], $p[1]])) {
        add_$3(table, $.copy(key), value, $c, [$p[0], $p[1]]);
    }
    else {
        ref = borrow_mut_$5(table.inner, $.copy(key), $c, [$p[0], $p[1]]);
        $.set(ref, value);
    }
    return;
}
function loadParsers$H(repo) {
    repo.addParser('0x1::table_with_length::TableWithLength', TableWithLength.TableWithLengthParser);
}
class App$I {
    constructor(client, repo, cache) {
        this.client = client;
        this.repo = repo;
        this.cache = cache;
    }
    get moduleAddress() {
        {
            return moduleAddress$u;
        }
    }
    get moduleName() {
        {
            return moduleName$u;
        }
    }
    get TableWithLength() {
        return TableWithLength;
    }
}

var Table_with_length = /*#__PURE__*/Object.freeze({
    __proto__: null,
    packageName: packageName$u,
    moduleAddress: moduleAddress$u,
    moduleName: moduleName$u,
    EALREADY_EXISTS: EALREADY_EXISTS,
    ENOT_EMPTY: ENOT_EMPTY,
    ENOT_FOUND: ENOT_FOUND,
    TableWithLength: TableWithLength,
    add_: add_$3,
    borrow_: borrow_$3,
    borrow_mut_: borrow_mut_$3,
    borrow_mut_with_default_: borrow_mut_with_default_$1,
    contains_: contains_$2,
    destroy_empty_: destroy_empty_$2,
    empty_: empty_$3,
    length_: length_$2,
    new___: new___$2,
    remove_: remove_$1,
    upsert_: upsert_,
    loadParsers: loadParsers$H,
    App: App$I
});

function loadParsers$G(repo) {
    loadParsers$1t(repo);
    loadParsers$1s(repo);
    loadParsers$1r(repo);
    loadParsers$1q(repo);
    loadParsers$1p(repo);
    loadParsers$1l(repo);
    loadParsers$16(repo);
    loadParsers$14(repo);
    loadParsers$13(repo);
    loadParsers$1i(repo);
    loadParsers$12(repo);
    loadParsers$11(repo);
    loadParsers$1j(repo);
    loadParsers$_(repo);
    loadParsers$1n(repo);
    loadParsers$1a(repo);
    loadParsers$Z(repo);
    loadParsers$Y(repo);
    loadParsers$1C(repo);
    loadParsers$1B(repo);
    loadParsers$10(repo);
    loadParsers$W(repo);
    loadParsers$V(repo);
    loadParsers$O(repo);
    loadParsers$1k(repo);
    loadParsers$1y(repo);
    loadParsers$N(repo);
    loadParsers$1x(repo);
    loadParsers$1E(repo);
    loadParsers$1o(repo);
    loadParsers$U(repo);
    loadParsers$1b(repo);
    loadParsers$L(repo);
    loadParsers$K(repo);
    loadParsers$J(repo);
    loadParsers$19(repo);
    loadParsers$1e(repo);
    loadParsers$1g(repo);
    loadParsers$T(repo);
    loadParsers$1d(repo);
    loadParsers$1c(repo);
    loadParsers$1A(repo);
    loadParsers$1u(repo);
    loadParsers$H(repo);
    loadParsers$1f(repo);
    loadParsers$S(repo);
    loadParsers$R(repo);
    loadParsers$1D(repo);
    loadParsers$Q(repo);
    loadParsers$P(repo);
    loadParsers$17(repo);
}
function getPackageRepo$c() {
    const repo = new AptosParserRepo();
    loadParsers$G(repo);
    repo.addDefaultParsers();
    return repo;
}
class App$H {
    constructor(client, repo, cache) {
        this.client = client;
        this.repo = repo;
        this.cache = cache;
        this.account = new App$1u(client, repo, cache);
        this.acl = new App$1t(client, repo, cache);
        this.aggregator = new App$1s(client, repo, cache);
        this.aggregator_factory = new App$1r(client, repo, cache);
        this.any = new App$1q(client, repo, cache);
        this.aptos_account = new App$1n(client, repo, cache);
        this.aptos_coin = new App$1m(client, repo, cache);
        this.aptos_governance = new App$17(client, repo, cache);
        this.aptos_hash = new App$16(client, repo, cache);
        this.bcs = new App$1J(client, repo, cache);
        this.bit_vector = new App$15(client, repo, cache);
        this.block = new App$14(client, repo, cache);
        this.bls12381 = new App$1j(client, repo, cache);
        this.capability = new App$13(client, repo, cache);
        this.chain_id = new App$12(client, repo, cache);
        this.chain_status = new App$1k(client, repo, cache);
        this.code = new App$$(client, repo, cache);
        this.coin = new App$1o(client, repo, cache);
        this.comparator = new App$1b(client, repo, cache);
        this.consensus_config = new App$_(client, repo, cache);
        this.copyable_any = new App$Z(client, repo, cache);
        this.debug = new App$Y(client, repo, cache);
        this.ed25519 = new App$1D(client, repo, cache);
        this.error = new App$1I(client, repo, cache);
        this.event = new App$1C(client, repo, cache);
        this.features = new App$11(client, repo, cache);
        this.fixed_point32 = new App$X(client, repo, cache);
        this.from_bcs = new App$1A(client, repo, cache);
        this.gas_schedule = new App$W(client, repo, cache);
        this.genesis = new App$P(client, repo, cache);
        this.governance_proposal = new App$1l(client, repo, cache);
        this.guid = new App$1z(client, repo, cache);
        this.hash = new App$1H(client, repo, cache);
        this.managed_coin = new App$O(client, repo, cache);
        this.math128 = new App$N(client, repo, cache);
        this.math64 = new App$1i(client, repo, cache);
        this.multi_ed25519 = new App$1y(client, repo, cache);
        this.option = new App$1F(client, repo, cache);
        this.optional_aggregator = new App$1p(client, repo, cache);
        this.pool_u64 = new App$V(client, repo, cache);
        this.reconfiguration = new App$1c(client, repo, cache);
        this.resource_account = new App$M(client, repo, cache);
        this.ristretto255 = new App$L(client, repo, cache);
        this.secp256k1 = new App$K(client, repo, cache);
        this.signer = new App$1x(client, repo, cache);
        this.simple_map = new App$1a(client, repo, cache);
        this.stake = new App$1f(client, repo, cache);
        this.staking_config = new App$1h(client, repo, cache);
        this.staking_contract = new App$U(client, repo, cache);
        this.staking_proxy = new App$J(client, repo, cache);
        this.state_storage = new App$1e(client, repo, cache);
        this.storage_gas = new App$1d(client, repo, cache);
        this.string = new App$1B(client, repo, cache);
        this.system_addresses = new App$1w(client, repo, cache);
        this.table = new App$1v(client, repo, cache);
        this.table_with_length = new App$I(client, repo, cache);
        this.timestamp = new App$1g(client, repo, cache);
        this.transaction_context = new App$19(client, repo, cache);
        this.transaction_fee = new App$T(client, repo, cache);
        this.transaction_validation = new App$S(client, repo, cache);
        this.type_info = new App$1E(client, repo, cache);
        this.util = new App$10(client, repo, cache);
        this.vector = new App$1G(client, repo, cache);
        this.version = new App$R(client, repo, cache);
        this.vesting = new App$Q(client, repo, cache);
        this.voting = new App$18(client, repo, cache);
    }
}

var stdlib = /*#__PURE__*/Object.freeze({
    __proto__: null,
    loadParsers: loadParsers$G,
    getPackageRepo: getPackageRepo$c,
    App: App$H,
    Account: Account$1,
    Acl: Acl,
    Aggregator: Aggregator$2,
    Aggregator_factory: Aggregator_factory,
    Any: Any$2,
    Aptos_account: Aptos_account,
    Aptos_coin: Aptos_coin,
    Aptos_governance: Aptos_governance,
    Aptos_hash: Aptos_hash,
    Bcs: Bcs,
    Bit_vector: Bit_vector,
    Block: Block,
    Bls12381: Bls12381,
    Capability: Capability,
    Chain_id: Chain_id,
    Chain_status: Chain_status,
    Code: Code,
    Coin: Coin$1,
    Comparator: Comparator,
    Consensus_config: Consensus_config,
    Copyable_any: Copyable_any,
    Debug: Debug,
    Ed25519: Ed25519,
    Error: Error$1,
    Event: Event,
    Features: Features$1,
    Fixed_point32: Fixed_point32,
    From_bcs: From_bcs,
    Gas_schedule: Gas_schedule,
    Genesis: Genesis,
    Governance_proposal: Governance_proposal,
    Guid: Guid,
    Hash: Hash,
    Managed_coin: Managed_coin,
    Math128: Math128,
    Math64: Math64,
    Multi_ed25519: Multi_ed25519,
    Option: Option$1,
    Optional_aggregator: Optional_aggregator,
    Pool_u64: Pool_u64,
    Reconfiguration: Reconfiguration,
    Resource_account: Resource_account,
    Ristretto255: Ristretto255,
    Secp256k1: Secp256k1,
    Signer: Signer,
    Simple_map: Simple_map,
    Stake: Stake,
    Staking_config: Staking_config,
    Staking_contract: Staking_contract,
    Staking_proxy: Staking_proxy,
    State_storage: State_storage,
    Storage_gas: Storage_gas,
    String: String$1,
    System_addresses: System_addresses,
    Table: Table$1,
    Table_with_length: Table_with_length,
    Timestamp: Timestamp,
    Transaction_context: Transaction_context,
    Transaction_fee: Transaction_fee,
    Transaction_validation: Transaction_validation,
    Type_info: Type_info,
    Util: Util,
    Vector: Vector,
    Version: Version$1,
    Vesting: Vesting,
    Voting: Voting
});

const packageName$t = 'CoinList';
const moduleAddress$t = new HexString('0x498d8926f16eb9ca90cab1b3a26aa6f97a080b3fcbe6e83ae150b7243a00fb68');
const moduleName$t = 'devnet_coins';
class CoinCaps {
    constructor(proto, typeTag) {
        this.typeTag = typeTag;
        this.__app = null;
        this.mint = proto['mint'];
        this.freeze = proto['freeze'];
        this.burn = proto['burn'];
    }
    static CoinCapsParser(data, typeTag, repo) {
        const proto = $.parseStructProto(data, typeTag, repo, CoinCaps);
        return new CoinCaps(proto, typeTag);
    }
    static load(repo, client, address, typeParams) {
        return __awaiter(this, void 0, void 0, function* () {
            const result = yield repo.loadResource(client, address, CoinCaps, typeParams);
            return result;
        });
    }
    static loadByApp(app, address, typeParams) {
        return __awaiter(this, void 0, void 0, function* () {
            const result = yield app.repo.loadResource(app.client, address, CoinCaps, typeParams);
            yield result.loadFullState(app);
            return result;
        });
    }
    static makeTag($p) {
        return new StructTag(moduleAddress$t, moduleName$t, 'CoinCaps', $p);
    }
    loadFullState(app) {
        return __awaiter(this, void 0, void 0, function* () {
            yield this.mint.loadFullState(app);
            yield this.freeze.loadFullState(app);
            yield this.burn.loadFullState(app);
            this.__app = app;
        });
    }
}
CoinCaps.moduleAddress = moduleAddress$t;
CoinCaps.moduleName = moduleName$t;
CoinCaps.structName = 'CoinCaps';
CoinCaps.typeParameters = [{ name: 'T', isPhantom: true }];
CoinCaps.fields = [
    { name: 'mint', typeTag: new StructTag(new HexString('0x1'), 'coin', 'MintCapability', [new $.TypeParamIdx(0)]) },
    {
        name: 'freeze',
        typeTag: new StructTag(new HexString('0x1'), 'coin', 'FreezeCapability', [new $.TypeParamIdx(0)])
    },
    { name: 'burn', typeTag: new StructTag(new HexString('0x1'), 'coin', 'BurnCapability', [new $.TypeParamIdx(0)]) }
];
class DevnetBNB {
    constructor(proto, typeTag) {
        this.typeTag = typeTag;
        this.__app = null;
    }
    static DevnetBNBParser(data, typeTag, repo) {
        const proto = $.parseStructProto(data, typeTag, repo, DevnetBNB);
        return new DevnetBNB(proto, typeTag);
    }
    static getTag() {
        return new StructTag(moduleAddress$t, moduleName$t, 'DevnetBNB', []);
    }
    loadFullState(app) {
        return __awaiter(this, void 0, void 0, function* () {
            this.__app = app;
        });
    }
}
DevnetBNB.moduleAddress = moduleAddress$t;
DevnetBNB.moduleName = moduleName$t;
DevnetBNB.structName = 'DevnetBNB';
DevnetBNB.typeParameters = [];
DevnetBNB.fields = [];
class DevnetBTC {
    constructor(proto, typeTag) {
        this.typeTag = typeTag;
        this.__app = null;
    }
    static DevnetBTCParser(data, typeTag, repo) {
        const proto = $.parseStructProto(data, typeTag, repo, DevnetBTC);
        return new DevnetBTC(proto, typeTag);
    }
    static getTag() {
        return new StructTag(moduleAddress$t, moduleName$t, 'DevnetBTC', []);
    }
    loadFullState(app) {
        return __awaiter(this, void 0, void 0, function* () {
            this.__app = app;
        });
    }
}
DevnetBTC.moduleAddress = moduleAddress$t;
DevnetBTC.moduleName = moduleName$t;
DevnetBTC.structName = 'DevnetBTC';
DevnetBTC.typeParameters = [];
DevnetBTC.fields = [];
class DevnetDAI {
    constructor(proto, typeTag) {
        this.typeTag = typeTag;
        this.__app = null;
    }
    static DevnetDAIParser(data, typeTag, repo) {
        const proto = $.parseStructProto(data, typeTag, repo, DevnetDAI);
        return new DevnetDAI(proto, typeTag);
    }
    static getTag() {
        return new StructTag(moduleAddress$t, moduleName$t, 'DevnetDAI', []);
    }
    loadFullState(app) {
        return __awaiter(this, void 0, void 0, function* () {
            this.__app = app;
        });
    }
}
DevnetDAI.moduleAddress = moduleAddress$t;
DevnetDAI.moduleName = moduleName$t;
DevnetDAI.structName = 'DevnetDAI';
DevnetDAI.typeParameters = [];
DevnetDAI.fields = [];
class DevnetETH {
    constructor(proto, typeTag) {
        this.typeTag = typeTag;
        this.__app = null;
    }
    static DevnetETHParser(data, typeTag, repo) {
        const proto = $.parseStructProto(data, typeTag, repo, DevnetETH);
        return new DevnetETH(proto, typeTag);
    }
    static getTag() {
        return new StructTag(moduleAddress$t, moduleName$t, 'DevnetETH', []);
    }
    loadFullState(app) {
        return __awaiter(this, void 0, void 0, function* () {
            this.__app = app;
        });
    }
}
DevnetETH.moduleAddress = moduleAddress$t;
DevnetETH.moduleName = moduleName$t;
DevnetETH.structName = 'DevnetETH';
DevnetETH.typeParameters = [];
DevnetETH.fields = [];
class DevnetSOL {
    constructor(proto, typeTag) {
        this.typeTag = typeTag;
        this.__app = null;
    }
    static DevnetSOLParser(data, typeTag, repo) {
        const proto = $.parseStructProto(data, typeTag, repo, DevnetSOL);
        return new DevnetSOL(proto, typeTag);
    }
    static getTag() {
        return new StructTag(moduleAddress$t, moduleName$t, 'DevnetSOL', []);
    }
    loadFullState(app) {
        return __awaiter(this, void 0, void 0, function* () {
            this.__app = app;
        });
    }
}
DevnetSOL.moduleAddress = moduleAddress$t;
DevnetSOL.moduleName = moduleName$t;
DevnetSOL.structName = 'DevnetSOL';
DevnetSOL.typeParameters = [];
DevnetSOL.fields = [];
class DevnetUSDC {
    constructor(proto, typeTag) {
        this.typeTag = typeTag;
        this.__app = null;
    }
    static DevnetUSDCParser(data, typeTag, repo) {
        const proto = $.parseStructProto(data, typeTag, repo, DevnetUSDC);
        return new DevnetUSDC(proto, typeTag);
    }
    static getTag() {
        return new StructTag(moduleAddress$t, moduleName$t, 'DevnetUSDC', []);
    }
    loadFullState(app) {
        return __awaiter(this, void 0, void 0, function* () {
            this.__app = app;
        });
    }
}
DevnetUSDC.moduleAddress = moduleAddress$t;
DevnetUSDC.moduleName = moduleName$t;
DevnetUSDC.structName = 'DevnetUSDC';
DevnetUSDC.typeParameters = [];
DevnetUSDC.fields = [];
class DevnetUSDT {
    constructor(proto, typeTag) {
        this.typeTag = typeTag;
        this.__app = null;
    }
    static DevnetUSDTParser(data, typeTag, repo) {
        const proto = $.parseStructProto(data, typeTag, repo, DevnetUSDT);
        return new DevnetUSDT(proto, typeTag);
    }
    static getTag() {
        return new StructTag(moduleAddress$t, moduleName$t, 'DevnetUSDT', []);
    }
    loadFullState(app) {
        return __awaiter(this, void 0, void 0, function* () {
            this.__app = app;
        });
    }
}
DevnetUSDT.moduleAddress = moduleAddress$t;
DevnetUSDT.moduleName = moduleName$t;
DevnetUSDT.structName = 'DevnetUSDT';
DevnetUSDT.typeParameters = [];
DevnetUSDT.fields = [];
function burn_$1(tokens, $c, $p /* <TokenType>*/) {
    let temp$1, addr, amt, cap;
    temp$1 = type_of_($c, [$p[0]]);
    addr = account_address_(temp$1);
    cap = $c.borrow_global(new SimpleStructTag(CoinCaps, [$p[0]]), $.copy(addr));
    amt = value_(tokens, $c, [$p[0]]);
    if ($.copy(amt).eq(u64('0'))) {
        destroy_zero_(tokens, $c, [$p[0]]);
    }
    else {
        burn_$3(tokens, cap.burn, $c, [$p[0]]);
    }
    return;
}
function deploy_(admin, $c) {
    init_coin_and_register_(admin, utf8_([u8('66'), u8('105'), u8('116'), u8('99'), u8('111'), u8('105'), u8('110')], $c), utf8_([u8('100'), u8('101'), u8('118'), u8('66'), u8('84'), u8('67')], $c), u8('8'), $c, [new SimpleStructTag(DevnetBTC)]);
    init_coin_and_register_(admin, utf8_([u8('66'), u8('78'), u8('66')], $c), utf8_([u8('100'), u8('101'), u8('118'), u8('66'), u8('78'), u8('66')], $c), u8('8'), $c, [new SimpleStructTag(DevnetBNB)]);
    init_coin_and_register_(admin, utf8_([u8('69'), u8('116'), u8('104'), u8('101'), u8('114'), u8('101'), u8('117'), u8('109')], $c), utf8_([u8('100'), u8('101'), u8('118'), u8('69'), u8('84'), u8('72')], $c), u8('8'), $c, [new SimpleStructTag(DevnetETH)]);
    init_coin_and_register_(admin, utf8_([u8('83'), u8('111'), u8('108'), u8('97'), u8('110'), u8('97')], $c), utf8_([u8('100'), u8('101'), u8('118'), u8('83'), u8('79'), u8('76')], $c), u8('8'), $c, [new SimpleStructTag(DevnetSOL)]);
    init_coin_and_register_(admin, utf8_([u8('85'), u8('83'), u8('68'), u8('32'), u8('67'), u8('111'), u8('105'), u8('110')], $c), utf8_([u8('100'), u8('101'), u8('118'), u8('85'), u8('83'), u8('68'), u8('67')], $c), u8('8'), $c, [new SimpleStructTag(DevnetUSDC)]);
    init_coin_and_register_(admin, utf8_([u8('84'), u8('101'), u8('116'), u8('104'), u8('101'), u8('114')], $c), utf8_([u8('100'), u8('101'), u8('118'), u8('85'), u8('83'), u8('68'), u8('84')], $c), u8('8'), $c, [new SimpleStructTag(DevnetUSDT)]);
    init_coin_and_register_(admin, utf8_([u8('68'), u8('65'), u8('73')], $c), utf8_([u8('100'), u8('101'), u8('118'), u8('68'), u8('65'), u8('73')], $c), u8('8'), $c, [new SimpleStructTag(DevnetDAI)]);
    return;
}
function buildPayload_deploy(isJSON = false) {
    const typeParamStrings = [];
    return $.buildPayload(new HexString('0x498d8926f16eb9ca90cab1b3a26aa6f97a080b3fcbe6e83ae150b7243a00fb68'), 'devnet_coins', 'deploy', typeParamStrings, [], isJSON);
}
function deposit_(user, coin, $c, $p /* <CoinType>*/) {
    if (!is_account_registered_(address_of_(user, $c), $c, [$p[0]])) {
        register_$2(user, $c, [$p[0]]);
    }
    deposit_$1(address_of_(user, $c), coin, $c, [$p[0]]);
    return;
}
function init_coin_(admin, name, symbol, decimals, $c, $p /* <CoinType>*/) {
    let burn, freeze, mint;
    [burn, freeze, mint] = initialize_$j(admin, utf8_($.copy(name), $c), utf8_($.copy(symbol), $c), $.copy(decimals), false, $c, [$p[0]]);
    $c.move_to(new SimpleStructTag(CoinCaps, [$p[0]]), admin, new CoinCaps({ mint: $.copy(mint), freeze: $.copy(freeze), burn: $.copy(burn) }, new SimpleStructTag(CoinCaps, [$p[0]])));
    return;
}
function buildPayload_init_coin(name, symbol, decimals, $p /* <CoinType>*/, isJSON = false) {
    const typeParamStrings = $p.map((t) => $.getTypeTagFullname(t));
    return $.buildPayload(new HexString('0x498d8926f16eb9ca90cab1b3a26aa6f97a080b3fcbe6e83ae150b7243a00fb68'), 'devnet_coins', 'init_coin', typeParamStrings, [name, symbol, decimals], isJSON);
}
function init_coin_and_register_(admin, name, symbol, decimals, $c, $p /* <CoinType>*/) {
    init_coin_(admin, $.copy(bytes_(name)), $.copy(bytes_(symbol)), $.copy(decimals), $c, [$p[0]]);
    return;
}
function initialize_$2(admin, decimals, $c, $p /* <TokenType>*/) {
    let temp$1, name;
    temp$1 = type_of_($c, [$p[0]]);
    name = struct_name_(temp$1);
    return init_coin_(admin, $.copy(name), $.copy(name), $.copy(decimals), $c, [$p[0]]);
}
function mint_$1(amount, $c, $p /* <CoinType>*/) {
    let caps;
    caps = $c.borrow_global(new SimpleStructTag(CoinCaps, [$p[0]]), new HexString('0x498d8926f16eb9ca90cab1b3a26aa6f97a080b3fcbe6e83ae150b7243a00fb68'));
    return mint_$4($.copy(amount), caps.mint, $c, [$p[0]]);
}
function mint_to_wallet_(user, amount, $c, $p /* <CoinType>*/) {
    let coin;
    coin = mint_$1($.copy(amount), $c, [$p[0]]);
    if (!is_account_registered_(address_of_(user, $c), $c, [$p[0]])) {
        register_$2(user, $c, [$p[0]]);
    }
    deposit_$1(address_of_(user, $c), coin, $c, [$p[0]]);
    return;
}
function buildPayload_mint_to_wallet(amount, $p /* <CoinType>*/, isJSON = false) {
    const typeParamStrings = $p.map((t) => $.getTypeTagFullname(t));
    return $.buildPayload(new HexString('0x498d8926f16eb9ca90cab1b3a26aa6f97a080b3fcbe6e83ae150b7243a00fb68'), 'devnet_coins', 'mint_to_wallet', typeParamStrings, [amount], isJSON);
}
function loadParsers$F(repo) {
    repo.addParser('0x498d8926f16eb9ca90cab1b3a26aa6f97a080b3fcbe6e83ae150b7243a00fb68::devnet_coins::CoinCaps', CoinCaps.CoinCapsParser);
    repo.addParser('0x498d8926f16eb9ca90cab1b3a26aa6f97a080b3fcbe6e83ae150b7243a00fb68::devnet_coins::DevnetBNB', DevnetBNB.DevnetBNBParser);
    repo.addParser('0x498d8926f16eb9ca90cab1b3a26aa6f97a080b3fcbe6e83ae150b7243a00fb68::devnet_coins::DevnetBTC', DevnetBTC.DevnetBTCParser);
    repo.addParser('0x498d8926f16eb9ca90cab1b3a26aa6f97a080b3fcbe6e83ae150b7243a00fb68::devnet_coins::DevnetDAI', DevnetDAI.DevnetDAIParser);
    repo.addParser('0x498d8926f16eb9ca90cab1b3a26aa6f97a080b3fcbe6e83ae150b7243a00fb68::devnet_coins::DevnetETH', DevnetETH.DevnetETHParser);
    repo.addParser('0x498d8926f16eb9ca90cab1b3a26aa6f97a080b3fcbe6e83ae150b7243a00fb68::devnet_coins::DevnetSOL', DevnetSOL.DevnetSOLParser);
    repo.addParser('0x498d8926f16eb9ca90cab1b3a26aa6f97a080b3fcbe6e83ae150b7243a00fb68::devnet_coins::DevnetUSDC', DevnetUSDC.DevnetUSDCParser);
    repo.addParser('0x498d8926f16eb9ca90cab1b3a26aa6f97a080b3fcbe6e83ae150b7243a00fb68::devnet_coins::DevnetUSDT', DevnetUSDT.DevnetUSDTParser);
}
class App$G {
    constructor(client, repo, cache) {
        this.client = client;
        this.repo = repo;
        this.cache = cache;
    }
    get moduleAddress() {
        {
            return moduleAddress$t;
        }
    }
    get moduleName() {
        {
            return moduleName$t;
        }
    }
    get CoinCaps() {
        return CoinCaps;
    }
    loadCoinCaps(owner, $p /* <T> */, loadFull = true, fillCache = true) {
        return __awaiter(this, void 0, void 0, function* () {
            const val = yield CoinCaps.load(this.repo, this.client, owner, $p);
            if (loadFull) {
                yield val.loadFullState(this);
            }
            if (fillCache) {
                this.cache.set(val.typeTag, owner, val);
            }
            return val;
        });
    }
    get DevnetBNB() {
        return DevnetBNB;
    }
    get DevnetBTC() {
        return DevnetBTC;
    }
    get DevnetDAI() {
        return DevnetDAI;
    }
    get DevnetETH() {
        return DevnetETH;
    }
    get DevnetSOL() {
        return DevnetSOL;
    }
    get DevnetUSDC() {
        return DevnetUSDC;
    }
    get DevnetUSDT() {
        return DevnetUSDT;
    }
    payload_deploy(isJSON = false) {
        return buildPayload_deploy(isJSON);
    }
    deploy(_account, option, _isJSON = false) {
        return __awaiter(this, void 0, void 0, function* () {
            const payload__ = buildPayload_deploy(_isJSON);
            return $.sendPayloadTx(this.client, _account, payload__, option);
        });
    }
    payload_init_coin(name, symbol, decimals, $p /* <CoinType>*/, isJSON = false) {
        return buildPayload_init_coin(name, symbol, decimals, $p, isJSON);
    }
    init_coin(_account, name, symbol, decimals, $p /* <CoinType>*/, option, _isJSON = false) {
        return __awaiter(this, void 0, void 0, function* () {
            const payload__ = buildPayload_init_coin(name, symbol, decimals, $p, _isJSON);
            return $.sendPayloadTx(this.client, _account, payload__, option);
        });
    }
    payload_mint_to_wallet(amount, $p /* <CoinType>*/, isJSON = false) {
        return buildPayload_mint_to_wallet(amount, $p, isJSON);
    }
    mint_to_wallet(_account, amount, $p /* <CoinType>*/, option, _isJSON = false) {
        return __awaiter(this, void 0, void 0, function* () {
            const payload__ = buildPayload_mint_to_wallet(amount, $p, _isJSON);
            return $.sendPayloadTx(this.client, _account, payload__, option);
        });
    }
}

var Devnet_coins = /*#__PURE__*/Object.freeze({
    __proto__: null,
    packageName: packageName$t,
    moduleAddress: moduleAddress$t,
    moduleName: moduleName$t,
    CoinCaps: CoinCaps,
    DevnetBNB: DevnetBNB,
    DevnetBTC: DevnetBTC,
    DevnetDAI: DevnetDAI,
    DevnetETH: DevnetETH,
    DevnetSOL: DevnetSOL,
    DevnetUSDC: DevnetUSDC,
    DevnetUSDT: DevnetUSDT,
    burn_: burn_$1,
    deploy_: deploy_,
    buildPayload_deploy: buildPayload_deploy,
    deposit_: deposit_,
    init_coin_: init_coin_,
    buildPayload_init_coin: buildPayload_init_coin,
    init_coin_and_register_: init_coin_and_register_,
    initialize_: initialize_$2,
    mint_: mint_$1,
    mint_to_wallet_: mint_to_wallet_,
    buildPayload_mint_to_wallet: buildPayload_mint_to_wallet,
    loadParsers: loadParsers$F,
    App: App$G
});

const packageName$s = 'CoinList';
const moduleAddress$s = new HexString('0x498d8926f16eb9ca90cab1b3a26aa6f97a080b3fcbe6e83ae150b7243a00fb68');
const moduleName$s = 'iterable_table';
class IterableTable {
    constructor(proto, typeTag) {
        this.typeTag = typeTag;
        this.__app = null;
        this.inner = proto['inner'];
        this.head = proto['head'];
        this.tail = proto['tail'];
    }
    static IterableTableParser(data, typeTag, repo) {
        const proto = $.parseStructProto(data, typeTag, repo, IterableTable);
        return new IterableTable(proto, typeTag);
    }
    static makeTag($p) {
        return new StructTag(moduleAddress$s, moduleName$s, 'IterableTable', $p);
    }
    loadFullState(app) {
        return __awaiter(this, void 0, void 0, function* () {
            yield this.inner.loadFullState(app);
            yield this.head.loadFullState(app);
            yield this.tail.loadFullState(app);
            this.__app = app;
        });
    }
}
IterableTable.moduleAddress = moduleAddress$s;
IterableTable.moduleName = moduleName$s;
IterableTable.structName = 'IterableTable';
IterableTable.typeParameters = [
    { name: 'K', isPhantom: false },
    { name: 'V', isPhantom: false }
];
IterableTable.fields = [
    {
        name: 'inner',
        typeTag: new StructTag(new HexString('0x1'), 'table_with_length', 'TableWithLength', [
            new $.TypeParamIdx(0),
            new StructTag(new HexString('0x498d8926f16eb9ca90cab1b3a26aa6f97a080b3fcbe6e83ae150b7243a00fb68'), 'iterable_table', 'IterableValue', [new $.TypeParamIdx(0), new $.TypeParamIdx(1)])
        ])
    },
    { name: 'head', typeTag: new StructTag(new HexString('0x1'), 'option', 'Option', [new $.TypeParamIdx(0)]) },
    { name: 'tail', typeTag: new StructTag(new HexString('0x1'), 'option', 'Option', [new $.TypeParamIdx(0)]) }
];
class IterableValue {
    constructor(proto, typeTag) {
        this.typeTag = typeTag;
        this.__app = null;
        this.val = proto['val'];
        this.prev = proto['prev'];
        this.next = proto['next'];
    }
    static IterableValueParser(data, typeTag, repo) {
        const proto = $.parseStructProto(data, typeTag, repo, IterableValue);
        return new IterableValue(proto, typeTag);
    }
    static makeTag($p) {
        return new StructTag(moduleAddress$s, moduleName$s, 'IterableValue', $p);
    }
    loadFullState(app) {
        return __awaiter(this, void 0, void 0, function* () {
            if (this.val.typeTag instanceof StructTag) {
                yield this.val.loadFullState(app);
            }
            yield this.prev.loadFullState(app);
            yield this.next.loadFullState(app);
            this.__app = app;
        });
    }
}
IterableValue.moduleAddress = moduleAddress$s;
IterableValue.moduleName = moduleName$s;
IterableValue.structName = 'IterableValue';
IterableValue.typeParameters = [
    { name: 'K', isPhantom: false },
    { name: 'V', isPhantom: false }
];
IterableValue.fields = [
    { name: 'val', typeTag: new $.TypeParamIdx(1) },
    { name: 'prev', typeTag: new StructTag(new HexString('0x1'), 'option', 'Option', [new $.TypeParamIdx(0)]) },
    { name: 'next', typeTag: new StructTag(new HexString('0x1'), 'option', 'Option', [new $.TypeParamIdx(0)]) }
];
function add_$2(table, key, val, $c, $p /* <K, V>*/) {
    let k, wrapped_value;
    wrapped_value = new IterableValue({ val: val, prev: $.copy(table.tail), next: none_($c, [$p[0]]) }, new SimpleStructTag(IterableValue, [$p[0], $p[1]]));
    add_$3(table.inner, $.copy(key), wrapped_value, $c, [
        $p[0],
        new SimpleStructTag(IterableValue, [$p[0], $p[1]])
    ]);
    if (is_some_(table.tail, $c, [$p[0]])) {
        k = borrow_$6(table.tail, $c, [$p[0]]);
        borrow_mut_$3(table.inner, $.copy(k), $c, [
            $p[0],
            new SimpleStructTag(IterableValue, [$p[0], $p[1]])
        ]).next = some_($.copy(key), $c, [$p[0]]);
    }
    else {
        table.head = some_($.copy(key), $c, [$p[0]]);
    }
    table.tail = some_($.copy(key), $c, [$p[0]]);
    return;
}
function append_(v1, v2, $c, $p /* <K, V>*/) {
    let key, next, val;
    key = head_key_(v2, $c, [$p[0], $p[1]]);
    while (is_some_(key, $c, [$p[0]])) {
        {
            [val, , next] = remove_iter_(v2, $.copy(borrow_$6(key, $c, [$p[0]])), $c, [$p[0], $p[1]]);
            add_$2(v1, $.copy(borrow_$6(key, $c, [$p[0]])), val, $c, [$p[0], $p[1]]);
            key = $.copy(next);
        }
    }
    return;
}
function borrow_$2(table, key, $c, $p /* <K, V>*/) {
    return borrow_$3(table.inner, $.copy(key), $c, [
        $p[0],
        new SimpleStructTag(IterableValue, [$p[0], $p[1]])
    ]).val;
}
function borrow_iter_(table, key, $c, $p /* <K, V>*/) {
    let v;
    v = borrow_$3(table.inner, $.copy(key), $c, [
        $p[0],
        new SimpleStructTag(IterableValue, [$p[0], $p[1]])
    ]);
    return [v.val, $.copy(v.prev), $.copy(v.next)];
}
function borrow_iter_mut_(table, key, $c, $p /* <K, V>*/) {
    let v;
    v = borrow_mut_$3(table.inner, $.copy(key), $c, [
        $p[0],
        new SimpleStructTag(IterableValue, [$p[0], $p[1]])
    ]);
    return [v.val, $.copy(v.prev), $.copy(v.next)];
}
function borrow_mut_$2(table, key, $c, $p /* <K, V>*/) {
    return borrow_mut_$3(table.inner, $.copy(key), $c, [
        $p[0],
        new SimpleStructTag(IterableValue, [$p[0], $p[1]])
    ]).val;
}
function borrow_mut_with_default_(table, key, default__, $c, $p /* <K, V>*/) {
    let temp$1, temp$2;
    [temp$1, temp$2] = [table, $.copy(key)];
    if (!contains_$1(temp$1, temp$2, $c, [$p[0], $p[1]])) {
        add_$2(table, $.copy(key), default__, $c, [$p[0], $p[1]]);
    }
    return borrow_mut_$2(table, $.copy(key), $c, [$p[0], $p[1]]);
}
function contains_$1(table, key, $c, $p /* <K, V>*/) {
    return contains_$2(table.inner, $.copy(key), $c, [
        $p[0],
        new SimpleStructTag(IterableValue, [$p[0], $p[1]])
    ]);
}
function destroy_empty_$1(table, $c, $p /* <K, V>*/) {
    if (!empty_$2(table, $c, [$p[0], $p[1]])) {
        throw $.abortCode(u64('0'));
    }
    if (!is_none_(table.head, $c, [$p[0]])) {
        throw $.abortCode(u64('0'));
    }
    if (!is_none_(table.tail, $c, [$p[0]])) {
        throw $.abortCode(u64('0'));
    }
    let { inner: inner } = table;
    destroy_empty_$2(inner, $c, [$p[0], new SimpleStructTag(IterableValue, [$p[0], $p[1]])]);
    return;
}
function empty_$2(table, $c, $p /* <K, V>*/) {
    return empty_$3(table.inner, $c, [$p[0], new SimpleStructTag(IterableValue, [$p[0], $p[1]])]);
}
function head_key_(table, $c, $p /* <K, V>*/) {
    return $.copy(table.head);
}
function length_$1(table, $c, $p /* <K, V>*/) {
    return length_$2(table.inner, $c, [$p[0], new SimpleStructTag(IterableValue, [$p[0], $p[1]])]);
}
function new___$1($c, $p /* <K, V>*/) {
    return new IterableTable({
        inner: new___$2($c, [$p[0], new SimpleStructTag(IterableValue, [$p[0], $p[1]])]),
        head: none_($c, [$p[0]]),
        tail: none_($c, [$p[0]])
    }, new SimpleStructTag(IterableTable, [$p[0], $p[1]]));
}
function remove_(table, key, $c, $p /* <K, V>*/) {
    let val;
    [val, ,] = remove_iter_(table, $.copy(key), $c, [$p[0], $p[1]]);
    return val;
}
function remove_iter_(table, key, $c, $p /* <K, V>*/) {
    let key__1, key__2, val;
    val = remove_$1(table.inner, $.copy(key), $c, [
        $p[0],
        new SimpleStructTag(IterableValue, [$p[0], $p[1]])
    ]);
    if (contains_$7(table.tail, key, $c, [$p[0]])) {
        table.tail = $.copy(val.prev);
    }
    if (contains_$7(table.head, key, $c, [$p[0]])) {
        table.head = $.copy(val.next);
    }
    if (is_some_(val.prev, $c, [$p[0]])) {
        key__1 = borrow_$6(val.prev, $c, [$p[0]]);
        borrow_mut_$3(table.inner, $.copy(key__1), $c, [
            $p[0],
            new SimpleStructTag(IterableValue, [$p[0], $p[1]])
        ]).next = $.copy(val.next);
    }
    if (is_some_(val.next, $c, [$p[0]])) {
        key__2 = borrow_$6(val.next, $c, [$p[0]]);
        borrow_mut_$3(table.inner, $.copy(key__2), $c, [
            $p[0],
            new SimpleStructTag(IterableValue, [$p[0], $p[1]])
        ]).prev = $.copy(val.prev);
    }
    let { val: val__3, prev: prev, next: next } = val;
    return [val__3, $.copy(prev), $.copy(next)];
}
function tail_key_(table, $c, $p /* <K, V>*/) {
    return $.copy(table.tail);
}
function loadParsers$E(repo) {
    repo.addParser('0x498d8926f16eb9ca90cab1b3a26aa6f97a080b3fcbe6e83ae150b7243a00fb68::iterable_table::IterableTable', IterableTable.IterableTableParser);
    repo.addParser('0x498d8926f16eb9ca90cab1b3a26aa6f97a080b3fcbe6e83ae150b7243a00fb68::iterable_table::IterableValue', IterableValue.IterableValueParser);
}
class App$F {
    constructor(client, repo, cache) {
        this.client = client;
        this.repo = repo;
        this.cache = cache;
    }
    get moduleAddress() {
        {
            return moduleAddress$s;
        }
    }
    get moduleName() {
        {
            return moduleName$s;
        }
    }
    get IterableTable() {
        return IterableTable;
    }
    get IterableValue() {
        return IterableValue;
    }
}

var Iterable_table = /*#__PURE__*/Object.freeze({
    __proto__: null,
    packageName: packageName$s,
    moduleAddress: moduleAddress$s,
    moduleName: moduleName$s,
    IterableTable: IterableTable,
    IterableValue: IterableValue,
    add_: add_$2,
    append_: append_,
    borrow_: borrow_$2,
    borrow_iter_: borrow_iter_,
    borrow_iter_mut_: borrow_iter_mut_,
    borrow_mut_: borrow_mut_$2,
    borrow_mut_with_default_: borrow_mut_with_default_,
    contains_: contains_$1,
    destroy_empty_: destroy_empty_$1,
    empty_: empty_$2,
    head_key_: head_key_,
    length_: length_$1,
    new___: new___$1,
    remove_: remove_,
    remove_iter_: remove_iter_,
    tail_key_: tail_key_,
    loadParsers: loadParsers$E,
    App: App$F
});

const packageName$r = 'CoinList';
const moduleAddress$r = new HexString('0x498d8926f16eb9ca90cab1b3a26aa6f97a080b3fcbe6e83ae150b7243a00fb68');
const moduleName$r = 'coin_list';
const E_APPROVER_ONLY = u64('5');
const E_COIN_NOT_IN_REGISTRY = u64('3');
const E_COIN_OWNER_ONLY = u64('1');
const E_CONTRACT_OWNER_ONLY = u64('0');
const E_LIST_DOES_NOT_EXIST = u64('4');
const E_TYPE_ALREADY_EXISTS = u64('2');
const E_UID_ALREADY_EXISTS = u64('6');
const E_UNSUPPORTED_METHOD = u64('7');
class CoinInfo {
    constructor(proto, typeTag) {
        this.typeTag = typeTag;
        this.__app = null;
        this.name = proto['name'];
        this.symbol = proto['symbol'];
        this.official_symbol = proto['official_symbol'];
        this.coingecko_id = proto['coingecko_id'];
        this.decimals = proto['decimals'];
        this.logo_url = proto['logo_url'];
        this.project_url = proto['project_url'];
        this.token_type = proto['token_type'];
        this.extensions = proto['extensions'];
    }
    static CoinInfoParser(data, typeTag, repo) {
        const proto = $.parseStructProto(data, typeTag, repo, CoinInfo);
        return new CoinInfo(proto, typeTag);
    }
    static getTag() {
        return new StructTag(moduleAddress$r, moduleName$r, 'CoinInfo', []);
    }
    loadFullState(app) {
        return __awaiter(this, void 0, void 0, function* () {
            yield this.name.loadFullState(app);
            yield this.symbol.loadFullState(app);
            yield this.official_symbol.loadFullState(app);
            yield this.coingecko_id.loadFullState(app);
            yield this.logo_url.loadFullState(app);
            yield this.project_url.loadFullState(app);
            yield this.token_type.loadFullState(app);
            yield this.extensions.loadFullState(app);
            this.__app = app;
        });
    }
}
CoinInfo.moduleAddress = moduleAddress$r;
CoinInfo.moduleName = moduleName$r;
CoinInfo.structName = 'CoinInfo';
CoinInfo.typeParameters = [];
CoinInfo.fields = [
    { name: 'name', typeTag: new StructTag(new HexString('0x1'), 'string', 'String', []) },
    { name: 'symbol', typeTag: new StructTag(new HexString('0x1'), 'string', 'String', []) },
    { name: 'official_symbol', typeTag: new StructTag(new HexString('0x1'), 'string', 'String', []) },
    { name: 'coingecko_id', typeTag: new StructTag(new HexString('0x1'), 'string', 'String', []) },
    { name: 'decimals', typeTag: AtomicTypeTag.U8 },
    { name: 'logo_url', typeTag: new StructTag(new HexString('0x1'), 'string', 'String', []) },
    { name: 'project_url', typeTag: new StructTag(new HexString('0x1'), 'string', 'String', []) },
    { name: 'token_type', typeTag: new StructTag(new HexString('0x1'), 'type_info', 'TypeInfo', []) },
    {
        name: 'extensions',
        typeTag: new StructTag(new HexString('0x1'), 'simple_map', 'SimpleMap', [
            new StructTag(new HexString('0x1'), 'string', 'String', []),
            new StructTag(new HexString('0x1'), 'string', 'String', [])
        ])
    }
];
class CoinList {
    constructor(proto, typeTag) {
        this.typeTag = typeTag;
        this.__app = null;
        this.coin_types = proto['coin_types'];
        this.approvers = proto['approvers'];
    }
    static CoinListParser(data, typeTag, repo) {
        const proto = $.parseStructProto(data, typeTag, repo, CoinList);
        return new CoinList(proto, typeTag);
    }
    static load(repo, client, address, typeParams) {
        return __awaiter(this, void 0, void 0, function* () {
            const result = yield repo.loadResource(client, address, CoinList, typeParams);
            return result;
        });
    }
    static loadByApp(app, address, typeParams) {
        return __awaiter(this, void 0, void 0, function* () {
            const result = yield app.repo.loadResource(app.client, address, CoinList, typeParams);
            yield result.loadFullState(app);
            return result;
        });
    }
    static getTag() {
        return new StructTag(moduleAddress$r, moduleName$r, 'CoinList', []);
    }
    loadFullState(app) {
        return __awaiter(this, void 0, void 0, function* () {
            yield this.coin_types.loadFullState(app);
            this.__app = app;
        });
    }
}
CoinList.moduleAddress = moduleAddress$r;
CoinList.moduleName = moduleName$r;
CoinList.structName = 'CoinList';
CoinList.typeParameters = [];
CoinList.fields = [
    {
        name: 'coin_types',
        typeTag: new StructTag(new HexString('0x498d8926f16eb9ca90cab1b3a26aa6f97a080b3fcbe6e83ae150b7243a00fb68'), 'iterable_table', 'IterableTable', [
            new StructTag(new HexString('0x1'), 'type_info', 'TypeInfo', []),
            new StructTag(new HexString('0x498d8926f16eb9ca90cab1b3a26aa6f97a080b3fcbe6e83ae150b7243a00fb68'), 'coin_list', 'Nothing', [])
        ])
    },
    { name: 'approvers', typeTag: new VectorTag(AtomicTypeTag.Address) }
];
class CoinRegistry {
    constructor(proto, typeTag) {
        this.typeTag = typeTag;
        this.__app = null;
        this.type_to_coin_info = proto['type_to_coin_info'];
        this.uids = proto['uids'];
        this.approvers = proto['approvers'];
    }
    static CoinRegistryParser(data, typeTag, repo) {
        const proto = $.parseStructProto(data, typeTag, repo, CoinRegistry);
        return new CoinRegistry(proto, typeTag);
    }
    static load(repo, client, address, typeParams) {
        return __awaiter(this, void 0, void 0, function* () {
            const result = yield repo.loadResource(client, address, CoinRegistry, typeParams);
            return result;
        });
    }
    static loadByApp(app, address, typeParams) {
        return __awaiter(this, void 0, void 0, function* () {
            const result = yield app.repo.loadResource(app.client, address, CoinRegistry, typeParams);
            yield result.loadFullState(app);
            return result;
        });
    }
    static getTag() {
        return new StructTag(moduleAddress$r, moduleName$r, 'CoinRegistry', []);
    }
    loadFullState(app) {
        return __awaiter(this, void 0, void 0, function* () {
            yield this.type_to_coin_info.loadFullState(app);
            yield this.uids.loadFullState(app);
            this.__app = app;
        });
    }
}
CoinRegistry.moduleAddress = moduleAddress$r;
CoinRegistry.moduleName = moduleName$r;
CoinRegistry.structName = 'CoinRegistry';
CoinRegistry.typeParameters = [];
CoinRegistry.fields = [
    {
        name: 'type_to_coin_info',
        typeTag: new StructTag(new HexString('0x498d8926f16eb9ca90cab1b3a26aa6f97a080b3fcbe6e83ae150b7243a00fb68'), 'iterable_table', 'IterableTable', [
            new StructTag(new HexString('0x1'), 'type_info', 'TypeInfo', []),
            new StructTag(new HexString('0x498d8926f16eb9ca90cab1b3a26aa6f97a080b3fcbe6e83ae150b7243a00fb68'), 'coin_list', 'CoinInfo', [])
        ])
    },
    {
        name: 'uids',
        typeTag: new StructTag(new HexString('0x1'), 'table', 'Table', [
            new StructTag(new HexString('0x1'), 'string', 'String', []),
            new StructTag(new HexString('0x498d8926f16eb9ca90cab1b3a26aa6f97a080b3fcbe6e83ae150b7243a00fb68'), 'coin_list', 'Nothing', [])
        ])
    },
    { name: 'approvers', typeTag: new VectorTag(AtomicTypeTag.Address) }
];
class FullList {
    constructor(proto, typeTag) {
        this.typeTag = typeTag;
        this.__app = null;
        this.coin_info_list = proto['coin_info_list'];
    }
    static FullListParser(data, typeTag, repo) {
        const proto = $.parseStructProto(data, typeTag, repo, FullList);
        return new FullList(proto, typeTag);
    }
    static load(repo, client, address, typeParams) {
        return __awaiter(this, void 0, void 0, function* () {
            const result = yield repo.loadResource(client, address, FullList, typeParams);
            return result;
        });
    }
    static loadByApp(app, address, typeParams) {
        return __awaiter(this, void 0, void 0, function* () {
            const result = yield app.repo.loadResource(app.client, address, FullList, typeParams);
            yield result.loadFullState(app);
            return result;
        });
    }
    static getTag() {
        return new StructTag(moduleAddress$r, moduleName$r, 'FullList', []);
    }
    loadFullState(app) {
        return __awaiter(this, void 0, void 0, function* () {
            this.__app = app;
        });
    }
}
FullList.moduleAddress = moduleAddress$r;
FullList.moduleName = moduleName$r;
FullList.structName = 'FullList';
FullList.typeParameters = [];
FullList.fields = [
    {
        name: 'coin_info_list',
        typeTag: new VectorTag(new StructTag(new HexString('0x498d8926f16eb9ca90cab1b3a26aa6f97a080b3fcbe6e83ae150b7243a00fb68'), 'coin_list', 'CoinInfo', []))
    }
];
class Nothing {
    constructor(proto, typeTag) {
        this.typeTag = typeTag;
        this.__app = null;
    }
    static NothingParser(data, typeTag, repo) {
        const proto = $.parseStructProto(data, typeTag, repo, Nothing);
        return new Nothing(proto, typeTag);
    }
    static getTag() {
        return new StructTag(moduleAddress$r, moduleName$r, 'Nothing', []);
    }
    loadFullState(app) {
        return __awaiter(this, void 0, void 0, function* () {
            this.__app = app;
        });
    }
}
Nothing.moduleAddress = moduleAddress$r;
Nothing.moduleName = moduleName$r;
Nothing.structName = 'Nothing';
Nothing.typeParameters = [];
Nothing.fields = [];
function add_approver_to_list_(list_owner, approver, $c) {
    let list;
    list = $c.borrow_global_mut(new SimpleStructTag(CoinList), address_of_(list_owner, $c));
    if (!!contains_$8(list.approvers, approver, $c, [AtomicTypeTag.Address])) {
        throw $.abortCode(u64('0'));
    }
    push_back_(list.approvers, $.copy(approver), $c, [AtomicTypeTag.Address]);
    return;
}
function buildPayload_add_approver_to_list(approver, isJSON = false) {
    const typeParamStrings = [];
    return $.buildPayload(new HexString('0x498d8926f16eb9ca90cab1b3a26aa6f97a080b3fcbe6e83ae150b7243a00fb68'), 'coin_list', 'add_approver_to_list', typeParamStrings, [approver], isJSON);
}
function add_approver_to_registry_(admin, approver, $c) {
    let registry;
    if (!(address_of_(admin, $c).hex() ===
        new HexString('0x498d8926f16eb9ca90cab1b3a26aa6f97a080b3fcbe6e83ae150b7243a00fb68').hex())) {
        throw $.abortCode($.copy(E_CONTRACT_OWNER_ONLY));
    }
    registry = $c.borrow_global_mut(new SimpleStructTag(CoinRegistry), new HexString('0x498d8926f16eb9ca90cab1b3a26aa6f97a080b3fcbe6e83ae150b7243a00fb68'));
    if (!!contains_$8(registry.approvers, approver, $c, [AtomicTypeTag.Address])) {
        throw $.abortCode(u64('0'));
    }
    push_back_(registry.approvers, $.copy(approver), $c, [AtomicTypeTag.Address]);
    return;
}
function buildPayload_add_approver_to_registry(approver, isJSON = false) {
    const typeParamStrings = [];
    return $.buildPayload(new HexString('0x498d8926f16eb9ca90cab1b3a26aa6f97a080b3fcbe6e83ae150b7243a00fb68'), 'coin_list', 'add_approver_to_registry', typeParamStrings, [approver], isJSON);
}
function add_extension_(coin_owner, key, value, $c, $p /* <CoinType>*/) {
    let coin_info, registry, type_info;
    registry = $c.borrow_global_mut(new SimpleStructTag(CoinRegistry), new HexString('0x498d8926f16eb9ca90cab1b3a26aa6f97a080b3fcbe6e83ae150b7243a00fb68'));
    type_info = type_of_($c, [$p[0]]);
    if (!(address_of_(coin_owner, $c).hex() === account_address_(type_info).hex())) {
        throw $.abortCode($.copy(E_COIN_OWNER_ONLY));
    }
    coin_info = borrow_mut_$2(registry.type_to_coin_info, $.copy(type_info), $c, [
        new StructTag(new HexString('0x1'), 'type_info', 'TypeInfo', []),
        new SimpleStructTag(CoinInfo)
    ]);
    add_$4(coin_info.extensions, $.copy(key), $.copy(value), $c, [
        new StructTag(new HexString('0x1'), 'string', 'String', []),
        new StructTag(new HexString('0x1'), 'string', 'String', [])
    ]);
    return;
}
function buildPayload_add_extension(key, value, $p /* <CoinType>*/, isJSON = false) {
    const typeParamStrings = $p.map((t) => $.getTypeTagFullname(t));
    return $.buildPayload(new HexString('0x498d8926f16eb9ca90cab1b3a26aa6f97a080b3fcbe6e83ae150b7243a00fb68'), 'coin_list', 'add_extension', typeParamStrings, [key, value], isJSON);
}
function add_to_list_(approver, list, $c, $p /* <CoinType>*/) {
    let temp$1, temp$3, temp$4, coin_type, list__2;
    if (!is_coin_registered_($c, [$p[0]])) {
        throw $.abortCode($.copy(E_COIN_NOT_IN_REGISTRY));
    }
    if (!$c.exists(new SimpleStructTag(CoinList), $.copy(list))) {
        temp$1 = $.copy(list).hex() === address_of_(approver, $c).hex();
    }
    else {
        temp$1 = false;
    }
    if (temp$1) {
        create_list_(approver, $c);
    }
    list__2 = $c.borrow_global_mut(new SimpleStructTag(CoinList), $.copy(list));
    temp$4 = list__2.approvers;
    temp$3 = address_of_(approver, $c);
    if (!contains_$8(temp$4, temp$3, $c, [AtomicTypeTag.Address])) {
        throw $.abortCode($.copy(E_APPROVER_ONLY));
    }
    coin_type = type_of_($c, [$p[0]]);
    add_$2(list__2.coin_types, $.copy(coin_type), new Nothing({}, new SimpleStructTag(Nothing)), $c, [
        new StructTag(new HexString('0x1'), 'type_info', 'TypeInfo', []),
        new SimpleStructTag(Nothing)
    ]);
    return;
}
function buildPayload_add_to_list(list, $p /* <CoinType>*/, isJSON = false) {
    const typeParamStrings = $p.map((t) => $.getTypeTagFullname(t));
    return $.buildPayload(new HexString('0x498d8926f16eb9ca90cab1b3a26aa6f97a080b3fcbe6e83ae150b7243a00fb68'), 'coin_list', 'add_to_list', typeParamStrings, [list], isJSON);
}
function add_to_registry_(registry, name, symbol, coingecko_id, logo_url, project_url, is_update, $c, $p /* <CoinType>*/) {
    let coin_info, type_info;
    type_info = type_of_($c, [$p[0]]);
    coin_info = new CoinInfo({
        name: $.copy(name),
        symbol: $.copy(symbol),
        official_symbol: symbol_($c, [$p[0]]),
        coingecko_id: $.copy(coingecko_id),
        decimals: decimals_($c, [$p[0]]),
        logo_url: $.copy(logo_url),
        project_url: $.copy(project_url),
        token_type: $.copy(type_info),
        extensions: create_$2($c, [
            new StructTag(new HexString('0x1'), 'string', 'String', []),
            new StructTag(new HexString('0x1'), 'string', 'String', [])
        ])
    }, new SimpleStructTag(CoinInfo));
    if (!is_update) {
        if (!!contains_$1(registry.type_to_coin_info, $.copy(type_info), $c, [
            new StructTag(new HexString('0x1'), 'type_info', 'TypeInfo', []),
            new SimpleStructTag(CoinInfo)
        ])) {
            throw $.abortCode($.copy(E_TYPE_ALREADY_EXISTS));
        }
        if (!!contains_$6(registry.uids, $.copy(symbol), $c, [
            new StructTag(new HexString('0x1'), 'string', 'String', []),
            new SimpleStructTag(Nothing)
        ])) {
            throw $.abortCode($.copy(E_UID_ALREADY_EXISTS));
        }
    }
    else {
        remove_(registry.type_to_coin_info, $.copy(type_info), $c, [
            new StructTag(new HexString('0x1'), 'type_info', 'TypeInfo', []),
            new SimpleStructTag(CoinInfo)
        ]);
        if (contains_$6(registry.uids, $.copy(symbol), $c, [
            new StructTag(new HexString('0x1'), 'string', 'String', []),
            new SimpleStructTag(Nothing)
        ])) {
            remove_$4(registry.uids, $.copy(symbol), $c, [
                new StructTag(new HexString('0x1'), 'string', 'String', []),
                new SimpleStructTag(Nothing)
            ]);
        }
    }
    add_$2(registry.type_to_coin_info, $.copy(type_info), $.copy(coin_info), $c, [
        new StructTag(new HexString('0x1'), 'type_info', 'TypeInfo', []),
        new SimpleStructTag(CoinInfo)
    ]);
    add_$8(registry.uids, $.copy(symbol), new Nothing({}, new SimpleStructTag(Nothing)), $c, [
        new StructTag(new HexString('0x1'), 'string', 'String', []),
        new SimpleStructTag(Nothing)
    ]);
    return;
}
function add_to_registry_by_approver_(approver, name, symbol, coingecko_id, logo_url, project_url, is_update, $c, $p /* <CoinType>*/) {
    let temp$1, temp$2, registry;
    registry = $c.borrow_global_mut(new SimpleStructTag(CoinRegistry), new HexString('0x498d8926f16eb9ca90cab1b3a26aa6f97a080b3fcbe6e83ae150b7243a00fb68'));
    temp$2 = registry.approvers;
    temp$1 = address_of_(approver, $c);
    if (!contains_$8(temp$2, temp$1, $c, [AtomicTypeTag.Address])) {
        throw $.abortCode($.copy(E_APPROVER_ONLY));
    }
    add_to_registry_(registry, $.copy(name), $.copy(symbol), $.copy(coingecko_id), $.copy(logo_url), $.copy(project_url), is_update, $c, [$p[0]]);
    return;
}
function buildPayload_add_to_registry_by_approver(name, symbol, coingecko_id, logo_url, project_url, is_update, $p /* <CoinType>*/, isJSON = false) {
    const typeParamStrings = $p.map((t) => $.getTypeTagFullname(t));
    return $.buildPayload(new HexString('0x498d8926f16eb9ca90cab1b3a26aa6f97a080b3fcbe6e83ae150b7243a00fb68'), 'coin_list', 'add_to_registry_by_approver', typeParamStrings, [name, symbol, coingecko_id, logo_url, project_url, is_update], isJSON);
}
function add_to_registry_by_proof_(_ownership_proof, name, symbol, coingecko_id, logo_url, project_url, is_update, $c, $p /* <CoinType, OwnershipProof>*/) {
    let coin_type, ownership_address, ownership_name, ownership_type, registry, type_address;
    coin_type = type_of_($c, [$p[0]]);
    ownership_type = type_of_($c, [$p[1]]);
    type_address = account_address_(coin_type);
    ownership_address = account_address_(ownership_type);
    ownership_name = module_name_(ownership_type);
    if (!$.veq($.copy(ownership_name), [
        u8('79'),
        u8('119'),
        u8('110'),
        u8('101'),
        u8('114'),
        u8('115'),
        u8('104'),
        u8('105'),
        u8('112'),
        u8('80'),
        u8('114'),
        u8('111'),
        u8('111'),
        u8('102')
    ])) {
        throw $.abortCode($.copy(E_COIN_OWNER_ONLY));
    }
    if (!($.copy(type_address).hex() === $.copy(ownership_address).hex())) {
        throw $.abortCode($.copy(E_COIN_OWNER_ONLY));
    }
    registry = $c.borrow_global_mut(new SimpleStructTag(CoinRegistry), new HexString('0x498d8926f16eb9ca90cab1b3a26aa6f97a080b3fcbe6e83ae150b7243a00fb68'));
    add_to_registry_(registry, $.copy(name), $.copy(symbol), $.copy(coingecko_id), $.copy(logo_url), $.copy(project_url), is_update, $c, [$p[0]]);
    return;
}
function add_to_registry_by_signer_(coin_owner, name, symbol, coingecko_id, logo_url, project_url, is_update, $c, $p /* <CoinType>*/) {
    let registry, type_info;
    type_info = type_of_($c, [$p[0]]);
    if (!(address_of_(coin_owner, $c).hex() === account_address_(type_info).hex())) {
        throw $.abortCode($.copy(E_COIN_OWNER_ONLY));
    }
    registry = $c.borrow_global_mut(new SimpleStructTag(CoinRegistry), new HexString('0x498d8926f16eb9ca90cab1b3a26aa6f97a080b3fcbe6e83ae150b7243a00fb68'));
    add_to_registry_(registry, $.copy(name), $.copy(symbol), $.copy(coingecko_id), $.copy(logo_url), $.copy(project_url), is_update, $c, [$p[0]]);
    return;
}
function buildPayload_add_to_registry_by_signer(name, symbol, coingecko_id, logo_url, project_url, is_update, $p /* <CoinType>*/, isJSON = false) {
    const typeParamStrings = $p.map((t) => $.getTypeTagFullname(t));
    return $.buildPayload(new HexString('0x498d8926f16eb9ca90cab1b3a26aa6f97a080b3fcbe6e83ae150b7243a00fb68'), 'coin_list', 'add_to_registry_by_signer', typeParamStrings, [name, symbol, coingecko_id, logo_url, project_url, is_update], isJSON);
}
function create_list_(list_owner, $c) {
    let approvers;
    approvers = empty_$5($c, [AtomicTypeTag.Address]);
    push_back_(approvers, address_of_(list_owner, $c), $c, [AtomicTypeTag.Address]);
    return $c.move_to(new SimpleStructTag(CoinList), list_owner, new CoinList({
        coin_types: new___$1($c, [
            new StructTag(new HexString('0x1'), 'type_info', 'TypeInfo', []),
            new SimpleStructTag(Nothing)
        ]),
        approvers: $.copy(approvers)
    }, new SimpleStructTag(CoinList)));
}
function buildPayload_create_list(isJSON = false) {
    const typeParamStrings = [];
    return $.buildPayload(new HexString('0x498d8926f16eb9ca90cab1b3a26aa6f97a080b3fcbe6e83ae150b7243a00fb68'), 'coin_list', 'create_list', typeParamStrings, [], isJSON);
}
function drop_extension_(coin_owner, key, value, $c, $p /* <CoinType>*/) {
    let coin_info, registry, type_info;
    registry = $c.borrow_global_mut(new SimpleStructTag(CoinRegistry), new HexString('0x498d8926f16eb9ca90cab1b3a26aa6f97a080b3fcbe6e83ae150b7243a00fb68'));
    type_info = type_of_($c, [$p[0]]);
    if (!(address_of_(coin_owner, $c).hex() === account_address_(type_info).hex())) {
        throw $.abortCode($.copy(E_COIN_OWNER_ONLY));
    }
    coin_info = borrow_mut_$2(registry.type_to_coin_info, $.copy(type_info), $c, [
        new StructTag(new HexString('0x1'), 'type_info', 'TypeInfo', []),
        new SimpleStructTag(CoinInfo)
    ]);
    add_$4(coin_info.extensions, $.copy(key), $.copy(value), $c, [
        new StructTag(new HexString('0x1'), 'string', 'String', []),
        new StructTag(new HexString('0x1'), 'string', 'String', [])
    ]);
    return;
}
function buildPayload_drop_extension(key, value, $p /* <CoinType>*/, isJSON = false) {
    const typeParamStrings = $p.map((t) => $.getTypeTagFullname(t));
    return $.buildPayload(new HexString('0x498d8926f16eb9ca90cab1b3a26aa6f97a080b3fcbe6e83ae150b7243a00fb68'), 'coin_list', 'drop_extension', typeParamStrings, [key, value], isJSON);
}
function fetch_all_registered_coin_info_(fetcher, $c) {
    return $c.move_to(new SimpleStructTag(FullList), fetcher, get_all_registered_coin_info_($c));
}
function buildPayload_fetch_all_registered_coin_info(isJSON = false) {
    const typeParamStrings = [];
    return $.buildPayload(new HexString('0x498d8926f16eb9ca90cab1b3a26aa6f97a080b3fcbe6e83ae150b7243a00fb68'), 'coin_list', 'fetch_all_registered_coin_info', typeParamStrings, [], isJSON);
}
function query_fetch_all_registered_coin_info(client, fetcher, repo, $p, option, _isJSON = false) {
    return __awaiter(this, void 0, void 0, function* () {
        const payload__ = buildPayload_fetch_all_registered_coin_info(_isJSON);
        const outputTypeTag = new SimpleStructTag(FullList);
        const output = yield $.simulatePayloadTx(client, fetcher, payload__, option);
        return $.takeSimulationValue(output, outputTypeTag, repo);
    });
}
function fetch_full_list_(fetcher, list_owner_addr, $c) {
    return $c.move_to(new SimpleStructTag(FullList), fetcher, get_full_list_($.copy(list_owner_addr), $c));
}
function buildPayload_fetch_full_list(list_owner_addr, isJSON = false) {
    const typeParamStrings = [];
    return $.buildPayload(new HexString('0x498d8926f16eb9ca90cab1b3a26aa6f97a080b3fcbe6e83ae150b7243a00fb68'), 'coin_list', 'fetch_full_list', typeParamStrings, [list_owner_addr], isJSON);
}
function query_fetch_full_list(client, fetcher, repo, list_owner_addr, $p, option, _isJSON = false) {
    return __awaiter(this, void 0, void 0, function* () {
        const payload__ = buildPayload_fetch_full_list(list_owner_addr, _isJSON);
        const outputTypeTag = new SimpleStructTag(FullList);
        const output = yield $.simulatePayloadTx(client, fetcher, payload__, option);
        return $.takeSimulationValue(output, outputTypeTag, repo);
    });
}
function get_all_registered_coin_info_($c) {
    let coin_info, fulllist, prev, registry, tail, tail_key;
    registry = $c.borrow_global(new SimpleStructTag(CoinRegistry), new HexString('0x498d8926f16eb9ca90cab1b3a26aa6f97a080b3fcbe6e83ae150b7243a00fb68'));
    tail = tail_key_(registry.type_to_coin_info, $c, [
        new StructTag(new HexString('0x1'), 'type_info', 'TypeInfo', []),
        new SimpleStructTag(CoinInfo)
    ]);
    fulllist = new FullList({ coin_info_list: empty_$5($c, [new SimpleStructTag(CoinInfo)]) }, new SimpleStructTag(FullList));
    while (is_some_(tail, $c, [new StructTag(new HexString('0x1'), 'type_info', 'TypeInfo', [])])) {
        {
            tail_key = $.copy(borrow_$6(tail, $c, [new StructTag(new HexString('0x1'), 'type_info', 'TypeInfo', [])]));
            coin_info = borrow_$2(registry.type_to_coin_info, $.copy(tail_key), $c, [
                new StructTag(new HexString('0x1'), 'type_info', 'TypeInfo', []),
                new SimpleStructTag(CoinInfo)
            ]);
            push_back_(fulllist.coin_info_list, $.copy(coin_info), $c, [new SimpleStructTag(CoinInfo)]);
            [, prev] = borrow_iter_(registry.type_to_coin_info, $.copy(tail_key), $c, [
                new StructTag(new HexString('0x1'), 'type_info', 'TypeInfo', []),
                new SimpleStructTag(CoinInfo)
            ]);
            tail = $.copy(prev);
        }
    }
    return $.copy(fulllist);
}
function get_coin_info_($c, $p /* <CoinType>*/) {
    let registry, type_info;
    registry = $c.borrow_global(new SimpleStructTag(CoinRegistry), new HexString('0x498d8926f16eb9ca90cab1b3a26aa6f97a080b3fcbe6e83ae150b7243a00fb68'));
    type_info = type_of_($c, [$p[0]]);
    return $.copy(borrow_$2(registry.type_to_coin_info, $.copy(type_info), $c, [
        new StructTag(new HexString('0x1'), 'type_info', 'TypeInfo', []),
        new SimpleStructTag(CoinInfo)
    ]));
}
function get_full_list_(list_owner_addr, $c) {
    let coin_info, fulllist, list, prev, registry, tail, tail_key;
    list = $c.borrow_global(new SimpleStructTag(CoinList), $.copy(list_owner_addr));
    registry = $c.borrow_global(new SimpleStructTag(CoinRegistry), new HexString('0x498d8926f16eb9ca90cab1b3a26aa6f97a080b3fcbe6e83ae150b7243a00fb68'));
    tail = tail_key_(list.coin_types, $c, [
        new StructTag(new HexString('0x1'), 'type_info', 'TypeInfo', []),
        new SimpleStructTag(Nothing)
    ]);
    fulllist = new FullList({ coin_info_list: empty_$5($c, [new SimpleStructTag(CoinInfo)]) }, new SimpleStructTag(FullList));
    while (is_some_(tail, $c, [new StructTag(new HexString('0x1'), 'type_info', 'TypeInfo', [])])) {
        {
            tail_key = $.copy(borrow_$6(tail, $c, [new StructTag(new HexString('0x1'), 'type_info', 'TypeInfo', [])]));
            coin_info = borrow_$2(registry.type_to_coin_info, $.copy(tail_key), $c, [
                new StructTag(new HexString('0x1'), 'type_info', 'TypeInfo', []),
                new SimpleStructTag(CoinInfo)
            ]);
            push_back_(fulllist.coin_info_list, $.copy(coin_info), $c, [new SimpleStructTag(CoinInfo)]);
            [, prev] = borrow_iter_(list.coin_types, $.copy(tail_key), $c, [
                new StructTag(new HexString('0x1'), 'type_info', 'TypeInfo', []),
                new SimpleStructTag(Nothing)
            ]);
            tail = $.copy(prev);
        }
    }
    return $.copy(fulllist);
}
function init_module_$1(admin, $c) {
    initialize_$1(admin, $c);
    return;
}
function buildPayload_init_module$1(isJSON = false) {
    const typeParamStrings = [];
    return $.buildPayload(new HexString('0x498d8926f16eb9ca90cab1b3a26aa6f97a080b3fcbe6e83ae150b7243a00fb68'), 'coin_list', 'init_module', typeParamStrings, [], isJSON);
}
function initialize_$1(admin, $c) {
    let approvers;
    if (!(address_of_(admin, $c).hex() ===
        new HexString('0x498d8926f16eb9ca90cab1b3a26aa6f97a080b3fcbe6e83ae150b7243a00fb68').hex())) {
        throw $.abortCode($.copy(E_CONTRACT_OWNER_ONLY));
    }
    approvers = empty_$5($c, [AtomicTypeTag.Address]);
    push_back_(approvers, address_of_(admin, $c), $c, [AtomicTypeTag.Address]);
    $c.move_to(new SimpleStructTag(CoinRegistry), admin, new CoinRegistry({
        type_to_coin_info: new___$1($c, [
            new StructTag(new HexString('0x1'), 'type_info', 'TypeInfo', []),
            new SimpleStructTag(CoinInfo)
        ]),
        uids: new___$5($c, [
            new StructTag(new HexString('0x1'), 'string', 'String', []),
            new SimpleStructTag(Nothing)
        ]),
        approvers: $.copy(approvers)
    }, new SimpleStructTag(CoinRegistry)));
    create_list_(admin, $c);
    deploy_(admin, $c);
    return;
}
function buildPayload_initialize$1(isJSON = false) {
    const typeParamStrings = [];
    return $.buildPayload(new HexString('0x498d8926f16eb9ca90cab1b3a26aa6f97a080b3fcbe6e83ae150b7243a00fb68'), 'coin_list', 'initialize', typeParamStrings, [], isJSON);
}
function is_coin_in_list_(list_owner_addr, $c, $p /* <CoinType>*/) {
    let coin_type, list;
    if (!$c.exists(new SimpleStructTag(CoinList), $.copy(list_owner_addr))) {
        return false;
    }
    list = $c.borrow_global(new SimpleStructTag(CoinList), $.copy(list_owner_addr));
    coin_type = type_of_($c, [$p[0]]);
    return contains_$1(list.coin_types, $.copy(coin_type), $c, [
        new StructTag(new HexString('0x1'), 'type_info', 'TypeInfo', []),
        new SimpleStructTag(Nothing)
    ]);
}
function is_coin_registered_($c, $p /* <CoinType>*/) {
    let registry, type_info;
    registry = $c.borrow_global(new SimpleStructTag(CoinRegistry), new HexString('0x498d8926f16eb9ca90cab1b3a26aa6f97a080b3fcbe6e83ae150b7243a00fb68'));
    type_info = type_of_($c, [$p[0]]);
    return contains_$1(registry.type_to_coin_info, $.copy(type_info), $c, [
        new StructTag(new HexString('0x1'), 'type_info', 'TypeInfo', []),
        new SimpleStructTag(CoinInfo)
    ]);
}
function is_registry_initialized_($c) {
    return $c.exists(new SimpleStructTag(CoinRegistry), new HexString('0x498d8926f16eb9ca90cab1b3a26aa6f97a080b3fcbe6e83ae150b7243a00fb68'));
}
function remove_approver_from_list_(list_owner, approver, $c) {
    let i, list;
    list = $c.borrow_global_mut(new SimpleStructTag(CoinList), address_of_(list_owner, $c));
    if (!contains_$8(list.approvers, approver, $c, [AtomicTypeTag.Address])) {
        throw $.abortCode(u64('0'));
    }
    [, i] = index_of_$1(list.approvers, approver, $c, [AtomicTypeTag.Address]);
    remove_$5(list.approvers, $.copy(i), $c, [AtomicTypeTag.Address]);
    return;
}
function buildPayload_remove_approver_from_list(approver, isJSON = false) {
    const typeParamStrings = [];
    return $.buildPayload(new HexString('0x498d8926f16eb9ca90cab1b3a26aa6f97a080b3fcbe6e83ae150b7243a00fb68'), 'coin_list', 'remove_approver_from_list', typeParamStrings, [approver], isJSON);
}
function remove_approver_from_registry_(admin, approver, $c) {
    let i, registry;
    if (!(address_of_(admin, $c).hex() ===
        new HexString('0x498d8926f16eb9ca90cab1b3a26aa6f97a080b3fcbe6e83ae150b7243a00fb68').hex())) {
        throw $.abortCode($.copy(E_CONTRACT_OWNER_ONLY));
    }
    registry = $c.borrow_global_mut(new SimpleStructTag(CoinRegistry), new HexString('0x498d8926f16eb9ca90cab1b3a26aa6f97a080b3fcbe6e83ae150b7243a00fb68'));
    if (!contains_$8(registry.approvers, approver, $c, [AtomicTypeTag.Address])) {
        throw $.abortCode(u64('0'));
    }
    [, i] = index_of_$1(registry.approvers, approver, $c, [AtomicTypeTag.Address]);
    remove_$5(registry.approvers, $.copy(i), $c, [AtomicTypeTag.Address]);
    return;
}
function buildPayload_remove_approver_from_registry(approver, isJSON = false) {
    const typeParamStrings = [];
    return $.buildPayload(new HexString('0x498d8926f16eb9ca90cab1b3a26aa6f97a080b3fcbe6e83ae150b7243a00fb68'), 'coin_list', 'remove_approver_from_registry', typeParamStrings, [approver], isJSON);
}
function remove_from_list_(list_owner, $c, $p /* <CoinType>*/) {
    let coin_type, list;
    list = $c.borrow_global_mut(new SimpleStructTag(CoinList), address_of_(list_owner, $c));
    coin_type = type_of_($c, [$p[0]]);
    remove_(list.coin_types, $.copy(coin_type), $c, [
        new StructTag(new HexString('0x1'), 'type_info', 'TypeInfo', []),
        new SimpleStructTag(Nothing)
    ]);
    return;
}
function buildPayload_remove_from_list($p /* <CoinType>*/, isJSON = false) {
    const typeParamStrings = $p.map((t) => $.getTypeTagFullname(t));
    return $.buildPayload(new HexString('0x498d8926f16eb9ca90cab1b3a26aa6f97a080b3fcbe6e83ae150b7243a00fb68'), 'coin_list', 'remove_from_list', typeParamStrings, [], isJSON);
}
function remove_from_registry_by_approver_(_approver, $c, $p /* <CoinType>*/) {
    throw $.abortCode($.copy(E_UNSUPPORTED_METHOD));
}
function buildPayload_remove_from_registry_by_approver($p /* <CoinType>*/, isJSON = false) {
    const typeParamStrings = $p.map((t) => $.getTypeTagFullname(t));
    return $.buildPayload(new HexString('0x498d8926f16eb9ca90cab1b3a26aa6f97a080b3fcbe6e83ae150b7243a00fb68'), 'coin_list', 'remove_from_registry_by_approver', typeParamStrings, [], isJSON);
}
function remove_from_registry_by_proof_(_ownership_proof, $c, $p /* <CoinType, OwnershipProof>*/) {
    throw $.abortCode($.copy(E_UNSUPPORTED_METHOD));
}
function remove_from_registry_by_signer_(_coin_owner, $c, $p /* <CoinType>*/) {
    throw $.abortCode($.copy(E_UNSUPPORTED_METHOD));
}
function buildPayload_remove_from_registry_by_signer($p /* <CoinType>*/, isJSON = false) {
    const typeParamStrings = $p.map((t) => $.getTypeTagFullname(t));
    return $.buildPayload(new HexString('0x498d8926f16eb9ca90cab1b3a26aa6f97a080b3fcbe6e83ae150b7243a00fb68'), 'coin_list', 'remove_from_registry_by_signer', typeParamStrings, [], isJSON);
}
function loadParsers$D(repo) {
    repo.addParser('0x498d8926f16eb9ca90cab1b3a26aa6f97a080b3fcbe6e83ae150b7243a00fb68::coin_list::CoinInfo', CoinInfo.CoinInfoParser);
    repo.addParser('0x498d8926f16eb9ca90cab1b3a26aa6f97a080b3fcbe6e83ae150b7243a00fb68::coin_list::CoinList', CoinList.CoinListParser);
    repo.addParser('0x498d8926f16eb9ca90cab1b3a26aa6f97a080b3fcbe6e83ae150b7243a00fb68::coin_list::CoinRegistry', CoinRegistry.CoinRegistryParser);
    repo.addParser('0x498d8926f16eb9ca90cab1b3a26aa6f97a080b3fcbe6e83ae150b7243a00fb68::coin_list::FullList', FullList.FullListParser);
    repo.addParser('0x498d8926f16eb9ca90cab1b3a26aa6f97a080b3fcbe6e83ae150b7243a00fb68::coin_list::Nothing', Nothing.NothingParser);
}
class App$E {
    constructor(client, repo, cache) {
        this.client = client;
        this.repo = repo;
        this.cache = cache;
    }
    get moduleAddress() {
        {
            return moduleAddress$r;
        }
    }
    get moduleName() {
        {
            return moduleName$r;
        }
    }
    get CoinInfo() {
        return CoinInfo;
    }
    get CoinList() {
        return CoinList;
    }
    loadCoinList(owner, loadFull = true, fillCache = true) {
        return __awaiter(this, void 0, void 0, function* () {
            const val = yield CoinList.load(this.repo, this.client, owner, []);
            if (loadFull) {
                yield val.loadFullState(this);
            }
            if (fillCache) {
                this.cache.set(val.typeTag, owner, val);
            }
            return val;
        });
    }
    get CoinRegistry() {
        return CoinRegistry;
    }
    loadCoinRegistry(owner, loadFull = true, fillCache = true) {
        return __awaiter(this, void 0, void 0, function* () {
            const val = yield CoinRegistry.load(this.repo, this.client, owner, []);
            if (loadFull) {
                yield val.loadFullState(this);
            }
            if (fillCache) {
                this.cache.set(val.typeTag, owner, val);
            }
            return val;
        });
    }
    get FullList() {
        return FullList;
    }
    loadFullList(owner, loadFull = true, fillCache = true) {
        return __awaiter(this, void 0, void 0, function* () {
            const val = yield FullList.load(this.repo, this.client, owner, []);
            if (loadFull) {
                yield val.loadFullState(this);
            }
            if (fillCache) {
                this.cache.set(val.typeTag, owner, val);
            }
            return val;
        });
    }
    get Nothing() {
        return Nothing;
    }
    payload_add_approver_to_list(approver, isJSON = false) {
        return buildPayload_add_approver_to_list(approver, isJSON);
    }
    add_approver_to_list(_account, approver, option, _isJSON = false) {
        return __awaiter(this, void 0, void 0, function* () {
            const payload__ = buildPayload_add_approver_to_list(approver, _isJSON);
            return $.sendPayloadTx(this.client, _account, payload__, option);
        });
    }
    payload_add_approver_to_registry(approver, isJSON = false) {
        return buildPayload_add_approver_to_registry(approver, isJSON);
    }
    add_approver_to_registry(_account, approver, option, _isJSON = false) {
        return __awaiter(this, void 0, void 0, function* () {
            const payload__ = buildPayload_add_approver_to_registry(approver, _isJSON);
            return $.sendPayloadTx(this.client, _account, payload__, option);
        });
    }
    payload_add_extension(key, value, $p /* <CoinType>*/, isJSON = false) {
        return buildPayload_add_extension(key, value, $p, isJSON);
    }
    add_extension(_account, key, value, $p /* <CoinType>*/, option, _isJSON = false) {
        return __awaiter(this, void 0, void 0, function* () {
            const payload__ = buildPayload_add_extension(key, value, $p, _isJSON);
            return $.sendPayloadTx(this.client, _account, payload__, option);
        });
    }
    payload_add_to_list(list, $p /* <CoinType>*/, isJSON = false) {
        return buildPayload_add_to_list(list, $p, isJSON);
    }
    add_to_list(_account, list, $p /* <CoinType>*/, option, _isJSON = false) {
        return __awaiter(this, void 0, void 0, function* () {
            const payload__ = buildPayload_add_to_list(list, $p, _isJSON);
            return $.sendPayloadTx(this.client, _account, payload__, option);
        });
    }
    payload_add_to_registry_by_approver(name, symbol, coingecko_id, logo_url, project_url, is_update, $p /* <CoinType>*/, isJSON = false) {
        return buildPayload_add_to_registry_by_approver(name, symbol, coingecko_id, logo_url, project_url, is_update, $p, isJSON);
    }
    add_to_registry_by_approver(_account, name, symbol, coingecko_id, logo_url, project_url, is_update, $p /* <CoinType>*/, option, _isJSON = false) {
        return __awaiter(this, void 0, void 0, function* () {
            const payload__ = buildPayload_add_to_registry_by_approver(name, symbol, coingecko_id, logo_url, project_url, is_update, $p, _isJSON);
            return $.sendPayloadTx(this.client, _account, payload__, option);
        });
    }
    payload_add_to_registry_by_signer(name, symbol, coingecko_id, logo_url, project_url, is_update, $p /* <CoinType>*/, isJSON = false) {
        return buildPayload_add_to_registry_by_signer(name, symbol, coingecko_id, logo_url, project_url, is_update, $p, isJSON);
    }
    add_to_registry_by_signer(_account, name, symbol, coingecko_id, logo_url, project_url, is_update, $p /* <CoinType>*/, option, _isJSON = false) {
        return __awaiter(this, void 0, void 0, function* () {
            const payload__ = buildPayload_add_to_registry_by_signer(name, symbol, coingecko_id, logo_url, project_url, is_update, $p, _isJSON);
            return $.sendPayloadTx(this.client, _account, payload__, option);
        });
    }
    payload_create_list(isJSON = false) {
        return buildPayload_create_list(isJSON);
    }
    create_list(_account, option, _isJSON = false) {
        return __awaiter(this, void 0, void 0, function* () {
            const payload__ = buildPayload_create_list(_isJSON);
            return $.sendPayloadTx(this.client, _account, payload__, option);
        });
    }
    payload_drop_extension(key, value, $p /* <CoinType>*/, isJSON = false) {
        return buildPayload_drop_extension(key, value, $p, isJSON);
    }
    drop_extension(_account, key, value, $p /* <CoinType>*/, option, _isJSON = false) {
        return __awaiter(this, void 0, void 0, function* () {
            const payload__ = buildPayload_drop_extension(key, value, $p, _isJSON);
            return $.sendPayloadTx(this.client, _account, payload__, option);
        });
    }
    payload_fetch_all_registered_coin_info(isJSON = false) {
        return buildPayload_fetch_all_registered_coin_info(isJSON);
    }
    fetch_all_registered_coin_info(_account, option, _isJSON = false) {
        return __awaiter(this, void 0, void 0, function* () {
            const payload__ = buildPayload_fetch_all_registered_coin_info(_isJSON);
            return $.sendPayloadTx(this.client, _account, payload__, option);
        });
    }
    query_fetch_all_registered_coin_info($p, option, _isJSON = false, fetcher = $.SIM_KEYS) {
        return __awaiter(this, void 0, void 0, function* () {
            return query_fetch_all_registered_coin_info(this.client, fetcher, this.repo, $p, option);
        });
    }
    payload_fetch_full_list(list_owner_addr, isJSON = false) {
        return buildPayload_fetch_full_list(list_owner_addr, isJSON);
    }
    fetch_full_list(_account, list_owner_addr, option, _isJSON = false) {
        return __awaiter(this, void 0, void 0, function* () {
            const payload__ = buildPayload_fetch_full_list(list_owner_addr, _isJSON);
            return $.sendPayloadTx(this.client, _account, payload__, option);
        });
    }
    query_fetch_full_list(list_owner_addr, $p, option, _isJSON = false, fetcher = $.SIM_KEYS) {
        return __awaiter(this, void 0, void 0, function* () {
            return query_fetch_full_list(this.client, fetcher, this.repo, list_owner_addr, $p, option);
        });
    }
    payload_init_module(isJSON = false) {
        return buildPayload_init_module$1(isJSON);
    }
    init_module(_account, option, _isJSON = false) {
        return __awaiter(this, void 0, void 0, function* () {
            const payload__ = buildPayload_init_module$1(_isJSON);
            return $.sendPayloadTx(this.client, _account, payload__, option);
        });
    }
    payload_initialize(isJSON = false) {
        return buildPayload_initialize$1(isJSON);
    }
    initialize(_account, option, _isJSON = false) {
        return __awaiter(this, void 0, void 0, function* () {
            const payload__ = buildPayload_initialize$1(_isJSON);
            return $.sendPayloadTx(this.client, _account, payload__, option);
        });
    }
    payload_remove_approver_from_list(approver, isJSON = false) {
        return buildPayload_remove_approver_from_list(approver, isJSON);
    }
    remove_approver_from_list(_account, approver, option, _isJSON = false) {
        return __awaiter(this, void 0, void 0, function* () {
            const payload__ = buildPayload_remove_approver_from_list(approver, _isJSON);
            return $.sendPayloadTx(this.client, _account, payload__, option);
        });
    }
    payload_remove_approver_from_registry(approver, isJSON = false) {
        return buildPayload_remove_approver_from_registry(approver, isJSON);
    }
    remove_approver_from_registry(_account, approver, option, _isJSON = false) {
        return __awaiter(this, void 0, void 0, function* () {
            const payload__ = buildPayload_remove_approver_from_registry(approver, _isJSON);
            return $.sendPayloadTx(this.client, _account, payload__, option);
        });
    }
    payload_remove_from_list($p /* <CoinType>*/, isJSON = false) {
        return buildPayload_remove_from_list($p, isJSON);
    }
    remove_from_list(_account, $p /* <CoinType>*/, option, _isJSON = false) {
        return __awaiter(this, void 0, void 0, function* () {
            const payload__ = buildPayload_remove_from_list($p, _isJSON);
            return $.sendPayloadTx(this.client, _account, payload__, option);
        });
    }
    payload_remove_from_registry_by_approver($p /* <CoinType>*/, isJSON = false) {
        return buildPayload_remove_from_registry_by_approver($p, isJSON);
    }
    remove_from_registry_by_approver(_account, $p /* <CoinType>*/, option, _isJSON = false) {
        return __awaiter(this, void 0, void 0, function* () {
            const payload__ = buildPayload_remove_from_registry_by_approver($p, _isJSON);
            return $.sendPayloadTx(this.client, _account, payload__, option);
        });
    }
    payload_remove_from_registry_by_signer($p /* <CoinType>*/, isJSON = false) {
        return buildPayload_remove_from_registry_by_signer($p, isJSON);
    }
    remove_from_registry_by_signer(_account, $p /* <CoinType>*/, option, _isJSON = false) {
        return __awaiter(this, void 0, void 0, function* () {
            const payload__ = buildPayload_remove_from_registry_by_signer($p, _isJSON);
            return $.sendPayloadTx(this.client, _account, payload__, option);
        });
    }
}

var Coin_list = /*#__PURE__*/Object.freeze({
    __proto__: null,
    packageName: packageName$r,
    moduleAddress: moduleAddress$r,
    moduleName: moduleName$r,
    E_APPROVER_ONLY: E_APPROVER_ONLY,
    E_COIN_NOT_IN_REGISTRY: E_COIN_NOT_IN_REGISTRY,
    E_COIN_OWNER_ONLY: E_COIN_OWNER_ONLY,
    E_CONTRACT_OWNER_ONLY: E_CONTRACT_OWNER_ONLY,
    E_LIST_DOES_NOT_EXIST: E_LIST_DOES_NOT_EXIST,
    E_TYPE_ALREADY_EXISTS: E_TYPE_ALREADY_EXISTS,
    E_UID_ALREADY_EXISTS: E_UID_ALREADY_EXISTS,
    E_UNSUPPORTED_METHOD: E_UNSUPPORTED_METHOD,
    CoinInfo: CoinInfo,
    CoinList: CoinList,
    CoinRegistry: CoinRegistry,
    FullList: FullList,
    Nothing: Nothing,
    add_approver_to_list_: add_approver_to_list_,
    buildPayload_add_approver_to_list: buildPayload_add_approver_to_list,
    add_approver_to_registry_: add_approver_to_registry_,
    buildPayload_add_approver_to_registry: buildPayload_add_approver_to_registry,
    add_extension_: add_extension_,
    buildPayload_add_extension: buildPayload_add_extension,
    add_to_list_: add_to_list_,
    buildPayload_add_to_list: buildPayload_add_to_list,
    add_to_registry_: add_to_registry_,
    add_to_registry_by_approver_: add_to_registry_by_approver_,
    buildPayload_add_to_registry_by_approver: buildPayload_add_to_registry_by_approver,
    add_to_registry_by_proof_: add_to_registry_by_proof_,
    add_to_registry_by_signer_: add_to_registry_by_signer_,
    buildPayload_add_to_registry_by_signer: buildPayload_add_to_registry_by_signer,
    create_list_: create_list_,
    buildPayload_create_list: buildPayload_create_list,
    drop_extension_: drop_extension_,
    buildPayload_drop_extension: buildPayload_drop_extension,
    fetch_all_registered_coin_info_: fetch_all_registered_coin_info_,
    buildPayload_fetch_all_registered_coin_info: buildPayload_fetch_all_registered_coin_info,
    query_fetch_all_registered_coin_info: query_fetch_all_registered_coin_info,
    fetch_full_list_: fetch_full_list_,
    buildPayload_fetch_full_list: buildPayload_fetch_full_list,
    query_fetch_full_list: query_fetch_full_list,
    get_all_registered_coin_info_: get_all_registered_coin_info_,
    get_coin_info_: get_coin_info_,
    get_full_list_: get_full_list_,
    init_module_: init_module_$1,
    buildPayload_init_module: buildPayload_init_module$1,
    initialize_: initialize_$1,
    buildPayload_initialize: buildPayload_initialize$1,
    is_coin_in_list_: is_coin_in_list_,
    is_coin_registered_: is_coin_registered_,
    is_registry_initialized_: is_registry_initialized_,
    remove_approver_from_list_: remove_approver_from_list_,
    buildPayload_remove_approver_from_list: buildPayload_remove_approver_from_list,
    remove_approver_from_registry_: remove_approver_from_registry_,
    buildPayload_remove_approver_from_registry: buildPayload_remove_approver_from_registry,
    remove_from_list_: remove_from_list_,
    buildPayload_remove_from_list: buildPayload_remove_from_list,
    remove_from_registry_by_approver_: remove_from_registry_by_approver_,
    buildPayload_remove_from_registry_by_approver: buildPayload_remove_from_registry_by_approver,
    remove_from_registry_by_proof_: remove_from_registry_by_proof_,
    remove_from_registry_by_signer_: remove_from_registry_by_signer_,
    buildPayload_remove_from_registry_by_signer: buildPayload_remove_from_registry_by_signer,
    loadParsers: loadParsers$D,
    App: App$E
});

function loadParsers$C(repo) {
    loadParsers$D(repo);
    loadParsers$F(repo);
    loadParsers$E(repo);
}
function getPackageRepo$b() {
    const repo = new AptosParserRepo();
    loadParsers$C(repo);
    repo.addDefaultParsers();
    return repo;
}
class App$D {
    constructor(client, repo, cache) {
        this.client = client;
        this.repo = repo;
        this.cache = cache;
        this.coin_list = new App$E(client, repo, cache);
        this.devnet_coins = new App$G(client, repo, cache);
        this.iterable_table = new App$F(client, repo, cache);
    }
}

var coin_list = /*#__PURE__*/Object.freeze({
    __proto__: null,
    loadParsers: loadParsers$C,
    getPackageRepo: getPackageRepo$b,
    App: App$D,
    Coin_list: Coin_list,
    Devnet_coins: Devnet_coins,
    Iterable_table: Iterable_table
});

const packageName$q = 'Aptoswap';
const moduleAddress$q = new HexString('0xa5d3ac4d429052674ed38adc62d010e52d7c24ca159194d17ddc196ddb7e480b');
const moduleName$q = 'pool';
function swap_x_to_y_direct_(in_coin, $c, $p /* <X, Y>*/) {
    destroy_zero_(in_coin, $c, [$p[0]]);
    return zero_$1($c, [$p[1]]);
}
function swap_y_to_x_direct_(in_coin, $c, $p /* <X, Y>*/) {
    destroy_zero_(in_coin, $c, [$p[1]]);
    return zero_$1($c, [$p[0]]);
}
function loadParsers$B(repo) { }
class App$C {
    constructor(client, repo, cache) {
        this.client = client;
        this.repo = repo;
        this.cache = cache;
    }
    get moduleAddress() {
        {
            return moduleAddress$q;
        }
    }
    get moduleName() {
        {
            return moduleName$q;
        }
    }
}

var Pool$1 = /*#__PURE__*/Object.freeze({
    __proto__: null,
    packageName: packageName$q,
    moduleAddress: moduleAddress$q,
    moduleName: moduleName$q,
    swap_x_to_y_direct_: swap_x_to_y_direct_,
    swap_y_to_x_direct_: swap_y_to_x_direct_,
    loadParsers: loadParsers$B,
    App: App$C
});

function loadParsers$A(repo) {
}
function getPackageRepo$a() {
    const repo = new AptosParserRepo();
    repo.addDefaultParsers();
    return repo;
}
class App$B {
    constructor(client, repo, cache) {
        this.client = client;
        this.repo = repo;
        this.cache = cache;
        this.pool = new App$C(client, repo, cache);
    }
}

var Aptoswap = /*#__PURE__*/Object.freeze({
    __proto__: null,
    loadParsers: loadParsers$A,
    getPackageRepo: getPackageRepo$a,
    App: App$B,
    Pool: Pool$1
});

const packageName$p = 'LPCoin';
const moduleAddress$p = new HexString('0x796900ebe1a1a54ff9e932f19c548f5c1af5c6e7d34965857ac2f7b1d1ab2cbf');
const moduleName$p = 'LPCoinV1';
class LPCoin {
    constructor(proto, typeTag) {
        this.typeTag = typeTag;
        this.__app = null;
    }
    static LPCoinParser(data, typeTag, repo) {
        const proto = $.parseStructProto(data, typeTag, repo, LPCoin);
        return new LPCoin(proto, typeTag);
    }
    static makeTag($p) {
        return new StructTag(moduleAddress$p, moduleName$p, 'LPCoin', $p);
    }
    loadFullState(app) {
        return __awaiter(this, void 0, void 0, function* () {
            this.__app = app;
        });
    }
}
LPCoin.moduleAddress = moduleAddress$p;
LPCoin.moduleName = moduleName$p;
LPCoin.structName = 'LPCoin';
LPCoin.typeParameters = [
    { name: 'CoinType1', isPhantom: true },
    { name: 'CoinType2', isPhantom: true }
];
LPCoin.fields = [];
function loadParsers$z(repo) {
    repo.addParser('0x796900ebe1a1a54ff9e932f19c548f5c1af5c6e7d34965857ac2f7b1d1ab2cbf::LPCoinV1::LPCoin', LPCoin.LPCoinParser);
}
class App$A {
    constructor(client, repo, cache) {
        this.client = client;
        this.repo = repo;
        this.cache = cache;
    }
    get moduleAddress() {
        {
            return moduleAddress$p;
        }
    }
    get moduleName() {
        {
            return moduleName$p;
        }
    }
    get LPCoin() {
        return LPCoin;
    }
}

var LPCoinV1 = /*#__PURE__*/Object.freeze({
    __proto__: null,
    packageName: packageName$p,
    moduleAddress: moduleAddress$p,
    moduleName: moduleName$p,
    LPCoin: LPCoin,
    loadParsers: loadParsers$z,
    App: App$A
});

function loadParsers$y(repo) {
    loadParsers$z(repo);
}
function getPackageRepo$9() {
    const repo = new AptosParserRepo();
    loadParsers$y(repo);
    repo.addDefaultParsers();
    return repo;
}
class App$z {
    constructor(client, repo, cache) {
        this.client = client;
        this.repo = repo;
        this.cache = cache;
        this.LPCoinV1 = new App$A(client, repo, cache);
    }
}

var ResourceAccountDeployer = /*#__PURE__*/Object.freeze({
    __proto__: null,
    loadParsers: loadParsers$y,
    getPackageRepo: getPackageRepo$9,
    App: App$z,
    LPCoinV1: LPCoinV1
});

const packageName$o = 'AnimeSwapV1';
const moduleAddress$o = new HexString('0x16fe2df00ea7dde4a63409201f7f4e536bde7bb7335526a35d05111e68aa322c');
const moduleName$o = 'AnimeSwapPoolV1';
class AdminData {
    constructor(proto, typeTag) {
        this.typeTag = typeTag;
        this.__app = null;
        this.signer_cap = proto['signer_cap'];
        this.dao_fee_to = proto['dao_fee_to'];
        this.admin_address = proto['admin_address'];
        this.dao_fee = proto['dao_fee'];
        this.swap_fee = proto['swap_fee'];
        this.dao_fee_on = proto['dao_fee_on'];
        this.is_pause = proto['is_pause'];
    }
    static AdminDataParser(data, typeTag, repo) {
        const proto = $.parseStructProto(data, typeTag, repo, AdminData);
        return new AdminData(proto, typeTag);
    }
    static load(repo, client, address, typeParams) {
        return __awaiter(this, void 0, void 0, function* () {
            const result = yield repo.loadResource(client, address, AdminData, typeParams);
            return result;
        });
    }
    static loadByApp(app, address, typeParams) {
        return __awaiter(this, void 0, void 0, function* () {
            const result = yield app.repo.loadResource(app.client, address, AdminData, typeParams);
            yield result.loadFullState(app);
            return result;
        });
    }
    static getTag() {
        return new StructTag(moduleAddress$o, moduleName$o, 'AdminData', []);
    }
    loadFullState(app) {
        return __awaiter(this, void 0, void 0, function* () {
            yield this.signer_cap.loadFullState(app);
            this.__app = app;
        });
    }
}
AdminData.moduleAddress = moduleAddress$o;
AdminData.moduleName = moduleName$o;
AdminData.structName = 'AdminData';
AdminData.typeParameters = [];
AdminData.fields = [
    { name: 'signer_cap', typeTag: new StructTag(new HexString('0x1'), 'account', 'SignerCapability', []) },
    { name: 'dao_fee_to', typeTag: AtomicTypeTag.Address },
    { name: 'admin_address', typeTag: AtomicTypeTag.Address },
    { name: 'dao_fee', typeTag: AtomicTypeTag.U8 },
    { name: 'swap_fee', typeTag: AtomicTypeTag.U64 },
    { name: 'dao_fee_on', typeTag: AtomicTypeTag.Bool },
    { name: 'is_pause', typeTag: AtomicTypeTag.Bool }
];
class LiquidityPool$1 {
    constructor(proto, typeTag) {
        this.typeTag = typeTag;
        this.__app = null;
        this.coin_x_reserve = proto['coin_x_reserve'];
        this.coin_y_reserve = proto['coin_y_reserve'];
        this.last_block_timestamp = proto['last_block_timestamp'];
        this.last_price_x_cumulative = proto['last_price_x_cumulative'];
        this.last_price_y_cumulative = proto['last_price_y_cumulative'];
        this.k_last = proto['k_last'];
        this.lp_mint_cap = proto['lp_mint_cap'];
        this.lp_freeze_cap = proto['lp_freeze_cap'];
        this.lp_burn_cap = proto['lp_burn_cap'];
        this.locked = proto['locked'];
    }
    static LiquidityPoolParser(data, typeTag, repo) {
        const proto = $.parseStructProto(data, typeTag, repo, LiquidityPool$1);
        return new LiquidityPool$1(proto, typeTag);
    }
    static load(repo, client, address, typeParams) {
        return __awaiter(this, void 0, void 0, function* () {
            const result = yield repo.loadResource(client, address, LiquidityPool$1, typeParams);
            return result;
        });
    }
    static loadByApp(app, address, typeParams) {
        return __awaiter(this, void 0, void 0, function* () {
            const result = yield app.repo.loadResource(app.client, address, LiquidityPool$1, typeParams);
            yield result.loadFullState(app);
            return result;
        });
    }
    static makeTag($p) {
        return new StructTag(moduleAddress$o, moduleName$o, 'LiquidityPool', $p);
    }
    loadFullState(app) {
        return __awaiter(this, void 0, void 0, function* () {
            yield this.coin_x_reserve.loadFullState(app);
            yield this.coin_y_reserve.loadFullState(app);
            yield this.lp_mint_cap.loadFullState(app);
            yield this.lp_freeze_cap.loadFullState(app);
            yield this.lp_burn_cap.loadFullState(app);
            this.__app = app;
        });
    }
}
LiquidityPool$1.moduleAddress = moduleAddress$o;
LiquidityPool$1.moduleName = moduleName$o;
LiquidityPool$1.structName = 'LiquidityPool';
LiquidityPool$1.typeParameters = [
    { name: 'X', isPhantom: true },
    { name: 'Y', isPhantom: true }
];
LiquidityPool$1.fields = [
    { name: 'coin_x_reserve', typeTag: new StructTag(new HexString('0x1'), 'coin', 'Coin', [new $.TypeParamIdx(0)]) },
    { name: 'coin_y_reserve', typeTag: new StructTag(new HexString('0x1'), 'coin', 'Coin', [new $.TypeParamIdx(1)]) },
    { name: 'last_block_timestamp', typeTag: AtomicTypeTag.U64 },
    { name: 'last_price_x_cumulative', typeTag: AtomicTypeTag.U128 },
    { name: 'last_price_y_cumulative', typeTag: AtomicTypeTag.U128 },
    { name: 'k_last', typeTag: AtomicTypeTag.U128 },
    {
        name: 'lp_mint_cap',
        typeTag: new StructTag(new HexString('0x1'), 'coin', 'MintCapability', [
            new StructTag(new HexString('0x796900ebe1a1a54ff9e932f19c548f5c1af5c6e7d34965857ac2f7b1d1ab2cbf'), 'LPCoinV1', 'LPCoin', [new $.TypeParamIdx(0), new $.TypeParamIdx(1)])
        ])
    },
    {
        name: 'lp_freeze_cap',
        typeTag: new StructTag(new HexString('0x1'), 'coin', 'FreezeCapability', [
            new StructTag(new HexString('0x796900ebe1a1a54ff9e932f19c548f5c1af5c6e7d34965857ac2f7b1d1ab2cbf'), 'LPCoinV1', 'LPCoin', [new $.TypeParamIdx(0), new $.TypeParamIdx(1)])
        ])
    },
    {
        name: 'lp_burn_cap',
        typeTag: new StructTag(new HexString('0x1'), 'coin', 'BurnCapability', [
            new StructTag(new HexString('0x796900ebe1a1a54ff9e932f19c548f5c1af5c6e7d34965857ac2f7b1d1ab2cbf'), 'LPCoinV1', 'LPCoin', [new $.TypeParamIdx(0), new $.TypeParamIdx(1)])
        ])
    },
    { name: 'locked', typeTag: AtomicTypeTag.Bool }
];
function swap_coins_for_coins_(_coins_in, $c, $p /* <X, Y>*/) {
    throw $.abortCode(u64('0'));
}
function loadParsers$x(repo) {
    repo.addParser('0x16fe2df00ea7dde4a63409201f7f4e536bde7bb7335526a35d05111e68aa322c::AnimeSwapPoolV1::AdminData', AdminData.AdminDataParser);
    repo.addParser('0x16fe2df00ea7dde4a63409201f7f4e536bde7bb7335526a35d05111e68aa322c::AnimeSwapPoolV1::LiquidityPool', LiquidityPool$1.LiquidityPoolParser);
}
class App$y {
    constructor(client, repo, cache) {
        this.client = client;
        this.repo = repo;
        this.cache = cache;
    }
    get moduleAddress() {
        {
            return moduleAddress$o;
        }
    }
    get moduleName() {
        {
            return moduleName$o;
        }
    }
    get AdminData() {
        return AdminData;
    }
    loadAdminData(owner, loadFull = true, fillCache = true) {
        return __awaiter(this, void 0, void 0, function* () {
            const val = yield AdminData.load(this.repo, this.client, owner, []);
            if (loadFull) {
                yield val.loadFullState(this);
            }
            if (fillCache) {
                this.cache.set(val.typeTag, owner, val);
            }
            return val;
        });
    }
    get LiquidityPool() {
        return LiquidityPool$1;
    }
    loadLiquidityPool(owner, $p /* <X, Y> */, loadFull = true, fillCache = true) {
        return __awaiter(this, void 0, void 0, function* () {
            const val = yield LiquidityPool$1.load(this.repo, this.client, owner, $p);
            if (loadFull) {
                yield val.loadFullState(this);
            }
            if (fillCache) {
                this.cache.set(val.typeTag, owner, val);
            }
            return val;
        });
    }
}

var AnimeSwapPoolV1 = /*#__PURE__*/Object.freeze({
    __proto__: null,
    packageName: packageName$o,
    moduleAddress: moduleAddress$o,
    moduleName: moduleName$o,
    AdminData: AdminData,
    LiquidityPool: LiquidityPool$1,
    swap_coins_for_coins_: swap_coins_for_coins_,
    loadParsers: loadParsers$x,
    App: App$y
});

const packageName$n = 'AnimeSwapV1';
const moduleAddress$n = new HexString('0x16fe2df00ea7dde4a63409201f7f4e536bde7bb7335526a35d05111e68aa322c');
const moduleName$n = 'AnimeSwapPoolV1Library';
const ERR_COIN_TYPE_SAME_ERROR = u64('205');
const ERR_INSUFFICIENT_AMOUNT = u64('201');
const ERR_INSUFFICIENT_INPUT_AMOUNT = u64('203');
const ERR_INSUFFICIENT_LIQUIDITY = u64('202');
const ERR_INSUFFICIENT_OUTPUT_AMOUNT = u64('204');
const MAX_U128 = u128('340282366920938463463374607431768211455');
function get_amount_out_$2(amount_in, reserve_in, reserve_out, swap_fee, $c) {
    let temp$1, amount_in_with_fee, amount_out, denominator, numerator;
    if (!$.copy(amount_in).gt(u64('0'))) {
        throw $.abortCode($.copy(ERR_INSUFFICIENT_INPUT_AMOUNT));
    }
    if ($.copy(reserve_in).gt(u64('0'))) {
        temp$1 = $.copy(reserve_out).gt(u64('0'));
    }
    else {
        temp$1 = false;
    }
    if (!temp$1) {
        throw $.abortCode($.copy(ERR_INSUFFICIENT_LIQUIDITY));
    }
    amount_in_with_fee = u128($.copy(amount_in)).mul(u128(u64('10000').sub($.copy(swap_fee))));
    numerator = $.copy(amount_in_with_fee).mul(u128($.copy(reserve_out)));
    denominator = u128($.copy(reserve_in)).mul(u128('10000')).add($.copy(amount_in_with_fee));
    amount_out = $.copy(numerator).div($.copy(denominator));
    return u64($.copy(amount_out));
}
function quote_(amount_x, reserve_x, reserve_y, $c) {
    let temp$1, amount_y;
    if (!$.copy(amount_x).gt(u64('0'))) {
        throw $.abortCode($.copy(ERR_INSUFFICIENT_AMOUNT));
    }
    if ($.copy(reserve_x).gt(u64('0'))) {
        temp$1 = $.copy(reserve_y).gt(u64('0'));
    }
    else {
        temp$1 = false;
    }
    if (!temp$1) {
        throw $.abortCode($.copy(ERR_INSUFFICIENT_LIQUIDITY));
    }
    amount_y = u64(u128($.copy(amount_x))
        .mul(u128($.copy(reserve_y)))
        .div(u128($.copy(reserve_x))));
    return $.copy(amount_y);
}
function loadParsers$w(repo) { }
class App$x {
    constructor(client, repo, cache) {
        this.client = client;
        this.repo = repo;
        this.cache = cache;
    }
    get moduleAddress() {
        {
            return moduleAddress$n;
        }
    }
    get moduleName() {
        {
            return moduleName$n;
        }
    }
}

var AnimeSwapPoolV1Library = /*#__PURE__*/Object.freeze({
    __proto__: null,
    packageName: packageName$n,
    moduleAddress: moduleAddress$n,
    moduleName: moduleName$n,
    ERR_COIN_TYPE_SAME_ERROR: ERR_COIN_TYPE_SAME_ERROR,
    ERR_INSUFFICIENT_AMOUNT: ERR_INSUFFICIENT_AMOUNT,
    ERR_INSUFFICIENT_INPUT_AMOUNT: ERR_INSUFFICIENT_INPUT_AMOUNT,
    ERR_INSUFFICIENT_LIQUIDITY: ERR_INSUFFICIENT_LIQUIDITY,
    ERR_INSUFFICIENT_OUTPUT_AMOUNT: ERR_INSUFFICIENT_OUTPUT_AMOUNT,
    MAX_U128: MAX_U128,
    get_amount_out_: get_amount_out_$2,
    quote_: quote_,
    loadParsers: loadParsers$w,
    App: App$x
});

function loadParsers$v(repo) {
    loadParsers$x(repo);
}
function getPackageRepo$8() {
    const repo = new AptosParserRepo();
    loadParsers$v(repo);
    repo.addDefaultParsers();
    return repo;
}
class App$w {
    constructor(client, repo, cache) {
        this.client = client;
        this.repo = repo;
        this.cache = cache;
        this.AnimeSwapPoolV1 = new App$y(client, repo, cache);
        this.AnimeSwapPoolV1Library = new App$x(client, repo, cache);
    }
}

var SwapDeployer = /*#__PURE__*/Object.freeze({
    __proto__: null,
    loadParsers: loadParsers$v,
    getPackageRepo: getPackageRepo$8,
    App: App$w,
    AnimeSwapPoolV1: AnimeSwapPoolV1,
    AnimeSwapPoolV1Library: AnimeSwapPoolV1Library
});

const packageName$m = 'aux';
const moduleAddress$m = new HexString('0xbd35135844473187163ca197ca93b2ab014370587bb0ed3befff9e902d6bb541');
const moduleName$m = 'uint256';
const E_OVERFLOW = u64('1001');
const MAX_SHIFT = u8('255');
const UNDERLYING_HALF_POINT = u128('170141183460469231731687303715884105728');
const UNDERLYING_HALF_SIZE = u8('64');
const UNDERLYING_LOWER_ONES = u128('18446744073709551615');
const UNDERLYING_ONES = u128('340282366920938463463374607431768211455');
const UNDERLYING_SIZE = u8('128');
const UNDERLYING_UPPER_ONES = u128('340282366920938463444927863358058659840');
class Uint256 {
    constructor(proto, typeTag) {
        this.typeTag = typeTag;
        this.__app = null;
        this.hi = proto['hi'];
        this.lo = proto['lo'];
    }
    static Uint256Parser(data, typeTag, repo) {
        const proto = $.parseStructProto(data, typeTag, repo, Uint256);
        return new Uint256(proto, typeTag);
    }
    static getTag() {
        return new StructTag(moduleAddress$m, moduleName$m, 'Uint256', []);
    }
    loadFullState(app) {
        return __awaiter(this, void 0, void 0, function* () {
            this.__app = app;
        });
    }
}
Uint256.moduleAddress = moduleAddress$m;
Uint256.moduleName = moduleName$m;
Uint256.structName = 'Uint256';
Uint256.typeParameters = [];
Uint256.fields = [
    { name: 'hi', typeTag: AtomicTypeTag.U128 },
    { name: 'lo', typeTag: AtomicTypeTag.U128 }
];
function downcast_(x, $c) {
    if (!!underlying_overflow_($.copy(x))) {
        throw $.abortCode($.copy(E_OVERFLOW));
    }
    return $.copy(x.lo);
}
function new___(hi, lo, $c) {
    return new Uint256({ hi: $.copy(hi), lo: $.copy(lo) }, new SimpleStructTag(Uint256));
}
function underlying_add_with_carry_(x, y, $c) {
    let temp$1, temp$2, r;
    r = $.copy(UNDERLYING_ONES).sub($.copy(x));
    if ($.copy(r).lt($.copy(y))) {
        [temp$1, temp$2] = [$.copy(y).sub($.copy(r)).sub(u128('1')), u128('1')];
    }
    else {
        [temp$1, temp$2] = [$.copy(x).add($.copy(y)), u128('0')];
    }
    return [temp$1, temp$2];
}
function underlying_mul_to_uint256_(x, y, $c) {
    let hi, lo;
    [lo, hi] = underlying_mul_with_carry_($.copy(x), $.copy(y));
    return new___($.copy(hi), $.copy(lo));
}
function underlying_mul_with_carry_(x, y, $c) {
    let hi, lo, lo__1, lo_carry_1, lo_carry_2, xh, xhyl, xl, xlyh, yh, yl;
    xh = $.copy(x).and($.copy(UNDERLYING_UPPER_ONES)).shr($.copy(UNDERLYING_HALF_SIZE));
    xl = $.copy(x).and($.copy(UNDERLYING_LOWER_ONES));
    yh = $.copy(y).and($.copy(UNDERLYING_UPPER_ONES)).shr($.copy(UNDERLYING_HALF_SIZE));
    yl = $.copy(y).and($.copy(UNDERLYING_LOWER_ONES));
    xhyl = $.copy(xh).mul($.copy(yl));
    xlyh = $.copy(xl).mul($.copy(yh));
    [lo, lo_carry_1] = underlying_add_with_carry_($.copy(xl).mul($.copy(yl)), $.copy(xhyl).and($.copy(UNDERLYING_LOWER_ONES)).shl($.copy(UNDERLYING_HALF_SIZE)));
    [lo__1, lo_carry_2] = underlying_add_with_carry_($.copy(lo), $.copy(xlyh).and($.copy(UNDERLYING_LOWER_ONES)).shl($.copy(UNDERLYING_HALF_SIZE)));
    hi = $.copy(xh)
        .mul($.copy(yh))
        .add($.copy(xhyl).shr($.copy(UNDERLYING_HALF_SIZE)))
        .add($.copy(xlyh).shr($.copy(UNDERLYING_HALF_SIZE)))
        .add($.copy(lo_carry_1))
        .add($.copy(lo_carry_2));
    return [$.copy(lo__1), $.copy(hi)];
}
function underlying_overflow_(x, $c) {
    return $.copy(x.hi).neq(u128('0'));
}
function loadParsers$u(repo) {
    repo.addParser('0xbd35135844473187163ca197ca93b2ab014370587bb0ed3befff9e902d6bb541::uint256::Uint256', Uint256.Uint256Parser);
}
class App$v {
    constructor(client, repo, cache) {
        this.client = client;
        this.repo = repo;
        this.cache = cache;
    }
    get moduleAddress() {
        {
            return moduleAddress$m;
        }
    }
    get moduleName() {
        {
            return moduleName$m;
        }
    }
    get Uint256() {
        return Uint256;
    }
}

var Uint256$1 = /*#__PURE__*/Object.freeze({
    __proto__: null,
    packageName: packageName$m,
    moduleAddress: moduleAddress$m,
    moduleName: moduleName$m,
    E_OVERFLOW: E_OVERFLOW,
    MAX_SHIFT: MAX_SHIFT,
    UNDERLYING_HALF_POINT: UNDERLYING_HALF_POINT,
    UNDERLYING_HALF_SIZE: UNDERLYING_HALF_SIZE,
    UNDERLYING_LOWER_ONES: UNDERLYING_LOWER_ONES,
    UNDERLYING_ONES: UNDERLYING_ONES,
    UNDERLYING_SIZE: UNDERLYING_SIZE,
    UNDERLYING_UPPER_ONES: UNDERLYING_UPPER_ONES,
    Uint256: Uint256,
    downcast_: downcast_,
    new___: new___,
    underlying_add_with_carry_: underlying_add_with_carry_,
    underlying_mul_to_uint256_: underlying_mul_to_uint256_,
    underlying_mul_with_carry_: underlying_mul_with_carry_,
    underlying_overflow_: underlying_overflow_,
    loadParsers: loadParsers$u,
    App: App$v
});

const packageName$l = 'aux';
const moduleAddress$l = new HexString('0xbd35135844473187163ca197ca93b2ab014370587bb0ed3befff9e902d6bb541');
const moduleName$l = 'amm';
const EINSUFFICIENT_INPUT_AMOUNT = u64('16');
const EINSUFFICIENT_LIQUIDITY = u64('17');
const EINSUFFICIENT_OUTPUT_AMOUNT = u64('19');
const EPOOL_NOT_FOUND = u64('2');
class AddLiquidityEvent {
    constructor(proto, typeTag) {
        this.typeTag = typeTag;
        this.__app = null;
        this.timestamp = proto['timestamp'];
        this.x_coin_type = proto['x_coin_type'];
        this.y_coin_type = proto['y_coin_type'];
        this.x_added_au = proto['x_added_au'];
        this.y_added_au = proto['y_added_au'];
        this.lp_minted_au = proto['lp_minted_au'];
    }
    static AddLiquidityEventParser(data, typeTag, repo) {
        const proto = $.parseStructProto(data, typeTag, repo, AddLiquidityEvent);
        return new AddLiquidityEvent(proto, typeTag);
    }
    static getTag() {
        return new StructTag(moduleAddress$l, moduleName$l, 'AddLiquidityEvent', []);
    }
    loadFullState(app) {
        return __awaiter(this, void 0, void 0, function* () {
            yield this.x_coin_type.loadFullState(app);
            yield this.y_coin_type.loadFullState(app);
            this.__app = app;
        });
    }
}
AddLiquidityEvent.moduleAddress = moduleAddress$l;
AddLiquidityEvent.moduleName = moduleName$l;
AddLiquidityEvent.structName = 'AddLiquidityEvent';
AddLiquidityEvent.typeParameters = [];
AddLiquidityEvent.fields = [
    { name: 'timestamp', typeTag: AtomicTypeTag.U64 },
    { name: 'x_coin_type', typeTag: new StructTag(new HexString('0x1'), 'string', 'String', []) },
    { name: 'y_coin_type', typeTag: new StructTag(new HexString('0x1'), 'string', 'String', []) },
    { name: 'x_added_au', typeTag: AtomicTypeTag.U64 },
    { name: 'y_added_au', typeTag: AtomicTypeTag.U64 },
    { name: 'lp_minted_au', typeTag: AtomicTypeTag.U64 }
];
class LP$1 {
    constructor(proto, typeTag) {
        this.typeTag = typeTag;
        this.__app = null;
    }
    static LPParser(data, typeTag, repo) {
        const proto = $.parseStructProto(data, typeTag, repo, LP$1);
        return new LP$1(proto, typeTag);
    }
    static makeTag($p) {
        return new StructTag(moduleAddress$l, moduleName$l, 'LP', $p);
    }
    loadFullState(app) {
        return __awaiter(this, void 0, void 0, function* () {
            this.__app = app;
        });
    }
}
LP$1.moduleAddress = moduleAddress$l;
LP$1.moduleName = moduleName$l;
LP$1.structName = 'LP';
LP$1.typeParameters = [
    { name: 'X', isPhantom: true },
    { name: 'Y', isPhantom: true }
];
LP$1.fields = [];
class Pool {
    constructor(proto, typeTag) {
        this.typeTag = typeTag;
        this.__app = null;
        this.frozen = proto['frozen'];
        this.timestamp = proto['timestamp'];
        this.fee_bps = proto['fee_bps'];
        this.swap_events = proto['swap_events'];
        this.add_liquidity_events = proto['add_liquidity_events'];
        this.remove_liquidity_events = proto['remove_liquidity_events'];
        this.x_reserve = proto['x_reserve'];
        this.y_reserve = proto['y_reserve'];
        this.lp_mint = proto['lp_mint'];
        this.lp_burn = proto['lp_burn'];
    }
    static PoolParser(data, typeTag, repo) {
        const proto = $.parseStructProto(data, typeTag, repo, Pool);
        return new Pool(proto, typeTag);
    }
    static load(repo, client, address, typeParams) {
        return __awaiter(this, void 0, void 0, function* () {
            const result = yield repo.loadResource(client, address, Pool, typeParams);
            return result;
        });
    }
    static loadByApp(app, address, typeParams) {
        return __awaiter(this, void 0, void 0, function* () {
            const result = yield app.repo.loadResource(app.client, address, Pool, typeParams);
            yield result.loadFullState(app);
            return result;
        });
    }
    static makeTag($p) {
        return new StructTag(moduleAddress$l, moduleName$l, 'Pool', $p);
    }
    loadFullState(app) {
        return __awaiter(this, void 0, void 0, function* () {
            yield this.swap_events.loadFullState(app);
            yield this.add_liquidity_events.loadFullState(app);
            yield this.remove_liquidity_events.loadFullState(app);
            yield this.x_reserve.loadFullState(app);
            yield this.y_reserve.loadFullState(app);
            yield this.lp_mint.loadFullState(app);
            yield this.lp_burn.loadFullState(app);
            this.__app = app;
        });
    }
}
Pool.moduleAddress = moduleAddress$l;
Pool.moduleName = moduleName$l;
Pool.structName = 'Pool';
Pool.typeParameters = [
    { name: 'X', isPhantom: true },
    { name: 'Y', isPhantom: true }
];
Pool.fields = [
    { name: 'frozen', typeTag: AtomicTypeTag.Bool },
    { name: 'timestamp', typeTag: AtomicTypeTag.U64 },
    { name: 'fee_bps', typeTag: AtomicTypeTag.U64 },
    {
        name: 'swap_events',
        typeTag: new StructTag(new HexString('0x1'), 'event', 'EventHandle', [
            new StructTag(new HexString('0xbd35135844473187163ca197ca93b2ab014370587bb0ed3befff9e902d6bb541'), 'amm', 'SwapEvent', [])
        ])
    },
    {
        name: 'add_liquidity_events',
        typeTag: new StructTag(new HexString('0x1'), 'event', 'EventHandle', [
            new StructTag(new HexString('0xbd35135844473187163ca197ca93b2ab014370587bb0ed3befff9e902d6bb541'), 'amm', 'AddLiquidityEvent', [])
        ])
    },
    {
        name: 'remove_liquidity_events',
        typeTag: new StructTag(new HexString('0x1'), 'event', 'EventHandle', [
            new StructTag(new HexString('0xbd35135844473187163ca197ca93b2ab014370587bb0ed3befff9e902d6bb541'), 'amm', 'RemoveLiquidityEvent', [])
        ])
    },
    { name: 'x_reserve', typeTag: new StructTag(new HexString('0x1'), 'coin', 'Coin', [new $.TypeParamIdx(0)]) },
    { name: 'y_reserve', typeTag: new StructTag(new HexString('0x1'), 'coin', 'Coin', [new $.TypeParamIdx(1)]) },
    {
        name: 'lp_mint',
        typeTag: new StructTag(new HexString('0x1'), 'coin', 'MintCapability', [
            new StructTag(new HexString('0xbd35135844473187163ca197ca93b2ab014370587bb0ed3befff9e902d6bb541'), 'amm', 'LP', [new $.TypeParamIdx(0), new $.TypeParamIdx(1)])
        ])
    },
    {
        name: 'lp_burn',
        typeTag: new StructTag(new HexString('0x1'), 'coin', 'BurnCapability', [
            new StructTag(new HexString('0xbd35135844473187163ca197ca93b2ab014370587bb0ed3befff9e902d6bb541'), 'amm', 'LP', [new $.TypeParamIdx(0), new $.TypeParamIdx(1)])
        ])
    }
];
class RemoveLiquidityEvent {
    constructor(proto, typeTag) {
        this.typeTag = typeTag;
        this.__app = null;
        this.timestamp = proto['timestamp'];
        this.x_coin_type = proto['x_coin_type'];
        this.y_coin_type = proto['y_coin_type'];
        this.x_removed_au = proto['x_removed_au'];
        this.y_removed_au = proto['y_removed_au'];
        this.lp_burned_au = proto['lp_burned_au'];
    }
    static RemoveLiquidityEventParser(data, typeTag, repo) {
        const proto = $.parseStructProto(data, typeTag, repo, RemoveLiquidityEvent);
        return new RemoveLiquidityEvent(proto, typeTag);
    }
    static getTag() {
        return new StructTag(moduleAddress$l, moduleName$l, 'RemoveLiquidityEvent', []);
    }
    loadFullState(app) {
        return __awaiter(this, void 0, void 0, function* () {
            yield this.x_coin_type.loadFullState(app);
            yield this.y_coin_type.loadFullState(app);
            this.__app = app;
        });
    }
}
RemoveLiquidityEvent.moduleAddress = moduleAddress$l;
RemoveLiquidityEvent.moduleName = moduleName$l;
RemoveLiquidityEvent.structName = 'RemoveLiquidityEvent';
RemoveLiquidityEvent.typeParameters = [];
RemoveLiquidityEvent.fields = [
    { name: 'timestamp', typeTag: AtomicTypeTag.U64 },
    { name: 'x_coin_type', typeTag: new StructTag(new HexString('0x1'), 'string', 'String', []) },
    { name: 'y_coin_type', typeTag: new StructTag(new HexString('0x1'), 'string', 'String', []) },
    { name: 'x_removed_au', typeTag: AtomicTypeTag.U64 },
    { name: 'y_removed_au', typeTag: AtomicTypeTag.U64 },
    { name: 'lp_burned_au', typeTag: AtomicTypeTag.U64 }
];
class SwapEvent {
    constructor(proto, typeTag) {
        this.typeTag = typeTag;
        this.__app = null;
        this.sender_addr = proto['sender_addr'];
        this.timestamp = proto['timestamp'];
        this.in_coin_type = proto['in_coin_type'];
        this.out_coin_type = proto['out_coin_type'];
        this.in_reserve = proto['in_reserve'];
        this.out_reserve = proto['out_reserve'];
        this.in_au = proto['in_au'];
        this.out_au = proto['out_au'];
        this.fee_bps = proto['fee_bps'];
    }
    static SwapEventParser(data, typeTag, repo) {
        const proto = $.parseStructProto(data, typeTag, repo, SwapEvent);
        return new SwapEvent(proto, typeTag);
    }
    static getTag() {
        return new StructTag(moduleAddress$l, moduleName$l, 'SwapEvent', []);
    }
    loadFullState(app) {
        return __awaiter(this, void 0, void 0, function* () {
            yield this.in_coin_type.loadFullState(app);
            yield this.out_coin_type.loadFullState(app);
            this.__app = app;
        });
    }
}
SwapEvent.moduleAddress = moduleAddress$l;
SwapEvent.moduleName = moduleName$l;
SwapEvent.structName = 'SwapEvent';
SwapEvent.typeParameters = [];
SwapEvent.fields = [
    { name: 'sender_addr', typeTag: AtomicTypeTag.Address },
    { name: 'timestamp', typeTag: AtomicTypeTag.U64 },
    { name: 'in_coin_type', typeTag: new StructTag(new HexString('0x1'), 'string', 'String', []) },
    { name: 'out_coin_type', typeTag: new StructTag(new HexString('0x1'), 'string', 'String', []) },
    { name: 'in_reserve', typeTag: AtomicTypeTag.U64 },
    { name: 'out_reserve', typeTag: AtomicTypeTag.U64 },
    { name: 'in_au', typeTag: AtomicTypeTag.U64 },
    { name: 'out_au', typeTag: AtomicTypeTag.U64 },
    { name: 'fee_bps', typeTag: AtomicTypeTag.U64 }
];
function add_exact_liquidity_(_sender, _x_au, _y_au, $c, $p /* <X, Y>*/) {
    return;
}
function buildPayload_add_exact_liquidity(_x_au, _y_au, $p /* <X, Y>*/, isJSON = false) {
    const typeParamStrings = $p.map((t) => $.getTypeTagFullname(t));
    return $.buildPayload(new HexString('0xbd35135844473187163ca197ca93b2ab014370587bb0ed3befff9e902d6bb541'), 'amm', 'add_exact_liquidity', typeParamStrings, [_x_au, _y_au], isJSON);
}
function au_in_(au_out, $c, $p /* <CoinIn, CoinOut>*/) {
    let temp$4, temp$5, pool, pool__1, x_reserve, x_reserve__2, y_reserve, y_reserve__3;
    if ($c.exists(new SimpleStructTag(Pool, [$p[0], $p[1]]), new HexString('0xbd35135844473187163ca197ca93b2ab014370587bb0ed3befff9e902d6bb541'))) {
        pool = $c.borrow_global(new SimpleStructTag(Pool, [$p[0], $p[1]]), new HexString('0xbd35135844473187163ca197ca93b2ab014370587bb0ed3befff9e902d6bb541'));
        x_reserve = value_(pool.x_reserve, $c, [$p[0]]);
        y_reserve = value_(pool.y_reserve, $c, [$p[1]]);
        temp$5 = get_amount_in_($.copy(au_out), $.copy(x_reserve), $.copy(y_reserve), $.copy(pool.fee_bps));
    }
    else {
        if ($c.exists(new SimpleStructTag(Pool, [$p[1], $p[0]]), new HexString('0xbd35135844473187163ca197ca93b2ab014370587bb0ed3befff9e902d6bb541'))) {
            pool__1 = $c.borrow_global(new SimpleStructTag(Pool, [$p[1], $p[0]]), new HexString('0xbd35135844473187163ca197ca93b2ab014370587bb0ed3befff9e902d6bb541'));
            x_reserve__2 = value_(pool__1.x_reserve, $c, [$p[1]]);
            y_reserve__3 = value_(pool__1.y_reserve, $c, [$p[0]]);
            temp$4 = get_amount_in_($.copy(au_out), $.copy(y_reserve__3), $.copy(x_reserve__2), $.copy(pool__1.fee_bps));
        }
        else {
            throw $.abortCode($.copy(EPOOL_NOT_FOUND));
        }
        temp$5 = temp$4;
    }
    return temp$5;
}
function au_out_(au_in, $c, $p /* <CoinIn, CoinOut>*/) {
    let temp$4, temp$5, pool, pool__1, x_reserve, x_reserve__2, y_reserve, y_reserve__3;
    if ($c.exists(new SimpleStructTag(Pool, [$p[0], $p[1]]), new HexString('0xbd35135844473187163ca197ca93b2ab014370587bb0ed3befff9e902d6bb541'))) {
        pool = $c.borrow_global(new SimpleStructTag(Pool, [$p[0], $p[1]]), new HexString('0xbd35135844473187163ca197ca93b2ab014370587bb0ed3befff9e902d6bb541'));
        x_reserve = value_(pool.x_reserve, $c, [$p[0]]);
        y_reserve = value_(pool.y_reserve, $c, [$p[1]]);
        temp$5 = get_amount_out_$1($.copy(au_in), $.copy(x_reserve), $.copy(y_reserve), $.copy(pool.fee_bps));
    }
    else {
        if ($c.exists(new SimpleStructTag(Pool, [$p[1], $p[0]]), new HexString('0xbd35135844473187163ca197ca93b2ab014370587bb0ed3befff9e902d6bb541'))) {
            pool__1 = $c.borrow_global(new SimpleStructTag(Pool, [$p[1], $p[0]]), new HexString('0xbd35135844473187163ca197ca93b2ab014370587bb0ed3befff9e902d6bb541'));
            x_reserve__2 = value_(pool__1.x_reserve, $c, [$p[1]]);
            y_reserve__3 = value_(pool__1.y_reserve, $c, [$p[0]]);
            temp$4 = get_amount_out_$1($.copy(au_in), $.copy(y_reserve__3), $.copy(x_reserve__2), $.copy(pool__1.fee_bps));
        }
        else {
            throw $.abortCode($.copy(EPOOL_NOT_FOUND));
        }
        temp$5 = temp$4;
    }
    return temp$5;
}
function create_pool_(_sender, _fee_bps, $c, $p /* <X, Y>*/) {
    return;
}
function buildPayload_create_pool(_fee_bps, $p /* <X, Y>*/, isJSON = false) {
    const typeParamStrings = $p.map((t) => $.getTypeTagFullname(t));
    return $.buildPayload(new HexString('0xbd35135844473187163ca197ca93b2ab014370587bb0ed3befff9e902d6bb541'), 'amm', 'create_pool', typeParamStrings, [_fee_bps], isJSON);
}
function get_amount_in_(amount_out, reserve_in, reserve_out, fee_bps, $c) {
    let temp$1, denominator, numerator;
    if (!$.copy(amount_out).gt(u64('0'))) {
        throw $.abortCode($.copy(EINSUFFICIENT_OUTPUT_AMOUNT));
    }
    if ($.copy(reserve_in).gt(u64('0'))) {
        temp$1 = $.copy(reserve_out).gt(u64('0'));
    }
    else {
        temp$1 = false;
    }
    if (!temp$1) {
        throw $.abortCode($.copy(EINSUFFICIENT_LIQUIDITY));
    }
    numerator = u128($.copy(reserve_in))
        .mul(u128($.copy(amount_out)))
        .mul(u128('10000'));
    denominator = u128($.copy(reserve_out).sub($.copy(amount_out))).mul(u128(u64('10000').sub($.copy(fee_bps))));
    return u64($.copy(numerator).add($.copy(denominator)).sub(u128('1')).div($.copy(denominator)));
}
function get_amount_out_$1(amount_in, reserve_in, reserve_out, fee_bps, $c) {
    let temp$1, amount_in_with_fee, denominator, numerator;
    if (!$.copy(amount_in).gt(u64('0'))) {
        throw $.abortCode($.copy(EINSUFFICIENT_INPUT_AMOUNT));
    }
    if ($.copy(reserve_in).gt(u64('0'))) {
        temp$1 = $.copy(reserve_out).gt(u64('0'));
    }
    else {
        temp$1 = false;
    }
    if (!temp$1) {
        throw $.abortCode($.copy(EINSUFFICIENT_LIQUIDITY));
    }
    amount_in_with_fee = u128($.copy(amount_in)).mul(u128(u64('10000').sub($.copy(fee_bps))));
    numerator = downcast_(underlying_mul_to_uint256_($.copy(amount_in_with_fee), u128($.copy(reserve_out))));
    denominator = u128($.copy(reserve_in)).mul(u128('10000')).add($.copy(amount_in_with_fee));
    return u64($.copy(numerator).div($.copy(denominator)));
}
function swap_exact_coin_for_coin_mut_(_sender_addr, _user_in, _user_out, _au_in, _min_au_out, _use_limit_price, _max_out_per_in_au_numerator, _max_out_per_in_au_denominator, $c, $p /* <CoinIn, CoinOut>*/) {
    return [u64('0'), u64('0')];
}
function loadParsers$t(repo) {
    repo.addParser('0xbd35135844473187163ca197ca93b2ab014370587bb0ed3befff9e902d6bb541::amm::AddLiquidityEvent', AddLiquidityEvent.AddLiquidityEventParser);
    repo.addParser('0xbd35135844473187163ca197ca93b2ab014370587bb0ed3befff9e902d6bb541::amm::LP', LP$1.LPParser);
    repo.addParser('0xbd35135844473187163ca197ca93b2ab014370587bb0ed3befff9e902d6bb541::amm::Pool', Pool.PoolParser);
    repo.addParser('0xbd35135844473187163ca197ca93b2ab014370587bb0ed3befff9e902d6bb541::amm::RemoveLiquidityEvent', RemoveLiquidityEvent.RemoveLiquidityEventParser);
    repo.addParser('0xbd35135844473187163ca197ca93b2ab014370587bb0ed3befff9e902d6bb541::amm::SwapEvent', SwapEvent.SwapEventParser);
}
class App$u {
    constructor(client, repo, cache) {
        this.client = client;
        this.repo = repo;
        this.cache = cache;
    }
    get moduleAddress() {
        {
            return moduleAddress$l;
        }
    }
    get moduleName() {
        {
            return moduleName$l;
        }
    }
    get AddLiquidityEvent() {
        return AddLiquidityEvent;
    }
    get LP() {
        return LP$1;
    }
    get Pool() {
        return Pool;
    }
    loadPool(owner, $p /* <X, Y> */, loadFull = true, fillCache = true) {
        return __awaiter(this, void 0, void 0, function* () {
            const val = yield Pool.load(this.repo, this.client, owner, $p);
            if (loadFull) {
                yield val.loadFullState(this);
            }
            if (fillCache) {
                this.cache.set(val.typeTag, owner, val);
            }
            return val;
        });
    }
    get RemoveLiquidityEvent() {
        return RemoveLiquidityEvent;
    }
    get SwapEvent() {
        return SwapEvent;
    }
    payload_add_exact_liquidity(_x_au, _y_au, $p /* <X, Y>*/, isJSON = false) {
        return buildPayload_add_exact_liquidity(_x_au, _y_au, $p, isJSON);
    }
    add_exact_liquidity(_account, _x_au, _y_au, $p /* <X, Y>*/, option, _isJSON = false) {
        return __awaiter(this, void 0, void 0, function* () {
            const payload__ = buildPayload_add_exact_liquidity(_x_au, _y_au, $p, _isJSON);
            return $.sendPayloadTx(this.client, _account, payload__, option);
        });
    }
    payload_create_pool(_fee_bps, $p /* <X, Y>*/, isJSON = false) {
        return buildPayload_create_pool(_fee_bps, $p, isJSON);
    }
    create_pool(_account, _fee_bps, $p /* <X, Y>*/, option, _isJSON = false) {
        return __awaiter(this, void 0, void 0, function* () {
            const payload__ = buildPayload_create_pool(_fee_bps, $p, _isJSON);
            return $.sendPayloadTx(this.client, _account, payload__, option);
        });
    }
}

var Amm = /*#__PURE__*/Object.freeze({
    __proto__: null,
    packageName: packageName$l,
    moduleAddress: moduleAddress$l,
    moduleName: moduleName$l,
    EINSUFFICIENT_INPUT_AMOUNT: EINSUFFICIENT_INPUT_AMOUNT,
    EINSUFFICIENT_LIQUIDITY: EINSUFFICIENT_LIQUIDITY,
    EINSUFFICIENT_OUTPUT_AMOUNT: EINSUFFICIENT_OUTPUT_AMOUNT,
    EPOOL_NOT_FOUND: EPOOL_NOT_FOUND,
    AddLiquidityEvent: AddLiquidityEvent,
    LP: LP$1,
    Pool: Pool,
    RemoveLiquidityEvent: RemoveLiquidityEvent,
    SwapEvent: SwapEvent,
    add_exact_liquidity_: add_exact_liquidity_,
    buildPayload_add_exact_liquidity: buildPayload_add_exact_liquidity,
    au_in_: au_in_,
    au_out_: au_out_,
    create_pool_: create_pool_,
    buildPayload_create_pool: buildPayload_create_pool,
    get_amount_in_: get_amount_in_,
    get_amount_out_: get_amount_out_$1,
    swap_exact_coin_for_coin_mut_: swap_exact_coin_for_coin_mut_,
    loadParsers: loadParsers$t,
    App: App$u
});

function loadParsers$s(repo) {
    loadParsers$t(repo);
    loadParsers$u(repo);
}
function getPackageRepo$7() {
    const repo = new AptosParserRepo();
    loadParsers$s(repo);
    repo.addDefaultParsers();
    return repo;
}
class App$t {
    constructor(client, repo, cache) {
        this.client = client;
        this.repo = repo;
        this.cache = cache;
        this.amm = new App$u(client, repo, cache);
        this.uint256 = new App$v(client, repo, cache);
    }
}

var aux = /*#__PURE__*/Object.freeze({
    __proto__: null,
    loadParsers: loadParsers$s,
    getPackageRepo: getPackageRepo$7,
    App: App$t,
    Amm: Amm,
    Uint256: Uint256$1
});

const packageName$k = 'basiq';
const moduleAddress$k = new HexString('0x4885b08864b81ca42b19c38fff2eb958b5e312b1ec366014d4afff2775c19aab');
const moduleName$k = 'dex';
class V1LP {
    constructor(proto, typeTag) {
        this.typeTag = typeTag;
        this.__app = null;
    }
    static V1LPParser(data, typeTag, repo) {
        const proto = $.parseStructProto(data, typeTag, repo, V1LP);
        return new V1LP(proto, typeTag);
    }
    static makeTag($p) {
        return new StructTag(moduleAddress$k, moduleName$k, 'V1LP', $p);
    }
    loadFullState(app) {
        return __awaiter(this, void 0, void 0, function* () {
            this.__app = app;
        });
    }
}
V1LP.moduleAddress = moduleAddress$k;
V1LP.moduleName = moduleName$k;
V1LP.structName = 'V1LP';
V1LP.typeParameters = [
    { name: 'CoinX', isPhantom: true },
    { name: 'CoinY', isPhantom: true }
];
V1LP.fields = [];
function add_liquidity_entry_(_sender, _amount_x, _amount_y, $c, $p /* <CoinX, CoinY>*/) {
    return;
}
function buildPayload_add_liquidity_entry(_amount_x, _amount_y, $p /* <CoinX, CoinY>*/, isJSON = false) {
    const typeParamStrings = $p.map((t) => $.getTypeTagFullname(t));
    return $.buildPayload(new HexString('0x4885b08864b81ca42b19c38fff2eb958b5e312b1ec366014d4afff2775c19aab'), 'dex', 'add_liquidity_entry', typeParamStrings, [_amount_x, _amount_y], isJSON);
}
function admin_create_pool_(_admin, _x_price, _y_price, _lp_name, _lp_symbol, _is_not_pegged, $c, $p /* <CoinX, CoinY>*/) {
    return;
}
function buildPayload_admin_create_pool(_x_price, _y_price, _lp_name, _lp_symbol, _is_not_pegged, $p /* <CoinX, CoinY>*/, isJSON = false) {
    const typeParamStrings = $p.map((t) => $.getTypeTagFullname(t));
    return $.buildPayload(new HexString('0x4885b08864b81ca42b19c38fff2eb958b5e312b1ec366014d4afff2775c19aab'), 'dex', 'admin_create_pool', typeParamStrings, [_x_price, _y_price, _lp_name, _lp_symbol, _is_not_pegged], isJSON);
}
function swap_$2(coin_from, $c, $p /* <CoinFrom, CoinTo>*/) {
    destroy_zero_(coin_from, $c, [$p[0]]);
    return zero_$1($c, [$p[1]]);
}
function loadParsers$r(repo) {
    repo.addParser('0x4885b08864b81ca42b19c38fff2eb958b5e312b1ec366014d4afff2775c19aab::dex::V1LP', V1LP.V1LPParser);
}
class App$s {
    constructor(client, repo, cache) {
        this.client = client;
        this.repo = repo;
        this.cache = cache;
    }
    get moduleAddress() {
        {
            return moduleAddress$k;
        }
    }
    get moduleName() {
        {
            return moduleName$k;
        }
    }
    get V1LP() {
        return V1LP;
    }
    payload_add_liquidity_entry(_amount_x, _amount_y, $p /* <CoinX, CoinY>*/, isJSON = false) {
        return buildPayload_add_liquidity_entry(_amount_x, _amount_y, $p, isJSON);
    }
    add_liquidity_entry(_account, _amount_x, _amount_y, $p /* <CoinX, CoinY>*/, option, _isJSON = false) {
        return __awaiter(this, void 0, void 0, function* () {
            const payload__ = buildPayload_add_liquidity_entry(_amount_x, _amount_y, $p, _isJSON);
            return $.sendPayloadTx(this.client, _account, payload__, option);
        });
    }
    payload_admin_create_pool(_x_price, _y_price, _lp_name, _lp_symbol, _is_not_pegged, $p /* <CoinX, CoinY>*/, isJSON = false) {
        return buildPayload_admin_create_pool(_x_price, _y_price, _lp_name, _lp_symbol, _is_not_pegged, $p, isJSON);
    }
    admin_create_pool(_account, _x_price, _y_price, _lp_name, _lp_symbol, _is_not_pegged, $p /* <CoinX, CoinY>*/, option, _isJSON = false) {
        return __awaiter(this, void 0, void 0, function* () {
            const payload__ = buildPayload_admin_create_pool(_x_price, _y_price, _lp_name, _lp_symbol, _is_not_pegged, $p, _isJSON);
            return $.sendPayloadTx(this.client, _account, payload__, option);
        });
    }
}

var Dex = /*#__PURE__*/Object.freeze({
    __proto__: null,
    packageName: packageName$k,
    moduleAddress: moduleAddress$k,
    moduleName: moduleName$k,
    V1LP: V1LP,
    add_liquidity_entry_: add_liquidity_entry_,
    buildPayload_add_liquidity_entry: buildPayload_add_liquidity_entry,
    admin_create_pool_: admin_create_pool_,
    buildPayload_admin_create_pool: buildPayload_admin_create_pool,
    swap_: swap_$2,
    loadParsers: loadParsers$r,
    App: App$s
});

function loadParsers$q(repo) {
    loadParsers$r(repo);
}
function getPackageRepo$6() {
    const repo = new AptosParserRepo();
    loadParsers$q(repo);
    repo.addDefaultParsers();
    return repo;
}
class App$r {
    constructor(client, repo, cache) {
        this.client = client;
        this.repo = repo;
        this.cache = cache;
        this.dex = new App$s(client, repo, cache);
    }
}

var basiq = /*#__PURE__*/Object.freeze({
    __proto__: null,
    loadParsers: loadParsers$q,
    getPackageRepo: getPackageRepo$6,
    App: App$r,
    Dex: Dex
});

const packageName$j = 'Econia';
const moduleAddress$j = new HexString('0x51d8534aba004732df9a7229f89d6d7a687ad56f8c906e482f62ee298ec7c778');
const moduleName$j = 'assets';
const BASE_COIN_DECIMALS = u8('4');
const BASE_COIN_NAME = [
    u8('66'),
    u8('97'),
    u8('115'),
    u8('101'),
    u8('32'),
    u8('99'),
    u8('111'),
    u8('105'),
    u8('110')
];
const BASE_COIN_SYMBOL = [u8('66'), u8('67')];
const E_HAS_CAPABILITIES = u64('1');
const E_NOT_ECONIA$1 = u64('0');
const E_NO_CAPABILITIES = u64('2');
const QUOTE_COIN_DECIMALS = u8('12');
const QUOTE_COIN_NAME = [
    u8('81'),
    u8('117'),
    u8('111'),
    u8('116'),
    u8('101'),
    u8('32'),
    u8('99'),
    u8('111'),
    u8('105'),
    u8('110')
];
const QUOTE_COIN_SYMBOL = [u8('81'), u8('67')];
class BC {
    constructor(proto, typeTag) {
        this.typeTag = typeTag;
        this.__app = null;
    }
    static BCParser(data, typeTag, repo) {
        const proto = $.parseStructProto(data, typeTag, repo, BC);
        return new BC(proto, typeTag);
    }
    static getTag() {
        return new StructTag(moduleAddress$j, moduleName$j, 'BC', []);
    }
    loadFullState(app) {
        return __awaiter(this, void 0, void 0, function* () {
            this.__app = app;
        });
    }
}
BC.moduleAddress = moduleAddress$j;
BC.moduleName = moduleName$j;
BC.structName = 'BC';
BC.typeParameters = [];
BC.fields = [];
class CoinCapabilities {
    constructor(proto, typeTag) {
        this.typeTag = typeTag;
        this.__app = null;
        this.burn_capability = proto['burn_capability'];
        this.freeze_capability = proto['freeze_capability'];
        this.mint_capability = proto['mint_capability'];
    }
    static CoinCapabilitiesParser(data, typeTag, repo) {
        const proto = $.parseStructProto(data, typeTag, repo, CoinCapabilities);
        return new CoinCapabilities(proto, typeTag);
    }
    static load(repo, client, address, typeParams) {
        return __awaiter(this, void 0, void 0, function* () {
            const result = yield repo.loadResource(client, address, CoinCapabilities, typeParams);
            return result;
        });
    }
    static loadByApp(app, address, typeParams) {
        return __awaiter(this, void 0, void 0, function* () {
            const result = yield app.repo.loadResource(app.client, address, CoinCapabilities, typeParams);
            yield result.loadFullState(app);
            return result;
        });
    }
    static makeTag($p) {
        return new StructTag(moduleAddress$j, moduleName$j, 'CoinCapabilities', $p);
    }
    loadFullState(app) {
        return __awaiter(this, void 0, void 0, function* () {
            yield this.burn_capability.loadFullState(app);
            yield this.freeze_capability.loadFullState(app);
            yield this.mint_capability.loadFullState(app);
            this.__app = app;
        });
    }
}
CoinCapabilities.moduleAddress = moduleAddress$j;
CoinCapabilities.moduleName = moduleName$j;
CoinCapabilities.structName = 'CoinCapabilities';
CoinCapabilities.typeParameters = [{ name: 'CoinType', isPhantom: true }];
CoinCapabilities.fields = [
    {
        name: 'burn_capability',
        typeTag: new StructTag(new HexString('0x1'), 'coin', 'BurnCapability', [new $.TypeParamIdx(0)])
    },
    {
        name: 'freeze_capability',
        typeTag: new StructTag(new HexString('0x1'), 'coin', 'FreezeCapability', [new $.TypeParamIdx(0)])
    },
    {
        name: 'mint_capability',
        typeTag: new StructTag(new HexString('0x1'), 'coin', 'MintCapability', [new $.TypeParamIdx(0)])
    }
];
class QC {
    constructor(proto, typeTag) {
        this.typeTag = typeTag;
        this.__app = null;
    }
    static QCParser(data, typeTag, repo) {
        const proto = $.parseStructProto(data, typeTag, repo, QC);
        return new QC(proto, typeTag);
    }
    static getTag() {
        return new StructTag(moduleAddress$j, moduleName$j, 'QC', []);
    }
    loadFullState(app) {
        return __awaiter(this, void 0, void 0, function* () {
            this.__app = app;
        });
    }
}
QC.moduleAddress = moduleAddress$j;
QC.moduleName = moduleName$j;
QC.structName = 'QC';
QC.typeParameters = [];
QC.fields = [];
function burn_(coins, $c, $p /* <CoinType>*/) {
    let burn_capability;
    burn_capability = $c.borrow_global(new SimpleStructTag(CoinCapabilities, [$p[0]]), new HexString('0x51d8534aba004732df9a7229f89d6d7a687ad56f8c906e482f62ee298ec7c778')).burn_capability;
    burn_$3(coins, burn_capability, $c, [$p[0]]);
    return;
}
function init_coin_type_(account, coin_name, coin_symbol, decimals, $c, $p /* <CoinType>*/) {
    let burn_capability, freeze_capability, mint_capability;
    if (!(address_of_(account, $c).hex() ===
        new HexString('0x51d8534aba004732df9a7229f89d6d7a687ad56f8c906e482f62ee298ec7c778').hex())) {
        throw $.abortCode($.copy(E_NOT_ECONIA$1));
    }
    if (!!$c.exists(new SimpleStructTag(CoinCapabilities, [$p[0]]), new HexString('0x51d8534aba004732df9a7229f89d6d7a687ad56f8c906e482f62ee298ec7c778'))) {
        throw $.abortCode($.copy(E_HAS_CAPABILITIES));
    }
    [burn_capability, freeze_capability, mint_capability] = initialize_$j(account, utf8_($.copy(coin_name), $c), utf8_($.copy(coin_symbol), $c), $.copy(decimals), false, $c, [$p[0]]);
    $c.move_to(new SimpleStructTag(CoinCapabilities, [$p[0]]), account, new CoinCapabilities({
        burn_capability: $.copy(burn_capability),
        freeze_capability: $.copy(freeze_capability),
        mint_capability: $.copy(mint_capability)
    }, new SimpleStructTag(CoinCapabilities, [$p[0]])));
    return;
}
function init_coin_types_(account, $c) {
    init_coin_type_(account, $.copy(BASE_COIN_NAME), $.copy(BASE_COIN_SYMBOL), $.copy(BASE_COIN_DECIMALS), $c, [
        new SimpleStructTag(BC)
    ]);
    init_coin_type_(account, $.copy(QUOTE_COIN_NAME), $.copy(QUOTE_COIN_SYMBOL), $.copy(QUOTE_COIN_DECIMALS), $c, [
        new SimpleStructTag(QC)
    ]);
    return;
}
function buildPayload_init_coin_types(isJSON = false) {
    const typeParamStrings = [];
    return $.buildPayload(new HexString('0x51d8534aba004732df9a7229f89d6d7a687ad56f8c906e482f62ee298ec7c778'), 'assets', 'init_coin_types', typeParamStrings, [], isJSON);
}
function mint_(account, amount, $c, $p /* <CoinType>*/) {
    let account_address, mint_capability;
    account_address = address_of_(account, $c);
    if (!($.copy(account_address).hex() ===
        new HexString('0x51d8534aba004732df9a7229f89d6d7a687ad56f8c906e482f62ee298ec7c778').hex())) {
        throw $.abortCode($.copy(E_NOT_ECONIA$1));
    }
    if (!$c.exists(new SimpleStructTag(CoinCapabilities, [$p[0]]), $.copy(account_address))) {
        throw $.abortCode($.copy(E_NO_CAPABILITIES));
    }
    mint_capability = $c.borrow_global(new SimpleStructTag(CoinCapabilities, [$p[0]]), $.copy(account_address)).mint_capability;
    return mint_$4($.copy(amount), mint_capability, $c, [$p[0]]);
}
function buildPayload_mint(amount, $p /* <CoinType>*/, isJSON = false) {
    const typeParamStrings = $p.map((t) => $.getTypeTagFullname(t));
    return $.buildPayload(new HexString('0x51d8534aba004732df9a7229f89d6d7a687ad56f8c906e482f62ee298ec7c778'), 'assets', 'mint', typeParamStrings, [amount], isJSON);
}
function loadParsers$p(repo) {
    repo.addParser('0x51d8534aba004732df9a7229f89d6d7a687ad56f8c906e482f62ee298ec7c778::assets::BC', BC.BCParser);
    repo.addParser('0x51d8534aba004732df9a7229f89d6d7a687ad56f8c906e482f62ee298ec7c778::assets::CoinCapabilities', CoinCapabilities.CoinCapabilitiesParser);
    repo.addParser('0x51d8534aba004732df9a7229f89d6d7a687ad56f8c906e482f62ee298ec7c778::assets::QC', QC.QCParser);
}
class App$q {
    constructor(client, repo, cache) {
        this.client = client;
        this.repo = repo;
        this.cache = cache;
    }
    get moduleAddress() {
        {
            return moduleAddress$j;
        }
    }
    get moduleName() {
        {
            return moduleName$j;
        }
    }
    get BC() {
        return BC;
    }
    get CoinCapabilities() {
        return CoinCapabilities;
    }
    loadCoinCapabilities(owner, $p /* <CoinType> */, loadFull = true, fillCache = true) {
        return __awaiter(this, void 0, void 0, function* () {
            const val = yield CoinCapabilities.load(this.repo, this.client, owner, $p);
            if (loadFull) {
                yield val.loadFullState(this);
            }
            if (fillCache) {
                this.cache.set(val.typeTag, owner, val);
            }
            return val;
        });
    }
    get QC() {
        return QC;
    }
    payload_init_coin_types(isJSON = false) {
        return buildPayload_init_coin_types(isJSON);
    }
    init_coin_types(_account, option, _isJSON = false) {
        return __awaiter(this, void 0, void 0, function* () {
            const payload__ = buildPayload_init_coin_types(_isJSON);
            return $.sendPayloadTx(this.client, _account, payload__, option);
        });
    }
    payload_mint(amount, $p /* <CoinType>*/, isJSON = false) {
        return buildPayload_mint(amount, $p, isJSON);
    }
    mint(_account, amount, $p /* <CoinType>*/, option, _isJSON = false) {
        return __awaiter(this, void 0, void 0, function* () {
            const payload__ = buildPayload_mint(amount, $p, _isJSON);
            return $.sendPayloadTx(this.client, _account, payload__, option);
        });
    }
}

var Assets = /*#__PURE__*/Object.freeze({
    __proto__: null,
    packageName: packageName$j,
    moduleAddress: moduleAddress$j,
    moduleName: moduleName$j,
    BASE_COIN_DECIMALS: BASE_COIN_DECIMALS,
    BASE_COIN_NAME: BASE_COIN_NAME,
    BASE_COIN_SYMBOL: BASE_COIN_SYMBOL,
    E_HAS_CAPABILITIES: E_HAS_CAPABILITIES,
    E_NOT_ECONIA: E_NOT_ECONIA$1,
    E_NO_CAPABILITIES: E_NO_CAPABILITIES,
    QUOTE_COIN_DECIMALS: QUOTE_COIN_DECIMALS,
    QUOTE_COIN_NAME: QUOTE_COIN_NAME,
    QUOTE_COIN_SYMBOL: QUOTE_COIN_SYMBOL,
    BC: BC,
    CoinCapabilities: CoinCapabilities,
    QC: QC,
    burn_: burn_,
    init_coin_type_: init_coin_type_,
    init_coin_types_: init_coin_types_,
    buildPayload_init_coin_types: buildPayload_init_coin_types,
    mint_: mint_,
    buildPayload_mint: buildPayload_mint,
    loadParsers: loadParsers$p,
    App: App$q
});

const packageName$i = 'Econia';
const moduleAddress$i = new HexString('0x51d8534aba004732df9a7229f89d6d7a687ad56f8c906e482f62ee298ec7c778');
const moduleName$i = 'critbit';
const E_BIT_NOT_0_OR_1 = u64('0');
const E_BORROW_EMPTY = u64('3');
const E_DESTROY_NOT_EMPTY = u64('1');
const E_HAS_KEY = u64('2');
const E_INSERT_FULL = u64('5');
const E_LOOKUP_EMPTY = u64('7');
const E_NOT_HAS_KEY = u64('4');
const E_POP_EMPTY = u64('6');
const HI_128 = u128('340282366920938463463374607431768211455');
const HI_64$4 = u64('18446744073709551615');
const INNER = u64('0');
const LEFT$1 = true;
const MSB_u128 = u8('127');
const NODE_TYPE = u8('63');
const OUTER = u64('1');
const RIGHT$1 = false;
const ROOT = u64('18446744073709551615');
class CritBitTree {
    constructor(proto, typeTag) {
        this.typeTag = typeTag;
        this.__app = null;
        this.root = proto['root'];
        this.inner_nodes = proto['inner_nodes'];
        this.outer_nodes = proto['outer_nodes'];
    }
    static CritBitTreeParser(data, typeTag, repo) {
        const proto = $.parseStructProto(data, typeTag, repo, CritBitTree);
        return new CritBitTree(proto, typeTag);
    }
    static makeTag($p) {
        return new StructTag(moduleAddress$i, moduleName$i, 'CritBitTree', $p);
    }
    loadFullState(app) {
        return __awaiter(this, void 0, void 0, function* () {
            this.__app = app;
        });
    }
}
CritBitTree.moduleAddress = moduleAddress$i;
CritBitTree.moduleName = moduleName$i;
CritBitTree.structName = 'CritBitTree';
CritBitTree.typeParameters = [{ name: 'V', isPhantom: false }];
CritBitTree.fields = [
    { name: 'root', typeTag: AtomicTypeTag.U64 },
    {
        name: 'inner_nodes',
        typeTag: new VectorTag(new StructTag(new HexString('0x51d8534aba004732df9a7229f89d6d7a687ad56f8c906e482f62ee298ec7c778'), 'critbit', 'InnerNode', []))
    },
    {
        name: 'outer_nodes',
        typeTag: new VectorTag(new StructTag(new HexString('0x51d8534aba004732df9a7229f89d6d7a687ad56f8c906e482f62ee298ec7c778'), 'critbit', 'OuterNode', [new $.TypeParamIdx(0)]))
    }
];
class InnerNode {
    constructor(proto, typeTag) {
        this.typeTag = typeTag;
        this.__app = null;
        this.critical_bit = proto['critical_bit'];
        this.parent_index = proto['parent_index'];
        this.left_child_index = proto['left_child_index'];
        this.right_child_index = proto['right_child_index'];
    }
    static InnerNodeParser(data, typeTag, repo) {
        const proto = $.parseStructProto(data, typeTag, repo, InnerNode);
        return new InnerNode(proto, typeTag);
    }
    static getTag() {
        return new StructTag(moduleAddress$i, moduleName$i, 'InnerNode', []);
    }
    loadFullState(app) {
        return __awaiter(this, void 0, void 0, function* () {
            this.__app = app;
        });
    }
}
InnerNode.moduleAddress = moduleAddress$i;
InnerNode.moduleName = moduleName$i;
InnerNode.structName = 'InnerNode';
InnerNode.typeParameters = [];
InnerNode.fields = [
    { name: 'critical_bit', typeTag: AtomicTypeTag.U8 },
    { name: 'parent_index', typeTag: AtomicTypeTag.U64 },
    { name: 'left_child_index', typeTag: AtomicTypeTag.U64 },
    { name: 'right_child_index', typeTag: AtomicTypeTag.U64 }
];
class OuterNode {
    constructor(proto, typeTag) {
        this.typeTag = typeTag;
        this.__app = null;
        this.key = proto['key'];
        this.value = proto['value'];
        this.parent_index = proto['parent_index'];
    }
    static OuterNodeParser(data, typeTag, repo) {
        const proto = $.parseStructProto(data, typeTag, repo, OuterNode);
        return new OuterNode(proto, typeTag);
    }
    static makeTag($p) {
        return new StructTag(moduleAddress$i, moduleName$i, 'OuterNode', $p);
    }
    loadFullState(app) {
        return __awaiter(this, void 0, void 0, function* () {
            if (this.value.typeTag instanceof StructTag) {
                yield this.value.loadFullState(app);
            }
            this.__app = app;
        });
    }
}
OuterNode.moduleAddress = moduleAddress$i;
OuterNode.moduleName = moduleName$i;
OuterNode.structName = 'OuterNode';
OuterNode.typeParameters = [{ name: 'V', isPhantom: false }];
OuterNode.fields = [
    { name: 'key', typeTag: AtomicTypeTag.U128 },
    { name: 'value', typeTag: new $.TypeParamIdx(0) },
    { name: 'parent_index', typeTag: AtomicTypeTag.U64 }
];
function borrow_$1(tree, key, $c, $p /* <V>*/) {
    let closest_outer_node_ref;
    if (!!is_empty_(tree, $c, [$p[0]])) {
        throw $.abortCode($.copy(E_BORROW_EMPTY));
    }
    closest_outer_node_ref = borrow_closest_outer_node_(tree, $.copy(key), $c, [$p[0]]);
    if (!$.copy(closest_outer_node_ref.key).eq($.copy(key))) {
        throw $.abortCode($.copy(E_NOT_HAS_KEY));
    }
    return closest_outer_node_ref.value;
}
function borrow_closest_outer_node_(tree, key, $c, $p /* <V>*/) {
    let temp$1, child_index, node;
    if (is_outer_node_($.copy(tree.root))) {
        return borrow_$7(tree.outer_nodes, outer_node_vector_index_($.copy(tree.root)), $c, [
            new SimpleStructTag(OuterNode, [$p[0]])
        ]);
    }
    node = borrow_$7(tree.inner_nodes, $.copy(tree.root), $c, [new SimpleStructTag(InnerNode)]);
    while (true) {
        if (is_set_($.copy(key), $.copy(node.critical_bit))) {
            temp$1 = $.copy(node.right_child_index);
        }
        else {
            temp$1 = $.copy(node.left_child_index);
        }
        child_index = temp$1;
        if (is_outer_node_($.copy(child_index))) {
            return borrow_$7(tree.outer_nodes, outer_node_vector_index_($.copy(child_index)), $c, [
                new SimpleStructTag(OuterNode, [$p[0]])
            ]);
        }
        node = borrow_$7(tree.inner_nodes, $.copy(child_index), $c, [new SimpleStructTag(InnerNode)]);
    }
}
function borrow_closest_outer_node_mut_(tree, key, $c, $p /* <V>*/) {
    let temp$1, child_index, node;
    if (is_outer_node_($.copy(tree.root))) {
        return borrow_mut_$7(tree.outer_nodes, outer_node_vector_index_($.copy(tree.root)), $c, [
            new SimpleStructTag(OuterNode, [$p[0]])
        ]);
    }
    node = borrow_$7(tree.inner_nodes, $.copy(tree.root), $c, [new SimpleStructTag(InnerNode)]);
    while (true) {
        if (is_set_($.copy(key), $.copy(node.critical_bit))) {
            temp$1 = $.copy(node.right_child_index);
        }
        else {
            temp$1 = $.copy(node.left_child_index);
        }
        child_index = temp$1;
        if (is_outer_node_($.copy(child_index))) {
            return borrow_mut_$7(tree.outer_nodes, outer_node_vector_index_($.copy(child_index)), $c, [
                new SimpleStructTag(OuterNode, [$p[0]])
            ]);
        }
        node = borrow_$7(tree.inner_nodes, $.copy(child_index), $c, [new SimpleStructTag(InnerNode)]);
    }
}
function borrow_mut_$1(tree, key, $c, $p /* <V>*/) {
    let closest_outer_node_ref_mut;
    if (!!is_empty_(tree, $c, [$p[0]])) {
        throw $.abortCode($.copy(E_BORROW_EMPTY));
    }
    closest_outer_node_ref_mut = borrow_closest_outer_node_mut_(tree, $.copy(key), $c, [$p[0]]);
    if (!$.copy(closest_outer_node_ref_mut.key).eq($.copy(key))) {
        throw $.abortCode($.copy(E_NOT_HAS_KEY));
    }
    return closest_outer_node_ref_mut.value;
}
function check_length_(length, $c) {
    if (!$.copy(length).lt($.copy(HI_64$4).xor($.copy(OUTER).shl($.copy(NODE_TYPE))))) {
        throw $.abortCode($.copy(E_INSERT_FULL));
    }
    return;
}
function crit_bit_(s1, s2, $c) {
    let l, m, s, u, x;
    x = $.copy(s1).xor($.copy(s2));
    l = u8('0');
    u = $.copy(MSB_u128);
    while (true) {
        m = $.copy(l).add($.copy(u)).div(u8('2'));
        s = $.copy(x).shr($.copy(m));
        if ($.copy(s).eq(u128('1'))) {
            return $.copy(m);
        }
        if ($.copy(s).gt(u128('1'))) {
            l = $.copy(m).add(u8('1'));
        }
        else {
            u = $.copy(m).sub(u8('1'));
        }
    }
}
function destroy_empty_(tree, $c, $p /* <V>*/) {
    if (!is_empty_(tree, $c, [$p[0]])) {
        throw $.abortCode($.copy(E_DESTROY_NOT_EMPTY));
    }
    let { inner_nodes: inner_nodes, outer_nodes: outer_nodes } = tree;
    destroy_empty_$5(inner_nodes, $c, [new SimpleStructTag(InnerNode)]);
    destroy_empty_$5(outer_nodes, $c, [new SimpleStructTag(OuterNode, [$p[0]])]);
    return;
}
function empty_$1($c, $p /* <V>*/) {
    return new CritBitTree({
        root: u64('0'),
        inner_nodes: empty_$5($c, [new SimpleStructTag(InnerNode)]),
        outer_nodes: empty_$5($c, [new SimpleStructTag(OuterNode, [$p[0]])])
    }, new SimpleStructTag(CritBitTree, [$p[0]]));
}
function has_key_(tree, key, $c, $p /* <V>*/) {
    if (is_empty_(tree, $c, [$p[0]])) {
        return false;
    }
    return $.copy(borrow_closest_outer_node_(tree, $.copy(key), $c, [$p[0]]).key).eq($.copy(key));
}
function insert_(tree, key, value, $c, $p /* <V>*/) {
    let length;
    length = length_(tree, $c, [$p[0]]);
    check_length_($.copy(length));
    if ($.copy(length).eq(u64('0'))) {
        insert_empty_(tree, $.copy(key), value, $c, [$p[0]]);
    }
    else {
        if ($.copy(length).eq(u64('1'))) {
            insert_singleton_(tree, $.copy(key), value, $c, [$p[0]]);
        }
        else {
            insert_general_(tree, $.copy(key), value, $.copy(length), $c, [$p[0]]);
        }
    }
    return;
}
function insert_above_(tree, key, value, n_outer_nodes, n_inner_nodes, search_parent_index, critical_bit, $c, $p /* <V>*/) {
    let node, node_index;
    node_index = $.copy(borrow_$7(tree.inner_nodes, $.copy(search_parent_index), $c, [new SimpleStructTag(InnerNode)])
        .parent_index);
    while (true) {
        if ($.copy(node_index).eq($.copy(ROOT))) {
            return insert_above_root_(tree, $.copy(key), value, $.copy(n_outer_nodes), $.copy(n_inner_nodes), $.copy(critical_bit), $c, [$p[0]]);
        }
        else {
            node = borrow_mut_$7(tree.inner_nodes, $.copy(node_index), $c, [new SimpleStructTag(InnerNode)]);
            if ($.copy(critical_bit).lt($.copy(node.critical_bit))) {
                return insert_below_walk_(tree, $.copy(key), value, $.copy(n_outer_nodes), $.copy(n_inner_nodes), $.copy(node_index), $.copy(critical_bit), $c, [$p[0]]);
            }
            else {
                node_index = $.copy(node.parent_index);
            }
        }
    }
}
function insert_above_root_(tree, key, value, n_outer_nodes, n_inner_nodes, critical_bit, $c, $p /* <V>*/) {
    let old_root_index;
    old_root_index = $.copy(tree.root);
    borrow_mut_$7(tree.inner_nodes, $.copy(old_root_index), $c, [
        new SimpleStructTag(InnerNode)
    ]).parent_index = $.copy(n_inner_nodes);
    tree.root = $.copy(n_inner_nodes);
    push_back_insert_nodes_(tree, $.copy(key), value, $.copy(n_inner_nodes), $.copy(critical_bit), $.copy(ROOT), is_set_($.copy(key), $.copy(critical_bit)), $.copy(old_root_index), outer_node_child_index_($.copy(n_outer_nodes)), $c, [$p[0]]);
    return;
}
function insert_below_(tree, key, value, n_outer_nodes, n_inner_nodes, search_index, search_child_side, search_key, search_parent_index, critical_bit, $c, $p /* <V>*/) {
    let search_parent;
    search_parent = borrow_mut_$7(tree.inner_nodes, $.copy(search_parent_index), $c, [
        new SimpleStructTag(InnerNode)
    ]);
    if (search_child_side == $.copy(LEFT$1)) {
        search_parent.left_child_index = $.copy(n_inner_nodes);
    }
    else {
        search_parent.right_child_index = $.copy(n_inner_nodes);
    }
    borrow_mut_$7(tree.outer_nodes, outer_node_vector_index_($.copy(search_index)), $c, [
        new SimpleStructTag(OuterNode, [$p[0]])
    ]).parent_index = $.copy(n_inner_nodes);
    push_back_insert_nodes_(tree, $.copy(key), value, $.copy(n_inner_nodes), $.copy(critical_bit), $.copy(search_parent_index), $.copy(key).lt($.copy(search_key)), outer_node_child_index_($.copy(n_outer_nodes)), $.copy(search_index), $c, [$p[0]]);
    return;
}
function insert_below_walk_(tree, key, value, n_outer_nodes, n_inner_nodes, review_node_index, critical_bit, $c, $p /* <V>*/) {
    let temp$1, temp$2, review_node, walked_child_index, walked_child_side;
    review_node = borrow_mut_$7(tree.inner_nodes, $.copy(review_node_index), $c, [
        new SimpleStructTag(InnerNode)
    ]);
    if (is_set_($.copy(key), $.copy(review_node.critical_bit))) {
        [temp$1, temp$2] = [$.copy(RIGHT$1), $.copy(review_node.right_child_index)];
    }
    else {
        [temp$1, temp$2] = [$.copy(LEFT$1), $.copy(review_node.left_child_index)];
    }
    [walked_child_side, walked_child_index] = [temp$1, temp$2];
    if (walked_child_side == $.copy(LEFT$1)) {
        review_node.left_child_index = $.copy(n_inner_nodes);
    }
    else {
        review_node.right_child_index = $.copy(n_inner_nodes);
    }
    borrow_mut_$7(tree.inner_nodes, $.copy(walked_child_index), $c, [
        new SimpleStructTag(InnerNode)
    ]).parent_index = $.copy(n_inner_nodes);
    push_back_insert_nodes_(tree, $.copy(key), value, $.copy(n_inner_nodes), $.copy(critical_bit), $.copy(review_node_index), is_set_($.copy(key), $.copy(critical_bit)), $.copy(walked_child_index), outer_node_child_index_($.copy(n_outer_nodes)), $c, [$p[0]]);
    return;
}
function insert_empty_(tree, key, value, $c, $p /* <V>*/) {
    push_back_(tree.outer_nodes, new OuterNode({ key: $.copy(key), value: value, parent_index: $.copy(ROOT) }, new SimpleStructTag(OuterNode, [$p[0]])), $c, [new SimpleStructTag(OuterNode, [$p[0]])]);
    tree.root = $.copy(OUTER).shl($.copy(NODE_TYPE));
    return;
}
function insert_general_(tree, key, value, n_outer_nodes, $c, $p /* <V>*/) {
    let temp$1, temp$2, critical_bit, n_inner_nodes, search_child_side, search_index, search_key, search_parent_critical_bit, search_parent_index;
    n_inner_nodes = length_$6(tree.inner_nodes, $c, [new SimpleStructTag(InnerNode)]);
    [temp$1, temp$2] = [tree, $.copy(key)];
    [search_index, search_child_side, search_key, search_parent_index, search_parent_critical_bit] = search_outer_(temp$1, temp$2, $c, [$p[0]]);
    if (!$.copy(search_key).neq($.copy(key))) {
        throw $.abortCode($.copy(E_HAS_KEY));
    }
    critical_bit = crit_bit_($.copy(search_key), $.copy(key));
    if ($.copy(critical_bit).lt($.copy(search_parent_critical_bit))) {
        insert_below_(tree, $.copy(key), value, $.copy(n_outer_nodes), $.copy(n_inner_nodes), $.copy(search_index), search_child_side, $.copy(search_key), $.copy(search_parent_index), $.copy(critical_bit), $c, [$p[0]]);
    }
    else {
        insert_above_(tree, $.copy(key), value, $.copy(n_outer_nodes), $.copy(n_inner_nodes), $.copy(search_parent_index), $.copy(critical_bit), $c, [$p[0]]);
    }
    return;
}
function insert_singleton_(tree, key, value, $c, $p /* <V>*/) {
    let critical_bit, outer_node;
    outer_node = borrow_$7(tree.outer_nodes, u64('0'), $c, [new SimpleStructTag(OuterNode, [$p[0]])]);
    if (!$.copy(key).neq($.copy(outer_node.key))) {
        throw $.abortCode($.copy(E_HAS_KEY));
    }
    critical_bit = crit_bit_($.copy(outer_node.key), $.copy(key));
    push_back_insert_nodes_(tree, $.copy(key), value, u64('0'), $.copy(critical_bit), $.copy(ROOT), $.copy(key).gt($.copy(outer_node.key)), outer_node_child_index_(u64('0')), outer_node_child_index_(u64('1')), $c, [$p[0]]);
    tree.root = u64('0');
    borrow_mut_$7(tree.outer_nodes, u64('0'), $c, [new SimpleStructTag(OuterNode, [$p[0]])]).parent_index =
        u64('0');
    return;
}
function is_empty_(tree, $c, $p /* <V>*/) {
    return is_empty_$2(tree.outer_nodes, $c, [new SimpleStructTag(OuterNode, [$p[0]])]);
}
function is_outer_node_(child_field_index, $c) {
    return $.copy(child_field_index).shr($.copy(NODE_TYPE)).and($.copy(OUTER)).eq($.copy(OUTER));
}
function is_set_(key, bit_number, $c) {
    return $.copy(key).shr($.copy(bit_number)).and(u128('1')).eq(u128('1'));
}
function length_(tree, $c, $p /* <V>*/) {
    return length_$6(tree.outer_nodes, $c, [new SimpleStructTag(OuterNode, [$p[0]])]);
}
function max_key_(tree, $c, $p /* <V>*/) {
    if (!!is_empty_(tree, $c, [$p[0]])) {
        throw $.abortCode($.copy(E_LOOKUP_EMPTY));
    }
    return $.copy(borrow_$7(tree.outer_nodes, outer_node_vector_index_(max_node_child_index_(tree, $c, [$p[0]])), $c, [new SimpleStructTag(OuterNode, [$p[0]])]).key);
}
function max_node_child_index_(tree, $c, $p /* <V>*/) {
    let child_field_index;
    child_field_index = $.copy(tree.root);
    while (true) {
        if (is_outer_node_($.copy(child_field_index))) {
            return $.copy(child_field_index);
        }
        child_field_index = $.copy(borrow_$7(tree.inner_nodes, $.copy(child_field_index), $c, [new SimpleStructTag(InnerNode)])
            .right_child_index);
    }
}
function min_key_(tree, $c, $p /* <V>*/) {
    if (!!is_empty_(tree, $c, [$p[0]])) {
        throw $.abortCode($.copy(E_LOOKUP_EMPTY));
    }
    return $.copy(borrow_$7(tree.outer_nodes, outer_node_vector_index_(min_node_child_index_(tree, $c, [$p[0]])), $c, [new SimpleStructTag(OuterNode, [$p[0]])]).key);
}
function min_node_child_index_(tree, $c, $p /* <V>*/) {
    let child_field_index;
    child_field_index = $.copy(tree.root);
    while (true) {
        if (is_outer_node_($.copy(child_field_index))) {
            return $.copy(child_field_index);
        }
        child_field_index = $.copy(borrow_$7(tree.inner_nodes, $.copy(child_field_index), $c, [new SimpleStructTag(InnerNode)])
            .left_child_index);
    }
}
function outer_node_child_index_(vector_index, $c) {
    return $.copy(vector_index).or($.copy(OUTER).shl($.copy(NODE_TYPE)));
}
function outer_node_vector_index_(child_field_index, $c) {
    return $.copy(child_field_index)
        .and($.copy(HI_64$4))
        .xor($.copy(OUTER).shl($.copy(NODE_TYPE)));
}
function pop_(tree, key, $c, $p /* <V>*/) {
    let temp$1, length;
    if (!!is_empty_(tree, $c, [$p[0]])) {
        throw $.abortCode($.copy(E_POP_EMPTY));
    }
    length = length_(tree, $c, [$p[0]]);
    if ($.copy(length).eq(u64('1'))) {
        temp$1 = pop_singleton_(tree, $.copy(key), $c, [$p[0]]);
    }
    else {
        temp$1 = pop_general_(tree, $.copy(key), $.copy(length), $c, [$p[0]]);
    }
    return temp$1;
}
function pop_destroy_nodes_(tree, inner_index, outer_index, n_outer_nodes, $c, $p /* <V>*/) {
    let n_inner_nodes;
    n_inner_nodes = length_$6(tree.inner_nodes, $c, [new SimpleStructTag(InnerNode)]);
    swap_remove_(tree.inner_nodes, $.copy(inner_index), $c, [new SimpleStructTag(InnerNode)]);
    if ($.copy(inner_index).lt($.copy(n_inner_nodes).sub(u64('1')))) {
        stitch_swap_remove_(tree, $.copy(inner_index), $.copy(n_inner_nodes), $c, [$p[0]]);
    }
    let { value: value } = swap_remove_(tree.outer_nodes, outer_node_vector_index_($.copy(outer_index)), $c, [new SimpleStructTag(OuterNode, [$p[0]])]);
    if (outer_node_vector_index_($.copy(outer_index)).lt($.copy(n_outer_nodes).sub(u64('1')))) {
        stitch_swap_remove_(tree, $.copy(outer_index), $.copy(n_outer_nodes), $c, [$p[0]]);
    }
    return value;
}
function pop_general_(tree, key, n_outer_nodes, $c, $p /* <V>*/) {
    let temp$1, temp$2, search_child_side, search_index, search_key, search_parent_index;
    [temp$1, temp$2] = [tree, $.copy(key)];
    [search_index, search_child_side, search_key, search_parent_index] = search_outer_(temp$1, temp$2, $c, [$p[0]]);
    if (!$.copy(search_key).eq($.copy(key))) {
        throw $.abortCode($.copy(E_NOT_HAS_KEY));
    }
    pop_update_relationships_(tree, search_child_side, $.copy(search_parent_index), $c, [$p[0]]);
    return pop_destroy_nodes_(tree, $.copy(search_parent_index), $.copy(search_index), $.copy(n_outer_nodes), $c, [
        $p[0]
    ]);
}
function pop_singleton_(tree, key, $c, $p /* <V>*/) {
    if (!$.copy(borrow_$7(tree.outer_nodes, u64('0'), $c, [new SimpleStructTag(OuterNode, [$p[0]])]).key).eq($.copy(key))) {
        throw $.abortCode($.copy(E_NOT_HAS_KEY));
    }
    tree.root = u64('0');
    let { value: value } = pop_back_(tree.outer_nodes, $c, [new SimpleStructTag(OuterNode, [$p[0]])]);
    return value;
}
function pop_update_relationships_(tree, child_side, parent_index, $c, $p /* <V>*/) {
    let temp$1, grandparent, grandparent_index, parent, sibling_index;
    parent = borrow_$7(tree.inner_nodes, $.copy(parent_index), $c, [new SimpleStructTag(InnerNode)]);
    if (child_side == $.copy(LEFT$1)) {
        temp$1 = $.copy(parent.right_child_index);
    }
    else {
        temp$1 = $.copy(parent.left_child_index);
    }
    sibling_index = temp$1;
    grandparent_index = $.copy(parent.parent_index);
    if (is_outer_node_($.copy(sibling_index))) {
        borrow_mut_$7(tree.outer_nodes, outer_node_vector_index_($.copy(sibling_index)), $c, [
            new SimpleStructTag(OuterNode, [$p[0]])
        ]).parent_index = $.copy(grandparent_index);
    }
    else {
        borrow_mut_$7(tree.inner_nodes, $.copy(sibling_index), $c, [
            new SimpleStructTag(InnerNode)
        ]).parent_index = $.copy(grandparent_index);
    }
    if ($.copy(grandparent_index).eq($.copy(ROOT))) {
        tree.root = $.copy(sibling_index);
    }
    else {
        grandparent = borrow_mut_$7(tree.inner_nodes, $.copy(grandparent_index), $c, [
            new SimpleStructTag(InnerNode)
        ]);
        if ($.copy(grandparent.left_child_index).eq($.copy(parent_index))) {
            grandparent.left_child_index = $.copy(sibling_index);
        }
        else {
            grandparent.right_child_index = $.copy(sibling_index);
        }
    }
    return;
}
function push_back_insert_nodes_(tree, key, value, inner_index, critical_bit, parent_index, child_polarity, child_index_1, child_index_2, $c, $p /* <V>*/) {
    let temp$1, temp$2, left_child_index, right_child_index;
    if (child_polarity) {
        [temp$1, temp$2] = [$.copy(child_index_1), $.copy(child_index_2)];
    }
    else {
        [temp$1, temp$2] = [$.copy(child_index_2), $.copy(child_index_1)];
    }
    [left_child_index, right_child_index] = [temp$1, temp$2];
    push_back_(tree.outer_nodes, new OuterNode({ key: $.copy(key), value: value, parent_index: $.copy(inner_index) }, new SimpleStructTag(OuterNode, [$p[0]])), $c, [new SimpleStructTag(OuterNode, [$p[0]])]);
    push_back_(tree.inner_nodes, new InnerNode({
        critical_bit: $.copy(critical_bit),
        parent_index: $.copy(parent_index),
        left_child_index: $.copy(left_child_index),
        right_child_index: $.copy(right_child_index)
    }, new SimpleStructTag(InnerNode)), $c, [new SimpleStructTag(InnerNode)]);
    return;
}
function search_outer_(tree, key, $c, $p /* <V>*/) {
    let temp$1, temp$2, index, node, parent, side;
    parent = borrow_$7(tree.inner_nodes, $.copy(tree.root), $c, [new SimpleStructTag(InnerNode)]);
    while (true) {
        if (is_set_($.copy(key), $.copy(parent.critical_bit))) {
            [temp$1, temp$2] = [$.copy(parent.right_child_index), $.copy(RIGHT$1)];
        }
        else {
            [temp$1, temp$2] = [$.copy(parent.left_child_index), $.copy(LEFT$1)];
        }
        [index, side] = [temp$1, temp$2];
        if (is_outer_node_($.copy(index))) {
            node = borrow_$7(tree.outer_nodes, outer_node_vector_index_($.copy(index)), $c, [
                new SimpleStructTag(OuterNode, [$p[0]])
            ]);
            return [$.copy(index), side, $.copy(node.key), $.copy(node.parent_index), $.copy(parent.critical_bit)];
        }
        parent = borrow_$7(tree.inner_nodes, $.copy(index), $c, [new SimpleStructTag(InnerNode)]);
    }
}
function singleton_(key, value, $c, $p /* <V>*/) {
    let tree;
    tree = new CritBitTree({
        root: u64('0'),
        inner_nodes: empty_$5($c, [new SimpleStructTag(InnerNode)]),
        outer_nodes: empty_$5($c, [new SimpleStructTag(OuterNode, [$p[0]])])
    }, new SimpleStructTag(CritBitTree, [$p[0]]));
    insert_empty_(tree, $.copy(key), value, $c, [$p[0]]);
    return tree;
}
function stitch_child_of_parent_(tree, new_index, parent_index, old_index, $c, $p /* <V>*/) {
    let parent;
    parent = borrow_mut_$7(tree.inner_nodes, $.copy(parent_index), $c, [new SimpleStructTag(InnerNode)]);
    if ($.copy(parent.left_child_index).eq($.copy(old_index))) {
        parent.left_child_index = $.copy(new_index);
    }
    else {
        parent.right_child_index = $.copy(new_index);
    }
    return;
}
function stitch_parent_of_child_(tree, new_index, child_index, $c, $p /* <V>*/) {
    if (is_outer_node_($.copy(child_index))) {
        borrow_mut_$7(tree.outer_nodes, outer_node_vector_index_($.copy(child_index)), $c, [
            new SimpleStructTag(OuterNode, [$p[0]])
        ]).parent_index = $.copy(new_index);
    }
    else {
        borrow_mut_$7(tree.inner_nodes, $.copy(child_index), $c, [
            new SimpleStructTag(InnerNode)
        ]).parent_index = $.copy(new_index);
    }
    return;
}
function stitch_swap_remove_(tree, node_index, n_nodes, $c, $p /* <V>*/) {
    let left_child_index, node, parent_index, parent_index__1, right_child_index;
    if (is_outer_node_($.copy(node_index))) {
        parent_index = $.copy(borrow_$7(tree.outer_nodes, outer_node_vector_index_($.copy(node_index)), $c, [
            new SimpleStructTag(OuterNode, [$p[0]])
        ]).parent_index);
        if ($.copy(parent_index).eq($.copy(ROOT))) {
            tree.root = $.copy(node_index);
            return;
        }
        stitch_child_of_parent_(tree, $.copy(node_index), $.copy(parent_index), outer_node_child_index_($.copy(n_nodes).sub(u64('1'))), $c, [$p[0]]);
    }
    else {
        node = borrow_$7(tree.inner_nodes, $.copy(node_index), $c, [new SimpleStructTag(InnerNode)]);
        [parent_index__1, left_child_index, right_child_index] = [
            $.copy(node.parent_index),
            $.copy(node.left_child_index),
            $.copy(node.right_child_index)
        ];
        stitch_parent_of_child_(tree, $.copy(node_index), $.copy(left_child_index), $c, [$p[0]]);
        stitch_parent_of_child_(tree, $.copy(node_index), $.copy(right_child_index), $c, [$p[0]]);
        if ($.copy(parent_index__1).eq($.copy(ROOT))) {
            tree.root = $.copy(node_index);
            return;
        }
        stitch_child_of_parent_(tree, $.copy(node_index), $.copy(parent_index__1), $.copy(n_nodes).sub(u64('1')), $c, [
            $p[0]
        ]);
    }
    return;
}
function traverse_end_pop_(tree, parent_index, child_index, n_outer_nodes, $c, $p /* <V>*/) {
    let temp$1, node_child_side;
    if ($.copy(n_outer_nodes).eq(u64('1'))) {
        tree.root = u64('0');
        let { value: value } = pop_back_(tree.outer_nodes, $c, [new SimpleStructTag(OuterNode, [$p[0]])]);
        temp$1 = value;
    }
    else {
        node_child_side = $.copy(borrow_$7(tree.inner_nodes, $.copy(parent_index), $c, [new SimpleStructTag(InnerNode)])
            .left_child_index).eq($.copy(child_index));
        pop_update_relationships_(tree, node_child_side, $.copy(parent_index), $c, [$p[0]]);
        temp$1 = pop_destroy_nodes_(tree, $.copy(parent_index), $.copy(child_index), $.copy(n_outer_nodes), $c, [$p[0]]);
    }
    return temp$1;
}
function traverse_init_mut_(tree, direction, $c, $p /* <V>*/) {
    let temp$1, child_field_index, node;
    if (direction == $.copy(LEFT$1)) {
        temp$1 = max_node_child_index_(tree, $c, [$p[0]]);
    }
    else {
        temp$1 = min_node_child_index_(tree, $c, [$p[0]]);
    }
    child_field_index = temp$1;
    node = borrow_mut_$7(tree.outer_nodes, outer_node_vector_index_($.copy(child_field_index)), $c, [
        new SimpleStructTag(OuterNode, [$p[0]])
    ]);
    return [$.copy(node.key), node.value, $.copy(node.parent_index), $.copy(child_field_index)];
}
function traverse_mut_(tree, key, parent_index, direction, $c, $p /* <V>*/) {
    let temp$1, temp$2, temp$3, temp$4, node, target_child_index;
    [temp$1, temp$2, temp$3, temp$4] = [tree, $.copy(key), $.copy(parent_index), direction];
    target_child_index = traverse_target_child_index_(temp$1, temp$2, temp$3, temp$4, $c, [$p[0]]);
    node = borrow_mut_$7(tree.outer_nodes, outer_node_vector_index_($.copy(target_child_index)), $c, [
        new SimpleStructTag(OuterNode, [$p[0]])
    ]);
    return [$.copy(node.key), node.value, $.copy(node.parent_index), $.copy(target_child_index)];
}
function traverse_pop_mut_(tree, key, parent_index, child_index, n_outer_nodes, direction, $c, $p /* <V>*/) {
    let temp$1, temp$2, temp$3, temp$4, start_child_side, start_value, target_child_index, target_node;
    start_child_side = $.copy(borrow_$7(tree.inner_nodes, $.copy(parent_index), $c, [new SimpleStructTag(InnerNode)]).left_child_index).eq($.copy(child_index));
    [temp$1, temp$2, temp$3, temp$4] = [tree, $.copy(key), $.copy(parent_index), direction];
    target_child_index = traverse_target_child_index_(temp$1, temp$2, temp$3, temp$4, $c, [$p[0]]);
    pop_update_relationships_(tree, start_child_side, $.copy(parent_index), $c, [$p[0]]);
    start_value = pop_destroy_nodes_(tree, $.copy(parent_index), $.copy(child_index), $.copy(n_outer_nodes), $c, [$p[0]]);
    if (outer_node_vector_index_($.copy(target_child_index)).eq($.copy(n_outer_nodes).sub(u64('1')))) {
        target_child_index = $.copy(child_index);
    }
    target_node = borrow_mut_$7(tree.outer_nodes, outer_node_vector_index_($.copy(target_child_index)), $c, [new SimpleStructTag(OuterNode, [$p[0]])]);
    return [
        $.copy(target_node.key),
        target_node.value,
        $.copy(target_node.parent_index),
        $.copy(target_child_index),
        start_value
    ];
}
function traverse_predecessor_init_mut_(tree, $c, $p /* <V>*/) {
    return traverse_init_mut_(tree, $.copy(LEFT$1), $c, [$p[0]]);
}
function traverse_predecessor_mut_(tree, key, parent_index, $c, $p /* <V>*/) {
    return traverse_mut_(tree, $.copy(key), $.copy(parent_index), $.copy(LEFT$1), $c, [$p[0]]);
}
function traverse_predecessor_pop_mut_(tree, key, parent_index, child_index, n_outer_nodes, $c, $p /* <V>*/) {
    return traverse_pop_mut_(tree, $.copy(key), $.copy(parent_index), $.copy(child_index), $.copy(n_outer_nodes), $.copy(LEFT$1), $c, [$p[0]]);
}
function traverse_successor_init_mut_(tree, $c, $p /* <V>*/) {
    return traverse_init_mut_(tree, $.copy(RIGHT$1), $c, [$p[0]]);
}
function traverse_successor_mut_(tree, key, parent_index, $c, $p /* <V>*/) {
    return traverse_mut_(tree, $.copy(key), $.copy(parent_index), $.copy(RIGHT$1), $c, [$p[0]]);
}
function traverse_successor_pop_mut_(tree, key, parent_index, child_index, n_outer_nodes, $c, $p /* <V>*/) {
    return traverse_pop_mut_(tree, $.copy(key), $.copy(parent_index), $.copy(child_index), $.copy(n_outer_nodes), $.copy(RIGHT$1), $c, [$p[0]]);
}
function traverse_target_child_index_(tree, key, parent_index, direction, $c, $p /* <V>*/) {
    let temp$1, temp$2, child_index, parent;
    parent = borrow_$7(tree.inner_nodes, $.copy(parent_index), $c, [new SimpleStructTag(InnerNode)]);
    while (direction != is_set_($.copy(key), $.copy(parent.critical_bit))) {
        {
            parent = borrow_$7(tree.inner_nodes, $.copy(parent.parent_index), $c, [
                new SimpleStructTag(InnerNode)
            ]);
        }
    }
    if (direction == $.copy(LEFT$1)) {
        temp$1 = $.copy(parent.left_child_index);
    }
    else {
        temp$1 = $.copy(parent.right_child_index);
    }
    child_index = temp$1;
    while (!is_outer_node_($.copy(child_index))) {
        {
            if (direction == $.copy(LEFT$1)) {
                temp$2 = $.copy(borrow_$7(tree.inner_nodes, $.copy(child_index), $c, [new SimpleStructTag(InnerNode)])
                    .right_child_index);
            }
            else {
                temp$2 = $.copy(borrow_$7(tree.inner_nodes, $.copy(child_index), $c, [new SimpleStructTag(InnerNode)])
                    .left_child_index);
            }
            child_index = temp$2;
        }
    }
    return $.copy(child_index);
}
function loadParsers$o(repo) {
    repo.addParser('0x51d8534aba004732df9a7229f89d6d7a687ad56f8c906e482f62ee298ec7c778::critbit::CritBitTree', CritBitTree.CritBitTreeParser);
    repo.addParser('0x51d8534aba004732df9a7229f89d6d7a687ad56f8c906e482f62ee298ec7c778::critbit::InnerNode', InnerNode.InnerNodeParser);
    repo.addParser('0x51d8534aba004732df9a7229f89d6d7a687ad56f8c906e482f62ee298ec7c778::critbit::OuterNode', OuterNode.OuterNodeParser);
}
class App$p {
    constructor(client, repo, cache) {
        this.client = client;
        this.repo = repo;
        this.cache = cache;
    }
    get moduleAddress() {
        {
            return moduleAddress$i;
        }
    }
    get moduleName() {
        {
            return moduleName$i;
        }
    }
    get CritBitTree() {
        return CritBitTree;
    }
    get InnerNode() {
        return InnerNode;
    }
    get OuterNode() {
        return OuterNode;
    }
}

var Critbit = /*#__PURE__*/Object.freeze({
    __proto__: null,
    packageName: packageName$i,
    moduleAddress: moduleAddress$i,
    moduleName: moduleName$i,
    E_BIT_NOT_0_OR_1: E_BIT_NOT_0_OR_1,
    E_BORROW_EMPTY: E_BORROW_EMPTY,
    E_DESTROY_NOT_EMPTY: E_DESTROY_NOT_EMPTY,
    E_HAS_KEY: E_HAS_KEY,
    E_INSERT_FULL: E_INSERT_FULL,
    E_LOOKUP_EMPTY: E_LOOKUP_EMPTY,
    E_NOT_HAS_KEY: E_NOT_HAS_KEY,
    E_POP_EMPTY: E_POP_EMPTY,
    HI_128: HI_128,
    HI_64: HI_64$4,
    INNER: INNER,
    LEFT: LEFT$1,
    MSB_u128: MSB_u128,
    NODE_TYPE: NODE_TYPE,
    OUTER: OUTER,
    RIGHT: RIGHT$1,
    ROOT: ROOT,
    CritBitTree: CritBitTree,
    InnerNode: InnerNode,
    OuterNode: OuterNode,
    borrow_: borrow_$1,
    borrow_closest_outer_node_: borrow_closest_outer_node_,
    borrow_closest_outer_node_mut_: borrow_closest_outer_node_mut_,
    borrow_mut_: borrow_mut_$1,
    check_length_: check_length_,
    crit_bit_: crit_bit_,
    destroy_empty_: destroy_empty_,
    empty_: empty_$1,
    has_key_: has_key_,
    insert_: insert_,
    insert_above_: insert_above_,
    insert_above_root_: insert_above_root_,
    insert_below_: insert_below_,
    insert_below_walk_: insert_below_walk_,
    insert_empty_: insert_empty_,
    insert_general_: insert_general_,
    insert_singleton_: insert_singleton_,
    is_empty_: is_empty_,
    is_outer_node_: is_outer_node_,
    is_set_: is_set_,
    length_: length_,
    max_key_: max_key_,
    max_node_child_index_: max_node_child_index_,
    min_key_: min_key_,
    min_node_child_index_: min_node_child_index_,
    outer_node_child_index_: outer_node_child_index_,
    outer_node_vector_index_: outer_node_vector_index_,
    pop_: pop_,
    pop_destroy_nodes_: pop_destroy_nodes_,
    pop_general_: pop_general_,
    pop_singleton_: pop_singleton_,
    pop_update_relationships_: pop_update_relationships_,
    push_back_insert_nodes_: push_back_insert_nodes_,
    search_outer_: search_outer_,
    singleton_: singleton_,
    stitch_child_of_parent_: stitch_child_of_parent_,
    stitch_parent_of_child_: stitch_parent_of_child_,
    stitch_swap_remove_: stitch_swap_remove_,
    traverse_end_pop_: traverse_end_pop_,
    traverse_init_mut_: traverse_init_mut_,
    traverse_mut_: traverse_mut_,
    traverse_pop_mut_: traverse_pop_mut_,
    traverse_predecessor_init_mut_: traverse_predecessor_init_mut_,
    traverse_predecessor_mut_: traverse_predecessor_mut_,
    traverse_predecessor_pop_mut_: traverse_predecessor_pop_mut_,
    traverse_successor_init_mut_: traverse_successor_init_mut_,
    traverse_successor_mut_: traverse_successor_mut_,
    traverse_successor_pop_mut_: traverse_successor_pop_mut_,
    traverse_target_child_index_: traverse_target_child_index_,
    loadParsers: loadParsers$o,
    App: App$p
});

const packageName$h = 'Econia';
const moduleAddress$h = new HexString('0x51d8534aba004732df9a7229f89d6d7a687ad56f8c906e482f62ee298ec7c778');
const moduleName$h = 'open_table';
class OpenTable {
    constructor(proto, typeTag) {
        this.typeTag = typeTag;
        this.__app = null;
        this.base_table = proto['base_table'];
        this.keys = proto['keys'];
    }
    static OpenTableParser(data, typeTag, repo) {
        const proto = $.parseStructProto(data, typeTag, repo, OpenTable);
        return new OpenTable(proto, typeTag);
    }
    static makeTag($p) {
        return new StructTag(moduleAddress$h, moduleName$h, 'OpenTable', $p);
    }
    loadFullState(app) {
        return __awaiter(this, void 0, void 0, function* () {
            yield this.base_table.loadFullState(app);
            this.__app = app;
        });
    }
}
OpenTable.moduleAddress = moduleAddress$h;
OpenTable.moduleName = moduleName$h;
OpenTable.structName = 'OpenTable';
OpenTable.typeParameters = [
    { name: 'K', isPhantom: false },
    { name: 'V', isPhantom: true }
];
OpenTable.fields = [
    {
        name: 'base_table',
        typeTag: new StructTag(new HexString('0x1'), 'table', 'Table', [new $.TypeParamIdx(0), new $.TypeParamIdx(1)])
    },
    { name: 'keys', typeTag: new VectorTag(new $.TypeParamIdx(0)) }
];
function add_$1(open_table, key, value, $c, $p /* <K, V>*/) {
    add_$8(open_table.base_table, $.copy(key), value, $c, [$p[0], $p[1]]);
    push_back_(open_table.keys, $.copy(key), $c, [$p[0]]);
    return;
}
function borrow_(open_table, key, $c, $p /* <K, V>*/) {
    return borrow_$5(open_table.base_table, $.copy(key), $c, [$p[0], $p[1]]);
}
function borrow_mut_(open_table, key, $c, $p /* <K, V>*/) {
    return borrow_mut_$5(open_table.base_table, $.copy(key), $c, [$p[0], $p[1]]);
}
function contains_(open_table, key, $c, $p /* <K, V>*/) {
    return contains_$6(open_table.base_table, $.copy(key), $c, [$p[0], $p[1]]);
}
function empty_($c, $p /* <K, V>*/) {
    return new OpenTable({ base_table: new___$5($c, [$p[0], $p[1]]), keys: empty_$5($c, [$p[0]]) }, new SimpleStructTag(OpenTable, [$p[0], $p[1]]));
}
function loadParsers$n(repo) {
    repo.addParser('0x51d8534aba004732df9a7229f89d6d7a687ad56f8c906e482f62ee298ec7c778::open_table::OpenTable', OpenTable.OpenTableParser);
}
class App$o {
    constructor(client, repo, cache) {
        this.client = client;
        this.repo = repo;
        this.cache = cache;
    }
    get moduleAddress() {
        {
            return moduleAddress$h;
        }
    }
    get moduleName() {
        {
            return moduleName$h;
        }
    }
    get OpenTable() {
        return OpenTable;
    }
}

var Open_table = /*#__PURE__*/Object.freeze({
    __proto__: null,
    packageName: packageName$h,
    moduleAddress: moduleAddress$h,
    moduleName: moduleName$h,
    OpenTable: OpenTable,
    add_: add_$1,
    borrow_: borrow_,
    borrow_mut_: borrow_mut_,
    contains_: contains_,
    empty_: empty_,
    loadParsers: loadParsers$n,
    App: App$o
});

const packageName$g = 'Econia';
const moduleAddress$g = new HexString('0x51d8534aba004732df9a7229f89d6d7a687ad56f8c906e482f62ee298ec7c778');
const moduleName$g = 'order_id';
const ASK$2 = true;
const BID$2 = false;
const FIRST_64$1 = u8('64');
const HI_64$3 = u64('18446744073709551615');
function counter_ask_(order_id, $c) {
    return u64($.copy(order_id).and(u128($.copy(HI_64$3))));
}
function counter_bid_(order_id, $c) {
    return u64($.copy(order_id).and(u128($.copy(HI_64$3)))).xor($.copy(HI_64$3));
}
function order_id_(price, counter, side, $c) {
    let temp$1;
    if (side == $.copy(ASK$2)) {
        temp$1 = order_id_ask_($.copy(price), $.copy(counter));
    }
    else {
        temp$1 = order_id_bid_($.copy(price), $.copy(counter));
    }
    return temp$1;
}
function order_id_ask_(price, counter, $c) {
    return u128($.copy(price))
        .shl($.copy(FIRST_64$1))
        .or(u128($.copy(counter)));
}
function order_id_bid_(price, counter, $c) {
    return u128($.copy(price))
        .shl($.copy(FIRST_64$1))
        .or(u128($.copy(counter).xor($.copy(HI_64$3))));
}
function price_(order_id, $c) {
    return u64($.copy(order_id).shr($.copy(FIRST_64$1)));
}
function loadParsers$m(repo) { }
class App$n {
    constructor(client, repo, cache) {
        this.client = client;
        this.repo = repo;
        this.cache = cache;
    }
    get moduleAddress() {
        {
            return moduleAddress$g;
        }
    }
    get moduleName() {
        {
            return moduleName$g;
        }
    }
}

var Order_id = /*#__PURE__*/Object.freeze({
    __proto__: null,
    packageName: packageName$g,
    moduleAddress: moduleAddress$g,
    moduleName: moduleName$g,
    ASK: ASK$2,
    BID: BID$2,
    FIRST_64: FIRST_64$1,
    HI_64: HI_64$3,
    counter_ask_: counter_ask_,
    counter_bid_: counter_bid_,
    order_id_: order_id_,
    order_id_ask_: order_id_ask_,
    order_id_bid_: order_id_bid_,
    price_: price_,
    loadParsers: loadParsers$m,
    App: App$n
});

const packageName$f = 'Econia';
const moduleAddress$f = new HexString('0x51d8534aba004732df9a7229f89d6d7a687ad56f8c906e482f62ee298ec7c778');
const moduleName$f = 'registry';
const E_INVALID_BASE_ASSET = u64('10');
const E_INVALID_CUSTODIAN$1 = u64('5');
const E_INVALID_MARKET_ID = u64('9');
const E_INVALID_QUOTE_ASSET = u64('11');
const E_LOT_SIZE_0 = u64('3');
const E_MARKET_EXISTS = u64('7');
const E_NOT_ECONIA = u64('0');
const E_NOT_IN_MARKET_PAIR$1 = u64('8');
const E_NO_REGISTRY = u64('2');
const E_REGISTRY_EXISTS = u64('1');
const E_SAME_COIN = u64('6');
const E_TICK_SIZE_0 = u64('4');
const NO_CUSTODIAN$2 = u64('0');
const PURE_COIN_PAIR$2 = u64('0');
class CustodianCapability {
    constructor(proto, typeTag) {
        this.typeTag = typeTag;
        this.__app = null;
        this.custodian_id = proto['custodian_id'];
    }
    static CustodianCapabilityParser(data, typeTag, repo) {
        const proto = $.parseStructProto(data, typeTag, repo, CustodianCapability);
        return new CustodianCapability(proto, typeTag);
    }
    static getTag() {
        return new StructTag(moduleAddress$f, moduleName$f, 'CustodianCapability', []);
    }
    loadFullState(app) {
        return __awaiter(this, void 0, void 0, function* () {
            this.__app = app;
        });
    }
}
CustodianCapability.moduleAddress = moduleAddress$f;
CustodianCapability.moduleName = moduleName$f;
CustodianCapability.structName = 'CustodianCapability';
CustodianCapability.typeParameters = [];
CustodianCapability.fields = [{ name: 'custodian_id', typeTag: AtomicTypeTag.U64 }];
class GenericAsset {
    constructor(proto, typeTag) {
        this.typeTag = typeTag;
        this.__app = null;
    }
    static GenericAssetParser(data, typeTag, repo) {
        const proto = $.parseStructProto(data, typeTag, repo, GenericAsset);
        return new GenericAsset(proto, typeTag);
    }
    static getTag() {
        return new StructTag(moduleAddress$f, moduleName$f, 'GenericAsset', []);
    }
    loadFullState(app) {
        return __awaiter(this, void 0, void 0, function* () {
            this.__app = app;
        });
    }
}
GenericAsset.moduleAddress = moduleAddress$f;
GenericAsset.moduleName = moduleName$f;
GenericAsset.structName = 'GenericAsset';
GenericAsset.typeParameters = [];
GenericAsset.fields = [];
class MarketInfo {
    constructor(proto, typeTag) {
        this.typeTag = typeTag;
        this.__app = null;
        this.host = proto['host'];
        this.trading_pair_info = proto['trading_pair_info'];
    }
    static MarketInfoParser(data, typeTag, repo) {
        const proto = $.parseStructProto(data, typeTag, repo, MarketInfo);
        return new MarketInfo(proto, typeTag);
    }
    static getTag() {
        return new StructTag(moduleAddress$f, moduleName$f, 'MarketInfo', []);
    }
    loadFullState(app) {
        return __awaiter(this, void 0, void 0, function* () {
            yield this.trading_pair_info.loadFullState(app);
            this.__app = app;
        });
    }
}
MarketInfo.moduleAddress = moduleAddress$f;
MarketInfo.moduleName = moduleName$f;
MarketInfo.structName = 'MarketInfo';
MarketInfo.typeParameters = [];
MarketInfo.fields = [
    { name: 'host', typeTag: AtomicTypeTag.Address },
    {
        name: 'trading_pair_info',
        typeTag: new StructTag(new HexString('0x51d8534aba004732df9a7229f89d6d7a687ad56f8c906e482f62ee298ec7c778'), 'registry', 'TradingPairInfo', [])
    }
];
class Registry {
    constructor(proto, typeTag) {
        this.typeTag = typeTag;
        this.__app = null;
        this.hosts = proto['hosts'];
        this.markets = proto['markets'];
        this.n_custodians = proto['n_custodians'];
    }
    static RegistryParser(data, typeTag, repo) {
        const proto = $.parseStructProto(data, typeTag, repo, Registry);
        return new Registry(proto, typeTag);
    }
    static load(repo, client, address, typeParams) {
        return __awaiter(this, void 0, void 0, function* () {
            const result = yield repo.loadResource(client, address, Registry, typeParams);
            return result;
        });
    }
    static loadByApp(app, address, typeParams) {
        return __awaiter(this, void 0, void 0, function* () {
            const result = yield app.repo.loadResource(app.client, address, Registry, typeParams);
            yield result.loadFullState(app);
            return result;
        });
    }
    static getTag() {
        return new StructTag(moduleAddress$f, moduleName$f, 'Registry', []);
    }
    loadFullState(app) {
        return __awaiter(this, void 0, void 0, function* () {
            yield this.hosts.loadFullState(app);
            this.__app = app;
        });
    }
}
Registry.moduleAddress = moduleAddress$f;
Registry.moduleName = moduleName$f;
Registry.structName = 'Registry';
Registry.typeParameters = [];
Registry.fields = [
    {
        name: 'hosts',
        typeTag: new StructTag(new HexString('0x1'), 'table', 'Table', [
            new StructTag(new HexString('0x51d8534aba004732df9a7229f89d6d7a687ad56f8c906e482f62ee298ec7c778'), 'registry', 'TradingPairInfo', []),
            AtomicTypeTag.Address
        ])
    },
    {
        name: 'markets',
        typeTag: new VectorTag(new StructTag(new HexString('0x51d8534aba004732df9a7229f89d6d7a687ad56f8c906e482f62ee298ec7c778'), 'registry', 'MarketInfo', []))
    },
    { name: 'n_custodians', typeTag: AtomicTypeTag.U64 }
];
class TradingPairInfo {
    constructor(proto, typeTag) {
        this.typeTag = typeTag;
        this.__app = null;
        this.base_type_info = proto['base_type_info'];
        this.quote_type_info = proto['quote_type_info'];
        this.lot_size = proto['lot_size'];
        this.tick_size = proto['tick_size'];
        this.generic_asset_transfer_custodian_id = proto['generic_asset_transfer_custodian_id'];
        this.agnostic_disambiguator = proto['agnostic_disambiguator'];
    }
    static TradingPairInfoParser(data, typeTag, repo) {
        const proto = $.parseStructProto(data, typeTag, repo, TradingPairInfo);
        return new TradingPairInfo(proto, typeTag);
    }
    static getTag() {
        return new StructTag(moduleAddress$f, moduleName$f, 'TradingPairInfo', []);
    }
    loadFullState(app) {
        return __awaiter(this, void 0, void 0, function* () {
            yield this.base_type_info.loadFullState(app);
            yield this.quote_type_info.loadFullState(app);
            this.__app = app;
        });
    }
}
TradingPairInfo.moduleAddress = moduleAddress$f;
TradingPairInfo.moduleName = moduleName$f;
TradingPairInfo.structName = 'TradingPairInfo';
TradingPairInfo.typeParameters = [];
TradingPairInfo.fields = [
    { name: 'base_type_info', typeTag: new StructTag(new HexString('0x1'), 'type_info', 'TypeInfo', []) },
    { name: 'quote_type_info', typeTag: new StructTag(new HexString('0x1'), 'type_info', 'TypeInfo', []) },
    { name: 'lot_size', typeTag: AtomicTypeTag.U64 },
    { name: 'tick_size', typeTag: AtomicTypeTag.U64 },
    { name: 'generic_asset_transfer_custodian_id', typeTag: AtomicTypeTag.U64 },
    { name: 'agnostic_disambiguator', typeTag: AtomicTypeTag.U64 }
];
function custodian_id_(custodian_capability_ref, $c) {
    return $.copy(custodian_capability_ref.custodian_id);
}
function get_verified_market_custodian_id_(market_id, $c, $p /* <BaseType, QuoteType>*/) {
    let registry_ref, trading_pair_info_ref;
    if (!$c.exists(new SimpleStructTag(Registry), new HexString('0x51d8534aba004732df9a7229f89d6d7a687ad56f8c906e482f62ee298ec7c778'))) {
        throw $.abortCode($.copy(E_NO_REGISTRY));
    }
    registry_ref = $c.borrow_global(new SimpleStructTag(Registry), new HexString('0x51d8534aba004732df9a7229f89d6d7a687ad56f8c906e482f62ee298ec7c778'));
    if (!$.copy(market_id).lt(length_$6(registry_ref.markets, $c, [new SimpleStructTag(MarketInfo)]))) {
        throw $.abortCode($.copy(E_INVALID_MARKET_ID));
    }
    trading_pair_info_ref = borrow_$7(registry_ref.markets, $.copy(market_id), $c, [
        new SimpleStructTag(MarketInfo)
    ]).trading_pair_info;
    if (!$.deep_eq($.copy(trading_pair_info_ref.base_type_info), type_of_($c, [$p[0]]))) {
        throw $.abortCode($.copy(E_INVALID_BASE_ASSET));
    }
    if (!$.deep_eq($.copy(trading_pair_info_ref.quote_type_info), type_of_($c, [$p[1]]))) {
        throw $.abortCode($.copy(E_INVALID_QUOTE_ASSET));
    }
    return $.copy(trading_pair_info_ref.generic_asset_transfer_custodian_id);
}
function init_registry_(account, $c) {
    if (!(address_of_(account, $c).hex() ===
        new HexString('0x51d8534aba004732df9a7229f89d6d7a687ad56f8c906e482f62ee298ec7c778').hex())) {
        throw $.abortCode($.copy(E_NOT_ECONIA));
    }
    if (!!$c.exists(new SimpleStructTag(Registry), new HexString('0x51d8534aba004732df9a7229f89d6d7a687ad56f8c906e482f62ee298ec7c778'))) {
        throw $.abortCode($.copy(E_REGISTRY_EXISTS));
    }
    $c.move_to(new SimpleStructTag(Registry), account, new Registry({
        hosts: new___$5($c, [new SimpleStructTag(TradingPairInfo), AtomicTypeTag.Address]),
        markets: empty_$5($c, [new SimpleStructTag(MarketInfo)]),
        n_custodians: u64('0')
    }, new SimpleStructTag(Registry)));
    return;
}
function buildPayload_init_registry(isJSON = false) {
    const typeParamStrings = [];
    return $.buildPayload(new HexString('0x51d8534aba004732df9a7229f89d6d7a687ad56f8c906e482f62ee298ec7c778'), 'registry', 'init_registry', typeParamStrings, [], isJSON);
}
function is_base_asset_(market_info, $c, $p /* <T>*/) {
    let type_info;
    type_info = type_of_($c, [$p[0]]);
    if ($.deep_eq($.copy(type_info), $.copy(market_info.trading_pair_info.base_type_info))) {
        return true;
    }
    if ($.deep_eq($.copy(type_info), $.copy(market_info.trading_pair_info.quote_type_info))) {
        return false;
    }
    throw $.abortCode($.copy(E_NOT_IN_MARKET_PAIR$1));
}
function is_base_or_quote_(market_info, $c, $p /* <T>*/) {
    let temp$1, type_info;
    type_info = type_of_($c, [$p[0]]);
    if ($.deep_eq($.copy(type_info), $.copy(market_info.trading_pair_info.base_type_info))) {
        temp$1 = true;
    }
    else {
        temp$1 = $.deep_eq($.copy(type_info), $.copy(market_info.trading_pair_info.quote_type_info));
    }
    return temp$1;
}
function is_registered_custodian_id_(custodian_id, $c) {
    let temp$1;
    if (!$c.exists(new SimpleStructTag(Registry), new HexString('0x51d8534aba004732df9a7229f89d6d7a687ad56f8c906e482f62ee298ec7c778'))) {
        return false;
    }
    if ($.copy(custodian_id).le(n_custodians_($c))) {
        temp$1 = $.copy(custodian_id).neq($.copy(NO_CUSTODIAN$2));
    }
    else {
        temp$1 = false;
    }
    return temp$1;
}
function is_registered_trading_pair_(trading_pair_info, $c) {
    let registry_ref;
    if (!$c.exists(new SimpleStructTag(Registry), new HexString('0x51d8534aba004732df9a7229f89d6d7a687ad56f8c906e482f62ee298ec7c778'))) {
        return false;
    }
    registry_ref = $c.borrow_global(new SimpleStructTag(Registry), new HexString('0x51d8534aba004732df9a7229f89d6d7a687ad56f8c906e482f62ee298ec7c778'));
    return contains_$6(registry_ref.hosts, $.copy(trading_pair_info), $c, [
        new SimpleStructTag(TradingPairInfo),
        AtomicTypeTag.Address
    ]);
}
function n_custodians_($c) {
    if (!$c.exists(new SimpleStructTag(Registry), new HexString('0x51d8534aba004732df9a7229f89d6d7a687ad56f8c906e482f62ee298ec7c778'))) {
        throw $.abortCode($.copy(E_NO_REGISTRY));
    }
    return $.copy($c.borrow_global(new SimpleStructTag(Registry), new HexString('0x51d8534aba004732df9a7229f89d6d7a687ad56f8c906e482f62ee298ec7c778')).n_custodians);
}
function n_markets_($c) {
    if (!$c.exists(new SimpleStructTag(Registry), new HexString('0x51d8534aba004732df9a7229f89d6d7a687ad56f8c906e482f62ee298ec7c778'))) {
        throw $.abortCode($.copy(E_NO_REGISTRY));
    }
    return length_$6($c.borrow_global(new SimpleStructTag(Registry), new HexString('0x51d8534aba004732df9a7229f89d6d7a687ad56f8c906e482f62ee298ec7c778')).markets, $c, [new SimpleStructTag(MarketInfo)]);
}
function register_custodian_capability_($c) {
    let custodian_id, registry_ref_mut;
    if (!$c.exists(new SimpleStructTag(Registry), new HexString('0x51d8534aba004732df9a7229f89d6d7a687ad56f8c906e482f62ee298ec7c778'))) {
        throw $.abortCode($.copy(E_NO_REGISTRY));
    }
    registry_ref_mut = $c.borrow_global_mut(new SimpleStructTag(Registry), new HexString('0x51d8534aba004732df9a7229f89d6d7a687ad56f8c906e482f62ee298ec7c778'));
    custodian_id = $.copy(registry_ref_mut.n_custodians).add(u64('1'));
    registry_ref_mut.n_custodians = $.copy(custodian_id);
    return new CustodianCapability({ custodian_id: $.copy(custodian_id) }, new SimpleStructTag(CustodianCapability));
}
function register_market_internal_(host, lot_size, tick_size, generic_asset_transfer_custodian_id, $c, $p /* <BaseType, QuoteType>*/) {
    let temp$1, agnostic_disambiguator, base_is_coin, base_type_info, market_id, pure_coin, quote_is_coin, quote_type_info, registry_ref_mut, trading_pair_info;
    if (!$c.exists(new SimpleStructTag(Registry), new HexString('0x51d8534aba004732df9a7229f89d6d7a687ad56f8c906e482f62ee298ec7c778'))) {
        throw $.abortCode($.copy(E_NO_REGISTRY));
    }
    if (!$.copy(lot_size).gt(u64('0'))) {
        throw $.abortCode($.copy(E_LOT_SIZE_0));
    }
    if (!$.copy(tick_size).gt(u64('0'))) {
        throw $.abortCode($.copy(E_TICK_SIZE_0));
    }
    base_type_info = type_of_($c, [$p[0]]);
    quote_type_info = type_of_($c, [$p[1]]);
    base_is_coin = is_coin_initialized_($c, [$p[0]]);
    quote_is_coin = is_coin_initialized_($c, [$p[1]]);
    pure_coin = base_is_coin && quote_is_coin;
    market_id = n_markets_($c);
    if (pure_coin) {
        temp$1 = $.copy(PURE_COIN_PAIR$2);
    }
    else {
        temp$1 = $.copy(market_id);
    }
    agnostic_disambiguator = temp$1;
    trading_pair_info = new TradingPairInfo({
        base_type_info: $.copy(base_type_info),
        quote_type_info: $.copy(quote_type_info),
        lot_size: $.copy(lot_size),
        tick_size: $.copy(tick_size),
        generic_asset_transfer_custodian_id: $.copy(generic_asset_transfer_custodian_id),
        agnostic_disambiguator: $.copy(agnostic_disambiguator)
    }, new SimpleStructTag(TradingPairInfo));
    if (pure_coin) {
        if (!!$.deep_eq($.copy(base_type_info), $.copy(quote_type_info))) {
            throw $.abortCode($.copy(E_SAME_COIN));
        }
        if (!!is_registered_trading_pair_($.copy(trading_pair_info), $c)) {
            throw $.abortCode($.copy(E_MARKET_EXISTS));
        }
        if (!$.copy(generic_asset_transfer_custodian_id).eq($.copy(PURE_COIN_PAIR$2))) {
            throw $.abortCode($.copy(E_INVALID_CUSTODIAN$1));
        }
    }
    else {
        if (!is_registered_custodian_id_($.copy(generic_asset_transfer_custodian_id), $c)) {
            throw $.abortCode($.copy(E_INVALID_CUSTODIAN$1));
        }
    }
    registry_ref_mut = $c.borrow_global_mut(new SimpleStructTag(Registry), new HexString('0x51d8534aba004732df9a7229f89d6d7a687ad56f8c906e482f62ee298ec7c778'));
    add_$8(registry_ref_mut.hosts, $.copy(trading_pair_info), $.copy(host), $c, [
        new SimpleStructTag(TradingPairInfo),
        AtomicTypeTag.Address
    ]);
    push_back_(registry_ref_mut.markets, new MarketInfo({ host: $.copy(host), trading_pair_info: $.copy(trading_pair_info) }, new SimpleStructTag(MarketInfo)), $c, [new SimpleStructTag(MarketInfo)]);
    return $.copy(market_id);
}
function loadParsers$l(repo) {
    repo.addParser('0x51d8534aba004732df9a7229f89d6d7a687ad56f8c906e482f62ee298ec7c778::registry::CustodianCapability', CustodianCapability.CustodianCapabilityParser);
    repo.addParser('0x51d8534aba004732df9a7229f89d6d7a687ad56f8c906e482f62ee298ec7c778::registry::GenericAsset', GenericAsset.GenericAssetParser);
    repo.addParser('0x51d8534aba004732df9a7229f89d6d7a687ad56f8c906e482f62ee298ec7c778::registry::MarketInfo', MarketInfo.MarketInfoParser);
    repo.addParser('0x51d8534aba004732df9a7229f89d6d7a687ad56f8c906e482f62ee298ec7c778::registry::Registry', Registry.RegistryParser);
    repo.addParser('0x51d8534aba004732df9a7229f89d6d7a687ad56f8c906e482f62ee298ec7c778::registry::TradingPairInfo', TradingPairInfo.TradingPairInfoParser);
}
class App$m {
    constructor(client, repo, cache) {
        this.client = client;
        this.repo = repo;
        this.cache = cache;
    }
    get moduleAddress() {
        {
            return moduleAddress$f;
        }
    }
    get moduleName() {
        {
            return moduleName$f;
        }
    }
    get CustodianCapability() {
        return CustodianCapability;
    }
    get GenericAsset() {
        return GenericAsset;
    }
    get MarketInfo() {
        return MarketInfo;
    }
    get Registry() {
        return Registry;
    }
    loadRegistry(owner, loadFull = true, fillCache = true) {
        return __awaiter(this, void 0, void 0, function* () {
            const val = yield Registry.load(this.repo, this.client, owner, []);
            if (loadFull) {
                yield val.loadFullState(this);
            }
            if (fillCache) {
                this.cache.set(val.typeTag, owner, val);
            }
            return val;
        });
    }
    get TradingPairInfo() {
        return TradingPairInfo;
    }
    payload_init_registry(isJSON = false) {
        return buildPayload_init_registry(isJSON);
    }
    init_registry(_account, option, _isJSON = false) {
        return __awaiter(this, void 0, void 0, function* () {
            const payload__ = buildPayload_init_registry(_isJSON);
            return $.sendPayloadTx(this.client, _account, payload__, option);
        });
    }
}

var Registry$1 = /*#__PURE__*/Object.freeze({
    __proto__: null,
    packageName: packageName$f,
    moduleAddress: moduleAddress$f,
    moduleName: moduleName$f,
    E_INVALID_BASE_ASSET: E_INVALID_BASE_ASSET,
    E_INVALID_CUSTODIAN: E_INVALID_CUSTODIAN$1,
    E_INVALID_MARKET_ID: E_INVALID_MARKET_ID,
    E_INVALID_QUOTE_ASSET: E_INVALID_QUOTE_ASSET,
    E_LOT_SIZE_0: E_LOT_SIZE_0,
    E_MARKET_EXISTS: E_MARKET_EXISTS,
    E_NOT_ECONIA: E_NOT_ECONIA,
    E_NOT_IN_MARKET_PAIR: E_NOT_IN_MARKET_PAIR$1,
    E_NO_REGISTRY: E_NO_REGISTRY,
    E_REGISTRY_EXISTS: E_REGISTRY_EXISTS,
    E_SAME_COIN: E_SAME_COIN,
    E_TICK_SIZE_0: E_TICK_SIZE_0,
    NO_CUSTODIAN: NO_CUSTODIAN$2,
    PURE_COIN_PAIR: PURE_COIN_PAIR$2,
    CustodianCapability: CustodianCapability,
    GenericAsset: GenericAsset,
    MarketInfo: MarketInfo,
    Registry: Registry,
    TradingPairInfo: TradingPairInfo,
    custodian_id_: custodian_id_,
    get_verified_market_custodian_id_: get_verified_market_custodian_id_,
    init_registry_: init_registry_,
    buildPayload_init_registry: buildPayload_init_registry,
    is_base_asset_: is_base_asset_,
    is_base_or_quote_: is_base_or_quote_,
    is_registered_custodian_id_: is_registered_custodian_id_,
    is_registered_trading_pair_: is_registered_trading_pair_,
    n_custodians_: n_custodians_,
    n_markets_: n_markets_,
    register_custodian_capability_: register_custodian_capability_,
    register_market_internal_: register_market_internal_,
    loadParsers: loadParsers$l,
    App: App$m
});

const packageName$e = 'Econia';
const moduleAddress$e = new HexString('0x51d8534aba004732df9a7229f89d6d7a687ad56f8c906e482f62ee298ec7c778');
const moduleName$e = 'user';
const ASK$1 = true;
const BID$1 = false;
const COIN_ASSET_TRANSFER = u64('0');
const E_DEPOSIT_OVERFLOW_ASSET_CEILING = u64('5');
const E_EXISTS_MARKET_ACCOUNT = u64('2');
const E_NOT_COIN_ASSET = u64('13');
const E_NOT_ENOUGH_ASSET_AVAILABLE = u64('4');
const E_NOT_GENERIC_ASSET = u64('12');
const E_NOT_IN_MARKET_PAIR = u64('0');
const E_NO_MARKET_ACCOUNT = u64('3');
const E_NO_MARKET_ACCOUNTS = u64('7');
const E_NO_ORDERS = u64('15');
const E_OVERFLOW_ASSET_IN = u64('10');
const E_OVERFLOW_ASSET_OUT = u64('11');
const E_PRICE_0 = u64('9');
const E_SIZE_0 = u64('8');
const E_TICKS_OVERFLOW = u64('6');
const E_UNAUTHORIZED_CUSTODIAN = u64('14');
const E_UNREGISTERED_CUSTODIAN_ID = u64('1');
const FIRST_64 = u8('64');
const HI_64$2 = u64('18446744073709551615');
const IN = true;
const NO_CUSTODIAN$1 = u64('0');
const OUT = false;
const PURE_COIN_PAIR$1 = u64('0');
class Collateral {
    constructor(proto, typeTag) {
        this.typeTag = typeTag;
        this.__app = null;
        this.map = proto['map'];
    }
    static CollateralParser(data, typeTag, repo) {
        const proto = $.parseStructProto(data, typeTag, repo, Collateral);
        return new Collateral(proto, typeTag);
    }
    static load(repo, client, address, typeParams) {
        return __awaiter(this, void 0, void 0, function* () {
            const result = yield repo.loadResource(client, address, Collateral, typeParams);
            return result;
        });
    }
    static loadByApp(app, address, typeParams) {
        return __awaiter(this, void 0, void 0, function* () {
            const result = yield app.repo.loadResource(app.client, address, Collateral, typeParams);
            yield result.loadFullState(app);
            return result;
        });
    }
    static makeTag($p) {
        return new StructTag(moduleAddress$e, moduleName$e, 'Collateral', $p);
    }
    loadFullState(app) {
        return __awaiter(this, void 0, void 0, function* () {
            yield this.map.loadFullState(app);
            this.__app = app;
        });
    }
}
Collateral.moduleAddress = moduleAddress$e;
Collateral.moduleName = moduleName$e;
Collateral.structName = 'Collateral';
Collateral.typeParameters = [{ name: 'CoinType', isPhantom: true }];
Collateral.fields = [
    {
        name: 'map',
        typeTag: new StructTag(new HexString('0x51d8534aba004732df9a7229f89d6d7a687ad56f8c906e482f62ee298ec7c778'), 'open_table', 'OpenTable', [AtomicTypeTag.U128, new StructTag(new HexString('0x1'), 'coin', 'Coin', [new $.TypeParamIdx(0)])])
    }
];
class MarketAccount {
    constructor(proto, typeTag) {
        this.typeTag = typeTag;
        this.__app = null;
        this.base_type_info = proto['base_type_info'];
        this.quote_type_info = proto['quote_type_info'];
        this.generic_asset_transfer_custodian_id = proto['generic_asset_transfer_custodian_id'];
        this.asks = proto['asks'];
        this.bids = proto['bids'];
        this.base_total = proto['base_total'];
        this.base_available = proto['base_available'];
        this.base_ceiling = proto['base_ceiling'];
        this.quote_total = proto['quote_total'];
        this.quote_available = proto['quote_available'];
        this.quote_ceiling = proto['quote_ceiling'];
    }
    static MarketAccountParser(data, typeTag, repo) {
        const proto = $.parseStructProto(data, typeTag, repo, MarketAccount);
        return new MarketAccount(proto, typeTag);
    }
    static getTag() {
        return new StructTag(moduleAddress$e, moduleName$e, 'MarketAccount', []);
    }
    loadFullState(app) {
        return __awaiter(this, void 0, void 0, function* () {
            yield this.base_type_info.loadFullState(app);
            yield this.quote_type_info.loadFullState(app);
            yield this.asks.loadFullState(app);
            yield this.bids.loadFullState(app);
            this.__app = app;
        });
    }
}
MarketAccount.moduleAddress = moduleAddress$e;
MarketAccount.moduleName = moduleName$e;
MarketAccount.structName = 'MarketAccount';
MarketAccount.typeParameters = [];
MarketAccount.fields = [
    { name: 'base_type_info', typeTag: new StructTag(new HexString('0x1'), 'type_info', 'TypeInfo', []) },
    { name: 'quote_type_info', typeTag: new StructTag(new HexString('0x1'), 'type_info', 'TypeInfo', []) },
    { name: 'generic_asset_transfer_custodian_id', typeTag: AtomicTypeTag.U64 },
    {
        name: 'asks',
        typeTag: new StructTag(new HexString('0x51d8534aba004732df9a7229f89d6d7a687ad56f8c906e482f62ee298ec7c778'), 'critbit', 'CritBitTree', [AtomicTypeTag.U64])
    },
    {
        name: 'bids',
        typeTag: new StructTag(new HexString('0x51d8534aba004732df9a7229f89d6d7a687ad56f8c906e482f62ee298ec7c778'), 'critbit', 'CritBitTree', [AtomicTypeTag.U64])
    },
    { name: 'base_total', typeTag: AtomicTypeTag.U64 },
    { name: 'base_available', typeTag: AtomicTypeTag.U64 },
    { name: 'base_ceiling', typeTag: AtomicTypeTag.U64 },
    { name: 'quote_total', typeTag: AtomicTypeTag.U64 },
    { name: 'quote_available', typeTag: AtomicTypeTag.U64 },
    { name: 'quote_ceiling', typeTag: AtomicTypeTag.U64 }
];
class MarketAccounts {
    constructor(proto, typeTag) {
        this.typeTag = typeTag;
        this.__app = null;
        this.map = proto['map'];
    }
    static MarketAccountsParser(data, typeTag, repo) {
        const proto = $.parseStructProto(data, typeTag, repo, MarketAccounts);
        return new MarketAccounts(proto, typeTag);
    }
    static load(repo, client, address, typeParams) {
        return __awaiter(this, void 0, void 0, function* () {
            const result = yield repo.loadResource(client, address, MarketAccounts, typeParams);
            return result;
        });
    }
    static loadByApp(app, address, typeParams) {
        return __awaiter(this, void 0, void 0, function* () {
            const result = yield app.repo.loadResource(app.client, address, MarketAccounts, typeParams);
            yield result.loadFullState(app);
            return result;
        });
    }
    static getTag() {
        return new StructTag(moduleAddress$e, moduleName$e, 'MarketAccounts', []);
    }
    loadFullState(app) {
        return __awaiter(this, void 0, void 0, function* () {
            yield this.map.loadFullState(app);
            this.__app = app;
        });
    }
}
MarketAccounts.moduleAddress = moduleAddress$e;
MarketAccounts.moduleName = moduleName$e;
MarketAccounts.structName = 'MarketAccounts';
MarketAccounts.typeParameters = [];
MarketAccounts.fields = [
    {
        name: 'map',
        typeTag: new StructTag(new HexString('0x51d8534aba004732df9a7229f89d6d7a687ad56f8c906e482f62ee298ec7c778'), 'open_table', 'OpenTable', [
            AtomicTypeTag.U128,
            new StructTag(new HexString('0x51d8534aba004732df9a7229f89d6d7a687ad56f8c906e482f62ee298ec7c778'), 'user', 'MarketAccount', [])
        ])
    }
];
function borrow_transfer_fields_mixed_(market_accounts_map_ref_mut, market_account_id, $c, $p /* <AssetType>*/) {
    let asset_type_info, market_account_ref_mut;
    market_account_ref_mut = borrow_mut_(market_accounts_map_ref_mut, $.copy(market_account_id), $c, [
        AtomicTypeTag.U128,
        new SimpleStructTag(MarketAccount)
    ]);
    asset_type_info = type_of_($c, [$p[0]]);
    if ($.deep_eq($.copy(asset_type_info), $.copy(market_account_ref_mut.base_type_info))) {
        return [
            market_account_ref_mut.base_total,
            market_account_ref_mut.base_available,
            market_account_ref_mut.base_ceiling,
            market_account_ref_mut.generic_asset_transfer_custodian_id
        ];
    }
    else {
        if ($.deep_eq($.copy(asset_type_info), $.copy(market_account_ref_mut.quote_type_info))) {
            return [
                market_account_ref_mut.quote_total,
                market_account_ref_mut.quote_available,
                market_account_ref_mut.quote_ceiling,
                market_account_ref_mut.generic_asset_transfer_custodian_id
            ];
        }
    }
    throw $.abortCode($.copy(E_NOT_IN_MARKET_PAIR));
}
function deposit_asset_(user, market_account_id, amount, optional_coins, generic_asset_transfer_custodian_id, $c, $p /* <AssetType>*/) {
    let asset_available_ref_mut, asset_ceiling_ref_mut, asset_total_ref_mut, collateral_map_ref_mut, collateral_ref_mut, generic_asset_transfer_custodian_id_ref, market_accounts_map_ref_mut;
    verify_market_account_exists_($.copy(user), $.copy(market_account_id), $c);
    market_accounts_map_ref_mut = $c.borrow_global_mut(new SimpleStructTag(MarketAccounts), $.copy(user)).map;
    [asset_total_ref_mut, asset_available_ref_mut, asset_ceiling_ref_mut, generic_asset_transfer_custodian_id_ref] =
        borrow_transfer_fields_mixed_(market_accounts_map_ref_mut, $.copy(market_account_id), $c, [$p[0]]);
    if (!!u128($.copy(asset_ceiling_ref_mut))
        .add(u128($.copy(amount)))
        .gt(u128($.copy(HI_64$2)))) {
        throw $.abortCode($.copy(E_DEPOSIT_OVERFLOW_ASSET_CEILING));
    }
    $.set(asset_total_ref_mut, $.copy(asset_total_ref_mut).add($.copy(amount)));
    $.set(asset_available_ref_mut, $.copy(asset_available_ref_mut).add($.copy(amount)));
    $.set(asset_ceiling_ref_mut, $.copy(asset_ceiling_ref_mut).add($.copy(amount)));
    if (is_some_(optional_coins, $c, [new StructTag(new HexString('0x1'), 'coin', 'Coin', [$p[0]])])) {
        collateral_map_ref_mut = $c.borrow_global_mut(new SimpleStructTag(Collateral, [$p[0]]), $.copy(user)).map;
        collateral_ref_mut = borrow_mut_(collateral_map_ref_mut, $.copy(market_account_id), $c, [
            AtomicTypeTag.U128,
            new StructTag(new HexString('0x1'), 'coin', 'Coin', [$p[0]])
        ]);
        merge_(collateral_ref_mut, destroy_some_(optional_coins, $c, [new StructTag(new HexString('0x1'), 'coin', 'Coin', [$p[0]])]), $c, [$p[0]]);
    }
    else {
        if (!$.copy(generic_asset_transfer_custodian_id).eq($.copy(generic_asset_transfer_custodian_id_ref))) {
            throw $.abortCode($.copy(E_UNAUTHORIZED_CUSTODIAN));
        }
        destroy_none_(optional_coins, $c, [new StructTag(new HexString('0x1'), 'coin', 'Coin', [$p[0]])]);
    }
    return;
}
function deposit_asset_as_option_internal_(user, market_account_id, amount, optional_coins, generic_asset_transfer_custodian_id, $c, $p /* <AssetType>*/) {
    return deposit_asset_($.copy(user), $.copy(market_account_id), $.copy(amount), optional_coins, $.copy(generic_asset_transfer_custodian_id), $c, [$p[0]]);
}
function deposit_assets_as_option_internal_(user, market_account_id, base_amount, quote_amount, optional_base_coins, optional_quote_coins, generic_asset_transfer_custodian_id, $c, $p /* <BaseType, QuoteType>*/) {
    deposit_asset_as_option_internal_($.copy(user), $.copy(market_account_id), $.copy(base_amount), optional_base_coins, $.copy(generic_asset_transfer_custodian_id), $c, [$p[0]]);
    deposit_asset_as_option_internal_($.copy(user), $.copy(market_account_id), $.copy(quote_amount), optional_quote_coins, $.copy(generic_asset_transfer_custodian_id), $c, [$p[1]]);
    return;
}
function deposit_coins_(user, market_id, general_custodian_id, coins, $c, $p /* <CoinType>*/) {
    return deposit_asset_($.copy(user), get_market_account_id_($.copy(market_id), $.copy(general_custodian_id)), value_(coins, $c, [$p[0]]), some_(coins, $c, [new StructTag(new HexString('0x1'), 'coin', 'Coin', [$p[0]])]), $.copy(COIN_ASSET_TRANSFER), $c, [$p[0]]);
}
function deposit_from_coinstore_(user, market_id, general_custodian_id, amount, $c, $p /* <CoinType>*/) {
    return deposit_coins_(address_of_(user, $c), $.copy(market_id), $.copy(general_custodian_id), withdraw_$1(user, $.copy(amount), $c, [$p[0]]), $c, [$p[0]]);
}
function buildPayload_deposit_from_coinstore(market_id, general_custodian_id, amount, $p /* <CoinType>*/, isJSON = false) {
    const typeParamStrings = $p.map((t) => $.getTypeTagFullname(t));
    return $.buildPayload(new HexString('0x51d8534aba004732df9a7229f89d6d7a687ad56f8c906e482f62ee298ec7c778'), 'user', 'deposit_from_coinstore', typeParamStrings, [market_id, general_custodian_id, amount], isJSON);
}
function deposit_generic_asset_(user, market_id, general_custodian_id, amount, generic_asset_transfer_custodian_capability_ref, $c, $p /* <AssetType>*/) {
    let generic_asset_transfer_custodian_id;
    if (!!is_coin_initialized_($c, [$p[0]])) {
        throw $.abortCode($.copy(E_NOT_GENERIC_ASSET));
    }
    generic_asset_transfer_custodian_id = custodian_id_(generic_asset_transfer_custodian_capability_ref);
    return deposit_asset_($.copy(user), get_market_account_id_($.copy(market_id), $.copy(general_custodian_id)), $.copy(amount), none_($c, [new StructTag(new HexString('0x1'), 'coin', 'Coin', [$p[0]])]), $.copy(generic_asset_transfer_custodian_id), $c, [$p[0]]);
}
function fill_order_internal_(user, market_account_id, side, order_id, complete_fill, fill_size, optional_base_coins_ref_mut, optional_quote_coins_ref_mut, base_to_route, quote_to_route, $c, $p /* <BaseType, QuoteType>*/) {
    fill_order_update_market_account_($.copy(user), $.copy(market_account_id), side, $.copy(order_id), complete_fill, $.copy(fill_size), $.copy(base_to_route), $.copy(quote_to_route), $c);
    fill_order_route_collateral_($.copy(user), $.copy(market_account_id), side, optional_base_coins_ref_mut, optional_quote_coins_ref_mut, $.copy(base_to_route), $.copy(quote_to_route), $c, [$p[0], $p[1]]);
    return;
}
function fill_order_route_collateral_(user, market_account_id, side, optional_base_coins_ref_mut, optional_quote_coins_ref_mut, base_to_route, quote_to_route, $c, $p /* <BaseType, QuoteType>*/) {
    let temp$1, temp$2, base_direction, quote_direction;
    if (side == $.copy(ASK$1)) {
        [temp$1, temp$2] = [$.copy(OUT), $.copy(IN)];
    }
    else {
        [temp$1, temp$2] = [$.copy(IN), $.copy(OUT)];
    }
    [base_direction, quote_direction] = [temp$1, temp$2];
    if (is_some_(optional_base_coins_ref_mut, $c, [
        new StructTag(new HexString('0x1'), 'coin', 'Coin', [$p[0]])
    ])) {
        fill_order_route_collateral_single_($.copy(user), $.copy(market_account_id), borrow_mut_$6(optional_base_coins_ref_mut, $c, [
            new StructTag(new HexString('0x1'), 'coin', 'Coin', [$p[0]])
        ]), $.copy(base_to_route), base_direction, $c, [$p[0]]);
    }
    if (is_some_(optional_quote_coins_ref_mut, $c, [
        new StructTag(new HexString('0x1'), 'coin', 'Coin', [$p[1]])
    ])) {
        fill_order_route_collateral_single_($.copy(user), $.copy(market_account_id), borrow_mut_$6(optional_quote_coins_ref_mut, $c, [
            new StructTag(new HexString('0x1'), 'coin', 'Coin', [$p[1]])
        ]), $.copy(quote_to_route), quote_direction, $c, [$p[1]]);
    }
    return;
}
function fill_order_route_collateral_single_(user, market_account_id, external_coins_ref_mut, amount, direction, $c, $p /* <CoinType>*/) {
    let collateral_map_ref_mut, collateral_ref_mut;
    collateral_map_ref_mut = $c.borrow_global_mut(new SimpleStructTag(Collateral, [$p[0]]), $.copy(user)).map;
    collateral_ref_mut = borrow_mut_(collateral_map_ref_mut, $.copy(market_account_id), $c, [
        AtomicTypeTag.U128,
        new StructTag(new HexString('0x1'), 'coin', 'Coin', [$p[0]])
    ]);
    if (direction == $.copy(IN)) {
        merge_(collateral_ref_mut, extract_(external_coins_ref_mut, $.copy(amount), $c, [$p[0]]), $c, [$p[0]]);
    }
    else {
        merge_(external_coins_ref_mut, extract_(collateral_ref_mut, $.copy(amount), $c, [$p[0]]), $c, [$p[0]]);
    }
    return;
}
function fill_order_update_market_account_(user, market_account_id, side, order_id, complete_fill, fill_size, base_to_route, quote_to_route, $c) {
    let temp$1, temp$2, temp$3, temp$4, temp$5, temp$6, temp$7, asset_in, asset_in_available_ref_mut, asset_in_total_ref_mut, asset_out, asset_out_ceiling_ref_mut, asset_out_total_ref_mut, market_account_ref_mut, market_accounts_map_ref_mut, order_size_ref_mut, tree_ref_mut;
    market_accounts_map_ref_mut = $c.borrow_global_mut(new SimpleStructTag(MarketAccounts), $.copy(user)).map;
    market_account_ref_mut = borrow_mut_(market_accounts_map_ref_mut, $.copy(market_account_id), $c, [
        AtomicTypeTag.U128,
        new SimpleStructTag(MarketAccount)
    ]);
    if (side == $.copy(ASK$1)) {
        [temp$1, temp$2, temp$3, temp$4, temp$5, temp$6, temp$7] = [
            market_account_ref_mut.asks,
            $.copy(quote_to_route),
            market_account_ref_mut.quote_total,
            market_account_ref_mut.quote_available,
            $.copy(base_to_route),
            market_account_ref_mut.base_total,
            market_account_ref_mut.base_ceiling
        ];
    }
    else {
        [temp$1, temp$2, temp$3, temp$4, temp$5, temp$6, temp$7] = [
            market_account_ref_mut.bids,
            $.copy(base_to_route),
            market_account_ref_mut.base_total,
            market_account_ref_mut.base_available,
            $.copy(quote_to_route),
            market_account_ref_mut.quote_total,
            market_account_ref_mut.quote_ceiling
        ];
    }
    [
        tree_ref_mut,
        asset_in,
        asset_in_total_ref_mut,
        asset_in_available_ref_mut,
        asset_out,
        asset_out_total_ref_mut,
        asset_out_ceiling_ref_mut
    ] = [temp$1, temp$2, temp$3, temp$4, temp$5, temp$6, temp$7];
    if (complete_fill) {
        pop_(tree_ref_mut, $.copy(order_id), $c, [AtomicTypeTag.U64]);
    }
    else {
        order_size_ref_mut = borrow_mut_$1(tree_ref_mut, $.copy(order_id), $c, [AtomicTypeTag.U64]);
        $.set(order_size_ref_mut, $.copy(order_size_ref_mut).sub($.copy(fill_size)));
    }
    $.set(asset_in_total_ref_mut, $.copy(asset_in_total_ref_mut).add($.copy(asset_in)));
    $.set(asset_in_available_ref_mut, $.copy(asset_in_available_ref_mut).add($.copy(asset_in)));
    $.set(asset_out_total_ref_mut, $.copy(asset_out_total_ref_mut).sub($.copy(asset_out)));
    $.set(asset_out_ceiling_ref_mut, $.copy(asset_out_ceiling_ref_mut).sub($.copy(asset_out)));
    return;
}
function get_asset_counts_(user, market_account_id, $c) {
    let market_account_ref, market_accounts_map_ref;
    verify_market_account_exists_($.copy(user), $.copy(market_account_id), $c);
    market_accounts_map_ref = $c.borrow_global(new SimpleStructTag(MarketAccounts), $.copy(user)).map;
    market_account_ref = borrow_(market_accounts_map_ref, $.copy(market_account_id), $c, [
        AtomicTypeTag.U128,
        new SimpleStructTag(MarketAccount)
    ]);
    return [
        $.copy(market_account_ref.base_total),
        $.copy(market_account_ref.base_available),
        $.copy(market_account_ref.base_ceiling),
        $.copy(market_account_ref.quote_total),
        $.copy(market_account_ref.quote_available),
        $.copy(market_account_ref.quote_ceiling)
    ];
}
function get_asset_counts_custodian_(user, market_id, general_custodian_capability_ref, $c) {
    return get_asset_counts_($.copy(user), get_market_account_id_($.copy(market_id), custodian_id_(general_custodian_capability_ref)), $c);
}
function get_asset_counts_internal_(user, market_account_id, $c) {
    return get_asset_counts_($.copy(user), $.copy(market_account_id), $c);
}
function get_asset_counts_user_(user, market_id, $c) {
    return get_asset_counts_(address_of_(user, $c), get_market_account_id_($.copy(market_id), $.copy(NO_CUSTODIAN$1)), $c);
}
function get_general_custodian_id_(market_account_id, $c) {
    return u64($.copy(market_account_id).and(u128($.copy(HI_64$2))));
}
function get_market_account_id_(market_id, general_custodian_id, $c) {
    return u128($.copy(market_id))
        .shl($.copy(FIRST_64))
        .or(u128($.copy(general_custodian_id)));
}
function get_market_id_(market_account_id, $c) {
    return u64($.copy(market_account_id).shr($.copy(FIRST_64)));
}
function get_n_orders_internal_(user, market_account_id, side, $c) {
    let temp$1, market_account_ref, market_accounts_map_ref, tree_ref;
    verify_market_account_exists_($.copy(user), $.copy(market_account_id), $c);
    market_accounts_map_ref = $c.borrow_global(new SimpleStructTag(MarketAccounts), $.copy(user)).map;
    market_account_ref = borrow_(market_accounts_map_ref, $.copy(market_account_id), $c, [
        AtomicTypeTag.U128,
        new SimpleStructTag(MarketAccount)
    ]);
    if (side == $.copy(ASK$1)) {
        temp$1 = market_account_ref.asks;
    }
    else {
        temp$1 = market_account_ref.bids;
    }
    tree_ref = temp$1;
    return length_(tree_ref, $c, [AtomicTypeTag.U64]);
}
function get_order_id_nearest_spread_internal_(user, market_account_id, side, $c) {
    let temp$1, temp$2, market_account_ref, market_accounts_map_ref, tree_ref;
    verify_market_account_exists_($.copy(user), $.copy(market_account_id), $c);
    market_accounts_map_ref = $c.borrow_global(new SimpleStructTag(MarketAccounts), $.copy(user)).map;
    market_account_ref = borrow_(market_accounts_map_ref, $.copy(market_account_id), $c, [
        AtomicTypeTag.U128,
        new SimpleStructTag(MarketAccount)
    ]);
    if (side == $.copy(ASK$1)) {
        temp$1 = market_account_ref.asks;
    }
    else {
        temp$1 = market_account_ref.bids;
    }
    tree_ref = temp$1;
    if (!!is_empty_(tree_ref, $c, [AtomicTypeTag.U64])) {
        throw $.abortCode($.copy(E_NO_ORDERS));
    }
    if (side == $.copy(ASK$1)) {
        temp$2 = min_key_(tree_ref, $c, [AtomicTypeTag.U64]);
    }
    else {
        temp$2 = max_key_(tree_ref, $c, [AtomicTypeTag.U64]);
    }
    return temp$2;
}
function range_check_new_order_(side, size, price, lot_size, tick_size, in_asset_ceiling, out_asset_available, $c) {
    let temp$1, temp$2, base_fill, in_asset_fill, out_asset_fill, quote_fill, ticks;
    if (!$.copy(size).gt(u64('0'))) {
        throw $.abortCode($.copy(E_SIZE_0));
    }
    if (!$.copy(price).gt(u64('0'))) {
        throw $.abortCode($.copy(E_PRICE_0));
    }
    base_fill = u128($.copy(size)).mul(u128($.copy(lot_size)));
    ticks = u128($.copy(size)).mul(u128($.copy(price)));
    if (!!$.copy(ticks).gt(u128($.copy(HI_64$2)))) {
        throw $.abortCode($.copy(E_TICKS_OVERFLOW));
    }
    quote_fill = $.copy(ticks).mul(u128($.copy(tick_size)));
    if (side == $.copy(ASK$1)) {
        [temp$1, temp$2] = [$.copy(quote_fill), $.copy(base_fill)];
    }
    else {
        [temp$1, temp$2] = [$.copy(base_fill), $.copy(quote_fill)];
    }
    [in_asset_fill, out_asset_fill] = [temp$1, temp$2];
    if (!!$.copy(in_asset_fill)
        .add(u128($.copy(in_asset_ceiling)))
        .gt(u128($.copy(HI_64$2)))) {
        throw $.abortCode($.copy(E_OVERFLOW_ASSET_IN));
    }
    if (!!$.copy(out_asset_fill).gt(u128($.copy(HI_64$2)))) {
        throw $.abortCode($.copy(E_OVERFLOW_ASSET_OUT));
    }
    if (!!$.copy(out_asset_fill).gt(u128($.copy(out_asset_available)))) {
        throw $.abortCode($.copy(E_NOT_ENOUGH_ASSET_AVAILABLE));
    }
    return [u64($.copy(in_asset_fill)), u64($.copy(out_asset_fill))];
}
function register_collateral_entry_(user, market_account_id, $c, $p /* <CoinType>*/) {
    let temp$1, temp$2, collateral_map_ref_mut, user_address;
    user_address = address_of_(user, $c);
    if (!$c.exists(new SimpleStructTag(Collateral, [$p[0]]), $.copy(user_address))) {
        $c.move_to(new SimpleStructTag(Collateral, [$p[0]]), user, new Collateral({
            map: empty_($c, [AtomicTypeTag.U128, new StructTag(new HexString('0x1'), 'coin', 'Coin', [$p[0]])])
        }, new SimpleStructTag(Collateral, [$p[0]])));
    }
    collateral_map_ref_mut = $c.borrow_global_mut(new SimpleStructTag(Collateral, [$p[0]]), $.copy(user_address)).map;
    [temp$1, temp$2] = [collateral_map_ref_mut, $.copy(market_account_id)];
    if (!!contains_(temp$1, temp$2, $c, [
        AtomicTypeTag.U128,
        new StructTag(new HexString('0x1'), 'coin', 'Coin', [$p[0]])
    ])) {
        throw $.abortCode($.copy(E_EXISTS_MARKET_ACCOUNT));
    }
    add_$1(collateral_map_ref_mut, $.copy(market_account_id), zero_$1($c, [$p[0]]), $c, [
        AtomicTypeTag.U128,
        new StructTag(new HexString('0x1'), 'coin', 'Coin', [$p[0]])
    ]);
    return;
}
function register_market_account_(user, market_id, general_custodian_id, $c, $p /* <BaseType, QuoteType>*/) {
    let market_account_id;
    if ($.copy(general_custodian_id).neq($.copy(NO_CUSTODIAN$1))) {
        if (!is_registered_custodian_id_($.copy(general_custodian_id), $c)) {
            throw $.abortCode($.copy(E_UNREGISTERED_CUSTODIAN_ID));
        }
    }
    market_account_id = get_market_account_id_($.copy(market_id), $.copy(general_custodian_id));
    register_market_accounts_entry_(user, $.copy(market_account_id), $c, [$p[0], $p[1]]);
    if (is_coin_initialized_($c, [$p[0]])) {
        register_collateral_entry_(user, $.copy(market_account_id), $c, [$p[0]]);
    }
    if (is_coin_initialized_($c, [$p[1]])) {
        register_collateral_entry_(user, $.copy(market_account_id), $c, [$p[1]]);
    }
    return;
}
function buildPayload_register_market_account(market_id, general_custodian_id, $p /* <BaseType, QuoteType>*/, isJSON = false) {
    const typeParamStrings = $p.map((t) => $.getTypeTagFullname(t));
    return $.buildPayload(new HexString('0x51d8534aba004732df9a7229f89d6d7a687ad56f8c906e482f62ee298ec7c778'), 'user', 'register_market_account', typeParamStrings, [market_id, general_custodian_id], isJSON);
}
function register_market_accounts_entry_(user, market_account_id, $c, $p /* <BaseType, QuoteType>*/) {
    let temp$1, temp$2, generic_asset_transfer_custodian_id, market_accounts_map_ref_mut, user_address;
    generic_asset_transfer_custodian_id = get_verified_market_custodian_id_(get_market_id_($.copy(market_account_id)), $c, [$p[0], $p[1]]);
    user_address = address_of_(user, $c);
    if (!$c.exists(new SimpleStructTag(MarketAccounts), $.copy(user_address))) {
        $c.move_to(new SimpleStructTag(MarketAccounts), user, new MarketAccounts({ map: empty_($c, [AtomicTypeTag.U128, new SimpleStructTag(MarketAccount)]) }, new SimpleStructTag(MarketAccounts)));
    }
    market_accounts_map_ref_mut = $c.borrow_global_mut(new SimpleStructTag(MarketAccounts), $.copy(user_address)).map;
    [temp$1, temp$2] = [market_accounts_map_ref_mut, $.copy(market_account_id)];
    if (!!contains_(temp$1, temp$2, $c, [AtomicTypeTag.U128, new SimpleStructTag(MarketAccount)])) {
        throw $.abortCode($.copy(E_EXISTS_MARKET_ACCOUNT));
    }
    add_$1(market_accounts_map_ref_mut, $.copy(market_account_id), new MarketAccount({
        base_type_info: type_of_($c, [$p[0]]),
        quote_type_info: type_of_($c, [$p[1]]),
        generic_asset_transfer_custodian_id: $.copy(generic_asset_transfer_custodian_id),
        asks: empty_$1($c, [AtomicTypeTag.U64]),
        bids: empty_$1($c, [AtomicTypeTag.U64]),
        base_total: u64('0'),
        base_available: u64('0'),
        base_ceiling: u64('0'),
        quote_total: u64('0'),
        quote_available: u64('0'),
        quote_ceiling: u64('0')
    }, new SimpleStructTag(MarketAccount)), $c, [AtomicTypeTag.U128, new SimpleStructTag(MarketAccount)]);
    return;
}
function register_order_internal_(user, market_account_id, side, order_id, size, price, lot_size, tick_size, $c) {
    let temp$1, temp$2, temp$3, in_asset_ceiling_ref_mut, in_asset_fill, market_account_ref_mut, market_accounts_map_ref_mut, out_asset_available_ref_mut, out_asset_fill, tree_ref_mut;
    verify_market_account_exists_($.copy(user), $.copy(market_account_id), $c);
    market_accounts_map_ref_mut = $c.borrow_global_mut(new SimpleStructTag(MarketAccounts), $.copy(user)).map;
    market_account_ref_mut = borrow_mut_(market_accounts_map_ref_mut, $.copy(market_account_id), $c, [
        AtomicTypeTag.U128,
        new SimpleStructTag(MarketAccount)
    ]);
    if (side == $.copy(ASK$1)) {
        [temp$1, temp$2, temp$3] = [
            market_account_ref_mut.asks,
            market_account_ref_mut.quote_ceiling,
            market_account_ref_mut.base_available
        ];
    }
    else {
        [temp$1, temp$2, temp$3] = [
            market_account_ref_mut.bids,
            market_account_ref_mut.base_ceiling,
            market_account_ref_mut.quote_available
        ];
    }
    [tree_ref_mut, in_asset_ceiling_ref_mut, out_asset_available_ref_mut] = [temp$1, temp$2, temp$3];
    [in_asset_fill, out_asset_fill] = range_check_new_order_(side, $.copy(size), $.copy(price), $.copy(lot_size), $.copy(tick_size), $.copy(in_asset_ceiling_ref_mut), $.copy(out_asset_available_ref_mut));
    insert_(tree_ref_mut, $.copy(order_id), $.copy(size), $c, [AtomicTypeTag.U64]);
    $.set(in_asset_ceiling_ref_mut, $.copy(in_asset_ceiling_ref_mut).add($.copy(in_asset_fill)));
    $.set(out_asset_available_ref_mut, $.copy(out_asset_available_ref_mut).sub($.copy(out_asset_fill)));
    return;
}
function remove_order_internal_(user, market_account_id, lot_size, tick_size, side, order_id, $c) {
    let temp$1, temp$2, temp$3, temp$4, temp$5, asset_available_ref_mut, asset_ceiling_ref_mut, ceiling_decrement_amount, market_account_ref_mut, market_accounts_map_ref_mut, size, size_multiplier_available, size_multiplier_ceiling, tree_ref_mut, unlocked;
    market_accounts_map_ref_mut = $c.borrow_global_mut(new SimpleStructTag(MarketAccounts), $.copy(user)).map;
    market_account_ref_mut = borrow_mut_(market_accounts_map_ref_mut, $.copy(market_account_id), $c, [
        AtomicTypeTag.U128,
        new SimpleStructTag(MarketAccount)
    ]);
    if (side == $.copy(ASK$1)) {
        [temp$1, temp$2, temp$3, temp$4, temp$5] = [
            market_account_ref_mut.asks,
            market_account_ref_mut.base_available,
            market_account_ref_mut.quote_ceiling,
            $.copy(lot_size),
            price_($.copy(order_id)).mul($.copy(tick_size))
        ];
    }
    else {
        [temp$1, temp$2, temp$3, temp$4, temp$5] = [
            market_account_ref_mut.bids,
            market_account_ref_mut.quote_available,
            market_account_ref_mut.base_ceiling,
            price_($.copy(order_id)).mul($.copy(tick_size)),
            $.copy(lot_size)
        ];
    }
    [tree_ref_mut, asset_available_ref_mut, asset_ceiling_ref_mut, size_multiplier_available, size_multiplier_ceiling] = [
        temp$1,
        temp$2,
        temp$3,
        temp$4,
        temp$5
    ];
    size = pop_(tree_ref_mut, $.copy(order_id), $c, [AtomicTypeTag.U64]);
    unlocked = $.copy(size).mul($.copy(size_multiplier_available));
    $.set(asset_available_ref_mut, $.copy(asset_available_ref_mut).add($.copy(unlocked)));
    ceiling_decrement_amount = $.copy(size).mul($.copy(size_multiplier_ceiling));
    $.set(asset_ceiling_ref_mut, $.copy(asset_ceiling_ref_mut).sub($.copy(ceiling_decrement_amount)));
    return;
}
function verify_market_account_exists_(user, market_account_id, $c) {
    let market_accounts_map_ref;
    if (!$c.exists(new SimpleStructTag(MarketAccounts), $.copy(user))) {
        throw $.abortCode($.copy(E_NO_MARKET_ACCOUNTS));
    }
    market_accounts_map_ref = $c.borrow_global(new SimpleStructTag(MarketAccounts), $.copy(user)).map;
    if (!contains_(market_accounts_map_ref, $.copy(market_account_id), $c, [
        AtomicTypeTag.U128,
        new SimpleStructTag(MarketAccount)
    ])) {
        throw $.abortCode($.copy(E_NO_MARKET_ACCOUNT));
    }
    return;
}
function withdraw_asset_(user, market_account_id, amount, asset_is_coin, generic_asset_transfer_custodian_id, $c, $p /* <AssetType>*/) {
    let asset_available_ref_mut, asset_ceiling_ref_mut, asset_total_ref_mut, collateral_map_ref_mut, collateral_ref_mut, generic_asset_transfer_custodian_id_ref, market_accounts_map_ref_mut;
    verify_market_account_exists_($.copy(user), $.copy(market_account_id), $c);
    market_accounts_map_ref_mut = $c.borrow_global_mut(new SimpleStructTag(MarketAccounts), $.copy(user)).map;
    [asset_total_ref_mut, asset_available_ref_mut, asset_ceiling_ref_mut, generic_asset_transfer_custodian_id_ref] =
        borrow_transfer_fields_mixed_(market_accounts_map_ref_mut, $.copy(market_account_id), $c, [$p[0]]);
    if (!!$.copy(amount).gt($.copy(asset_available_ref_mut))) {
        throw $.abortCode($.copy(E_NOT_ENOUGH_ASSET_AVAILABLE));
    }
    $.set(asset_total_ref_mut, $.copy(asset_total_ref_mut).sub($.copy(amount)));
    $.set(asset_available_ref_mut, $.copy(asset_available_ref_mut).sub($.copy(amount)));
    $.set(asset_ceiling_ref_mut, $.copy(asset_ceiling_ref_mut).sub($.copy(amount)));
    if (asset_is_coin) {
        collateral_map_ref_mut = $c.borrow_global_mut(new SimpleStructTag(Collateral, [$p[0]]), $.copy(user)).map;
        collateral_ref_mut = borrow_mut_(collateral_map_ref_mut, $.copy(market_account_id), $c, [
            AtomicTypeTag.U128,
            new StructTag(new HexString('0x1'), 'coin', 'Coin', [$p[0]])
        ]);
        return some_(extract_(collateral_ref_mut, $.copy(amount), $c, [$p[0]]), $c, [
            new StructTag(new HexString('0x1'), 'coin', 'Coin', [$p[0]])
        ]);
    }
    else {
        if (!$.copy(generic_asset_transfer_custodian_id).eq($.copy(generic_asset_transfer_custodian_id_ref))) {
            throw $.abortCode($.copy(E_UNAUTHORIZED_CUSTODIAN));
        }
        return none_($c, [new StructTag(new HexString('0x1'), 'coin', 'Coin', [$p[0]])]);
    }
}
function withdraw_asset_as_option_internal_(user, market_account_id, amount, generic_asset_transfer_custodian_id, $c, $p /* <AssetType>*/) {
    return withdraw_asset_($.copy(user), $.copy(market_account_id), $.copy(amount), is_coin_initialized_($c, [$p[0]]), $.copy(generic_asset_transfer_custodian_id), $c, [$p[0]]);
}
function withdraw_assets_as_option_internal_(user, market_account_id, base_amount, quote_amount, generic_asset_transfer_custodian_id, $c, $p /* <BaseType, QuoteType>*/) {
    return [
        withdraw_asset_($.copy(user), $.copy(market_account_id), $.copy(base_amount), is_coin_initialized_($c, [$p[0]]), $.copy(generic_asset_transfer_custodian_id), $c, [$p[0]]),
        withdraw_asset_($.copy(user), $.copy(market_account_id), $.copy(quote_amount), is_coin_initialized_($c, [$p[1]]), $.copy(generic_asset_transfer_custodian_id), $c, [$p[1]])
    ];
}
function withdraw_coins_(user, market_id, general_custodian_id, amount, $c, $p /* <CoinType>*/) {
    let market_account_id, option_coins;
    if (!is_coin_initialized_($c, [$p[0]])) {
        throw $.abortCode($.copy(E_NOT_COIN_ASSET));
    }
    market_account_id = get_market_account_id_($.copy(market_id), $.copy(general_custodian_id));
    option_coins = withdraw_asset_($.copy(user), $.copy(market_account_id), $.copy(amount), true, $.copy(COIN_ASSET_TRANSFER), $c, [$p[0]]);
    return destroy_some_(option_coins, $c, [new StructTag(new HexString('0x1'), 'coin', 'Coin', [$p[0]])]);
}
function withdraw_coins_as_option_internal_(user, market_account_id, amount, $c, $p /* <CoinType>*/) {
    return withdraw_asset_($.copy(user), $.copy(market_account_id), $.copy(amount), true, $.copy(COIN_ASSET_TRANSFER), $c, [$p[0]]);
}
function withdraw_coins_custodian_(user, market_id, amount, general_custodian_capability_ref, $c, $p /* <CoinType>*/) {
    return withdraw_coins_($.copy(user), $.copy(market_id), custodian_id_(general_custodian_capability_ref), $.copy(amount), $c, [$p[0]]);
}
function withdraw_coins_user_(user, market_id, amount, $c, $p /* <CoinType>*/) {
    return withdraw_coins_(address_of_(user, $c), $.copy(market_id), $.copy(NO_CUSTODIAN$1), $.copy(amount), $c, [$p[0]]);
}
function withdraw_generic_asset_(user, market_id, general_custodian_id, amount, generic_asset_transfer_custodian_capability_ref, $c, $p /* <AssetType>*/) {
    let empty_option, generic_asset_transfer_custodian_id, market_account_id;
    if (!!is_coin_initialized_($c, [$p[0]])) {
        throw $.abortCode($.copy(E_NOT_GENERIC_ASSET));
    }
    generic_asset_transfer_custodian_id = custodian_id_(generic_asset_transfer_custodian_capability_ref);
    market_account_id = get_market_account_id_($.copy(market_id), $.copy(general_custodian_id));
    empty_option = withdraw_asset_($.copy(user), $.copy(market_account_id), $.copy(amount), false, $.copy(generic_asset_transfer_custodian_id), $c, [$p[0]]);
    destroy_none_(empty_option, $c, [new StructTag(new HexString('0x1'), 'coin', 'Coin', [$p[0]])]);
    return;
}
function withdraw_to_coinstore_(user, market_id, amount, $c, $p /* <CoinType>*/) {
    let coins;
    coins = withdraw_coins_user_(user, $.copy(market_id), $.copy(amount), $c, [$p[0]]);
    deposit_$1(address_of_(user, $c), coins, $c, [$p[0]]);
    return;
}
function buildPayload_withdraw_to_coinstore(market_id, amount, $p /* <CoinType>*/, isJSON = false) {
    const typeParamStrings = $p.map((t) => $.getTypeTagFullname(t));
    return $.buildPayload(new HexString('0x51d8534aba004732df9a7229f89d6d7a687ad56f8c906e482f62ee298ec7c778'), 'user', 'withdraw_to_coinstore', typeParamStrings, [market_id, amount], isJSON);
}
function loadParsers$k(repo) {
    repo.addParser('0x51d8534aba004732df9a7229f89d6d7a687ad56f8c906e482f62ee298ec7c778::user::Collateral', Collateral.CollateralParser);
    repo.addParser('0x51d8534aba004732df9a7229f89d6d7a687ad56f8c906e482f62ee298ec7c778::user::MarketAccount', MarketAccount.MarketAccountParser);
    repo.addParser('0x51d8534aba004732df9a7229f89d6d7a687ad56f8c906e482f62ee298ec7c778::user::MarketAccounts', MarketAccounts.MarketAccountsParser);
}
class App$l {
    constructor(client, repo, cache) {
        this.client = client;
        this.repo = repo;
        this.cache = cache;
    }
    get moduleAddress() {
        {
            return moduleAddress$e;
        }
    }
    get moduleName() {
        {
            return moduleName$e;
        }
    }
    get Collateral() {
        return Collateral;
    }
    loadCollateral(owner, $p /* <CoinType> */, loadFull = true, fillCache = true) {
        return __awaiter(this, void 0, void 0, function* () {
            const val = yield Collateral.load(this.repo, this.client, owner, $p);
            if (loadFull) {
                yield val.loadFullState(this);
            }
            if (fillCache) {
                this.cache.set(val.typeTag, owner, val);
            }
            return val;
        });
    }
    get MarketAccount() {
        return MarketAccount;
    }
    get MarketAccounts() {
        return MarketAccounts;
    }
    loadMarketAccounts(owner, loadFull = true, fillCache = true) {
        return __awaiter(this, void 0, void 0, function* () {
            const val = yield MarketAccounts.load(this.repo, this.client, owner, []);
            if (loadFull) {
                yield val.loadFullState(this);
            }
            if (fillCache) {
                this.cache.set(val.typeTag, owner, val);
            }
            return val;
        });
    }
    payload_deposit_from_coinstore(market_id, general_custodian_id, amount, $p /* <CoinType>*/, isJSON = false) {
        return buildPayload_deposit_from_coinstore(market_id, general_custodian_id, amount, $p, isJSON);
    }
    deposit_from_coinstore(_account, market_id, general_custodian_id, amount, $p /* <CoinType>*/, option, _isJSON = false) {
        return __awaiter(this, void 0, void 0, function* () {
            const payload__ = buildPayload_deposit_from_coinstore(market_id, general_custodian_id, amount, $p, _isJSON);
            return $.sendPayloadTx(this.client, _account, payload__, option);
        });
    }
    payload_register_market_account(market_id, general_custodian_id, $p /* <BaseType, QuoteType>*/, isJSON = false) {
        return buildPayload_register_market_account(market_id, general_custodian_id, $p, isJSON);
    }
    register_market_account(_account, market_id, general_custodian_id, $p /* <BaseType, QuoteType>*/, option, _isJSON = false) {
        return __awaiter(this, void 0, void 0, function* () {
            const payload__ = buildPayload_register_market_account(market_id, general_custodian_id, $p, _isJSON);
            return $.sendPayloadTx(this.client, _account, payload__, option);
        });
    }
    payload_withdraw_to_coinstore(market_id, amount, $p /* <CoinType>*/, isJSON = false) {
        return buildPayload_withdraw_to_coinstore(market_id, amount, $p, isJSON);
    }
    withdraw_to_coinstore(_account, market_id, amount, $p /* <CoinType>*/, option, _isJSON = false) {
        return __awaiter(this, void 0, void 0, function* () {
            const payload__ = buildPayload_withdraw_to_coinstore(market_id, amount, $p, _isJSON);
            return $.sendPayloadTx(this.client, _account, payload__, option);
        });
    }
}

var User = /*#__PURE__*/Object.freeze({
    __proto__: null,
    packageName: packageName$e,
    moduleAddress: moduleAddress$e,
    moduleName: moduleName$e,
    ASK: ASK$1,
    BID: BID$1,
    COIN_ASSET_TRANSFER: COIN_ASSET_TRANSFER,
    E_DEPOSIT_OVERFLOW_ASSET_CEILING: E_DEPOSIT_OVERFLOW_ASSET_CEILING,
    E_EXISTS_MARKET_ACCOUNT: E_EXISTS_MARKET_ACCOUNT,
    E_NOT_COIN_ASSET: E_NOT_COIN_ASSET,
    E_NOT_ENOUGH_ASSET_AVAILABLE: E_NOT_ENOUGH_ASSET_AVAILABLE,
    E_NOT_GENERIC_ASSET: E_NOT_GENERIC_ASSET,
    E_NOT_IN_MARKET_PAIR: E_NOT_IN_MARKET_PAIR,
    E_NO_MARKET_ACCOUNT: E_NO_MARKET_ACCOUNT,
    E_NO_MARKET_ACCOUNTS: E_NO_MARKET_ACCOUNTS,
    E_NO_ORDERS: E_NO_ORDERS,
    E_OVERFLOW_ASSET_IN: E_OVERFLOW_ASSET_IN,
    E_OVERFLOW_ASSET_OUT: E_OVERFLOW_ASSET_OUT,
    E_PRICE_0: E_PRICE_0,
    E_SIZE_0: E_SIZE_0,
    E_TICKS_OVERFLOW: E_TICKS_OVERFLOW,
    E_UNAUTHORIZED_CUSTODIAN: E_UNAUTHORIZED_CUSTODIAN,
    E_UNREGISTERED_CUSTODIAN_ID: E_UNREGISTERED_CUSTODIAN_ID,
    FIRST_64: FIRST_64,
    HI_64: HI_64$2,
    IN: IN,
    NO_CUSTODIAN: NO_CUSTODIAN$1,
    OUT: OUT,
    PURE_COIN_PAIR: PURE_COIN_PAIR$1,
    Collateral: Collateral,
    MarketAccount: MarketAccount,
    MarketAccounts: MarketAccounts,
    borrow_transfer_fields_mixed_: borrow_transfer_fields_mixed_,
    deposit_asset_: deposit_asset_,
    deposit_asset_as_option_internal_: deposit_asset_as_option_internal_,
    deposit_assets_as_option_internal_: deposit_assets_as_option_internal_,
    deposit_coins_: deposit_coins_,
    deposit_from_coinstore_: deposit_from_coinstore_,
    buildPayload_deposit_from_coinstore: buildPayload_deposit_from_coinstore,
    deposit_generic_asset_: deposit_generic_asset_,
    fill_order_internal_: fill_order_internal_,
    fill_order_route_collateral_: fill_order_route_collateral_,
    fill_order_route_collateral_single_: fill_order_route_collateral_single_,
    fill_order_update_market_account_: fill_order_update_market_account_,
    get_asset_counts_: get_asset_counts_,
    get_asset_counts_custodian_: get_asset_counts_custodian_,
    get_asset_counts_internal_: get_asset_counts_internal_,
    get_asset_counts_user_: get_asset_counts_user_,
    get_general_custodian_id_: get_general_custodian_id_,
    get_market_account_id_: get_market_account_id_,
    get_market_id_: get_market_id_,
    get_n_orders_internal_: get_n_orders_internal_,
    get_order_id_nearest_spread_internal_: get_order_id_nearest_spread_internal_,
    range_check_new_order_: range_check_new_order_,
    register_collateral_entry_: register_collateral_entry_,
    register_market_account_: register_market_account_,
    buildPayload_register_market_account: buildPayload_register_market_account,
    register_market_accounts_entry_: register_market_accounts_entry_,
    register_order_internal_: register_order_internal_,
    remove_order_internal_: remove_order_internal_,
    verify_market_account_exists_: verify_market_account_exists_,
    withdraw_asset_: withdraw_asset_,
    withdraw_asset_as_option_internal_: withdraw_asset_as_option_internal_,
    withdraw_assets_as_option_internal_: withdraw_assets_as_option_internal_,
    withdraw_coins_: withdraw_coins_,
    withdraw_coins_as_option_internal_: withdraw_coins_as_option_internal_,
    withdraw_coins_custodian_: withdraw_coins_custodian_,
    withdraw_coins_user_: withdraw_coins_user_,
    withdraw_generic_asset_: withdraw_generic_asset_,
    withdraw_to_coinstore_: withdraw_to_coinstore_,
    buildPayload_withdraw_to_coinstore: buildPayload_withdraw_to_coinstore,
    loadParsers: loadParsers$k,
    App: App$l
});

const packageName$d = 'Econia';
const moduleAddress$d = new HexString('0x51d8534aba004732df9a7229f89d6d7a687ad56f8c906e482f62ee298ec7c778');
const moduleName$d = 'market';
const ASK = true;
const BID = false;
const BUY = true;
const E_BOTH_COINS = u64('18');
const E_INBOUND_ASSET_OVERFLOW = u64('9');
const E_INVALID_BASE = u64('14');
const E_INVALID_CUSTODIAN = u64('7');
const E_INVALID_OPTION_BASE = u64('16');
const E_INVALID_OPTION_QUOTE = u64('17');
const E_INVALID_QUOTE = u64('15');
const E_INVALID_USER = u64('6');
const E_LIMIT_PRICE_0 = u64('13');
const E_MIN_BASE_EXCEEDS_MAX = u64('11');
const E_MIN_LOTS_NOT_FILLED = u64('3');
const E_MIN_QUOTE_EXCEEDS_MAX = u64('12');
const E_MIN_TICKS_NOT_FILLED = u64('4');
const E_NOT_ENOUGH_OUTBOUND_ASSET = u64('10');
const E_NO_ORDER = u64('5');
const E_NO_ORDER_BOOK = u64('2');
const E_NO_ORDER_BOOKS = u64('1');
const E_ORDER_BOOK_EXISTS = u64('0');
const E_POST_OR_ABORT_CROSSED_SPREAD = u64('8');
const E_SIZE_BASE_OVERFLOW = u64('20');
const E_SIZE_QUOTE_OVERFLOW = u64('22');
const E_SIZE_TICKS_OVERFLOW = u64('21');
const E_TOO_MANY_ORDER_FLAGS = u64('19');
const HI_64$1 = u64('18446744073709551615');
const LEFT = true;
const MAX_BID_DEFAULT = u128('0');
const MIN_ASK_DEFAULT = u128('340282366920938463463374607431768211455');
const NO_CUSTODIAN = u64('0');
const PURE_COIN_PAIR = u64('0');
const RIGHT = false;
const SELL = false;
class Order {
    constructor(proto, typeTag) {
        this.typeTag = typeTag;
        this.__app = null;
        this.size = proto['size'];
        this.user = proto['user'];
        this.general_custodian_id = proto['general_custodian_id'];
    }
    static OrderParser(data, typeTag, repo) {
        const proto = $.parseStructProto(data, typeTag, repo, Order);
        return new Order(proto, typeTag);
    }
    static getTag() {
        return new StructTag(moduleAddress$d, moduleName$d, 'Order', []);
    }
    loadFullState(app) {
        return __awaiter(this, void 0, void 0, function* () {
            this.__app = app;
        });
    }
}
Order.moduleAddress = moduleAddress$d;
Order.moduleName = moduleName$d;
Order.structName = 'Order';
Order.typeParameters = [];
Order.fields = [
    { name: 'size', typeTag: AtomicTypeTag.U64 },
    { name: 'user', typeTag: AtomicTypeTag.Address },
    { name: 'general_custodian_id', typeTag: AtomicTypeTag.U64 }
];
class OrderBook {
    constructor(proto, typeTag) {
        this.typeTag = typeTag;
        this.__app = null;
        this.base_type_info = proto['base_type_info'];
        this.quote_type_info = proto['quote_type_info'];
        this.lot_size = proto['lot_size'];
        this.tick_size = proto['tick_size'];
        this.generic_asset_transfer_custodian_id = proto['generic_asset_transfer_custodian_id'];
        this.asks = proto['asks'];
        this.bids = proto['bids'];
        this.min_ask = proto['min_ask'];
        this.max_bid = proto['max_bid'];
        this.counter = proto['counter'];
    }
    static OrderBookParser(data, typeTag, repo) {
        const proto = $.parseStructProto(data, typeTag, repo, OrderBook);
        return new OrderBook(proto, typeTag);
    }
    static getTag() {
        return new StructTag(moduleAddress$d, moduleName$d, 'OrderBook', []);
    }
    loadFullState(app) {
        return __awaiter(this, void 0, void 0, function* () {
            yield this.base_type_info.loadFullState(app);
            yield this.quote_type_info.loadFullState(app);
            yield this.asks.loadFullState(app);
            yield this.bids.loadFullState(app);
            this.__app = app;
        });
    }
    orders_vector(side) {
        var _a;
        const cache = ((_a = this.__app) === null || _a === void 0 ? void 0 : _a.cache) || new AptosLocalCache();
        this.typeTag.typeParams;
        return orders_vector_(this, side, cache);
    }
    orders_vectors() {
        var _a;
        const cache = ((_a = this.__app) === null || _a === void 0 ? void 0 : _a.cache) || new AptosLocalCache();
        this.typeTag.typeParams;
        return orders_vectors_(this, cache);
    }
    price_levels_vectors() {
        var _a;
        const cache = ((_a = this.__app) === null || _a === void 0 ? void 0 : _a.cache) || new AptosLocalCache();
        this.typeTag.typeParams;
        return price_levels_vectors_(this, cache);
    }
}
OrderBook.moduleAddress = moduleAddress$d;
OrderBook.moduleName = moduleName$d;
OrderBook.structName = 'OrderBook';
OrderBook.typeParameters = [];
OrderBook.fields = [
    { name: 'base_type_info', typeTag: new StructTag(new HexString('0x1'), 'type_info', 'TypeInfo', []) },
    { name: 'quote_type_info', typeTag: new StructTag(new HexString('0x1'), 'type_info', 'TypeInfo', []) },
    { name: 'lot_size', typeTag: AtomicTypeTag.U64 },
    { name: 'tick_size', typeTag: AtomicTypeTag.U64 },
    { name: 'generic_asset_transfer_custodian_id', typeTag: AtomicTypeTag.U64 },
    {
        name: 'asks',
        typeTag: new StructTag(new HexString('0x51d8534aba004732df9a7229f89d6d7a687ad56f8c906e482f62ee298ec7c778'), 'critbit', 'CritBitTree', [
            new StructTag(new HexString('0x51d8534aba004732df9a7229f89d6d7a687ad56f8c906e482f62ee298ec7c778'), 'market', 'Order', [])
        ])
    },
    {
        name: 'bids',
        typeTag: new StructTag(new HexString('0x51d8534aba004732df9a7229f89d6d7a687ad56f8c906e482f62ee298ec7c778'), 'critbit', 'CritBitTree', [
            new StructTag(new HexString('0x51d8534aba004732df9a7229f89d6d7a687ad56f8c906e482f62ee298ec7c778'), 'market', 'Order', [])
        ])
    },
    { name: 'min_ask', typeTag: AtomicTypeTag.U128 },
    { name: 'max_bid', typeTag: AtomicTypeTag.U128 },
    { name: 'counter', typeTag: AtomicTypeTag.U64 }
];
class OrderBooks {
    constructor(proto, typeTag) {
        this.typeTag = typeTag;
        this.__app = null;
        this.map = proto['map'];
    }
    static OrderBooksParser(data, typeTag, repo) {
        const proto = $.parseStructProto(data, typeTag, repo, OrderBooks);
        return new OrderBooks(proto, typeTag);
    }
    static load(repo, client, address, typeParams) {
        return __awaiter(this, void 0, void 0, function* () {
            const result = yield repo.loadResource(client, address, OrderBooks, typeParams);
            return result;
        });
    }
    static loadByApp(app, address, typeParams) {
        return __awaiter(this, void 0, void 0, function* () {
            const result = yield app.repo.loadResource(app.client, address, OrderBooks, typeParams);
            yield result.loadFullState(app);
            return result;
        });
    }
    static getTag() {
        return new StructTag(moduleAddress$d, moduleName$d, 'OrderBooks', []);
    }
    loadFullState(app) {
        return __awaiter(this, void 0, void 0, function* () {
            yield this.map.loadFullState(app);
            this.__app = app;
        });
    }
}
OrderBooks.moduleAddress = moduleAddress$d;
OrderBooks.moduleName = moduleName$d;
OrderBooks.structName = 'OrderBooks';
OrderBooks.typeParameters = [];
OrderBooks.fields = [
    {
        name: 'map',
        typeTag: new StructTag(new HexString('0x51d8534aba004732df9a7229f89d6d7a687ad56f8c906e482f62ee298ec7c778'), 'open_table', 'OpenTable', [
            AtomicTypeTag.U64,
            new StructTag(new HexString('0x51d8534aba004732df9a7229f89d6d7a687ad56f8c906e482f62ee298ec7c778'), 'market', 'OrderBook', [])
        ])
    }
];
class PriceLevel {
    constructor(proto, typeTag) {
        this.typeTag = typeTag;
        this.__app = null;
        this.price = proto['price'];
        this.size = proto['size'];
    }
    static PriceLevelParser(data, typeTag, repo) {
        const proto = $.parseStructProto(data, typeTag, repo, PriceLevel);
        return new PriceLevel(proto, typeTag);
    }
    static getTag() {
        return new StructTag(moduleAddress$d, moduleName$d, 'PriceLevel', []);
    }
    loadFullState(app) {
        return __awaiter(this, void 0, void 0, function* () {
            this.__app = app;
        });
    }
}
PriceLevel.moduleAddress = moduleAddress$d;
PriceLevel.moduleName = moduleName$d;
PriceLevel.structName = 'PriceLevel';
PriceLevel.typeParameters = [];
PriceLevel.fields = [
    { name: 'price', typeTag: AtomicTypeTag.U64 },
    { name: 'size', typeTag: AtomicTypeTag.U64 }
];
class SimpleOrder {
    constructor(proto, typeTag) {
        this.typeTag = typeTag;
        this.__app = null;
        this.price = proto['price'];
        this.size = proto['size'];
    }
    static SimpleOrderParser(data, typeTag, repo) {
        const proto = $.parseStructProto(data, typeTag, repo, SimpleOrder);
        return new SimpleOrder(proto, typeTag);
    }
    static getTag() {
        return new StructTag(moduleAddress$d, moduleName$d, 'SimpleOrder', []);
    }
    loadFullState(app) {
        return __awaiter(this, void 0, void 0, function* () {
            this.__app = app;
        });
    }
}
SimpleOrder.moduleAddress = moduleAddress$d;
SimpleOrder.moduleName = moduleName$d;
SimpleOrder.structName = 'SimpleOrder';
SimpleOrder.typeParameters = [];
SimpleOrder.fields = [
    { name: 'price', typeTag: AtomicTypeTag.U64 },
    { name: 'size', typeTag: AtomicTypeTag.U64 }
];
function cancel_all_limit_orders_(user, host, market_id, general_custodian_id, side, $c) {
    let market_account_id, n_orders, order_id_nearest_spread;
    market_account_id = get_market_account_id_($.copy(market_id), $.copy(general_custodian_id));
    n_orders = get_n_orders_internal_($.copy(user), $.copy(market_account_id), side, $c);
    while ($.copy(n_orders).gt(u64('0'))) {
        {
            order_id_nearest_spread = get_order_id_nearest_spread_internal_($.copy(user), $.copy(market_account_id), side, $c);
            cancel_limit_order_($.copy(user), $.copy(host), $.copy(market_id), $.copy(general_custodian_id), side, $.copy(order_id_nearest_spread), $c);
            n_orders = $.copy(n_orders).sub(u64('1'));
        }
    }
    return;
}
function cancel_all_limit_orders_custodian_(user, host, market_id, side, general_custodian_capability_ref, $c) {
    cancel_all_limit_orders_($.copy(user), $.copy(host), $.copy(market_id), custodian_id_(general_custodian_capability_ref), side, $c);
    return;
}
function cancel_all_limit_orders_user_(user, host, market_id, side, $c) {
    cancel_all_limit_orders_(address_of_(user, $c), $.copy(host), $.copy(market_id), $.copy(NO_CUSTODIAN), side, $c);
    return;
}
function buildPayload_cancel_all_limit_orders_user(host, market_id, side, isJSON = false) {
    const typeParamStrings = [];
    return $.buildPayload(new HexString('0x51d8534aba004732df9a7229f89d6d7a687ad56f8c906e482f62ee298ec7c778'), 'market', 'cancel_all_limit_orders_user', typeParamStrings, [host, market_id, side], isJSON);
}
function cancel_limit_order_(user, host, market_id, general_custodian_id, side, order_id, $c) {
    let temp$1, temp$2, temp$3, temp$4, temp$5, temp$6, temp$7, lot_size, market_account_id, order_book_ref_mut, order_books_map_ref_mut, tick_size, tree_ref_mut;
    verify_order_book_exists_($.copy(host), $.copy(market_id), $c);
    order_books_map_ref_mut = $c.borrow_global_mut(new SimpleStructTag(OrderBooks), $.copy(host)).map;
    order_book_ref_mut = borrow_mut_(order_books_map_ref_mut, $.copy(market_id), $c, [
        AtomicTypeTag.U64,
        new SimpleStructTag(OrderBook)
    ]);
    if (side == $.copy(ASK)) {
        temp$1 = order_book_ref_mut.asks;
    }
    else {
        temp$1 = order_book_ref_mut.bids;
    }
    tree_ref_mut = temp$1;
    [temp$2, temp$3] = [tree_ref_mut, $.copy(order_id)];
    if (!has_key_(temp$2, temp$3, $c, [new SimpleStructTag(Order)])) {
        throw $.abortCode($.copy(E_NO_ORDER));
    }
    let { user: order_user, general_custodian_id: order_general_custodian_id } = pop_(tree_ref_mut, $.copy(order_id), $c, [new SimpleStructTag(Order)]);
    if (!($.copy(user).hex() === $.copy(order_user).hex())) {
        throw $.abortCode($.copy(E_INVALID_USER));
    }
    if (!$.copy(general_custodian_id).eq($.copy(order_general_custodian_id))) {
        throw $.abortCode($.copy(E_INVALID_CUSTODIAN));
    }
    if (side == $.copy(ASK)) {
        temp$4 = $.copy(order_id).eq($.copy(order_book_ref_mut.min_ask));
    }
    else {
        temp$4 = false;
    }
    if (temp$4) {
        if (is_empty_(tree_ref_mut, $c, [new SimpleStructTag(Order)])) {
            temp$5 = $.copy(MIN_ASK_DEFAULT);
        }
        else {
            temp$5 = min_key_(tree_ref_mut, $c, [new SimpleStructTag(Order)]);
        }
        order_book_ref_mut.min_ask = temp$5;
    }
    else {
        if (side == $.copy(BID)) {
            temp$6 = $.copy(order_id).eq($.copy(order_book_ref_mut.max_bid));
        }
        else {
            temp$6 = false;
        }
        if (temp$6) {
            if (is_empty_(tree_ref_mut, $c, [new SimpleStructTag(Order)])) {
                temp$7 = $.copy(MAX_BID_DEFAULT);
            }
            else {
                temp$7 = max_key_(tree_ref_mut, $c, [new SimpleStructTag(Order)]);
            }
            order_book_ref_mut.max_bid = temp$7;
        }
    }
    [market_account_id, lot_size, tick_size] = [
        get_market_account_id_($.copy(market_id), $.copy(general_custodian_id)),
        $.copy(order_book_ref_mut.lot_size),
        $.copy(order_book_ref_mut.tick_size)
    ];
    remove_order_internal_($.copy(user), $.copy(market_account_id), $.copy(lot_size), $.copy(tick_size), side, $.copy(order_id), $c);
    return;
}
function cancel_limit_order_custodian_(user, host, market_id, side, order_id, general_custodian_capability_ref, $c) {
    cancel_limit_order_($.copy(user), $.copy(host), $.copy(market_id), custodian_id_(general_custodian_capability_ref), side, $.copy(order_id), $c);
    return;
}
function cancel_limit_order_user_(user, host, market_id, side, order_id, $c) {
    cancel_limit_order_(address_of_(user, $c), $.copy(host), $.copy(market_id), $.copy(NO_CUSTODIAN), side, $.copy(order_id), $c);
    return;
}
function buildPayload_cancel_limit_order_user(host, market_id, side, order_id, isJSON = false) {
    const typeParamStrings = [];
    return $.buildPayload(new HexString('0x51d8534aba004732df9a7229f89d6d7a687ad56f8c906e482f62ee298ec7c778'), 'market', 'cancel_limit_order_user', typeParamStrings, [host, market_id, side, order_id], isJSON);
}
function get_counter_(order_book_ref_mut, $c) {
    let count, counter_ref_mut;
    counter_ref_mut = order_book_ref_mut.counter;
    count = $.copy(counter_ref_mut);
    $.set(counter_ref_mut, $.copy(count).add(u64('1')));
    return $.copy(count);
}
function match_(market_id_ref, order_book_ref_mut, lot_size_ref, tick_size_ref, direction_ref, min_lots_ref, max_lots_ref, min_ticks_ref, max_ticks_ref, limit_price_ref, optional_base_coins_ref_mut, optional_quote_coins_ref_mut, lots_filled_ref_mut, ticks_filled_ref_mut, $c, $p /* <BaseType, QuoteType>*/) {
    let lots_until_max, n_orders, side, spread_maker_ref_mut, ticks_until_max, traversal_direction, tree_ref_mut;
    [lots_until_max, ticks_until_max, side, tree_ref_mut, spread_maker_ref_mut, n_orders, traversal_direction] =
        match_init_(order_book_ref_mut, direction_ref, max_lots_ref, max_ticks_ref, $c, [$p[0], $p[1]]);
    if ($.copy(n_orders).neq(u64('0'))) {
        match_loop_(market_id_ref, tree_ref_mut, side, lot_size_ref, tick_size_ref, lots_until_max, ticks_until_max, limit_price_ref, n_orders, spread_maker_ref_mut, traversal_direction, optional_base_coins_ref_mut, optional_quote_coins_ref_mut, $c, [$p[0], $p[1]]);
    }
    match_verify_fills_(min_lots_ref, max_lots_ref, min_ticks_ref, max_ticks_ref, lots_until_max, ticks_until_max, lots_filled_ref_mut, ticks_filled_ref_mut);
    return;
}
function match_from_market_account_(user_ref, market_account_id_ref, market_id_ref, order_book_ref_mut, direction_ref, min_base_ref, max_base_ref, min_quote_ref, max_quote_ref, limit_price_ref, lots_filled_ref_mut, $c, $p /* <BaseType, QuoteType>*/) {
    let temp$1, temp$10, temp$11, temp$12, temp$13, temp$14, temp$15, temp$16, temp$2, temp$3, temp$4, temp$5, temp$6, temp$7, temp$8, temp$9, base_available, base_ceiling, base_on_hand, base_to_withdraw, lot_size, optional_base_coins, optional_quote_coins, quote_available, quote_ceiling, quote_on_hand, quote_to_withdraw, tick_size, ticks_filled;
    lot_size = $.copy(order_book_ref_mut.lot_size);
    tick_size = $.copy(order_book_ref_mut.tick_size);
    [, base_available, base_ceiling, , quote_available, quote_ceiling] = get_asset_counts_internal_($.copy(user_ref), $.copy(market_account_id_ref), $c);
    match_range_check_fills_(direction_ref, min_base_ref, max_base_ref, min_quote_ref, max_quote_ref, base_available, base_ceiling, quote_available, quote_ceiling);
    if ($.copy(direction_ref) == $.copy(BUY)) {
        [temp$1, temp$2] = [u64('0'), $.copy(max_quote_ref)];
    }
    else {
        [temp$1, temp$2] = [$.copy(max_base_ref), u64('0')];
    }
    [base_to_withdraw, quote_to_withdraw] = [temp$1, temp$2];
    [optional_base_coins, optional_quote_coins] = withdraw_assets_as_option_internal_($.copy(user_ref), $.copy(market_account_id_ref), $.copy(base_to_withdraw), $.copy(quote_to_withdraw), $.copy(order_book_ref_mut.generic_asset_transfer_custodian_id), $c, [$p[0], $p[1]]);
    ticks_filled = u64('0');
    temp$14 = market_id_ref;
    temp$13 = order_book_ref_mut;
    temp$12 = lot_size;
    temp$11 = tick_size;
    temp$10 = direction_ref;
    temp$8 = $.copy(min_base_ref).div($.copy(lot_size));
    temp$9 = temp$8;
    temp$6 = $.copy(max_base_ref).div($.copy(lot_size));
    temp$7 = temp$6;
    temp$4 = $.copy(min_quote_ref).div($.copy(tick_size));
    temp$5 = temp$4;
    temp$3 = $.copy(max_quote_ref).div($.copy(tick_size));
    match_(temp$14, temp$13, temp$12, temp$11, temp$10, temp$9, temp$7, temp$5, temp$3, limit_price_ref, optional_base_coins, optional_quote_coins, lots_filled_ref_mut, ticks_filled, $c, [$p[0], $p[1]]);
    if ($.copy(direction_ref) == $.copy(BUY)) {
        [temp$15, temp$16] = [
            $.copy(lots_filled_ref_mut).mul($.copy(lot_size)),
            $.copy(max_quote_ref).sub($.copy(ticks_filled).mul($.copy(tick_size)))
        ];
    }
    else {
        [temp$15, temp$16] = [
            $.copy(max_base_ref).sub($.copy(lots_filled_ref_mut).mul($.copy(lot_size))),
            $.copy(ticks_filled).mul($.copy(tick_size))
        ];
    }
    [base_on_hand, quote_on_hand] = [temp$15, temp$16];
    deposit_assets_as_option_internal_($.copy(user_ref), $.copy(market_account_id_ref), $.copy(base_on_hand), $.copy(quote_on_hand), optional_base_coins, optional_quote_coins, $.copy(order_book_ref_mut.generic_asset_transfer_custodian_id), $c, [$p[0], $p[1]]);
    return;
}
function match_init_(order_book_ref_mut, direction_ref, max_lots_ref, max_ticks_ref, $c, $p /* <BaseType, QuoteType>*/) {
    let temp$1, temp$2, temp$3, temp$4, n_orders, side, spread_maker_ref_mut, traversal_direction, tree_ref_mut;
    if (!$.deep_eq(type_of_($c, [$p[0]]), $.copy(order_book_ref_mut.base_type_info))) {
        throw $.abortCode($.copy(E_INVALID_BASE));
    }
    if (!$.deep_eq(type_of_($c, [$p[1]]), $.copy(order_book_ref_mut.quote_type_info))) {
        throw $.abortCode($.copy(E_INVALID_QUOTE));
    }
    if ($.copy(direction_ref) == $.copy(BUY)) {
        [temp$1, temp$2, temp$3, temp$4] = [
            $.copy(ASK),
            order_book_ref_mut.asks,
            order_book_ref_mut.min_ask,
            $.copy(RIGHT)
        ];
    }
    else {
        [temp$1, temp$2, temp$3, temp$4] = [$.copy(BID), order_book_ref_mut.bids, order_book_ref_mut.max_bid, $.copy(LEFT)];
    }
    [side, tree_ref_mut, spread_maker_ref_mut, traversal_direction] = [temp$1, temp$2, temp$3, temp$4];
    n_orders = length_(tree_ref_mut, $c, [new SimpleStructTag(Order)]);
    return [
        $.copy(max_lots_ref),
        $.copy(max_ticks_ref),
        side,
        tree_ref_mut,
        spread_maker_ref_mut,
        $.copy(n_orders),
        traversal_direction
    ];
}
function match_loop_(market_id_ref, tree_ref_mut, side_ref, lot_size_ref, tick_size_ref, lots_until_max_ref_mut, ticks_until_max_ref_mut, limit_price_ref, n_orders_ref_mut, spread_maker_ref_mut, traversal_direction_ref, optional_base_coins_ref_mut, optional_quote_coins_ref_mut, $c, $p /* <BaseType, QuoteType>*/) {
    let complete_target_fill, new_spread_maker, should_break, should_pop_last, target_child_index, target_order_id, target_order_ref_mut, target_parent_index;
    [
        target_order_id,
        target_order_ref_mut,
        target_parent_index,
        target_child_index,
        complete_target_fill,
        should_pop_last,
        new_spread_maker
    ] = match_loop_init_(tree_ref_mut, traversal_direction_ref, $c);
    while (true) {
        match_loop_order_(market_id_ref, side_ref, lot_size_ref, tick_size_ref, lots_until_max_ref_mut, ticks_until_max_ref_mut, limit_price_ref, target_order_id, target_order_ref_mut, complete_target_fill, optional_base_coins_ref_mut, optional_quote_coins_ref_mut, $c, [$p[0], $p[1]]);
        [target_order_id, target_order_ref_mut, should_break] = match_loop_order_follow_up_(tree_ref_mut, side_ref, traversal_direction_ref, n_orders_ref_mut, complete_target_fill, should_pop_last, $.copy(target_order_id), target_parent_index, target_child_index, new_spread_maker, $c);
        if (should_break) {
            match_loop_break_(spread_maker_ref_mut, new_spread_maker, should_pop_last, tree_ref_mut, target_order_id, $c);
            break;
        }
    }
    return;
}
function match_loop_break_(spread_maker_ref_mut, new_spread_maker_ref, should_pop_last_ref, tree_ref_mut, final_order_id_ref, $c) {
    $.set(spread_maker_ref_mut, $.copy(new_spread_maker_ref));
    if ($.copy(should_pop_last_ref)) {
        pop_(tree_ref_mut, $.copy(final_order_id_ref), $c, [new SimpleStructTag(Order)]);
    }
    return;
}
function match_loop_init_(tree_ref_mut, traversal_direction_ref, $c) {
    let target_child_index, target_order_id, target_order_ref_mut, target_parent_index;
    [target_order_id, target_order_ref_mut, target_parent_index, target_child_index] = traverse_init_mut_(tree_ref_mut, $.copy(traversal_direction_ref), $c, [new SimpleStructTag(Order)]);
    return [
        $.copy(target_order_id),
        target_order_ref_mut,
        $.copy(target_parent_index),
        $.copy(target_child_index),
        false,
        false,
        u128('0')
    ];
}
function match_loop_order_(market_id_ref, side_ref, lot_size_ref, tick_size_ref, lots_until_max_ref_mut, ticks_until_max_ref_mut, limit_price_ref, target_order_id_ref, target_order_ref_mut, complete_target_fill_ref_mut, optional_base_coins_ref_mut, optional_quote_coins_ref_mut, $c, $p /* <BaseType, QuoteType>*/) {
    let temp$1, temp$2, temp$3, temp$4, temp$5, temp$6, temp$7, temp$8, temp$9, base_to_route, fill_size, quote_to_route, target_order_market_account_id, target_order_price, ticks_filled;
    target_order_price = price_($.copy(target_order_id_ref));
    if ($.copy(side_ref) == $.copy(ASK)) {
        temp$1 = $.copy(target_order_price).gt($.copy(limit_price_ref));
    }
    else {
        temp$1 = false;
    }
    if (temp$1) {
        temp$3 = true;
    }
    else {
        if ($.copy(side_ref) == $.copy(BID)) {
            temp$2 = $.copy(target_order_price).lt($.copy(limit_price_ref));
        }
        else {
            temp$2 = false;
        }
        temp$3 = temp$2;
    }
    if (temp$3) {
        $.set(complete_target_fill_ref_mut, false);
        return;
    }
    fill_size = u64('0');
    [temp$4, temp$5, temp$6, temp$7, temp$8, temp$9] = [
        lots_until_max_ref_mut,
        ticks_until_max_ref_mut,
        target_order_price,
        target_order_ref_mut,
        fill_size,
        complete_target_fill_ref_mut
    ];
    match_loop_order_fill_size_(temp$4, temp$5, temp$6, temp$7, temp$8, temp$9);
    if ($.copy(fill_size).eq(u64('0'))) {
        $.set(complete_target_fill_ref_mut, false);
        return;
    }
    ticks_filled = $.copy(fill_size).mul($.copy(target_order_price));
    $.set(lots_until_max_ref_mut, $.copy(lots_until_max_ref_mut).sub($.copy(fill_size)));
    $.set(ticks_until_max_ref_mut, $.copy(ticks_until_max_ref_mut).sub($.copy(ticks_filled)));
    [base_to_route, quote_to_route] = [
        $.copy(fill_size).mul($.copy(lot_size_ref)),
        $.copy(ticks_filled).mul($.copy(tick_size_ref))
    ];
    target_order_market_account_id = get_market_account_id_($.copy(market_id_ref), $.copy(target_order_ref_mut.general_custodian_id));
    fill_order_internal_($.copy(target_order_ref_mut.user), $.copy(target_order_market_account_id), $.copy(side_ref), $.copy(target_order_id_ref), $.copy(complete_target_fill_ref_mut), $.copy(fill_size), optional_base_coins_ref_mut, optional_quote_coins_ref_mut, $.copy(base_to_route), $.copy(quote_to_route), $c, [$p[0], $p[1]]);
    target_order_ref_mut.size = $.copy(target_order_ref_mut.size).sub($.copy(fill_size));
    return;
}
function match_loop_order_fill_size_(lots_until_max_ref, ticks_until_max_ref, target_order_price_ref, target_order_ref, fill_size_ref_mut, complete_target_fill_ref_mut, $c) {
    let temp$1, temp$2, temp$3, complete_target_fill, fill_size, fill_size_max_limited, fill_size_tick_limited;
    fill_size_tick_limited = $.copy(ticks_until_max_ref).div($.copy(target_order_price_ref));
    if ($.copy(fill_size_tick_limited).lt($.copy(lots_until_max_ref))) {
        temp$1 = $.copy(fill_size_tick_limited);
    }
    else {
        temp$1 = $.copy(lots_until_max_ref);
    }
    fill_size_max_limited = temp$1;
    if ($.copy(fill_size_max_limited).lt($.copy(target_order_ref.size))) {
        [temp$2, temp$3] = [$.copy(fill_size_max_limited), false];
    }
    else {
        [temp$2, temp$3] = [$.copy(target_order_ref.size), true];
    }
    [fill_size, complete_target_fill] = [temp$2, temp$3];
    $.set(fill_size_ref_mut, $.copy(fill_size));
    $.set(complete_target_fill_ref_mut, complete_target_fill);
    return;
}
function match_loop_order_follow_up_(tree_ref_mut, side_ref, traversal_direction_ref, n_orders_ref_mut, complete_target_fill_ref, should_pop_last_ref_mut, target_order_id, target_parent_index_ref_mut, target_child_index_ref_mut, new_spread_maker_ref_mut, $c) {
    let temp$1, empty_order, should_break, target_child_index, target_order_ref_mut, target_parent_index;
    target_order_ref_mut = borrow_mut_$1(tree_ref_mut, $.copy(target_order_id), $c, [new SimpleStructTag(Order)]);
    $.set(new_spread_maker_ref_mut, $.copy(target_order_id));
    $.set(should_pop_last_ref_mut, false);
    should_break = true;
    if ($.copy(n_orders_ref_mut).eq(u64('1'))) {
        if ($.copy(complete_target_fill_ref)) {
            $.set(should_pop_last_ref_mut, true);
            if ($.copy(side_ref) == $.copy(ASK)) {
                temp$1 = $.copy(MIN_ASK_DEFAULT);
            }
            else {
                temp$1 = $.copy(MAX_BID_DEFAULT);
            }
            $.set(new_spread_maker_ref_mut, temp$1);
        }
    }
    else {
        if ($.copy(complete_target_fill_ref)) {
            [target_order_id, target_order_ref_mut, target_parent_index, target_child_index, empty_order] =
                traverse_pop_mut_(tree_ref_mut, $.copy(target_order_id), $.copy(target_parent_index_ref_mut), $.copy(target_child_index_ref_mut), $.copy(n_orders_ref_mut), $.copy(traversal_direction_ref), $c, [new SimpleStructTag(Order)]);
            $.set(target_parent_index_ref_mut, $.copy(target_parent_index));
            $.set(target_child_index_ref_mut, $.copy(target_child_index));
            should_break = false;
            $.set(n_orders_ref_mut, $.copy(n_orders_ref_mut).sub(u64('1')));
        }
    }
    return [$.copy(target_order_id), target_order_ref_mut, should_break];
}
function match_range_check_fills_(direction_ref, min_base_ref, max_base_ref, min_quote_ref, max_quote_ref, base_available_ref, base_ceiling_ref, quote_available_ref, quote_ceiling_ref, $c) {
    let temp$1, temp$2, temp$3, temp$4, in_ceiling, in_ceiling_max, max_in, max_out, out_available;
    if (!!$.copy(min_base_ref).gt($.copy(max_base_ref))) {
        throw $.abortCode($.copy(E_MIN_BASE_EXCEEDS_MAX));
    }
    if (!!$.copy(min_quote_ref).gt($.copy(max_quote_ref))) {
        throw $.abortCode($.copy(E_MIN_QUOTE_EXCEEDS_MAX));
    }
    if ($.copy(direction_ref) == $.copy(BUY)) {
        [temp$1, temp$2, temp$3, temp$4] = [
            $.copy(base_ceiling_ref),
            $.copy(max_base_ref),
            $.copy(quote_available_ref),
            $.copy(max_quote_ref)
        ];
    }
    else {
        [temp$1, temp$2, temp$3, temp$4] = [
            $.copy(quote_ceiling_ref),
            $.copy(max_quote_ref),
            $.copy(base_available_ref),
            $.copy(max_base_ref)
        ];
    }
    [in_ceiling, max_in, out_available, max_out] = [temp$1, temp$2, temp$3, temp$4];
    in_ceiling_max = u128($.copy(in_ceiling)).add(u128($.copy(max_in)));
    if (!!$.copy(in_ceiling_max).gt(u128($.copy(HI_64$1)))) {
        throw $.abortCode($.copy(E_INBOUND_ASSET_OVERFLOW));
    }
    if (!!$.copy(out_available).lt($.copy(max_out))) {
        throw $.abortCode($.copy(E_NOT_ENOUGH_OUTBOUND_ASSET));
    }
    return;
}
function match_verify_fills_(min_lots_ref, max_lots_ref, min_ticks_ref, max_ticks_ref, lots_until_max_ref, ticks_until_max_ref, lots_filled_ref_mut, ticks_filled_ref_mut, $c) {
    $.set(lots_filled_ref_mut, $.copy(max_lots_ref).sub($.copy(lots_until_max_ref)));
    $.set(ticks_filled_ref_mut, $.copy(max_ticks_ref).sub($.copy(ticks_until_max_ref)));
    if (!!$.copy(lots_filled_ref_mut).lt($.copy(min_lots_ref))) {
        throw $.abortCode($.copy(E_MIN_LOTS_NOT_FILLED));
    }
    if (!!$.copy(ticks_filled_ref_mut).lt($.copy(min_ticks_ref))) {
        throw $.abortCode($.copy(E_MIN_TICKS_NOT_FILLED));
    }
    return;
}
function orders_vector_(order_book_ref_mut, side, $c) {
    let temp$1, temp$2, remaining_traversals, simple_orders, target_id, target_order_ref_mut, target_parent_index, traversal_direction, tree_ref_mut;
    simple_orders = empty_$5($c, [new SimpleStructTag(SimpleOrder)]);
    if (side == $.copy(ASK)) {
        [temp$1, temp$2] = [order_book_ref_mut.asks, $.copy(RIGHT)];
    }
    else {
        [temp$1, temp$2] = [order_book_ref_mut.bids, $.copy(LEFT)];
    }
    [tree_ref_mut, traversal_direction] = [temp$1, temp$2];
    if (is_empty_(tree_ref_mut, $c, [new SimpleStructTag(Order)])) {
        return $.copy(simple_orders);
    }
    remaining_traversals = length_(tree_ref_mut, $c, [new SimpleStructTag(Order)]).sub(u64('1'));
    [target_id, target_order_ref_mut, target_parent_index] = traverse_init_mut_(tree_ref_mut, traversal_direction, $c, [new SimpleStructTag(Order)]);
    while (true) {
        push_back_(simple_orders, new SimpleOrder({ price: price_($.copy(target_id)), size: $.copy(target_order_ref_mut.size) }, new SimpleStructTag(SimpleOrder)), $c, [new SimpleStructTag(SimpleOrder)]);
        if ($.copy(remaining_traversals).eq(u64('0'))) {
            return $.copy(simple_orders);
        }
        [target_id, target_order_ref_mut, target_parent_index] = traverse_mut_(tree_ref_mut, $.copy(target_id), $.copy(target_parent_index), traversal_direction, $c, [new SimpleStructTag(Order)]);
        remaining_traversals = $.copy(remaining_traversals).sub(u64('1'));
    }
}
function orders_vectors_(order_book_ref_mut, $c) {
    return [orders_vector_(order_book_ref_mut, $.copy(ASK), $c), orders_vector_(order_book_ref_mut, $.copy(BID), $c)];
}
function place_limit_order_(user_ref, host_ref, market_id_ref, general_custodian_id_ref, side_ref, size_ref, price_ref, post_or_abort_ref, fill_or_abort_ref, immediate_or_cancel_ref, $c, $p /* <BaseType, QuoteType>*/) {
    let temp$1, temp$10, temp$11, temp$12, temp$13, temp$14, temp$15, temp$16, temp$17, temp$18, temp$19, temp$2, temp$20, temp$21, temp$22, temp$23, temp$24, temp$25, temp$3, temp$4, temp$5, temp$6, temp$7, temp$8, temp$9, direction, lot_size, lots_filled, market_account_id, max_base, max_quote, min_base, order_book_ref_mut, order_books_map_ref_mut, tick_size;
    if (!$.copy(price_ref).neq(u64('0'))) {
        throw $.abortCode($.copy(E_LIMIT_PRICE_0));
    }
    if ($.copy(size_ref).eq(u64('0'))) {
        return;
    }
    verify_order_book_exists_($.copy(host_ref), $.copy(market_id_ref), $c);
    order_books_map_ref_mut = $c.borrow_global_mut(new SimpleStructTag(OrderBooks), $.copy(host_ref)).map;
    order_book_ref_mut = borrow_mut_(order_books_map_ref_mut, $.copy(market_id_ref), $c, [
        AtomicTypeTag.U64,
        new SimpleStructTag(OrderBook)
    ]);
    [market_account_id, lot_size, tick_size, direction, min_base, max_base, max_quote, lots_filled] = [
        u128('0'),
        u64('0'),
        u64('0'),
        false,
        u64('0'),
        u64('0'),
        u64('0'),
        u64('0')
    ];
    [
        temp$1,
        temp$2,
        temp$3,
        temp$4,
        temp$5,
        temp$6,
        temp$7,
        temp$8,
        temp$9,
        temp$10,
        temp$11,
        temp$12,
        temp$13,
        temp$14,
        temp$15,
        temp$16,
        temp$17
    ] = [
        user_ref,
        order_book_ref_mut,
        market_id_ref,
        general_custodian_id_ref,
        side_ref,
        size_ref,
        price_ref,
        post_or_abort_ref,
        fill_or_abort_ref,
        immediate_or_cancel_ref,
        market_account_id,
        lot_size,
        tick_size,
        direction,
        min_base,
        max_base,
        max_quote
    ];
    place_limit_order_pre_match_(temp$1, temp$2, temp$3, temp$4, temp$5, temp$6, temp$7, temp$8, temp$9, temp$10, temp$11, temp$12, temp$13, temp$14, temp$15, temp$16, temp$17, $c);
    temp$25 = user_ref;
    temp$24 = market_account_id;
    temp$23 = market_id_ref;
    temp$22 = order_book_ref_mut;
    temp$21 = direction;
    temp$20 = min_base;
    temp$19 = max_base;
    temp$18 = u64('0');
    match_from_market_account_(temp$25, temp$24, temp$23, temp$22, temp$21, temp$20, temp$19, temp$18, max_quote, price_ref, lots_filled, $c, [$p[0], $p[1]]);
    place_limit_order_post_match_(user_ref, order_book_ref_mut, market_account_id, general_custodian_id_ref, lot_size, tick_size, side_ref, size_ref, price_ref, lots_filled, immediate_or_cancel_ref, $c);
    return;
}
function place_limit_order_custodian_(user, host, market_id, side, size, price, post_or_abort, fill_or_abort, immediate_or_cancel, general_custodian_capability_ref, $c, $p /* <BaseType, QuoteType>*/) {
    let temp$1, temp$2, temp$3, temp$4;
    temp$4 = user;
    temp$3 = host;
    temp$2 = market_id;
    temp$1 = custodian_id_(general_custodian_capability_ref);
    place_limit_order_(temp$4, temp$3, temp$2, temp$1, side, size, price, post_or_abort, fill_or_abort, immediate_or_cancel, $c, [$p[0], $p[1]]);
    return;
}
function place_limit_order_post_match_(user_ref, order_book_ref_mut, market_account_id_ref, general_custodian_id_ref, lot_size_ref, tick_size_ref, side_ref, size_ref, price_ref, lots_filled_ref, immediate_or_cancel_ref, $c) {
    let temp$1, temp$2, temp$3, temp$4, new_spread_maker, order_id, size_to_fill, spread_maker_ref_mut, tree_ref_mut;
    if ($.copy(immediate_or_cancel_ref)) {
        temp$1 = true;
    }
    else {
        temp$1 = $.copy(lots_filled_ref).eq($.copy(size_ref));
    }
    if (temp$1) {
        return;
    }
    size_to_fill = $.copy(size_ref).sub($.copy(lots_filled_ref));
    order_id = order_id_($.copy(price_ref), get_counter_(order_book_ref_mut), $.copy(side_ref));
    register_order_internal_($.copy(user_ref), $.copy(market_account_id_ref), $.copy(side_ref), $.copy(order_id), $.copy(size_to_fill), $.copy(price_ref), $.copy(lot_size_ref), $.copy(tick_size_ref), $c);
    if ($.copy(side_ref) == $.copy(ASK)) {
        [temp$2, temp$3, temp$4] = [
            order_book_ref_mut.asks,
            $.copy(order_id).lt($.copy(order_book_ref_mut.min_ask)),
            order_book_ref_mut.min_ask
        ];
    }
    else {
        [temp$2, temp$3, temp$4] = [
            order_book_ref_mut.bids,
            $.copy(order_id).gt($.copy(order_book_ref_mut.max_bid)),
            order_book_ref_mut.max_bid
        ];
    }
    [tree_ref_mut, new_spread_maker, spread_maker_ref_mut] = [temp$2, temp$3, temp$4];
    if (new_spread_maker) {
        $.set(spread_maker_ref_mut, $.copy(order_id));
    }
    insert_(tree_ref_mut, $.copy(order_id), new Order({ size: $.copy(size_to_fill), user: $.copy(user_ref), general_custodian_id: $.copy(general_custodian_id_ref) }, new SimpleStructTag(Order)), $c, [new SimpleStructTag(Order)]);
    return;
}
function place_limit_order_pre_match_(user_ref, order_book_ref, market_id_ref, general_custodian_id_ref, side_ref, size_ref, price_ref, post_or_abort_ref, fill_or_abort_ref, immediate_or_cancel_ref, market_account_id_ref_mut, lot_size_ref_mut, tick_size_ref_mut, direction_ref_mut, min_base_ref_mut, max_base_ref_mut, max_quote_ref_mut, $c) {
    let temp$1, temp$2, temp$3, temp$4, temp$5, temp$6, temp$7, base, crossed_spread, quote, quote_ceiling, ticks;
    if ($.copy(post_or_abort_ref)) {
        if ($.copy(fill_or_abort_ref)) {
            temp$1 = true;
        }
        else {
            temp$1 = $.copy(immediate_or_cancel_ref);
        }
        temp$3 = !temp$1;
    }
    else {
        if ($.copy(fill_or_abort_ref)) {
            temp$2 = $.copy(immediate_or_cancel_ref);
        }
        else {
            temp$2 = false;
        }
        temp$3 = !temp$2;
    }
    if (!temp$3) {
        throw $.abortCode($.copy(E_TOO_MANY_ORDER_FLAGS));
    }
    if ($.copy(side_ref) == $.copy(ASK)) {
        temp$4 = $.copy(price_ref).le(price_($.copy(order_book_ref.max_bid)));
    }
    else {
        temp$4 = $.copy(price_ref).ge(price_($.copy(order_book_ref.min_ask)));
    }
    crossed_spread = temp$4;
    if (!!($.copy(post_or_abort_ref) && crossed_spread)) {
        throw $.abortCode($.copy(E_POST_OR_ABORT_CROSSED_SPREAD));
    }
    $.set(market_account_id_ref_mut, get_market_account_id_($.copy(market_id_ref), $.copy(general_custodian_id_ref)));
    if ($.copy(side_ref) == $.copy(ASK)) {
        temp$5 = $.copy(SELL);
    }
    else {
        temp$5 = $.copy(BUY);
    }
    $.set(direction_ref_mut, temp$5);
    $.set(lot_size_ref_mut, $.copy(order_book_ref.lot_size));
    $.set(tick_size_ref_mut, $.copy(order_book_ref.tick_size));
    base = u128($.copy(size_ref)).mul(u128($.copy(lot_size_ref_mut)));
    if (!!$.copy(base).gt(u128($.copy(HI_64$1)))) {
        throw $.abortCode($.copy(E_SIZE_BASE_OVERFLOW));
    }
    ticks = u128($.copy(size_ref)).mul(u128($.copy(price_ref)));
    if (!!$.copy(ticks).gt(u128($.copy(HI_64$1)))) {
        throw $.abortCode($.copy(E_SIZE_TICKS_OVERFLOW));
    }
    quote = $.copy(ticks).mul(u128($.copy(tick_size_ref_mut)));
    if (!!$.copy(quote).gt(u128($.copy(HI_64$1)))) {
        throw $.abortCode($.copy(E_SIZE_QUOTE_OVERFLOW));
    }
    $.set(max_base_ref_mut, u64($.copy(base)));
    if ($.copy(fill_or_abort_ref)) {
        temp$6 = u64($.copy(base));
    }
    else {
        temp$6 = u64('0');
    }
    $.set(min_base_ref_mut, temp$6);
    if (crossed_spread) {
        temp$7 = $.copy(side_ref) == $.copy(ASK);
    }
    else {
        temp$7 = false;
    }
    if (temp$7) {
        [, , , , , quote_ceiling] = get_asset_counts_internal_($.copy(user_ref), $.copy(market_account_id_ref_mut), $c);
        $.set(max_quote_ref_mut, $.copy(HI_64$1).sub($.copy(quote_ceiling)));
    }
    else {
        $.set(max_quote_ref_mut, u64($.copy(quote)));
    }
    return;
}
function place_limit_order_user_(user, host, market_id, side, size, price, post_or_abort, fill_or_abort, immediate_or_cancel, $c, $p /* <BaseType, QuoteType>*/) {
    let temp$1, temp$2, temp$3, temp$4, temp$5;
    temp$4 = address_of_(user, $c);
    temp$5 = temp$4;
    temp$3 = host;
    temp$2 = market_id;
    temp$1 = $.copy(NO_CUSTODIAN);
    place_limit_order_(temp$5, temp$3, temp$2, temp$1, side, size, price, post_or_abort, fill_or_abort, immediate_or_cancel, $c, [$p[0], $p[1]]);
    return;
}
function buildPayload_place_limit_order_user(host, market_id, side, size, price, post_or_abort, fill_or_abort, immediate_or_cancel, $p /* <BaseType, QuoteType>*/, isJSON = false) {
    const typeParamStrings = $p.map((t) => $.getTypeTagFullname(t));
    return $.buildPayload(new HexString('0x51d8534aba004732df9a7229f89d6d7a687ad56f8c906e482f62ee298ec7c778'), 'market', 'place_limit_order_user', typeParamStrings, [host, market_id, side, size, price, post_or_abort, fill_or_abort, immediate_or_cancel], isJSON);
}
function place_market_order_(user_ref, host_ref, market_id_ref, general_custodian_id_ref, direction_ref, min_base_ref, max_base_ref, min_quote_ref, max_quote_ref, limit_price_ref, $c, $p /* <BaseType, QuoteType>*/) {
    let lots_filled, market_account_id, order_book_ref_mut, order_books_map_ref_mut;
    verify_order_book_exists_($.copy(host_ref), $.copy(market_id_ref), $c);
    order_books_map_ref_mut = $c.borrow_global_mut(new SimpleStructTag(OrderBooks), $.copy(host_ref)).map;
    order_book_ref_mut = borrow_mut_(order_books_map_ref_mut, $.copy(market_id_ref), $c, [
        AtomicTypeTag.U64,
        new SimpleStructTag(OrderBook)
    ]);
    market_account_id = get_market_account_id_($.copy(market_id_ref), $.copy(general_custodian_id_ref));
    lots_filled = u64('0');
    match_from_market_account_(user_ref, market_account_id, market_id_ref, order_book_ref_mut, direction_ref, min_base_ref, max_base_ref, min_quote_ref, max_quote_ref, limit_price_ref, lots_filled, $c, [$p[0], $p[1]]);
    return;
}
function place_market_order_custodian_(user, host, market_id, direction, min_base, max_base, min_quote, max_quote, limit_price, general_custodian_capability_ref, $c, $p /* <BaseType, QuoteType>*/) {
    let temp$1, temp$2, temp$3, temp$4;
    temp$4 = user;
    temp$3 = host;
    temp$2 = market_id;
    temp$1 = custodian_id_(general_custodian_capability_ref);
    place_market_order_(temp$4, temp$3, temp$2, temp$1, direction, min_base, max_base, min_quote, max_quote, limit_price, $c, [$p[0], $p[1]]);
    return;
}
function place_market_order_user_(user, host, market_id, direction, min_base, max_base, min_quote, max_quote, limit_price, $c, $p /* <BaseType, QuoteType>*/) {
    let temp$1, temp$2, temp$3, temp$4, temp$5;
    temp$4 = address_of_(user, $c);
    temp$5 = temp$4;
    temp$3 = host;
    temp$2 = market_id;
    temp$1 = $.copy(NO_CUSTODIAN);
    place_market_order_(temp$5, temp$3, temp$2, temp$1, direction, min_base, max_base, min_quote, max_quote, limit_price, $c, [$p[0], $p[1]]);
    return;
}
function buildPayload_place_market_order_user(host, market_id, direction, min_base, max_base, min_quote, max_quote, limit_price, $p /* <BaseType, QuoteType>*/, isJSON = false) {
    const typeParamStrings = $p.map((t) => $.getTypeTagFullname(t));
    return $.buildPayload(new HexString('0x51d8534aba004732df9a7229f89d6d7a687ad56f8c906e482f62ee298ec7c778'), 'market', 'place_market_order_user', typeParamStrings, [host, market_id, direction, min_base, max_base, min_quote, max_quote, limit_price], isJSON);
}
function price_levels_vector_(simple_orders, $c) {
    let level_price, level_size, n_simple_orders, price_levels, simple_order_index, simple_order_ref;
    price_levels = empty_$5($c, [new SimpleStructTag(PriceLevel)]);
    if (is_empty_$2(simple_orders, $c, [new SimpleStructTag(SimpleOrder)])) {
        return $.copy(price_levels);
    }
    simple_order_ref = borrow_$7(simple_orders, u64('0'), $c, [new SimpleStructTag(SimpleOrder)]);
    level_price = $.copy(simple_order_ref.price);
    level_size = $.copy(simple_order_ref.size);
    n_simple_orders = length_$6(simple_orders, $c, [new SimpleStructTag(SimpleOrder)]);
    simple_order_index = u64('1');
    while ($.copy(simple_order_index).lt($.copy(n_simple_orders))) {
        {
            simple_order_ref = borrow_$7(simple_orders, $.copy(simple_order_index), $c, [
                new SimpleStructTag(SimpleOrder)
            ]);
            if ($.copy(simple_order_ref.price).neq($.copy(level_price))) {
                push_back_(price_levels, new PriceLevel({ price: $.copy(level_price), size: $.copy(level_size) }, new SimpleStructTag(PriceLevel)), $c, [new SimpleStructTag(PriceLevel)]);
                [level_price, level_size] = [$.copy(simple_order_ref.price), $.copy(simple_order_ref.size)];
            }
            else {
                level_size = $.copy(level_size).add($.copy(simple_order_ref.size));
            }
            simple_order_index = $.copy(simple_order_index).add(u64('1'));
        }
    }
    push_back_(price_levels, new PriceLevel({ price: $.copy(level_price), size: $.copy(level_size) }, new SimpleStructTag(PriceLevel)), $c, [new SimpleStructTag(PriceLevel)]);
    return $.copy(price_levels);
}
function price_levels_vectors_(order_book_ref_mut, $c) {
    return [
        price_levels_vector_(orders_vector_(order_book_ref_mut, $.copy(ASK), $c), $c),
        price_levels_vector_(orders_vector_(order_book_ref_mut, $.copy(BID), $c), $c)
    ];
}
function register_market_(host, lot_size, tick_size, generic_asset_transfer_custodian_id, $c, $p /* <BaseType, QuoteType>*/) {
    let market_id;
    market_id = register_market_internal_(address_of_(host, $c), $.copy(lot_size), $.copy(tick_size), $.copy(generic_asset_transfer_custodian_id), $c, [$p[0], $p[1]]);
    register_order_book_(host, $.copy(market_id), $.copy(lot_size), $.copy(tick_size), $.copy(generic_asset_transfer_custodian_id), $c, [$p[0], $p[1]]);
    return;
}
function register_market_generic_(host, lot_size, tick_size, generic_asset_transfer_custodian_id_ref, $c, $p /* <BaseType, QuoteType>*/) {
    register_market_(host, $.copy(lot_size), $.copy(tick_size), custodian_id_(generic_asset_transfer_custodian_id_ref), $c, [$p[0], $p[1]]);
    return;
}
function register_market_pure_coin_(host, lot_size, tick_size, $c, $p /* <BaseCoinType, QuoteCoinType>*/) {
    register_market_(host, $.copy(lot_size), $.copy(tick_size), $.copy(PURE_COIN_PAIR), $c, [$p[0], $p[1]]);
    return;
}
function buildPayload_register_market_pure_coin(lot_size, tick_size, $p /* <BaseCoinType, QuoteCoinType>*/, isJSON = false) {
    const typeParamStrings = $p.map((t) => $.getTypeTagFullname(t));
    return $.buildPayload(new HexString('0x51d8534aba004732df9a7229f89d6d7a687ad56f8c906e482f62ee298ec7c778'), 'market', 'register_market_pure_coin', typeParamStrings, [lot_size, tick_size], isJSON);
}
function register_order_book_(host, market_id, lot_size, tick_size, generic_asset_transfer_custodian_id, $c, $p /* <BaseType, QuoteType>*/) {
    let temp$1, temp$2, host_address, order_books_map_ref_mut;
    host_address = address_of_(host, $c);
    if (!$c.exists(new SimpleStructTag(OrderBooks), $.copy(host_address))) {
        $c.move_to(new SimpleStructTag(OrderBooks), host, new OrderBooks({ map: empty_($c, [AtomicTypeTag.U64, new SimpleStructTag(OrderBook)]) }, new SimpleStructTag(OrderBooks)));
    }
    order_books_map_ref_mut = $c.borrow_global_mut(new SimpleStructTag(OrderBooks), $.copy(host_address)).map;
    [temp$1, temp$2] = [order_books_map_ref_mut, $.copy(market_id)];
    if (!!contains_(temp$1, temp$2, $c, [AtomicTypeTag.U64, new SimpleStructTag(OrderBook)])) {
        throw $.abortCode($.copy(E_ORDER_BOOK_EXISTS));
    }
    add_$1(order_books_map_ref_mut, $.copy(market_id), new OrderBook({
        base_type_info: type_of_($c, [$p[0]]),
        quote_type_info: type_of_($c, [$p[1]]),
        lot_size: $.copy(lot_size),
        tick_size: $.copy(tick_size),
        generic_asset_transfer_custodian_id: $.copy(generic_asset_transfer_custodian_id),
        asks: empty_$1($c, [new SimpleStructTag(Order)]),
        bids: empty_$1($c, [new SimpleStructTag(Order)]),
        min_ask: $.copy(MIN_ASK_DEFAULT),
        max_bid: $.copy(MAX_BID_DEFAULT),
        counter: u64('0')
    }, new SimpleStructTag(OrderBook)), $c, [AtomicTypeTag.U64, new SimpleStructTag(OrderBook)]);
    return;
}
function swap_$1(host_ref, market_id_ref, direction_ref, min_base_ref, max_base_ref, min_quote_ref, max_quote_ref, limit_price_ref, optional_base_coins_ref_mut, optional_quote_coins_ref_mut, base_filled_ref_mut, quote_filled_ref_mut, generic_asset_transfer_custodian_id_ref, $c, $p /* <BaseType, QuoteType>*/) {
    let temp$1, temp$10, temp$11, temp$12, temp$2, temp$3, temp$4, temp$5, temp$6, temp$7, temp$8, temp$9, lot_size, lots_filled, order_book_ref_mut, order_books_map_ref_mut, tick_size, ticks_filled;
    verify_order_book_exists_($.copy(host_ref), $.copy(market_id_ref), $c);
    order_books_map_ref_mut = $c.borrow_global_mut(new SimpleStructTag(OrderBooks), $.copy(host_ref)).map;
    order_book_ref_mut = borrow_mut_(order_books_map_ref_mut, $.copy(market_id_ref), $c, [
        AtomicTypeTag.U64,
        new SimpleStructTag(OrderBook)
    ]);
    if (!$.copy(generic_asset_transfer_custodian_id_ref).eq($.copy(order_book_ref_mut.generic_asset_transfer_custodian_id))) {
        throw $.abortCode($.copy(E_INVALID_CUSTODIAN));
    }
    lot_size = $.copy(order_book_ref_mut.lot_size);
    tick_size = $.copy(order_book_ref_mut.tick_size);
    [lots_filled, ticks_filled] = [u64('0'), u64('0')];
    temp$12 = market_id_ref;
    temp$11 = order_book_ref_mut;
    temp$10 = lot_size;
    temp$9 = tick_size;
    temp$8 = direction_ref;
    temp$6 = $.copy(min_base_ref).div($.copy(lot_size));
    temp$7 = temp$6;
    temp$4 = $.copy(max_base_ref).div($.copy(lot_size));
    temp$5 = temp$4;
    temp$2 = $.copy(min_quote_ref).div($.copy(tick_size));
    temp$3 = temp$2;
    temp$1 = $.copy(max_quote_ref).div($.copy(tick_size));
    match_(temp$12, temp$11, temp$10, temp$9, temp$8, temp$7, temp$5, temp$3, temp$1, limit_price_ref, optional_base_coins_ref_mut, optional_quote_coins_ref_mut, lots_filled, ticks_filled, $c, [$p[0], $p[1]]);
    $.set(base_filled_ref_mut, $.copy(lots_filled).mul($.copy(lot_size)));
    $.set(quote_filled_ref_mut, $.copy(ticks_filled).mul($.copy(tick_size)));
    return;
}
function swap_between_coinstores_(user, host, market_id, direction, min_base, max_base, min_quote, max_quote, limit_price, $c, $p /* <BaseCoinType, QuoteCoinType>*/) {
    let temp$1, temp$10, temp$11, temp$12, temp$13, temp$14, temp$15, temp$2, temp$3, temp$4, temp$5, temp$6, temp$7, temp$8, temp$9, base_filled_drop, base_value, optional_base_coins, optional_quote_coins, quote_filled_drop, quote_value, user_address;
    user_address = address_of_(user, $c);
    if (!is_account_registered_($.copy(user_address), $c, [$p[0]])) {
        register_$2(user, $c, [$p[0]]);
    }
    if (!is_account_registered_($.copy(user_address), $c, [$p[1]])) {
        register_$2(user, $c, [$p[1]]);
    }
    base_value = balance_$1($.copy(user_address), $c, [$p[0]]);
    quote_value = balance_$1($.copy(user_address), $c, [$p[1]]);
    match_range_check_fills_(direction, min_base, max_base, min_quote, max_quote, base_value, base_value, quote_value, quote_value);
    if (direction == $.copy(BUY)) {
        [temp$1, temp$2] = [
            some_(zero_$1($c, [$p[0]]), $c, [
                new StructTag(new HexString('0x1'), 'coin', 'Coin', [$p[0]])
            ]),
            some_(withdraw_$1(user, $.copy(max_quote), $c, [$p[1]]), $c, [
                new StructTag(new HexString('0x1'), 'coin', 'Coin', [$p[1]])
            ])
        ];
    }
    else {
        [temp$1, temp$2] = [
            some_(withdraw_$1(user, $.copy(max_base), $c, [$p[0]]), $c, [
                new StructTag(new HexString('0x1'), 'coin', 'Coin', [$p[0]])
            ]),
            some_(zero_$1($c, [$p[1]]), $c, [
                new StructTag(new HexString('0x1'), 'coin', 'Coin', [$p[1]])
            ])
        ];
    }
    [optional_base_coins, optional_quote_coins] = [temp$1, temp$2];
    [base_filled_drop, quote_filled_drop] = [u64('0'), u64('0')];
    temp$15 = host;
    temp$14 = market_id;
    temp$13 = direction;
    temp$12 = min_base;
    temp$11 = max_base;
    temp$10 = min_quote;
    temp$9 = max_quote;
    temp$8 = limit_price;
    temp$7 = optional_base_coins;
    temp$6 = optional_quote_coins;
    temp$5 = base_filled_drop;
    temp$4 = quote_filled_drop;
    temp$3 = $.copy(PURE_COIN_PAIR);
    swap_$1(temp$15, temp$14, temp$13, temp$12, temp$11, temp$10, temp$9, temp$8, temp$7, temp$6, temp$5, temp$4, temp$3, $c, [$p[0], $p[1]]);
    deposit_$1($.copy(user_address), destroy_some_(optional_base_coins, $c, [
        new StructTag(new HexString('0x1'), 'coin', 'Coin', [$p[0]])
    ]), $c, [$p[0]]);
    deposit_$1($.copy(user_address), destroy_some_(optional_quote_coins, $c, [
        new StructTag(new HexString('0x1'), 'coin', 'Coin', [$p[1]])
    ]), $c, [$p[1]]);
    return;
}
function buildPayload_swap_between_coinstores(host, market_id, direction, min_base, max_base, min_quote, max_quote, limit_price, $p /* <BaseCoinType, QuoteCoinType>*/, isJSON = false) {
    const typeParamStrings = $p.map((t) => $.getTypeTagFullname(t));
    return $.buildPayload(new HexString('0x51d8534aba004732df9a7229f89d6d7a687ad56f8c906e482f62ee298ec7c778'), 'market', 'swap_between_coinstores', typeParamStrings, [host, market_id, direction, min_base, max_base, min_quote, max_quote, limit_price], isJSON);
}
function swap_coins_(host, market_id, direction, min_base, max_base, min_quote, max_quote, limit_price, base_coins_ref_mut, quote_coins_ref_mut, $c, $p /* <BaseCoinType, QuoteCoinType>*/) {
    let temp$1, temp$10, temp$11, temp$12, temp$13, temp$14, temp$15, temp$2, temp$3, temp$4, temp$5, temp$6, temp$7, temp$8, temp$9, base_filled, base_value, optional_base_coins, optional_quote_coins, quote_filled, quote_value;
    base_value = value_(base_coins_ref_mut, $c, [$p[0]]);
    quote_value = value_(quote_coins_ref_mut, $c, [$p[1]]);
    match_range_check_fills_(direction, min_base, max_base, min_quote, max_quote, base_value, base_value, quote_value, quote_value);
    if (direction == $.copy(BUY)) {
        [temp$1, temp$2] = [
            some_(zero_$1($c, [$p[0]]), $c, [
                new StructTag(new HexString('0x1'), 'coin', 'Coin', [$p[0]])
            ]),
            some_(extract_(quote_coins_ref_mut, $.copy(max_quote), $c, [$p[1]]), $c, [
                new StructTag(new HexString('0x1'), 'coin', 'Coin', [$p[1]])
            ])
        ];
    }
    else {
        [temp$1, temp$2] = [
            some_(extract_(base_coins_ref_mut, $.copy(max_base), $c, [$p[0]]), $c, [
                new StructTag(new HexString('0x1'), 'coin', 'Coin', [$p[0]])
            ]),
            some_(zero_$1($c, [$p[1]]), $c, [
                new StructTag(new HexString('0x1'), 'coin', 'Coin', [$p[1]])
            ])
        ];
    }
    [optional_base_coins, optional_quote_coins] = [temp$1, temp$2];
    [base_filled, quote_filled] = [u64('0'), u64('0')];
    temp$15 = host;
    temp$14 = market_id;
    temp$13 = direction;
    temp$12 = min_base;
    temp$11 = max_base;
    temp$10 = min_quote;
    temp$9 = max_quote;
    temp$8 = limit_price;
    temp$7 = optional_base_coins;
    temp$6 = optional_quote_coins;
    temp$5 = base_filled;
    temp$4 = quote_filled;
    temp$3 = $.copy(PURE_COIN_PAIR);
    swap_$1(temp$15, temp$14, temp$13, temp$12, temp$11, temp$10, temp$9, temp$8, temp$7, temp$6, temp$5, temp$4, temp$3, $c, [$p[0], $p[1]]);
    merge_(base_coins_ref_mut, destroy_some_(optional_base_coins, $c, [
        new StructTag(new HexString('0x1'), 'coin', 'Coin', [$p[0]])
    ]), $c, [$p[0]]);
    merge_(quote_coins_ref_mut, destroy_some_(optional_quote_coins, $c, [
        new StructTag(new HexString('0x1'), 'coin', 'Coin', [$p[1]])
    ]), $c, [$p[1]]);
    return [$.copy(base_filled), $.copy(quote_filled)];
}
function swap_coins_simulate_(host, market_id, direction, min_base, max_base, min_quote, max_quote, limit_price, base_coins_ref_mut, quote_coins_ref_mut, $c, $p /* <BaseCoinType, QuoteCoinType>*/) {
    return swap_coins_($.copy(host), $.copy(market_id), direction, $.copy(min_base), $.copy(max_base), $.copy(min_quote), $.copy(max_quote), $.copy(limit_price), base_coins_ref_mut, quote_coins_ref_mut, $c, [$p[0], $p[1]]);
}
function swap_generic_(host, market_id, direction, min_base, max_base, min_quote, max_quote, limit_price, optional_base_coins_ref_mut, optional_quote_coins_ref_mut, generic_asset_transfer_custodian_capability_ref, $c, $p /* <BaseType, QuoteType>*/) {
    let temp$1, temp$2, temp$3, temp$4, base_filled, base_is_coin, base_value, generic_asset_transfer_custodian_id, quote_filled, quote_is_coin, quote_value;
    base_is_coin = is_coin_initialized_($c, [$p[0]]);
    quote_is_coin = is_coin_initialized_($c, [$p[1]]);
    if (!!(base_is_coin && quote_is_coin)) {
        throw $.abortCode($.copy(E_BOTH_COINS));
    }
    if (!(base_is_coin ==
        is_some_(optional_base_coins_ref_mut, $c, [
            new StructTag(new HexString('0x1'), 'coin', 'Coin', [$p[0]])
        ]))) {
        throw $.abortCode($.copy(E_INVALID_OPTION_BASE));
    }
    if (!(quote_is_coin ==
        is_some_(optional_quote_coins_ref_mut, $c, [
            new StructTag(new HexString('0x1'), 'coin', 'Coin', [$p[1]])
        ]))) {
        throw $.abortCode($.copy(E_INVALID_OPTION_QUOTE));
    }
    if (base_is_coin) {
        temp$2 = value_(borrow_$6(optional_base_coins_ref_mut, $c, [
            new StructTag(new HexString('0x1'), 'coin', 'Coin', [$p[0]])
        ]), $c, [$p[0]]);
    }
    else {
        if (direction == $.copy(BUY)) {
            temp$1 = u64('0');
        }
        else {
            temp$1 = $.copy(max_base);
        }
        temp$2 = temp$1;
    }
    base_value = temp$2;
    if (quote_is_coin) {
        temp$4 = value_(borrow_$6(optional_quote_coins_ref_mut, $c, [
            new StructTag(new HexString('0x1'), 'coin', 'Coin', [$p[1]])
        ]), $c, [$p[1]]);
    }
    else {
        if (direction == $.copy(BUY)) {
            temp$3 = $.copy(max_quote);
        }
        else {
            temp$3 = u64('0');
        }
        temp$4 = temp$3;
    }
    quote_value = temp$4;
    match_range_check_fills_(direction, min_base, max_base, min_quote, max_quote, base_value, base_value, quote_value, quote_value);
    [base_filled, quote_filled] = [u64('0'), u64('0')];
    generic_asset_transfer_custodian_id = custodian_id_(generic_asset_transfer_custodian_capability_ref);
    swap_$1(host, market_id, direction, min_base, max_base, min_quote, max_quote, limit_price, optional_base_coins_ref_mut, optional_quote_coins_ref_mut, base_filled, quote_filled, generic_asset_transfer_custodian_id, $c, [$p[0], $p[1]]);
    return [$.copy(base_filled), $.copy(quote_filled)];
}
function verify_order_book_exists_(host, market_id, $c) {
    let order_books_map_ref;
    if (!$c.exists(new SimpleStructTag(OrderBooks), $.copy(host))) {
        throw $.abortCode($.copy(E_NO_ORDER_BOOKS));
    }
    order_books_map_ref = $c.borrow_global(new SimpleStructTag(OrderBooks), $.copy(host)).map;
    if (!contains_(order_books_map_ref, $.copy(market_id), $c, [
        AtomicTypeTag.U64,
        new SimpleStructTag(OrderBook)
    ])) {
        throw $.abortCode($.copy(E_NO_ORDER_BOOK));
    }
    return;
}
function loadParsers$j(repo) {
    repo.addParser('0x51d8534aba004732df9a7229f89d6d7a687ad56f8c906e482f62ee298ec7c778::market::Order', Order.OrderParser);
    repo.addParser('0x51d8534aba004732df9a7229f89d6d7a687ad56f8c906e482f62ee298ec7c778::market::OrderBook', OrderBook.OrderBookParser);
    repo.addParser('0x51d8534aba004732df9a7229f89d6d7a687ad56f8c906e482f62ee298ec7c778::market::OrderBooks', OrderBooks.OrderBooksParser);
    repo.addParser('0x51d8534aba004732df9a7229f89d6d7a687ad56f8c906e482f62ee298ec7c778::market::PriceLevel', PriceLevel.PriceLevelParser);
    repo.addParser('0x51d8534aba004732df9a7229f89d6d7a687ad56f8c906e482f62ee298ec7c778::market::SimpleOrder', SimpleOrder.SimpleOrderParser);
}
class App$k {
    constructor(client, repo, cache) {
        this.client = client;
        this.repo = repo;
        this.cache = cache;
    }
    get moduleAddress() {
        {
            return moduleAddress$d;
        }
    }
    get moduleName() {
        {
            return moduleName$d;
        }
    }
    get Order() {
        return Order;
    }
    get OrderBook() {
        return OrderBook;
    }
    get OrderBooks() {
        return OrderBooks;
    }
    loadOrderBooks(owner, loadFull = true, fillCache = true) {
        return __awaiter(this, void 0, void 0, function* () {
            const val = yield OrderBooks.load(this.repo, this.client, owner, []);
            if (loadFull) {
                yield val.loadFullState(this);
            }
            if (fillCache) {
                this.cache.set(val.typeTag, owner, val);
            }
            return val;
        });
    }
    get PriceLevel() {
        return PriceLevel;
    }
    get SimpleOrder() {
        return SimpleOrder;
    }
    payload_cancel_all_limit_orders_user(host, market_id, side, isJSON = false) {
        return buildPayload_cancel_all_limit_orders_user(host, market_id, side, isJSON);
    }
    cancel_all_limit_orders_user(_account, host, market_id, side, option, _isJSON = false) {
        return __awaiter(this, void 0, void 0, function* () {
            const payload__ = buildPayload_cancel_all_limit_orders_user(host, market_id, side, _isJSON);
            return $.sendPayloadTx(this.client, _account, payload__, option);
        });
    }
    payload_cancel_limit_order_user(host, market_id, side, order_id, isJSON = false) {
        return buildPayload_cancel_limit_order_user(host, market_id, side, order_id, isJSON);
    }
    cancel_limit_order_user(_account, host, market_id, side, order_id, option, _isJSON = false) {
        return __awaiter(this, void 0, void 0, function* () {
            const payload__ = buildPayload_cancel_limit_order_user(host, market_id, side, order_id, _isJSON);
            return $.sendPayloadTx(this.client, _account, payload__, option);
        });
    }
    payload_place_limit_order_user(host, market_id, side, size, price, post_or_abort, fill_or_abort, immediate_or_cancel, $p /* <BaseType, QuoteType>*/, isJSON = false) {
        return buildPayload_place_limit_order_user(host, market_id, side, size, price, post_or_abort, fill_or_abort, immediate_or_cancel, $p, isJSON);
    }
    place_limit_order_user(_account, host, market_id, side, size, price, post_or_abort, fill_or_abort, immediate_or_cancel, $p /* <BaseType, QuoteType>*/, option, _isJSON = false) {
        return __awaiter(this, void 0, void 0, function* () {
            const payload__ = buildPayload_place_limit_order_user(host, market_id, side, size, price, post_or_abort, fill_or_abort, immediate_or_cancel, $p, _isJSON);
            return $.sendPayloadTx(this.client, _account, payload__, option);
        });
    }
    payload_place_market_order_user(host, market_id, direction, min_base, max_base, min_quote, max_quote, limit_price, $p /* <BaseType, QuoteType>*/, isJSON = false) {
        return buildPayload_place_market_order_user(host, market_id, direction, min_base, max_base, min_quote, max_quote, limit_price, $p, isJSON);
    }
    place_market_order_user(_account, host, market_id, direction, min_base, max_base, min_quote, max_quote, limit_price, $p /* <BaseType, QuoteType>*/, option, _isJSON = false) {
        return __awaiter(this, void 0, void 0, function* () {
            const payload__ = buildPayload_place_market_order_user(host, market_id, direction, min_base, max_base, min_quote, max_quote, limit_price, $p, _isJSON);
            return $.sendPayloadTx(this.client, _account, payload__, option);
        });
    }
    payload_register_market_pure_coin(lot_size, tick_size, $p /* <BaseCoinType, QuoteCoinType>*/, isJSON = false) {
        return buildPayload_register_market_pure_coin(lot_size, tick_size, $p, isJSON);
    }
    register_market_pure_coin(_account, lot_size, tick_size, $p /* <BaseCoinType, QuoteCoinType>*/, option, _isJSON = false) {
        return __awaiter(this, void 0, void 0, function* () {
            const payload__ = buildPayload_register_market_pure_coin(lot_size, tick_size, $p, _isJSON);
            return $.sendPayloadTx(this.client, _account, payload__, option);
        });
    }
    payload_swap_between_coinstores(host, market_id, direction, min_base, max_base, min_quote, max_quote, limit_price, $p /* <BaseCoinType, QuoteCoinType>*/, isJSON = false) {
        return buildPayload_swap_between_coinstores(host, market_id, direction, min_base, max_base, min_quote, max_quote, limit_price, $p, isJSON);
    }
    swap_between_coinstores(_account, host, market_id, direction, min_base, max_base, min_quote, max_quote, limit_price, $p /* <BaseCoinType, QuoteCoinType>*/, option, _isJSON = false) {
        return __awaiter(this, void 0, void 0, function* () {
            const payload__ = buildPayload_swap_between_coinstores(host, market_id, direction, min_base, max_base, min_quote, max_quote, limit_price, $p, _isJSON);
            return $.sendPayloadTx(this.client, _account, payload__, option);
        });
    }
}

var Market = /*#__PURE__*/Object.freeze({
    __proto__: null,
    packageName: packageName$d,
    moduleAddress: moduleAddress$d,
    moduleName: moduleName$d,
    ASK: ASK,
    BID: BID,
    BUY: BUY,
    E_BOTH_COINS: E_BOTH_COINS,
    E_INBOUND_ASSET_OVERFLOW: E_INBOUND_ASSET_OVERFLOW,
    E_INVALID_BASE: E_INVALID_BASE,
    E_INVALID_CUSTODIAN: E_INVALID_CUSTODIAN,
    E_INVALID_OPTION_BASE: E_INVALID_OPTION_BASE,
    E_INVALID_OPTION_QUOTE: E_INVALID_OPTION_QUOTE,
    E_INVALID_QUOTE: E_INVALID_QUOTE,
    E_INVALID_USER: E_INVALID_USER,
    E_LIMIT_PRICE_0: E_LIMIT_PRICE_0,
    E_MIN_BASE_EXCEEDS_MAX: E_MIN_BASE_EXCEEDS_MAX,
    E_MIN_LOTS_NOT_FILLED: E_MIN_LOTS_NOT_FILLED,
    E_MIN_QUOTE_EXCEEDS_MAX: E_MIN_QUOTE_EXCEEDS_MAX,
    E_MIN_TICKS_NOT_FILLED: E_MIN_TICKS_NOT_FILLED,
    E_NOT_ENOUGH_OUTBOUND_ASSET: E_NOT_ENOUGH_OUTBOUND_ASSET,
    E_NO_ORDER: E_NO_ORDER,
    E_NO_ORDER_BOOK: E_NO_ORDER_BOOK,
    E_NO_ORDER_BOOKS: E_NO_ORDER_BOOKS,
    E_ORDER_BOOK_EXISTS: E_ORDER_BOOK_EXISTS,
    E_POST_OR_ABORT_CROSSED_SPREAD: E_POST_OR_ABORT_CROSSED_SPREAD,
    E_SIZE_BASE_OVERFLOW: E_SIZE_BASE_OVERFLOW,
    E_SIZE_QUOTE_OVERFLOW: E_SIZE_QUOTE_OVERFLOW,
    E_SIZE_TICKS_OVERFLOW: E_SIZE_TICKS_OVERFLOW,
    E_TOO_MANY_ORDER_FLAGS: E_TOO_MANY_ORDER_FLAGS,
    HI_64: HI_64$1,
    LEFT: LEFT,
    MAX_BID_DEFAULT: MAX_BID_DEFAULT,
    MIN_ASK_DEFAULT: MIN_ASK_DEFAULT,
    NO_CUSTODIAN: NO_CUSTODIAN,
    PURE_COIN_PAIR: PURE_COIN_PAIR,
    RIGHT: RIGHT,
    SELL: SELL,
    Order: Order,
    OrderBook: OrderBook,
    OrderBooks: OrderBooks,
    PriceLevel: PriceLevel,
    SimpleOrder: SimpleOrder,
    cancel_all_limit_orders_: cancel_all_limit_orders_,
    cancel_all_limit_orders_custodian_: cancel_all_limit_orders_custodian_,
    cancel_all_limit_orders_user_: cancel_all_limit_orders_user_,
    buildPayload_cancel_all_limit_orders_user: buildPayload_cancel_all_limit_orders_user,
    cancel_limit_order_: cancel_limit_order_,
    cancel_limit_order_custodian_: cancel_limit_order_custodian_,
    cancel_limit_order_user_: cancel_limit_order_user_,
    buildPayload_cancel_limit_order_user: buildPayload_cancel_limit_order_user,
    get_counter_: get_counter_,
    match_: match_,
    match_from_market_account_: match_from_market_account_,
    match_init_: match_init_,
    match_loop_: match_loop_,
    match_loop_break_: match_loop_break_,
    match_loop_init_: match_loop_init_,
    match_loop_order_: match_loop_order_,
    match_loop_order_fill_size_: match_loop_order_fill_size_,
    match_loop_order_follow_up_: match_loop_order_follow_up_,
    match_range_check_fills_: match_range_check_fills_,
    match_verify_fills_: match_verify_fills_,
    orders_vector_: orders_vector_,
    orders_vectors_: orders_vectors_,
    place_limit_order_: place_limit_order_,
    place_limit_order_custodian_: place_limit_order_custodian_,
    place_limit_order_post_match_: place_limit_order_post_match_,
    place_limit_order_pre_match_: place_limit_order_pre_match_,
    place_limit_order_user_: place_limit_order_user_,
    buildPayload_place_limit_order_user: buildPayload_place_limit_order_user,
    place_market_order_: place_market_order_,
    place_market_order_custodian_: place_market_order_custodian_,
    place_market_order_user_: place_market_order_user_,
    buildPayload_place_market_order_user: buildPayload_place_market_order_user,
    price_levels_vector_: price_levels_vector_,
    price_levels_vectors_: price_levels_vectors_,
    register_market_: register_market_,
    register_market_generic_: register_market_generic_,
    register_market_pure_coin_: register_market_pure_coin_,
    buildPayload_register_market_pure_coin: buildPayload_register_market_pure_coin,
    register_order_book_: register_order_book_,
    swap_: swap_$1,
    swap_between_coinstores_: swap_between_coinstores_,
    buildPayload_swap_between_coinstores: buildPayload_swap_between_coinstores,
    swap_coins_: swap_coins_,
    swap_coins_simulate_: swap_coins_simulate_,
    swap_generic_: swap_generic_,
    verify_order_book_exists_: verify_order_book_exists_,
    loadParsers: loadParsers$j,
    App: App$k
});

function loadParsers$i(repo) {
    loadParsers$p(repo);
    loadParsers$o(repo);
    loadParsers$j(repo);
    loadParsers$n(repo);
    loadParsers$l(repo);
    loadParsers$k(repo);
}
function getPackageRepo$5() {
    const repo = new AptosParserRepo();
    loadParsers$i(repo);
    repo.addDefaultParsers();
    return repo;
}
class App$j {
    constructor(client, repo, cache) {
        this.client = client;
        this.repo = repo;
        this.cache = cache;
        this.assets = new App$q(client, repo, cache);
        this.critbit = new App$p(client, repo, cache);
        this.market = new App$k(client, repo, cache);
        this.open_table = new App$o(client, repo, cache);
        this.order_id = new App$n(client, repo, cache);
        this.registry = new App$m(client, repo, cache);
        this.user = new App$l(client, repo, cache);
    }
}

var econia = /*#__PURE__*/Object.freeze({
    __proto__: null,
    loadParsers: loadParsers$i,
    getPackageRepo: getPackageRepo$5,
    App: App$j,
    Assets: Assets,
    Critbit: Critbit,
    Market: Market,
    Open_table: Open_table,
    Order_id: Order_id,
    Registry: Registry$1,
    User: User
});

const packageName$c = 'Liquidswap';
const moduleAddress$c = new HexString('0x190d44266241744264b964a37b8f09863167a12d3e70cda39376cfb4e3561e12');
const moduleName$c = 'coin_helper';
const ERR_CANNOT_BE_THE_SAME_COIN = u64('3000');
const ERR_IS_NOT_COIN = u64('3001');
const SYMBOL_PREFIX_LENGTH = u64('4');
function compare_$2($c, $p /* <X, Y>*/) {
    let address_cmp, module_cmp, struct_cmp, x_address, x_info, x_module_name, x_struct_name, y_address, y_info, y_module_name, y_struct_name;
    x_info = type_of_($c, [$p[0]]);
    y_info = type_of_($c, [$p[1]]);
    x_struct_name = struct_name_(x_info);
    y_struct_name = struct_name_(y_info);
    struct_cmp = compare_$3(x_struct_name, y_struct_name, $c, [new VectorTag(AtomicTypeTag.U8)]);
    if (!is_equal_(struct_cmp)) {
        return struct_cmp;
    }
    x_module_name = module_name_(x_info);
    y_module_name = module_name_(y_info);
    module_cmp = compare_$3(x_module_name, y_module_name, $c, [new VectorTag(AtomicTypeTag.U8)]);
    if (!is_equal_(module_cmp)) {
        return module_cmp;
    }
    x_address = account_address_(x_info);
    y_address = account_address_(y_info);
    address_cmp = compare_$3(x_address, y_address, $c, [AtomicTypeTag.Address]);
    return address_cmp;
}
function is_sorted_($c, $p /* <X, Y>*/) {
    let order;
    order = compare_$2($c, [$p[0], $p[1]]);
    if (!!is_equal_(order)) {
        throw $.abortCode($.copy(ERR_CANNOT_BE_THE_SAME_COIN));
    }
    return is_smaller_than_(order);
}
function loadParsers$h(repo) { }
class App$i {
    constructor(client, repo, cache) {
        this.client = client;
        this.repo = repo;
        this.cache = cache;
    }
    get moduleAddress() {
        {
            return moduleAddress$c;
        }
    }
    get moduleName() {
        {
            return moduleName$c;
        }
    }
}

var Coin_helper = /*#__PURE__*/Object.freeze({
    __proto__: null,
    packageName: packageName$c,
    moduleAddress: moduleAddress$c,
    moduleName: moduleName$c,
    ERR_CANNOT_BE_THE_SAME_COIN: ERR_CANNOT_BE_THE_SAME_COIN,
    ERR_IS_NOT_COIN: ERR_IS_NOT_COIN,
    SYMBOL_PREFIX_LENGTH: SYMBOL_PREFIX_LENGTH,
    compare_: compare_$2,
    is_sorted_: is_sorted_,
    loadParsers: loadParsers$h,
    App: App$i
});

const packageName$b = 'Liquidswap';
const moduleAddress$b = new HexString('0x190d44266241744264b964a37b8f09863167a12d3e70cda39376cfb4e3561e12');
const moduleName$b = 'curves';
const ERR_INVALID_CURVE = u64('10001');
class Stable {
    constructor(proto, typeTag) {
        this.typeTag = typeTag;
        this.__app = null;
    }
    static StableParser(data, typeTag, repo) {
        const proto = $.parseStructProto(data, typeTag, repo, Stable);
        return new Stable(proto, typeTag);
    }
    static getTag() {
        return new StructTag(moduleAddress$b, moduleName$b, 'Stable', []);
    }
    loadFullState(app) {
        return __awaiter(this, void 0, void 0, function* () {
            this.__app = app;
        });
    }
}
Stable.moduleAddress = moduleAddress$b;
Stable.moduleName = moduleName$b;
Stable.structName = 'Stable';
Stable.typeParameters = [];
Stable.fields = [];
class Uncorrelated {
    constructor(proto, typeTag) {
        this.typeTag = typeTag;
        this.__app = null;
    }
    static UncorrelatedParser(data, typeTag, repo) {
        const proto = $.parseStructProto(data, typeTag, repo, Uncorrelated);
        return new Uncorrelated(proto, typeTag);
    }
    static getTag() {
        return new StructTag(moduleAddress$b, moduleName$b, 'Uncorrelated', []);
    }
    loadFullState(app) {
        return __awaiter(this, void 0, void 0, function* () {
            this.__app = app;
        });
    }
}
Uncorrelated.moduleAddress = moduleAddress$b;
Uncorrelated.moduleName = moduleName$b;
Uncorrelated.structName = 'Uncorrelated';
Uncorrelated.typeParameters = [];
Uncorrelated.fields = [];
function assert_valid_curve_($c, $p /* <Curve>*/) {
    if (!is_valid_curve_($c, [$p[0]])) {
        throw $.abortCode($.copy(ERR_INVALID_CURVE));
    }
    return;
}
function is_stable_($c, $p /* <Curve>*/) {
    return $.deep_eq(type_of_($c, [$p[0]]), type_of_($c, [new SimpleStructTag(Stable)]));
}
function is_uncorrelated_($c, $p /* <Curve>*/) {
    return $.deep_eq(type_of_($c, [$p[0]]), type_of_($c, [new SimpleStructTag(Uncorrelated)]));
}
function is_valid_curve_($c, $p /* <Curve>*/) {
    let temp$1;
    if (is_uncorrelated_($c, [$p[0]])) {
        temp$1 = true;
    }
    else {
        temp$1 = is_stable_($c, [$p[0]]);
    }
    return temp$1;
}
function loadParsers$g(repo) {
    repo.addParser('0x190d44266241744264b964a37b8f09863167a12d3e70cda39376cfb4e3561e12::curves::Stable', Stable.StableParser);
    repo.addParser('0x190d44266241744264b964a37b8f09863167a12d3e70cda39376cfb4e3561e12::curves::Uncorrelated', Uncorrelated.UncorrelatedParser);
}
class App$h {
    constructor(client, repo, cache) {
        this.client = client;
        this.repo = repo;
        this.cache = cache;
    }
    get moduleAddress() {
        {
            return moduleAddress$b;
        }
    }
    get moduleName() {
        {
            return moduleName$b;
        }
    }
    get Stable() {
        return Stable;
    }
    get Uncorrelated() {
        return Uncorrelated;
    }
}

var Curves = /*#__PURE__*/Object.freeze({
    __proto__: null,
    packageName: packageName$b,
    moduleAddress: moduleAddress$b,
    moduleName: moduleName$b,
    ERR_INVALID_CURVE: ERR_INVALID_CURVE,
    Stable: Stable,
    Uncorrelated: Uncorrelated,
    assert_valid_curve_: assert_valid_curve_,
    is_stable_: is_stable_,
    is_uncorrelated_: is_uncorrelated_,
    is_valid_curve_: is_valid_curve_,
    loadParsers: loadParsers$g,
    App: App$h
});

const packageName$a = 'Liquidswap';
const moduleAddress$a = new HexString('0x190d44266241744264b964a37b8f09863167a12d3e70cda39376cfb4e3561e12');
const moduleName$a = 'liquidity_pool';
const ERR_DISABLED = u64('4002');
const ERR_EMERGENCY = u64('4001');
const ERR_POOL_DOES_NOT_EXIST = u64('107');
const ERR_POOL_IS_LOCKED = u64('111');
const ERR_WRONG_PAIR_ORDERING = u64('100');
const FEE_SCALE = u64('10000');
class IsEmergency {
    constructor(proto, typeTag) {
        this.typeTag = typeTag;
        this.__app = null;
    }
    static IsEmergencyParser(data, typeTag, repo) {
        const proto = $.parseStructProto(data, typeTag, repo, IsEmergency);
        return new IsEmergency(proto, typeTag);
    }
    static load(repo, client, address, typeParams) {
        return __awaiter(this, void 0, void 0, function* () {
            const result = yield repo.loadResource(client, address, IsEmergency, typeParams);
            return result;
        });
    }
    static loadByApp(app, address, typeParams) {
        return __awaiter(this, void 0, void 0, function* () {
            const result = yield app.repo.loadResource(app.client, address, IsEmergency, typeParams);
            yield result.loadFullState(app);
            return result;
        });
    }
    static getTag() {
        return new StructTag(moduleAddress$a, moduleName$a, 'IsEmergency', []);
    }
    loadFullState(app) {
        return __awaiter(this, void 0, void 0, function* () {
            this.__app = app;
        });
    }
}
IsEmergency.moduleAddress = moduleAddress$a;
IsEmergency.moduleName = moduleName$a;
IsEmergency.structName = 'IsEmergency';
IsEmergency.typeParameters = [];
IsEmergency.fields = [];
class LiquidityPool {
    constructor(proto, typeTag) {
        this.typeTag = typeTag;
        this.__app = null;
        this.coin_x_reserve = proto['coin_x_reserve'];
        this.coin_y_reserve = proto['coin_y_reserve'];
        this.last_block_timestamp = proto['last_block_timestamp'];
        this.last_price_x_cumulative = proto['last_price_x_cumulative'];
        this.last_price_y_cumulative = proto['last_price_y_cumulative'];
        this.lp_mint_cap = proto['lp_mint_cap'];
        this.lp_burn_cap = proto['lp_burn_cap'];
        this.x_scale = proto['x_scale'];
        this.y_scale = proto['y_scale'];
        this.locked = proto['locked'];
        this.fee = proto['fee'];
        this.dao_fee = proto['dao_fee'];
    }
    static LiquidityPoolParser(data, typeTag, repo) {
        const proto = $.parseStructProto(data, typeTag, repo, LiquidityPool);
        return new LiquidityPool(proto, typeTag);
    }
    static load(repo, client, address, typeParams) {
        return __awaiter(this, void 0, void 0, function* () {
            const result = yield repo.loadResource(client, address, LiquidityPool, typeParams);
            return result;
        });
    }
    static loadByApp(app, address, typeParams) {
        return __awaiter(this, void 0, void 0, function* () {
            const result = yield app.repo.loadResource(app.client, address, LiquidityPool, typeParams);
            yield result.loadFullState(app);
            return result;
        });
    }
    static makeTag($p) {
        return new StructTag(moduleAddress$a, moduleName$a, 'LiquidityPool', $p);
    }
    loadFullState(app) {
        return __awaiter(this, void 0, void 0, function* () {
            yield this.coin_x_reserve.loadFullState(app);
            yield this.coin_y_reserve.loadFullState(app);
            yield this.lp_mint_cap.loadFullState(app);
            yield this.lp_burn_cap.loadFullState(app);
            this.__app = app;
        });
    }
}
LiquidityPool.moduleAddress = moduleAddress$a;
LiquidityPool.moduleName = moduleName$a;
LiquidityPool.structName = 'LiquidityPool';
LiquidityPool.typeParameters = [
    { name: 'X', isPhantom: true },
    { name: 'Y', isPhantom: true },
    { name: 'Curve', isPhantom: true }
];
LiquidityPool.fields = [
    { name: 'coin_x_reserve', typeTag: new StructTag(new HexString('0x1'), 'coin', 'Coin', [new $.TypeParamIdx(0)]) },
    { name: 'coin_y_reserve', typeTag: new StructTag(new HexString('0x1'), 'coin', 'Coin', [new $.TypeParamIdx(1)]) },
    { name: 'last_block_timestamp', typeTag: AtomicTypeTag.U64 },
    { name: 'last_price_x_cumulative', typeTag: AtomicTypeTag.U128 },
    { name: 'last_price_y_cumulative', typeTag: AtomicTypeTag.U128 },
    {
        name: 'lp_mint_cap',
        typeTag: new StructTag(new HexString('0x1'), 'coin', 'MintCapability', [
            new StructTag(new HexString('0x05a97986a9d031c4567e15b797be516910cfcb4156312482efc6a19c0a30c948'), 'lp_coin', 'LP', [new $.TypeParamIdx(0), new $.TypeParamIdx(1), new $.TypeParamIdx(2)])
        ])
    },
    {
        name: 'lp_burn_cap',
        typeTag: new StructTag(new HexString('0x1'), 'coin', 'BurnCapability', [
            new StructTag(new HexString('0x05a97986a9d031c4567e15b797be516910cfcb4156312482efc6a19c0a30c948'), 'lp_coin', 'LP', [new $.TypeParamIdx(0), new $.TypeParamIdx(1), new $.TypeParamIdx(2)])
        ])
    },
    { name: 'x_scale', typeTag: AtomicTypeTag.U64 },
    { name: 'y_scale', typeTag: AtomicTypeTag.U64 },
    { name: 'locked', typeTag: AtomicTypeTag.Bool },
    { name: 'fee', typeTag: AtomicTypeTag.U64 },
    { name: 'dao_fee', typeTag: AtomicTypeTag.U64 }
];
function assert_no_emergency_($c) {
    if (!!is_emergency_($c)) {
        throw $.abortCode($.copy(ERR_EMERGENCY));
    }
    return;
}
function assert_pool_unlocked_($c, $p /* <X, Y, Curve>*/) {
    let pool;
    pool = $c.borrow_global(new SimpleStructTag(LiquidityPool, [$p[0], $p[1], $p[2]]), new HexString('0x05a97986a9d031c4567e15b797be516910cfcb4156312482efc6a19c0a30c948'));
    if (!($.copy(pool.locked) == false)) {
        throw $.abortCode($.copy(ERR_POOL_IS_LOCKED));
    }
    return;
}
function get_decimals_scales_$1($c, $p /* <X, Y, Curve>*/) {
    let pool;
    if (!is_sorted_($c, [$p[0], $p[1]])) {
        throw $.abortCode($.copy(ERR_WRONG_PAIR_ORDERING));
    }
    if (!$c.exists(new SimpleStructTag(LiquidityPool, [$p[0], $p[1], $p[2]]), new HexString('0x05a97986a9d031c4567e15b797be516910cfcb4156312482efc6a19c0a30c948'))) {
        throw $.abortCode($.copy(ERR_POOL_DOES_NOT_EXIST));
    }
    pool = $c.borrow_global(new SimpleStructTag(LiquidityPool, [$p[0], $p[1], $p[2]]), new HexString('0x05a97986a9d031c4567e15b797be516910cfcb4156312482efc6a19c0a30c948'));
    return [$.copy(pool.x_scale), $.copy(pool.y_scale)];
}
function get_fee_($c, $p /* <X, Y, Curve>*/) {
    let pool;
    if (!is_sorted_($c, [$p[0], $p[1]])) {
        throw $.abortCode($.copy(ERR_WRONG_PAIR_ORDERING));
    }
    if (!$c.exists(new SimpleStructTag(LiquidityPool, [$p[0], $p[1], $p[2]]), new HexString('0x05a97986a9d031c4567e15b797be516910cfcb4156312482efc6a19c0a30c948'))) {
        throw $.abortCode($.copy(ERR_POOL_DOES_NOT_EXIST));
    }
    pool = $c.borrow_global(new SimpleStructTag(LiquidityPool, [$p[0], $p[1], $p[2]]), new HexString('0x05a97986a9d031c4567e15b797be516910cfcb4156312482efc6a19c0a30c948'));
    return $.copy(pool.fee);
}
function get_fees_config_$1($c, $p /* <X, Y, Curve>*/) {
    return [get_fee_($c, [$p[0], $p[1], $p[2]]), $.copy(FEE_SCALE)];
}
function get_reserves_size_$1($c, $p /* <X, Y, Curve>*/) {
    let liquidity_pool, x_reserve, y_reserve;
    assert_no_emergency_($c);
    if (!is_sorted_($c, [$p[0], $p[1]])) {
        throw $.abortCode($.copy(ERR_WRONG_PAIR_ORDERING));
    }
    if (!$c.exists(new SimpleStructTag(LiquidityPool, [$p[0], $p[1], $p[2]]), new HexString('0x05a97986a9d031c4567e15b797be516910cfcb4156312482efc6a19c0a30c948'))) {
        throw $.abortCode($.copy(ERR_POOL_DOES_NOT_EXIST));
    }
    assert_pool_unlocked_($c, [$p[0], $p[1], $p[2]]);
    liquidity_pool = $c.borrow_global(new SimpleStructTag(LiquidityPool, [$p[0], $p[1], $p[2]]), new HexString('0x05a97986a9d031c4567e15b797be516910cfcb4156312482efc6a19c0a30c948'));
    x_reserve = value_(liquidity_pool.coin_x_reserve, $c, [$p[0]]);
    y_reserve = value_(liquidity_pool.coin_y_reserve, $c, [$p[1]]);
    return [$.copy(x_reserve), $.copy(y_reserve)];
}
function is_emergency_($c) {
    return $c.exists(new SimpleStructTag(IsEmergency), new HexString('0xa6d6e549b917e454464ff6c63f91386d98769ea512bc778bdaca00969f896764'));
}
function loadParsers$f(repo) {
    repo.addParser('0x190d44266241744264b964a37b8f09863167a12d3e70cda39376cfb4e3561e12::liquidity_pool::IsEmergency', IsEmergency.IsEmergencyParser);
    repo.addParser('0x190d44266241744264b964a37b8f09863167a12d3e70cda39376cfb4e3561e12::liquidity_pool::LiquidityPool', LiquidityPool.LiquidityPoolParser);
}
class App$g {
    constructor(client, repo, cache) {
        this.client = client;
        this.repo = repo;
        this.cache = cache;
    }
    get moduleAddress() {
        {
            return moduleAddress$a;
        }
    }
    get moduleName() {
        {
            return moduleName$a;
        }
    }
    get IsEmergency() {
        return IsEmergency;
    }
    loadIsEmergency(owner, loadFull = true, fillCache = true) {
        return __awaiter(this, void 0, void 0, function* () {
            const val = yield IsEmergency.load(this.repo, this.client, owner, []);
            if (loadFull) {
                yield val.loadFullState(this);
            }
            if (fillCache) {
                this.cache.set(val.typeTag, owner, val);
            }
            return val;
        });
    }
    get LiquidityPool() {
        return LiquidityPool;
    }
    loadLiquidityPool(owner, $p /* <X, Y, Curve> */, loadFull = true, fillCache = true) {
        return __awaiter(this, void 0, void 0, function* () {
            const val = yield LiquidityPool.load(this.repo, this.client, owner, $p);
            if (loadFull) {
                yield val.loadFullState(this);
            }
            if (fillCache) {
                this.cache.set(val.typeTag, owner, val);
            }
            return val;
        });
    }
}

var Liquidity_pool = /*#__PURE__*/Object.freeze({
    __proto__: null,
    packageName: packageName$a,
    moduleAddress: moduleAddress$a,
    moduleName: moduleName$a,
    ERR_DISABLED: ERR_DISABLED,
    ERR_EMERGENCY: ERR_EMERGENCY,
    ERR_POOL_DOES_NOT_EXIST: ERR_POOL_DOES_NOT_EXIST,
    ERR_POOL_IS_LOCKED: ERR_POOL_IS_LOCKED,
    ERR_WRONG_PAIR_ORDERING: ERR_WRONG_PAIR_ORDERING,
    FEE_SCALE: FEE_SCALE,
    IsEmergency: IsEmergency,
    LiquidityPool: LiquidityPool,
    assert_no_emergency_: assert_no_emergency_,
    assert_pool_unlocked_: assert_pool_unlocked_,
    get_decimals_scales_: get_decimals_scales_$1,
    get_fee_: get_fee_,
    get_fees_config_: get_fees_config_$1,
    get_reserves_size_: get_reserves_size_$1,
    is_emergency_: is_emergency_,
    loadParsers: loadParsers$f,
    App: App$g
});

const packageName$9 = 'Liquidswap';
const moduleAddress$9 = new HexString('0x190d44266241744264b964a37b8f09863167a12d3e70cda39376cfb4e3561e12');
const moduleName$9 = 'math';
const ERR_DIVIDE_BY_ZERO$1 = u64('2000');
function mul_div_(x, y, z, $c) {
    let r;
    if (!$.copy(z).neq(u64('0'))) {
        throw $.abortCode($.copy(ERR_DIVIDE_BY_ZERO$1));
    }
    r = u128($.copy(x))
        .mul(u128($.copy(y)))
        .div(u128($.copy(z)));
    return u64($.copy(r));
}
function mul_to_u128_(x, y, $c) {
    return u128($.copy(x)).mul(u128($.copy(y)));
}
function loadParsers$e(repo) { }
class App$f {
    constructor(client, repo, cache) {
        this.client = client;
        this.repo = repo;
        this.cache = cache;
    }
    get moduleAddress() {
        {
            return moduleAddress$9;
        }
    }
    get moduleName() {
        {
            return moduleName$9;
        }
    }
}

var Math$1 = /*#__PURE__*/Object.freeze({
    __proto__: null,
    packageName: packageName$9,
    moduleAddress: moduleAddress$9,
    moduleName: moduleName$9,
    ERR_DIVIDE_BY_ZERO: ERR_DIVIDE_BY_ZERO$1,
    mul_div_: mul_div_,
    mul_to_u128_: mul_to_u128_,
    loadParsers: loadParsers$e,
    App: App$f
});

const packageName$8 = 'U256';
const moduleAddress$8 = new HexString('0x4e9fce03284c0ce0b86c88dd5a46f050cad2f4f33c4cdd29d98f501868558c81');
const moduleName$8 = 'u256';
const ECAST_OVERFLOW = u64('0');
const EDIV_BY_ZERO = u64('3');
const EOVERFLOW = u64('2');
const EQUAL$1 = u8('0');
const EWORDS_OVERFLOW = u64('1');
const GREATER_THAN$1 = u8('2');
const LESS_THAN$1 = u8('1');
const U128_MAX = u128('340282366920938463463374607431768211455');
const U64_MAX = u128('18446744073709551615');
const WORDS = u64('4');
class DU256 {
    constructor(proto, typeTag) {
        this.typeTag = typeTag;
        this.__app = null;
        this.v0 = proto['v0'];
        this.v1 = proto['v1'];
        this.v2 = proto['v2'];
        this.v3 = proto['v3'];
        this.v4 = proto['v4'];
        this.v5 = proto['v5'];
        this.v6 = proto['v6'];
        this.v7 = proto['v7'];
    }
    static DU256Parser(data, typeTag, repo) {
        const proto = $.parseStructProto(data, typeTag, repo, DU256);
        return new DU256(proto, typeTag);
    }
    static getTag() {
        return new StructTag(moduleAddress$8, moduleName$8, 'DU256', []);
    }
    loadFullState(app) {
        return __awaiter(this, void 0, void 0, function* () {
            this.__app = app;
        });
    }
}
DU256.moduleAddress = moduleAddress$8;
DU256.moduleName = moduleName$8;
DU256.structName = 'DU256';
DU256.typeParameters = [];
DU256.fields = [
    { name: 'v0', typeTag: AtomicTypeTag.U64 },
    { name: 'v1', typeTag: AtomicTypeTag.U64 },
    { name: 'v2', typeTag: AtomicTypeTag.U64 },
    { name: 'v3', typeTag: AtomicTypeTag.U64 },
    { name: 'v4', typeTag: AtomicTypeTag.U64 },
    { name: 'v5', typeTag: AtomicTypeTag.U64 },
    { name: 'v6', typeTag: AtomicTypeTag.U64 },
    { name: 'v7', typeTag: AtomicTypeTag.U64 }
];
class U256 {
    constructor(proto, typeTag) {
        this.typeTag = typeTag;
        this.__app = null;
        this.v0 = proto['v0'];
        this.v1 = proto['v1'];
        this.v2 = proto['v2'];
        this.v3 = proto['v3'];
    }
    static U256Parser(data, typeTag, repo) {
        const proto = $.parseStructProto(data, typeTag, repo, U256);
        return new U256(proto, typeTag);
    }
    static getTag() {
        return new StructTag(moduleAddress$8, moduleName$8, 'U256', []);
    }
    loadFullState(app) {
        return __awaiter(this, void 0, void 0, function* () {
            this.__app = app;
        });
    }
}
U256.moduleAddress = moduleAddress$8;
U256.moduleName = moduleName$8;
U256.structName = 'U256';
U256.typeParameters = [];
U256.fields = [
    { name: 'v0', typeTag: AtomicTypeTag.U64 },
    { name: 'v1', typeTag: AtomicTypeTag.U64 },
    { name: 'v2', typeTag: AtomicTypeTag.U64 },
    { name: 'v3', typeTag: AtomicTypeTag.U64 }
];
function add_(a, b, $c) {
    let a1, b1, carry, i, is_overflow, is_overflow1, is_overflow2, res, res1, res2, ret;
    ret = zero_();
    carry = u64('0');
    i = u64('0');
    while ($.copy(i).lt($.copy(WORDS))) {
        {
            a1 = get_(a, $.copy(i));
            b1 = get_(b, $.copy(i));
            if ($.copy(carry).neq(u64('0'))) {
                [res1, is_overflow1] = overflowing_add_($.copy(a1), $.copy(b1));
                [res2, is_overflow2] = overflowing_add_($.copy(res1), $.copy(carry));
                put_(ret, $.copy(i), $.copy(res2));
                carry = u64('0');
                if (is_overflow1) {
                    carry = $.copy(carry).add(u64('1'));
                }
                if (is_overflow2) {
                    carry = $.copy(carry).add(u64('1'));
                }
            }
            else {
                [res, is_overflow] = overflowing_add_($.copy(a1), $.copy(b1));
                put_(ret, $.copy(i), $.copy(res));
                carry = u64('0');
                if (is_overflow) {
                    carry = u64('1');
                }
            }
            i = $.copy(i).add(u64('1'));
        }
    }
    if (!$.copy(carry).eq(u64('0'))) {
        throw $.abortCode($.copy(EOVERFLOW));
    }
    return $.copy(ret);
}
function as_u128_(a, $c) {
    let temp$1;
    if ($.copy(a.v2).eq(u64('0'))) {
        temp$1 = $.copy(a.v3).eq(u64('0'));
    }
    else {
        temp$1 = false;
    }
    if (!temp$1) {
        throw $.abortCode($.copy(ECAST_OVERFLOW));
    }
    return u128($.copy(a.v1))
        .shl(u8('64'))
        .add(u128($.copy(a.v0)));
}
function as_u64_(a, $c) {
    let temp$1, temp$2;
    if ($.copy(a.v1).eq(u64('0'))) {
        temp$1 = $.copy(a.v2).eq(u64('0'));
    }
    else {
        temp$1 = false;
    }
    if (temp$1) {
        temp$2 = $.copy(a.v3).eq(u64('0'));
    }
    else {
        temp$2 = false;
    }
    if (!temp$2) {
        throw $.abortCode($.copy(ECAST_OVERFLOW));
    }
    return $.copy(a.v0);
}
function bitand_(a, b, $c) {
    let a1, b1, i, ret;
    ret = zero_();
    i = u64('0');
    while ($.copy(i).lt($.copy(WORDS))) {
        {
            a1 = get_(a, $.copy(i));
            b1 = get_(b, $.copy(i));
            put_(ret, $.copy(i), $.copy(a1).and($.copy(b1)));
            i = $.copy(i).add(u64('1'));
        }
    }
    return $.copy(ret);
}
function bitor_(a, b, $c) {
    let a1, b1, i, ret;
    ret = zero_();
    i = u64('0');
    while ($.copy(i).lt($.copy(WORDS))) {
        {
            a1 = get_(a, $.copy(i));
            b1 = get_(b, $.copy(i));
            put_(ret, $.copy(i), $.copy(a1).or($.copy(b1)));
            i = $.copy(i).add(u64('1'));
        }
    }
    return $.copy(ret);
}
function bits_(a, $c) {
    let a1, a1__1, i;
    i = u64('1');
    while ($.copy(i).lt($.copy(WORDS))) {
        {
            a1 = get_(a, $.copy(WORDS).sub($.copy(i)));
            if ($.copy(a1).gt(u64('0'))) {
                return u64('64')
                    .mul($.copy(WORDS).sub($.copy(i)).add(u64('1')))
                    .sub(u64(leading_zeros_u64_($.copy(a1))));
            }
            i = $.copy(i).add(u64('1'));
        }
    }
    a1__1 = get_(a, u64('0'));
    return u64('64').sub(u64(leading_zeros_u64_($.copy(a1__1))));
}
function bitxor_(a, b, $c) {
    let a1, b1, i, ret;
    ret = zero_();
    i = u64('0');
    while ($.copy(i).lt($.copy(WORDS))) {
        {
            a1 = get_(a, $.copy(i));
            b1 = get_(b, $.copy(i));
            put_(ret, $.copy(i), $.copy(a1).xor($.copy(b1)));
            i = $.copy(i).add(u64('1'));
        }
    }
    return $.copy(ret);
}
function compare_$1(a, b, $c) {
    let a1, b1, i;
    i = $.copy(WORDS);
    while ($.copy(i).gt(u64('0'))) {
        {
            i = $.copy(i).sub(u64('1'));
            a1 = get_(a, $.copy(i));
            b1 = get_(b, $.copy(i));
            if ($.copy(a1).neq($.copy(b1))) {
                if ($.copy(a1).lt($.copy(b1))) {
                    return $.copy(LESS_THAN$1);
                }
                else {
                    return $.copy(GREATER_THAN$1);
                }
            }
        }
    }
    return $.copy(EQUAL$1);
}
function div_$1(a, b, $c) {
    let temp$1, a_bits, b_bits, c, cmp, index, m, ret, shift;
    ret = zero_();
    a_bits = bits_(a);
    b_bits = bits_(b);
    if (!$.copy(b_bits).neq(u64('0'))) {
        throw $.abortCode($.copy(EDIV_BY_ZERO));
    }
    if ($.copy(a_bits).lt($.copy(b_bits))) {
        return $.copy(ret);
    }
    shift = $.copy(a_bits).sub($.copy(b_bits));
    b = shl_($.copy(b), u8($.copy(shift)));
    while (true) {
        cmp = compare_$1(a, b);
        if ($.copy(cmp).eq($.copy(GREATER_THAN$1))) {
            temp$1 = true;
        }
        else {
            temp$1 = $.copy(cmp).eq($.copy(EQUAL$1));
        }
        if (temp$1) {
            index = $.copy(shift).div(u64('64'));
            m = get_(ret, $.copy(index));
            c = $.copy(m).or(u64('1').shl(u8($.copy(shift).mod(u64('64')))));
            put_(ret, $.copy(index), $.copy(c));
            a = sub_($.copy(a), $.copy(b));
        }
        b = shr_($.copy(b), u8('1'));
        if ($.copy(shift).eq(u64('0'))) {
            break;
        }
        shift = $.copy(shift).sub(u64('1'));
    }
    return $.copy(ret);
}
function du256_to_u256_(a, $c) {
    let temp$1, temp$2, temp$3, b, overflow;
    b = new U256({ v0: $.copy(a.v0), v1: $.copy(a.v1), v2: $.copy(a.v2), v3: $.copy(a.v3) }, new SimpleStructTag(U256));
    overflow = false;
    if ($.copy(a.v4).neq(u64('0'))) {
        temp$1 = true;
    }
    else {
        temp$1 = $.copy(a.v5).neq(u64('0'));
    }
    if (temp$1) {
        temp$2 = true;
    }
    else {
        temp$2 = $.copy(a.v6).neq(u64('0'));
    }
    if (temp$2) {
        temp$3 = true;
    }
    else {
        temp$3 = $.copy(a.v7).neq(u64('0'));
    }
    if (temp$3) {
        overflow = true;
    }
    return [$.copy(b), overflow];
}
function from_u128_(val, $c) {
    let a1, a2;
    [a2, a1] = split_u128_($.copy(val));
    return new U256({ v0: $.copy(a1), v1: $.copy(a2), v2: u64('0'), v3: u64('0') }, new SimpleStructTag(U256));
}
function from_u64_(val, $c) {
    return from_u128_(u128($.copy(val)));
}
function get_(a, i, $c) {
    let temp$1, temp$2, temp$3, temp$4;
    if ($.copy(i).eq(u64('0'))) {
        temp$4 = $.copy(a.v0);
    }
    else {
        if ($.copy(i).eq(u64('1'))) {
            temp$3 = $.copy(a.v1);
        }
        else {
            if ($.copy(i).eq(u64('2'))) {
                temp$2 = $.copy(a.v2);
            }
            else {
                if ($.copy(i).eq(u64('3'))) {
                    temp$1 = $.copy(a.v3);
                }
                else {
                    throw $.abortCode($.copy(EWORDS_OVERFLOW));
                }
                temp$2 = temp$1;
            }
            temp$3 = temp$2;
        }
        temp$4 = temp$3;
    }
    return temp$4;
}
function get_d_(a, i, $c) {
    let temp$1, temp$2, temp$3, temp$4, temp$5, temp$6, temp$7, temp$8;
    if ($.copy(i).eq(u64('0'))) {
        temp$8 = $.copy(a.v0);
    }
    else {
        if ($.copy(i).eq(u64('1'))) {
            temp$7 = $.copy(a.v1);
        }
        else {
            if ($.copy(i).eq(u64('2'))) {
                temp$6 = $.copy(a.v2);
            }
            else {
                if ($.copy(i).eq(u64('3'))) {
                    temp$5 = $.copy(a.v3);
                }
                else {
                    if ($.copy(i).eq(u64('4'))) {
                        temp$4 = $.copy(a.v4);
                    }
                    else {
                        if ($.copy(i).eq(u64('5'))) {
                            temp$3 = $.copy(a.v5);
                        }
                        else {
                            if ($.copy(i).eq(u64('6'))) {
                                temp$2 = $.copy(a.v6);
                            }
                            else {
                                if ($.copy(i).eq(u64('7'))) {
                                    temp$1 = $.copy(a.v7);
                                }
                                else {
                                    throw $.abortCode($.copy(EWORDS_OVERFLOW));
                                }
                                temp$2 = temp$1;
                            }
                            temp$3 = temp$2;
                        }
                        temp$4 = temp$3;
                    }
                    temp$5 = temp$4;
                }
                temp$6 = temp$5;
            }
            temp$7 = temp$6;
        }
        temp$8 = temp$7;
    }
    return temp$8;
}
function leading_zeros_u64_(a, $c) {
    let temp$3, a1, a2, b, b__2, bit, bit__1;
    if ($.copy(a).eq(u64('0'))) {
        return u8('64');
    }
    a1 = $.copy(a).and(u64('4294967295'));
    a2 = $.copy(a).shr(u8('32'));
    if ($.copy(a2).eq(u64('0'))) {
        bit = u8('32');
        while ($.copy(bit).ge(u8('1'))) {
            {
                b = $.copy(a1)
                    .shr($.copy(bit).sub(u8('1')))
                    .and(u64('1'));
                if ($.copy(b).neq(u64('0'))) {
                    break;
                }
                bit = $.copy(bit).sub(u8('1'));
            }
        }
        temp$3 = u8('32').sub($.copy(bit)).add(u8('32'));
    }
    else {
        bit__1 = u8('64');
        while ($.copy(bit__1).ge(u8('1'))) {
            {
                b__2 = $.copy(a)
                    .shr($.copy(bit__1).sub(u8('1')))
                    .and(u64('1'));
                if ($.copy(b__2).neq(u64('0'))) {
                    break;
                }
                bit__1 = $.copy(bit__1).sub(u8('1'));
            }
        }
        temp$3 = u8('64').sub($.copy(bit__1));
    }
    return temp$3;
}
function mul_$1(a, b, $c) {
    let temp$1, temp$3, temp$7, a1, b1, carry, existing_hi, existing_low, hi, hi__4, hi__5, hi__6, i, j, low, low__2, o, o0, o1, overflow, overflow__8, r, ret;
    ret = new DU256({ v0: u64('0'), v1: u64('0'), v2: u64('0'), v3: u64('0'), v4: u64('0'), v5: u64('0'), v6: u64('0'), v7: u64('0') }, new SimpleStructTag(DU256));
    i = u64('0');
    while ($.copy(i).lt($.copy(WORDS))) {
        {
            carry = u64('0');
            b1 = get_(b, $.copy(i));
            j = u64('0');
            while ($.copy(j).lt($.copy(WORDS))) {
                {
                    a1 = get_(a, $.copy(j));
                    if ($.copy(a1).neq(u64('0'))) {
                        temp$1 = true;
                    }
                    else {
                        temp$1 = $.copy(carry).neq(u64('0'));
                    }
                    if (temp$1) {
                        [hi, low] = split_u128_(u128($.copy(a1)).mul(u128($.copy(b1))));
                        existing_low = get_d_(ret, $.copy(i).add($.copy(j)));
                        [low__2, o] = overflowing_add_($.copy(low), $.copy(existing_low));
                        put_d_(ret, $.copy(i).add($.copy(j)), $.copy(low__2));
                        if (o) {
                            temp$3 = u64('1');
                        }
                        else {
                            temp$3 = u64('0');
                        }
                        overflow = temp$3;
                        existing_hi = get_d_(ret, $.copy(i).add($.copy(j)).add(u64('1')));
                        hi__4 = $.copy(hi).add($.copy(overflow));
                        [hi__5, o0] = overflowing_add_($.copy(hi__4), $.copy(carry));
                        [hi__6, o1] = overflowing_add_($.copy(hi__5), $.copy(existing_hi));
                        put_d_(ret, $.copy(i).add($.copy(j)).add(u64('1')), $.copy(hi__6));
                        if (o0 || o1) {
                            temp$7 = u64('1');
                        }
                        else {
                            temp$7 = u64('0');
                        }
                        carry = temp$7;
                    }
                    j = $.copy(j).add(u64('1'));
                }
            }
            i = $.copy(i).add(u64('1'));
        }
    }
    [r, overflow__8] = du256_to_u256_($.copy(ret));
    if (!!overflow__8) {
        throw $.abortCode($.copy(EOVERFLOW));
    }
    return $.copy(r);
}
function overflowing_add_(a, b, $c) {
    let temp$1, temp$2, a128, b128, overflow, r;
    a128 = u128($.copy(a));
    b128 = u128($.copy(b));
    r = $.copy(a128).add($.copy(b128));
    if ($.copy(r).gt($.copy(U64_MAX))) {
        overflow = $.copy(r).sub($.copy(U64_MAX)).sub(u128('1'));
        [temp$1, temp$2] = [u64($.copy(overflow)), true];
    }
    else {
        [temp$1, temp$2] = [u64($.copy(a128).add($.copy(b128))), false];
    }
    return [temp$1, temp$2];
}
function overflowing_sub_(a, b, $c) {
    let temp$1, temp$2, r;
    if ($.copy(a).lt($.copy(b))) {
        r = $.copy(b).sub($.copy(a));
        [temp$1, temp$2] = [u64($.copy(U64_MAX)).sub($.copy(r)).add(u64('1')), true];
    }
    else {
        [temp$1, temp$2] = [$.copy(a).sub($.copy(b)), false];
    }
    return [temp$1, temp$2];
}
function put_(a, i, val, $c) {
    if ($.copy(i).eq(u64('0'))) {
        a.v0 = $.copy(val);
    }
    else {
        if ($.copy(i).eq(u64('1'))) {
            a.v1 = $.copy(val);
        }
        else {
            if ($.copy(i).eq(u64('2'))) {
                a.v2 = $.copy(val);
            }
            else {
                if ($.copy(i).eq(u64('3'))) {
                    a.v3 = $.copy(val);
                }
                else {
                    throw $.abortCode($.copy(EWORDS_OVERFLOW));
                }
            }
        }
    }
    return;
}
function put_d_(a, i, val, $c) {
    if ($.copy(i).eq(u64('0'))) {
        a.v0 = $.copy(val);
    }
    else {
        if ($.copy(i).eq(u64('1'))) {
            a.v1 = $.copy(val);
        }
        else {
            if ($.copy(i).eq(u64('2'))) {
                a.v2 = $.copy(val);
            }
            else {
                if ($.copy(i).eq(u64('3'))) {
                    a.v3 = $.copy(val);
                }
                else {
                    if ($.copy(i).eq(u64('4'))) {
                        a.v4 = $.copy(val);
                    }
                    else {
                        if ($.copy(i).eq(u64('5'))) {
                            a.v5 = $.copy(val);
                        }
                        else {
                            if ($.copy(i).eq(u64('6'))) {
                                a.v6 = $.copy(val);
                            }
                            else {
                                if ($.copy(i).eq(u64('7'))) {
                                    a.v7 = $.copy(val);
                                }
                                else {
                                    throw $.abortCode($.copy(EWORDS_OVERFLOW));
                                }
                            }
                        }
                    }
                }
            }
        }
    }
    return;
}
function shl_(a, shift, $c) {
    let bit_shift, i, j, m, m__1, ret, word_shift;
    ret = zero_();
    word_shift = u64($.copy(shift)).div(u64('64'));
    bit_shift = u64($.copy(shift)).mod(u64('64'));
    i = $.copy(word_shift);
    while ($.copy(i).lt($.copy(WORDS))) {
        {
            m = get_(a, $.copy(i).sub($.copy(word_shift))).shl(u8($.copy(bit_shift)));
            put_(ret, $.copy(i), $.copy(m));
            i = $.copy(i).add(u64('1'));
        }
    }
    if ($.copy(bit_shift).gt(u64('0'))) {
        j = $.copy(word_shift).add(u64('1'));
        while ($.copy(j).lt($.copy(WORDS))) {
            {
                m__1 = get_(ret, $.copy(j)).add(get_(a, $.copy(j).sub(u64('1')).sub($.copy(word_shift))).shr(u8('64').sub(u8($.copy(bit_shift)))));
                put_(ret, $.copy(j), $.copy(m__1));
                j = $.copy(j).add(u64('1'));
            }
        }
    }
    return $.copy(ret);
}
function shr_(a, shift, $c) {
    let bit_shift, i, j, m, m__1, ret, word_shift;
    ret = zero_();
    word_shift = u64($.copy(shift)).div(u64('64'));
    bit_shift = u64($.copy(shift)).mod(u64('64'));
    i = $.copy(word_shift);
    while ($.copy(i).lt($.copy(WORDS))) {
        {
            m = get_(a, $.copy(i)).shr(u8($.copy(bit_shift)));
            put_(ret, $.copy(i).sub($.copy(word_shift)), $.copy(m));
            i = $.copy(i).add(u64('1'));
        }
    }
    if ($.copy(bit_shift).gt(u64('0'))) {
        j = $.copy(word_shift).add(u64('1'));
        while ($.copy(j).lt($.copy(WORDS))) {
            {
                m__1 = get_(ret, $.copy(j).sub($.copy(word_shift)).sub(u64('1'))).add(get_(a, $.copy(j)).shl(u8('64').sub(u8($.copy(bit_shift)))));
                put_(ret, $.copy(j).sub($.copy(word_shift)).sub(u64('1')), $.copy(m__1));
                j = $.copy(j).add(u64('1'));
            }
        }
    }
    return $.copy(ret);
}
function split_u128_(a, $c) {
    let a1, a2;
    a1 = u64($.copy(a).shr(u8('64')));
    a2 = u64($.copy(a).and(u128('18446744073709551615')));
    return [$.copy(a1), $.copy(a2)];
}
function sub_(a, b, $c) {
    let a1, b1, carry, i, is_overflow, is_overflow1, is_overflow2, res, res1, res2, ret;
    ret = zero_();
    carry = u64('0');
    i = u64('0');
    while ($.copy(i).lt($.copy(WORDS))) {
        {
            a1 = get_(a, $.copy(i));
            b1 = get_(b, $.copy(i));
            if ($.copy(carry).neq(u64('0'))) {
                [res1, is_overflow1] = overflowing_sub_($.copy(a1), $.copy(b1));
                [res2, is_overflow2] = overflowing_sub_($.copy(res1), $.copy(carry));
                put_(ret, $.copy(i), $.copy(res2));
                carry = u64('0');
                if (is_overflow1) {
                    carry = $.copy(carry).add(u64('1'));
                }
                if (is_overflow2) {
                    carry = $.copy(carry).add(u64('1'));
                }
            }
            else {
                [res, is_overflow] = overflowing_sub_($.copy(a1), $.copy(b1));
                put_(ret, $.copy(i), $.copy(res));
                carry = u64('0');
                if (is_overflow) {
                    carry = u64('1');
                }
            }
            i = $.copy(i).add(u64('1'));
        }
    }
    if (!$.copy(carry).eq(u64('0'))) {
        throw $.abortCode($.copy(EOVERFLOW));
    }
    return $.copy(ret);
}
function zero_($c) {
    return new U256({ v0: u64('0'), v1: u64('0'), v2: u64('0'), v3: u64('0') }, new SimpleStructTag(U256));
}
function loadParsers$d(repo) {
    repo.addParser('0x4e9fce03284c0ce0b86c88dd5a46f050cad2f4f33c4cdd29d98f501868558c81::u256::DU256', DU256.DU256Parser);
    repo.addParser('0x4e9fce03284c0ce0b86c88dd5a46f050cad2f4f33c4cdd29d98f501868558c81::u256::U256', U256.U256Parser);
}
class App$e {
    constructor(client, repo, cache) {
        this.client = client;
        this.repo = repo;
        this.cache = cache;
    }
    get moduleAddress() {
        {
            return moduleAddress$8;
        }
    }
    get moduleName() {
        {
            return moduleName$8;
        }
    }
    get DU256() {
        return DU256;
    }
    get U256() {
        return U256;
    }
}

var U256$1 = /*#__PURE__*/Object.freeze({
    __proto__: null,
    packageName: packageName$8,
    moduleAddress: moduleAddress$8,
    moduleName: moduleName$8,
    ECAST_OVERFLOW: ECAST_OVERFLOW,
    EDIV_BY_ZERO: EDIV_BY_ZERO,
    EOVERFLOW: EOVERFLOW,
    EQUAL: EQUAL$1,
    EWORDS_OVERFLOW: EWORDS_OVERFLOW,
    GREATER_THAN: GREATER_THAN$1,
    LESS_THAN: LESS_THAN$1,
    U128_MAX: U128_MAX,
    U64_MAX: U64_MAX,
    WORDS: WORDS,
    DU256: DU256,
    U256: U256,
    add_: add_,
    as_u128_: as_u128_,
    as_u64_: as_u64_,
    bitand_: bitand_,
    bitor_: bitor_,
    bits_: bits_,
    bitxor_: bitxor_,
    compare_: compare_$1,
    div_: div_$1,
    du256_to_u256_: du256_to_u256_,
    from_u128_: from_u128_,
    from_u64_: from_u64_,
    get_: get_,
    get_d_: get_d_,
    leading_zeros_u64_: leading_zeros_u64_,
    mul_: mul_$1,
    overflowing_add_: overflowing_add_,
    overflowing_sub_: overflowing_sub_,
    put_: put_,
    put_d_: put_d_,
    shl_: shl_,
    shr_: shr_,
    split_u128_: split_u128_,
    sub_: sub_,
    zero_: zero_,
    loadParsers: loadParsers$d,
    App: App$e
});

function loadParsers$c(repo) {
    loadParsers$d(repo);
}
function getPackageRepo$4() {
    const repo = new AptosParserRepo();
    loadParsers$c(repo);
    repo.addDefaultParsers();
    return repo;
}
class App$d {
    constructor(client, repo, cache) {
        this.client = client;
        this.repo = repo;
        this.cache = cache;
        this.u256 = new App$e(client, repo, cache);
    }
}

var u256 = /*#__PURE__*/Object.freeze({
    __proto__: null,
    loadParsers: loadParsers$c,
    getPackageRepo: getPackageRepo$4,
    App: App$d,
    U256: U256$1
});

const packageName$7 = 'Liquidswap';
const moduleAddress$7 = new HexString('0x190d44266241744264b964a37b8f09863167a12d3e70cda39376cfb4e3561e12');
const moduleName$7 = 'stable_curve';
const ONE_E_8 = u128('100000000');
function coin_out_(coin_in, scale_in, scale_out, reserve_in, reserve_out, $c) {
    let amount_in, r, reserve_in_u256, reserve_out_u256, total_reserve, u2561e8, xy, y;
    u2561e8 = from_u128_($.copy(ONE_E_8));
    xy = lp_value_($.copy(reserve_in), $.copy(scale_in), $.copy(reserve_out), $.copy(scale_out));
    reserve_in_u256 = div_$1(mul_$1(from_u128_($.copy(reserve_in)), $.copy(u2561e8)), from_u64_($.copy(scale_in)));
    reserve_out_u256 = div_$1(mul_$1(from_u128_($.copy(reserve_out)), $.copy(u2561e8)), from_u64_($.copy(scale_out)));
    amount_in = div_$1(mul_$1(from_u128_($.copy(coin_in)), $.copy(u2561e8)), from_u64_($.copy(scale_in)));
    total_reserve = add_($.copy(amount_in), $.copy(reserve_in_u256));
    y = sub_($.copy(reserve_out_u256), get_y_($.copy(total_reserve), $.copy(xy), $.copy(reserve_out_u256)));
    r = div_$1(mul_$1($.copy(y), from_u64_($.copy(scale_out))), $.copy(u2561e8));
    return as_u128_($.copy(r));
}
function d_(x0_u256, y_u256, $c) {
    let three_u256, x3, xx, xxx, xyy3, yy;
    three_u256 = from_u128_(u128('3'));
    x3 = mul_$1($.copy(three_u256), $.copy(x0_u256));
    yy = mul_$1($.copy(y_u256), $.copy(y_u256));
    xyy3 = mul_$1($.copy(x3), $.copy(yy));
    xx = mul_$1($.copy(x0_u256), $.copy(x0_u256));
    xxx = mul_$1($.copy(xx), $.copy(x0_u256));
    return add_($.copy(xyy3), $.copy(xxx));
}
function f_(x0_u256, y_u256, $c) {
    let a, b, xx, xxx, yy, yyy;
    yy = mul_$1($.copy(y_u256), $.copy(y_u256));
    yyy = mul_$1($.copy(yy), $.copy(y_u256));
    a = mul_$1($.copy(x0_u256), $.copy(yyy));
    xx = mul_$1($.copy(x0_u256), $.copy(x0_u256));
    xxx = mul_$1($.copy(xx), $.copy(x0_u256));
    b = mul_$1($.copy(xxx), $.copy(y_u256));
    return add_($.copy(a), $.copy(b));
}
function get_y_(x0, xy, y, $c) {
    let temp$1, _dy, cmp, i, k, one_u256;
    i = u64('0');
    one_u256 = from_u128_(u128('1'));
    while ($.copy(i).lt(u64('255'))) {
        {
            k = f_($.copy(x0), $.copy(y));
            _dy = zero_();
            cmp = compare_$1(k, xy);
            if ($.copy(cmp).eq(u8('1'))) {
                _dy = add_(div_$1(sub_($.copy(xy), $.copy(k)), d_($.copy(x0), $.copy(y))), $.copy(one_u256));
                y = add_($.copy(y), $.copy(_dy));
            }
            else {
                _dy = div_$1(sub_($.copy(k), $.copy(xy)), d_($.copy(x0), $.copy(y)));
                y = sub_($.copy(y), $.copy(_dy));
            }
            cmp = compare_$1(_dy, one_u256);
            if ($.copy(cmp).eq(u8('0'))) {
                temp$1 = true;
            }
            else {
                temp$1 = $.copy(cmp).eq(u8('1'));
            }
            if (temp$1) {
                return $.copy(y);
            }
            i = $.copy(i).add(u64('1'));
        }
    }
    return $.copy(y);
}
function lp_value_(x_coin, x_scale, y_coin, y_scale, $c) {
    let _a, _b, _x, _y, u2561e8, x_scale_u256, x_u256, y_scale_u256, y_u256;
    x_u256 = from_u128_($.copy(x_coin));
    y_u256 = from_u128_($.copy(y_coin));
    u2561e8 = from_u128_($.copy(ONE_E_8));
    x_scale_u256 = from_u64_($.copy(x_scale));
    y_scale_u256 = from_u64_($.copy(y_scale));
    _x = div_$1(mul_$1($.copy(x_u256), $.copy(u2561e8)), $.copy(x_scale_u256));
    _y = div_$1(mul_$1($.copy(y_u256), $.copy(u2561e8)), $.copy(y_scale_u256));
    _a = mul_$1($.copy(_x), $.copy(_y));
    _b = add_(mul_$1($.copy(_x), $.copy(_x)), mul_$1($.copy(_y), $.copy(_y)));
    return mul_$1($.copy(_a), $.copy(_b));
}
function loadParsers$b(repo) { }
class App$c {
    constructor(client, repo, cache) {
        this.client = client;
        this.repo = repo;
        this.cache = cache;
    }
    get moduleAddress() {
        {
            return moduleAddress$7;
        }
    }
    get moduleName() {
        {
            return moduleName$7;
        }
    }
}

var Stable_curve = /*#__PURE__*/Object.freeze({
    __proto__: null,
    packageName: packageName$7,
    moduleAddress: moduleAddress$7,
    moduleName: moduleName$7,
    ONE_E_8: ONE_E_8,
    coin_out_: coin_out_,
    d_: d_,
    f_: f_,
    get_y_: get_y_,
    lp_value_: lp_value_,
    loadParsers: loadParsers$b,
    App: App$c
});

const packageName$6 = 'Liquidswap';
const moduleAddress$6 = new HexString('0x190d44266241744264b964a37b8f09863167a12d3e70cda39376cfb4e3561e12');
const moduleName$6 = 'router';
const ERR_UNREACHABLE = u64('207');
function get_amount_out_(amount_in, $c, $p /* <X, Y, Curve>*/) {
    let reserve_x, reserve_y, scale_x, scale_y;
    [reserve_x, reserve_y] = get_reserves_size_($c, [$p[0], $p[1], $p[2]]);
    [scale_x, scale_y] = get_decimals_scales_($c, [$p[0], $p[1], $p[2]]);
    return get_coin_out_with_fees_($.copy(amount_in), $.copy(reserve_x), $.copy(reserve_y), $.copy(scale_x), $.copy(scale_y), $c, [$p[0], $p[1], $p[2]]);
}
function get_coin_out_with_fees_(coin_in, reserve_in, reserve_out, scale_in, scale_out, $c, $p /* <X, Y, Curve>*/) {
    let temp$1, temp$3, temp$4, coin_in_val_after_fees, coin_in_val_after_fees__2, coin_in_val_scaled, fee_multiplier, fee_pct, fee_scale, new_reserve_in;
    [fee_pct, fee_scale] = get_fees_config_($c, [$p[0], $p[1], $p[2]]);
    fee_multiplier = $.copy(fee_scale).sub($.copy(fee_pct));
    if (is_stable_($c, [$p[2]])) {
        coin_in_val_scaled = mul_to_u128_($.copy(coin_in), $.copy(fee_multiplier));
        if ($.copy(coin_in_val_scaled)
            .mod(u128($.copy(fee_scale)))
            .neq(u128('0'))) {
            temp$1 = $.copy(coin_in_val_scaled)
                .div(u128($.copy(fee_scale)))
                .add(u128('1'));
        }
        else {
            temp$1 = $.copy(coin_in_val_scaled).div(u128($.copy(fee_scale)));
        }
        coin_in_val_after_fees = temp$1;
        temp$4 = u64(coin_out_(u128($.copy(coin_in_val_after_fees)), $.copy(scale_in), $.copy(scale_out), u128($.copy(reserve_in)), u128($.copy(reserve_out))));
    }
    else {
        if (is_uncorrelated_($c, [$p[2]])) {
            coin_in_val_after_fees__2 = $.copy(coin_in).mul($.copy(fee_multiplier));
            new_reserve_in = $.copy(reserve_in).mul($.copy(fee_scale)).add($.copy(coin_in_val_after_fees__2));
            temp$3 = mul_div_($.copy(coin_in_val_after_fees__2), $.copy(reserve_out), $.copy(new_reserve_in));
        }
        else {
            throw $.abortCode($.copy(ERR_UNREACHABLE));
        }
        temp$4 = temp$3;
    }
    return temp$4;
}
function get_decimals_scales_($c, $p /* <X, Y, Curve>*/) {
    let temp$1, temp$2, x, y;
    if (is_sorted_($c, [$p[0], $p[1]])) {
        [temp$1, temp$2] = get_decimals_scales_$1($c, [$p[0], $p[1], $p[2]]);
    }
    else {
        [y, x] = get_decimals_scales_$1($c, [$p[1], $p[0], $p[2]]);
        [temp$1, temp$2] = [$.copy(x), $.copy(y)];
    }
    return [temp$1, temp$2];
}
function get_fees_config_($c, $p /* <X, Y, Curve>*/) {
    let temp$1, temp$2;
    if (is_sorted_($c, [$p[0], $p[1]])) {
        [temp$1, temp$2] = get_fees_config_$1($c, [$p[0], $p[1], $p[2]]);
    }
    else {
        [temp$1, temp$2] = get_fees_config_$1($c, [$p[1], $p[0], $p[2]]);
    }
    return [temp$1, temp$2];
}
function get_reserves_size_($c, $p /* <X, Y, Curve>*/) {
    let temp$1, temp$2, x_res, y_res;
    if (is_sorted_($c, [$p[0], $p[1]])) {
        [temp$1, temp$2] = get_reserves_size_$1($c, [$p[0], $p[1], $p[2]]);
    }
    else {
        [y_res, x_res] = get_reserves_size_$1($c, [$p[1], $p[0], $p[2]]);
        [temp$1, temp$2] = [$.copy(x_res), $.copy(y_res)];
    }
    return [temp$1, temp$2];
}
function swap_exact_coin_for_coin_(coin_in, _mint_out_amt, $c, $p /* <X, Y, LP>*/) {
    destroy_zero_(coin_in, $c, [$p[0]]);
    return zero_$1($c, [$p[1]]);
}
function loadParsers$a(repo) { }
class App$b {
    constructor(client, repo, cache) {
        this.client = client;
        this.repo = repo;
        this.cache = cache;
    }
    get moduleAddress() {
        {
            return moduleAddress$6;
        }
    }
    get moduleName() {
        {
            return moduleName$6;
        }
    }
}

var Router = /*#__PURE__*/Object.freeze({
    __proto__: null,
    packageName: packageName$6,
    moduleAddress: moduleAddress$6,
    moduleName: moduleName$6,
    ERR_UNREACHABLE: ERR_UNREACHABLE,
    get_amount_out_: get_amount_out_,
    get_coin_out_with_fees_: get_coin_out_with_fees_,
    get_decimals_scales_: get_decimals_scales_,
    get_fees_config_: get_fees_config_,
    get_reserves_size_: get_reserves_size_,
    swap_exact_coin_for_coin_: swap_exact_coin_for_coin_,
    loadParsers: loadParsers$a,
    App: App$b
});

const packageName$5 = 'Liquidswap';
const moduleAddress$5 = new HexString('0x190d44266241744264b964a37b8f09863167a12d3e70cda39376cfb4e3561e12');
const moduleName$5 = 'scripts';
function register_pool_and_add_liquidity_(_creator, _x_amount, _x_min_amount, _y_amount, _y_min_amount, $c, $p /* <X, Y, LP>*/) {
    return;
}
function buildPayload_register_pool_and_add_liquidity(_x_amount, _x_min_amount, _y_amount, _y_min_amount, $p /* <X, Y, LP>*/, isJSON = false) {
    const typeParamStrings = $p.map((t) => $.getTypeTagFullname(t));
    return $.buildPayload(new HexString('0x190d44266241744264b964a37b8f09863167a12d3e70cda39376cfb4e3561e12'), 'scripts', 'register_pool_and_add_liquidity', typeParamStrings, [_x_amount, _x_min_amount, _y_amount, _y_min_amount], isJSON);
}
function loadParsers$9(repo) { }
class App$a {
    constructor(client, repo, cache) {
        this.client = client;
        this.repo = repo;
        this.cache = cache;
    }
    get moduleAddress() {
        {
            return moduleAddress$5;
        }
    }
    get moduleName() {
        {
            return moduleName$5;
        }
    }
    payload_register_pool_and_add_liquidity(_x_amount, _x_min_amount, _y_amount, _y_min_amount, $p /* <X, Y, LP>*/, isJSON = false) {
        return buildPayload_register_pool_and_add_liquidity(_x_amount, _x_min_amount, _y_amount, _y_min_amount, $p, isJSON);
    }
    register_pool_and_add_liquidity(_account, _x_amount, _x_min_amount, _y_amount, _y_min_amount, $p /* <X, Y, LP>*/, option, _isJSON = false) {
        return __awaiter(this, void 0, void 0, function* () {
            const payload__ = buildPayload_register_pool_and_add_liquidity(_x_amount, _x_min_amount, _y_amount, _y_min_amount, $p, _isJSON);
            return $.sendPayloadTx(this.client, _account, payload__, option);
        });
    }
}

var Scripts = /*#__PURE__*/Object.freeze({
    __proto__: null,
    packageName: packageName$5,
    moduleAddress: moduleAddress$5,
    moduleName: moduleName$5,
    register_pool_and_add_liquidity_: register_pool_and_add_liquidity_,
    buildPayload_register_pool_and_add_liquidity: buildPayload_register_pool_and_add_liquidity,
    loadParsers: loadParsers$9,
    App: App$a
});

function loadParsers$8(repo) {
    loadParsers$g(repo);
    loadParsers$f(repo);
}
function getPackageRepo$3() {
    const repo = new AptosParserRepo();
    loadParsers$8(repo);
    repo.addDefaultParsers();
    return repo;
}
class App$9 {
    constructor(client, repo, cache) {
        this.client = client;
        this.repo = repo;
        this.cache = cache;
        this.coin_helper = new App$i(client, repo, cache);
        this.curves = new App$h(client, repo, cache);
        this.liquidity_pool = new App$g(client, repo, cache);
        this.math = new App$f(client, repo, cache);
        this.router = new App$b(client, repo, cache);
        this.scripts = new App$a(client, repo, cache);
        this.stable_curve = new App$c(client, repo, cache);
    }
}

var liquidswap = /*#__PURE__*/Object.freeze({
    __proto__: null,
    loadParsers: loadParsers$8,
    getPackageRepo: getPackageRepo$3,
    App: App$9,
    Coin_helper: Coin_helper,
    Curves: Curves,
    Liquidity_pool: Liquidity_pool,
    Math: Math$1,
    Router: Router,
    Scripts: Scripts,
    Stable_curve: Stable_curve
});

const packageName$4 = 'HippoAggregator';
const moduleAddress$4 = new HexString('0x510c1110ceb407484d394ce00f47b8421707df417be80a3a7d9c72884fa303c7');
const moduleName$4 = 'aggregator';
const DEX_ANIMESWAP = u8('9');
const DEX_APTOSWAP = u8('7');
const DEX_AUX = u8('8');
const DEX_BASIQ = u8('4');
const DEX_DITTO = u8('5');
const DEX_ECONIA = u8('2');
const DEX_HIPPO = u8('1');
const DEX_PONTEM = u8('3');
const DEX_TORTUGA = u8('6');
const E_COIN_STORE_NOT_EXITES = u64('8');
const E_INVALID_PAIR_OF_DITTO = u64('5');
const E_INVALID_PAIR_OF_TORTUGA = u64('6');
const E_NOT_ADMIN$1 = u64('4');
const E_OUTPUT_LESS_THAN_MINIMUM = u64('2');
const E_TYPE_NOT_EQUAL = u64('7');
const E_UNKNOWN_DEX = u64('3');
const E_UNKNOWN_POOL_TYPE = u64('1');
const E_UNSUPPORTED_NUM_STEPS = u64('9');
const HIPPO_CONSTANT_PRODUCT = u64('1');
const HIPPO_PIECEWISE = u64('3');
const HI_64 = u64('18446744073709551615');
class AuxSigner {
    constructor(proto, typeTag) {
        this.typeTag = typeTag;
        this.__app = null;
        this.signerCapability = proto['signerCapability'];
    }
    static AuxSignerParser(data, typeTag, repo) {
        const proto = $.parseStructProto(data, typeTag, repo, AuxSigner);
        return new AuxSigner(proto, typeTag);
    }
    static load(repo, client, address, typeParams) {
        return __awaiter(this, void 0, void 0, function* () {
            const result = yield repo.loadResource(client, address, AuxSigner, typeParams);
            return result;
        });
    }
    static loadByApp(app, address, typeParams) {
        return __awaiter(this, void 0, void 0, function* () {
            const result = yield app.repo.loadResource(app.client, address, AuxSigner, typeParams);
            yield result.loadFullState(app);
            return result;
        });
    }
    static getTag() {
        return new StructTag(moduleAddress$4, moduleName$4, 'AuxSigner', []);
    }
    loadFullState(app) {
        return __awaiter(this, void 0, void 0, function* () {
            yield this.signerCapability.loadFullState(app);
            this.__app = app;
        });
    }
}
AuxSigner.moduleAddress = moduleAddress$4;
AuxSigner.moduleName = moduleName$4;
AuxSigner.structName = 'AuxSigner';
AuxSigner.typeParameters = [];
AuxSigner.fields = [
    { name: 'signerCapability', typeTag: new StructTag(new HexString('0x1'), 'account', 'SignerCapability', []) }
];
class CoinStore {
    constructor(proto, typeTag) {
        this.typeTag = typeTag;
        this.__app = null;
        this.balance = proto['balance'];
    }
    static CoinStoreParser(data, typeTag, repo) {
        const proto = $.parseStructProto(data, typeTag, repo, CoinStore);
        return new CoinStore(proto, typeTag);
    }
    static load(repo, client, address, typeParams) {
        return __awaiter(this, void 0, void 0, function* () {
            const result = yield repo.loadResource(client, address, CoinStore, typeParams);
            return result;
        });
    }
    static loadByApp(app, address, typeParams) {
        return __awaiter(this, void 0, void 0, function* () {
            const result = yield app.repo.loadResource(app.client, address, CoinStore, typeParams);
            yield result.loadFullState(app);
            return result;
        });
    }
    static makeTag($p) {
        return new StructTag(moduleAddress$4, moduleName$4, 'CoinStore', $p);
    }
    loadFullState(app) {
        return __awaiter(this, void 0, void 0, function* () {
            yield this.balance.loadFullState(app);
            this.__app = app;
        });
    }
}
CoinStore.moduleAddress = moduleAddress$4;
CoinStore.moduleName = moduleName$4;
CoinStore.structName = 'CoinStore';
CoinStore.typeParameters = [{ name: 'CoinType', isPhantom: true }];
CoinStore.fields = [
    { name: 'balance', typeTag: new StructTag(new HexString('0x1'), 'coin', 'Coin', [new $.TypeParamIdx(0)]) }
];
class EventStore {
    constructor(proto, typeTag) {
        this.typeTag = typeTag;
        this.__app = null;
        this.swap_step_events = proto['swap_step_events'];
    }
    static EventStoreParser(data, typeTag, repo) {
        const proto = $.parseStructProto(data, typeTag, repo, EventStore);
        return new EventStore(proto, typeTag);
    }
    static load(repo, client, address, typeParams) {
        return __awaiter(this, void 0, void 0, function* () {
            const result = yield repo.loadResource(client, address, EventStore, typeParams);
            return result;
        });
    }
    static loadByApp(app, address, typeParams) {
        return __awaiter(this, void 0, void 0, function* () {
            const result = yield app.repo.loadResource(app.client, address, EventStore, typeParams);
            yield result.loadFullState(app);
            return result;
        });
    }
    static getTag() {
        return new StructTag(moduleAddress$4, moduleName$4, 'EventStore', []);
    }
    loadFullState(app) {
        return __awaiter(this, void 0, void 0, function* () {
            yield this.swap_step_events.loadFullState(app);
            this.__app = app;
        });
    }
}
EventStore.moduleAddress = moduleAddress$4;
EventStore.moduleName = moduleName$4;
EventStore.structName = 'EventStore';
EventStore.typeParameters = [];
EventStore.fields = [
    {
        name: 'swap_step_events',
        typeTag: new StructTag(new HexString('0x1'), 'event', 'EventHandle', [
            new StructTag(new HexString('0x510c1110ceb407484d394ce00f47b8421707df417be80a3a7d9c72884fa303c7'), 'aggregator', 'SwapStepEvent', [])
        ])
    }
];
class SwapStepEvent {
    constructor(proto, typeTag) {
        this.typeTag = typeTag;
        this.__app = null;
        this.dex_type = proto['dex_type'];
        this.pool_type = proto['pool_type'];
        this.x_type_info = proto['x_type_info'];
        this.y_type_info = proto['y_type_info'];
        this.input_amount = proto['input_amount'];
        this.output_amount = proto['output_amount'];
        this.time_stamp = proto['time_stamp'];
    }
    static SwapStepEventParser(data, typeTag, repo) {
        const proto = $.parseStructProto(data, typeTag, repo, SwapStepEvent);
        return new SwapStepEvent(proto, typeTag);
    }
    static getTag() {
        return new StructTag(moduleAddress$4, moduleName$4, 'SwapStepEvent', []);
    }
    loadFullState(app) {
        return __awaiter(this, void 0, void 0, function* () {
            yield this.x_type_info.loadFullState(app);
            yield this.y_type_info.loadFullState(app);
            this.__app = app;
        });
    }
}
SwapStepEvent.moduleAddress = moduleAddress$4;
SwapStepEvent.moduleName = moduleName$4;
SwapStepEvent.structName = 'SwapStepEvent';
SwapStepEvent.typeParameters = [];
SwapStepEvent.fields = [
    { name: 'dex_type', typeTag: AtomicTypeTag.U8 },
    { name: 'pool_type', typeTag: AtomicTypeTag.U64 },
    { name: 'x_type_info', typeTag: new StructTag(new HexString('0x1'), 'type_info', 'TypeInfo', []) },
    { name: 'y_type_info', typeTag: new StructTag(new HexString('0x1'), 'type_info', 'TypeInfo', []) },
    { name: 'input_amount', typeTag: AtomicTypeTag.U64 },
    { name: 'output_amount', typeTag: AtomicTypeTag.U64 },
    { name: 'time_stamp', typeTag: AtomicTypeTag.U64 }
];
function change_coin_type_(x_coin, $c, $p /* <X, Y>*/) {
    let amount, x_coin_store, y_coin_store;
    if (!$.deep_eq(type_of_($c, [$p[0]]), type_of_($c, [$p[1]]))) {
        throw $.abortCode($.copy(E_TYPE_NOT_EQUAL));
    }
    if (!$c.exists(new SimpleStructTag(CoinStore, [$p[0]]), new HexString('0x510c1110ceb407484d394ce00f47b8421707df417be80a3a7d9c72884fa303c7'))) {
        throw $.abortCode(u64('0'));
    }
    amount = value_(x_coin, $c, [$p[0]]);
    x_coin_store = $c.borrow_global_mut(new SimpleStructTag(CoinStore, [$p[0]]), new HexString('0x510c1110ceb407484d394ce00f47b8421707df417be80a3a7d9c72884fa303c7'));
    merge_(x_coin_store.balance, x_coin, $c, [$p[0]]);
    y_coin_store = $c.borrow_global_mut(new SimpleStructTag(CoinStore, [$p[1]]), new HexString('0x510c1110ceb407484d394ce00f47b8421707df417be80a3a7d9c72884fa303c7'));
    return extract_(y_coin_store.balance, $.copy(amount), $c, [$p[1]]);
}
function check_and_deposit_(sender, coin, $c, $p /* <X>*/) {
    let sender_addr;
    sender_addr = address_of_(sender, $c);
    if (!is_account_registered_($.copy(sender_addr), $c, [$p[0]])) {
        register_$2(sender, $c, [$p[0]]);
    }
    deposit_$1($.copy(sender_addr), coin, $c, [$p[0]]);
    return;
}
function check_and_deposit_opt_(sender, coin_opt, $c, $p /* <X>*/) {
    let coin, sender_addr;
    if (is_some_(coin_opt, $c, [new StructTag(new HexString('0x1'), 'coin', 'Coin', [$p[0]])])) {
        coin = extract_$1(coin_opt, $c, [new StructTag(new HexString('0x1'), 'coin', 'Coin', [$p[0]])]);
        sender_addr = address_of_(sender, $c);
        if (!is_account_registered_($.copy(sender_addr), $c, [$p[0]])) {
            register_$2(sender, $c, [$p[0]]);
        }
        deposit_$1($.copy(sender_addr), coin, $c, [$p[0]]);
    }
    return destroy_none_(coin_opt, $c, [new StructTag(new HexString('0x1'), 'coin', 'Coin', [$p[0]])]);
}
function create_aux_signer_(admin, $c) {
    let _signer, signerCapability;
    [_signer, signerCapability] = create_resource_account_$1(admin, [u8('97'), u8('117'), u8('120'), u8('95'), u8('115'), u8('105'), u8('103'), u8('110'), u8('101'), u8('114')], $c);
    $c.move_to(new SimpleStructTag(AuxSigner), admin, new AuxSigner({ signerCapability: signerCapability }, new SimpleStructTag(AuxSigner)));
    return;
}
function buildPayload_create_aux_signer(isJSON = false) {
    const typeParamStrings = [];
    return $.buildPayload(new HexString('0x510c1110ceb407484d394ce00f47b8421707df417be80a3a7d9c72884fa303c7'), 'aggregator', 'create_aux_signer', typeParamStrings, [], isJSON);
}
function emit_swap_step_event_(dex_type, pool_type, input_amount, output_amount, $c, $p /* <Input, Output>*/) {
    let event_store;
    event_store = $c.borrow_global_mut(new SimpleStructTag(EventStore), new HexString('0x510c1110ceb407484d394ce00f47b8421707df417be80a3a7d9c72884fa303c7'));
    emit_event_(event_store.swap_step_events, new SwapStepEvent({
        dex_type: $.copy(dex_type),
        pool_type: $.copy(pool_type),
        x_type_info: type_of_($c, [new StructTag(new HexString('0x1'), 'coin', 'Coin', [$p[0]])]),
        y_type_info: type_of_($c, [new StructTag(new HexString('0x1'), 'coin', 'Coin', [$p[1]])]),
        input_amount: $.copy(input_amount),
        output_amount: $.copy(output_amount),
        time_stamp: now_microseconds_($c)
    }, new SimpleStructTag(SwapStepEvent)), $c, [new SimpleStructTag(SwapStepEvent)]);
    return;
}
function get_intermediate_output_(dex_type, pool_type, is_x_to_y, x_in, $c, $p /* <X, Y, E>*/) {
    let temp$10, temp$11, temp$12, temp$13, temp$14, temp$16, temp$2, temp$3, temp$5, temp$6, temp$7, temp$8, temp$9, coin_in_value, coin_in_value__17, x_out_opt, y_out, y_out__1, y_out__15, y_out__4;
    coin_in_value = value_(x_in, $c, [$p[0]]);
    if ($.copy(dex_type).eq($.copy(DEX_HIPPO))) {
        throw $.abortCode($.copy(E_UNKNOWN_POOL_TYPE));
    }
    else {
        if ($.copy(dex_type).eq($.copy(DEX_PONTEM))) {
            [temp$11, temp$12] = [
                none_($c, [new StructTag(new HexString('0x1'), 'coin', 'Coin', [$p[0]])]),
                swap_exact_coin_for_coin_(x_in, u64('0'), $c, [$p[0], $p[1], $p[2]])
            ];
        }
        else {
            if ($.copy(dex_type).eq($.copy(DEX_APTOSWAP))) {
                if (is_x_to_y) {
                    y_out = swap_x_to_y_direct_(x_in, $c, [$p[0], $p[1]]);
                    [temp$2, temp$3] = [
                        none_($c, [new StructTag(new HexString('0x1'), 'coin', 'Coin', [$p[0]])]),
                        y_out
                    ];
                }
                else {
                    y_out__1 = swap_y_to_x_direct_(x_in, $c, [$p[1], $p[0]]);
                    [temp$2, temp$3] = [
                        none_($c, [new StructTag(new HexString('0x1'), 'coin', 'Coin', [$p[0]])]),
                        y_out__1
                    ];
                }
                [temp$9, temp$10] = [temp$2, temp$3];
            }
            else {
                if ($.copy(dex_type).eq($.copy(DEX_AUX))) {
                    y_out__4 = zero_$1($c, [$p[1]]);
                    swap_exact_coin_for_coin_mut_(new HexString('0x510c1110ceb407484d394ce00f47b8421707df417be80a3a7d9c72884fa303c7'), x_in, y_out__4, $.copy(coin_in_value), u64('0'), false, u128('0'), u128('0'), $c, [$p[0], $p[1]]);
                    [temp$7, temp$8] = [
                        some_(x_in, $c, [new StructTag(new HexString('0x1'), 'coin', 'Coin', [$p[0]])]),
                        y_out__4
                    ];
                }
                else {
                    if ($.copy(dex_type).eq($.copy(DEX_ANIMESWAP))) {
                        [temp$5, temp$6] = [
                            none_($c, [new StructTag(new HexString('0x1'), 'coin', 'Coin', [$p[0]])]),
                            swap_coins_for_coins_(x_in, $c, [$p[0], $p[1]])
                        ];
                    }
                    else {
                        throw $.abortCode($.copy(E_UNKNOWN_DEX));
                    }
                    [temp$7, temp$8] = [temp$5, temp$6];
                }
                [temp$9, temp$10] = [temp$7, temp$8];
            }
            [temp$11, temp$12] = [temp$9, temp$10];
        }
        [temp$13, temp$14] = [temp$11, temp$12];
    }
    [x_out_opt, y_out__15] = [temp$13, temp$14];
    if (is_some_(x_out_opt, $c, [new StructTag(new HexString('0x1'), 'coin', 'Coin', [$p[0]])])) {
        temp$16 = $.copy(coin_in_value).sub(value_(borrow_$6(x_out_opt, $c, [new StructTag(new HexString('0x1'), 'coin', 'Coin', [$p[0]])]), $c, [$p[0]]));
    }
    else {
        temp$16 = $.copy(coin_in_value);
    }
    coin_in_value__17 = temp$16;
    emit_swap_step_event_($.copy(dex_type), $.copy(pool_type), $.copy(coin_in_value__17), value_(y_out__15, $c, [$p[1]]), $c, [$p[0], $p[1]]);
    return [x_out_opt, y_out__15];
}
function init_coin_store_(admin, $c, $p /* <X>*/) {
    let admin_addr;
    admin_addr = address_of_(admin, $c);
    if (!($.copy(admin_addr).hex() ===
        new HexString('0x510c1110ceb407484d394ce00f47b8421707df417be80a3a7d9c72884fa303c7').hex())) {
        throw $.abortCode($.copy(E_NOT_ADMIN$1));
    }
    $c.move_to(new SimpleStructTag(CoinStore, [$p[0]]), admin, new CoinStore({ balance: zero_$1($c, [$p[0]]) }, new SimpleStructTag(CoinStore, [$p[0]])));
    return;
}
function buildPayload_init_coin_store($p /* <X>*/, isJSON = false) {
    const typeParamStrings = $p.map((t) => $.getTypeTagFullname(t));
    return $.buildPayload(new HexString('0x510c1110ceb407484d394ce00f47b8421707df417be80a3a7d9c72884fa303c7'), 'aggregator', 'init_coin_store', typeParamStrings, [], isJSON);
}
function init_coin_store_all_(admin, $c) {
    init_coin_store_(admin, $c, [new StructTag(new HexString('0x1'), 'aptos_coin', 'AptosCoin', [])]);
    return;
}
function buildPayload_init_coin_store_all(isJSON = false) {
    const typeParamStrings = [];
    return $.buildPayload(new HexString('0x510c1110ceb407484d394ce00f47b8421707df417be80a3a7d9c72884fa303c7'), 'aggregator', 'init_coin_store_all', typeParamStrings, [], isJSON);
}
function init_module_(admin, $c) {
    let admin_addr;
    admin_addr = address_of_(admin, $c);
    if (!($.copy(admin_addr).hex() ===
        new HexString('0x510c1110ceb407484d394ce00f47b8421707df417be80a3a7d9c72884fa303c7').hex())) {
        throw $.abortCode($.copy(E_NOT_ADMIN$1));
    }
    init_coin_store_all_(admin, $c);
    $c.move_to(new SimpleStructTag(EventStore), admin, new EventStore({ swap_step_events: new_event_handle_(admin, $c, [new SimpleStructTag(SwapStepEvent)]) }, new SimpleStructTag(EventStore)));
    create_aux_signer_(admin, $c);
    return;
}
function buildPayload_init_module(isJSON = false) {
    const typeParamStrings = [];
    return $.buildPayload(new HexString('0x510c1110ceb407484d394ce00f47b8421707df417be80a3a7d9c72884fa303c7'), 'aggregator', 'init_module', typeParamStrings, [], isJSON);
}
function one_step_direct_(dex_type, pool_type, is_x_to_y, x_in, $c, $p /* <X, Y, E>*/) {
    return get_intermediate_output_($.copy(dex_type), $.copy(pool_type), is_x_to_y, x_in, $c, [$p[0], $p[1], $p[2]]);
}
function one_step_route_(sender, first_dex_type, first_pool_type, first_is_x_to_y, x_in, y_min_out, $c, $p /* <X, Y, E>*/) {
    let coin_in, coin_out, coin_remain_opt;
    coin_in = withdraw_$1(sender, $.copy(x_in), $c, [$p[0]]);
    [coin_remain_opt, coin_out] = one_step_direct_($.copy(first_dex_type), $.copy(first_pool_type), first_is_x_to_y, coin_in, $c, [$p[0], $p[1], $p[2]]);
    if (!value_(coin_out, $c, [$p[1]]).ge($.copy(y_min_out))) {
        throw $.abortCode($.copy(E_OUTPUT_LESS_THAN_MINIMUM));
    }
    check_and_deposit_opt_(sender, coin_remain_opt, $c, [$p[0]]);
    check_and_deposit_(sender, coin_out, $c, [$p[1]]);
    return;
}
function buildPayload_one_step_route(first_dex_type, first_pool_type, first_is_x_to_y, x_in, y_min_out, $p /* <X, Y, E>*/, isJSON = false) {
    const typeParamStrings = $p.map((t) => $.getTypeTagFullname(t));
    return $.buildPayload(new HexString('0x510c1110ceb407484d394ce00f47b8421707df417be80a3a7d9c72884fa303c7'), 'aggregator', 'one_step_route', typeParamStrings, [first_dex_type, first_pool_type, first_is_x_to_y, x_in, y_min_out], isJSON);
}
function swap_(sender, num_steps, first_dex_type, first_pool_type, first_is_x_to_y, second_dex_type, second_pool_type, second_is_x_to_y, third_dex_type, third_pool_type, third_is_x_to_y, x_in, m_min_out, $c, $p /* <X, Y, Z, OutCoin, E1, E2, E3>*/) {
    let coin_m, coin_x, x_remain, y_remain, z_remain;
    coin_x = withdraw_$1(sender, $.copy(x_in), $c, [$p[0]]);
    [x_remain, y_remain, z_remain, coin_m] = swap_direct_($.copy(num_steps), $.copy(first_dex_type), $.copy(first_pool_type), first_is_x_to_y, $.copy(second_dex_type), $.copy(second_pool_type), second_is_x_to_y, $.copy(third_dex_type), $.copy(third_pool_type), third_is_x_to_y, coin_x, $c, [$p[0], $p[1], $p[2], $p[3], $p[4], $p[5], $p[6]]);
    if (!value_(coin_m, $c, [$p[3]]).ge($.copy(m_min_out))) {
        throw $.abortCode($.copy(E_OUTPUT_LESS_THAN_MINIMUM));
    }
    check_and_deposit_opt_(sender, x_remain, $c, [$p[0]]);
    check_and_deposit_opt_(sender, y_remain, $c, [$p[1]]);
    check_and_deposit_opt_(sender, z_remain, $c, [$p[2]]);
    check_and_deposit_(sender, coin_m, $c, [$p[3]]);
    return;
}
function buildPayload_swap(num_steps, first_dex_type, first_pool_type, first_is_x_to_y, second_dex_type, second_pool_type, second_is_x_to_y, third_dex_type, third_pool_type, third_is_x_to_y, x_in, m_min_out, $p /* <X, Y, Z, OutCoin, E1, E2, E3>*/, isJSON = false) {
    const typeParamStrings = $p.map((t) => $.getTypeTagFullname(t));
    return $.buildPayload(new HexString('0x510c1110ceb407484d394ce00f47b8421707df417be80a3a7d9c72884fa303c7'), 'aggregator', 'swap', typeParamStrings, [
        num_steps,
        first_dex_type,
        first_pool_type,
        first_is_x_to_y,
        second_dex_type,
        second_pool_type,
        second_is_x_to_y,
        third_dex_type,
        third_pool_type,
        third_is_x_to_y,
        x_in,
        m_min_out
    ], isJSON);
}
function swap_direct_(num_steps, first_dex_type, first_pool_type, first_is_x_to_y, second_dex_type, second_pool_type, second_is_x_to_y, third_dex_type, third_pool_type, third_is_x_to_y, x_in, $c, $p /* <X, Y, Z, OutCoin, E1, E2, E3>*/) {
    let temp$10, temp$11, temp$12, temp$13, temp$14, temp$15, temp$16, temp$17, temp$18, temp$7, temp$8, temp$9, coin_m, coin_m__2, coin_m__6, coin_x_remain, coin_x_remain__1, coin_x_remain__3, coin_y, coin_y__4, coin_y_remain, coin_y_remain__5, coin_z, coin_z_remain;
    if ($.copy(num_steps).eq(u8('1'))) {
        [coin_x_remain, coin_m] = get_intermediate_output_($.copy(first_dex_type), $.copy(first_pool_type), first_is_x_to_y, x_in, $c, [$p[0], $p[3], $p[4]]);
        [temp$15, temp$16, temp$17, temp$18] = [
            coin_x_remain,
            some_(zero_$1($c, [$p[1]]), $c, [
                new StructTag(new HexString('0x1'), 'coin', 'Coin', [$p[1]])
            ]),
            some_(zero_$1($c, [$p[2]]), $c, [
                new StructTag(new HexString('0x1'), 'coin', 'Coin', [$p[2]])
            ]),
            coin_m
        ];
    }
    else {
        if ($.copy(num_steps).eq(u8('2'))) {
            [coin_x_remain__1, coin_y] = get_intermediate_output_($.copy(first_dex_type), $.copy(first_pool_type), first_is_x_to_y, x_in, $c, [$p[0], $p[1], $p[4]]);
            [coin_y_remain, coin_m__2] = get_intermediate_output_($.copy(second_dex_type), $.copy(second_pool_type), second_is_x_to_y, coin_y, $c, [$p[1], $p[3], $p[5]]);
            [temp$11, temp$12, temp$13, temp$14] = [
                coin_x_remain__1,
                coin_y_remain,
                some_(zero_$1($c, [$p[2]]), $c, [
                    new StructTag(new HexString('0x1'), 'coin', 'Coin', [$p[2]])
                ]),
                coin_m__2
            ];
        }
        else {
            if ($.copy(num_steps).eq(u8('3'))) {
                [coin_x_remain__3, coin_y__4] = get_intermediate_output_($.copy(first_dex_type), $.copy(first_pool_type), first_is_x_to_y, x_in, $c, [$p[0], $p[1], $p[4]]);
                [coin_y_remain__5, coin_z] = get_intermediate_output_($.copy(second_dex_type), $.copy(second_pool_type), second_is_x_to_y, coin_y__4, $c, [$p[1], $p[2], $p[5]]);
                [coin_z_remain, coin_m__6] = get_intermediate_output_($.copy(third_dex_type), $.copy(third_pool_type), third_is_x_to_y, coin_z, $c, [$p[2], $p[3], $p[6]]);
                [temp$7, temp$8, temp$9, temp$10] = [coin_x_remain__3, coin_y_remain__5, coin_z_remain, coin_m__6];
            }
            else {
                throw $.abortCode($.copy(E_UNSUPPORTED_NUM_STEPS));
            }
            [temp$11, temp$12, temp$13, temp$14] = [temp$7, temp$8, temp$9, temp$10];
        }
        [temp$15, temp$16, temp$17, temp$18] = [temp$11, temp$12, temp$13, temp$14];
    }
    return [temp$15, temp$16, temp$17, temp$18];
}
function three_step_direct_(first_dex_type, first_pool_type, first_is_x_to_y, second_dex_type, second_pool_type, second_is_x_to_y, third_dex_type, third_pool_type, third_is_x_to_y, x_in, $c, $p /* <X, Y, Z, M, E1, E2, E3>*/) {
    let coin_m, coin_x_remain, coin_y, coin_y_remain, coin_z, coin_z_remain;
    [coin_x_remain, coin_y] = get_intermediate_output_($.copy(first_dex_type), $.copy(first_pool_type), first_is_x_to_y, x_in, $c, [$p[0], $p[1], $p[4]]);
    [coin_y_remain, coin_z] = get_intermediate_output_($.copy(second_dex_type), $.copy(second_pool_type), second_is_x_to_y, coin_y, $c, [$p[1], $p[2], $p[5]]);
    [coin_z_remain, coin_m] = get_intermediate_output_($.copy(third_dex_type), $.copy(third_pool_type), third_is_x_to_y, coin_z, $c, [$p[2], $p[3], $p[6]]);
    return [coin_x_remain, coin_y_remain, coin_z_remain, coin_m];
}
function three_step_route_(sender, first_dex_type, first_pool_type, first_is_x_to_y, second_dex_type, second_pool_type, second_is_x_to_y, third_dex_type, third_pool_type, third_is_x_to_y, x_in, m_min_out, $c, $p /* <X, Y, Z, M, E1, E2, E3>*/) {
    let coin_m, coin_x, coin_x_remain, coin_y_remain, coin_z_remain;
    coin_x = withdraw_$1(sender, $.copy(x_in), $c, [$p[0]]);
    [coin_x_remain, coin_y_remain, coin_z_remain, coin_m] = three_step_direct_($.copy(first_dex_type), $.copy(first_pool_type), first_is_x_to_y, $.copy(second_dex_type), $.copy(second_pool_type), second_is_x_to_y, $.copy(third_dex_type), $.copy(third_pool_type), third_is_x_to_y, coin_x, $c, [$p[0], $p[1], $p[2], $p[3], $p[4], $p[5], $p[6]]);
    if (!value_(coin_m, $c, [$p[3]]).ge($.copy(m_min_out))) {
        throw $.abortCode($.copy(E_OUTPUT_LESS_THAN_MINIMUM));
    }
    check_and_deposit_opt_(sender, coin_x_remain, $c, [$p[0]]);
    check_and_deposit_opt_(sender, coin_y_remain, $c, [$p[1]]);
    check_and_deposit_opt_(sender, coin_z_remain, $c, [$p[2]]);
    check_and_deposit_(sender, coin_m, $c, [$p[3]]);
    return;
}
function buildPayload_three_step_route(first_dex_type, first_pool_type, first_is_x_to_y, second_dex_type, second_pool_type, second_is_x_to_y, third_dex_type, third_pool_type, third_is_x_to_y, x_in, m_min_out, $p /* <X, Y, Z, M, E1, E2, E3>*/, isJSON = false) {
    const typeParamStrings = $p.map((t) => $.getTypeTagFullname(t));
    return $.buildPayload(new HexString('0x510c1110ceb407484d394ce00f47b8421707df417be80a3a7d9c72884fa303c7'), 'aggregator', 'three_step_route', typeParamStrings, [
        first_dex_type,
        first_pool_type,
        first_is_x_to_y,
        second_dex_type,
        second_pool_type,
        second_is_x_to_y,
        third_dex_type,
        third_pool_type,
        third_is_x_to_y,
        x_in,
        m_min_out
    ], isJSON);
}
function two_step_direct_(first_dex_type, first_pool_type, first_is_x_to_y, second_dex_type, second_pool_type, second_is_x_to_y, x_in, $c, $p /* <X, Y, Z, E1, E2>*/) {
    let coin_x_remain, coin_y, coin_y_remain, coin_z;
    [coin_x_remain, coin_y] = get_intermediate_output_($.copy(first_dex_type), $.copy(first_pool_type), first_is_x_to_y, x_in, $c, [$p[0], $p[1], $p[3]]);
    [coin_y_remain, coin_z] = get_intermediate_output_($.copy(second_dex_type), $.copy(second_pool_type), second_is_x_to_y, coin_y, $c, [$p[1], $p[2], $p[4]]);
    return [coin_x_remain, coin_y_remain, coin_z];
}
function two_step_route_(sender, first_dex_type, first_pool_type, first_is_x_to_y, second_dex_type, second_pool_type, second_is_x_to_y, x_in, z_min_out, $c, $p /* <X, Y, Z, E1, E2>*/) {
    let coin_x, coin_x_remain, coin_y_remain, coin_z;
    coin_x = withdraw_$1(sender, $.copy(x_in), $c, [$p[0]]);
    [coin_x_remain, coin_y_remain, coin_z] = two_step_direct_($.copy(first_dex_type), $.copy(first_pool_type), first_is_x_to_y, $.copy(second_dex_type), $.copy(second_pool_type), second_is_x_to_y, coin_x, $c, [$p[0], $p[1], $p[2], $p[3], $p[4]]);
    if (!value_(coin_z, $c, [$p[2]]).ge($.copy(z_min_out))) {
        throw $.abortCode($.copy(E_OUTPUT_LESS_THAN_MINIMUM));
    }
    check_and_deposit_opt_(sender, coin_x_remain, $c, [$p[0]]);
    check_and_deposit_opt_(sender, coin_y_remain, $c, [$p[1]]);
    check_and_deposit_(sender, coin_z, $c, [$p[2]]);
    return;
}
function buildPayload_two_step_route(first_dex_type, first_pool_type, first_is_x_to_y, second_dex_type, second_pool_type, second_is_x_to_y, x_in, z_min_out, $p /* <X, Y, Z, E1, E2>*/, isJSON = false) {
    const typeParamStrings = $p.map((t) => $.getTypeTagFullname(t));
    return $.buildPayload(new HexString('0x510c1110ceb407484d394ce00f47b8421707df417be80a3a7d9c72884fa303c7'), 'aggregator', 'two_step_route', typeParamStrings, [
        first_dex_type,
        first_pool_type,
        first_is_x_to_y,
        second_dex_type,
        second_pool_type,
        second_is_x_to_y,
        x_in,
        z_min_out
    ], isJSON);
}
function loadParsers$7(repo) {
    repo.addParser('0x510c1110ceb407484d394ce00f47b8421707df417be80a3a7d9c72884fa303c7::aggregator::AuxSigner', AuxSigner.AuxSignerParser);
    repo.addParser('0x510c1110ceb407484d394ce00f47b8421707df417be80a3a7d9c72884fa303c7::aggregator::CoinStore', CoinStore.CoinStoreParser);
    repo.addParser('0x510c1110ceb407484d394ce00f47b8421707df417be80a3a7d9c72884fa303c7::aggregator::EventStore', EventStore.EventStoreParser);
    repo.addParser('0x510c1110ceb407484d394ce00f47b8421707df417be80a3a7d9c72884fa303c7::aggregator::SwapStepEvent', SwapStepEvent.SwapStepEventParser);
}
class App$8 {
    constructor(client, repo, cache) {
        this.client = client;
        this.repo = repo;
        this.cache = cache;
    }
    get moduleAddress() {
        {
            return moduleAddress$4;
        }
    }
    get moduleName() {
        {
            return moduleName$4;
        }
    }
    get AuxSigner() {
        return AuxSigner;
    }
    loadAuxSigner(owner, loadFull = true, fillCache = true) {
        return __awaiter(this, void 0, void 0, function* () {
            const val = yield AuxSigner.load(this.repo, this.client, owner, []);
            if (loadFull) {
                yield val.loadFullState(this);
            }
            if (fillCache) {
                this.cache.set(val.typeTag, owner, val);
            }
            return val;
        });
    }
    get CoinStore() {
        return CoinStore;
    }
    loadCoinStore(owner, $p /* <CoinType> */, loadFull = true, fillCache = true) {
        return __awaiter(this, void 0, void 0, function* () {
            const val = yield CoinStore.load(this.repo, this.client, owner, $p);
            if (loadFull) {
                yield val.loadFullState(this);
            }
            if (fillCache) {
                this.cache.set(val.typeTag, owner, val);
            }
            return val;
        });
    }
    get EventStore() {
        return EventStore;
    }
    loadEventStore(owner, loadFull = true, fillCache = true) {
        return __awaiter(this, void 0, void 0, function* () {
            const val = yield EventStore.load(this.repo, this.client, owner, []);
            if (loadFull) {
                yield val.loadFullState(this);
            }
            if (fillCache) {
                this.cache.set(val.typeTag, owner, val);
            }
            return val;
        });
    }
    get SwapStepEvent() {
        return SwapStepEvent;
    }
    payload_create_aux_signer(isJSON = false) {
        return buildPayload_create_aux_signer(isJSON);
    }
    create_aux_signer(_account, option, _isJSON = false) {
        return __awaiter(this, void 0, void 0, function* () {
            const payload__ = buildPayload_create_aux_signer(_isJSON);
            return $.sendPayloadTx(this.client, _account, payload__, option);
        });
    }
    payload_init_coin_store($p /* <X>*/, isJSON = false) {
        return buildPayload_init_coin_store($p, isJSON);
    }
    init_coin_store(_account, $p /* <X>*/, option, _isJSON = false) {
        return __awaiter(this, void 0, void 0, function* () {
            const payload__ = buildPayload_init_coin_store($p, _isJSON);
            return $.sendPayloadTx(this.client, _account, payload__, option);
        });
    }
    payload_init_coin_store_all(isJSON = false) {
        return buildPayload_init_coin_store_all(isJSON);
    }
    init_coin_store_all(_account, option, _isJSON = false) {
        return __awaiter(this, void 0, void 0, function* () {
            const payload__ = buildPayload_init_coin_store_all(_isJSON);
            return $.sendPayloadTx(this.client, _account, payload__, option);
        });
    }
    payload_init_module(isJSON = false) {
        return buildPayload_init_module(isJSON);
    }
    init_module(_account, option, _isJSON = false) {
        return __awaiter(this, void 0, void 0, function* () {
            const payload__ = buildPayload_init_module(_isJSON);
            return $.sendPayloadTx(this.client, _account, payload__, option);
        });
    }
    payload_one_step_route(first_dex_type, first_pool_type, first_is_x_to_y, x_in, y_min_out, $p /* <X, Y, E>*/, isJSON = false) {
        return buildPayload_one_step_route(first_dex_type, first_pool_type, first_is_x_to_y, x_in, y_min_out, $p, isJSON);
    }
    one_step_route(_account, first_dex_type, first_pool_type, first_is_x_to_y, x_in, y_min_out, $p /* <X, Y, E>*/, option, _isJSON = false) {
        return __awaiter(this, void 0, void 0, function* () {
            const payload__ = buildPayload_one_step_route(first_dex_type, first_pool_type, first_is_x_to_y, x_in, y_min_out, $p, _isJSON);
            return $.sendPayloadTx(this.client, _account, payload__, option);
        });
    }
    payload_swap(num_steps, first_dex_type, first_pool_type, first_is_x_to_y, second_dex_type, second_pool_type, second_is_x_to_y, third_dex_type, third_pool_type, third_is_x_to_y, x_in, m_min_out, $p /* <X, Y, Z, OutCoin, E1, E2, E3>*/, isJSON = false) {
        return buildPayload_swap(num_steps, first_dex_type, first_pool_type, first_is_x_to_y, second_dex_type, second_pool_type, second_is_x_to_y, third_dex_type, third_pool_type, third_is_x_to_y, x_in, m_min_out, $p, isJSON);
    }
    swap(_account, num_steps, first_dex_type, first_pool_type, first_is_x_to_y, second_dex_type, second_pool_type, second_is_x_to_y, third_dex_type, third_pool_type, third_is_x_to_y, x_in, m_min_out, $p /* <X, Y, Z, OutCoin, E1, E2, E3>*/, option, _isJSON = false) {
        return __awaiter(this, void 0, void 0, function* () {
            const payload__ = buildPayload_swap(num_steps, first_dex_type, first_pool_type, first_is_x_to_y, second_dex_type, second_pool_type, second_is_x_to_y, third_dex_type, third_pool_type, third_is_x_to_y, x_in, m_min_out, $p, _isJSON);
            return $.sendPayloadTx(this.client, _account, payload__, option);
        });
    }
    payload_three_step_route(first_dex_type, first_pool_type, first_is_x_to_y, second_dex_type, second_pool_type, second_is_x_to_y, third_dex_type, third_pool_type, third_is_x_to_y, x_in, m_min_out, $p /* <X, Y, Z, M, E1, E2, E3>*/, isJSON = false) {
        return buildPayload_three_step_route(first_dex_type, first_pool_type, first_is_x_to_y, second_dex_type, second_pool_type, second_is_x_to_y, third_dex_type, third_pool_type, third_is_x_to_y, x_in, m_min_out, $p, isJSON);
    }
    three_step_route(_account, first_dex_type, first_pool_type, first_is_x_to_y, second_dex_type, second_pool_type, second_is_x_to_y, third_dex_type, third_pool_type, third_is_x_to_y, x_in, m_min_out, $p /* <X, Y, Z, M, E1, E2, E3>*/, option, _isJSON = false) {
        return __awaiter(this, void 0, void 0, function* () {
            const payload__ = buildPayload_three_step_route(first_dex_type, first_pool_type, first_is_x_to_y, second_dex_type, second_pool_type, second_is_x_to_y, third_dex_type, third_pool_type, third_is_x_to_y, x_in, m_min_out, $p, _isJSON);
            return $.sendPayloadTx(this.client, _account, payload__, option);
        });
    }
    payload_two_step_route(first_dex_type, first_pool_type, first_is_x_to_y, second_dex_type, second_pool_type, second_is_x_to_y, x_in, z_min_out, $p /* <X, Y, Z, E1, E2>*/, isJSON = false) {
        return buildPayload_two_step_route(first_dex_type, first_pool_type, first_is_x_to_y, second_dex_type, second_pool_type, second_is_x_to_y, x_in, z_min_out, $p, isJSON);
    }
    two_step_route(_account, first_dex_type, first_pool_type, first_is_x_to_y, second_dex_type, second_pool_type, second_is_x_to_y, x_in, z_min_out, $p /* <X, Y, Z, E1, E2>*/, option, _isJSON = false) {
        return __awaiter(this, void 0, void 0, function* () {
            const payload__ = buildPayload_two_step_route(first_dex_type, first_pool_type, first_is_x_to_y, second_dex_type, second_pool_type, second_is_x_to_y, x_in, z_min_out, $p, _isJSON);
            return $.sendPayloadTx(this.client, _account, payload__, option);
        });
    }
}

var Aggregator = /*#__PURE__*/Object.freeze({
    __proto__: null,
    packageName: packageName$4,
    moduleAddress: moduleAddress$4,
    moduleName: moduleName$4,
    DEX_ANIMESWAP: DEX_ANIMESWAP,
    DEX_APTOSWAP: DEX_APTOSWAP,
    DEX_AUX: DEX_AUX,
    DEX_BASIQ: DEX_BASIQ,
    DEX_DITTO: DEX_DITTO,
    DEX_ECONIA: DEX_ECONIA,
    DEX_HIPPO: DEX_HIPPO,
    DEX_PONTEM: DEX_PONTEM,
    DEX_TORTUGA: DEX_TORTUGA,
    E_COIN_STORE_NOT_EXITES: E_COIN_STORE_NOT_EXITES,
    E_INVALID_PAIR_OF_DITTO: E_INVALID_PAIR_OF_DITTO,
    E_INVALID_PAIR_OF_TORTUGA: E_INVALID_PAIR_OF_TORTUGA,
    E_NOT_ADMIN: E_NOT_ADMIN$1,
    E_OUTPUT_LESS_THAN_MINIMUM: E_OUTPUT_LESS_THAN_MINIMUM,
    E_TYPE_NOT_EQUAL: E_TYPE_NOT_EQUAL,
    E_UNKNOWN_DEX: E_UNKNOWN_DEX,
    E_UNKNOWN_POOL_TYPE: E_UNKNOWN_POOL_TYPE,
    E_UNSUPPORTED_NUM_STEPS: E_UNSUPPORTED_NUM_STEPS,
    HIPPO_CONSTANT_PRODUCT: HIPPO_CONSTANT_PRODUCT,
    HIPPO_PIECEWISE: HIPPO_PIECEWISE,
    HI_64: HI_64,
    AuxSigner: AuxSigner,
    CoinStore: CoinStore,
    EventStore: EventStore,
    SwapStepEvent: SwapStepEvent,
    change_coin_type_: change_coin_type_,
    check_and_deposit_: check_and_deposit_,
    check_and_deposit_opt_: check_and_deposit_opt_,
    create_aux_signer_: create_aux_signer_,
    buildPayload_create_aux_signer: buildPayload_create_aux_signer,
    emit_swap_step_event_: emit_swap_step_event_,
    get_intermediate_output_: get_intermediate_output_,
    init_coin_store_: init_coin_store_,
    buildPayload_init_coin_store: buildPayload_init_coin_store,
    init_coin_store_all_: init_coin_store_all_,
    buildPayload_init_coin_store_all: buildPayload_init_coin_store_all,
    init_module_: init_module_,
    buildPayload_init_module: buildPayload_init_module,
    one_step_direct_: one_step_direct_,
    one_step_route_: one_step_route_,
    buildPayload_one_step_route: buildPayload_one_step_route,
    swap_: swap_,
    buildPayload_swap: buildPayload_swap,
    swap_direct_: swap_direct_,
    three_step_direct_: three_step_direct_,
    three_step_route_: three_step_route_,
    buildPayload_three_step_route: buildPayload_three_step_route,
    two_step_direct_: two_step_direct_,
    two_step_route_: two_step_route_,
    buildPayload_two_step_route: buildPayload_two_step_route,
    loadParsers: loadParsers$7,
    App: App$8
});

const packageName$3 = 'HippoAggregator';
const moduleAddress$3 = new HexString('0x510c1110ceb407484d394ce00f47b8421707df417be80a3a7d9c72884fa303c7');
const moduleName$3 = 'devnet';
const BTC_AMOUNT = u64('100000000').mul(u64('1000'));
const STABLE_COIN_AMOUNT = u64('100000000').mul(u64('1000')).mul(u64('10000'));
class PontemLP {
    constructor(proto, typeTag) {
        this.typeTag = typeTag;
        this.__app = null;
    }
    static PontemLPParser(data, typeTag, repo) {
        const proto = $.parseStructProto(data, typeTag, repo, PontemLP);
        return new PontemLP(proto, typeTag);
    }
    static makeTag($p) {
        return new StructTag(moduleAddress$3, moduleName$3, 'PontemLP', $p);
    }
    loadFullState(app) {
        return __awaiter(this, void 0, void 0, function* () {
            this.__app = app;
        });
    }
}
PontemLP.moduleAddress = moduleAddress$3;
PontemLP.moduleName = moduleName$3;
PontemLP.structName = 'PontemLP';
PontemLP.typeParameters = [
    { name: 'X', isPhantom: true },
    { name: 'Y', isPhantom: true }
];
PontemLP.fields = [];
class PontemLP2 {
    constructor(proto, typeTag) {
        this.typeTag = typeTag;
        this.__app = null;
    }
    static PontemLP2Parser(data, typeTag, repo) {
        const proto = $.parseStructProto(data, typeTag, repo, PontemLP2);
        return new PontemLP2(proto, typeTag);
    }
    static makeTag($p) {
        return new StructTag(moduleAddress$3, moduleName$3, 'PontemLP2', $p);
    }
    loadFullState(app) {
        return __awaiter(this, void 0, void 0, function* () {
            this.__app = app;
        });
    }
}
PontemLP2.moduleAddress = moduleAddress$3;
PontemLP2.moduleName = moduleName$3;
PontemLP2.structName = 'PontemLP2';
PontemLP2.typeParameters = [
    { name: 'X', isPhantom: true },
    { name: 'Y', isPhantom: true },
    { name: 'curve', isPhantom: true }
];
PontemLP2.fields = [];
function deploy_aux_(admin, xAmount, yAmount, $c, $p /* <X, Y>*/) {
    create_pool_(admin, u64('1'), $c, [$p[0], $p[1]]);
    mint_to_wallet_(admin, $.copy(xAmount), $c, [$p[0]]);
    mint_to_wallet_(admin, $.copy(yAmount), $c, [$p[1]]);
    return add_exact_liquidity_(admin, $.copy(xAmount), $.copy(yAmount), $c, [$p[0], $p[1]]);
}
function deploy_pontem_(admin, xAmount, yAmount, $c, $p /* <xCoin, yCoin, curve>*/) {
    mint_to_wallet_(admin, $.copy(xAmount), $c, [$p[0]]);
    mint_to_wallet_(admin, $.copy(yAmount), $c, [$p[1]]);
    return register_pool_and_add_liquidity_(admin, $.copy(xAmount), $.copy(xAmount), $.copy(yAmount), $.copy(yAmount), $c, [$p[0], $p[1], $p[2]]);
}
function mock_deploy_aux_(admin, $c) {
    deploy_aux_(admin, $.copy(BTC_AMOUNT), $.copy(STABLE_COIN_AMOUNT), $c, [
        new StructTag(new HexString('0x498d8926f16eb9ca90cab1b3a26aa6f97a080b3fcbe6e83ae150b7243a00fb68'), 'devnet_coins', 'DevnetBTC', []),
        new StructTag(new HexString('0x498d8926f16eb9ca90cab1b3a26aa6f97a080b3fcbe6e83ae150b7243a00fb68'), 'devnet_coins', 'DevnetUSDC', [])
    ]);
    deploy_aux_(admin, $.copy(BTC_AMOUNT), $.copy(STABLE_COIN_AMOUNT), $c, [
        new StructTag(new HexString('0x498d8926f16eb9ca90cab1b3a26aa6f97a080b3fcbe6e83ae150b7243a00fb68'), 'devnet_coins', 'DevnetBTC', []),
        new StructTag(new HexString('0x498d8926f16eb9ca90cab1b3a26aa6f97a080b3fcbe6e83ae150b7243a00fb68'), 'devnet_coins', 'DevnetUSDT', [])
    ]);
    deploy_aux_(admin, $.copy(STABLE_COIN_AMOUNT), $.copy(STABLE_COIN_AMOUNT), $c, [
        new StructTag(new HexString('0x498d8926f16eb9ca90cab1b3a26aa6f97a080b3fcbe6e83ae150b7243a00fb68'), 'devnet_coins', 'DevnetUSDC', []),
        new StructTag(new HexString('0x498d8926f16eb9ca90cab1b3a26aa6f97a080b3fcbe6e83ae150b7243a00fb68'), 'devnet_coins', 'DevnetUSDT', [])
    ]);
    deploy_aux_(admin, $.copy(STABLE_COIN_AMOUNT), $.copy(STABLE_COIN_AMOUNT), $c, [
        new StructTag(new HexString('0x498d8926f16eb9ca90cab1b3a26aa6f97a080b3fcbe6e83ae150b7243a00fb68'), 'devnet_coins', 'DevnetDAI', []),
        new StructTag(new HexString('0x498d8926f16eb9ca90cab1b3a26aa6f97a080b3fcbe6e83ae150b7243a00fb68'), 'devnet_coins', 'DevnetUSDC', [])
    ]);
    return;
}
function buildPayload_mock_deploy_aux(isJSON = false) {
    const typeParamStrings = [];
    return $.buildPayload(new HexString('0x510c1110ceb407484d394ce00f47b8421707df417be80a3a7d9c72884fa303c7'), 'devnet', 'mock_deploy_aux', typeParamStrings, [], isJSON);
}
function mock_deploy_pontem_(admin, $c) {
    deploy_pontem_(admin, $.copy(BTC_AMOUNT), $.copy(STABLE_COIN_AMOUNT), $c, [
        new StructTag(new HexString('0x498d8926f16eb9ca90cab1b3a26aa6f97a080b3fcbe6e83ae150b7243a00fb68'), 'devnet_coins', 'DevnetBTC', []),
        new StructTag(new HexString('0x498d8926f16eb9ca90cab1b3a26aa6f97a080b3fcbe6e83ae150b7243a00fb68'), 'devnet_coins', 'DevnetUSDC', []),
        new StructTag(new HexString('0x190d44266241744264b964a37b8f09863167a12d3e70cda39376cfb4e3561e12'), 'curves', 'Uncorrelated', [])
    ]);
    deploy_pontem_(admin, $.copy(BTC_AMOUNT), $.copy(STABLE_COIN_AMOUNT), $c, [
        new StructTag(new HexString('0x498d8926f16eb9ca90cab1b3a26aa6f97a080b3fcbe6e83ae150b7243a00fb68'), 'devnet_coins', 'DevnetBTC', []),
        new StructTag(new HexString('0x498d8926f16eb9ca90cab1b3a26aa6f97a080b3fcbe6e83ae150b7243a00fb68'), 'devnet_coins', 'DevnetUSDT', []),
        new StructTag(new HexString('0x190d44266241744264b964a37b8f09863167a12d3e70cda39376cfb4e3561e12'), 'curves', 'Uncorrelated', [])
    ]);
    deploy_pontem_(admin, $.copy(STABLE_COIN_AMOUNT), $.copy(STABLE_COIN_AMOUNT), $c, [
        new StructTag(new HexString('0x498d8926f16eb9ca90cab1b3a26aa6f97a080b3fcbe6e83ae150b7243a00fb68'), 'devnet_coins', 'DevnetUSDC', []),
        new StructTag(new HexString('0x498d8926f16eb9ca90cab1b3a26aa6f97a080b3fcbe6e83ae150b7243a00fb68'), 'devnet_coins', 'DevnetUSDT', []),
        new StructTag(new HexString('0x190d44266241744264b964a37b8f09863167a12d3e70cda39376cfb4e3561e12'), 'curves', 'Stable', [])
    ]);
    deploy_pontem_(admin, $.copy(STABLE_COIN_AMOUNT), $.copy(STABLE_COIN_AMOUNT), $c, [
        new StructTag(new HexString('0x498d8926f16eb9ca90cab1b3a26aa6f97a080b3fcbe6e83ae150b7243a00fb68'), 'devnet_coins', 'DevnetDAI', []),
        new StructTag(new HexString('0x498d8926f16eb9ca90cab1b3a26aa6f97a080b3fcbe6e83ae150b7243a00fb68'), 'devnet_coins', 'DevnetUSDC', []),
        new StructTag(new HexString('0x190d44266241744264b964a37b8f09863167a12d3e70cda39376cfb4e3561e12'), 'curves', 'Stable', [])
    ]);
    return;
}
function buildPayload_mock_deploy_pontem(isJSON = false) {
    const typeParamStrings = [];
    return $.buildPayload(new HexString('0x510c1110ceb407484d394ce00f47b8421707df417be80a3a7d9c72884fa303c7'), 'devnet', 'mock_deploy_pontem', typeParamStrings, [], isJSON);
}
function registe_coins_(hippo_swap, coin_list, deploy_coin_list, $c) {
    return;
}
function buildPayload_registe_coins(deploy_coin_list, isJSON = false) {
    const typeParamStrings = [];
    return $.buildPayload(new HexString('0x510c1110ceb407484d394ce00f47b8421707df417be80a3a7d9c72884fa303c7'), 'devnet', 'registe_coins', typeParamStrings, [deploy_coin_list], isJSON);
}
function loadParsers$6(repo) {
    repo.addParser('0x510c1110ceb407484d394ce00f47b8421707df417be80a3a7d9c72884fa303c7::devnet::PontemLP', PontemLP.PontemLPParser);
    repo.addParser('0x510c1110ceb407484d394ce00f47b8421707df417be80a3a7d9c72884fa303c7::devnet::PontemLP2', PontemLP2.PontemLP2Parser);
}
class App$7 {
    constructor(client, repo, cache) {
        this.client = client;
        this.repo = repo;
        this.cache = cache;
    }
    get moduleAddress() {
        {
            return moduleAddress$3;
        }
    }
    get moduleName() {
        {
            return moduleName$3;
        }
    }
    get PontemLP() {
        return PontemLP;
    }
    get PontemLP2() {
        return PontemLP2;
    }
    payload_mock_deploy_aux(isJSON = false) {
        return buildPayload_mock_deploy_aux(isJSON);
    }
    mock_deploy_aux(_account, option, _isJSON = false) {
        return __awaiter(this, void 0, void 0, function* () {
            const payload__ = buildPayload_mock_deploy_aux(_isJSON);
            return $.sendPayloadTx(this.client, _account, payload__, option);
        });
    }
    payload_mock_deploy_pontem(isJSON = false) {
        return buildPayload_mock_deploy_pontem(isJSON);
    }
    mock_deploy_pontem(_account, option, _isJSON = false) {
        return __awaiter(this, void 0, void 0, function* () {
            const payload__ = buildPayload_mock_deploy_pontem(_isJSON);
            return $.sendPayloadTx(this.client, _account, payload__, option);
        });
    }
    payload_registe_coins(deploy_coin_list, isJSON = false) {
        return buildPayload_registe_coins(deploy_coin_list, isJSON);
    }
    registe_coins(_account, deploy_coin_list, option, _isJSON = false) {
        return __awaiter(this, void 0, void 0, function* () {
            const payload__ = buildPayload_registe_coins(deploy_coin_list, _isJSON);
            return $.sendPayloadTx(this.client, _account, payload__, option);
        });
    }
}

var Devnet = /*#__PURE__*/Object.freeze({
    __proto__: null,
    packageName: packageName$3,
    moduleAddress: moduleAddress$3,
    moduleName: moduleName$3,
    BTC_AMOUNT: BTC_AMOUNT,
    STABLE_COIN_AMOUNT: STABLE_COIN_AMOUNT,
    PontemLP: PontemLP,
    PontemLP2: PontemLP2,
    deploy_aux_: deploy_aux_,
    deploy_pontem_: deploy_pontem_,
    mock_deploy_aux_: mock_deploy_aux_,
    buildPayload_mock_deploy_aux: buildPayload_mock_deploy_aux,
    mock_deploy_pontem_: mock_deploy_pontem_,
    buildPayload_mock_deploy_pontem: buildPayload_mock_deploy_pontem,
    registe_coins_: registe_coins_,
    buildPayload_registe_coins: buildPayload_registe_coins,
    loadParsers: loadParsers$6,
    App: App$7
});

const packageName$2 = 'HippoAggregator';
const moduleAddress$2 = new HexString('0x510c1110ceb407484d394ce00f47b8421707df417be80a3a7d9c72884fa303c7');
const moduleName$2 = 'volume';
const E_NOT_ADMIN = u64('1');
const E_NOT_POSTER = u64('2');
const E_REPEAT_POST = u64('3');
const E_VERCTOR_LENGT_NOT_EQUAL = u64('4');
const VOLUME_HISTORY_LENGTH = u64('30');
class PoolProvider {
    constructor(proto, typeTag) {
        this.typeTag = typeTag;
        this.__app = null;
        this.dex_type = proto['dex_type'];
        this.amount = proto['amount'];
    }
    static PoolProviderParser(data, typeTag, repo) {
        const proto = $.parseStructProto(data, typeTag, repo, PoolProvider);
        return new PoolProvider(proto, typeTag);
    }
    static getTag() {
        return new StructTag(moduleAddress$2, moduleName$2, 'PoolProvider', []);
    }
    loadFullState(app) {
        return __awaiter(this, void 0, void 0, function* () {
            this.__app = app;
        });
    }
}
PoolProvider.moduleAddress = moduleAddress$2;
PoolProvider.moduleName = moduleName$2;
PoolProvider.structName = 'PoolProvider';
PoolProvider.typeParameters = [];
PoolProvider.fields = [
    { name: 'dex_type', typeTag: AtomicTypeTag.U8 },
    { name: 'amount', typeTag: AtomicTypeTag.U64 }
];
class TotalVolume {
    constructor(proto, typeTag) {
        this.typeTag = typeTag;
        this.__app = null;
        this.start_time = proto['start_time'];
        this.amount = proto['amount'];
    }
    static TotalVolumeParser(data, typeTag, repo) {
        const proto = $.parseStructProto(data, typeTag, repo, TotalVolume);
        return new TotalVolume(proto, typeTag);
    }
    static getTag() {
        return new StructTag(moduleAddress$2, moduleName$2, 'TotalVolume', []);
    }
    loadFullState(app) {
        return __awaiter(this, void 0, void 0, function* () {
            this.__app = app;
        });
    }
}
TotalVolume.moduleAddress = moduleAddress$2;
TotalVolume.moduleName = moduleName$2;
TotalVolume.structName = 'TotalVolume';
TotalVolume.typeParameters = [];
TotalVolume.fields = [
    { name: 'start_time', typeTag: AtomicTypeTag.U64 },
    { name: 'amount', typeTag: AtomicTypeTag.U64 }
];
class TradingPair {
    constructor(proto, typeTag) {
        this.typeTag = typeTag;
        this.__app = null;
        this.coin_x = proto['coin_x'];
        this.coin_y = proto['coin_y'];
        this.amount = proto['amount'];
    }
    static TradingPairParser(data, typeTag, repo) {
        const proto = $.parseStructProto(data, typeTag, repo, TradingPair);
        return new TradingPair(proto, typeTag);
    }
    static getTag() {
        return new StructTag(moduleAddress$2, moduleName$2, 'TradingPair', []);
    }
    loadFullState(app) {
        return __awaiter(this, void 0, void 0, function* () {
            yield this.coin_x.loadFullState(app);
            yield this.coin_y.loadFullState(app);
            this.__app = app;
        });
    }
}
TradingPair.moduleAddress = moduleAddress$2;
TradingPair.moduleName = moduleName$2;
TradingPair.structName = 'TradingPair';
TradingPair.typeParameters = [];
TradingPair.fields = [
    { name: 'coin_x', typeTag: new StructTag(new HexString('0x1'), 'string', 'String', []) },
    { name: 'coin_y', typeTag: new StructTag(new HexString('0x1'), 'string', 'String', []) },
    { name: 'amount', typeTag: AtomicTypeTag.U64 }
];
class Volume {
    constructor(proto, typeTag) {
        this.typeTag = typeTag;
        this.__app = null;
        this.poster = proto['poster'];
        this.total_volume = proto['total_volume'];
        this.last_24h_volume = proto['last_24h_volume'];
        this.last_7d_volume = proto['last_7d_volume'];
        this.data_end_sequence_number = proto['data_end_sequence_number'];
        this.data_end_time = proto['data_end_time'];
        this.volume_decimals = proto['volume_decimals'];
        this.total_volume_history_24h = proto['total_volume_history_24h'];
        this.total_volume_history_7d = proto['total_volume_history_7d'];
        this.top_trading_pairs_24h = proto['top_trading_pairs_24h'];
        this.top_trading_pairs_7d = proto['top_trading_pairs_7d'];
        this.top_pool_provider_24h = proto['top_pool_provider_24h'];
        this.top_pool_provider_7d = proto['top_pool_provider_7d'];
    }
    static VolumeParser(data, typeTag, repo) {
        const proto = $.parseStructProto(data, typeTag, repo, Volume);
        return new Volume(proto, typeTag);
    }
    static load(repo, client, address, typeParams) {
        return __awaiter(this, void 0, void 0, function* () {
            const result = yield repo.loadResource(client, address, Volume, typeParams);
            return result;
        });
    }
    static loadByApp(app, address, typeParams) {
        return __awaiter(this, void 0, void 0, function* () {
            const result = yield app.repo.loadResource(app.client, address, Volume, typeParams);
            yield result.loadFullState(app);
            return result;
        });
    }
    static getTag() {
        return new StructTag(moduleAddress$2, moduleName$2, 'Volume', []);
    }
    loadFullState(app) {
        return __awaiter(this, void 0, void 0, function* () {
            this.__app = app;
        });
    }
}
Volume.moduleAddress = moduleAddress$2;
Volume.moduleName = moduleName$2;
Volume.structName = 'Volume';
Volume.typeParameters = [];
Volume.fields = [
    { name: 'poster', typeTag: AtomicTypeTag.Address },
    { name: 'total_volume', typeTag: AtomicTypeTag.U128 },
    { name: 'last_24h_volume', typeTag: AtomicTypeTag.U64 },
    { name: 'last_7d_volume', typeTag: AtomicTypeTag.U64 },
    { name: 'data_end_sequence_number', typeTag: AtomicTypeTag.U64 },
    { name: 'data_end_time', typeTag: AtomicTypeTag.U64 },
    { name: 'volume_decimals', typeTag: AtomicTypeTag.U64 },
    {
        name: 'total_volume_history_24h',
        typeTag: new VectorTag(new StructTag(new HexString('0x510c1110ceb407484d394ce00f47b8421707df417be80a3a7d9c72884fa303c7'), 'volume', 'TotalVolume', []))
    },
    {
        name: 'total_volume_history_7d',
        typeTag: new VectorTag(new StructTag(new HexString('0x510c1110ceb407484d394ce00f47b8421707df417be80a3a7d9c72884fa303c7'), 'volume', 'TotalVolume', []))
    },
    {
        name: 'top_trading_pairs_24h',
        typeTag: new VectorTag(new StructTag(new HexString('0x510c1110ceb407484d394ce00f47b8421707df417be80a3a7d9c72884fa303c7'), 'volume', 'TradingPair', []))
    },
    {
        name: 'top_trading_pairs_7d',
        typeTag: new VectorTag(new StructTag(new HexString('0x510c1110ceb407484d394ce00f47b8421707df417be80a3a7d9c72884fa303c7'), 'volume', 'TradingPair', []))
    },
    {
        name: 'top_pool_provider_24h',
        typeTag: new VectorTag(new StructTag(new HexString('0x510c1110ceb407484d394ce00f47b8421707df417be80a3a7d9c72884fa303c7'), 'volume', 'PoolProvider', []))
    },
    {
        name: 'top_pool_provider_7d',
        typeTag: new VectorTag(new StructTag(new HexString('0x510c1110ceb407484d394ce00f47b8421707df417be80a3a7d9c72884fa303c7'), 'volume', 'PoolProvider', []))
    }
];
function add_volume_(total_volume_array, round_start_time, amount, $c) {
    let array_length, total_volume;
    array_length = length_$6(total_volume_array, $c, [new SimpleStructTag(TotalVolume)]);
    if ($.copy(array_length).eq(u64('0'))) {
        push_back_(total_volume_array, new TotalVolume({ start_time: $.copy(round_start_time), amount: $.copy(amount) }, new SimpleStructTag(TotalVolume)), $c, [new SimpleStructTag(TotalVolume)]);
        return;
    }
    total_volume = borrow_mut_$7(total_volume_array, $.copy(array_length).sub(u64('1')), $c, [
        new SimpleStructTag(TotalVolume)
    ]);
    if ($.copy(total_volume.start_time).eq($.copy(round_start_time))) {
        total_volume.amount = $.copy(total_volume.amount).add($.copy(amount));
    }
    else {
        push_back_(total_volume_array, new TotalVolume({ start_time: $.copy(round_start_time), amount: $.copy(amount) }, new SimpleStructTag(TotalVolume)), $c, [new SimpleStructTag(TotalVolume)]);
    }
    if ($.copy(array_length).gt($.copy(VOLUME_HISTORY_LENGTH))) {
        remove_$5(total_volume_array, u64('0'), $c, [new SimpleStructTag(TotalVolume)]);
    }
    return;
}
function clean_(poster, $c) {
    let volume;
    volume = $c.borrow_global_mut(new SimpleStructTag(Volume), new HexString('0x510c1110ceb407484d394ce00f47b8421707df417be80a3a7d9c72884fa303c7'));
    if (!(address_of_(poster, $c).hex() === $.copy(volume.poster).hex())) {
        throw $.abortCode($.copy(E_NOT_POSTER));
    }
    volume.total_volume = u128('0');
    volume.data_end_sequence_number = u64('0');
    volume.data_end_time = u64('0');
    volume.last_24h_volume = u64('0');
    volume.last_7d_volume = u64('0');
    volume.total_volume_history_24h = empty_$5($c, [new SimpleStructTag(TotalVolume)]);
    volume.total_volume_history_7d = empty_$5($c, [new SimpleStructTag(TotalVolume)]);
    volume.top_trading_pairs_24h = empty_$5($c, [new SimpleStructTag(TradingPair)]);
    volume.top_trading_pairs_7d = empty_$5($c, [new SimpleStructTag(TradingPair)]);
    volume.top_pool_provider_24h = empty_$5($c, [new SimpleStructTag(PoolProvider)]);
    volume.top_pool_provider_7d = empty_$5($c, [new SimpleStructTag(PoolProvider)]);
    return;
}
function buildPayload_clean(isJSON = false) {
    const typeParamStrings = [];
    return $.buildPayload(new HexString('0x510c1110ceb407484d394ce00f47b8421707df417be80a3a7d9c72884fa303c7'), 'volume', 'clean', typeParamStrings, [], isJSON);
}
function fetch_volume_(fetcher, $c) {
    return $c.move_to(new SimpleStructTag(Volume), fetcher, get_volume_($c));
}
function buildPayload_fetch_volume(isJSON = false) {
    const typeParamStrings = [];
    return $.buildPayload(new HexString('0x510c1110ceb407484d394ce00f47b8421707df417be80a3a7d9c72884fa303c7'), 'volume', 'fetch_volume', typeParamStrings, [], isJSON);
}
function query_fetch_volume(client, fetcher, repo, $p, option, _isJSON = false) {
    return __awaiter(this, void 0, void 0, function* () {
        const payload__ = buildPayload_fetch_volume(_isJSON);
        const outputTypeTag = new SimpleStructTag(Volume);
        const output = yield $.simulatePayloadTx(client, fetcher, payload__, option);
        return $.takeSimulationValue(output, outputTypeTag, repo);
    });
}
function get_volume_($c) {
    return $.copy($c.borrow_global(new SimpleStructTag(Volume), new HexString('0x510c1110ceb407484d394ce00f47b8421707df417be80a3a7d9c72884fa303c7')));
}
function buildPayload_get_volume(isJSON = false) {
    const typeParamStrings = [];
    return $.buildPayload(new HexString('0x510c1110ceb407484d394ce00f47b8421707df417be80a3a7d9c72884fa303c7'), 'volume', 'get_volume', typeParamStrings, [], isJSON);
}
function initialize_(admin, poster, $c) {
    let admin_addr;
    admin_addr = address_of_(admin, $c);
    if (!($.copy(admin_addr).hex() ===
        new HexString('0x510c1110ceb407484d394ce00f47b8421707df417be80a3a7d9c72884fa303c7').hex())) {
        throw $.abortCode($.copy(E_NOT_ADMIN));
    }
    return $c.move_to(new SimpleStructTag(Volume), admin, new Volume({
        poster: $.copy(poster),
        total_volume: u128('0'),
        last_24h_volume: u64('0'),
        last_7d_volume: u64('0'),
        data_end_sequence_number: u64('0'),
        data_end_time: u64('0'),
        volume_decimals: u64('4'),
        total_volume_history_24h: empty_$5($c, [new SimpleStructTag(TotalVolume)]),
        total_volume_history_7d: empty_$5($c, [new SimpleStructTag(TotalVolume)]),
        top_trading_pairs_24h: empty_$5($c, [new SimpleStructTag(TradingPair)]),
        top_trading_pairs_7d: empty_$5($c, [new SimpleStructTag(TradingPair)]),
        top_pool_provider_24h: empty_$5($c, [new SimpleStructTag(PoolProvider)]),
        top_pool_provider_7d: empty_$5($c, [new SimpleStructTag(PoolProvider)])
    }, new SimpleStructTag(Volume)));
}
function buildPayload_initialize(poster, isJSON = false) {
    const typeParamStrings = [];
    return $.buildPayload(new HexString('0x510c1110ceb407484d394ce00f47b8421707df417be80a3a7d9c72884fa303c7'), 'volume', 'initialize', typeParamStrings, [poster], isJSON);
}
function parse_pool_provider_vector_(dex_type_vector, amount_vector, $c) {
    let i, pool_provider;
    pool_provider = empty_$5($c, [new SimpleStructTag(PoolProvider)]);
    i = u64('0');
    while ($.copy(i).lt(length_$6(dex_type_vector, $c, [AtomicTypeTag.U8]))) {
        {
            push_back_(pool_provider, new PoolProvider({
                dex_type: $.copy(borrow_$7(dex_type_vector, $.copy(i), $c, [AtomicTypeTag.U8])),
                amount: $.copy(borrow_$7(amount_vector, $.copy(i), $c, [AtomicTypeTag.U64]))
            }, new SimpleStructTag(PoolProvider)), $c, [new SimpleStructTag(PoolProvider)]);
            i = $.copy(i).add(u64('1'));
        }
    }
    return $.copy(pool_provider);
}
function parse_trading_pairs_vector_(coin_x_vector, coin_y_vector, amount_vector, $c) {
    let i, trading_pairs;
    trading_pairs = empty_$5($c, [new SimpleStructTag(TradingPair)]);
    i = u64('0');
    while ($.copy(i).lt(length_$6(coin_x_vector, $c, [new VectorTag(AtomicTypeTag.U8)]))) {
        {
            push_back_(trading_pairs, new TradingPair({
                coin_x: utf8_($.copy(borrow_$7(coin_x_vector, $.copy(i), $c, [new VectorTag(AtomicTypeTag.U8)])), $c),
                coin_y: utf8_($.copy(borrow_$7(coin_y_vector, $.copy(i), $c, [new VectorTag(AtomicTypeTag.U8)])), $c),
                amount: $.copy(borrow_$7(amount_vector, $.copy(i), $c, [AtomicTypeTag.U64]))
            }, new SimpleStructTag(TradingPair)), $c, [new SimpleStructTag(TradingPair)]);
            i = $.copy(i).add(u64('1'));
        }
    }
    return $.copy(trading_pairs);
}
function parse_volume_history_vector_(start_time_vector, amount_vector, $c) {
    let i, volume_history;
    volume_history = empty_$5($c, [new SimpleStructTag(TotalVolume)]);
    i = u64('0');
    while ($.copy(i).lt(length_$6(start_time_vector, $c, [AtomicTypeTag.U64]))) {
        {
            push_back_(volume_history, new TotalVolume({
                start_time: $.copy(borrow_$7(start_time_vector, $.copy(i), $c, [AtomicTypeTag.U64])),
                amount: $.copy(borrow_$7(amount_vector, $.copy(i), $c, [AtomicTypeTag.U64]))
            }, new SimpleStructTag(TotalVolume)), $c, [new SimpleStructTag(TotalVolume)]);
            i = $.copy(i).add(u64('1'));
        }
    }
    return $.copy(volume_history);
}
function post_(_poster, _amount, _last_24_volume, _last_7d_volume, _round_start_time_24h, _round_start_time_7d, _new_data_end_time, _new_data_end_seauence_number, _trading_pairs_24h_coin_x, _trading_pairs_24h_coin_y, _trading_pairs_24h_amount, _trading_pairs_7d_coin_x, _trading_pairs_7d_coin_y, _trading_pairs_7d_amount, _pool_provider_24h_dex_type, _pool_provider_24h_amount, _pool_provider_7d_dex_type, _pool_provider_7d_amount, $c) {
    return;
}
function buildPayload_post(_amount, _last_24_volume, _last_7d_volume, _round_start_time_24h, _round_start_time_7d, _new_data_end_time, _new_data_end_seauence_number, _trading_pairs_24h_coin_x, _trading_pairs_24h_coin_y, _trading_pairs_24h_amount, _trading_pairs_7d_coin_x, _trading_pairs_7d_coin_y, _trading_pairs_7d_amount, _pool_provider_24h_dex_type, _pool_provider_24h_amount, _pool_provider_7d_dex_type, _pool_provider_7d_amount, isJSON = false) {
    const typeParamStrings = [];
    return $.buildPayload(new HexString('0x510c1110ceb407484d394ce00f47b8421707df417be80a3a7d9c72884fa303c7'), 'volume', 'post', typeParamStrings, [
        _amount,
        _last_24_volume,
        _last_7d_volume,
        _round_start_time_24h,
        _round_start_time_7d,
        _new_data_end_time,
        _new_data_end_seauence_number,
        _trading_pairs_24h_coin_x,
        _trading_pairs_24h_coin_y,
        _trading_pairs_24h_amount,
        _trading_pairs_7d_coin_x,
        _trading_pairs_7d_coin_y,
        _trading_pairs_7d_amount,
        _pool_provider_24h_dex_type,
        _pool_provider_24h_amount,
        _pool_provider_7d_dex_type,
        _pool_provider_7d_amount
    ], isJSON);
}
function post_v2_(poster, total_volume, last_24_volume, last_7d_volume, data_end_time, data_end_seauence_number, total_volume_history_24h_start_time, total_volume_history_24h_volume, total_volume_history_7d_start_time, total_volume_history_7d_volume, trading_pairs_24h_coin_x, trading_pairs_24h_coin_y, trading_pairs_24h_amount, trading_pairs_7d_coin_x, trading_pairs_7d_coin_y, trading_pairs_7d_amount, pool_provider_24h_dex_type, pool_provider_24h_amount, pool_provider_7d_dex_type, pool_provider_7d_amount, $c) {
    let volume;
    volume = $c.borrow_global_mut(new SimpleStructTag(Volume), new HexString('0x510c1110ceb407484d394ce00f47b8421707df417be80a3a7d9c72884fa303c7'));
    if (!(address_of_(poster, $c).hex() === $.copy(volume.poster).hex())) {
        throw $.abortCode($.copy(E_NOT_POSTER));
    }
    volume.total_volume = $.copy(total_volume);
    volume.last_24h_volume = $.copy(last_24_volume);
    volume.last_7d_volume = $.copy(last_7d_volume);
    volume.data_end_time = $.copy(data_end_time);
    volume.data_end_sequence_number = $.copy(data_end_seauence_number);
    volume.top_trading_pairs_24h = parse_trading_pairs_vector_(trading_pairs_24h_coin_x, trading_pairs_24h_coin_y, trading_pairs_24h_amount, $c);
    volume.top_trading_pairs_7d = parse_trading_pairs_vector_(trading_pairs_7d_coin_x, trading_pairs_7d_coin_y, trading_pairs_7d_amount, $c);
    volume.top_pool_provider_24h = parse_pool_provider_vector_(pool_provider_24h_dex_type, pool_provider_24h_amount, $c);
    volume.top_pool_provider_7d = parse_pool_provider_vector_(pool_provider_7d_dex_type, pool_provider_7d_amount, $c);
    volume.total_volume_history_24h = parse_volume_history_vector_(total_volume_history_24h_start_time, total_volume_history_24h_volume, $c);
    volume.total_volume_history_7d = parse_volume_history_vector_(total_volume_history_7d_start_time, total_volume_history_7d_volume, $c);
    return;
}
function buildPayload_post_v2(total_volume, last_24_volume, last_7d_volume, data_end_time, data_end_seauence_number, total_volume_history_24h_start_time, total_volume_history_24h_volume, total_volume_history_7d_start_time, total_volume_history_7d_volume, trading_pairs_24h_coin_x, trading_pairs_24h_coin_y, trading_pairs_24h_amount, trading_pairs_7d_coin_x, trading_pairs_7d_coin_y, trading_pairs_7d_amount, pool_provider_24h_dex_type, pool_provider_24h_amount, pool_provider_7d_dex_type, pool_provider_7d_amount, isJSON = false) {
    const typeParamStrings = [];
    return $.buildPayload(new HexString('0x510c1110ceb407484d394ce00f47b8421707df417be80a3a7d9c72884fa303c7'), 'volume', 'post_v2', typeParamStrings, [
        total_volume,
        last_24_volume,
        last_7d_volume,
        data_end_time,
        data_end_seauence_number,
        total_volume_history_24h_start_time,
        total_volume_history_24h_volume,
        total_volume_history_7d_start_time,
        total_volume_history_7d_volume,
        trading_pairs_24h_coin_x,
        trading_pairs_24h_coin_y,
        trading_pairs_24h_amount,
        trading_pairs_7d_coin_x,
        trading_pairs_7d_coin_y,
        trading_pairs_7d_amount,
        pool_provider_24h_dex_type,
        pool_provider_24h_amount,
        pool_provider_7d_dex_type,
        pool_provider_7d_amount
    ], isJSON);
}
function set_poster_(admin, new_poster, $c) {
    let admin_addr, volume;
    admin_addr = address_of_(admin, $c);
    if (!($.copy(admin_addr).hex() ===
        new HexString('0x510c1110ceb407484d394ce00f47b8421707df417be80a3a7d9c72884fa303c7').hex())) {
        throw $.abortCode($.copy(E_NOT_ADMIN));
    }
    volume = $c.borrow_global_mut(new SimpleStructTag(Volume), $.copy(admin_addr));
    volume.poster = $.copy(new_poster);
    return;
}
function buildPayload_set_poster(new_poster, isJSON = false) {
    const typeParamStrings = [];
    return $.buildPayload(new HexString('0x510c1110ceb407484d394ce00f47b8421707df417be80a3a7d9c72884fa303c7'), 'volume', 'set_poster', typeParamStrings, [new_poster], isJSON);
}
function loadParsers$5(repo) {
    repo.addParser('0x510c1110ceb407484d394ce00f47b8421707df417be80a3a7d9c72884fa303c7::volume::PoolProvider', PoolProvider.PoolProviderParser);
    repo.addParser('0x510c1110ceb407484d394ce00f47b8421707df417be80a3a7d9c72884fa303c7::volume::TotalVolume', TotalVolume.TotalVolumeParser);
    repo.addParser('0x510c1110ceb407484d394ce00f47b8421707df417be80a3a7d9c72884fa303c7::volume::TradingPair', TradingPair.TradingPairParser);
    repo.addParser('0x510c1110ceb407484d394ce00f47b8421707df417be80a3a7d9c72884fa303c7::volume::Volume', Volume.VolumeParser);
}
class App$6 {
    constructor(client, repo, cache) {
        this.client = client;
        this.repo = repo;
        this.cache = cache;
    }
    get moduleAddress() {
        {
            return moduleAddress$2;
        }
    }
    get moduleName() {
        {
            return moduleName$2;
        }
    }
    get PoolProvider() {
        return PoolProvider;
    }
    get TotalVolume() {
        return TotalVolume;
    }
    get TradingPair() {
        return TradingPair;
    }
    get Volume() {
        return Volume;
    }
    loadVolume(owner, loadFull = true, fillCache = true) {
        return __awaiter(this, void 0, void 0, function* () {
            const val = yield Volume.load(this.repo, this.client, owner, []);
            if (loadFull) {
                yield val.loadFullState(this);
            }
            if (fillCache) {
                this.cache.set(val.typeTag, owner, val);
            }
            return val;
        });
    }
    payload_clean(isJSON = false) {
        return buildPayload_clean(isJSON);
    }
    clean(_account, option, _isJSON = false) {
        return __awaiter(this, void 0, void 0, function* () {
            const payload__ = buildPayload_clean(_isJSON);
            return $.sendPayloadTx(this.client, _account, payload__, option);
        });
    }
    payload_fetch_volume(isJSON = false) {
        return buildPayload_fetch_volume(isJSON);
    }
    fetch_volume(_account, option, _isJSON = false) {
        return __awaiter(this, void 0, void 0, function* () {
            const payload__ = buildPayload_fetch_volume(_isJSON);
            return $.sendPayloadTx(this.client, _account, payload__, option);
        });
    }
    query_fetch_volume($p, option, _isJSON = false, fetcher = $.SIM_KEYS) {
        return __awaiter(this, void 0, void 0, function* () {
            return query_fetch_volume(this.client, fetcher, this.repo, $p, option);
        });
    }
    payload_get_volume(isJSON = false) {
        return buildPayload_get_volume(isJSON);
    }
    get_volume(_account, option, _isJSON = false) {
        return __awaiter(this, void 0, void 0, function* () {
            const payload__ = buildPayload_get_volume(_isJSON);
            return $.sendPayloadTx(this.client, _account, payload__, option);
        });
    }
    payload_initialize(poster, isJSON = false) {
        return buildPayload_initialize(poster, isJSON);
    }
    initialize(_account, poster, option, _isJSON = false) {
        return __awaiter(this, void 0, void 0, function* () {
            const payload__ = buildPayload_initialize(poster, _isJSON);
            return $.sendPayloadTx(this.client, _account, payload__, option);
        });
    }
    payload_post(_amount, _last_24_volume, _last_7d_volume, _round_start_time_24h, _round_start_time_7d, _new_data_end_time, _new_data_end_seauence_number, _trading_pairs_24h_coin_x, _trading_pairs_24h_coin_y, _trading_pairs_24h_amount, _trading_pairs_7d_coin_x, _trading_pairs_7d_coin_y, _trading_pairs_7d_amount, _pool_provider_24h_dex_type, _pool_provider_24h_amount, _pool_provider_7d_dex_type, _pool_provider_7d_amount, isJSON = false) {
        return buildPayload_post(_amount, _last_24_volume, _last_7d_volume, _round_start_time_24h, _round_start_time_7d, _new_data_end_time, _new_data_end_seauence_number, _trading_pairs_24h_coin_x, _trading_pairs_24h_coin_y, _trading_pairs_24h_amount, _trading_pairs_7d_coin_x, _trading_pairs_7d_coin_y, _trading_pairs_7d_amount, _pool_provider_24h_dex_type, _pool_provider_24h_amount, _pool_provider_7d_dex_type, _pool_provider_7d_amount, isJSON);
    }
    post(_account, _amount, _last_24_volume, _last_7d_volume, _round_start_time_24h, _round_start_time_7d, _new_data_end_time, _new_data_end_seauence_number, _trading_pairs_24h_coin_x, _trading_pairs_24h_coin_y, _trading_pairs_24h_amount, _trading_pairs_7d_coin_x, _trading_pairs_7d_coin_y, _trading_pairs_7d_amount, _pool_provider_24h_dex_type, _pool_provider_24h_amount, _pool_provider_7d_dex_type, _pool_provider_7d_amount, option, _isJSON = false) {
        return __awaiter(this, void 0, void 0, function* () {
            const payload__ = buildPayload_post(_amount, _last_24_volume, _last_7d_volume, _round_start_time_24h, _round_start_time_7d, _new_data_end_time, _new_data_end_seauence_number, _trading_pairs_24h_coin_x, _trading_pairs_24h_coin_y, _trading_pairs_24h_amount, _trading_pairs_7d_coin_x, _trading_pairs_7d_coin_y, _trading_pairs_7d_amount, _pool_provider_24h_dex_type, _pool_provider_24h_amount, _pool_provider_7d_dex_type, _pool_provider_7d_amount, _isJSON);
            return $.sendPayloadTx(this.client, _account, payload__, option);
        });
    }
    payload_post_v2(total_volume, last_24_volume, last_7d_volume, data_end_time, data_end_seauence_number, total_volume_history_24h_start_time, total_volume_history_24h_volume, total_volume_history_7d_start_time, total_volume_history_7d_volume, trading_pairs_24h_coin_x, trading_pairs_24h_coin_y, trading_pairs_24h_amount, trading_pairs_7d_coin_x, trading_pairs_7d_coin_y, trading_pairs_7d_amount, pool_provider_24h_dex_type, pool_provider_24h_amount, pool_provider_7d_dex_type, pool_provider_7d_amount, isJSON = false) {
        return buildPayload_post_v2(total_volume, last_24_volume, last_7d_volume, data_end_time, data_end_seauence_number, total_volume_history_24h_start_time, total_volume_history_24h_volume, total_volume_history_7d_start_time, total_volume_history_7d_volume, trading_pairs_24h_coin_x, trading_pairs_24h_coin_y, trading_pairs_24h_amount, trading_pairs_7d_coin_x, trading_pairs_7d_coin_y, trading_pairs_7d_amount, pool_provider_24h_dex_type, pool_provider_24h_amount, pool_provider_7d_dex_type, pool_provider_7d_amount, isJSON);
    }
    post_v2(_account, total_volume, last_24_volume, last_7d_volume, data_end_time, data_end_seauence_number, total_volume_history_24h_start_time, total_volume_history_24h_volume, total_volume_history_7d_start_time, total_volume_history_7d_volume, trading_pairs_24h_coin_x, trading_pairs_24h_coin_y, trading_pairs_24h_amount, trading_pairs_7d_coin_x, trading_pairs_7d_coin_y, trading_pairs_7d_amount, pool_provider_24h_dex_type, pool_provider_24h_amount, pool_provider_7d_dex_type, pool_provider_7d_amount, option, _isJSON = false) {
        return __awaiter(this, void 0, void 0, function* () {
            const payload__ = buildPayload_post_v2(total_volume, last_24_volume, last_7d_volume, data_end_time, data_end_seauence_number, total_volume_history_24h_start_time, total_volume_history_24h_volume, total_volume_history_7d_start_time, total_volume_history_7d_volume, trading_pairs_24h_coin_x, trading_pairs_24h_coin_y, trading_pairs_24h_amount, trading_pairs_7d_coin_x, trading_pairs_7d_coin_y, trading_pairs_7d_amount, pool_provider_24h_dex_type, pool_provider_24h_amount, pool_provider_7d_dex_type, pool_provider_7d_amount, _isJSON);
            return $.sendPayloadTx(this.client, _account, payload__, option);
        });
    }
    payload_set_poster(new_poster, isJSON = false) {
        return buildPayload_set_poster(new_poster, isJSON);
    }
    set_poster(_account, new_poster, option, _isJSON = false) {
        return __awaiter(this, void 0, void 0, function* () {
            const payload__ = buildPayload_set_poster(new_poster, _isJSON);
            return $.sendPayloadTx(this.client, _account, payload__, option);
        });
    }
}

var Volume$1 = /*#__PURE__*/Object.freeze({
    __proto__: null,
    packageName: packageName$2,
    moduleAddress: moduleAddress$2,
    moduleName: moduleName$2,
    E_NOT_ADMIN: E_NOT_ADMIN,
    E_NOT_POSTER: E_NOT_POSTER,
    E_REPEAT_POST: E_REPEAT_POST,
    E_VERCTOR_LENGT_NOT_EQUAL: E_VERCTOR_LENGT_NOT_EQUAL,
    VOLUME_HISTORY_LENGTH: VOLUME_HISTORY_LENGTH,
    PoolProvider: PoolProvider,
    TotalVolume: TotalVolume,
    TradingPair: TradingPair,
    Volume: Volume,
    add_volume_: add_volume_,
    clean_: clean_,
    buildPayload_clean: buildPayload_clean,
    fetch_volume_: fetch_volume_,
    buildPayload_fetch_volume: buildPayload_fetch_volume,
    query_fetch_volume: query_fetch_volume,
    get_volume_: get_volume_,
    buildPayload_get_volume: buildPayload_get_volume,
    initialize_: initialize_,
    buildPayload_initialize: buildPayload_initialize,
    parse_pool_provider_vector_: parse_pool_provider_vector_,
    parse_trading_pairs_vector_: parse_trading_pairs_vector_,
    parse_volume_history_vector_: parse_volume_history_vector_,
    post_: post_,
    buildPayload_post: buildPayload_post,
    post_v2_: post_v2_,
    buildPayload_post_v2: buildPayload_post_v2,
    set_poster_: set_poster_,
    buildPayload_set_poster: buildPayload_set_poster,
    loadParsers: loadParsers$5,
    App: App$6
});

function loadParsers$4(repo) {
    loadParsers$7(repo);
    loadParsers$6(repo);
    loadParsers$5(repo);
}
function getPackageRepo$2() {
    const repo = new AptosParserRepo();
    loadParsers$4(repo);
    repo.addDefaultParsers();
    return repo;
}
class App$5 {
    constructor(client, repo, cache) {
        this.client = client;
        this.repo = repo;
        this.cache = cache;
        this.aggregator = new App$8(client, repo, cache);
        this.devnet = new App$7(client, repo, cache);
        this.volume = new App$6(client, repo, cache);
    }
}

var hippo_aggregator = /*#__PURE__*/Object.freeze({
    __proto__: null,
    loadParsers: loadParsers$4,
    getPackageRepo: getPackageRepo$2,
    App: App$5,
    Aggregator: Aggregator,
    Devnet: Devnet,
    Volume: Volume$1
});

const packageName$1 = 'LiquidswapLP';
const moduleAddress$1 = new HexString('0x05a97986a9d031c4567e15b797be516910cfcb4156312482efc6a19c0a30c948');
const moduleName$1 = 'lp_coin';
class LP {
    constructor(proto, typeTag) {
        this.typeTag = typeTag;
        this.__app = null;
    }
    static LPParser(data, typeTag, repo) {
        const proto = $.parseStructProto(data, typeTag, repo, LP);
        return new LP(proto, typeTag);
    }
    static makeTag($p) {
        return new StructTag(moduleAddress$1, moduleName$1, 'LP', $p);
    }
    loadFullState(app) {
        return __awaiter(this, void 0, void 0, function* () {
            this.__app = app;
        });
    }
}
LP.moduleAddress = moduleAddress$1;
LP.moduleName = moduleName$1;
LP.structName = 'LP';
LP.typeParameters = [
    { name: 'X', isPhantom: true },
    { name: 'Y', isPhantom: true },
    { name: 'Curve', isPhantom: true }
];
LP.fields = [];
function loadParsers$3(repo) {
    repo.addParser('0x05a97986a9d031c4567e15b797be516910cfcb4156312482efc6a19c0a30c948::lp_coin::LP', LP.LPParser);
}
class App$4 {
    constructor(client, repo, cache) {
        this.client = client;
        this.repo = repo;
        this.cache = cache;
    }
    get moduleAddress() {
        {
            return moduleAddress$1;
        }
    }
    get moduleName() {
        {
            return moduleName$1;
        }
    }
    get LP() {
        return LP;
    }
}

var Lp_coin = /*#__PURE__*/Object.freeze({
    __proto__: null,
    packageName: packageName$1,
    moduleAddress: moduleAddress$1,
    moduleName: moduleName$1,
    LP: LP,
    loadParsers: loadParsers$3,
    App: App$4
});

function loadParsers$2(repo) {
    loadParsers$3(repo);
}
function getPackageRepo$1() {
    const repo = new AptosParserRepo();
    loadParsers$2(repo);
    repo.addDefaultParsers();
    return repo;
}
class App$3 {
    constructor(client, repo, cache) {
        this.client = client;
        this.repo = repo;
        this.cache = cache;
        this.lp_coin = new App$4(client, repo, cache);
    }
}

var liquidswap_lp = /*#__PURE__*/Object.freeze({
    __proto__: null,
    loadParsers: loadParsers$2,
    getPackageRepo: getPackageRepo$1,
    App: App$3,
    Lp_coin: Lp_coin
});

const packageName = 'UQ64x64';
const moduleAddress = new HexString('0x4e9fce03284c0ce0b86c88dd5a46f050cad2f4f33c4cdd29d98f501868558c81');
const moduleName = 'uq64x64';
const EQUAL = u8('0');
const ERR_DIVIDE_BY_ZERO = u64('100');
const GREATER_THAN = u8('2');
const LESS_THAN = u8('1');
const Q64 = u128('18446744073709551615');
class UQ64x64 {
    constructor(proto, typeTag) {
        this.typeTag = typeTag;
        this.__app = null;
        this.v = proto['v'];
    }
    static UQ64x64Parser(data, typeTag, repo) {
        const proto = $.parseStructProto(data, typeTag, repo, UQ64x64);
        return new UQ64x64(proto, typeTag);
    }
    static getTag() {
        return new StructTag(moduleAddress, moduleName, 'UQ64x64', []);
    }
    loadFullState(app) {
        return __awaiter(this, void 0, void 0, function* () {
            this.__app = app;
        });
    }
}
UQ64x64.moduleAddress = moduleAddress;
UQ64x64.moduleName = moduleName;
UQ64x64.structName = 'UQ64x64';
UQ64x64.typeParameters = [];
UQ64x64.fields = [{ name: 'v', typeTag: AtomicTypeTag.U128 }];
function compare_(left, right, $c) {
    if ($.copy(left.v).eq($.copy(right.v))) {
        return $.copy(EQUAL);
    }
    else {
        if ($.copy(left.v).lt($.copy(right.v))) {
            return $.copy(LESS_THAN);
        }
        else {
            return $.copy(GREATER_THAN);
        }
    }
}
function decode_(uq, $c) {
    return u64($.copy(uq.v).div($.copy(Q64)));
}
function div_(uq, y, $c) {
    let v;
    if (!$.copy(y).neq(u64('0'))) {
        throw $.abortCode($.copy(ERR_DIVIDE_BY_ZERO));
    }
    v = $.copy(uq.v).div(u128($.copy(y)));
    return new UQ64x64({ v: $.copy(v) }, new SimpleStructTag(UQ64x64));
}
function encode_(x, $c) {
    let v;
    v = u128($.copy(x)).mul($.copy(Q64));
    return new UQ64x64({ v: $.copy(v) }, new SimpleStructTag(UQ64x64));
}
function fraction_(numerator, denominator, $c) {
    let r, v;
    if (!$.copy(denominator).neq(u64('0'))) {
        throw $.abortCode($.copy(ERR_DIVIDE_BY_ZERO));
    }
    r = u128($.copy(numerator)).mul($.copy(Q64));
    v = $.copy(r).div(u128($.copy(denominator)));
    return new UQ64x64({ v: $.copy(v) }, new SimpleStructTag(UQ64x64));
}
function is_zero_(uq, $c) {
    return $.copy(uq.v).eq(u128('0'));
}
function mul_(uq, y, $c) {
    let v;
    v = $.copy(uq.v).mul(u128($.copy(y)));
    return new UQ64x64({ v: $.copy(v) }, new SimpleStructTag(UQ64x64));
}
function to_u128_(uq, $c) {
    return $.copy(uq.v);
}
function loadParsers$1(repo) {
    repo.addParser('0x4e9fce03284c0ce0b86c88dd5a46f050cad2f4f33c4cdd29d98f501868558c81::uq64x64::UQ64x64', UQ64x64.UQ64x64Parser);
}
class App$2 {
    constructor(client, repo, cache) {
        this.client = client;
        this.repo = repo;
        this.cache = cache;
    }
    get moduleAddress() {
        {
            return moduleAddress;
        }
    }
    get moduleName() {
        {
            return moduleName;
        }
    }
    get UQ64x64() {
        return UQ64x64;
    }
}

var Uq64x64 = /*#__PURE__*/Object.freeze({
    __proto__: null,
    packageName: packageName,
    moduleAddress: moduleAddress,
    moduleName: moduleName,
    EQUAL: EQUAL,
    ERR_DIVIDE_BY_ZERO: ERR_DIVIDE_BY_ZERO,
    GREATER_THAN: GREATER_THAN,
    LESS_THAN: LESS_THAN,
    Q64: Q64,
    UQ64x64: UQ64x64,
    compare_: compare_,
    decode_: decode_,
    div_: div_,
    encode_: encode_,
    fraction_: fraction_,
    is_zero_: is_zero_,
    mul_: mul_,
    to_u128_: to_u128_,
    loadParsers: loadParsers$1,
    App: App$2
});

function loadParsers(repo) {
    loadParsers$1(repo);
}
function getPackageRepo() {
    const repo = new AptosParserRepo();
    loadParsers(repo);
    repo.addDefaultParsers();
    return repo;
}
class App$1 {
    constructor(client, repo, cache) {
        this.client = client;
        this.repo = repo;
        this.cache = cache;
        this.uq64x64 = new App$2(client, repo, cache);
    }
}

var uq64x64 = /*#__PURE__*/Object.freeze({
    __proto__: null,
    loadParsers: loadParsers,
    getPackageRepo: getPackageRepo,
    App: App$1,
    Uq64x64: Uq64x64
});

function getProjectRepo() {
    const repo = new AptosParserRepo();
    loadParsers$y(repo);
    loadParsers$v(repo);
    loadParsers$s(repo);
    loadParsers$q(repo);
    loadParsers$C(repo);
    loadParsers$i(repo);
    loadParsers$4(repo);
    loadParsers$8(repo);
    loadParsers$2(repo);
    loadParsers$G(repo);
    loadParsers$c(repo);
    loadParsers(repo);
    repo.addDefaultParsers();
    return repo;
}
class App {
    constructor(client) {
        this.client = client;
        this.parserRepo = getProjectRepo();
        this.cache = new AptosLocalCache();
        this.Aptoswap = new App$B(client, this.parserRepo, this.cache);
        this.ResourceAccountDeployer = new App$z(client, this.parserRepo, this.cache);
        this.SwapDeployer = new App$w(client, this.parserRepo, this.cache);
        this.aux = new App$t(client, this.parserRepo, this.cache);
        this.basiq = new App$r(client, this.parserRepo, this.cache);
        this.coin_list = new App$D(client, this.parserRepo, this.cache);
        this.econia = new App$j(client, this.parserRepo, this.cache);
        this.hippo_aggregator = new App$5(client, this.parserRepo, this.cache);
        this.liquidswap = new App$9(client, this.parserRepo, this.cache);
        this.liquidswap_lp = new App$3(client, this.parserRepo, this.cache);
        this.stdlib = new App$H(client, this.parserRepo, this.cache);
        this.u256 = new App$d(client, this.parserRepo, this.cache);
        this.uq64x64 = new App$1(client, this.parserRepo, this.cache);
    }
}

class NetworkConfiguration {
    constructor(name, fullNodeUrl, faucetUrl, coinListAddress, hippoAggregatorAddress, pontemAddress, econiaAddress, basiqAddress, dittoAddress, tortugaAddress, aptoswapAddress, auxAddress, animeAddress, isMainNet = false) {
        this.name = name;
        this.fullNodeUrl = fullNodeUrl;
        this.faucetUrl = faucetUrl;
        this.coinListAddress = coinListAddress;
        this.hippoAggregatorAddress = hippoAggregatorAddress;
        this.pontemAddress = pontemAddress;
        this.econiaAddress = econiaAddress;
        this.basiqAddress = basiqAddress;
        this.dittoAddress = dittoAddress;
        this.tortugaAddress = tortugaAddress;
        this.aptoswapAddress = aptoswapAddress;
        this.auxAddress = auxAddress;
        this.animeAddress = animeAddress;
        this.isMainNet = isMainNet;
    }
}
const LOCAL_CONFIG = new NetworkConfiguration('localhost', 'http://0.0.0.0:8080', 'http://0.0.0.0:8000', 
// coin list
moduleAddress$r, 
// hippo aggregator
moduleAddress$4, 
// pontem
new HexString('0x05a97986a9d031c4567e15b797be516910cfcb4156312482efc6a19c0a30c948'), 
// econia
moduleAddress$d, 
// basiq
moduleAddress$k, 
// ditto
new HexString('0x4d87417a2fb3248887d820f7737d9c4aeeb9591c5de91d08f7f490550e733894'), 
// tortuga
new HexString('0x12d75d5bde2535789041cd380e832038da873a4ba86348ca891d374e1d0e15ab'), 
// aptoswap
moduleAddress$q, 
// aux
moduleAddress$l, 
// anime
new HexString('0x796900ebe1a1a54ff9e932f19c548f5c1af5c6e7d34965857ac2f7b1d1ab2cbf'));
const TESTNET_CONFIG = new NetworkConfiguration('testnet', 'https://fullnode.testnet.aptoslabs.com/v1', 'https://faucet.testnet.aptoslabs.com', 
// coin list
moduleAddress$r, 
// hippo aggregator
moduleAddress$4, 
// pontem
new HexString('0x05a97986a9d031c4567e15b797be516910cfcb4156312482efc6a19c0a30c948'), 
// econia
moduleAddress$d, 
// basiq
moduleAddress$k, 
// ditto
new HexString('0x4d87417a2fb3248887d820f7737d9c4aeeb9591c5de91d08f7f490550e733894'), 
// tortuga
new HexString('0x12d75d5bde2535789041cd380e832038da873a4ba86348ca891d374e1d0e15ab'), 
// aptoswap
moduleAddress$q, 
// aux
moduleAddress$l, 
// anime
new HexString('0x796900ebe1a1a54ff9e932f19c548f5c1af5c6e7d34965857ac2f7b1d1ab2cbf'));
const MAINNET_CONFIG = new NetworkConfiguration('mainnet', 'https://fullnode.mainnet.aptoslabs.com/v1', '', 
// coin list
moduleAddress$r, 
// hippo aggregator
moduleAddress$4, 
// pontem
new HexString('0x05a97986a9d031c4567e15b797be516910cfcb4156312482efc6a19c0a30c948'), 
// econia
moduleAddress$d, 
// basiq
new HexString('0x4885b08864b81ca42b19c38fff2eb958b5e312b1ec366014d4afff2775c19aab'), 
// ditto
new HexString('0x4d87417a2fb3248887d820f7737d9c4aeeb9591c5de91d08f7f490550e733894'), 
// tortuga
new HexString('0x12d75d5bde2535789041cd380e832038da873a4ba86348ca891d374e1d0e15ab'), 
// aptoswap
moduleAddress$q, 
// aux
moduleAddress$l, 
// anime
new HexString('0x796900ebe1a1a54ff9e932f19c548f5c1af5c6e7d34965857ac2f7b1d1ab2cbf'));
const CONFIGS = {
    localhost: LOCAL_CONFIG,
    testnet: TESTNET_CONFIG,
    mainnet: MAINNET_CONFIG
};

function typeInfoToTypeTag(typeInfo) {
    const fullname = `${typeInfo.account_address.hex()}::${u8str(typeInfo.module_name)}::${u8str(typeInfo.struct_name)}`;
    return parseTypeTagOrThrow(fullname);
}
function typeTagToTypeInfo(tag) {
    return new TypeInfo({
        account_address: tag.address,
        module_name: strToU8(tag.module),
        struct_name: strToU8(tag.name)
    }, new StructTag(moduleAddress$1q, moduleName$1q, TypeInfo.structName, []));
}
function getCoinStoresForAddress(client, address, repo, version = undefined) {
    return __awaiter(this, void 0, void 0, function* () {
        const stores = [];
        let walletResources;
        try {
            walletResources = yield client.getAccountResources(address, version ? { ledgerVersion: version } : {});
        }
        catch (e) {
            if (e.status == 404 && e.errorCode === 'account_not_found') {
                return stores;
            }
            else {
                throw e;
            }
        }
        for (const resource of walletResources) {
            try {
                const typeTag = parseMoveStructTag(resource.type);
                // we only looking for 0x1::Coin::CoinStore
                if (typeTag.address.hex() !== moduleAddress$1a.hex() ||
                    typeTag.module !== moduleName$1a ||
                    typeTag.name !== CoinStore$1.structName) {
                    continue;
                }
                const store = repo.parse(resource.data, typeTag);
                stores.push(store);
            }
            catch (e) { }
        }
        return stores;
    });
}
function queryFetchFullList(app, owner, expireTimestampSecFromNow = 3 * 60) {
    return __awaiter(this, void 0, void 0, function* () {
        return app.coin_list.coin_list.query_fetch_full_list(owner, [], {
            expireTimestamp: Math.floor(Date.now() / 1000) + expireTimestampSecFromNow
        });
    });
}

class HippoWalletClient {
    constructor(netConf, app, walletAddress, coinStores) {
        this.netConf = netConf;
        this.app = app;
        this.walletAddress = walletAddress;
        this.coinStores = coinStores;
        this.symbolToCoinStore = {};
        this.fullnameToCoinStore = {};
        this.fullnameToTokenInfo = {};
        this.symbolToTokenInfo = {};
        this.devnetCoinSymbols = [];
    }
    buildCache() {
        return __awaiter(this, void 0, void 0, function* () {
            this.symbolToCoinStore = {};
            this.fullnameToCoinStore = {};
            this.fullnameToTokenInfo = {};
            this.symbolToTokenInfo = {};
            this.devnetCoinSymbols = [];
            const fullList = yield queryFetchFullList(this.app, this.netConf.coinListAddress);
            for (const tokenInfo of fullList.coin_info_list) {
                const typeTag = typeInfoToTypeTag(tokenInfo.token_type);
                const fullname = getTypeTagFullname(typeTag);
                this.fullnameToTokenInfo[fullname] = tokenInfo;
                this.symbolToTokenInfo[tokenInfo.symbol.str()] = tokenInfo;
                if (!(typeTag instanceof StructTag)) {
                    throw new Error();
                }
                if (typeTag.module === this.app.coin_list.devnet_coins.moduleName) {
                    this.devnetCoinSymbols.push(tokenInfo.symbol.str());
                }
            }
            for (const store of this.coinStores) {
                if (!(store.typeTag instanceof StructTag)) {
                    throw new Error();
                }
                const typeTag = store.typeTag.typeParams[0];
                if (!typeTag) {
                    throw new Error();
                }
                const fullname = getTypeTagFullname(typeTag);
                this.fullnameToCoinStore[fullname] = store;
                const tokenInfo = this.fullnameToTokenInfo[fullname];
                if (!tokenInfo) {
                    // token not part of our registry
                    continue;
                }
                this.symbolToCoinStore[tokenInfo.symbol.str()] = store;
            }
        });
    }
    refreshStores(version = undefined) {
        return __awaiter(this, void 0, void 0, function* () {
            this.coinStores = yield getCoinStoresForAddress(this.app.client, this.walletAddress, this.app.parserRepo, version);
            yield this.buildCache();
        });
    }
    static createInTwoCalls(netConf, app, walletAddress, version = undefined) {
        return __awaiter(this, void 0, void 0, function* () {
            const stores = yield getCoinStoresForAddress(app.client, walletAddress, app.parserRepo, version);
            const client = new HippoWalletClient(netConf, app, walletAddress, stores);
            yield client.buildCache();
            return client;
        });
    }
    makeFaucetMintToPayload(uiAmount, symbol, isJSONPayload = false) {
        if (!this.devnetCoinSymbols.includes(symbol)) {
            throw new Error(`${symbol} is not a MockCoin and we are unable to mint it.`);
        }
        const tokenInfo = this.symbolToTokenInfo[symbol];
        if (!tokenInfo) {
            throw new Error(`Cannot find TokenInfo for ${symbol}`);
        }
        const rawAmount = u64(Math.floor(uiAmount * Math.pow(10, tokenInfo.decimals.toJsNumber())));
        const tokenTypeTag = typeInfoToTypeTag(tokenInfo.token_type);
        return this.app.coin_list.devnet_coins.payload_mint_to_wallet(rawAmount, [tokenTypeTag], isJSONPayload);
    }
    debugPrint() {
        for (const symbol in this.symbolToCoinStore) {
            const store = this.symbolToCoinStore[symbol];
            const tokenInfo = this.symbolToTokenInfo[symbol];
            console.log(`${tokenInfo.symbol.str()}: ${store.coin.value.toJsNumber() / Math.pow(10, tokenInfo.decimals.toJsNumber())}`);
        }
    }
}

class CoinListClient {
    constructor(app) {
        this.app = app;
        this.fullnameToCoinInfo = {};
        this.symbolToCoinInfo = {};
        this.coinList = [];
    }
    hasTokenType(tokenType) {
        return tokenType.typeFullname() in this.fullnameToCoinInfo;
    }
    getCoinInfoList() {
        return this.coinList;
    }
    getCoinInfoBySymbol(symbol) {
        return this.symbolToCoinInfo[symbol];
    }
    getCoinInfoByType(tokenType) {
        return this.fullnameToCoinInfo[tokenType.typeFullname()];
    }
    static load(app) {
        return __awaiter(this, void 0, void 0, function* () {
            const coinRegistry = new CoinListClient(app);
            yield coinRegistry.buildCache();
            return coinRegistry;
        });
    }
    buildCache() {
        return __awaiter(this, void 0, void 0, function* () {
            const fullList = yield queryFetchFullList(this.app, CoinInfo.moduleAddress);
            this.coinList = fullList.coin_info_list;
            for (const tokenInfo of fullList.coin_info_list) {
                const fullname = tokenInfo.token_type.typeFullname();
                this.fullnameToCoinInfo[fullname] = tokenInfo;
                this.symbolToCoinInfo[tokenInfo.symbol.str()] = tokenInfo;
            }
        });
    }
}

class EconiaClient {
    constructor(aptosClient, repo, registryOwner) {
        this.aptosClient = aptosClient;
        this.repo = repo;
        this.registryOwner = registryOwner;
    }
    getMarkets() {
        return __awaiter(this, void 0, void 0, function* () {
            const registry = yield Registry.load(this.repo, this.aptosClient, this.registryOwner, []);
            return registry.markets;
        });
    }
}

var DexType;
(function (DexType) {
    // eslint-disable-next-line no-unused-vars
    DexType[DexType["Hippo"] = 1] = "Hippo";
    // eslint-disable-next-line no-unused-vars
    DexType[DexType["Econia"] = 2] = "Econia";
    // eslint-disable-next-line no-unused-vars
    DexType[DexType["Pontem"] = 3] = "Pontem";
    // eslint-disable-next-line no-unused-vars
    DexType[DexType["Basiq"] = 4] = "Basiq";
    // eslint-disable-next-line no-unused-vars
    DexType[DexType["Ditto"] = 5] = "Ditto";
    // eslint-disable-next-line no-unused-vars
    DexType[DexType["Tortuga"] = 6] = "Tortuga";
    // eslint-disable-next-line no-unused-vars
    DexType[DexType["Aptoswap"] = 7] = "Aptoswap";
    // eslint-disable-next-line no-unused-vars
    DexType[DexType["Aux"] = 8] = "Aux";
    // eslint-disable-next-line no-unused-vars
    DexType[DexType["AnimeSwap"] = 9] = "AnimeSwap";
})(DexType || (DexType = {}));
const DEX_TYPE_NAME = {
    [DexType.Hippo]: 'Hippo',
    [DexType.Econia]: 'Econia',
    [DexType.Pontem]: 'Pontem',
    [DexType.Basiq]: 'Basiq',
    [DexType.Ditto]: 'Ditto',
    [DexType.Tortuga]: 'Tortuga',
    [DexType.Aptoswap]: 'AptoSwap',
    [DexType.Aux]: 'Aux',
    [DexType.AnimeSwap]: 'AnimeSwap'
};
// An AMM pool or ohchain orderbook that supports trading directly between X and Y
class TradingPool {
    get xTag() {
        return this.xCoinInfo.token_type.toTypeTag();
    }
    get yTag() {
        return this.yCoinInfo.token_type.toTypeTag();
    }
    getTagE() {
        return AtomicTypeTag.U8;
    }
}
// a single trade step involving a Pool and a direction (X-to-Y or Y-to-X)
class TradeStep {
    constructor(pool, isXtoY) {
        this.pool = pool;
        this.isXtoY = isXtoY;
    }
    get xCoinInfo() {
        return this.isXtoY ? this.pool.xCoinInfo : this.pool.yCoinInfo;
    }
    get yCoinInfo() {
        return this.isXtoY ? this.pool.yCoinInfo : this.pool.xCoinInfo;
    }
    get xTag() {
        return this.xCoinInfo.token_type.toTypeTag();
    }
    get yTag() {
        return this.yCoinInfo.token_type.toTypeTag();
    }
    getPrice() {
        const price = this.pool.getPrice();
        if (this.isXtoY) {
            return price;
        }
        else {
            return {
                xToY: price.yToX,
                yToX: price.xToY
            };
        }
    }
    getQuote(inputUiAmt) {
        return this.pool.getQuote(inputUiAmt, this.isXtoY);
    }
    getTagE() {
        return this.pool.getTagE();
    }
}
class TradeRoute {
    constructor(steps) {
        this.steps = steps;
        // at least 1 step
        if (steps.length < 1) {
            throw new Error('A TradeRoute requires at least one TradeStep');
        }
        this.tokens = [];
        // steps have matching ends
        let tokFullname = steps[0].xCoinInfo.token_type.typeFullname();
        this.tokens.push(steps[0].xCoinInfo);
        for (const step of steps) {
            const xFullname = step.xCoinInfo.token_type.typeFullname();
            const yFullname = step.yCoinInfo.token_type.typeFullname();
            // make sure LHS matches tokFullname
            if (xFullname !== tokFullname) {
                throw new Error(`Mismatching tokens in route. Expected ${tokFullname} but received ${xFullname}`);
            }
            tokFullname = yFullname;
            this.tokens.push(step.yCoinInfo);
        }
    }
    get xCoinInfo() {
        return this.steps[0].xCoinInfo;
    }
    get yCoinInfo() {
        return this.steps[this.steps.length - 1].yCoinInfo;
    }
    get xTag() {
        return this.xCoinInfo.token_type.toTypeTag();
    }
    get yTag() {
        return this.yCoinInfo.token_type.toTypeTag();
    }
    getPrice() {
        let xToY = 1;
        let yToX = 1;
        for (const step of this.steps) {
            const price = step.pool.getPrice();
            xToY *= price.xToY;
            yToX *= price.yToX;
        }
        return { xToY, yToX };
    }
    getQuote(inputUiAmt) {
        let outputUiAmt = inputUiAmt;
        for (const step of this.steps) {
            outputUiAmt = step.getQuote(outputUiAmt).outputUiAmt;
        }
        return {
            inputSymbol: this.xCoinInfo.symbol.str(),
            outputSymbol: this.yCoinInfo.symbol.str(),
            inputUiAmt,
            outputUiAmt,
            avgPrice: outputUiAmt / inputUiAmt
        };
    }
    hasRoundTrip() {
        // whether something like A -> B -> A or A -> B -> C -> B happens
        const fullnameSet = new Set(this.tokens.map((ti) => ti.token_type.typeFullname()));
        return fullnameSet.size < this.tokens.length;
    }
    getSwapParams(inputUiAmt, minOutAmt) {
        const inputSize = Math.floor(inputUiAmt * Math.pow(10, this.xCoinInfo.decimals.toJsNumber()));
        const minOutputSize = Math.floor(minOutAmt * Math.pow(10, this.yCoinInfo.decimals.toJsNumber()));
        const dummyTag = String.getTag();
        if (this.steps.length === 1) {
            const step0 = this.steps[0];
            return {
                numSteps: u8(1),
                // first
                firstDexType: u8(step0.pool.dexType),
                firstPoolType: step0.pool.poolType,
                firstIsReversed: step0.isXtoY,
                // second
                secondDexType: u8(0),
                secondPoolType: u64(0),
                secondIsReversed: false,
                // third
                thirdDexType: u8(0),
                thirdPoolType: u64(0),
                thirdIsReversed: false,
                // sizes
                inAmt: u64(inputSize),
                minOutAmt: u64(minOutputSize),
                types: [
                    this.xCoinInfo.token_type.toTypeTag(),
                    dummyTag,
                    dummyTag,
                    this.yCoinInfo.token_type.toTypeTag(),
                    step0.getTagE(),
                    dummyTag,
                    dummyTag // E3
                ]
            };
        }
        else if (this.steps.length === 2) {
            const step0 = this.steps[0];
            const step1 = this.steps[1];
            return {
                numSteps: u8(2),
                // first
                firstDexType: u8(step0.pool.dexType),
                firstPoolType: step0.pool.poolType,
                firstIsReversed: step0.isXtoY,
                // second
                secondDexType: u8(step1.pool.dexType),
                secondPoolType: step1.pool.poolType,
                secondIsReversed: step1.isXtoY,
                // third
                thirdDexType: u8(0),
                thirdPoolType: u64(0),
                thirdIsReversed: false,
                // sizes
                inAmt: u64(inputSize),
                minOutAmt: u64(minOutputSize),
                types: [
                    this.tokens[0].token_type.toTypeTag(),
                    this.tokens[1].token_type.toTypeTag(),
                    dummyTag,
                    this.tokens[2].token_type.toTypeTag(),
                    step0.getTagE(),
                    step1.getTagE(),
                    dummyTag // E3
                ]
            };
        }
        else if (this.steps.length === 3) {
            const step0 = this.steps[0];
            const step1 = this.steps[1];
            const step2 = this.steps[2];
            return {
                numSteps: u8(3),
                // first
                firstDexType: u8(step0.pool.dexType),
                firstPoolType: step0.pool.poolType,
                firstIsReversed: step0.isXtoY,
                // second
                secondDexType: u8(step1.pool.dexType),
                secondPoolType: step1.pool.poolType,
                secondIsReversed: step1.isXtoY,
                // third
                thirdDexType: u8(step2.pool.dexType),
                thirdPoolType: step2.pool.poolType,
                thirdIsReversed: step2.isXtoY,
                // sizes
                inAmt: u64(inputSize),
                minOutAmt: u64(minOutputSize),
                types: [
                    this.tokens[0].token_type.toTypeTag(),
                    this.tokens[1].token_type.toTypeTag(),
                    this.tokens[2].token_type.toTypeTag(),
                    this.tokens[3].token_type.toTypeTag(),
                    step0.getTagE(),
                    step1.getTagE(),
                    step2.getTagE() // E3
                ]
            };
        }
        else {
            throw new Error('Unreachable');
        }
    }
    makeSwapPayload(inputUiAmt, minOutAmt, isJSONPayload = false) {
        const params = this.getSwapParams(inputUiAmt, minOutAmt);
        return buildPayload_swap(params.numSteps, 
        // first
        params.firstDexType, params.firstPoolType, params.firstIsReversed, 
        // second
        params.secondDexType, params.secondPoolType, params.secondIsReversed, 
        // third
        params.thirdDexType, params.thirdPoolType, params.thirdIsReversed, 
        // sizes
        params.inAmt, params.minOutAmt, params.types, isJSONPayload);
    }
    makePayload(inputUiAmt, minOutAmt, isJSONPayload = false) {
        const inputSize = Math.floor(inputUiAmt * Math.pow(10, this.xCoinInfo.decimals.toJsNumber()));
        const minOutputSize = Math.floor(minOutAmt * Math.pow(10, this.yCoinInfo.decimals.toJsNumber()));
        if (this.steps.length === 1) {
            const step0 = this.steps[0];
            return buildPayload_one_step_route(u8(step0.pool.dexType), step0.pool.poolType, step0.isXtoY, u64(inputSize), u64(minOutputSize), [this.xCoinInfo.token_type.toTypeTag(), this.yCoinInfo.token_type.toTypeTag(), step0.getTagE()], // X, Y, E
            isJSONPayload);
        }
        else if (this.steps.length === 2) {
            const step0 = this.steps[0];
            const step1 = this.steps[1];
            return buildPayload_two_step_route(u8(step0.pool.dexType), step0.pool.poolType, step0.isXtoY, u8(step1.pool.dexType), step1.pool.poolType, step1.isXtoY, u64(inputSize), u64(minOutputSize), [
                this.tokens[0].token_type.toTypeTag(),
                this.tokens[1].token_type.toTypeTag(),
                this.tokens[2].token_type.toTypeTag(),
                step0.getTagE(),
                step1.getTagE()
            ], // X, Y, Z, E1, E2
            isJSONPayload);
        }
        else if (this.steps.length === 3) {
            const step0 = this.steps[0];
            const step1 = this.steps[1];
            const step2 = this.steps[2];
            return buildPayload_three_step_route(u8(step0.pool.dexType), step0.pool.poolType, step0.isXtoY, u8(step1.pool.dexType), step1.pool.poolType, step1.isXtoY, u8(step2.pool.dexType), step2.pool.poolType, step2.isXtoY, u64(inputSize), u64(minOutputSize), [
                this.tokens[0].token_type.toTypeTag(),
                this.tokens[1].token_type.toTypeTag(),
                this.tokens[2].token_type.toTypeTag(),
                this.tokens[3].token_type.toTypeTag(),
                step0.getTagE(),
                step1.getTagE(),
                step2.getTagE()
            ], // X, Y, Z, M, E1, E2, E3
            isJSONPayload);
        }
        else {
            throw new Error('Unreachable');
        }
    }
    debugPrint() {
        const lastSymbol = this.steps[this.steps.length - 1].yCoinInfo.symbol.str();
        console.log(`Route: ${this.steps.map((step) => step.xCoinInfo.symbol.str()).join(' -> ')} -> ${lastSymbol}`);
        this.steps.forEach((step, i) => {
            console.log(`Step ${i}: ${step.xCoinInfo.symbol.str()} -> ${step.yCoinInfo.symbol.str()} (via ${DEX_TYPE_NAME[step.pool.dexType]})`);
        });
    }
}
// Each DEX is a TradeStepProvider
class TradingPoolProvider {
    constructor(app, netConfig = CONFIGS.testnet, registry) {
        this.app = app;
        this.netConfig = netConfig;
        this.registry = registry;
    }
    reloadAllPoolState() {
        return __awaiter(this, void 0, void 0, function* () {
            const pools = yield this.loadPoolList();
            const promises = pools.map((pool) => pool.reloadState(this.app));
            yield Promise.all(promises);
        });
    }
}

var types = /*#__PURE__*/Object.freeze({
    __proto__: null,
    get DexType () { return DexType; },
    DEX_TYPE_NAME: DEX_TYPE_NAME,
    TradingPool: TradingPool,
    TradeStep: TradeStep,
    TradeRoute: TradeRoute,
    TradingPoolProvider: TradingPoolProvider
});

var EconiaPoolType;
(function (EconiaPoolType) {
    // eslint-disable-next-line no-unused-vars
    EconiaPoolType[EconiaPoolType["V3"] = 3] = "V3";
})(EconiaPoolType || (EconiaPoolType = {}));
class EconiaTradingPoolV1 extends TradingPool {
    constructor(xInfo, yInfo, orderBook, mi, owner, repo, marketId) {
        super();
        this.xInfo = xInfo;
        this.yInfo = yInfo;
        this.orderBook = orderBook;
        this.mi = mi;
        this.owner = owner;
        this.repo = repo;
        this.marketId = marketId;
    }
    get dexType() {
        return DexType.Econia;
    }
    get poolType() {
        return this.marketId;
    }
    get isRoutable() {
        return true;
    }
    // X-Y
    get xCoinInfo() {
        return this.xInfo;
    }
    get yCoinInfo() {
        return this.yInfo;
    }
    get xTag() {
        return this.xCoinInfo.token_type.toTypeTag();
    }
    get yTag() {
        return this.yCoinInfo.token_type.toTypeTag();
    }
    // functions that depend on pool's onchain state
    isStateLoaded() {
        return !!this.orderBook;
    }
    reloadState(app) {
        return __awaiter(this, void 0, void 0, function* () {
            const orderBooks = yield OrderBooks.load(this.repo, app.client, this.owner, []);
            const rawOrderBook = yield app.client.getTableItem(orderBooks.map.base_table.handle.toString(), {
                key_type: getTypeTagFullname(AtomicTypeTag.U64),
                value_type: OrderBook.getTag().getFullname(),
                key: moveValueToOpenApiObject(this.marketId, AtomicTypeTag.U64)
            });
            this.orderBook = OrderBook.OrderBookParser(rawOrderBook, OrderBook.getTag(), this.repo);
        });
    }
    getUiPrice(rawPrice) {
        if (!this.orderBook) {
            throw new Error('Econia Orderbook not loaded. cannot compute price');
        }
        const xFactor = Math.pow(10, this.xCoinInfo.decimals.toJsNumber());
        const yFactor = Math.pow(10, this.yCoinInfo.decimals.toJsNumber());
        // const scaleFactor = this.orderBook.scale_factor.toJsNumber();
        const lotSize = this.orderBook.lot_size.toJsNumber();
        const tickSize = this.orderBook.tick_size.toJsNumber();
        // yToX price
        return rawPrice.toJsNumber() * (xFactor / yFactor) * (tickSize / lotSize);
    }
    getPrice() {
        if (!this.orderBook) {
            throw new Error('Econia Orderbook not loaded. cannot compute price');
        }
        // use top-of-book price
        let xToY = 0;
        let yToX = 0;
        const orderVectors = this.orderBook.orders_vectors();
        const [asks, bids] = orderVectors;
        if (asks.length > 0) {
            // y to x is buying, hits asks
            yToX = this.getUiPrice(asks[0].price);
        }
        if (bids.length > 0) {
            // x to y is selling, hits bids
            xToY = 1 / this.getUiPrice(bids[0].price);
        }
        return {
            xToY,
            yToX
        };
    }
    getQuote(inputUiAmt, isXtoY) {
        if (!this.orderBook) {
            throw new Error('Econia Orderbook not loaded. cannot compute quote');
        }
        const [asks, bids] = this.orderBook.orders_vectors();
        if (isXtoY) {
            // selling
            let soldBaseSize = u64(0);
            let remainingBaseSize = u64(Math.floor(inputUiAmt * Math.pow(10, this.xCoinInfo.decimals.toJsNumber())));
            let gotQuoteSize = u64(0);
            for (const bid of bids) {
                if (remainingBaseSize.eq(u64(0))) {
                    break;
                }
                const bidBaseSize = bid.size.mul(this.orderBook.lot_size);
                const fillBaseSize = remainingBaseSize.gt(bidBaseSize) ? bidBaseSize : remainingBaseSize;
                if (fillBaseSize.gt(u64(0))) {
                    soldBaseSize = soldBaseSize.add(fillBaseSize);
                    remainingBaseSize = remainingBaseSize.sub(fillBaseSize);
                    gotQuoteSize = gotQuoteSize.add(fillBaseSize.div(this.orderBook.lot_size).mul(bid.price).mul(this.orderBook.tick_size));
                }
            }
            // has partial unfilled
            const actualInputUiAmt = soldBaseSize.toJsNumber() / Math.pow(10, this.xCoinInfo.decimals.toJsNumber());
            const outputUiAmt = gotQuoteSize.toJsNumber() / Math.pow(10, this.yCoinInfo.decimals.toJsNumber());
            return {
                inputSymbol: this.xCoinInfo.symbol.str(),
                outputSymbol: this.yCoinInfo.symbol.str(),
                inputUiAmt: actualInputUiAmt,
                outputUiAmt,
                avgPrice: outputUiAmt / actualInputUiAmt
            };
        }
        else {
            // buying
            let gotBaseSize = u64(0);
            let soldQuoteSize = u64(0);
            let remainingQuoteSize = u64(Math.floor(inputUiAmt * Math.pow(10, this.yCoinInfo.decimals.toJsNumber())));
            for (const ask of asks) {
                if (remainingQuoteSize.eq(u64(0))) {
                    break;
                }
                const askQuoteSize = ask.size.mul(ask.price).mul(this.orderBook.tick_size);
                const fillQuoteSize = remainingQuoteSize.gt(askQuoteSize) ? askQuoteSize : remainingQuoteSize;
                if (fillQuoteSize.gt(u64(0))) {
                    soldQuoteSize = soldQuoteSize.add(fillQuoteSize);
                    remainingQuoteSize = remainingQuoteSize.sub(fillQuoteSize);
                    gotBaseSize = gotBaseSize.add(fillQuoteSize.div(this.orderBook.tick_size).div(ask.price).mul(this.orderBook.lot_size));
                }
            }
            const actualInputUiAmt = soldQuoteSize.toJsNumber() / Math.pow(10, this.yCoinInfo.decimals.toJsNumber());
            const outputUiAmt = gotBaseSize.toJsNumber() / Math.pow(10, this.xCoinInfo.decimals.toJsNumber());
            return {
                inputSymbol: this.yCoinInfo.symbol.str(),
                outputSymbol: this.xCoinInfo.symbol.str(),
                inputUiAmt: actualInputUiAmt,
                outputUiAmt,
                avgPrice: outputUiAmt / actualInputUiAmt
            };
        }
    }
    // build payload directly if not routable
    makePayload(inputUiAmt, minOutAmt) {
        // routable, so no need to implement
        throw new Error('Not Implemented');
    }
}
class EconiaPoolProvider extends TradingPoolProvider {
    loadPoolList() {
        return __awaiter(this, void 0, void 0, function* () {
            const econiaClient = new EconiaClient(this.app.client, this.app.parserRepo, moduleAddress$f);
            const markets = yield econiaClient.getMarkets();
            const pools = [];
            const promises = [];
            markets.forEach((mi, marketId) => {
                if (this.registry.hasTokenType(mi.trading_pair_info.base_type_info) &&
                    this.registry.hasTokenType(mi.trading_pair_info.quote_type_info) &&
                    // host is devnet contract
                    mi.host.hex() === this.netConfig.hippoAggregatorAddress.hex()) {
                    pools.push(new EconiaTradingPoolV1(this.registry.getCoinInfoByType(mi.trading_pair_info.base_type_info), this.registry.getCoinInfoByType(mi.trading_pair_info.quote_type_info), null, mi, mi.host, this.app.parserRepo, new U64(marketId)));
                }
            });
            yield Promise.all(promises);
            return pools;
        });
    }
}

class PontemTradingPool extends TradingPool {
    constructor(ownerAddress, _xCoinInfo, _yCoinInfo, curvesTag, poolResourceTag) {
        super();
        this.ownerAddress = ownerAddress;
        this._xCoinInfo = _xCoinInfo;
        this._yCoinInfo = _yCoinInfo;
        this.curvesTag = curvesTag;
        this.poolResourceTag = poolResourceTag;
        this.pontemPool = null;
    }
    get dexType() {
        return DexType.Pontem;
    }
    get poolType() {
        return u64(0);
    } // ignored
    get isRoutable() {
        return true;
    }
    // X-Y
    get xCoinInfo() {
        return this._xCoinInfo;
    }
    get yCoinInfo() {
        return this._yCoinInfo;
    }
    // state-dependent
    isStateLoaded() {
        return this.pontemPool != undefined;
    }
    reloadState(app) {
        return __awaiter(this, void 0, void 0, function* () {
            this.pontemPool = yield app.liquidswap.liquidity_pool.loadLiquidityPool(this.ownerAddress, [
                this.xCoinInfo.token_type.toTypeTag(),
                this.yCoinInfo.token_type.toTypeTag(),
                // todo may err
                this.getCurves()
            ]);
        });
    }
    getPrice() {
        if (!this.isStateLoaded()) {
            throw new Error('Pontem pool not loaded. cannot compute price');
        }
        throw new Error('Not Implemented');
    }
    getQuote(inputUiAmt, isXtoY) {
        var _a, _b, _c;
        if (!this.isStateLoaded()) {
            throw new Error('Pontem pool not loaded. cannot compute quote');
        }
        const inputTokenInfo = isXtoY ? this.xCoinInfo : this.yCoinInfo;
        const outputTokenInfo = isXtoY ? this.yCoinInfo : this.xCoinInfo;
        const pool = this.pontemPool;
        const cache = (_a = pool.__app) === null || _a === void 0 ? void 0 : _a.cache;
        cache.move_to(pool.typeTag, this.ownerAddress, pool, true);
        const outAmount = get_amount_out_(u64(Math.floor(inputUiAmt * Math.pow(10, inputTokenInfo.decimals.toJsNumber()))), (_c = (_b = this.pontemPool) === null || _b === void 0 ? void 0 : _b.__app) === null || _c === void 0 ? void 0 : _c.cache, [
            inputTokenInfo.token_type.toTypeTag(),
            outputTokenInfo.token_type.toTypeTag(),
            // todo may err
            this.getCurves()
        ]);
        const outputUiAmt = outAmount.toJsNumber() / Math.pow(10, outputTokenInfo.decimals.toJsNumber());
        return {
            inputSymbol: inputTokenInfo.symbol.str(),
            outputSymbol: outputTokenInfo.symbol.str(),
            inputUiAmt,
            outputUiAmt,
            avgPrice: outputUiAmt / inputUiAmt
        };
    }
    getTagE() {
        return this.curvesTag;
    }
    // build payload directly if not routable
    makePayload(inputUiAmt, minOutAmt) {
        throw new Error('Not Implemented');
    }
    getCurves() {
        return this.curvesTag;
    }
}

class PontemPoolProvider extends TradingPoolProvider {
    loadPoolList() {
        return __awaiter(this, void 0, void 0, function* () {
            const poolList = [];
            const ownerAddress = this.netConfig.pontemAddress;
            const resources = yield this.app.client.getAccountResources(ownerAddress);
            for (const resource of resources) {
                if (resource.type.indexOf('liquidity_pool::LiquidityPool') >= 0) {
                    const tag = parseMoveStructTag(resource.type);
                    const xTag = tag.typeParams[0];
                    const yTag = tag.typeParams[1];
                    const curvesTag = tag.typeParams[2];
                    const xCoinInfo = this.registry.getCoinInfoByType(typeTagToTypeInfo(xTag));
                    const yCoinInfo = this.registry.getCoinInfoByType(typeTagToTypeInfo(yTag));
                    if (!xCoinInfo || !yCoinInfo) {
                        continue;
                    }
                    // temporarily disable pontem stable routes due to out-of-gas
                    if (curvesTag.getFullname().indexOf('Stable') > 0) {
                        continue;
                    }
                    const pool = new PontemTradingPool(ownerAddress, xCoinInfo, yCoinInfo, curvesTag, tag);
                    poolList.push(pool);
                }
            }
            return poolList;
        });
    }
}

class AnimeTradingPool extends TradingPool {
    constructor(ownerAddr, tag, xCoinInfo, yCoinInfo) {
        super();
        this.ownerAddr = ownerAddr;
        this.tag = tag;
        this._xCoinInfo = xCoinInfo;
        this._yCoinInfo = yCoinInfo;
        this.pool = null;
    }
    get dexType() {
        return DexType.AnimeSwap;
    }
    get poolType() {
        return u64(0);
    } // ignored
    get isRoutable() {
        return true;
    }
    get xCoinInfo() {
        return this._xCoinInfo;
    }
    get yCoinInfo() {
        return this._yCoinInfo;
    }
    // state-dependent
    isStateLoaded() {
        return !!this.pool;
    }
    reloadState(app) {
        return __awaiter(this, void 0, void 0, function* () {
            // eslint-disable-next-line max-len
            this.pool = yield app.SwapDeployer.AnimeSwapPoolV1.LiquidityPool.load(app.parserRepo, app.client, this.ownerAddr, this.tag.typeParams);
        });
    }
    getPrice() {
        throw new Error('Not Implemented');
    }
    getQuote(inputUiAmt, isXtoY) {
        if (!this.pool) {
            throw new Error(`Anime Pool not loaded, unable to quote`);
        }
        const inputTokenInfo = isXtoY ? this.xCoinInfo : this.yCoinInfo;
        const outputTokenInfo = isXtoY ? this.yCoinInfo : this.xCoinInfo;
        const inputReserve = isXtoY ? this.pool.coin_x_reserve.value : this.pool.coin_y_reserve.value;
        const outputReserve = !isXtoY ? this.pool.coin_x_reserve.value : this.pool.coin_y_reserve.value;
        const coinInAmt = BigInt(Math.floor(inputUiAmt * Math.pow(10, inputTokenInfo.decimals.toJsNumber())));
        const coinOutAmt = get_amount_out_$2(u64(coinInAmt.toString()), inputReserve, outputReserve, u64(30));
        // eslint-disable-next-line max-len
        const outputUiAmt = bigInt(coinOutAmt.toBigInt()).toJSNumber() / Math.pow(10, outputTokenInfo.decimals.toJsNumber());
        return {
            inputSymbol: inputTokenInfo.symbol.str(),
            outputSymbol: outputTokenInfo.symbol.str(),
            inputUiAmt: inputUiAmt,
            outputUiAmt: outputUiAmt,
            avgPrice: outputUiAmt / inputUiAmt
        };
    }
    // build payload directly if not routable
    makePayload(inputUiAmt, minOutAmt) {
        throw new Error('Not Implemented');
    }
}

class AnimePoolProvider extends TradingPoolProvider {
    loadPoolList() {
        return __awaiter(this, void 0, void 0, function* () {
            const poolList = [];
            const ownerAddr = this.netConfig.animeAddress;
            const resources = yield this.app.client.getAccountResources(ownerAddr);
            for (const resource of resources) {
                if (resource.type.indexOf('AnimeSwapPoolV1::LiquidityPool') >= 0) {
                    const tag = parseMoveStructTag(resource.type);
                    const xTag = tag.typeParams[0];
                    const yTag = tag.typeParams[1];
                    const xCoinInfo = this.registry.getCoinInfoByType(typeTagToTypeInfo(xTag));
                    const yCoinInfo = this.registry.getCoinInfoByType(typeTagToTypeInfo(yTag));
                    if (!xCoinInfo || !yCoinInfo) {
                        continue;
                    }
                    try {
                        const pool = new AnimeTradingPool(ownerAddr, tag, xCoinInfo, yCoinInfo);
                        poolList.push(pool);
                    }
                    catch (_a) {
                        // ignore
                    }
                }
            }
            return poolList;
        });
    }
}

class AuxTradingPool extends TradingPool {
    constructor(ownerAddress, xInfo, yInfo) {
        super();
        this.ownerAddress = ownerAddress;
        this.xInfo = xInfo;
        this.yInfo = yInfo;
        this.pool = null;
    }
    get dexType() {
        return DexType.Aux;
    }
    getPrice() {
        var _a, _b, _c, _d;
        if (this.isStateLoaded()) {
            const xPrice = au_out_(u64(10 ** this.xInfo.decimals.toJsNumber()), (_b = (_a = this.pool) === null || _a === void 0 ? void 0 : _a.__app) === null || _b === void 0 ? void 0 : _b.cache, [
                this.xCoinInfo.token_type.toTypeTag(),
                this.yCoinInfo.token_type.toTypeTag()
            ]);
            const yPrice = au_out_(u64(10 ** this.xInfo.decimals.toJsNumber()), (_d = (_c = this.pool) === null || _c === void 0 ? void 0 : _c.__app) === null || _d === void 0 ? void 0 : _d.cache, [
                this.yCoinInfo.token_type.toTypeTag(),
                this.xCoinInfo.token_type.toTypeTag()
            ]);
            return {
                xToY: xPrice.toJsNumber(),
                yToX: yPrice.toJsNumber()
            };
        }
        throw new Error('Aux pool not loaded. cannot compute quote');
    }
    getQuote(inputUiAmt, isXtoY) {
        var _a, _b;
        if (!this.isStateLoaded()) {
            throw new Error('Aux pool not loaded. cannot compute quote');
        }
        const inputCoinInfo = isXtoY ? this.xCoinInfo : this.yCoinInfo;
        const outputCoinInfo = isXtoY ? this.yCoinInfo : this.xCoinInfo;
        if (inputUiAmt == 0) {
            return {
                inputSymbol: inputCoinInfo.symbol.str(),
                outputSymbol: outputCoinInfo.symbol.str(),
                inputUiAmt,
                outputUiAmt: 0,
                avgPrice: 0
            };
        }
        let outAmount = au_out_(u64(Math.floor(inputUiAmt * Math.pow(10, inputCoinInfo.decimals.toJsNumber()))), (_b = (_a = this.pool) === null || _a === void 0 ? void 0 : _a.__app) === null || _b === void 0 ? void 0 : _b.cache, [inputCoinInfo.token_type.toTypeTag(), outputCoinInfo.token_type.toTypeTag()]);
        const outputUiAmt = outAmount.toJsNumber() / Math.pow(10, outputCoinInfo.decimals.toJsNumber());
        return {
            inputSymbol: inputCoinInfo.symbol.str(),
            outputSymbol: outputCoinInfo.symbol.str(),
            inputUiAmt,
            outputUiAmt,
            avgPrice: outputUiAmt / inputUiAmt
        };
    }
    get isRoutable() {
        return true;
    }
    isStateLoaded() {
        return this.pool != null;
    }
    makePayload(inputUiAmt, minOutAmt) {
        throw new Error('Not Implemented');
    }
    get poolType() {
        return u64(0);
    }
    reloadState(app) {
        return __awaiter(this, void 0, void 0, function* () {
            this.pool = yield app.aux.amm.loadPool(this.ownerAddress, [
                this.xCoinInfo.token_type.toTypeTag(),
                this.yCoinInfo.token_type.toTypeTag()
            ]);
        });
    }
    get xCoinInfo() {
        return this.xInfo;
    }
    get yCoinInfo() {
        return this.yInfo;
    }
}

class AuxPooProvider extends TradingPoolProvider {
    loadPoolList() {
        return __awaiter(this, void 0, void 0, function* () {
            const poolList = [];
            const ownerAddress = this.netConfig.auxAddress;
            const resources = yield this.app.client.getAccountResources(ownerAddress);
            for (const resource of resources) {
                if (resource.type.indexOf('amm::Pool') > 0) {
                    const tag = parseMoveStructTag(resource.type);
                    const xTag = tag.typeParams[0];
                    const yTag = tag.typeParams[1];
                    const xCoinInfo = this.registry.getCoinInfoByType(typeTagToTypeInfo(xTag));
                    const yCoinInfo = this.registry.getCoinInfoByType(typeTagToTypeInfo(yTag));
                    if (!xCoinInfo || !yCoinInfo) {
                        continue;
                    }
                    const pool = new AuxTradingPool(ownerAddress, xCoinInfo, yCoinInfo);
                    poolList.push(pool);
                }
            }
            return poolList;
        });
    }
}

class BigIntConstants {
}
BigIntConstants.ZERO = BigInt(0);
BigIntConstants._1E0 = BigInt(1);
BigIntConstants._1E1 = BigInt(10 ** 1);
BigIntConstants._1E2 = BigInt(10 ** 2);
BigIntConstants._1E3 = BigInt(10 ** 3);
BigIntConstants._1E4 = BigInt(10 ** 4);
BigIntConstants._1E5 = BigInt(10 ** 5);
BigIntConstants._1E6 = BigInt(10 ** 6);
BigIntConstants._1E7 = BigInt(10 ** 7);
BigIntConstants._1E8 = BigInt(10 ** 8);
BigIntConstants._1E9 = BigInt(10 ** 9);
BigIntConstants.TWO = BigInt(2);
BigIntConstants.ONE = BigInt(1);
class AptoswapPoolInfo {
    constructor({ type, typeString, index, swapType, x, y, lspSupply, feeDirection, freeze, adminFee, lpFee, incentiveFee, connectFee, withdrawFee }) {
        this.totalAdminFee = () => {
            return this.adminFee + this.connectFee;
        };
        this.totalLpFee = () => {
            return this.incentiveFee + this.lpFee;
        };
        this.isAvaliableForSwap = () => {
            if (this.freeze) {
                return false;
            }
            else if (this.x === BigIntConstants.ZERO || this.y === BigIntConstants.ZERO) {
                return false;
            }
            return true;
        };
        this.getPrice = () => {
            // Define with base token, since X is quote and Y is base
            // which is -1 / (dX / dY) = - dY / dX
            // As X * Y = K
            // ==> X * dY + Y * dX = 0
            // ==> - dY / dX = Y / X
            if (this.x === BigIntConstants.ZERO)
                return 0.0;
            return Number(this.y) / Number(this.x);
        };
        this.getPriceBuy = () => {
            // Excahnge y to x by taking fee
            return this.getPrice() / (this._aAdmin * this._aLp);
        };
        this.getPriceSell = () => {
            // Excahnge x to y by taking fee
            return this.getPrice() * (this._aAdmin * this._aLp);
        };
        this.getXToYAmount = (dx) => {
            const x_reserve_amt = this.x;
            const y_reserve_amt = this.y;
            if (this.feeDirection === 'X') {
                dx = dx - (dx * this.totalAdminFee()) / AptoswapPoolInfo.BPS_SCALING;
            }
            dx = dx - (dx * this.totalLpFee()) / AptoswapPoolInfo.BPS_SCALING;
            if (dx < BigIntConstants.ZERO) {
                return BigIntConstants.ZERO;
            }
            let dy = this._computeAmount(dx, x_reserve_amt, y_reserve_amt);
            if (this.feeDirection === 'Y') {
                dy = dy - (dy * this.totalAdminFee()) / AptoswapPoolInfo.BPS_SCALING;
            }
            return dy;
        };
        this.getYToXAmount = (dy) => {
            const x_reserve_amt = this.x;
            const y_reserve_amt = this.y;
            if (this.feeDirection === 'Y') {
                dy = dy - (dy * this.totalAdminFee()) / AptoswapPoolInfo.BPS_SCALING;
            }
            dy = dy - (dy * this.totalLpFee()) / AptoswapPoolInfo.BPS_SCALING;
            if (dy < BigIntConstants.ZERO) {
                return BigIntConstants.ZERO;
            }
            let dx = this._computeAmount(dy, y_reserve_amt, x_reserve_amt);
            if (this.feeDirection === 'X') {
                dx = dx - (dx * this.totalAdminFee()) / AptoswapPoolInfo.BPS_SCALING;
            }
            return dx;
        };
        this.getPriceBuyWithInput = (dy) => {
            const dx = this.getYToXAmount(dy);
            return Number(dy) / Number(dx);
        };
        this.getPriceSellWithInput = (dx) => {
            const dy = this.getXToYAmount(dx);
            return Number(dy) / Number(dx);
        };
        this.getPriceBuySlippage = (dy) => {
            // TODO: Refine swap slippage computation, which should be actual amount / target amount
            const amountActual = this.getYToXAmount(dy) * BigIntConstants._1E8;
            const amountExpect = (dy * this.x * BigIntConstants._1E8) / this.y;
            if (amountExpect === BigIntConstants.ZERO) {
                return 0.0;
            }
            let diff = amountExpect - amountActual;
            if (diff < BigIntConstants.ZERO) {
                diff = -diff;
            }
            return Number((diff * BigIntConstants._1E8) / amountExpect) / 10 ** 8;
        };
        this.getPriceSellSlippage = (dx) => {
            // TODO: Refine swap slippage computation, which should be actual amount / target amount
            // const priceActual = this.getPriceSellWithInput(dx);
            // const priceExpect = this.getPriceSell();
            // const slippage = Math.max(0.0, priceExpect - priceActual) / priceExpect;
            // return (!isNaN(slippage)) ? slippage : 0.0;
            const amountActual = this.getXToYAmount(dx) * BigIntConstants._1E8;
            const amountExpect = (dx * this.y * BigIntConstants._1E8) / this.x;
            if (amountExpect === BigIntConstants.ZERO) {
                return 0.0;
            }
            let diff = amountExpect - amountActual;
            if (diff < BigIntConstants.ZERO) {
                diff = -diff;
            }
            return Number((diff * BigIntConstants._1E8) / amountExpect) / 10 ** 8;
        };
        this.getXToYMinOutputAmount = (dx, slippage) => {
            const dy = this.getXToYAmount(dx);
            return (dy * BigInt(Math.round(10 ** 9 * (1.0 - slippage)))) / BigIntConstants._1E9;
        };
        this.getYToXMinOutputAmount = (dy, slippage) => {
            const dx = this.getYToXAmount(dy);
            return (dx * BigInt(Math.round(10 ** 9 * (1.0 - slippage)))) / BigIntConstants._1E9;
        };
        this.getDepositXAmount = (y) => {
            if (this.y === BigIntConstants.ZERO) {
                return BigIntConstants.ZERO;
            }
            return (this.x * y) / this.y;
        };
        this.getDepositYAmount = (x) => {
            if (this.x === BigIntConstants.ZERO) {
                return BigIntConstants.ZERO;
            }
            return (x * this.y) / this.x;
        };
        this.isInitialized = () => {
            return this.x > BigIntConstants.ZERO && this.y > BigIntConstants.ZERO;
        };
        this._computeAmount = (dx, x, y) => {
            const numerator = y * dx;
            const denominator = x + dx;
            const dy = numerator / denominator;
            return dy;
        };
        this.type = type;
        this.typeString = typeString;
        this.index = index;
        this.swapType = swapType;
        this.x = x;
        this.y = y;
        this.lspSupply = lspSupply;
        this.feeDirection = feeDirection;
        this.freeze = freeze;
        this.adminFee = adminFee;
        this.lpFee = lpFee;
        this.incentiveFee = incentiveFee;
        this.connectFee = connectFee;
        this.withdrawFee = withdrawFee;
        this._fAdmin = Number(this.adminFee + this.connectFee) / 10000.0;
        this._fLp = Number(this.lpFee + this.incentiveFee) / 10000.0;
        this._aAdmin = 1.0 - this._fAdmin;
        this._aLp = 1.0 - this._fLp;
    }
}
AptoswapPoolInfo.BPS_SCALING = BigInt('10000');
AptoswapPoolInfo.mapResourceToPoolInfo = (resource) => {
    try {
        const typeString = resource.type;
        const mtt = parseMoveStructTag(typeString);
        const xCoinType = {
            network: 'aptos',
            name: mtt.typeParams[0]
        };
        const yCoinType = {
            network: 'aptos',
            name: mtt.typeParams[1]
        };
        const data = resource.data;
        const poolType = { xTokenType: xCoinType, yTokenType: yCoinType };
        const poolInfo = new AptoswapPoolInfo({
            type: poolType,
            typeString: typeString,
            index: Number(data.index),
            swapType: Number(data.pool_type) === 100 ? 'v2' : 'stable',
            x: BigInt(data.x.value),
            y: BigInt(data.y.value),
            lspSupply: BigInt(data.lsp_supply),
            feeDirection: Number(data.fee_direction) === 200 ? 'X' : 'Y',
            freeze: data.freeze,
            adminFee: BigInt(data.admin_fee),
            lpFee: BigInt(data.lp_fee),
            incentiveFee: BigInt(data.incentive_fee),
            connectFee: BigInt(data.connect_fee),
            withdrawFee: BigInt(data.withdraw_fee)
        });
        return poolInfo;
    }
    catch (_a) { }
    return null;
};
class AptoswapTradingPool extends TradingPool {
    constructor(packageAddr, tag, xCoinInfo, yCoinInfo, resource) {
        super();
        this.packageAddr = packageAddr;
        this.tag = tag;
        this._xCoinInfo = xCoinInfo;
        this._yCoinInfo = yCoinInfo;
        const pool = AptoswapPoolInfo.mapResourceToPoolInfo(resource);
        if (pool === null) {
            throw Error('Error while parsing Aptoswap pool from resource');
        }
        this.pool = pool;
    }
    get dexType() {
        return DexType.Aptoswap;
    }
    get poolType() {
        return u64(0);
    } // ignored
    get isRoutable() {
        return true;
    }
    get xCoinInfo() {
        return this._xCoinInfo;
    }
    get yCoinInfo() {
        return this._yCoinInfo;
    }
    // state-dependent
    isStateLoaded() {
        return true;
    }
    reloadState(app) {
        return __awaiter(this, void 0, void 0, function* () {
            const resource = yield app.client.getAccountResource(this.packageAddr, this.tag.getAptosMoveTypeTag());
            this.pool = AptoswapPoolInfo.mapResourceToPoolInfo(resource);
        });
    }
    getPrice() {
        const p = this.pool.getPrice();
        return {
            xToY: p > 0.0 ? 1.0 / p : 0.0,
            yToX: p > 0.0 ? p : 0.0
        };
    }
    getQuote(inputUiAmt, isXtoY) {
        const inputTokenInfo = isXtoY ? this.xCoinInfo : this.yCoinInfo;
        const outputTokenInfo = isXtoY ? this.yCoinInfo : this.xCoinInfo;
        const coinInAmt = BigInt(Math.floor(inputUiAmt * Math.pow(10, inputTokenInfo.decimals.toJsNumber())));
        const coinOutAmt = isXtoY ? this.pool.getXToYAmount(coinInAmt) : this.pool.getYToXAmount(coinInAmt);
        const outputUiAmt = bigInt(coinOutAmt).toJSNumber() / Math.pow(10, outputTokenInfo.decimals.toJsNumber());
        return {
            inputSymbol: inputTokenInfo.symbol.str(),
            outputSymbol: outputTokenInfo.symbol.str(),
            inputUiAmt: inputUiAmt,
            outputUiAmt: outputUiAmt,
            avgPrice: outputUiAmt / inputUiAmt
        };
    }
    // build payload directly if not routable
    makePayload(inputUiAmt, minOutAmt) {
        throw new Error('Not Implemented');
    }
}
class AptoswapPoolProvider extends TradingPoolProvider {
    loadPoolList() {
        return __awaiter(this, void 0, void 0, function* () {
            const poolList = [];
            const packageAddr = this.netConfig.aptoswapAddress;
            const resources = yield this.app.client.getAccountResources(packageAddr);
            for (const resource of resources) {
                if (resource.type.indexOf('pool::Pool') >= 0) {
                    const tag = parseMoveStructTag(resource.type);
                    const xTag = tag.typeParams[0];
                    const yTag = tag.typeParams[1];
                    const xCoinInfo = this.registry.getCoinInfoByType(typeTagToTypeInfo(xTag));
                    const yCoinInfo = this.registry.getCoinInfoByType(typeTagToTypeInfo(yTag));
                    if (!xCoinInfo || !yCoinInfo) {
                        continue;
                    }
                    try {
                        const pool = new AptoswapTradingPool(packageAddr, tag, xCoinInfo, yCoinInfo, resource);
                        if (pool.pool.isAvaliableForSwap()) {
                            poolList.push(pool);
                        }
                    }
                    catch (_a) {
                        // ignore
                    }
                }
            }
            return poolList;
        });
    }
}

class TradeAggregator {
    constructor(registryClient, app, poolProviders, printError = false) {
        this.registryClient = registryClient;
        this.app = app;
        this.poolProviders = poolProviders;
        this.printError = printError;
        this.allPools = [];
        this.xToAnyPools = new Map();
    }
    static create(aptosClient, netConfig = CONFIGS.mainnet) {
        return __awaiter(this, void 0, void 0, function* () {
            const app = new App(aptosClient);
            const registryClient = yield CoinListClient.load(app);
            const aggregator = new TradeAggregator(registryClient, app, [
                // new EconiaPoolProvider(app, netConfig, registryClient),
                new PontemPoolProvider(app, netConfig, registryClient),
                // new BasiqPoolProvider(app, netConfig, registryClient),
                //new DittoPoolProvider(app, fetcher, netConfig, registryClient),
                //new TortugaPoolProvider(app, fetcher, netConfig, registryClient),
                new AptoswapPoolProvider(app, netConfig, registryClient),
                new AuxPooProvider(app, netConfig, registryClient),
                new AnimePoolProvider(app, netConfig, registryClient)
            ]);
            yield aggregator.loadAllPoolLists();
            return aggregator;
        });
    }
    loadAllPoolLists() {
        return __awaiter(this, void 0, void 0, function* () {
            const promises = [];
            for (const provider of this.poolProviders) {
                promises.push(provider.loadPoolList());
            }
            const allResult = yield Promise.all(promises);
            this.allPools = allResult.flat();
            this.buildPoolsLookup();
        });
    }
    buildPoolsLookup() {
        this.xToAnyPools = new Map();
        for (const pool of this.allPools) {
            const xFullname = pool.xCoinInfo.token_type.typeFullname();
            if (!this.xToAnyPools.has(xFullname)) {
                this.xToAnyPools.set(xFullname, [pool]);
            }
            else {
                const xToAny = this.xToAnyPools.get(xFullname);
                if (!xToAny) {
                    throw new Error('Unreachable');
                }
                xToAny.push(pool);
            }
        }
    }
    getTradableCoinInfo() {
        const set = new Set();
        for (const pool of this.allPools) {
            set.add(pool.xCoinInfo);
            set.add(pool.yCoinInfo);
        }
        return Array.from(set.values());
    }
    getXtoYDirectSteps(x, y, requireRoutable = true) {
        const xFullname = x.token_type.typeFullname();
        const yFullname = y.token_type.typeFullname();
        if (xFullname === yFullname) {
            throw new Error(`Cannot swap ${x.symbol.str()} to ${y.symbol.str()}. They are the same coin.`);
        }
        const steps = [];
        const xToYCandidates = this.xToAnyPools.get(xFullname);
        const yToXCandidates = this.xToAnyPools.get(yFullname);
        if (xToYCandidates) {
            for (const pool of xToYCandidates) {
                if (requireRoutable && !pool.isRoutable) {
                    continue;
                }
                if (pool.yCoinInfo.token_type.typeFullname() === yFullname) {
                    steps.push(new TradeStep(pool, true));
                }
            }
        }
        if (yToXCandidates) {
            for (const pool of yToXCandidates) {
                if (pool.yCoinInfo.token_type.typeFullname() === xFullname) {
                    if (requireRoutable && !pool.isRoutable) {
                        continue;
                    }
                    steps.push(new TradeStep(pool, false));
                }
            }
        }
        return steps;
    }
    getOneStepRoutes(x, y) {
        const xFullname = x.token_type.typeFullname();
        if (xFullname === y.token_type.typeFullname()) {
            throw new Error(`Cannot swap ${x.symbol.str()} to ${y.symbol.str()}. They are the same coin.`);
        }
        const steps = this.getXtoYDirectSteps(x, y, false);
        return steps.map((step) => new TradeRoute([step]));
    }
    getTwoStepRoutes(x, y) {
        const xFullname = x.token_type.typeFullname();
        const yFullname = y.token_type.typeFullname();
        const results = [];
        for (const k of this.registryClient.getCoinInfoList()) {
            const kFullname = k.token_type.typeFullname();
            if (kFullname === xFullname || kFullname === yFullname) {
                continue;
            }
            // X-to-K
            const xToKSteps = this.getXtoYDirectSteps(x, k);
            if (xToKSteps.length === 0) {
                continue;
            }
            // K-to-Y
            const kToYSteps = this.getXtoYDirectSteps(k, y);
            if (kToYSteps.length === 0) {
                continue;
            }
            // cartesian product
            for (const xToK of xToKSteps) {
                for (const kToY of kToYSteps) {
                    results.push(new TradeRoute([xToK, kToY]));
                }
            }
        }
        return results;
    }
    getThreeStepRoutes(x, y) {
        const xFullname = x.token_type.typeFullname();
        const yFullname = y.token_type.typeFullname();
        const results = [];
        for (const k of this.registryClient.getCoinInfoList()) {
            const kFullname = k.token_type.typeFullname();
            if (kFullname === xFullname || kFullname === yFullname) {
                continue;
            }
            // X-to-K
            const xtoKRoutes = this.getTwoStepRoutes(x, k);
            if (xtoKRoutes.length === 0) {
                continue;
            }
            // K-to-Y
            const kToYSteps = this.getXtoYDirectSteps(k, y);
            if (kToYSteps.length === 0) {
                continue;
            }
            // cartesian product
            for (const xToKRoute of xtoKRoutes) {
                for (const kToY of kToYSteps) {
                    results.push(new TradeRoute([xToKRoute.steps[0], xToKRoute.steps[1], kToY]));
                }
            }
        }
        return results;
    }
    getAllRoutes(x, y, maxSteps = 3, allowRoundTrip = false) {
        // max 3 steps
        const step1Routes = maxSteps >= 1 ? this.getOneStepRoutes(x, y) : [];
        const step2Routes = maxSteps >= 2 ? this.getTwoStepRoutes(x, y) : [];
        const step3Routes = maxSteps >= 3 ? this.getThreeStepRoutes(x, y) : [];
        const allRoutes = step1Routes.concat(step2Routes).concat(step3Routes);
        if (allowRoundTrip) {
            return allRoutes;
        }
        else {
            return allRoutes.filter((r) => !r.hasRoundTrip());
        }
    }
    getQuotes(inputUiAmt, x, y, maxSteps = 3, reloadState = true, allowRoundTrip = false) {
        return __awaiter(this, void 0, void 0, function* () {
            const routes = this.getAllRoutes(x, y, maxSteps, allowRoundTrip);
            const poolSet = new Set(routes.flatMap((r) => r.steps).map((s) => s.pool));
            const promises = [];
            for (const pool of poolSet) {
                if (!pool.isStateLoaded || reloadState) {
                    try {
                        promises.push(pool.reloadState(this.app));
                    }
                    catch (e) {
                        if (this.printError) {
                            console.log('Load state err: ', e);
                        }
                    }
                }
            }
            yield Promise.all(promises);
            const result = [];
            for (const route of routes) {
                try {
                    const quote = route.getQuote(inputUiAmt);
                    result.push({ route, quote });
                }
                catch (e) {
                    if (this.printError) {
                        console.log('Get quote err: ', e);
                    }
                }
            }
            result.sort((a, b) => b.quote.outputUiAmt - a.quote.outputUiAmt);
            return result;
        });
    }
    getBestQuote(inputUiAmt, x, y, maxSteps = 3, reloadState = true, allowRoundTrip = false) {
        return __awaiter(this, void 0, void 0, function* () {
            const quotes = yield this.getQuotes(inputUiAmt, x, y, maxSteps, reloadState, allowRoundTrip);
            if (quotes.length === 0) {
                return null;
            }
            return quotes[0];
        });
    }
}

export { types as AggregatorTypes, AnimePoolProvider, AnimeTradingPool, App, Aptoswap, AptoswapPoolProvider, AptoswapTradingPool, AuxPooProvider, AuxTradingPool, CONFIGS, CoinListClient, EconiaClient, EconiaPoolProvider, EconiaPoolType, EconiaTradingPoolV1, HippoWalletClient, LOCAL_CONFIG, MAINNET_CONFIG, NetworkConfiguration, PontemPoolProvider, PontemTradingPool, ResourceAccountDeployer, SwapDeployer, TESTNET_CONFIG, TradeAggregator, aux, basiq, coin_list, econia, getProjectRepo, hippo_aggregator, liquidswap, liquidswap_lp, stdlib, u256, uq64x64 };
//# sourceMappingURL=index.mjs.map
